(* ---------------------------------------------------------------
Title         Q&D Dump
Author        PhG
Overview      dump screen to BMP or PCX format
Notes
Bugs
Wish List

--------------------------------------------------------------- *)

IMPLEMENTATION MODULE QD_Dump;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;

FROM QD_Hires IMPORT WaitVGAretrace, palval,
pset, HiresOn, TextOn, GrLine, GrCircle,
GrClearScreen, GrSetLinestyle, GrWrapon, GrPoint,
GrSetBkColor, GrOutText, GrSetTextColor, GrSetTextPosition, textcoords,
VGAhere, getmaxhtab, getmaxvtab,
xmax,ymax,xmin,ymin,cx,cy,
cPALEWHITE, cPALEBLUE, cPALEGREEN, cPALECYAN, cPALERED, cPALEMAGENTA,
cBROWN, cGRAY, cBLACK, cBLUE, cGREEN, cCYAN, cRED, cMAGENTA,
cYELLOW, cWHITE, cMYBLACK,
firstInk, lastInk, inkToRGB, FixPalette, palette16, pal16,
restype, initHGR, charheight;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory, qdSplitAllPath,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite,
getFileSize, verifyString, str4096;

(* ------------------------------------------------------------ *)

(* dyplicated but who cares ? *)

PROCEDURE sound (freq,duration:CARDINAL);
BEGIN
    Lib.Sound(freq);
    Lib.Delay(duration);
    Lib.NoSound();
END sound;

(* ------------------------------------------------------------ *)

PROCEDURE buildpicname (S:ARRAY OF CHAR;VAR num:CARDINAL; VAR pic:ARRAY OF CHAR);
VAR
    N:str128;
    v:LONGCARD;
    ok:BOOLEAN;
    p,len:CARDINAL;
    unit,dir,f8,e3,newf8:str128;
BEGIN
    qdSplitAllPath(S,unit,dir,f8,e3);
    LOOP
        Str.CardToStr(LONGCARD(num),N,10,ok);
        len:=Str.Length(N);
        p:=Str.Length(f8);
        IF (p+len) > 8 THEN
            Str.Delete(f8,8-len,p+len-8);
        END;
        Str.Concat(newf8,f8,N);
        Lib.MakeAllPath(pic,unit,dir,newf8,e3);
        IF FIO.Exists(pic)=FALSE THEN EXIT; END;
        INC(num);
    END;
END buildpicname;

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead; (* was 16 *)
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
VAR
    ioBuffer        : ARRAY [firstBufferByte..lastBufferByte] OF BYTE;

(* and now for yet another ugly hack... *)

VAR
    flagReverseVideo : BOOLEAN;
    flagBlackWhite   : BOOLEAN;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*%T SAVEASBMP  *)

CONST
    BMPmono = 0;
    BMP16   = 1;
VAR
    ThisByte:CARDINAL;

PROCEDURE PutPixel (hnd:FIO.File;colortype,x, ink:CARDINAL);
VAR
    currPixel:CARDINAL;
BEGIN
    CASE colortype OF
    | BMPmono:
	    currPixel := x MOD 8; (* 0..7 *)
        CASE ink OF
        | 0 :
	        ThisByte:= ThisByte << 1;
        ELSE  (*  trick to cover all other colors than 0 ! *)
	        ThisByte:= (ThisByte << 1) OR 1;
        END;
	    IF currPixel = 7 THEN FIO.WrBin(hnd,BYTE(ThisByte),1); END;
    | BMP16:
	    currPixel := x MOD 2; (* 0..1 *)
	    CASE currPixel OF
        | 0 :
            ThisByte := ink << 4;
        | 1 :
	        ThisByte := ThisByte OR ink;
	        FIO.WrBin(hnd,BYTE(ThisByte),1);
        END;
    END;
END PutPixel;

PROCEDURE savescreen (S:ARRAY OF CHAR;VAR num:CARDINAL);
CONST
    RLENONE = LONGCARD(0);
    RLE4    = LONGCARD(2);
TYPE
    BMPFileHeader = RECORD
        bfType 	     : ARRAY[0..1] OF CHAR; (* "BM" string *)
        bfSize 	     : LONGCARD;            (* file size in bytes *)
        bfReserved1  : CARDINAL;            (* must be set to 0 *)
        bfReserved2  : CARDINAL;            (* idem *)
        bfOffBits    : LONGCARD;            (* offset from this structure to the actual bitmap data in file *)
    END;
    BMPInfoHeader = RECORD
        biSize 	      : LONGCARD; (* size of this structure *)
        biWidth       : LONGINT;  (* # of pixels *)
        biHeight      : LONGINT;  (* # of pixels *)
        biPlanes      : CARDINAL; (* must be 1   *)
        biBitCount    : CARDINAL; (* bits per pixel (1=mono, 4=16 colors) *)
        biCompression : LONGCARD; (* 0=not compressed, 1=RLE8, 2=RLE4 *)
        (* from here, 0=default *)
        biSizeImage 	: LONGCARD; (* # of bytes in image (can be 0 if no compression) *)
        biXpelsPerMeter : LONGINT;  (* could be 0 *)
        biYpelsPerMeter : LONGINT;
        biClrUsed 	: LONGCARD; (* set to 0 to force use of all pallette *)
        biClrImportant 	: LONGCARD; (* 0=all colors are important *)
    END;
    RGBquad = RECORD
        rgbBlue    : BYTE; (* intensity *)
        rgbGreen   : BYTE;
        rgbRed     : BYTE;
        rgbReserved: BYTE; (* must be 0 *)
    END;
CONST
    firstRGBquad=1;
    maxRGBquad  =16;
TYPE
    palette2 =ARRAY[1..2]  OF LONGCARD;
CONST
    pal2=palette2(0H,03F3F3FH);  (* *4+3 to get $FF because of TopSpeed choices *)
    pal2i=palette2(03F3F3FH,0H);
VAR
    pic:str128;
    hnd:FIO.File;
    i:CARDINAL;
    FH : BMPFileHeader;
    IH : BMPInfoHeader;
    PaletteEntry : ARRAY [firstRGBquad..maxRGBquad] OF RGBquad;
    BitsPerPixel : CARDINAL;
    countRGBquad : CARDINAL;
    sizeFH,sizeIH,sizePalette:CARDINAL;
    countBits,countDwords,remainingBits,countBytes:CARDINAL;
    sizeData:LONGCARD;
    XMAX,YMAX:CARDINAL;
    vRGB:LONGCARD;
    x,y,ink,n:CARDINAL;
    colortype : CARDINAL;
BEGIN
    buildpicname(S,num,pic); (* and now assume enough room on disk ! *)
    CASE flagBlackWhite OF
    | TRUE : colortype:=BMPmono;
    | FALSE: colortype:=BMP16;
    END;

    XMAX:=xmax+1;
    YMAX:=ymax+1;
    CASE colortype OF
    | BMPmono :
    	BitsPerPixel:=1;
	    countRGBquad:=2; (* 2^1 *)
    | BMP16 :
	    BitsPerPixel:=4;
	    countRGBquad:=16; (* 2^4 *)
    END;
    sizeFH:=SIZE(FH);
    sizeIH:=SIZE(IH);
    sizePalette   := countRGBquad * SIZE(RGBquad);
    countBits     := XMAX*BitsPerPixel;
    countDwords   := countBits DIV 32;
    remainingBits := countBits MOD 32;
    IF remainingBits # 0 THEN INC(countDwords); END;
    countBytes    := countDwords * 4; (* les units passent de 32  8 bits *)
    sizeData      := LONGCARD(YMAX * countBytes);

    FH.bfType      := "BM";
    FH.bfSize      := LONGCARD(sizeFH+sizeIH+sizePalette)+sizeData;
    FH.bfReserved1 := 0;
    FH.bfReserved2 := 0;
    FH.bfOffBits   := LONGCARD(sizeFH+sizeIH+sizePalette); (* offset from this structure to the actual bitmap data in file *)

    IH.biSize          := LONGCARD(sizeIH);
    IH.biWidth         := LONGINT(XMAX);
    IH.biHeight        := LONGINT(YMAX);
    IH.biPlanes        := 1;
    IH.biBitCount      := BitsPerPixel;
    IH.biCompression   := RLENONE;
    IH.biSizeImage     := sizeData; (* could be 0 for RGB encoded *)
    IH.biXpelsPerMeter := 0;
    IH.biYpelsPerMeter := 0;
    IH.biClrUsed       := LONGCARD(countRGBquad); (* could be 0 *)
    IH.biClrImportant  := LONGCARD(countRGBquad); (* could be 0 *)

    FOR i := firstRGBquad TO countRGBquad DO
        CASE colortype OF
        | BMPmono :
             IF flagReverseVideo THEN
                vRGB:=pal2i[i];
             ELSE
                vRGB:=pal2[i];
             END;
        | BMP16   :
             vRGB:=pal16[i];
        END;
        PaletteEntry[i].rgbBlue		:=palval(  vRGB DIV 10000H);
        PaletteEntry[i].rgbGreen	:=palval( (vRGB DIV 100H) MOD 100H);
        PaletteEntry[i].rgbRed		:=palval(  vRGB MOD 100H);
        PaletteEntry[i].rgbReserved	:=00H;
    END;

    hnd:=FIO.Create(pic);
    FIO.AssignBuffer(hnd,ioBuffer);
    FIO.WrBin(hnd,FH,SIZE(FH));
    FIO.WrBin(hnd,IH,SIZE(IH));
    (* faut 2 RGBquad pour mono, 16 pour 16 colors *)
    (* si mono, bit  0 -> premier RGBquad, sinon second *)
    (* si 16col, 4 bits per pixel, index dans table 0..15 *)
    FOR i:=firstRGBquad TO countRGBquad DO
	FIO.WrBin(hnd,PaletteEntry[i],SIZE(RGBquad));
    END;

    (* array of bytes from left to right (padded at 32 bits) and from down to top *)

    FOR y := (YMAX-1) TO 0 BY -1 DO
	    FOR x := 0 TO (XMAX-1) DO
    	    ink:=GrPoint(x,y);
	        PutPixel (hnd,colortype,x,ink)
        END;
	    IF remainingBits # 0 THEN
            x:=XMAX;
            ink:=0;
            FOR n := 1 TO remainingBits DO
         	    PutPixel (hnd,colortype, x+n-1, ink); (* always padded at 32 *)
            END;
        END;
	    IF (y MOD 64) = 32 THEN sound(22,10); END;
    END;

    FIO.Flush(hnd);
    FIO.Close(hnd);
    sound(222,20);
    INC(num); (* next ! *)
END savescreen;

(*%E  *)

(* ------------------------------------------------------------ *)

(*%F SAVEASBMP  *)

TYPE
    PCXrgbType = RECORD
        red,green,blue:BYTE;
    END;

    PCXheaderType = RECORD
    manufacturer    : BYTE;
    version         : BYTE;
    encoding        : BYTE;
    bitsPerPixel    : BYTE;
    leftmargin      : WORD;
    uppermargin     : WORD;
    rightmargin     : WORD;
    lowermargin     : WORD;
    hDPIresolution  : WORD;
    vDPIresolution  : WORD;
    colormap        : ARRAY[0..15] OF PCXrgbType;
    reserved1       : BYTE;
    NCP             : BYTE;
    NBS             : WORD;
    paletteInfo     : WORD;
    hscreensize     : WORD;
    vscreensize     : WORD;
    reserved2       : ARRAY[0..53] OF BYTE;
    END;

CONST
    palID     = BYTE(0CH); (* 12=$0C *)
    palidsize = 1;
    palsize   = 3 * 256;

TYPE
    masktype = ARRAY [0..7] OF CARDINAL;
CONST
    bitmask = masktype(080H,040H,020H,010H,008H,004H,002H,001H);
CONST
    PCXCOUNTFLAG = BYTE(0C0H); (* 11000000 *)
    PCXCOUNTMASK = BYTE(03FH); (* 00111111 *)
    PCXMAXCOUNT  = 03FH;
CONST
    maxPlanes = 4;
    maxpixels = 1280;
    firstcode = 0;
    (* maxcode   = (1280 DIV 8) * maxPlanes -1; (* in bytes *) *)
    maxcode   = maxpixels * maxPlanes-1;
TYPE
    imgtype = RECORD
        decodebuffer : ARRAY [firstcode..maxcode] OF BYTE;
    END;
VAR
    img : imgtype;

(* remember $FC >> 2 = $3F, but $FF >> 2 = $3F too ! *)

PROCEDURE PCXpal (VAR v:BYTE);
VAR
    i : CARDINAL;
BEGIN
    i := CARDINAL(v) << 2;
    IF i >= 0FCH THEN i := 0FFH; END; (* we lose $FC but it's better here ! *)
    v := BYTE(i);
END PCXpal;

(* 2 or 256 colors only *)

PROCEDURE buildPCXheader (xmin,ymin,xmax,ymax,colors:CARDINAL):PCXheaderType;
VAR
    h : PCXheaderType;
    i : CARDINAL;
    r,g,b:BYTE;
    bgr:LONGCARD;
BEGIN
    h.manufacturer   := BYTE(0AH);
    h.version        := BYTE(5);
    h.encoding       := BYTE(1);
    CASE colors OF
    | 2   : i:=1;
    | 256 : i:=8;
    END;
    h.bitsPerPixel   := BYTE(i);
    h.leftmargin     := xmin;
    h.uppermargin    := ymin;
    h.rightmargin    := xmax;
    h.lowermargin    := ymax;
    h.hDPIresolution := 300;    (* reasonable but useless default *)
    h.vDPIresolution := 300;
        FOR i := 0 TO 15 DO
            CASE colors OF
            | 2 :
                CASE i OF
                | 0: bgr := pal16[cBLACK+1]; (* black 000000 *)
                | 1: bgr := pal16[cWHITE+1]; (* white 3f3f3f *)
                ELSE
                     bgr := pal16[cBLACK+1]; (* 00 00 00 *)
                END;
            | 256:
                bgr := pal16[i+1];
            END;
            r := BYTE( bgr        MOD 100H);
            g := BYTE((bgr >>  8) MOD 100H);
            b := BYTE((bgr >> 16) MOD 100H);
            PCXpal(r); PCXpal(g); PCXpal(b);
            h.colormap[i].red   := r;
            h.colormap[i].green := g;
            h.colormap[i].blue  := b;
        END;
    h.reserved1      := BYTE(0);
    h.NCP            := BYTE(1);
    CASE colors OF
    | 2   :  i := (xmax-xmin+1) >> 3; (*  1 bit per pixel, so DIV 8 *)
             IF ((xmax-xmin+1) MOD 8) # 0 THEN INC(i);END;
             (* IF ODD(i) THEN INC(i); END; *)
    | 256 :  i := (xmax-xmin+1) ; (*  8 bits per pixel, so DIV 8 then * 8 *)
    END;
    h.NBS            := i;
    h.paletteInfo    := 1;
    h.hscreensize    := 0; (* xmax-xmin+1 *)
    h.vscreensize    := 0; (* ymax-ymin+1 *)
    FOR i := 0 TO 53 DO
        h.reserved2[i] := BYTE(0);
    END;

    RETURN h;
END buildPCXheader;

PROCEDURE savePCXpal256 (hnd:FIO.File);
VAR
    i,j : CARDINAL;
    r,g,b:BYTE;
    bgr:LONGCARD;
BEGIN
    FIO.WrBin(hnd,palID,palidsize);
        FOR i := 0 TO 255 DO
            j:=i MOD 16;
            bgr := pal16[j+1];
            r := BYTE( bgr        MOD 100H);
            g := BYTE((bgr >>  8) MOD 100H);
            b := BYTE((bgr >> 16) MOD 100H);
            PCXpal(r); PCXpal(g); PCXpal(b);
            FIO.WrBin(hnd,r,1);
            FIO.WrBin(hnd,g,1);
            FIO.WrBin(hnd,b,1);
        END;
END savePCXpal256;

PROCEDURE encodeScanlineMono (y,xmin,xmax:CARDINAL):CARDINAL ;
VAR
    pattern : BYTE;
    x,ndxmask,themask,v,doton,i:CARDINAL;
    p:CARDINAL; (* in img.decodebuffer[] *)
    count,oldmask:CARDINAL;
BEGIN
    CASE flagReverseVideo OF
    | TRUE: doton:=0;
    |FALSE: doton:=1;
    END;
    p := firstcode;
    x := xmin;
    themask:=00H;
    count := 0;
    LOOP
        ndxmask := x MOD 8;
        v := GrPoint(x,y);
        IF v # 0 THEN
            themask := (themask OR bitmask[ndxmask]);
        END;
        IF ndxmask = 7 THEN (* we have a full BYTE *)
            IF flagReverseVideo THEN
                themask := CARDINAL((BITSET(themask) / BITSET(0FFH)));
            END;
            IF count=0 THEN
                oldmask := themask;
                count   :=1;
            ELSE
                IF themask=oldmask THEN
                    IF count = PCXMAXCOUNT THEN (* flush ! *)
                        img.decodebuffer[p]:=(PCXCOUNTFLAG OR BYTE(count));
                        INC(p);
                        img.decodebuffer[p]:= BYTE(oldmask);
                        INC(p);
                        count:=1; (* write 63, write byte, restart at 1 *)
                    ELSE
                        INC(count);
                    END;
                ELSE
                    IF count > 1 THEN
                        img.decodebuffer[p]:=(PCXCOUNTFLAG OR BYTE(count));
                        INC(p);
                        count:=1; (* write count, restart at 1 *)
                    ELSE (* count is 1 here *)
                        IF (BYTE(oldmask) AND PCXCOUNTFLAG) = PCXCOUNTFLAG THEN
                            img.decodebuffer[p]:=(PCXCOUNTFLAG OR BYTE(01H));
                            INC(p); (* write 1 *)
                        END;
                    END;
                    img.decodebuffer[p]:=BYTE(oldmask);
                    INC(p); (* write byte *)
                    oldmask:=themask; (* restart at 1 with new byte *)
                END;
            END;
            themask := 00H; (* eh ! *)
        END;

        INC(x);
        IF x > xmax THEN EXIT; END;
    END;

        ndxmask := x MOD 8;
        IF ndxmask # 0 THEN
            IF flagReverseVideo THEN
                themask := CARDINAL((BITSET(themask) / BITSET(0FFH)));
            END;

                IF themask=oldmask THEN
                    IF count = PCXMAXCOUNT THEN (* flush ! *)
                        img.decodebuffer[p]:=(PCXCOUNTFLAG OR BYTE(count));
                        INC(p);
                        img.decodebuffer[p]:= BYTE(oldmask);
                        INC(p);
                        count:=1; (* write 63, write byte, restart at 1 *)
                    ELSE
                        INC(count);
                    END;
                ELSE
                    IF count > 1 THEN
                        img.decodebuffer[p]:=(PCXCOUNTFLAG OR BYTE(count));
                        INC(p);
                        count:=1; (* write count, restart at 1 *)
                    ELSE (* count is 1 here *)
                        IF (BYTE(oldmask) AND PCXCOUNTFLAG) = PCXCOUNTFLAG THEN
                            img.decodebuffer[p]:=(PCXCOUNTFLAG OR BYTE(01H));
                            INC(p); (* write 1 *)
                        END;
                    END;
                    img.decodebuffer[p]:=BYTE(oldmask);
                    INC(p); (* write byte *)
                    oldmask:=themask; (* restart at 1 with new byte *)
                END;

                IF (BYTE(oldmask) AND PCXCOUNTFLAG) = PCXCOUNTFLAG THEN
                    img.decodebuffer[p]:=(PCXCOUNTFLAG OR BYTE(01H));
                    INC(p); (* write 1 *)
                END;
                img.decodebuffer[p]:=BYTE(oldmask);
                INC(p); (* write byte *)

        ELSE (* flush whatever is pending *)

            img.decodebuffer[p]:=(PCXCOUNTFLAG OR BYTE(count));
            INC(p);
            img.decodebuffer[p]:= BYTE(oldmask);
            INC(p);
        END;

    RETURN (p-firstcode); (* p is already +1, so useless to -1 *)

END encodeScanlineMono;

PROCEDURE encodeScanline256 (y,xmin,xmax:CARDINAL   ) : CARDINAL ;
VAR
    oldink,ink : BYTE;
    x,count:CARDINAL;
    p:CARDINAL; (* in img.decodebuffer[] *)
BEGIN
    oldink:= BYTE(GrPoint(xmin,y));
    count := 1;
    p := firstcode;
    x := xmin+1;
    LOOP
        ink := BYTE(GrPoint(x,y));
        IF ink=oldink THEN
            IF count = PCXMAXCOUNT THEN (* flush ! *)
                img.decodebuffer[p]:=(PCXCOUNTFLAG OR BYTE(count));
                INC(p);
                img.decodebuffer[p]:=oldink;
                INC(p);
                count:=1; (* write 63, write byte, restart at 1 *)
            ELSE
                INC(count);
            END;
        ELSE
            IF count > 1 THEN
                img.decodebuffer[p]:=(PCXCOUNTFLAG OR BYTE(count));
                INC(p);
                count:=1; (* write count, restart at 1 *)
            ELSE (* count is 1 here *)
                IF (oldink AND PCXCOUNTFLAG) = PCXCOUNTFLAG THEN
                    img.decodebuffer[p]:=(PCXCOUNTFLAG OR BYTE(01H));
                    INC(p); (* write 1 *)
                END;
            END;
            img.decodebuffer[p]:=oldink;
            INC(p); (* write byte *)
            oldink:=ink; (* restart at 1 with new byte *)
        END;

        INC(x);
        IF x > xmax THEN EXIT; END;
    END;

            IF count > 1 THEN
                img.decodebuffer[p]:=(PCXCOUNTFLAG OR BYTE(count));
                INC(p); (* write count *)
            ELSE (* count is 1 here *)
                IF (oldink AND PCXCOUNTFLAG) = PCXCOUNTFLAG THEN
                    img.decodebuffer[p]:=(PCXCOUNTFLAG OR BYTE(01H));
                    INC(p); (* write 1 *)
                END;
            END;
            img.decodebuffer[p]:=oldink;
            INC(p); (* write byte *)
    RETURN (p-firstcode); (* p is already +1, so useless to -1 *)
END encodeScanline256;

(* uses many globerks ! xmin, ymin, xmax, ymax, etc. *)

PROCEDURE savescreen (S:ARRAY OF CHAR; inverse,bw,autonum:BOOLEAN; VAR num:CARDINAL);
VAR
    pic:str128;
    hnd:FIO.File;
VAR
    x,y,count,colors:CARDINAL;
VAR
    h : PCXheaderType;
BEGIN
    (* and now for yet another ugly hack using local globerks *)
    flagReverseVideo := inverse;
    flagBlackWhite   := bw;

    (* and now assume enough room on disk ! *)
    IF autonum THEN
        buildpicname(S,num,pic);
    ELSE
        Str.Copy(pic,S);
    END;
    CASE flagBlackWhite OF
    | TRUE : colors:=2;
    | FALSE: colors:=256;
    END;

    hnd:=FIO.Create(pic);
    FIO.AssignBuffer(hnd,ioBuffer);
    h := buildPCXheader(xmin,ymin,xmax,ymax,colors);
    FIO.WrBin(hnd,h,SIZE(PCXheaderType));
    FOR y := ymin TO ymax DO
        CASE colors OF
        | 2   : count:=encodeScanlineMono(y,xmin,xmax);
        | 256 : count:=encodeScanline256(y,xmin,xmax);
        END;
        FIO.WrBin(hnd, img.decodebuffer, count);
	    IF (y MOD 64) = 32 THEN sound(22,10); END;
    END;
    IF colors=256 THEN savePCXpal256(hnd);END;
    FIO.Flush(hnd);
    FIO.Close(hnd);
    sound(222,20);
    INC(num); (* next ! *)
END savescreen;

(*%E  *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

BEGIN

END QD_Dump.
