(* ---------------------------------------------------------------
Title         Q&D Hires
Author        PhG
Overview      some use(d|ful) subroutines
Notes
Bugs
Wish List

--------------------------------------------------------------- *)

IMPLEMENTATION MODULE QD_Hires;

IMPORT Graph;
IMPORT SYSTEM;
IMPORT graphics;

(* ------------------------------------------------------------ *)

PROCEDURE WaitVGAretrace ();
BEGIN
    WHILE (SYSTEM.In(03DAH) AND 08H) # 0 DO
    END;
    WHILE (SYSTEM.In(03DAH) AND 08H) = 0 DO
    END;
END WaitVGAretrace;

(*
    $00 -> $00
    $20 -> $80
    $3F -> $FF
*)

PROCEDURE palval (n:LONGCARD):BYTE;
CONST
    upper = BYTE(03FH * 4); (* force $3F to become $FF, not $FC *)
VAR
    b : BYTE;
BEGIN
    b := BYTE(n*4);
    IF b = upper THEN b := 0FFH; END;
    RETURN b;
END palval;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*%F USEBGI *)

CONST (* pour mode VGA normal *)
    gmode = Graph._VRES16COLOR;

PROCEDURE pset (x,y,ink:CARDINAL  );
BEGIN
    Graph.Plot(x,y,ink);
END pset;

PROCEDURE HiresOn () : BOOLEAN;
BEGIN
    RETURN Graph.SetVideoMode(gmode);
END HiresOn;

PROCEDURE TextOn (  ) : BOOLEAN;
BEGIN
    RETURN Graph.SetVideoMode(Graph._DEFAULTMODE);
END TextOn;

PROCEDURE GrLine (x1,y1,x2,y2:INTEGER;ink,pattern:CARDINAL);
BEGIN
    Graph.SetLinestyle(pattern);
    Graph.Line(x1,y1,x2,y2,ink);
END GrLine;

PROCEDURE GrCircle (cx,cy,r,ink:CARDINAL);
BEGIN
    Graph.Circle(cx,cy,r,ink);
END GrCircle;

PROCEDURE GrClearScreen();
BEGIN
    Graph.ClearScreen(Graph._GWINDOW);
END GrClearScreen;

PROCEDURE GrSetLinestyle(pattern : CARDINAL);
BEGIN
    Graph.SetLinestyle(pattern);
END GrSetLinestyle;

PROCEDURE GrWrapon(option:BOOLEAN) : BOOLEAN;
BEGIN
    RETURN Graph.Wrapon(option);
END GrWrapon;

PROCEDURE GrPoint(x,y:CARDINAL) : CARDINAL;
BEGIN
    RETURN Graph.Point(x,y);
END GrPoint;

PROCEDURE GrSetBkColor (color : LONGCARD) : LONGCARD;
BEGIN
    RETURN Graph.SetBkColor(color);
END GrSetBkColor;

PROCEDURE GrOutText(S: ARRAY OF CHAR);
BEGIN
    Graph.OutText(S);
END GrOutText ;

PROCEDURE GrSetTextColor(color: CARDINAL): CARDINAL;
BEGIN
    RETURN Graph.SetTextColor(color);
END GrSetTextColor;

PROCEDURE GrSetTextPosition(row, col: CARDINAL) : textcoords ;
BEGIN
    RETURN textcoords(Graph.SetTextPosition(row,col));
END GrSetTextPosition;

(* ------------------------------------------------------------ *)

VAR
    infovideo : Graph.VideoConfig;

PROCEDURE VGAhere (  ) : BOOLEAN;
BEGIN
    Graph.GetVideoConfig(infovideo);
    IF infovideo.adapter # Graph._VGA THEN RETURN FALSE; END;
    RETURN TRUE;
END VGAhere;

(* we CAN avoid problems if video text mode was a weird extended one ! *)

PROCEDURE getmaxhtab():CARDINAL;   (* 80 *)
BEGIN
    CASE infovideo.numtextcols OF
    | 40,80 :
    ELSE
        infovideo.numtextcols := 80; (* force it here ! *)
    END;
    RETURN infovideo.numtextcols;
END getmaxhtab;

PROCEDURE getmaxvtab():CARDINAL;   (* 25 *)
BEGIN
    CASE infovideo.numtextrows OF
    | 25, 43, 50 :
    ELSE
        infovideo.numtextrows := 25; (* force it here ! *)
    END;
    RETURN infovideo.numtextrows;
END getmaxvtab;

(* ------------------------------------------------------------ *)

PROCEDURE inkToRGB (ink:CARDINAL) : LONGCARD;
VAR
    r:LONGCARD;
BEGIN
    CASE ink OF
    | cBLACK	     : r:= Graph._BLACK;
    | cPALEBLUE      : r:= Graph._BLUE;
    | cPALEGREEN     : r:= Graph._GREEN;
    | cPALECYAN      : r:= Graph._CYAN;
    | cPALERED       : r:= Graph._RED;
    | cPALEMAGENTA   : r:= Graph._MAGENTA;
    | cBROWN         : r:= Graph._BROWN;
    | cPALEWHITE     : r:= Graph._GRAY; (* was WHITE= =WHITE*)
    | cGRAY          : r:= Graph._BLACK; (* was = GRAY *)
    | cBLUE          : r:= Graph._LIGHTBLUE;
    | cGREEN         : r:= Graph._LIGHTGREEN;
    | cCYAN          : r:= Graph._LIGHTCYAN;
    | cRED           : r:= Graph._LIGHTRED;
    | cMAGENTA       : r:= Graph._LIGHTMAGENTA;
    | cYELLOW        : r:= Graph._LIGHTYELLOW;
    | cWHITE         : r:= Graph._BRIGHTWHITE; (* was BRIGHTWHITE= *)
    END;
    RETURN r;
END inkToRGB;

PROCEDURE FixPalette ();
VAR
    n:LONGCARD;
BEGIN

    n:=Graph.RemapPalette( cBLACK      , Graph._BLACK);
    n:=Graph.RemapPalette( cPALEBLUE   , Graph._BLUE);
    n:=Graph.RemapPalette( cPALEGREEN  , Graph._GREEN);
    n:=Graph.RemapPalette( cPALECYAN   , Graph._CYAN);
    n:=Graph.RemapPalette( cPALERED    , Graph._RED);
    n:=Graph.RemapPalette( cPALEMAGENTA, Graph._MAGENTA);
    n:=Graph.RemapPalette( cBROWN      , Graph._BROWN);
    n:=Graph.RemapPalette( cPALEWHITE  , Graph._WHITE);  (* was WHITE,  *)
    n:=Graph.RemapPalette( cGRAY       , Graph._GRAY);
    n:=Graph.RemapPalette( cBLUE       , Graph._LIGHTBLUE);
    n:=Graph.RemapPalette( cGREEN      , Graph._LIGHTGREEN);
    n:=Graph.RemapPalette( cCYAN       , Graph._LIGHTCYAN);
    n:=Graph.RemapPalette( cRED        , Graph._LIGHTRED);
    n:=Graph.RemapPalette( cMAGENTA    , Graph._LIGHTMAGENTA);
    n:=Graph.RemapPalette( cYELLOW     , Graph._LIGHTYELLOW);
    n:=Graph.RemapPalette( cWHITE      , Graph._BRIGHTWHITE); (* was BRIGHTWHITE, *)

    n:=Graph.RemapPalette( cGRAY       , Graph._BLACK); (* we don't need dark gray after all *)
END FixPalette;

(* ------------------------------------------------------------ *)

(* useless call : if USEBGI is FALSE, then we use faster constants *)

PROCEDURE initHGR (argresolution:restype);
BEGIN
(*
    CASE resolution OF
    | res640x480 :
        xmax := 640;
        ymax := 480;
    END;
    DEC(xmax); (* -1 *)
    DEC(ymax); (* -1 *)
    cx := xmax DIV 2;
    cy := ymax DIV 2;
    resolution := argresolution
*)
END initHGR;

(*%E *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*%T USEBGI *)

VAR
    resolution : restype;

CONST
    defaultfontwidth = 8;
    defaultfontheight= 8;

VAR
    gmode   : INTEGER;

VAR
    GraphDriver : INTEGER;
    GraphMode   : INTEGER;

PROCEDURE DetectSVGA () : INTEGER;
BEGIN
    RETURN gmode;
END DetectSVGA;

PROCEDURE pset (x,y,ink:CARDINAL  );
BEGIN
    graphics.putpixel( INTEGER(x), INTEGER(y), INTEGER(ink) );
END pset;

PROCEDURE HiresOn () : BOOLEAN;
BEGIN
    GraphMode   := gmode;
    graphics.initgraph(GraphDriver,GraphMode,"");
    RETURN (graphics.graphresult() = graphics.grOk);
END HiresOn;

PROCEDURE TextOn (  ) : BOOLEAN;
VAR
    rc : INTEGER;
BEGIN
    graphics.restorecrtmode;
    rc := graphics.graphresult();
    graphics.closegraph;
    RETURN (rc = graphics.grOk);
END TextOn;

PROCEDURE GrLine (x1,y1,x2,y2:INTEGER;ink,pattern:CARDINAL);
BEGIN
    graphics.setlinestyle(graphics.UserBitLn, pattern, graphics.NormWidth );
    graphics.setcolor( INTEGER(ink) );
    graphics.line(x1,y1,x2,y2);
END GrLine;

PROCEDURE GrCircle (cx,cy,r,ink:CARDINAL);
BEGIN
    graphics.setcolor( INTEGER(ink) );
    graphics.circle( INTEGER(cx), INTEGER(cy), INTEGER(r) );
END GrCircle;

PROCEDURE GrClearScreen();
BEGIN
    graphics.cleardevice;
END GrClearScreen;

PROCEDURE GrSetLinestyle(pattern : CARDINAL);
BEGIN
    graphics.setlinestyle(graphics.UserBitLn, pattern, graphics.NormWidth );
END GrSetLinestyle;

PROCEDURE GrWrapon(option:BOOLEAN) : BOOLEAN;
BEGIN
    RETURN TRUE;
END GrWrapon;

PROCEDURE GrPoint(x,y:CARDINAL) : CARDINAL;
BEGIN
    RETURN graphics.getpixel( INTEGER(x), INTEGER(y) );
END GrPoint;

PROCEDURE GrSetBkColor (color : LONGCARD) : LONGCARD;
VAR
    oldink : INTEGER;
BEGIN
    oldink := graphics.getbkcolor();
    graphics.setbkcolor( INTEGER(color) );
    RETURN LONGCARD(oldink);
END GrSetBkColor;

VAR
    htab,vtab:INTEGER;

PROCEDURE GrOutText(S: ARRAY OF CHAR);
BEGIN
    graphics.outtextxy(htab*defaultfontwidth,vtab*defaultfontheight,S);
END GrOutText ;

PROCEDURE GrSetTextColor(color: CARDINAL): CARDINAL;
VAR
    oldink : INTEGER;
BEGIN
    oldink := graphics.getcolor();
    graphics.setcolor( INTEGER(color) );
    RETURN CARDINAL(oldink);
END GrSetTextColor;

PROCEDURE GrSetTextPosition(row, col: CARDINAL) : textcoords ;
VAR
    dummy : textcoords;
BEGIN
    vtab := INTEGER(row);
    htab := INTEGER(col);
    dummy.row := row;
    dummy.col := col;
    RETURN dummy;
END GrSetTextPosition;

(* ------------------------------------------------------------ *)

(* installuserdriver requires direct constants *)

PROCEDURE VGAhere (  ) : BOOLEAN;
VAR
    rc : INTEGER;
BEGIN
    CASE resolution OF
(*%F ONLYBGI256 *)
    | res640x480 :
        (* graphics.VGAHi, "VGA" *)
        rc:=graphics.registerfarbgidriver( ADR(graphics.EGAVGA_driver_far) );
    | res800x600 :
        (* graphics.SVGA800x600x16 *)
        GraphDriver := graphics.installuserdriver("SVGA16", graphics.driverproc(DetectSVGA) );
        rc:=graphics.registerfarbgidriver( ADR(graphics.Svga16_driver_far) );
    | res1024x768 :
        (* graphics.SVGA1024x768x256 *)
        GraphDriver := graphics.installuserdriver("SVGA256", graphics.driverproc(DetectSVGA) );
        rc:=graphics.registerfarbgidriver( ADR(graphics.Svga256_driver_far) );
    | res320x240 :
        (* graphics.VGAHi, "VGA" *)
        rc:=graphics.registerfarbgidriver( ADR(graphics.EGAVGA_driver_far) );
(*%E *)
(*%T ONLYBGI256 *)
    | res640x480 :
        GraphDriver := graphics.installuserdriver("SVGA256", graphics.driverproc(DetectSVGA) );
        rc:=graphics.registerfarbgidriver( ADR(graphics.Svga256_driver_far) );
    | res800x600 :
        GraphDriver := graphics.installuserdriver("SVGA256", graphics.driverproc(DetectSVGA) );
        rc:=graphics.registerfarbgidriver( ADR(graphics.Svga256_driver_far) );
    | res1024x768 :
        GraphDriver := graphics.installuserdriver("SVGA256", graphics.driverproc(DetectSVGA) );
        rc:=graphics.registerfarbgidriver( ADR(graphics.Svga256_driver_far) );
    | res320x240 :
        GraphDriver := graphics.installuserdriver("SVGA256", graphics.driverproc(DetectSVGA) );
        rc:=graphics.registerfarbgidriver( ADR(graphics.Svga256_driver_far) );
(*%E *)
    END;
    RETURN (graphics.graphresult() = graphics.grOk);
END VGAhere;

PROCEDURE getmaxhtab():CARDINAL;   (* 80 *)
BEGIN
    RETURN (xmax DIV defaultfontwidth);
END getmaxhtab;

PROCEDURE getmaxvtab():CARDINAL;   (* 25 *)
BEGIN
    RETURN (ymax DIV defaultfontheight);
END getmaxvtab;

(* ------------------------------------------------------------ *)

(* M2 constants are bgr in fact ! *)

PROCEDURE setpal (color : INTEGER; lc:LONGCARD);
VAR
    r,g,b:INTEGER;
BEGIN
    r := INTEGER(lc MOD 100H);
    g := INTEGER(lc DIV 100H) MOD 100H;
    b := INTEGER(lc DIV 10000H);
    graphics.setrgbpalette(color,r,g,b);
END setpal;

PROCEDURE inkToRGB (ink:CARDINAL) : LONGCARD;
VAR
    r:LONGCARD;
BEGIN
    CASE ink OF
    | graphics.DarkGray  : r:= graphics.Black;
    ELSE
        r:=LONGCARD(ink);
    END;
    RETURN r;
END inkToRGB;

(* reversevideo does not really work in 1024x768x256 : in fact, hardly legible ! *)

PROCEDURE FixPalette ();
BEGIN

    setpal(graphics.Black        ,Graph._BLACK);
    setpal(graphics.Blue         ,Graph._BLUE);
    setpal(graphics.Green        ,Graph._GREEN);
    setpal(graphics.Cyan         ,Graph._CYAN);
    setpal(graphics.Red          ,Graph._RED);
    setpal(graphics.Magenta      ,Graph._MAGENTA);
    setpal(graphics.Brown        ,Graph._BROWN);
    setpal(graphics.LightGray    ,Graph._WHITE);
    setpal(graphics.DarkGray     ,Graph._GRAY);
    setpal(graphics.LightBlue    ,Graph._LIGHTBLUE);
    setpal(graphics.LightGreen   ,Graph._LIGHTGREEN);
    setpal(graphics.LightCyan    ,Graph._LIGHTCYAN);
    setpal(graphics.LightRed     ,Graph._LIGHTRED);
    setpal(graphics.LightMagenta ,Graph._LIGHTMAGENTA);
    setpal(graphics.Yellow       ,Graph._LIGHTYELLOW);
    setpal(graphics.White        ,Graph._BRIGHTWHITE);

    setpal(graphics.DarkGray     ,Graph._BLACK); (* we don't need dark gray *)

END FixPalette;

(* ------------------------------------------------------------ *)

PROCEDURE initHGR (argresolution:restype);
BEGIN
    CASE argresolution OF
(*%F ONLYBGI256 *)
    | res640x480 :
        xmax    := 640;
        ymax    := 480;
        gmode   := graphics.VGAHi;
    | res800x600 :
        xmax    := 800;
        ymax    := 600;
        gmode   := graphics.SVGA800x600x16;
    | res1024x768 :
        xmax    := 1024;
        ymax    := 768;
        gmode   := graphics.SVGA1024x768x256; (* matrox does NOT support x16 here ! *)
    | res320x240 :
        xmax    := 320;
        ymax    := 240;
        gmode   := graphics.VGAHi;
(*%E *)
(*%T ONLYBGI256 *)
    | res640x480 :
        xmax    := 640;
        ymax    := 480;
        gmode   := graphics.SVGA640x480x256;
    | res800x600 :
        xmax    := 800;
        ymax    := 600;
        gmode   := graphics.SVGA800x600x256;
    | res1024x768 :
        xmax    := 1024;
        ymax    := 768;
        gmode   := graphics.SVGA1024x768x256;
    | res320x240 :
        xmax    := 320;
        ymax    := 240;
        gmode   := graphics.SVGA640x480x256;
(*%E *)
    END;
    DEC(xmax); (* -1 *)
    DEC(ymax); (* -1 *)
    cx := xmax DIV 2;
    cy := ymax DIV 2;
    resolution := argresolution;
END initHGR;

(*%E *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

BEGIN

END QD_Hires.

