$if 0
--------------------------------------------------------------------
Title       : BW BMP to DEF or DAT
Version     : 1.0c
Author      : PhG
Overview    : converts a monochrome Paintbrush BMP file to .DEF
Future      : avoid array but how to strip then ?
Notes       : very quick & dirty ,-)
Usage       : BWBMPDEF bmpfile
--------------------------------------------------------------------
$endif

$CPU 8086

$OPTIMIZE SIZE
$COMPILE EXE

$DEBUG MAP OFF
$DEBUG PBDEBUG OFF

$LIB COM        OFF
$LIB CGA        OFF
$LIB EGA        ON
$LIB VGA        OFF
$LIB HERC       OFF
$LIB LPT        OFF
$LIB IPRINT     OFF
$LIB FULLFLOAT  ON

$ERROR BOUNDS   Off
$ERROR NUMERIC  Off
$ERROR OVERFLOW Off
$ERROR STACK    Off

$FLOAT PROCEDURE

$COM    0
$STRING 16
$STACK  8192 ' big stack for big local array in SUB
$SOUND  1

$DIM ARRAY

$DYNAMIC

$OPTION CNTLBREAK OFF ' OFF in final EXE

'--------------------------------------------------------------------

DEFINT A-Z
OPTION ARRAY BASE 0
OPTION BINARY BASE 0
'
%False = 0
%True = NOT %False

%Debug = %false ' false in final exe

'--------------------------------------------------------------------
' external functions

$LINK "PHGTOOLS.PBU"
$INCLUDE "PHGTOOLS.DEF"

'--------------------------------------------------------------------
' internal functions

DECLARE SUB GetStrLoc() ' PowerBasic runtime library

SUB StdOut ( BYVAL Text AS STRING )
! push DS                    ; save DS FOR PowerBASIC
! push WORD Ptr Text         ; push STRING handle on stack
! CALL GetStrLoc
! jcxz ExitStdOut
! mov  DS, DX
! mov  DX, AX
! mov  AH, &H40              ; DOS WRITE TO file
! mov  BX, 1                 ; file handle 1 is CONS
! INT  &H21
ExitStdOut:
! pop  DS
END SUB

SUB StdOutLn( BYVAL s$ )
CALL StdOut (s$ + CHR$(13, 10) )
END SUB

'--------------------------------------------------------------------

type bmpFileheader
	ftype as string * 2 ' bm
	fsize as dword ' file size
	fzut1 as word '0 uint?
	fzut2 as word '0
	foffset as dword ' offset from this structure to the actual bitmap data in file
end type

type bmpinfoheader
	isize as dword ' size of this structure
	iwidth as long ' # of pixels
	iheight as long ' # of pixels
	iplanes as word ' must e 1
	ibitsperpixel as word ' 1=mono
	icompression as dword '
	isizeimage as dword ' can be 0 if rgb
	izut1 as long
	izut2 as long
	izut3 as dword
	izut4 as dword
end type

type rgbquad
	blue as byte
	green as byte
	red as byte
	zut as byte
end type

dim FH as bmpFileHeader
dim IH as bmpInfoHeader
dim inkoff as rgbquad
dim inkon as rgbquad

'--------------------------------------------------------------------
' main () begins here

ProgramName$="BWbmpDEF"
EXEName$="BWBMPDEF"
Version$="v1.0c"
Copyright$="par PhG"
Banner$=ProgramName$+" "+Version$+" "+Copyright$

stdoutln ""
cli$=upper$(COMMAND$) ' uppercase now
n=argC(cli$)
if n=0 then
	sos=%true
else
	sos=%false
end if
f$=""
negate=%false
font=%false
verbose=%false
for i=1 to n
	s$=argV$(cli$,i)
    select case left$(s$,1)
    case "-","/"
    	s$=mid$(s$,2) ' remove "-" or "/"
        select case s$
        case "?","H"
        	sos=%true
        case "N","R","I"
			negate=%true
        case "F"
        	font=%true
        case "V"
        	verbose=%true
        case else
            stdoutln "Option inconnue !"
            end 1
        end select
	case else
        if f$="" then
        	f$=s$
        else
        	stdoutln "Trop de paramtres !"
            end 1
        end if

    end select
next

if sos=%true then
	stdoutln Banner$
	stdoutln ""
	stdoutln "Syntaxe : "+ExeName$+" bmpfile[.BMP] [-n] [-f] [-v]"
    stdoutln ""
    stdoutln "A partir d'un fichier BMP monochrome, BWBMPDEF gnre"
    stdoutln "une image .DEF (pour MorfMsg) ou .DAT (pour FontTool)."
    stdoutln ""
    stdoutln "  -n ngatif"
    stdoutln "  -f police (largeur fixe  8, hauteur automatique 8 ou 16)"
    stdoutln "  -v eyecandy"
    END 0
END IF

CALL SplitPath(f$,currunit$,currpath$,currfile$)
CALL SplitName(currfile$,filename$,ext$)
if ext$="" then ext$="BMP"
f$=currunit$+currpath$+filename$+"."+ext$
if exist(f$) = %false then
	stdoutln "Le fichier n'existe pas !"
	end 2
end if
if font=%false then
	ext$=".DEF"
else
	ext$=".DAT"
end if
fout$=filename$+ext$
IF Exist(fout$) = %true THEN
	rc=Makebak(fout$,"BAK")
    if rc=%False then
		stdoutln "Problme pendant la cration de la copie de sauvegarde !"
		end 3
    end if
end if

hnd=freefile
open "b",#hnd,f$
get #hnd,0,FH
get #hnd,,IH
e=0
if fh.ftype <> "BM" then incr e
if ih.isize <> &h28 then incr e
if ih.ibitsperpixel <> 1 then incr e
if ih.icompression <> 0 then incr e
if e > 0 then
	close #hnd
    stdoutln "Le fichier n'est pas au format BMP monochrome RGB !"
    end 3
end if
get #hnd,,inkoff
get #hnd,,inkon

stdoutln "Largeur :"+str$(IH.iwidth)
stdoutln "Hauteur :"+str$(ih.iheight)
stdoutln ""
xmax=ih.iwidth
ymax=ih.iheight
pad32=(xmax-1) MOD 32
padcount=(31-pad32) \ 8 ' warning we countr bits 0..31 here!
dim grid?(1:xmax,1:ymax)
lm=xmax
rm=1
blank=getblank(negate)
for y = ymax to 1 step -1 ' stored in silly from down to up
	for x=1 to xmax ' stored from left to right padded at 32 bits boundary
    	ink=getpixel(hnd,x)
        grid?(x,y)=ink
        if (x < lm) and (ink=blank) then lm=x ' keep pos of first "*"
    	if (x > rm) and (ink=blank) then rm=x ' keep pos of last "*"
    next
	' silly M$ 32 bits obsession
    if pad32 <> 0 then
    	for i=1 to padcount
	    	get #hnd,,padbyte?
        next
    end if
next
close #hnd

hnd=freefile
open "o",#hnd,fout$
if font=%false then
	for y=1 to ymax
		s$=""
		for x=1 to xmax
    		ink=grid?(x,y)
    		c$=getchar$(ink,negate)
        	s$=s$+c$
    	next
    	if rm <> 1 then s$=left$(s$,rm) ' strip trailer
    	if lm <> xmax then s$=mid$(s$,lm) ' strip leader
    	if verbose=%true then stdoutln s$ ' show something
    	write #hnd,s$
	next
	print #hnd,""
	print #hnd,"$"
else
    if ymax > 8 then
    	hfont=16
    else
		hfont=8
    end if
    h=hfont-ymax ' 16-10=6, 8-7=1
    half=h\2
	if h=(half+half) then ' even
    	h1=half
        h2=half
    else
    	h1=half+1
        h2=half
    end if

	wifont=8 ' always
    nc=xmax \ wifont

    pad$=space$(wifont)
    for i=1 to nc
    	x=(i-1)*wifont+1
		print #hnd,""
        print #hnd,";"
        print #hnd,"; :::"
        print #hnd,";"
        print #hnd,""
        for y=1 to h1
        	write #hnd,pad$
        next
		for y=1 to ymax
        	s$=""
            for xx=x to x+wifont-1
            	ink=grid?(xx,y)
            	c$=getchar$(ink,negate)
            	s$=s$+c$
            next
            if verbose=%true then stdoutln s$
            write #hnd,s$
        next
		for y=1 to h2
        	write #hnd,pad$
        next
        if verbose=%true then stdoutln ""
    next
end if

close #hnd

stdoutln ""
stdoutln fout$+" contient le motif de bits."
end 0

function getpixel(byval hnd,byval x)
static byte?
decr x
currbit=x mod 8 ' 0..7
if currbit = 0 then	get #hnd,,byte?
thisbit=7-currbit
r=bit (byte?,thisbit) ' better safe than sorry : convert to 0..1 after
if r=0 then
	getpixel=0
else
	getpixel=1
end if
end function

function getchar$ (byval ink, byval negate)
select case ink
case 0
	select case negate
    case %false
       	c$="*"
    case %true
    	c$=" "
    end select
case 1
	select case negate
    case %false
    	c$=" "
    case %true
    	c$="*"
    end select
end select
getchar$=c$
end function

function getblank(byval negate)
select case negate
case %false
	blank=0
case %true
	blank=1
end select
getblank=blank
end function