(* this is a mere Q&D skeleton *)

MODULE Chryzo;

IMPORT Graph,BiosIO,MATHLIB,SYSTEM;
IMPORT Lib,Str;
FROM IO IMPORT WrStr,WrLn;

(* ------------------------------------------------------------ *)

CONST
    exe = "CHRYZO";

PROCEDURE abort (e:CARDINAL;S:ARRAY OF CHAR  );
BEGIN
    IF Str.Length(S) # 0 THEN WrStr(exe);WrStr(" : ");WrStr(S);WrLn;END;
    Lib.SetReturnCode( SHORTCARD(e) );
    HALT;
END abort;

PROCEDURE retrace ();
VAR
    i:CARDINAL;
BEGIN
    WHILE (SYSTEM.In(03DAH) AND 08H) # 0 DO
    END;
    WHILE (SYSTEM.In(03DAH) AND 08H) = 0 DO
    END;
END retrace;

PROCEDURE Delay (n:CARDINAL  );
VAR
    i:CARDINAL;
BEGIN
    FOR i:=1 TO n DO retrace();END;
END Delay;

(* ------------------------------------------------------------ *)

PROCEDURE line (x1,y1,x2,y2:LONGREAL; ink,delay:CARDINAL );
VAR
    xx1,yy1,xx2,yy2:CARDINAL;
BEGIN
    xx1:=VAL(CARDINAL,x1);
    yy1:=VAL(CARDINAL,y1);
    xx2:=VAL(CARDINAL,x2);
    yy2:=VAL(CARDINAL,y2);
    Graph.Line( xx1,yy1,xx2,yy2, ink );
    Delay(delay);
END line;

PROCEDURE plot (x,y:LONGREAL; ink:CARDINAL );
VAR
    xx,yy:CARDINAL;
BEGIN
    xx:=VAL(CARDINAL,x);
    yy:=VAL(CARDINAL,y);
    Graph.Plot( xx,yy, ink );
END plot;

PROCEDURE circle ( x,y,r:LONGREAL;ink,delay:CARDINAL  );
VAR
    xx,yy,rr:CARDINAL;
BEGIN
    xx:=VAL(CARDINAL,x);
    yy:=VAL(CARDINAL,y);
    rr:=VAL(CARDINAL,r);
    Graph.Circle(xx,yy,rr,ink);
    Delay(delay);
END circle;

VAR
    organgle : LONGREAL;
CONST
    halfcircle = LONGREAL(180.0);
    fullcircle = LONGREAL(360.0);

PROCEDURE calcpos (VAR x,y:CARDINAL;
                  deg2rad,cx,cy,radius:LONGREAL;whatdot,lastdot:CARDINAL );
VAR
    px,py,alphadeg:LONGREAL;
BEGIN
    alphadeg:=fullcircle / LONGREAL(lastdot) * LONGREAL(whatdot);
    alphadeg:=alphadeg+organgle;
    px := cx+radius * MATHLIB.Cos( alphadeg * deg2rad);
    py := cy+radius * MATHLIB.Sin( alphadeg * deg2rad);
    x:=CARDINAL(px);
    y:=CARDINAL(py);
END calcpos;

(* ------------------------------------------------------------ *)

CONST
    mindots      = 1;     maxdots      = 360;     defaultdots  = 6;
    minmult      = 1;     maxmult      = 100;     defaultmult  = 3;
    mindelay     = 0;     maxdelay     = 5;       defaultdelay = 0;
CONST
    gmode        = Graph._VRES16COLOR;
    tmode        = Graph._DEFAULTMODE;
CONST
    bkcolor=Graph._LIGHTRED;
    white = 15;
    black = 8;
VAR
    S:ARRAY[0..15] OF CHAR;
    alpha,pause,i,parmcount,delay,mult,dots,p:CARDINAL;
    v:LONGCARD;
    ok:BOOLEAN;
    ch:CHAR;
    PI,deg2rad,alphadeg:LONGREAL;
VAR
    oldbk:LONGCARD;
    V  : Graph.VideoConfig;
    xmin,xmax,ymin,ymax:CARDINAL;
    cx,cy,radius:LONGREAL;
    x,y,xx,yy:CARDINAL;
BEGIN
    WrLn;

    dots:=defaultdots;
    mult:=defaultmult;
    delay:=defaultdelay;
    alpha := 270;

    parmcount:=Lib.ParamCount();
    FOR i:=1 TO parmcount DO
         Lib.ParamStr(S,i);
         CASE S[0] OF
         | "-","/","?":
             WrStr("Q&D Chryzo v0.9 par PhG");WrLn;
             WrLn;
             WrStr("Syntaxe : "+exe+" [angle [points_sur_circonfrence [multiplicateur [dlai]]]]");WrLn;
             WrLn;
             WrStr("Angle          : 270 par dfaut, (0=e, 90=s, 180=ouest, 270=n)");WrLn;
             WrStr("Points         : 6 par dfaut, [1..360]");WrLn;
             WrStr("Multiplicateur : 3 par dfaut, [1..100]");WrLn;
             WrStr("Dlai          : 0 par dfaut, [0..50]");WrLn;
             abort(0,"");
         ELSE
             v:=Str.StrToCard(S,10,ok);
             IF ok THEN
                 CASE i OF
                 | 1:
                     CASE CARDINAL(v) OF
                     |  0,90,180,270: ;
                     ELSE
                         abort(2,"0, 90, 180 ou 270 !");
                     END;
                     alpha:=CARDINAL(v);
                 | 2:
                     IF v < mindots THEN abort(2,"[1..360] !");END;
                     IF v > maxdots THEN abort(2,"[1..360] !");END;
                     dots:=CARDINAL(v);
                 | 3:
                     IF v < minmult THEN abort(2,"[1..100] !");END;
                     IF v > maxmult THEN abort(2,"[1..100] !");END;
                     mult:=CARDINAL(v);
                 | 4:
                     IF v < mindelay THEN abort(2,"[0..5] !");END;
                     IF v > maxdelay THEN abort(2,"[0..5] !");END;
                     delay:=CARDINAL(v);
                 END;
             END;
         END;
    END;

    organgle := LONGREAL(alpha);
    organgle := organgle+ fullcircle / LONGREAL(dots);

    ok:=Graph.SetVideoMode(gmode);
    Graph.GetVideoConfig(V);
    xmin:=0; xmax:=V.numxpixels-1;
    ymin:=0; ymax:=V.numypixels-1;
    cx:=LONGREAL(V.numxpixels DIV 2);
    cy:=LONGREAL(V.numypixels DIV 2);
    oldbk:=Graph.SetBkColor(bkcolor);
    Graph.ClearScreen(Graph._GWINDOW);

    PI := 4.0 * MATHLIB.ATan(1.0);
    deg2rad := PI / halfcircle;

    radius:=222.0;
    circle(cx,cy,radius,white,delay);

    FOR i:=mindots TO dots DO
        calcpos(x,y,  deg2rad,cx,cy,radius,i,dots);
        circle( LONGREAL(x), LONGREAL(y),LONGREAL(4+i),white,delay);
    END;


    FOR i:=minmult TO maxmult DO
        calcpos(x,y,  deg2rad,cx,cy,radius,i,dots);
        p:=(  ( i * mult ) MOD dots );
        calcpos(xx,yy,  deg2rad,cx,cy,radius,p,dots);
        line( LONGREAL(x), LONGREAL(y), LONGREAL(xx), LONGREAL(yy),white,delay);
    END;

    LOOP
        retrace();
        IF BiosIO.KeyPressed() THEN
            ch:=BiosIO.RdKey();IF ch=CHR(0) THEN ch:=BiosIO.RdKey();END;
            EXIT;
        END;
    END;

    ok:=Graph.SetVideoMode(tmode);
    abort(0,"");
END Chryzo.




