(* ---------------------------------------------------------------
Title         Q&D Try And Overwrite Deleted Entry Names
Overview      see help
Usage         see help
Notes         very, very, very quick & dirty... :-(

              any undeleter shows very old and overwritten
              deleted filenames are still recoverable
              seems there's nothing to do against this behavior
              especially with NTFS systems
              and as it is almost impossible to program
              at bare metal level...
              defragmenting seems useless
              this was an idea for an experimental fix :
              overwriting specified directories
              with dozens of files (incremented filenames, 0 or 1 byte long)
              this trick, should had it worked, would have done nothing
              for files still visible in deleted subdirs

              another useless idea... ;-)
              recreating a deleted subdir then filling it again might work

              error checking is minimal

              v0.9 for now because very experimental and utterly useless

Bugs          yes, yes, we should check handle returned by fileCreate()
              is not MAX(CARDINAL)... in another life !
Wish List     back to the AIM-65 and Apple ][+ days...

--------------------------------------------------------------- *)

MODULE gotoHell;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT SYSTEM;

FROM QD_ASCII IMPORT dash, slash, nullchar, tabchar, cr, lf, nl, bs,
space, dot, deg, degree, doublequote, quote, colon, percent, vbar,
blank, equal, dquote, charnull, singlequote, antislash, dollar,
star, backslash, coma, question, underscore, underbar, tabul, hbar,
comma, semicolon, diese, pound, openbracket, closebracket, tilde, exclam,
stardotstar, dotdot, escCh, escSet, letters, digits,
lettersUpp, lettersLow, openbrace, closebrace, ampersand;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite, setReadOnly,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs, UpperCaseAlt, LowerCaseAlt,
completedInit, completedShow, completedSHOW, completedEnd, completed,
removeDups, isValidHDunit, removePhantoms, removeFloppies,
getCDROMunits, getCDROMletters, removeCDROMs, getAllHDunits,
getAllLegalUnits, metaproc, getCli, argc, argv, qdSplitAllPath,
metaproc, UpperCaseFR, LowerCaseFR, ASCIIonly;

FROM QD_File IMPORT pathtype, w9XnothingRequired,
fileOpenRead, fileOpen, fileExists, fileExistsAlt,
fileIsRO, fileSetRW, fileSetRO,
fileErase, fileCreate, fileRename, fileGetFileSize, fileGetFileStamp,
fileIsDirectorySpec, fileClose, fileSupportLFN;

FROM IO IMPORT WrStr,WrLn,WrCard,WrLngCard;

(* ------------------------------------------------------------ *)

CONST
    (* select an executable filename ! *)
    useGOTOHELL     = TRUE;  (* go away from this entry space ! *)
    useOBLIVION     = FALSE; (* go forgotten once and for all ! *)
    useMASKEM       = FALSE; (* have a mask so you're anonymous... and cannot breathe too ! *)

CONST
(*%T useGOTOHELL *)
    ProgEXEname     = "GOTOHELL";
(*%E *)
(*%T useOBLIVION *)
    ProgEXEname     = "OBLIVION";
(*%E *)
(*%T useMASKEM *)
    ProgEXEname     = "MASKEM";
(*%E *)
    ProgTitle       = "Q&D Try And Overwrite Deleted Entry Names";
    ProgVersion     = "v0.9";
    ProgCopyright   = "by PhG";
    Banner          = ProgTitle+" "+ProgVersion+" "+ProgCopyright;
CONST
    strDefaultLFNbasename = "GoAway!GoAway!GoAway!.tmp";
    strDefaultDOSbasename = "DIE!.TMP";
    mincount            = 1;
    maxcount            = 9999;
    winum               = 4; (* #### *)
    wiDOSf8             = 8-winum;
    wiDOSe3             = 1+3; (* leading dot *)
    strCountRange       = "[1..9999]";
CONST
    sINFO           = "::: ";
    sPB             = "--- ";
CONST
    errNone         = 0;
    errHelp         = 1;
    errOption       = 2;
    errTooManyParms = 3;
    errMissingParm  = 4;
    errNotFound     = 5;
    errBadCount     = 6;
    errCountRange   = 7;
    errSyntax       = 8;
    errBadBasename  = 9;
    errBadDirList   = 10;
    errIsDir        = 11;
    errAborted      = 255;

(* ------------------------------------------------------------ *)

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)

errmsg =
Banner+nl+
nl+
"Syntax : "+ProgEXEname+" <[@]dirlist> <count> [basename] [option]..."+nl+
nl+
"This program creates <count> files named ####basename"+nl+
"for each directory specified in <[@]dirlist>,"+nl+
"then deletes them all unless instructed no to."+nl+
"Yet Another Useless Idea. ;-)"+nl+
nl+
"    -k[e|k] keep created files instead of deleting them (-ke = -k -e)"+nl+
"    -e[k|e] create 0-byte files instead of 1-byte files (-ek = -e -k)"+nl+
"    -x      disable LFN support even if available"+nl+
nl+
"a) Each entry in <[@]dirlist> must be a valid directory in canonical form."+nl+
"b) <count> must belong to "+strCountRange+"."+nl+
'c) Default LFN basefilename is "'+strDefaultLFNbasename+'" ;'+nl+
'   default DOS basefilename is "'+strDefaultDOSbasename+'".'+nl+
nl+
"Example : "+ProgEXEname+" list.lst 500 _tryandoverwriteme.$$$"+nl;

VAR
    S : str1024; (* was str256 but in case we get a LFN... *)
BEGIN
    CASE e OF
    | errHelp :
        WrStr(errmsg);
    | errOption:       S:= 'Unknown "~" option !';
    | errTooManyParms: S:= '"~" parameter is one too many !';
    | errMissingParm:  S:= 'Missing "~" parameter !';
    | errNotFound:     S:= '"~" does not exist !';
    | errBadCount:     S:= 'Illegal "~" <count> value !';
    | errCountRange:   S:= '"~" <count> must belong to '+strCountRange+"range !";
    | errSyntax:       S:= "Please check syntax !";
    | errBadBasename:  S:= 'Illegal "~" basename !';
    | errBadDirList:   S:= 'Illegal "~" dirlist !';
    | errIsDir:        S:= '"~" looks like a directory !';
    | errAborted:      S:= "Aborted by user !";
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp:
        ;
    ELSE
        Str.Subst(S,"~",einfo);
        WrStr(ProgEXEname+" : ");WrStr(S);WrLn;
    END;
    Lib.SetReturnCode(SHORTCARD(e));
    HALT;
END abort;

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBufferType  = ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
VAR
    ioBufferIn    : ioBufferType;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE fixTrailingDot (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = dot THEN RETURN; END;
    Str.Append(S,dot);
END fixTrailingDot;

PROCEDURE unfixTrailingDot (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # dot THEN RETURN; END;
    Str.Delete(S,len-1,1);
END unfixTrailingDot;

PROCEDURE fmtnum (v:LONGCARD;wi:CARDINAL;padchar:CHAR):str16;
VAR
    N:str16;
    ok:BOOLEAN;
    i:CARDINAL;
BEGIN
    Str.CardToStr(v,N,10,ok);
    IF ok THEN
        FOR i:= Str.Length(N)+1 TO wi DO
            Str.Prepend(N,padchar);
        END;
    ELSE
        N:="";
        FOR i:= 1 TO wi DO Str.Append(N,"#");END;
    END;
    RETURN N;
END fmtnum;

PROCEDURE pad (wi:CARDINAL;VAR R:ARRAY OF CHAR);
VAR
    i:CARDINAL;
BEGIN
    FOR i:=Str.Length(R)+1 TO wi DO Str.Append(R," ");END;
END pad;

(* ------------------------------------------------------------ *)

CONST
               (* 12345678901234567890 *)
    msgDirList = "dirlist";
    msgBasename= "basename";
    msgCount   = "count";
    msgEmpty   = "empty files";
    msgDelete  = "delete files";
    msgUseLFN  = "LFN";
    wimsg      = 12; (* longest *)

PROCEDURE msgstr (S1,S2:ARRAY OF CHAR   );
VAR
    S:str256;
BEGIN
    Str.Copy(S,S1);
    pad(wimsg,S);
    Str.Prepend(S,sINFO);
    Str.Append(S,' : "~"');
    Str.Subst(S,"~",S2);
    WrStr(S);WrLn;
END msgstr;

PROCEDURE msgbool (S1:ARRAY OF CHAR;tf:BOOLEAN);
CONST
    strYes = "yes";
    strNo  = "no";
VAR
    S:str256;
    truth:str16;
BEGIN
    Str.Copy(S,S1);
    pad(wimsg,S);
    Str.Prepend(S,sINFO);
    Str.Append(S,' : ~');
    IF tf THEN
        truth:=strYes;
    ELSE
        truth:=strNo;
    END;
    Str.Subst(S,"~",truth);
    WrStr(S);WrLn;
END msgbool;

PROCEDURE msgcard (S1:ARRAY OF CHAR;v:CARDINAL);
VAR
    S:str256;
BEGIN
    Str.Copy(S,S1);
    pad(wimsg,S);
    Str.Prepend(S,sINFO);
    Str.Append(S,' : ~');
    Str.Subst(S,"~",fmtnum(LONGCARD(v),1," ")); (* OR winum ? *)
    WrStr(S);WrLn;
END msgcard;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE isValidBasename ( useLFN:BOOLEAN;Z:pathtype):BOOLEAN;
CONST
    dotstarpat = ".*";
VAR
    S,u,d,n,e:pathtype;
    pb:CARDINAL;
BEGIN
    Str.Copy(S,Z);
    fixTrailingDot(S);

    pb:=0;
    qdSplitAllPath(S, u,d,n,e);
    IF Str.Length(u) > 0 THEN INC(pb);END;
    IF Str.Length(d) > 0 THEN INC(pb);END;
    IF Str.Length(n) < 1 THEN INC(pb);END;
    IF Str.Length(e) < 1 THEN INC(pb);END;
    IF Str.Match(e,dotstarpat)=FALSE THEN INC(pb);END;

    IF NOT(useLFN) THEN
        IF Str.Length(n) > wiDOSf8 THEN INC(pb);END;
        IF Str.Length(e) > wiDOSe3 THEN INC(pb);END;
    END;
    RETURN (pb=0);
END isValidBasename;

(* ------------------------------------------------------------ *)

PROCEDURE preprocessLine (useLFN:BOOLEAN; VAR S:ARRAY OF CHAR):BOOLEAN;
CONST
    quotedpat     = '"*"';
    canonicalpat  = "?:\*";
VAR
    len:CARDINAL;
    ok:BOOLEAN;
BEGIN
    LtrimBlanks(S);
    RtrimBlanks(S);
    IF Str.Match(S,quotedpat) THEN
        Str.Delete(S,0,1);
        len:=Str.Length(S);
        Str.Delete(S,len-1,1);
        LtrimBlanks(S);
        RtrimBlanks(S);
    END;
    ok:=Str.Match(S,canonicalpat);
    IF ok THEN
        ok:=fileIsDirectorySpec(useLFN,pathtype(S));
        IF ok THEN fixDirectory(S); END;
    END;
    RETURN ok;
END preprocessLine;

PROCEDURE procList (DEBUG,useLFN,createempty,keepalive:BOOLEAN;count:CARDINAL;
                   dirlist,basename:pathtype ):CARDINAL ;
CONST
    msgProcessing = sINFO+'processing "~"';
    msgSkipping   = sPB  +'skipping   "~"';
    stardotpat = "*.";
VAR
    hin,h:FIO.File;
    DIR,CREATED:pathtype;
    ok,aborted:BOOLEAN;
    i,n,poll,currpoll:CARDINAL;
    msg:str1024;
    zero:SHORTCARD;
BEGIN
    zero := 0;

    IF useLFN THEN
        poll := 50; (* vindoze does not like frequent calls TO chkEscape() *)
    ELSE
        poll := 5;
    END;
    currpoll:=0;

    aborted:=FALSE;
    FIO.EOF := FALSE;
    hin:=fileOpenRead(useLFN,dirlist);
    FIO.AssignBuffer(hin,ioBufferIn);
    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hin,DIR);
        IF FIO.EOF THEN EXIT; END;
        ok:=preprocessLine(useLFN,DIR);
        IF ok THEN
            fixDirectory(DIR);
            msg:=msgProcessing;
        ELSE
            msg:=msgSkipping;
        END;
        Str.Subst(msg,"~",DIR);
        WrStr(msg);WrLn;

        IF ok THEN
            n:=mincount-1;
            LOOP
                INC(n);
                Str.Concat(CREATED,fmtnum(LONGCARD(n),4,"0"),basename);
                Str.Prepend(CREATED,DIR);
                IF DEBUG THEN WrStr("created ");WrStr(CREATED);WrLn;END;
                h:=fileCreate(useLFN,CREATED);
                IF NOT(createempty) THEN
                    FIO.WrBin(h,zero,SIZE(zero));
                END;
                fileClose(useLFN,h);

                INC(currpoll);
                IF (currpoll MOD poll) = 0 THEN
                    aborted:=ChkEscape();IF aborted THEN EXIT;END;
                    currpoll:=0;
                END;

                IF n >= count THEN EXIT;END;
            END;
            IF NOT(keepalive) THEN
                FOR i:= mincount TO n DO
                    Str.Concat(CREATED,fmtnum(LONGCARD(i),4,"0"),basename);
                    Str.Prepend(CREATED,DIR);
                    IF DEBUG THEN WrStr("deleted "); WrStr(CREATED);WrLn;END;
                    fileErase(useLFN,CREATED);
                END;
            END;
        END;
    END;
    fileClose(useLFN,hin);
    IF aborted THEN
        i:=errAborted;
    ELSE
        i:=errNone;
    END;
    RETURN i;
END procList;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

VAR
    parmcount,i,opt : CARDINAL;
    S,R             : pathtype; (* was str128 *)
    state           : (waiting,gotdirlist,gotcount,gotbasename);
    dirlist,basename:pathtype;
    createempty,keepalive : BOOLEAN;
    lc:LONGCARD;
    count:CARDINAL;
VAR
    DEBUG,useLFN:BOOLEAN;
    poll,currpoll:CARDINAL;
BEGIN
    Lib.DisableBreakCheck();
    FIO.ShareMode:=FIO.ShareDenyNone;

    WrLn;

    basename    := "";
    createempty := FALSE;
    keepalive   := FALSE;
    useLFN      := TRUE;
    DEBUG       := FALSE;

    state   := waiting;
    parmcount := Lib.ParamCount();
    IF parmcount=0 THEN abort(errHelp,"");END;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   "X"+delim+"LFN"+delim+
                                   "K"+delim+"KEEP"+delim+
                                   "E"+delim+"EMPTY"+delim+
                                   "KE"+delim+"KK"+delim+
                                   "EK"+delim+"EE"+delim+
                                   "DEBUG"
                               );
            CASE opt OF
            | 1,2,3 : abort(errHelp,"");
            | 4,5   : useLFN      := FALSE;
            | 6,7   : keepalive   := TRUE;
            | 8,9   : createempty := TRUE;
            | 10,11 : keepalive   := TRUE; createempty := TRUE;
            | 12,13 : createempty := TRUE; keepalive   := TRUE;
            | 14    : DEBUG       := TRUE;
            ELSE
                abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            CASE state OF
            | waiting    : Str.Copy(dirlist,S);
            | gotdirlist : Str.Prepend(R,"-N:");
                           IF GetLongCard(R,lc)=FALSE THEN abort(errBadCount,S);END;
                           IF lc > maxcount THEN abort(errCountRange,S);END;
                           IF lc < mincount THEN abort(errCountRange,S);END;
                           count:=CARDINAL(lc);
            | gotcount:    Str.Copy(basename,S);
                           IF Str.RCharPos(basename,dot)=MAX(CARDINAL) THEN
                               Str.Append(basename,dot);
                           END;
            | gotbasename: abort(errTooManyParms,S);
            END;
            INC(state);
        END;
    END;

    useLFN := (useLFN AND fileSupportLFN() );
    IF same(basename,"") THEN
        IF useLFN THEN
            basename:=strDefaultLFNbasename;
        ELSE
            basename:=strDefaultDOSbasename;
        END;
    END;

    IF DEBUG THEN
        msgstr(msgDirList,dirlist);
        msgstr(msgBasename,basename);
        msgcard(msgCount,count);
        msgbool(msgEmpty,createempty);
        msgbool(msgDelete,NOT(keepalive));
        msgbool(msgUseLFN,useLFN);
        WrLn;
    END;

    CASE state OF
    | waiting:     abort(errSyntax,"");
    | gotdirlist:  abort(errSyntax,"");
    | gotcount:    ;
    | gotbasename: IF isValidBasename(useLFN,basename) = FALSE THEN
                       abort(errBadBasename,basename);
                   END;
    END;

    i:=0;
    IF same(dirlist,dot) THEN INC(i);END;
    IF chkJoker(dirlist) THEN INC(i);END;
    IF i # 0 THEN abort(errBadDirList,dirlist);END;

    IF Str.Match(dirlist,"@*") THEN Str.Delete(dirlist,0,1);END;

    unfixTrailingDot(dirlist);
    unfixTrailingDot(basename);

    IF fileIsDirectorySpec(useLFN,dirlist) THEN abort(errIsDir,dirlist);END;
    IF fileExists(useLFN,dirlist)=FALSE THEN abort(errNotFound,dirlist);END;

    IF DEBUG THEN
        msgstr(msgDirList,dirlist);
        msgstr(msgBasename,basename);
        msgcard(msgCount,count);
        msgbool(msgEmpty,createempty);
        msgbool(msgDelete,NOT(keepalive));
        msgbool(msgUseLFN,useLFN);
        WrLn;
    END;

    i:=procList(DEBUG,useLFN,createempty,keepalive,count,dirlist,basename);

    abort(i,"");
END gotoHell.



(*

c:\z\x.y
zut
"c:\z"
; c:\

*)
