(* ---------------------------------------------------------------
Title         see help
Overview      see help
Usage         see help
Notes         "the CASE against M2 ISO"
              "M2 ISO considered harmful"

              should a Win32 version be created,
              redirection will probably be a problem whether with XDS or ADW
              we don't care : we merely do DOS ;-)
              ah, we're too nice after all :
              let's process source and create a backup

              in EEVAL.MOD readtoken(), program v0.9a would wrongly fix
              outer LOOP with aa useless ELSE, thus preventing compilation
              by luck, only affected by the bug : EEVAL, STORM0, MPAUSE0

Bugs
Wish List     better check parser even if it seems OK
              (for now, label program as v0.9)
              insert CASE line number for inserted ELSE ?

--------------------------------------------------------------- *)

MODULE ISOCASE;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;

FROM IO IMPORT WrStr,WrLn,WrChar;

FROM QD_ASCII IMPORT dash, slash, nullchar, tabchar, cr, lf, nl, bs,
space, dot, deg, doublequote, quote, colon, percent, vbar,
blank, equal, dquote, charnull, singlequote, antislash, dollar,
star, backslash, coma, question, underscore, tabul, hbar,
comma, semicolon, diese, pound, openbracket, closebracket, tilde, exclam,
stardotstar, dotdot, escCh, escSet, letters, digits,
lettersUpp, lettersLow, openbrace, closebrace;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory, qdSplitAllPath,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite, setReadOnly,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs, UpperCaseAlt, LowerCaseAlt,
completedInit, completedShow, completedSHOW, completedEnd, completed,
removeDups, isValidHDunit, removePhantoms, removeFloppies,
getCDROMunits, getCDROMletters, removeCDROMs, getAllHDunits,
getAllLegalUnits, metaproc, getCli, argc, argv;

FROM QD_File IMPORT pathtype, w9XnothingRequired,
fileOpenRead, fileOpen, fileExists, fileExistsAlt,
fileIsRO, fileSetRW, fileSetRO,
fileErase, fileCreate, fileRename, fileGetFileSize, fileGetFileStamp,
fileIsDirectorySpec, fileClose, fileFlush, fileSupportLFN;


(* ------------------------------------------------------------ *)

CONST
    extMOD          = ".MOD";
    extINI          = ".INI";
    extBAK          = ".ORG";
CONST
    defaultInsertMEhere = "ELSE ; (* //ISO fixed silly requirement *)";
    defaultTokenset     = lettersLow+lettersUpp+underscore;
    defaultTokensetfull = defaultTokenset+digits;
    (* avoid CASE here, of course *)
    defaultKeywords     = "FOR,IF,LOOP,"+
                          "MODULE,PROCEDURE,RECORD,WHILE";
CONST
    (* no inner space, no inner tab *)
    defaultINI = nl+
"   ; verbatim strings can be delimited with double or single quotes"+nl+
"   ; 1. inserted ELSE statement with a reminder"+nl+
"   ;    (note a trailing space separator will be added if omitted here)"+nl+
'   "'+defaultInsertMEhere+'"'+nl+
"   ; 2. legal characters for first character of keyword"+nl+
'   "'+defaultTokenset+'"'+nl+
"   ; 3. legal characters for inner characters of keyword"+nl+
'   "'+defaultTokensetfull+'"'+nl+
"   ; 4. comma-separated keywords requiring an END (except CASE itself)"+nl+
'   "'+defaultKeywords+'"'+nl+
nl;

CONST
    ProgEXEname     = "ISOCASE";
    ProgTitle       = "Q&D Modula-2 ISO CASE checker";
    ProgVersion     = "v1.0";
    ProgCopyright   = "by PhG";
    Banner          = ProgTitle+" "+ProgVersion+" "+ProgCopyright;

CONST
    errNone         = 0;
    errHelp         = 1;
    errOption       = 2;
    errTooManyParms = 3;
    errJoker        = 4;
    errNotFound     = 5;
    errParm         = 6;
    errIniProblem   = 7;
    errStack        = 8;
    errBackup       = 9;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
    placeholder = vbar;
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)

errmsg = nl+
Banner+nl+
nl+
"Syntax : "+ProgEXEname+" <source["+extMOD+"]> [-![!]]"+nl+
nl+
"This program scans a TopSpeed Modula-2 source,"+nl+
"inserting the ELSE required by Modula-2 ISO for each CASE (if necessary)."+nl+
"Remarks and strings contents are ignored."+nl+
nl+
"This mandatory ELSE for each CASE is useless and stupid"+nl+
"whether the real-world programmer has handled all possible cases or not."+nl+
"The (censored) Modula-2 ISO academic committee has created the ternary BOOLEAN"+nl+
"requiring an ELSE in a CASE where both TRUE and FALSE are handled !"+nl+
'"The CASE against Modula-2 ISO" or "Modula-2 ISO considered harmful". ;-)'+nl+
nl+
"-@    dump fixed source to screen instead of modifying it"+nl+
"-![!] create default "+ProgEXEname+extINI+" in current directory then terminate"+nl+
"      (-!! = overwrite existing "+ProgEXEname+extINI+", if any)"+nl+
"-b    append "+extBAK+" extension to source instead of replacing original extension"+nl+
"      (this option obviously does require LFN support)"+nl+
"-x    disable LFN support even if available"+nl+
nl+
"a) Source code is assumed to be correct (its compilation should be a success)."+nl+
"b) If "+ProgEXEname+extINI+" exist in either current or executable directory,"+nl+
"   the program will read four strings from it. Else, it will default to :"+nl+
defaultINI+
"c) For safety, original source will be kept with "+extBAK+" extension."+nl+
"d) Any inserted ELSE will have this form :"+nl+
nl+
'   "'+defaultInsertMEhere+'"'+nl+
nl+
"e) By design, jokers are not supported."+nl;

VAR
    S : str1024;
BEGIN
    CASE e OF
    | errHelp :        WrStr(errmsg);
    | errOption:       S:='Unknown "'+placeholder+'" option !';
    | errTooManyParms: S:='"'+placeholder+'" parameter is one too many !';
    | errJoker:        S:='No joker allowed in "'+placeholder+'" specification !';
    | errNotFound:     S:='No valid file matches "'+placeholder+'" specification !';
    | errParm:         S:="Expecting "+placeholder+" parameter !";
    | errIniProblem:   S:="Illegal "+placeholder+" file !";
    | errStack:        S:="Keywords stack overflow or  underflow !";
    | errBackup:       S:='Illegal "'+extBAK+'" extension in "'+placeholder+'" specification !';
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp:
        ;
    ELSE
        Str.Subst(S,placeholder,einfo);
        WrLn; (* was NOT dumped at program start *)
        WrStr(ProgEXEname+" : ");WrStr(S);WrLn;
    END;
    Lib.SetReturnCode(SHORTCARD(e));
    HALT;
END abort;

(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBufferType    = ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
VAR
    ioBufferIn        : ioBufferType;
    ioBufferOut       : ioBufferType;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    widbg = 4; (* strings *)
    wicard= 6;

PROCEDURE card2str (v,base,wi:CARDINAL;padchar:CHAR):str16;
VAR
    R:str16;
    ok:BOOLEAN;
    i:CARDINAL;
BEGIN
    Str.CardToStr ( LONGCARD(v),R,base,ok);
    FOR i:=Str.Length(R)+1 TO wi DO Str.Prepend(R,padchar);END;
    RETURN R;
END card2str;

PROCEDURE dbgme (DEBUG:BOOLEAN;currline,stackndx:CARDINAL;token:ARRAY OF CHAR );
VAR
    S:str128;
BEGIN
    IF DEBUG THEN
        S:='::: line = ~ ::: stack index = ~ ::: token = "~"';
        Str.Subst(S,"~",card2str(currline,10,wicard,blank));
        Str.Subst(S,"~",card2str(stackndx,10,wicard,blank));
        Str.Subst(S,"~",token);
        WrStr(S);WrLn;
    END;
END dbgme;

PROCEDURE dbg (DEBUG:BOOLEAN;S1,S2:ARRAY OF CHAR);
VAR
    i:CARDINAL;
BEGIN
    IF DEBUG THEN
        WrLn; (* DO not be mixed IN code *)
        WrStr("::: "+"// "); (* avoid being kept by newline *)
        WrStr(S1);
        FOR i:= Str.Length(S1)+1 TO widbg DO WrStr(" ");END;
        WrStr(S2);WrLn;
    END;
END dbg;

PROCEDURE dbgv (DEBUG:BOOLEAN;v:CARDINAL; S1:ARRAY OF CHAR);
VAR
    i:CARDINAL;
BEGIN
    IF DEBUG THEN
        WrLn; (* DO NOT be mixed IN code *)
        WrStr("::: "+"// ");
        WrStr(S1);
        FOR i:= Str.Length(S1)+1 TO widbg DO WrStr(" ");END;
        WrStr( card2str(v,10,wicard,blank));WrLn;
    END;
END dbgv;

(* ------------------------------------------------------------ *)

PROCEDURE unquote (VAR S:ARRAY OF CHAR);
VAR
    len:CARDINAL;
BEGIN
    len:=Str.Length(S);
    IF len < (1+1) THEN RETURN;END; (* we need at least 2 chars *)
    IF S[0] = S[len-1] THEN
        S[len-1]:=charnull;
        Str.Delete(S,0,1);
    END;
END unquote;

VAR
    sinsertMEhere,stokenset,stokensetfull:str128;  (* more than enough *)
    skeywords:str1024;                             (* just in case *)

PROCEDURE initSpecial (DEBUG, useLFN:BOOLEAN ):BOOLEAN ;
CONST
    firststr = 1;
    laststr  = 4;
VAR
    ini:pathtype;
    p:CARDINAL;
    fromini,ok:BOOLEAN;
    hin:FIO.File;
    S:str1024;
BEGIN
    ok:=TRUE;
    ini:=ProgEXEname+extINI;
    fromini:= fileExists(useLFN,ini);
    IF NOT(fromini) THEN
        Lib.ParamStr(ini,0);
        p:=Str.RCharPos(ini,dot);
        IF p # MAX(CARDINAL) THEN ini[p]:=charnull;END;
        Str.Append(ini,extINI);
        fromini:=fileExists(useLFN,ini);
    END;
    IF fromini THEN
        dbg(DEBUG,"ini",ini);
        hin:=fileOpenRead(useLFN,ini);
        p:=firststr;
        LOOP
            IF FIO.EOF THEN EXIT; END;
            FIO.RdStr(hin,S);
            LtrimBlanks(S);
            RtrimBlanks(S);
            CASE S[0] OF
            | semicolon, pound, charnull: (* remark or empty *)
                ;
            ELSE
                dbg(DEBUG,"S",S);
                unquote(S); (* no trimming here *)
                CASE p OF
                | firststr: Str.Copy(sinsertMEhere,S);
                | 2:        Str.Copy(stokenset,S);
                | 3:        Str.Copy(stokensetfull,S);
                | laststr:  Str.Copy(skeywords,S);
                END;
                INC(p);
                IF p > laststr THEN EXIT;END;
            END;
        END;
        fileClose(useLFN,hin);
        ok:=( p > laststr );
    ELSE
        sinsertMEhere := defaultInsertMEhere;
        stokenset     := defaultTokenset;
        stokensetfull := defaultTokensetfull;
        skeywords     := defaultKeywords;
    END;

    ReplaceChar(skeywords, space,"");
    ReplaceChar(skeywords, tabul,"");

    p:=Str.Length(sinsertMEhere);
    IF p # 0 THEN
        CASE sinsertMEhere[p-1] OF
        | space,tabul:
            ; (* ok, user has thought OF it *)
        ELSE
            Str.Append(sinsertMEhere,space); (* force trailing space separator for following END *)
        END;
    END;
    RETURN ok;
END initSpecial;

PROCEDURE genINI (useLFN,overwrite:BOOLEAN;ini:pathtype  );
VAR
    hout:FIO.File;
    ok:BOOLEAN;
    S:str128;
BEGIN
    IF fileExists(useLFN,ini) THEN
        IF overwrite THEN
            ok:=TRUE; S:="::: Overwrite existing ~";
        ELSE
            ok:=FALSE;S:="::: Skip existing ~";
        END;
    ELSE
            ok:=TRUE; S:="::: Create ~";
    END;
    Str.Subst(S,tilde,dquote+tilde+dquote);
    Str.Subst(S,tilde,ini);
    WrLn; (* was not added at program start because of redirection *)
    WrStr(S);WrLn;
    IF ok THEN
        hout:=fileCreate(useLFN,ini);
        FIO.WrStr(hout,defaultINI);
        fileClose(useLFN,hout);
    END;
END genINI;

(* ------------------------------------------------------------ *)

CONST
    minstack = 1;
    maxstack = 16384; (* why... but why not ? should do anyway *)
VAR
    pushedtoken : ARRAY[minstack..maxstack] OF SHORTCARD;
    pushedline  : ARRAY[minstack..maxstack] OF CARDINAL;  (* for later use *)

PROCEDURE procToken (VAR stackndx:CARDINAL; VAR doinsert : BOOLEAN;
                    DEBUG:BOOLEAN;currline:CARDINAL;token:ARRAY OF CHAR):BOOLEAN;
CONST
    isCASE    = 0;
    isELSE    = 1;
    isEND     = 2;
    isIF      = 3;
    isOTHER   = 4;
    isIGNORED = 5; (* not IN list of keywords *)
VAR
    id:CARDINAL;
BEGIN
    doinsert := FALSE;
    IF same(token,"CASE") THEN
        id:=isCASE;
    ELSIF same(token,"ELSE") THEN
        id:=isELSE;
    ELSIF same(token,"END") THEN
        id:=isEND;
    ELSIF same(token,"IF") THEN
        id:=isIF;
    ELSIF getStrIndex(comma,token,skeywords) # 0 THEN
        id:=isOTHER;
    ELSE
        id:=isIGNORED;
    END;
    IF id = isIGNORED THEN RETURN TRUE;END;

    INC(stackndx); IF stackndx > maxstack THEN RETURN FALSE;END;

    (*
    dbg(DEBUG,"token",token); dbgv(DEBUG,currline,"currline");
    dbgv(DEBUG,stackndx,"stack index");
    *)
    dbgme(DEBUG,currline,stackndx,token);

    pushedline[stackndx]:=currline;
    CASE id OF
    | isCASE:
        pushedtoken[stackndx]:=isCASE;
    | isELSE:
        pushedtoken[stackndx]:=isELSE;
    | isOTHER:
        pushedtoken[stackndx]:=isOTHER;
    | isIF:
        pushedtoken[stackndx]:=isIF;
    | isEND:
        pushedtoken[stackndx]:=isEND; (* useless but for the principle *)
        DEC(stackndx); IF stackndx < minstack THEN RETURN FALSE;END;
        CASE pushedtoken[stackndx] OF
        | isOTHER:IF stackndx > minstack THEN DEC(stackndx);END;
        | isIF:   IF stackndx > minstack THEN DEC(stackndx);END;
        | isELSE: IF stackndx > minstack THEN DEC(stackndx);END;
                  CASE pushedtoken[stackndx] OF
                  | isCASE,isIF,isOTHER:
                      IF stackndx > minstack THEN DEC(stackndx);END;
                  END;
        | isCASE: IF stackndx > minstack THEN DEC(stackndx);END;
                  doinsert := TRUE;
        END;
    END;
    RETURN TRUE;
END procToken;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE backonechar ( hin:FIO.File );
VAR
    fpos:LONGCARD ;
BEGIN
    fpos:=FIO.GetPos(hin);
    IF fpos # 0 THEN FIO.Seek(hin,fpos-1);END;
END backonechar;

PROCEDURE grabnextchar ( VAR nextch:CHAR;hin:FIO.File  );
VAR
    got,wanted:CARDINAL;
BEGIN
    wanted:=SIZE(nextch);
    got:=FIO.RdBin(hin,nextch,wanted);
    IF got # wanted THEN nextch:=charnull;END;
END grabnextchar;

PROCEDURE procSrc (DEBUG,useLFN,tofile,dosbak:BOOLEAN;src:pathtype):BOOLEAN;
CONST
    (* extremely unlikely to already exists ! *)
    tmpf8 = "~TMP~ISO~";
    tmpe3 = ".TMP";
VAR
    hin,hout:FIO.File;
    state:(waiting,instring,intoken,inremark);
    token:str128;
    stackndx,remdepth,got,wanted,currline:CARDINAL;
    ch,stringdelim:CHAR;
    doinsert,ok:BOOLEAN;
    u,d,n,e,target,tmpcanonical:pathtype;
BEGIN
    qdSplitAllPath(src, u,d,n,e);
    IF dosbak THEN
    Lib.MakeAllPath(target,u,d,n,extBAK);
    ELSE
    Str.Concat(target,src,extBAK);
    END;
    Lib.MakeAllPath(tmpcanonical,u,d,tmpf8,tmpe3);

    IF tofile THEN
        hout:=fileCreate(useLFN,target);
        FIO.AssignBuffer(hout,ioBufferOut);
    ELSE
        hout:=FIO.StandardOutput;
    END;

    currline:=1;
    ok:=TRUE;
    stackndx := minstack-1;
    remdepth := 0;

    hin := fileOpenRead(useLFN,src);
    FIO.AssignBuffer(hin,ioBufferIn);
    wanted:=SIZE(ch);
    state:=waiting;
    LOOP
        got:=FIO.RdBin(hin,ch,wanted);
        IF got # wanted THEN EXIT;END;
        IF ch = lf THEN INC(currline);END; (* handle both DOS and "others" *)
        CASE state OF
        | waiting:
            IF Belongs(stokenset,ch) THEN
                Str.Copy(token,ch);
                state:=intoken;
            ELSE
                FIO.WrChar(hout,ch);
                CASE ch OF
                | doublequote,singlequote:
                    stringdelim:=ch;
                    state:=instring;
                | "(":
                    grabnextchar(ch,hin);
                    IF ch="*" THEN
                        FIO.WrChar(hout,ch);
                        INC(remdepth);
                        state:=inremark;
                    ELSE
                        backonechar(hin);
                    END;
                | "*":
                    grabnextchar(ch,hin);
                    IF ch = ")" THEN
                        IF remdepth # 0 THEN DEC(remdepth);END;
                        IF remdepth = 0 THEN state := waiting; END;
                        FIO.WrChar(hout,ch);
                    ELSE
                        backonechar(hin);
                    END;
                END;
            END;
        | intoken:
            IF Belongs(stokensetfull,ch) THEN
                Str.Append(token,ch);
            ELSE
                ok:= procToken(stackndx,doinsert,  DEBUG,currline,token);
                IF NOT(ok) THEN EXIT;END;
                IF doinsert THEN FIO.WrStr(hout,sinsertMEhere); END;
                FIO.WrStr(hout,token);
                state:=waiting;
                backonechar(hin);
            END;
        | instring:
            FIO.WrChar(hout,ch);
            IF ch = stringdelim THEN state:=waiting; END;
        | inremark:
                FIO.WrStr(hout,ch);
                CASE ch OF
                | "(":
                     grabnextchar(ch,hin);
                     IF ch = "*" THEN
                         FIO.WrChar(hout,ch);
                         INC(remdepth);
                     ELSE
                         backonechar(hin);
                     END;
                | "*":
                     grabnextchar(ch,hin);
                     IF ch = ")" THEN
                         FIO.WrChar(hout,ch);
                         IF remdepth # 0 THEN DEC(remdepth);END;
                         IF remdepth = 0 THEN state:=waiting;END;
                     ELSE
                         backonechar(hin);
                     END;
                END;
        END;
    END;
    CASE state OF
    | intoken:
        ok:=procToken(stackndx,doinsert,  DEBUG,currline,token);
        IF doinsert THEN FIO.WrStr(hout,sinsertMEhere); END;
        FIO.WrStr(hout,token);
    END;
    fileClose(useLFN,hin);

    IF tofile THEN
        fileClose(useLFN,hout);
        IF fileExists(useLFN,tmpcanonical) THEN
            setReadWrite(tmpcanonical);
            fileErase(useLFN,tmpcanonical);
        END;
        fileRename(useLFN,src,tmpcanonical);        (* .MOD becomes .tmp *)
        fileRename(useLFN,target,src);              (* .org becomes .MOD *)
        fileRename(useLFN,tmpcanonical,target);     (* .tmp becomes .org *)

        WrLn; (* was not added at program start *)
        WrStr("+++ Created  : ");WrStr(src);WrLn;
        WrStr("::: Original : ");WrStr(target);WrLn;

    END;

    RETURN ok;
END procSrc;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    minparm = 1;
    maxparm = 1;
VAR
    parm : ARRAY[minparm..maxparm] OF pathtype;
    lastparm,parmcount,i,opt : CARDINAL;
    S,R,src:pathtype;
    dosbak,tofile,useLFN,DEBUG : BOOLEAN;
BEGIN
    Lib.DisableBreakCheck();
    FIO.IOcheck := FALSE;

    (* WrLn; *)

    tofile      := TRUE;
    dosbak      := TRUE;
    useLFN      := TRUE;
    DEBUG       := FALSE;

    lastparm    := minparm-1;
    parmcount := Lib.ParamCount();
    IF parmcount=0 THEN abort(errHelp,"");END;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   "DEBUG"+delim+
                                   "!"+delim+"INI"+delim+
                                   "!!"+delim+"!O"+delim+
                                   "@"+delim+
                                   "B"+delim+"LFNBAK"+delim+
                                   "X"+delim+"LFN"
                               );
            CASE opt OF
            | 1,2,3 : abort(errHelp,"");
            | 4     : DEBUG:=TRUE;
            | 5,6   : genINI(FALSE, FALSE,ProgEXEname+extINI);
                      abort(errNone,"");
            | 7,8   : genINI(FALSE, TRUE ,ProgEXEname+extINI);
                      abort(errNone,"");
            | 9     : tofile := FALSE;
            | 10,11 : dosbak := FALSE;
            | 12,13 : useLFN := FALSE;
            ELSE
                abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            INC(lastparm);
            IF lastparm > maxparm THEN abort(errTooManyParms,S); END;
            Str.Copy(parm[lastparm],S); (* keep case *)
        END;
    END;

    useLFN := ( useLFN AND fileSupportLFN() );
    IF NOT(dosbak) THEN dosbak:=NOT(useLFN); END;

    CASE lastparm OF
    | minparm-1 : abort(errParm,"<file>");
    | minparm:    Str.Copy(src,parm[minparm]);
    ELSE
        ; (* handled supra *)
    END;

    IF same(src,dot) THEN Str.Copy(src,star+extMOD); END;
    IF same(src,star) THEN Str.Copy(src,star+extMOD); END;
    IF Str.Match(src,"*"+antislash) THEN Str.Append(src,star+extMOD); END;
    IF Str.RCharPos(src,dot)=MAX(CARDINAL) THEN Str.Append(src,extMOD);END;

    IF chkJoker(src) THEN abort(errJoker,src);END;

    IF Str.Match(src,"*"+extBAK) THEN abort(errBackup,src);END;

    IF fileExists(useLFN,src)=FALSE THEN abort(errNotFound,src);END;

    IF initSpecial(DEBUG,useLFN)=FALSE THEN abort(errIniProblem,ProgEXEname+extINI);END;

    IF procSrc(DEBUG,useLFN,tofile,dosbak,src) = FALSE THEN abort(errStack,"");END;

    abort(errNone,"");
END ISOCASE.


