Option Explicit
DefInt A-Z

Function bitspix% (cpic As Control)
Dim bpp%
Select Case cpic.ImageColors ' this is a long
Case 2: bpp% = 1
Case 16: bpp% = 4
Case 256: bpp% = 8
Case 65536: bpp% = 16
Case 16777216: bpp% = 24
Case Else
    bpp% = 32 ' assumption !
End Select
bitspix% = bpp%
End Function

Sub doSplash (ByVal showSplash%, ByVal starting%)
If showSplash% = False Then Exit Sub
Select Case starting%
Case True
    frmSplash.Hide
    frmSplash.Caption = ""' force no title bar
    frmSplash.lblSplash = SplashTitle$
    frmSplash.lblInfo = SplashInfo$
    centerform frmSplash ' no MODAL here !
    frmSplash.Show ' first show
    frmSplash.Refresh ' then force repaint
Case False
    frmSplash.Hide
    Unload frmSplash
End Select
End Sub

Sub getNewPicAndIndex (cpic As Control, clist As Control, ByVal filecount%, gLastIndex%, filetoshow$)
Dim localLastIndex%
Dim lowerbound%, upperbound%, n%
Dim h%, w%, newW%, newH% ' picHeight%, picWidth%
Dim s$, rc%, picmodified%, ErrCode%, letsgo%
Dim currChangeGamma%, currGamma%
Dim upperSizePercentage%, lowerSizePercentage%
Dim flagForceResize%
Dim targetWi%, targetHe%
Dim upperWi%, upperHe%
Dim lowerWi%, lowerHe%
Dim maxW%, maxH%, minW%, minH%
Dim counter%, counterlimit%, alcatraz%
Dim k&

picmodified% = 0 ' for effects

'screenratio! = XscreenInPixels% / YscreenInPixels%' ex : 640/480=1.33

' compute coefficients for lower and upper sizes, ensuring lower is at least 0,2 (i.e. 20 here)
upperSizePercentage% = gTargetSize% + gAddedMargin%
lowerSizePercentage% = gTargetSize% - gSubstractedMargin%
If lowerSizePercentage% < MINTARGETSIZE% Then lowerSizePercentage% = MINTARGETSIZE%

' damn types ! to avoid overflow, we need at least one long
k& = XscreenInPixels%: targetWi% = (k& * gTargetSize%) \ 100
k& = YscreenInPixels%: targetHe% = (k& * gTargetSize%) \ 100
k& = XscreenInPixels%: upperWi% = (k& * upperSizePercentage%) \ 100
k& = YscreenInPixels%: upperHe% = (k& * upperSizePercentage%) \ 100
k& = XscreenInPixels%: lowerWi% = (k& * lowerSizePercentage%) \ 100
k& = YscreenInPixels%: lowerHe% = (k& * lowerSizePercentage%) \ 100

' avoid repetition of the same picture
' when picking at random and skipping larger pictures
' using too many globerks...

' argh, problem when only two files : always the same selected... but who cares ?

' add a safety against infinite loop
counter% = 0
counterlimit% = filecount% * 4' safety
alcatraz% = False

waiting True ' (*
localLastIndex% = gLastIndex%
Do
    'should we DoEvents here just in case ?
    Select Case gPickAtRandom%
    Case True ' next picture will be selected
        ' Int((upperbound - lowerbound + 1) * Rnd + lowerbound)
        lowerbound% = ndxFIRSTPIC%' 0
        upperbound% = filecount% - 1 ' filecount is 1 or more
        n% = localLastIndex%
        Do Until n% <> localLastIndex%
            localLastIndex% = Int((upperbound% - lowerbound% + 1) * Rnd + lowerbound%)
        Loop
    Case False
        localLastIndex% = localLastIndex% + 1
        If localLastIndex% >= filecount% Then localLastIndex% = ndxFIRSTPIC%
    End Select
    filetoshow$ = gDirectory$ + clist.List(localLastIndex%)

    'postpone autoreduce AFTER resizing in order to avoid REALLY ugly effect
    'well, it's useless : we get the same ugly result whatever the processing order

    cpic.Picture = filetoshow$
    ErrCode% = cpic.ErrCode
    If ErrCode% > IM_ERRORNONE% Then
        s$ = fmtint$(ErrCode%)
        rc% = writeIni%(ini$, sSection$, eLastErrorCode$, s$)
        rc% = writeIni%(ini$, sSection$, eLastUnsupported$, filetoshow$)
        letsgo% = False
    Else
        h% = cpic.ImageHeight
        w% = cpic.ImageWidth
        Call bestfit(newW%, newH%, w%, h%, targetWi%, targetHe%)
        ' now we have our target dimensions, check for allowable (no-resize) range
        Call bestfit(maxW%, maxH%, w%, h%, upperWi%, upperHe%)
        Call bestfit(minW%, minH%, w%, h%, lowerWi%, lowerHe%)
        flagForceResize% = isOutOfRange%(minW%, minH%, w%, h%, maxW%, maxH%)
        If flagForceResize% = True Then
            ' resize needed : ignore or resize ?
            If gSkipOutOfRange% Then
                letsgo% = False
            Else
                letsgo% = True
            End If
        Else
            ' no resize needed, we're within tolerance margins
            letsgo% = True
        End If
    End If
    ' try and avoid infinite loop
    counter% = counter% + 1
    If counter% > counterlimit% Then alcatraz% = True: letsgo% = True
    If letsgo% = True Then Exit Do
Loop
waiting False ' *)

If alcatraz% = True Then
    ' argh !
    rc% = writeIni%(ini$, sSection$, eLastUnsupported$, "nothing : (ALMOST) INFINITE LOOP :-(")
    Exit Sub
End If

s$ = fmtint$(localLastIndex%)
rc% = writeIni%(ini$, sSection$, eLastIndex$, s$)
s$ = intToStr$(cpic.ImageWidth) + "x" + intToStr$(cpic.ImageHeight)
s$ = s$ + "x" + intToStr$(bitspix(cpic))
rc% = writeIni%(ini$, sSection$, eLastPicInfos$, s$)
rc% = writeIni%(ini$, sSection$, eLastFileName$, filetoshow$)

gLastIndex% = localLastIndex%

If flagForceResize% = True Then
    '///FIXME
    'cpic.ResizeWidth = newW%
    'cpic.ResizeHeight = newH%
    'cpic.Resize = True
End If

retrieveGlobalGammaForExtension filetoshow$, currChangeGamma%, currGamma%

If currChangeGamma% Then
    'cpic.Gamma = (currGamma% / 100!)
    cpic.Brightness = currGamma%
    cpic.Refresh
    picmodified% = picmodified% + 1
End If

If gColorReductionCode% <> IM_NOREDUCTION Then
    cpic.DitherMethod = gDitherCode%
    cpic.ReduceTo = gColorReductionCode%
    cpic.Refresh
    picmodified% = picmodified% + 1
End If
' we could use picmodified% to do only one refresh but safety first... though refresh seems useless
End Sub

Function getVar$ (ByVal envVar$)
Dim s$
Dim ok%
s$ = Environ$(envVar$)
If s$ <> "" Then
    If Right$(s$, 1) <> "\" Then s$ = s$ + "\" ' trailing \ needed
    ' should be useless but just in case
    ok% = 0
    If Mid$(s$, 2, 1) <> ":" Then ok% = ok% + 1' need unit
    If Mid$(s$, 3, 1) <> "\" Then ok% = ok% + 1' need from root
    If InStr(s$, ".") > 0 Then ok% = ok% + 1' no extension allowed !
    If ok% > 0 Then s$ = ""
End If
getVar$ = s$
End Function

Sub initImageMan (cpic As Control)
cpic.UseDDB = gUseDDB%
cpic.AutoScale = IM_AUTOSCALENONE
cpic.DitherMethod = IM_DITHERBAYER
cpic.ScaleMethod = IM_ANTIALIAS
cpic.BorderStyle = NONE
cpic.Scrollbars = False
cpic.AutoDraw = True ' seems necessary (else, problems when resizing or copying from clipboard) useful for operations not involving reload
cpic.Picture = ""
End Sub

Function isOutOfRange% (ByVal minW%, ByVal minH%, ByVal w%, ByVal h%, ByVal maxW%, ByVal maxH%)
Dim rc%
If w% > h% Then
    If (w% < minW%) Or (w% > maxW%) Then
        rc% = True
    Else
        rc% = False
    End If
Else
    If (h% < minH%) Or (h% > maxH%) Then
        rc% = True
    Else
        rc% = False
    End If
End If
isOutOfRange% = rc%
End Function

Sub processNewPic (cpic As Control, ByVal filetoshow$)
Dim rc%
Dim s$

cpic.Overwrite = IM_OVERWRITEYES
waiting True ' (*
s$ = createBMPpath$(tmpBMP$, exedir$)
cpic.SaveAs = s$
waiting False ' *)

rc% = cpic.ErrCode
If rc% > IM_ERRORNONE Then
    ' the microsoft way : say nothing about possible problem... ;-)
Else
    ChangeWallPaper s$
    If gKillTmpBMP% Then Kill s$
    If gWriteBMPpath% Then
        s$ = UCase$(filetoshow$)
        If InStr(s$, BMPext$) > 0 Then
            rc% = WriteWinIni%(sSectionDesktop$, eWallpaper$, s$)
        End If
    End If
End If
End Sub

Sub retrieveGlobalGammaForExtension (ByVal s$, currflag%, currval%)
Dim p%, flag%
p% = InStr(s$, ".")
s$ = UCase$(Mid$(s$, p%))
Select Case s$
Case GIFext$: currflag% = gChangeGammaGIF: currval% = gGammaGIF%
Case JPGext$: currflag% = gChangeGammaJPG: currval% = gGammaJPG%
Case PNGext$: currflag% = gChangeGammaPNG: currval% = gGammaPNG%
Case BMPext$: currflag% = gChangeGammaBMP: currval% = gGammaBMP%
Case PCXext$: currflag% = gChangeGammaPCx: currval% = gGammaPCx%
Case Else ' impossible ! ;-)
            currflag% = gChangeGammaGIF: currval% = gGammaGIF%
End Select
End Sub

Sub retrieveNames (clist As Control, ByVal picdir$, filecount%)
Dim s$
Dim n%
Dim attr%

' FIXME : we should use a filelist here, or use ListBoxLimitKB and ListBoxFix

clist.Clear

Select Case gIncludeHidden%
Case True
    attr% = MatchAllFilesWithHidden%
Case False
    attr% = MatchAllFilesWithoutHidden%
End Select

s$ = Dir$(picdir$ + STARdotSTAR$, attr%)
Do Until s$ = ""
    s$ = UCase$(s$)
    n% = 0' kludge for no GOTO allowed to skip ! :-(
    If gIncludeGIF% And (InStr(s$, GIFext$) > 0) Then n% = n% + 1
    If gIncludeJPG% And (InStr(s$, JPGext$) > 0) Then n% = n% + 1
    If gIncludeBMP% And (InStr(s$, BMPext$) > 0) Then n% = n% + 1
    If gIncludePCX% And (InStr(s$, PCXext$) > 0) Then n% = n% + 1
    If gIncludePNG% And (InStr(s$, PNGext$) > 0) Then n% = n% + 1
    If n% > 0 Then clist.AddItem s$ ' remember the dreaded 64Kb limit !
    s$ = Dir$
Loop
filecount% = clist.ListCount
End Sub

Sub bestfit (newW%, newH%, ByVal w%, ByVal h%, ByVal targetWi%, ByVal targetHe%)
Dim picratio!

' yes, we could use an intermediaty long type to avoid overflow with just integer computations
picratio! = w% / h%' ex : 800/200=4

If w% > h% Then
    newW% = targetWi%
    newH% = newW% / picratio!
    If newH% > targetHe% Then
        newH% = targetHe%
        newW% = newH% * picratio!
    End If
Else
    newH% = targetHe%
    newW% = newH% * picratio!
    If newW% > targetWi% Then
        newW% = targetWi%
        newH% = newW% / picratio!
    End If
End If
End Sub

Function createBMPpath$ (ByVal tmpBMP$, ByVal defaultPath$)
Dim s$
Dim n%
s$ = getVar$(envTMP$)' try TMP
If s$ = "" Then s$ = getVar$(envTEMP$)' try TEMP
If s$ = "" Then s$ = defaultPath$' last resort (already normalized)
s$ = s$ + tmpBMP$
If fileexists(s$) Then ' should not occur but who knows ?
    n% = GetAttr(s$)
    If (n% And ATTR_READONLY) <> 0 Then ' ~del_me~ exists and is read only !
        SetAttr s$, ATTR_NORMAL
    End If
End If
createBMPpath$ = s$
End Function

Sub doNewWallMain (ByVal showSplash%)
Dim cpic As Control
Dim clist As Control
Dim filecount%
Dim filetoshow$

Set f = frmNewWall
Set cpic = f!img ' accusoft picture

''' s$ = readWinIni$(sectionDesktop$, entryWallpaper$)
''' If InStr(UCase$(s$), BMPext$) > 0 Then quit

doSplash showSplash%, True

retrieveParameters

' Sorted property cannot be set at runtime !
If gSortedFileNames% = False Then
    Set clist = f!lstUnsorted
Else
    Set clist = f!lstSorted
End If

f.Visible = False
f.ScaleMode = PIXELS ' just in case
' f.AutoRedraw = True
' f.ControlBox = False
' f.MaxButton = False
' f.MinButton = False
' f.BorderStyle = NONE
' f.Caption = ""
' f.WindowState = NORMAL
' centerform f

' init a few things
' vb imageman specific -- should already be set at design time but who knows ?
initImageMan cpic

Randomize
retrieveNames clist, gDirectory$, filecount%

If filecount% = 0 Then
    doSplash showSplash%, False
    quit
End If
If gLastIndex% >= filecount% Then gLastIndex% = ndxFIRSTPIC% ' prevent problem !
' too many globerks...
getNewPicAndIndex cpic, clist, filecount%, gLastIndex%, filetoshow$
' again, too many globerks...
processNewPic cpic, filetoshow$

doSplash showSplash%, False
quit
End Sub

