(* ---------------------------------------------------------------
Title         Q&D PCX to Canon BJ200
Author        PhG
Overview
Usage         see help
Notes         very, very, very quick & dirty... :-(
              minimal error messages and checking, etc.
              ugly code (too many globerks) created
              project requires a pragma to set stack size at 24000
Bugs
Wish List

--------------------------------------------------------------- *)

MODULE PCX2BJ;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT BiosIO;
IMPORT SYSTEM;

FROM IO IMPORT WrStr,WrLn,WrCard,WrLngCard,KeyPressed, WrShtHex,WrLngInt;

FROM QD_ASCII IMPORT dash, slash, nullchar, tabchar, cr, lf, nl, bs,
space, dot, deg, degree, doublequote, quote, colon, percent, vbar,
blank, equal, dquote, charnull, singlequote, antislash, dollar,
star, backslash, coma, question, underscore, underbar, tabul, hbar,
comma, semicolon, diese, pound, openbracket, closebracket, tilde, exclam,
stardotstar, dotdot, escCh, escSet, letters, digits,
lettersUpp, lettersLow, openbrace, closebrace, ampersand;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite, setReadOnly,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs, UpperCaseAlt, LowerCaseAlt,
completedInit, completedShow, completedSHOW, completedEnd, completed,
removeDups, isValidHDunit, removePhantoms, removeFloppies,
getCDROMunits, getCDROMletters, removeCDROMs, getAllHDunits,
getAllLegalUnits, metaproc, getCli, argc, argv,
metaproc, UpperCaseFR, LowerCaseFR, ASCIIonly;

(* ------------------------------------------------------------ *)

CONST
    ProgEXEname   = "PCX2BJ";
    ProgTitle     = "Q&D Impression d'un fichier PCX monochrome";
    ProgVersion   = "v1.0d";
    ProgCopyright = "par PhG";
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;
CONST
    extPCX        = ".PCX";
CONST
    errNone              = 0;
    errHelp              = 1;
    errOption            = 2;
    errTooManyParameters = 3;
    errBadPins           = 4;
    errBadDPI            = 5;
    errBadLM             = 6;
    errBadTM             = 7;
    errNeedFile          = 8;
    errNeedDevice        = 9;
    errBadCombo          = 10;
    errBadName           = 11;
    errNotFound          = 12;
    errNotPCX            = 13;
    errNotMonoPCX        = 14;
    errNonsense          = 15;
    errUnsupportedDevice = 16;
    errCancelled         = 17;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
00000000011111111112222222222333333333344444444445555555555666666666677777777778
1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    msgHelp =
"Titre   : "+Banner+nl+
nl+
"Syntaxe : "+ProgEXEname+" <fichier["+extPCX+"]> <sortie> [option]..."+nl+
nl+
"Utilit : imprimer un fichier PCX monochrome sur une Canon BJ200 en mode LQ"+nl+
nl+
"Options : /a:#  nombre d'aiguilles (8 ou 24 -- 24 par dfault )"+nl+
"          /d:#  densit (60, 80, 90, 120, 180, 240 ou 360 -- 180 par dfaut)"+nl+
"          /x2   doublement des pixels en X"+nl+
"          /y2   doublement des pixels en Y"+nl+
"          /xy2  doublement des pixels en X et en Y"+nl+
"          /ch   centrage horizontal"+nl+
"          /cv   centrage vertical"+nl+
"          /c    centrage vertical et horizontal"+nl+
"          /lm:# marge de gauche en millimtres (4 par dfaut)"+nl+
"          /tm:# marge du haut en millimtres (13 par dfaut)"+nl+
"          /i    inversion des pixels monochromes"+nl+
"          /n    aucune demande de confirmation avant l'impression"+nl+
(* "          /e    jection de la page puis attente de la suivante" *)
"          /e    jection de la page aprs impression"+nl+
"          /j    jection de la page avant impression"+nl+
(* "          /v    indicateur de progression"+nl+ *)
"          /p    impression (sinon, simple analyse prliminaire de l'image)"+nl+
nl+
"Note 1  : Les modes lgaux sont 8*60, 8*120, 8*240, 8*80, 8*90, 24*60, 24*120,"+nl+
"          24*90, 24*180 et 24*360, les seuls modes utiles sont 8*60 et 24*180."+nl+
"Note 2  : La zone non-imprimable est de 4 mm  gauche, de 13 mm en haut."+nl+
"Note 3  : En 640x480 et 800x600, les paramtres de l'exemple sont recommands."+nl+
"Note 4  : Seule l'imprimante LPT1 est officiellement prise en compte. ;-)"+nl+
nl+
"Exemple : "+ProgEXEname+" phg.pcx lpt1 /xy2 /c /a:24 /d:180"+nl;

VAR
    S : str256;
BEGIN
    CASE e OF
    | errHelp :
        WrStr(msgHelp);
    | errOption:
        Str.Concat(S,"L'option ",einfo);Str.Append(S," est inconnue !");
    | errTooManyParameters:
        Str.Concat(S,"Le paramtre ",einfo);Str.Append(S," est superflu !");
    | errBadPins :
        Str.Concat(S,"Le nombre d'aiguilles ",einfo);Str.Append(S," est illgal !");
    | errBadDPI  :
        Str.Concat(S,"La densit ",einfo);Str.Append(S," est illgale !");
    | errBadLM   :
        Str.Concat(S,"La marge de gauche ",einfo);Str.Append(S," est illgale !");
    | errBadTM   :
        Str.Concat(S,"La marge du haut ",einfo);Str.Append(S," est illgale !");
    | errNeedFile:
        S := "Le <fichier> PCX est indispensable !";
    | errNeedDevice:
        S := "Le fichier ou le priphrique de <sortie> est indispensable !";
    | errBadCombo:
	    S := "La combinaison nombre d'aiguilles et densit est illgale !";
    | errBadName:
        Str.Concat(S,"Le nom de fichier ",einfo);Str.Append(S," est illgal !");
    | errNotFound:
        Str.Concat(S,"Le fichier ",einfo);Str.Append(S," est introuvable !");
    | errNotPCX:
        Str.Concat(S,"Le fichier ",einfo);Str.Append(S," n'est pas au format PCX !");
    | errNotMonoPCX:
        Str.Concat(S,"L'image ",einfo);Str.Append(S," n'est pas monochrome !");
    | errNonsense:
        S := "Les <fichier> image et fichier de <sortie> doivent tre diffrents !";
    | errUnsupportedDevice:
        Str.Concat(S,"Le priphrique de <sortie> ",einfo);Str.Append(S," n'est pas encore pris en compte !");
    | errCancelled:
        S := "Impression annule par l'utilisateur !";
    ELSE
        S := "Comment de telles choses sont-elles possibles ?";
    END;
    IF ( (e <> errNone) AND (e <> errHelp) ) THEN
        WrStr(ProgEXEname+" : ");
        WrStr(S);
        WrLn;
    END;
    Lib.SetReturnCode(SHORTCARD(e));
    HALT;
END abort;

(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
VAR
    ioBufferIn,ioBufferOut : ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
VAR
    hin,hout : FIO.File; (* globerk *)

(* ------------------------------------------------------------ *)

PROCEDURE getCard (S:ARRAY OF CHAR; VAR v:CARDINAL ):BOOLEAN;
VAR
    lc:LONGCARD;
BEGIN
    IF GetLongCard(S,lc)=FALSE THEN RETURN FALSE; END;
    IF lc > MAX(CARDINAL) THEN RETURN FALSE; END;
    v:=CARDINAL(lc);
    RETURN TRUE;
END getCard;

PROCEDURE handleExt (ext:ARRAY OF CHAR;VAR R:ARRAY OF CHAR);
BEGIN
    IF Str.CharPos(R,dot)=MAX(CARDINAL) THEN
        Str.Append(R,ext);
    END;
END handleExt;

PROCEDURE wrval (S:ARRAY OF CHAR;widigits,v:CARDINAL   );
BEGIN
    WrStr(S);WrStr(" : ");WrCard(v,widigits);WrLn;
END wrval;

PROCEDURE wrVAL (S:ARRAY OF CHAR;widigits:CARDINAL; v:LONGCARD);
BEGIN
    WrStr(S);WrStr(" : ");WrLngCard(v,widigits);WrLn;
END wrVAL;

PROCEDURE dbg (DEBUG:BOOLEAN; v:LONGINT;S:ARRAY OF CHAR);
BEGIN
    IF DEBUG THEN WrStr(S);WrStr(" : ");WrLngInt(v,9);WrLn; END;
END dbg;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    Bitfields for printer status:
    7	not busy
    6	acknowledge
    5	out of paper
    4	selected
    3	I/O error
    2   unused
    1	unused
    0	timeout
*)

PROCEDURE PrinterWriteCharacter (printer:CARDINAL;c:BYTE):BYTE ;
VAR
    R:SYSTEM.Registers;
BEGIN
    R.AL := c;
    R.AH := 00H;
    R.DX := printer;
    Lib.Intr(R, 17H);
    RETURN R.AH;
END PrinterWriteCharacter;

PROCEDURE PrinterGetStatus (printer:CARDINAL ):BYTE;
VAR
    R : SYSTEM.Registers;
BEGIN
    R.AH := 02H;
    R.DX := printer;
    Lib.Intr(R, 17H);
    RETURN R.AH;
END PrinterGetStatus;

PROCEDURE PrinterInitializePort (printer:CARDINAL):BYTE ;
VAR
    R : SYSTEM.Registers;
BEGIN
    R.AH := 01H;
    R.DX := printer;
    Lib.Intr(R, 17H);
    RETURN R.AH; (* better check isPrinterReady() too ! *)
END PrinterInitializePort;

PROCEDURE isPrinterReady (printer:CARDINAL  ):BOOLEAN ;
BEGIN
    RETURN ( (PrinterGetStatus(printer) AND BYTE(080H)) = BYTE(080H) );
END isPrinterReady;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    PCXrgbType = RECORD
        red,green,blue:BYTE;
    END;

    (* (almost) useless fields are indented again *)

    PCXheaderType = RECORD
     manufacturer    : BYTE; (* constant 10=$0A=ZSoft *)
     version         : BYTE; (* constant 5=PC Paintbrush v3.0+ *)
     encoding        : BYTE; (* constant 1=RLE *)
    bitsPerPixel     : BYTE; (* 1, 2, 4 or 8, i.e. mono, 4, 16 OR 256 colors  *)
	                  (* window, i.e. image dimensions : xmin, ymin, xmax, ymax *)
    leftmargin       : WORD;
    uppermargin      : WORD;
    rightmargin      : WORD; (* do not use xmax-xmin ! *)
    lowermargin      : WORD;
     hDPIresolution  : WORD; (* put 300 for instance *)
     vDPIresolution  : WORD; (* idem *)
    colormap         : ARRAY[0..15] OF PCXrgbType;
     reserved1       : BYTE; (* must be 0 *)
    NCP              : BYTE; (* number of color planes, 1 or 4 *)
    NBS              : WORD; (* number of bytes per scanline, always even *)
                            (* from here, fields may contain rubbish *)
     paletteInfo     : WORD; (* 1=color or BW, 2=grayscale *)
     hscreensize     : WORD;
     vscreensize     : WORD;
     reserved2       : ARRAY[0..53] OF BYTE; (* must be 0 *)
    END;

CONST
    PCXpalID     = BYTE(0CH); (* 12=$0C *)
    PCXpalIDsize = 1;
    PCXpalsize   = 3 * 256;

PROCEDURE chkPCX (S:ARRAY OF CHAR;VAR h:PCXheaderType):BOOLEAN ;
CONST
    kTen = BYTE(0AH);
    kOne = BYTE(1);
    kZero= BYTE(0);
VAR
    n : CARDINAL;
BEGIN
    hin:=FIO.OpenRead(S);
    FIO.AssignBuffer(hin,ioBufferIn);
    n:=FIO.RdBin(hin,h,SIZE(PCXheaderType));
    FIO.Close(hin);
    IF n < SIZE(PCXheaderType) THEN RETURN FALSE; END;
    IF h.manufacturer # kTen THEN RETURN FALSE; END;
    IF h.encoding # kOne THEN RETURN FALSE;END;
    IF h.reserved1 # kZero THEN RETURN FALSE; END;
    (*
    FOR n:=0 TO 53 DO
        IF h.reserved2[n] # kZero THEN RETURN FALSE; END;
    END;
    *)
    RETURN TRUE;
END chkPCX;

PROCEDURE chkMonoPCX (h:PCXheaderType):BOOLEAN;
CONST
    kOne   = BYTE(1);
    kEight = BYTE(8);
    kFour  = BYTE(4);
    wOne   = WORD(1);
BEGIN
    IF h.bitsPerPixel > kEight THEN RETURN FALSE; END;
    IF h.NCP > kFour THEN RETURN FALSE; END;
    IF h.paletteInfo # wOne THEN RETURN FALSE; END;
    RETURN ( (h.NCP=kOne) AND (h.bitsPerPixel=kOne) ); (* colors=2 *)
END chkMonoPCX;

PROCEDURE getPCXpictureSize(h:PCXheaderType;VAR picwidth,picheight:CARDINAL);
BEGIN
    picwidth := CARDINAL(h.rightmargin-h.leftmargin)+1;
    picheight:= CARDINAL(h.lowermargin-h.uppermargin)+1;
END getPCXpictureSize;

(* ------------------------------------------------------------ *)

TYPE
    masktype = ARRAY [0..7] OF CARDINAL;
CONST
    bitmask = masktype(080H,040H,020H,010H,008H,004H,002H,001H);
CONST
    PCXCOUNTFLAG = BYTE(0C0H); (* 11000000 *)
    PCXCOUNTMASK = BYTE(03FH); (* 00111111 *)
    PCXMAXCOUNT  = 03FH;
CONST
    maxPlanes = 4;
    maxpixels = 2560;
    firstcode = 0;
    maxcode   = maxpixels * maxPlanes-1;
TYPE
    PCXdecodebuffertype = ARRAY [firstcode..maxcode] OF BYTE;
VAR
    img : PCXdecodebuffertype;

PROCEDURE decodeScanline (lastcode:CARDINAL);
VAR
    databyte:BYTE;
    p,count,n : CARDINAL;
BEGIN
    p := firstcode;
    WHILE p <= lastcode DO
        n:=FIO.RdBin(hin,databyte,1);
        IF (databyte AND PCXCOUNTFLAG) = PCXCOUNTFLAG THEN
            count := CARDINAL(databyte AND PCXCOUNTMASK);
            n := FIO.RdBin(hin,databyte,1);
            FOR n := 1 TO count DO
                img[p]:=databyte;
                INC(p);
            END;
        ELSE
            img[p]:=databyte;
            INC(p);
        END;
    END;
END decodeScanline;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
   non printable margins for Canon BJ200 :
   left :  3,4 mm
   top  : 12,7 mm
*)

CONST
    lmBJ200     = 4;    (*  3,4 in fact *)
    tmBJ200     = 13;   (* 12,7 in fact *)
    minlm       = 0;
    maxlm       = 210; (* mm *)
    mintm       = 0;
    maxtm       = 297;
    defaultpins = 24;
    defaultdpi  = 180;
    defaultxmult= 1;
    defaultymult= 1;
TYPE
    pagesizeType = (A4,letterUS);

PROCEDURE getPageSize (VAR wi,he:CARDINAL ;pagesize:pagesizeType);
BEGIN
    CASE pagesize OF
    | A4:         wi := 210; he:=297; (* mm *)
    | letterUS:   wi := 210; he:=297; (* wrong, but never used anyway ! *)
    END;
END getPageSize;

PROCEDURE chkpins (S:ARRAY OF CHAR;VAR v:CARDINAL):BOOLEAN ;
BEGIN
    IF getCard(S,v)=FALSE THEN RETURN FALSE; END;
    CASE v OF
    | 8,24: RETURN TRUE;
    ELSE    RETURN FALSE;
    END;
END chkpins;

PROCEDURE chkdpi (S:ARRAY OF CHAR;VAR v:CARDINAL):BOOLEAN ;
BEGIN
    IF getCard(S,v)=FALSE THEN RETURN FALSE; END;
    CASE v OF
    | 60,80,90,120,180,240,360: RETURN TRUE;
    ELSE    RETURN FALSE;
    END;
END chkdpi;

PROCEDURE chklm (S:ARRAY OF CHAR;VAR v:CARDINAL ):BOOLEAN ;
BEGIN
    IF getCard(S,v)=FALSE THEN RETURN FALSE; END;
    RETURN ( (v>=lmBJ200) AND (v<=maxlm) );
END chklm;

PROCEDURE chktm (S:ARRAY OF CHAR;VAR v:CARDINAL ):BOOLEAN ;
BEGIN
    IF getCard(S,v)=FALSE THEN RETURN FALSE; END;
    RETURN ( (v>=tmBJ200) AND (v<=maxtm) );
END chktm;

CONST
    dpi60pins8 		= 0;
    dpi120pins8 	= 1;
    dpi120pins8alt 	= 2;
    dpi240pins8 	= 3;
    dpi80pins8 		= 4;
    dpi90pins8 		= 6;
    dpi60pins24		= 32;
    dpi120pins24	= 33;
    dpi90pins24		= 38;
    dpi180pins24	= 39;
    dpi360pins24	= 40;

PROCEDURE chkPrintMode (pins,dpi:CARDINAL;VAR printMode:CARDINAL):BOOLEAN ;
VAR
    rc:BOOLEAN;
BEGIN
    rc:=TRUE;
    CASE pins OF
    | 8:
        CASE dpi OF
        | 60  : printMode := dpi60pins8;
        | 120 : printMode := dpi120pins8;
        | 240 : printMode := dpi240pins8;
        | 80  : printMode := dpi80pins8;
        | 90  : printMode := dpi90pins8;
        ELSE    rc:=FALSE;
        END;
    | 24:
        CASE dpi OF
        | 60  : printMode := dpi60pins24;
        | 120 : printMode := dpi120pins24;
        | 90  : printMode := dpi90pins24;
        | 180 : printMode := dpi180pins24;
        | 360 : printMode := dpi360pins24;
        ELSE    rc:=FALSE;
        END;
    ELSE
        rc:=FALSE;
    END;
    RETURN rc;
END chkPrintMode;

CONST
    devicelist  = "LPT1:,COM1:,LPT2:,COM2:,LPT3:,COM3:,LPT4:,COM4:,PRN:,AUX:,NUL:";
    printerlist = "LPT1,COM1,LPT2,COM2,LPT3,COM3,LPT4,COM4,PRN,AUX,NUL";

PROCEDURE fixSpecialDevice (VAR S : ARRAY OF CHAR);
BEGIN
    CASE getStrIndex(comma,S,devicelist) OF
    | 1..11 : Str.Subst(S,colon,"");
    END;
END fixSpecialDevice;

(* for now, only LPT1 is officially supported *)

PROCEDURE chkSupportedDevice (S:ARRAY OF CHAR):BOOLEAN ;
BEGIN
    (*
    CASE getStrIndex(comma,S,printerlist) OF
    | 1     : RETURN TRUE;
    | 2..11 : RETURN FALSE;
    ELSE      RETURN FALSE;
    END;
    *)
    RETURN TRUE;
END chkSupportedDevice;

PROCEDURE isPrinterDevice (S:ARRAY OF CHAR  ):BOOLEAN ;
BEGIN
    CASE getStrIndex(comma,S,printerlist) OF
    | 1..11 : RETURN TRUE;
    ELSE     RETURN FALSE;
    END;
END isPrinterDevice;

PROCEDURE getPrinterNumber (S:ARRAY OF CHAR ):CARDINAL ;
VAR
    n : CARDINAL;
BEGIN
    CASE getStrIndex(comma,S,printerlist) OF
    | 1,2     : n:=0;
    | 3,4     : n:=1;
    | 5,6     : n:=2; (* hem... *)
    | 7,8     : n:=3; (* hem... *)
    | 9,10,11 : n:=0; (* hem... *)
    ELSE        n:=0; (* argh... *)
    END;
    RETURN n;
END getPrinterNumber;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE enlarge (org:BYTE; VAR b1,b2:BYTE  );
TYPE
    masktype = ARRAY [0..7] OF CARDINAL;
CONST
    bitmask = masktype(00001H,
                       00002H,
                       00004H,
                       00008H,
                       00010H,
                       00020H,
                       00040H,
                       00080H);
    newmask = masktype(00003H,
                       0000CH,
                       00030H,
                       000C0H,
                       00300H,
                       00C00H,
                       03000H,
                       0C000H);
VAR
    i,v,mask,w: CARDINAL;
BEGIN
    v :=CARDINAL(org);
    w :=0000H;
    FOR i := 0 TO 7 DO
        mask := bitmask[i];
        IF (v AND mask)=mask THEN w := (w OR newmask[i]); END;
    END;
    b2 := BYTE(  w AND 000FFH      );
    b1 := BYTE( (w AND 0FF00H) >> 8);
END enlarge;

CONST
    maxDOTS = 2976; (* 210mm at 360dpi gives about 2976 dots *)

(* using this big array as a variable parameter was a guaranteed crash *)

CONST
    firstdata = 0;
    maxdata = LONGCARD ((2 * maxDOTS) * 24) DIV 8; (* oversized : Xpixels * pins DIV bytes *)
VAR
    databuffer : ARRAY [firstdata..maxdata] OF BYTE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE GetRaster (inverse:BOOLEAN;
                     leftmarginindots,
                     xmult,ymult,pins,columns,lastcode,countbytes:CARDINAL;
                     VAR rows:CARDINAL;
                     VAR bitson,bitsoff:LONGCARD):CARDINAL;
CONST
    firstpin = 1;
    maxpin   = 24;
    firstdot = 0;
    maxdot   = (2 * maxDOTS) DIV 8;
TYPE
    hbuffertype  = ARRAY [firstdot..maxdot+1] OF BYTE; (* safety *)
VAR
    i,p,x,slice,y,v,ndxmask,mask,databyte,ndxmaskY,maskY : CARDINAL;
    hbuffer : ARRAY [firstpin..maxpin] OF hbuffertype;
    p1,p2:CARDINAL;
    b1,b2,filler:BYTE;
BEGIN
    IF inverse THEN
        filler := 000H; (* dans image fond blanc, bit arm  1 = pixel blanc *)
    ELSE
        filler := 0FFH;
    END;

    i:=1;
    LOOP (* for i := 1 TO pins *)
        IF rows > 0 THEN
            CASE ymult OF
            | 1 :
                decodeScanline(lastcode);
                Lib.Move(ADR(img),ADR(hbuffer[i]),countbytes);
                DEC(rows);
            | 2 :
                IF (i MOD 2)=1 THEN
                    decodeScanline(lastcode);
                    Lib.Move(ADR(img),ADR(hbuffer[i]),countbytes);
                    DEC(rows);
                ELSE
                    Lib.Move(ADR(img),ADR(hbuffer[i]),countbytes);
                END;
            END;
        ELSE
   	        Lib.Fill(ADR(hbuffer[i]),countbytes,filler);
        END;

        CASE xmult OF
        | 1 : ; (* nada *)
        | 2 :
            p2:=countbytes*xmult-1+firstdot;
            p1:=countbytes;
            WHILE p1 > 0 DO
                enlarge(hbuffer[i][p1-1],b1,b2);
                hbuffer[i][p2]:=b2; DEC(p2);
                hbuffer[i][p2]:=b1; IF p2 > 0 THEN DEC(p2); END; (* avoid underflow crash *)
                DEC(p1);
            END;

        END;

        INC(i);
        IF i > pins THEN EXIT; END;
    END;

    p:=firstdata;
    (* do left margin if required *)
    FOR x := 1 TO leftmarginindots DO
        FOR slice:=1 TO (pins DIV 8) DO (* 1 or 3 *)
            databyte:=00H;
            FOR y := 1 TO 8 DO
                v := CARDINAL(filler);
                ndxmask := (x-1) MOD 8;
                mask := bitmask[ndxmask];
                IF (v AND mask)=mask THEN
                    v:=1;
                ELSE
                    v:=0;
                END;
                ndxmaskY:=y-1;
                maskY:=bitmask[ndxmaskY];
                IF inverse THEN
                    IF v=0 THEN
                        INC(bitsoff);
                    ELSE
                        databyte := databyte OR maskY;
                        INC(bitson);
                    END;
                ELSE
                    IF v=0 THEN
                        databyte := databyte OR maskY;
                        INC(bitson);
                    ELSE
                        INC(bitsoff);
                    END;
                END;
            END;
            databuffer[p]:=BYTE(databyte);
            INC(p);
        END;
    END;

    (* now do real data *)
    FOR x := 1 TO (columns*xmult) DO
        FOR slice:=1 TO (pins DIV 8) DO (* 1 or 3 *)
            databyte:=00H;
            FOR y := 1 TO 8 DO
                v := CARDINAL(hbuffer[y+8*(slice-1)][(x-1) DIV 8]);
                ndxmask := (x-1) MOD 8;
                mask := bitmask[ndxmask];
                IF (v AND mask)=mask THEN
                    v:=1;
                ELSE
                    v:=0;
                END;
                ndxmaskY:=y-1;
                maskY:=bitmask[ndxmaskY];
                IF inverse THEN
                    IF v=0 THEN
                        INC(bitsoff);
                    ELSE
                        databyte := databyte OR maskY;
                        INC(bitson);
                    END;
                ELSE
                    IF v=0 THEN
                        databyte := databyte OR maskY;
                        INC(bitson);
                    ELSE
                        INC(bitsoff);
                    END;
                END;
            END;
            databuffer[p]:=BYTE(databyte);
            INC(p);
        END;
    END;

    RETURN p;
END GetRaster;

(*
   format de la daube:
   esc * mode lohi (lohi tant le nombre de colonnes en x)
   ensuite, donnes sur une hauteur de 8 ou 24 points
   bit 0 = maximum Y pour 8 (i.e. $01 donne un point en y=8)
   mme mcanisme en 24 aiguilles, sinon que le delta est de 24 en Y
   toujours avec bit 0 = point le plus bas en Y  l'impression

   24*180 et 8*60 donnent des images correctes (trop petites ou trop grandes !)
*)

PROCEDURE pcxToBJ (dpi,pins,lm,tm,xmult,ymult:CARDINAL;
                   picfile,outfile:ARRAY OF CHAR;
                   ejectfirst,eject,inverse,preview,centerh,centerv,DEBUG:BOOLEAN;
                   pagesize:pagesizeType;
                   VAR bitson,bitsoff:LONGCARD );
CONST
    msgWait  = "Patience... "; (* yep, final space for cursor *)
    magicLF  = BYTE(24); (* why 24 ? 30 is too much anyway... *)
    esc      = CHR(27);
    cr       = CHR(13);
    formfeed = CHR(12);
    star     = "*";
VAR
    h : PCXheaderType;
    LQmode, n, lastcode,countbytes,countX,countY,printernum,lo,hi:CARDINAL;
    pagewidth,pageheight:CARDINAL;
    printing,isPrinter,ok : BOOLEAN;
    cmd : ARRAY [1..5] OF BYTE;
    crlf: ARRAY [1..4] OF BYTE;
    leftmarginindots:CARDINAL;
    topmarginindots:CARDINAL;
    lc,wi:LONGINT;
    realCountX : CARDINAL;
BEGIN
    IF NOT(DEBUG) THEN video(msgWait,TRUE); END;
    ok:=chkPrintMode(pins,dpi,LQmode); (* already checked for validity *)
    getPageSize(pagewidth,pageheight,pagesize);

    printing := NOT(preview);
    bitson := 0;
    bitsoff:= 0;

    hin:=FIO.OpenRead(picfile);
    FIO.AssignBuffer(hin,ioBufferIn);
    n:=FIO.RdBin(hin,h,SIZE(PCXheaderType));

    lastcode := CARDINAL(h.NCP) * CARDINAL(h.NBS) -1;
    IF lastcode > maxcode THEN
        FIO.Close(hin);
        IF NOT(DEBUG) THEN video(msgWait,FALSE); END;
        RETURN;
    END;

    countX   := CARDINAL (h.rightmargin-h.leftmargin)  +1; (* columns i.e. pixels *)
    countY   := CARDINAL (h.lowermargin-h.uppermargin) +1; (* lines *)

    realCountX := countX * xmult;

    countbytes := countX DIV 8;
    IF (countbytes MOD 8) <> 0 THEN INC (countbytes); END;

    IF centerh THEN
        wi := LONGINT(countX * xmult);
        lc := LONGINT(pagewidth - (lm-lmBJ200) );
        lc := (lc * 10 * LONGINT(dpi) ) DIV 254; (* now rounded in dots *)
dbg(DEBUG,lc,"lc");
        lc := lc - wi;
dbg(DEBUG,lc,"lc");dbg(DEBUG,wi,"wi");
        IF lc < 0 THEN lc:=0;END;
        leftmarginindots := CARDINAL(lc DIV 2);
        INC(realCountX, leftmarginindots); (* do not multiply here : we add dots *)
    ELSE
        leftmarginindots := lm-lmBJ200;
    END;
dbg(DEBUG,LONGINT(leftmarginindots),"LM");

    IF centerv THEN
        (* hey, what about vertical dpi ??? *)
        wi := LONGINT(countY * ymult);
        lc := LONGINT(pageheight - (tm-tmBJ200) );
        lc := (lc * 10 * LONGINT(dpi) ) DIV 254; (* now rounded in dots *)
dbg(DEBUG,lc,"lc");
        lc := lc - wi;
dbg(DEBUG,lc,"lc");dbg(DEBUG,wi,"wi");
        IF lc < 0 THEN lc:=0;END;
        topmarginindots := CARDINAL(lc DIV 2);
    ELSE
        topmarginindots  := tm-tmBJ200;
    END;
dbg(DEBUG,LONGINT(topmarginindots),"TM");

    lo := realCountX MOD 256;
    hi := realCountX DIV 256;
    cmd[1]:=esc;
    cmd[2]:="*";
    cmd[3]:=BYTE(LQmode);
    cmd[4]:=BYTE(lo);
    cmd[5]:=BYTE(hi);

    crlf[1] := cr;
    crlf[2] := esc;
    crlf[3] := "J";
    crlf[4] := magicLF; (* cr then 24 lf of n/180" *)

    isPrinter  := isPrinterDevice(outfile);
    IF isPrinter THEN printernum := getPrinterNumber(outfile); END;

    IF printing THEN
        hout := FIO.Create(outfile);
        FIO.AssignBuffer(hout,ioBufferOut);
        IF isPrinter THEN
            IF ejectfirst THEN FIO.WrBin(hout,formfeed,1);END;
            FOR hi := 1 TO (topmarginindots DIV CARDINAL(magicLF) ) DO
    	        FIO.WrBin(hout,crlf,4);
            END;
        END;
    END;

    LOOP
        IF countY = 0 THEN EXIT; END;
        IF (printing AND isPrinter) THEN
    	    WHILE isPrinterReady(printernum)=FALSE DO
    	        IF KeyPressed() THEN EXIT; END;
            END;
        END;

    	n:=GetRaster (inverse,leftmarginindots,
    	              xmult,ymult,pins,
    	              countX,lastcode,countbytes,
    	              countY,bitson,bitsoff);

	    IF printing THEN
    	    FIO.WrBin(hout,cmd,5);
    	    FIO.WrBin(hout,databuffer,n);
    	    FIO.WrBin(hout,crlf,4);
        END;
        (* useless eyecandy removed *)
        IF KeyPressed() THEN EXIT; END;
    END;

    IF printing THEN
        IF (isPrinter AND eject) THEN FIO.WrBin(hout,formfeed+cr,1);END;
        FIO.Flush(hout);
        FIO.Close(hout);
    END;
    FIO.Close(hin);
    IF NOT(DEBUG) THEN video(msgWait,FALSE); END;
END pcxToBJ;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    kbdmsg = "[ESC] pour annuler, (presque) n'importe quelle autre touche pour imprimer : ";
    widigits = 7;
    cancel = CHR(01BH);
VAR
    picHeader            : PCXheaderType;
    bitson,bitsoff       : LONGCARD;
VAR
    parmcount, i, opt    : CARDINAL;
    S, R                 : str128;
    state                : (waiting,gotfile,gotdev);
    picfile,dev          : str128;
    picw,pich            : CARDINAL;
    query                : BOOLEAN;
    key                  : str2;
VAR
    pins, dpi, lm, tm, xmult, ymult  : CARDINAL;
    inverse, eject, ejectfirst, preview : BOOLEAN;
    centerhorizontal,centervertical  : BOOLEAN;
    pagesize:pagesizeType;
    DEBUG:BOOLEAN;
BEGIN
    Lib.DisableBreakCheck();
    FIO.IOcheck := FALSE;

    WrLn; (* here for pretty output *)

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,"");END;

    pins             := defaultpins;
    dpi              := defaultdpi;
    lm               := lmBJ200;
    tm               := tmBJ200;
    inverse          := FALSE;
    eject            := FALSE;
    ejectfirst       := FALSE;
    preview          := TRUE;
    centerhorizontal := FALSE;
    centervertical   := FALSE;
    pagesize         := A4;
    xmult            := defaultxmult;
    ymult            := defaultymult;
    query            := TRUE;
    DEBUG            := FALSE;

    state := waiting;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R)=TRUE THEN
            opt := GetOptIndex( R,"?"+delim+"H"+delim+"HELP"+delim+
                                  "A:"+delim+"PINS:"+delim+
                                  "D:"+delim+"DENSITY:"+delim+
                                  "I"+delim+"INVERSE"+delim+
                                  "E"+delim+"EJECT"+delim+
                                  "V"+delim+"VERBOSE"+delim+
                                  "P"+delim+"PRINT"+delim+
                                  "LM:"+delim+"LEFTMARGIN:"+delim+
                                  "TM:"+delim+"TOPMARGIN:"+delim+
                                  "CV"+delim+"CENTERVERTICAL"+delim+
                                  "CH"+delim+"CENTERHORIZONTAL"+delim+
                                  "X2"+delim+
                                  "Y2"+delim+
                                  "XY2"+delim+
                                  "C"+delim+"AUTOCENTER"+delim+
                                  "N"+delim+"NOQUERY"+delim+
                                  "J"+delim+"EJECTFIRST"+delim+
                                  "DEBUG"
                               );
            CASE opt OF
            | 1,2,3 : abort(errHelp,"");
            | 4,5   : IF chkpins(S,pins)=FALSE THEN abort(errBadPins,S);END;
            | 6,7   : IF chkdpi(S,dpi)=FALSE THEN abort(errBadDPI,S);END;
            | 8,9   : inverse:=TRUE;
            | 10,11 : eject:=TRUE;
            | 12,13 : ; (* was verbose eyecandy *)
            | 14,15 : preview:=FALSE;
            | 16,17 : IF chklm(S,lm)=FALSE THEN abort(errBadLM,S);END;
            | 18,19 : IF chktm(S,tm)=FALSE THEN abort(errBadTM,S);END;
            | 20,21 : centervertical    := TRUE;
            | 22,23 : centerhorizontal  := TRUE;
            | 24:     xmult:=2;
            | 25:     ymult:=2;
            | 26:     xmult:=2; ymult:=2;
            | 27, 28: centervertical    :=TRUE;
                      centerhorizontal  :=TRUE;
            | 29,30 : query := FALSE;
            | 31,32 : ejectfirst := TRUE;
            | 33    : DEBUG := TRUE;
            ELSE
                abort(errOption,S);
            END;
        ELSE
            CASE state OF
            | waiting :
                IF same(R,"?") THEN abort(errHelp,""); END;
                Str.Copy(picfile,R); (* keep upper case here *)
            | gotfile :
                Str.Copy(dev,R); (* keep upper case here *)
            ELSE
                abort(errTooManyParameters,S);
            END;
            INC(state);
        END;
    END;
    CASE state OF
    | waiting : abort(errNeedFile,"");
    | gotfile : abort(errNeedDevice,"");
    END;
    IF chkPrintMode(pins,dpi,opt)=FALSE THEN abort(errBadCombo,"");END;

    handleExt(extPCX,picfile);
    IF chkJoker(picfile) THEN abort(errBadName,picfile);END;
    IF FIO.Exists(picfile)=FALSE THEN abort(errNotFound,picfile);END;
    IF chkPCX(picfile,picHeader)=FALSE THEN abort(errNotPCX,picfile);END;
    IF chkMonoPCX(picHeader)=FALSE THEN abort(errNotMonoPCX,picfile);END;

    fixSpecialDevice(dev);
    IF chkJoker(dev) THEN abort(errBadName,dev);END;
    IF chkSupportedDevice(dev)=FALSE THEN abort(errUnsupportedDevice,dev);END;

    IF same(picfile,dev) THEN abort(errNonsense,"");END;

    getPCXpictureSize(picHeader,picw,pich);

    WrStr(Banner+nl);
    WrLn;
    WrStr("Fichier image                : ");WrStr(picfile);WrLn;
    WrStr("Fichier de sortie            : ");WrStr(dev);WrLn;
    WrLn;
    wrval("Largeur de l'image en pixels",widigits,picw);
    wrval("Hauteur de l'image en pixels",widigits,pich);
    WrLn;
    wrval("Colonnes                    ",widigits,picw*xmult);
    wrval("Lignes                      ",widigits,pich*ymult);
    WrLn;

    wrval("Nombre d'aiguilles          ",widigits,pins);
    wrval("Densit en points par pouce ",widigits,dpi);
    WrLn;

IF preview THEN
	pcxToBJ (dpi,pins,lm,tm,xmult,ymult,
	         picfile,dev,ejectfirst,eject,inverse,preview,
	         centerhorizontal,centervertical,DEBUG,
	         pagesize,
	         bitson,bitsoff);
    wrVAL("Points noirs                ",widigits,bitson);
	wrVAL("Points blancs               ",widigits,bitsoff);
    WrLn;
    IF bitson < bitsoff THEN (* few black dots, lots of white ones : ok *)
    	WrStr("L'impression devrait tre normale (les points blancs sont en majorit)."+nl);
    ELSE
		WrStr("L'impression sera ANORMALE (les points blancs sont en minorit)."+nl);
        WrLn;
		IF inverse THEN
        	WrStr("Pour imprimer ce fichier, ne spcifiez PAS l'option /i !"+nl);
        ELSE
        	WrStr("Pour imprimer ce fichier, spcifiez l'option /i !"+nl);
        END;
    END;
ELSE
    IF query THEN
        video(kbdmsg,TRUE);
        Flushkey;
        key:=Waitkey();
        video(kbdmsg,FALSE);
        IF same(key,cancel) THEN abort(errCancelled,"");END;
    END;
    pcxToBJ (dpi,pins,lm,tm,xmult,ymult,
             picfile,dev,ejectfirst,eject,inverse,preview,
             centerhorizontal,centervertical,DEBUG,
             pagesize,
             bitson,bitsoff);
    WrStr("Termin !");WrLn;
END;

    abort(errNone,"");
END PCX2BJ.

