
(*

*)

MODULE RLEtoLIF;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT IO;

FROM QD_ASCII IMPORT dash, slash, nullchar, tabchar, cr, lf, nl, bs,
space, dot, deg, degree, doublequote, quote, colon, percent, vbar,
blank, equal, dquote, charnull, singlequote, antislash, dollar,
star, backslash, coma, question, underscore, underbar, tabul, hbar,
comma, semicolon, diese, pound, openbracket, closebracket, tilde, exclam,
stardotstar, dotdot, escCh, escSet, letters, digits,
lettersUpp, lettersLow, openbrace, closebrace, ampersand;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite, setReadOnly,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs, UpperCaseAlt, LowerCaseAlt,
completedInit, completedShow, completedSHOW, completedEnd, completed,
removeDups, isValidHDunit, removePhantoms, removeFloppies,
getCDROMunits, getCDROMletters, removeCDROMs, getAllHDunits,
getAllLegalUnits, metaproc, getCli, argc, argv, qdSplitAllPath,
metaproc, UpperCaseFR, LowerCaseFR, ASCIIonly;

FROM QD_File IMPORT pathtype, w9XnothingRequired,
fileOpenRead, fileOpen, fileExists, fileExistsAlt,
fileIsRO, fileSetRW, fileSetRO,
fileErase, fileCreate, fileAppend,fileRename,
fileGetFileSize, fileGetFileStamp,
fileIsDirectorySpec, fileClose, fileFlush, fileSupportLFN;

FROM IO IMPORT WrStr, WrLn;

(* ------------------------------------------------------------ *)

CONST
    LIFid  = pound+"Life 1.05";
    LIFrem = pound+"D ~";
    LIFrule= pound+"R ~";
    LIFpos = pound+"P -~ -~";
    LIFnopos=pound+"D P -~ -~"; (* do not reset position *)
CONST
    chPB   = "?";
    extRLE = ".RLE";
    extLIF = ".LIF";
    exe    = "RLETOLIF";
    title  = "Q&D RLE to LIF format converter";
    version= "v1.0";
    culprit= "by PhG";
    msghelp = title+" "+version+" "+culprit+nl+
              nl+
              "Syntax : "+exe+" [option]... <file["+extRLE+"]>"+nl+
              nl+
              "This program creates a "+extLIF+" file from a "+extRLE+" file."+nl+
              nl+
              "  -o overwrite "+extLIF+" target file"+nl+
              "  -p replace #P with #C in target file"+nl+
              "  -x disable LFN support even if available"+nl;
CONST
    errNone = 0;
    errHelp = 1;
    errOpt  = 2;
    errOverflow= 3;
    errJoker= 4;
    errFNF  = 5;
    errExists=6;

PROCEDURE abort (errcode:CARDINAL; einfo:ARRAY OF CHAR);
VAR
    S:str1024;
BEGIN
    CASE errcode OF
    | errNone : ;
    | errHelp : WrStr(msghelp);
    ELSE
        CASE errcode OF
        | errOpt  : S:='Unknown "~" option !';
        | errOverflow: S:="Too many parameters !";
        | errJoker: S:='No jokers allowed in "~" !';
        | errFNF  : S:='"~" does not exist !';
        | errExists:S:='"~" already exists !';
        END;
        Str.Subst(S,"~",einfo);
        WrStr(exe);WrStr(" : ");WrStr(S);WrLn;
    END;
    Lib.SetReturnCode(SHORTCARD(errcode));
    HALT;
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE numtostr (v:CARDINAL):str16;
VAR
    ok:BOOLEAN;
    N:str16;
BEGIN
    Str.CardToStr(LONGCARD(v),N,10,ok);
    IF NOT(ok) THEN N:=chPB;END;
    RETURN N;
END numtostr;

(* MAX(CARDINAL) if pb *)

PROCEDURE strtonum (N:str16):CARDINAL;
VAR
    ok:BOOLEAN;
    lc:LONGCARD;
    v:CARDINAL;
BEGIN
    v:=MAX(CARDINAL);
    IF verifyString(N,digits) THEN
        lc:=Str.StrToCard(N,10,ok);
        IF ok THEN
            IF lc <= MAX(CARDINAL) THEN v:=CARDINAL(lc);END;
        END;
    END;
    RETURN v;
END strtonum;

(* orgrule is uppercased, return "?/?" if pb *)

PROCEDURE fixrule (VAR R:ARRAY OF CHAR;  orgrule:ARRAY OF CHAR);
VAR
    sS,sB:str16;
    p:CARDINAL;
BEGIN
    (* handled : "survival/birth"    "S*/B*"    "B*/S*"    "life" *)
    Str.Copy(R,orgrule);
    p:=Str.CharPos(R,slash);
    IF Str.Match(R,"S*/B*") THEN
        Str.Slice(sS,R,0,p); Str.Delete(R,0,p+1);Str.Copy(sB,R);
    ELSIF Str.Match(R,"B*/S*") THEN
        Str.Slice(sB,R,0,p); Str.Delete(R,0,p+1);Str.Copy(sS,R);
    ELSIF Str.Match(R,"*/*") THEN
        Str.Slice(sS,R,0,p); Str.Delete(R,0,p+1);Str.Copy(sB,R);
    ELSE
        sS:=chPB;
        sB:=chPB;
    END;
    Str.Subst(sS,"S","");
    Str.Subst(sB,"B","");
    Str.Concat(R,sS,slash);Str.Append(R,sB);
END fixrule;

(* ------------------------------------------------------------ *)

(* "#R S/B" AND "#P -wi/2,-he/2" *)

PROCEDURE procHeader (setpos:BOOLEAN; hout:FIO.File; Z:ARRAY OF CHAR):BOOLEAN;
CONST
    lifebyname  = "LIFE"; (* seen once ! *)
    badrule     = "?/?";
    defaultrule = "23/3"; (* Conway's *)
    swi         = "X=";
    she         = "Y=";
    srule       = "RULE=";
    spatwihe    = swi+"*"+coma+"*"+she+"*"; (* case-insensitive *)
VAR
    S:str128;
    pb,p,wi,he:CARDINAL;
    rule,orgrule:str80; (* S12345678/B12345678 *)
    N:str16;
BEGIN
    Str.Copy(S,Z);
    pb:=0;
    ReplaceChar(S,blank,"");
    ReplaceChar(S,tabul,"");
    Str.Caps(S); (* better safe than sorry *)
    IF Str.Match(S,spatwihe) THEN (* neither clever nor elegant but effective *)
        Str.Subst(S,swi,"");
        p:=Str.CharPos(S,coma);
        Str.Slice(N,S,0,p); Str.Delete(S,0,p+1);
        wi:=strtonum(N);
        IF wi = MAX(CARDINAL) THEN INC(pb);END;

        Str.Subst(S,she,"");
        p:=Str.CharPos(S,coma);
        IF p = MAX(CARDINAL) THEN (* no rule *)
            Str.Copy(N,S); S:="";
        ELSE
            Str.Slice(N,S,0,p); Str.Delete(S,0,p+1);
        END;
        he:=strtonum(N);
        IF he = MAX(CARDINAL) THEN INC(pb);END;

        IF same(S,"") THEN
            S:=defaultrule;
        ELSE
            Str.Subst(S,srule,"");
            IF same(S,lifebyname) THEN S:=defaultrule;END;
        END;
        Str.Copy(orgrule,S);
        fixrule(rule,orgrule);
        IF same(rule,badrule) THEN INC(pb);END;
    END;
    IF pb = 0 THEN
        S:=LIFrule;
        Str.Subst(S,"~",rule);
        FIO.WrStr(hout,S);FIO.WrLn(hout);

        IF setpos THEN
            S:=LIFpos;
        ELSE
            S:=LIFnopos;
        END;
        Str.Subst(S,"~",numtostr(wi DIV 2));
        Str.Subst(S,"~",numtostr(he DIV 2));
        FIO.WrStr(hout,S);FIO.WrLn(hout);
    END;
    RETURN (pb=0);
END procHeader;

PROCEDURE procRLE (hout:FIO.File;Z:ARRAY OF CHAR):BOOLEAN;
CONST
    dead = ".";
    alive= "*";
VAR
    S:str128;
    N:str16;
    last,i,len,count:CARDINAL;
    ch:CHAR;
    done,dmp:BOOLEAN;
BEGIN
    Str.Copy(S,Z);
    ReplaceChar(S,blank,"");
    ReplaceChar(S,tabul,"");
    Str.Caps(S); (* better safe than sorry *)
    len:=Str.Length(S);
    i:=0;
    N:="";
    dmp:=FALSE;
    done:=FALSE;
    LOOP
        IF i >= len THEN EXIT; END;
        CASE S[i] OF
        | "0".."9":     Str.Append(N,S[i]);
        | "B":          ch:=dead;  dmp:=TRUE;
        | "O":          ch:=alive; dmp:=TRUE;
        | "$":          FIO.WrLn(hout);
        | "!":          FIO.WrLn(hout);done:=TRUE;EXIT; (* force it now *)
        END;
        IF dmp THEN
            IF same(N,"") THEN N:="1";END;
            last:=strtonum(N);
            IF last # MAX(CARDINAL) THEN
                FOR count:=1 TO last DO FIO.WrChar(hout,ch);END;
            END;
            N:="";
            dmp:=FALSE;
        END;
        INC(i);
    END;

    RETURN done;
END procRLE;

(* ------------------------------------------------------------ *)

PROCEDURE procFile (DEBUG,useLFN,setpos,overwrite:BOOLEAN;src,dst:pathtype );
VAR
    len:CARDINAL;
    hin,hout:FIO.File;
    Z,S:str128;
    state : (waitingheader,gotheader);
BEGIN
    hin:=fileOpenRead(useLFN,src);
    hout:=fileCreate(useLFN,dst);

    FIO.WrStr(hout,LIFid);FIO.WrLn(hout);

    state:=waitingheader;
    LOOP
        FIO.RdStr(hin,S);
        LtrimBlanks(S);
        RtrimBlanks(S);
        len:=Str.Length(S);
        IF len # 0 THEN
            CASE S[0] OF
            | pound :
                IF len > 1 THEN
                    CASE S[1] OF
                    | "N","C","O": (* name, comment, origin *)
                        Str.Delete(S,0,2);
                        Z:=LIFrem;
                        Str.Subst(Z,"~",S);
                        FIO.WrStr(hout,Z);FIO.WrLn(hout);
                    END;
                END;
            ELSE
                CASE state OF
                | waitingheader:
                    IF procHeader(setpos,hout,S) THEN state:=gotheader;END;
                | gotheader:
                    IF procRLE(hout,S) THEN EXIT;END;
                END;
            END;
        END;
        IF FIO.EOF THEN EXIT;END;
    END;
    fileClose(useLFN,hout);
    fileClose(useLFN,hin);
END procFile;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

VAR
    R,S    : pathtype;
    src,dst: pathtype;
    flagSETPOS,flagOVERWRITE:BOOLEAN;
    useLFN,DEBUG:BOOLEAN;
    i,parmcount,opt:CARDINAL;
    info:str1024; (* oversized *)
BEGIN
    Lib.DisableBreakCheck();
    FIO.IOcheck := FALSE;

    WrLn;

    Str.Copy(src,"");
    flagSETPOS    := TRUE;
    flagOVERWRITE := FALSE;
    useLFN        := TRUE;
    DEBUG         := FALSE;

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,"");END;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R, "?"+delim+"H"+delim+"HELP"+delim+
                                  "X"+delim+"LFN"+delim+
                                  "O"+delim+"OVERWRITE"+delim+
                                  "P"+delim+"SETPOS"+delim+
                                  "DEBUG"
                              );
            CASE opt OF
            | 1,2,3    : abort(1,"");
            | 4,5      : useLFN        := FALSE;
            | 6,7      : flagOVERWRITE := TRUE;
            | 8,9      : flagSETPOS    := FALSE;
            | 10       : DEBUG         := TRUE;
            ELSE
                abort(errOpt,S);
            END;
        ELSE
            IF same(src,"")=FALSE THEN abort(errOverflow,S);END;
            Str.Copy( src, S);
        END;
    END;

    useLFN:=( useLFN AND fileSupportLFN() );

    IF Str.RCharPos(src,dot)=MAX(CARDINAL) THEN Str.Append(src,extRLE);END;
    IF chkJoker(src) THEN abort(errJoker,src);END;
    IF fileExists(useLFN,src)=FALSE THEN abort(errFNF,src);END;
    i:=Str.RCharPos(src,dot);
    IF i = MAX(CARDINAL) THEN
        Str.Copy(dst,src);
    ELSE
        Str.Slice(dst,src,0,i);
    END;
    Str.Append(dst,extLIF);
    IF fileExists(useLFN,dst) THEN
        IF flagOVERWRITE=FALSE THEN abort(errExists,dst);END;
    END;

    procFile(DEBUG,useLFN,flagSETPOS,flagOVERWRITE,src,dst);

    info:='::: Created : "~"';
    Str.Subst(info,"~",dst);
    WrStr(info);WrLn;

    abort(0,"");
END RLEtoLIF.

