Option Explicit
DefInt A-Z

Function boolToChk% (ByVal flag%)
Select Case flag%
Case True
    flag% = CHECKED
Case False
    flag% = UNCHECKED
End Select
boolToChk% = flag%
End Function

Sub doSetupCancel ()
Unload f
End Sub

Sub doSetupMain ()
Set f = frmSetup

retrieveParameters

f.Visible = False
f.AutoRedraw = True
' f.ControlBox = False
' f.MaxButton = False
' f.MinButton = False
' f.BorderStyle = DOUBLEFIXED
f.caption = title$ + " " + culprit$ + " : Setup"
f.WindowState = NORMAL

f.framePictureProcessing.caption = picprocessing$ + " (" + thisVBX$ + " VBX)"

centerform f

showSetupParms

f.Show
f.Visible = True
End Sub

Sub doSetupOK ()
saveSetupParms
Unload f
End Sub

Sub doSetupRestoreDefaults ()
Dim flag%

' directory and masks

gDirectory$ = exedir$ ' default

gIncludeHidden% = dIncludeHidden%
gIncludeGIF% = dIncludeGIF%
gIncludeJPG% = dIncludeJPG%
gIncludeBMP% = dIncludeBMP%
gIncludePCX% = dIncludePCX%
gIncludeTGA% = dIncludeTGA%

' misc

gSortedFileNames% = dSortedFileNames%
gPickAtRandom% = dPickAtRandom%

gTargetSize% = dTargetSize%
gAddedMargin% = dAddedMargin%
gSubstractedMargin% = dSubstractedMargin%
gSkipOutOfRange% = dSkipOutOfRange%

gColorReduction% = dColorReduction%
gColorReductionCode% = dColorReductionCode%
gDither% = dDither%
gDitherCode% = dDitherCode%

gChangeGammaGIF% = dChangeGammaGIF%
gChangeGammaJPG% = dChangeGammaJPG%
gChangeGammaTGA% = dChangeGammaTGA%
gChangeGammaBMP% = dChangeGammaBMP%
gChangeGammaPCX% = dChangeGammaPCx%

gGammaGIF% = dGammaGIF%
gGammaJPG% = dGammaJPG%
gGammaBMP% = dGammaBMP%
gGammaPCX% = dGammaPCX%
gGammaTGA% = dGammaTGA%

gAutoPreview% = dAutoPreview%

gKillTmpBMP% = dKillTmpBMP%
gWriteBMPpath% = dWriteBMPpath%
gPersistence% = dPersistence%
gUseDDB% = dUseDDB%
gPollInterval% = dPollInterval%

gLastIndex% = dLastIndex%
gLastFileName$ = ""

showSetupParms
End Sub

Function fmtLimits$ (ByVal W%, H%, target As Control, minus As Control, plus As Control)
Dim a$, b$, c$
Dim x%, y%
Dim p& ' damn types ! to avoid overflow, we need at least one long

p& = target.Value
x% = (W% * p&) \ 100
y% = (H% * p&) \ 100
a$ = fmtInt$(x%) + "x" + fmtInt$(y%)

p& = target.Value - minus.Value
x% = (W% * p&) \ 100
y% = (H% * p&) \ 100
b$ = fmtInt$(x%) + "x" + fmtInt$(y%)

p& = target.Value + plus.Value
x% = (W% * p&) \ 100
y% = (H% * p&) \ 100
c$ = fmtInt$(x%) + "x" + fmtInt$(y%)

fmtLimits$ = "Smallest = " + b$ + ", Target = " + a$ + ", Biggest = " + c$
End Function

Sub saveSetupParms ()
Dim rc%
Dim s$
Dim i%

' update all flags according to form

' directory and masks

s$ = gDirectory$ ' f!lblDirectory.caption
rc% = writeIni%(ini$, sSection$, eDirectory$, s$)

s$ = chkToStr$(f!chkIncludeHidden.Value)
rc% = writeIni%(ini$, sSection$, eIncludeHidden$, s$)
s$ = chkToStr$(f!chkIncludeGIF.Value)
rc% = writeIni%(ini$, sSection$, eIncludeGIF$, s$)
s$ = chkToStr$(f!chkIncludeJPG.Value)
rc% = writeIni%(ini$, sSection$, eIncludeJPG$, s$)
s$ = chkToStr$(f!chkIncludeBMP.Value)
rc% = writeIni%(ini$, sSection$, eIncludeBMP$, s$)
s$ = chkToStr$(f!chkIncludePCX.Value)
rc% = writeIni%(ini$, sSection$, eIncludePCX$, s$)
s$ = chkToStr$(f!chkIncludeTGA.Value)
rc% = writeIni%(ini$, sSection$, eIncludeTGA$, s$)

' misc

s$ = chkToStr$(f!chkSortedFileNames.Value)
rc% = writeIni%(ini$, sSection$, eSortedFileNames$, s$)
s$ = chkToStr$(f!chkPickAtRandom.Value)
rc% = writeIni%(ini$, sSection$, ePickAtRandom$, s$)

s$ = fmtInt$(f!hbarTargetSize.Value)
rc% = writeIni%(ini$, sSection$, eTargetSize$, s$)
s$ = fmtInt$(f!hbarAddedMargin.Value)
rc% = writeIni%(ini$, sSection$, eAddedMargin$, s$)
s$ = fmtInt$(f!hbarSubstractedMargin.Value)
rc% = writeIni%(ini$, sSection$, eSubstractedMargin$, s$)
s$ = chkToStr$(f!chkSkipOutOfRange.Value)
rc% = writeIni%(ini$, sSection$, eSkipOutOfRange$, s$)

i% = f!clstColorReduction.ListIndex
s$ = fmtInt$(i%)
rc% = writeIni%(ini$, sSection$, eColorReduction$, s$)
s$ = fmtInt$(f!clstColorReduction.ItemData(i%))
rc% = writeIni%(ini$, sSection$, eColorReductionCode$, s$)

i% = f!clstDither.ListIndex
s$ = fmtInt$(i%)
rc% = writeIni%(ini$, sSection$, eDither$, s$)
s$ = fmtInt$(f!clstDither.ItemData(i%))
rc% = writeIni%(ini$, sSection$, eDitherCode$, s$)

s$ = chkToStr$(f!chkChangeGammaGIF.Value)
rc% = writeIni%(ini$, sSection$, eChangeGammaGIF$, s$)
s$ = fmtInt$(f!hbarGammaGIF.Value)
rc% = writeIni%(ini$, sSection$, eGammaGIF$, s$)

s$ = chkToStr$(f!chkChangeGammaJPG.Value)
rc% = writeIni%(ini$, sSection$, eChangeGammaJPG$, s$)
s$ = fmtInt$(f!hbarGammaJPG.Value)
rc% = writeIni%(ini$, sSection$, eGammaJPG$, s$)

s$ = chkToStr$(f!chkChangeGammaTGA.Value)
rc% = writeIni%(ini$, sSection$, eChangeGammaTGA$, s$)
s$ = fmtInt$(f!hbarGammaTGA.Value)
rc% = writeIni%(ini$, sSection$, eGammaTGA$, s$)

s$ = chkToStr$(f!chkChangeGammaBMP.Value)
rc% = writeIni%(ini$, sSection$, eChangeGammaBMP$, s$)
s$ = fmtInt$(f!hbarGammaBMP.Value)
rc% = writeIni%(ini$, sSection$, eGammaBMP$, s$)

s$ = chkToStr$(f!chkChangeGammaPCX.Value)
rc% = writeIni%(ini$, sSection$, eChangeGammaPCX$, s$)
s$ = fmtInt$(f!hbarGammaPCX.Value)
rc% = writeIni%(ini$, sSection$, eGammaPCX$, s$)

' use gAutoPreview updated by pickdir.bas/frm
' instead of unloaded fff!chkAutoPreview.value
s$ = boolToStr$(gAutoPreview%)
rc% = writeIni%(ini$, sSection$, eAutoPreview$, s$)

s$ = chkToStr$(f!chkKilltmpBMP.Value)
rc% = writeIni%(ini$, sSection$, eKillTmpBMP$, s$)
s$ = chkToStr$(f!chkWriteBMPpath.Value)
rc% = writeIni%(ini$, sSection$, eWriteBMPpath$, s$)

s$ = fmtInt$(f!hbarPersistence.Value)
rc% = writeIni%(ini$, sSection$, ePersistence$, s$)

s$ = chkToStr$(f!chkUseDDB.Value)
rc% = writeIni%(ini$, sSection$, eUseDDB$, s$)

s$ = fmtInt$(f!hbarPollInterval.Value)
rc% = writeIni%(ini$, sSection$, ePollInterval$, s$)

' index is reset if directory is changed
' no longer true : now, it's set to last selected picture

s$ = fmtInt$(gLastIndex%)
rc% = writeIni%(ini$, sSection$, eLastIndex$, s$)

s$ = gLastFileName$
rc% = writeIni%(ini$, sSection$, eLastFileName$, s$)

End Sub

Sub showSetupParms ()
Dim c As Control
Dim s$
Dim crlf$
Dim i%, flag%
Dim c2 As Control

' directory and masks

f!lblDirectory.Alignment = LEFT_JUSTIFY
f!lblDirectory.caption = LCase$(gDirectory$)

f!lblLastWall.Alignment = LEFT_JUSTIFY
Select Case gLastFileName$
Case ""
    s$ = NOLASTWALL$
Case Else
    s$ = LASTWALL$ + LCase$(gLastFileName$)
End Select
f!lblLastWall.caption = s$

f!lblLastIndex.Alignment = LEFT_JUSTIFY
Select Case gLastFileName$ ' gLastIndex$ would do too
Case ""
    s$ = NOLASTINDEX$
Case Else
    s$ = "( " + gLastPicInfos$ + LASTINDEX$ + fmtInt$(gLastIndex%) + " )"
End Select
f!lblLastIndex.caption = s$

f!lblLastUnsupported.Alignment = LEFT_JUSTIFY
Select Case gLastUnsupported$
Case ""
    s$ = NOLASTUNSUPPORTED$
Case Else
    s$ = LASTUNSUPPORTED$ + LCase$(gLastUnsupported$) + " (" + gLastErrorCode$ + ")"
End Select
f!lblLastUnsupported.caption = s$

f!chkIncludeHidden.Value = boolToChk%(gIncludeHidden%)
f!chkIncludeGIF.Value = boolToChk%(gIncludeGIF%)
f!chkIncludeJPG.Value = boolToChk%(gIncludeJPG%)
f!chkIncludeBMP.Value = boolToChk%(gIncludeBMP%)
f!chkIncludePCX.Value = boolToChk%(gIncludePCX%)
f!chkIncludeTGA.Value = boolToChk%(gIncludeTGA%)

' misc

f!chkSortedFileNames.Value = boolToChk%(gSortedFileNames%)
f!chkPickAtRandom.Value = boolToChk%(gPickAtRandom%)

For i% = 1 To 3
    Select Case i%
    Case 1: Set c = f!hbarTargetSize: Set c2 = f!lblTargetSize: flag% = gTargetSize%
    Case 2: Set c = f!hbarAddedMargin: Set c2 = f!lblAddedMargin: flag% = gAddedMargin%
    Case 3: Set c = f!hbarSubstractedMargin: Set c2 = f!lblSubstractedMargin: flag% = gSubstractedMargin%
    End Select
    Select Case i%
    Case 1:
        c.Min = MINTARGETSIZE
        c.Max = MAXTARGETSIZE
        c.SmallChange = SMALLCHANGETARGETSIZE
        c.LargeChange = LARGECHANGETARGETSIZE
    Case 2, 3:
        c.Min = MINMARGIN
        c.Max = MAXMARGIN
        c.SmallChange = SMALLCHANGEMARGIN
        c.LargeChange = LARGECHANGEMARGIN
    End Select
    c.Value = flag%
    c2.Alignment = CENTER
    updateValue c, c2
Next
f!chkSkipOutOfRange.Value = boolToChk%(gSkipOutOfRange%)

f!lblAbsolute.Alignment = LEFT_JUSTIFY
updateLimits f

Set c = f!clstColorReduction
'c.Sorted = False
'c.Style = dropdown list
c.Clear
c.AddItem "Original unmodified colors"
c.ItemData(c.NewIndex) = EFFECTNONE
c.AddItem "Grey"
c.ItemData(c.NewIndex) = EFFECTGRAY
c.AddItem "Bayer (monochrome)"
c.ItemData(c.NewIndex) = EFFECTBAYERMONO
c.AddItem "Bayer (color)"
c.ItemData(c.NewIndex) = EFFECTBAYERCOLOR
c.AddItem "Diffusion (monochrome)"
c.ItemData(c.NewIndex) = EFFECTDIFFUSIONMONO
c.AddItem "Diffusion (color)"
c.ItemData(c.NewIndex) = EFFECTDIFFUSIONCOLOR
c.AddItem "Halftone (monochrome)"
c.ItemData(c.NewIndex) = EFFECTHALFTONEMONO
c.AddItem "Median"
c.ItemData(c.NewIndex) = EFFECTMEDIAN
c.AddItem "Popularity"
c.ItemData(c.NewIndex) = EFFECTPOPULARITY
c.AddItem "Laplacian"
c.ItemData(c.NewIndex) = EFFECTLAPLACIAN
c.AddItem "Dialation"
c.ItemData(c.NewIndex) = EFFECTDIALATION
c.AddItem "Reduction to 256 colors (8 BPP)"
c.ItemData(c.NewIndex) = EFFECTBPP8%
c.AddItem "Reduction to 16 colors (4 BPP)"
c.ItemData(c.NewIndex) = EFFECTBPP4%
c.AddItem "Reduction to monochrome (1 BPP)"
c.ItemData(c.NewIndex) = EFFECTBPP1%
c.AddItem "Color inversion"
c.ItemData(c.NewIndex) = EFFECTINVERSE%
c.ListIndex = gColorReduction%

Set c = f!clstDither
'c.Sorted = False
'c.Style = dropdown list
c.Clear
c.AddItem "Burkes"
c.ItemData(c.NewIndex) = AC_DITHERDIFFUSION
c.AddItem "Bayer"
c.ItemData(c.NewIndex) = AC_DITHERBAYER
c.AddItem "No dithering"
c.ItemData(c.NewIndex) = AC_DITHERNONE
c.ListIndex = gDither%

s$ = "Brightness"' Gamma when we find out how to save it using accusoft
For i% = 1 To 5
    Select Case i% ' yes, we know an array would have been easier
    Case 1: Set c = f!chkChangeGammaGIF: flag% = gChangeGammaGIF%
    Case 2: Set c = f!chkChangeGammaJPG: flag% = gChangeGammaJPG%
    Case 3: Set c = f!chkChangeGammaTGA: flag% = gChangeGammaTGA%
    Case 4: Set c = f!chkChangeGammaBMP: flag% = gChangeGammaBMP%
    Case 5: Set c = f!chkChangeGammaPCX: flag% = gChangeGammaPCX%
    End Select
    c.caption = s$
    c.Value = boolToChk%(flag%)
    Select Case i%
    Case 1: Set c = f!hbarGammaGIF: Set c2 = f!lblGammaGIF: flag% = gGammaGIF%
    Case 2: Set c = f!hbarGammaJPG: Set c2 = f!lblGammaJPG: flag% = gGammaJPG%
    Case 3: Set c = f!hbarGammaTGA: Set c2 = f!lblGammaTGA: flag% = gGammaTGA%
    Case 4: Set c = f!hbarGammaBMP: Set c2 = f!lblGammaBMP: flag% = gGammaBMP%
    Case 5: Set c = f!hbarGammaPCX: Set c2 = f!lblGammaPCX: flag% = gGammaPCX%
    End Select
    c.Min = MINGAMMA
    c.Max = MAXGAMMA
    c.SmallChange = SMALLCHANGEGAMMA
    c.LargeChange = LARGECHANGEGAMMA
    If flag% < MINGAMMA Then flag% = MINGAMMA
    If flag% > MAXGAMMA Then flag% = MAXGAMMA
    c.Value = flag%
    c2.Alignment = CENTER
    updateValueGamma c, c2
Next

'fff!chkAutoPreview.Value = boolToChk%(gAutoPreview%)

f!chkKilltmpBMP.Value = boolToChk%(gKillTmpBMP%)
f!chkWriteBMPpath.Value = boolToChk%(gWriteBMPpath%)

Set c = f!hbarPersistence
c.Min = MINPERSISTENCE
c.Max = MAXPERSISTENCE
c.SmallChange = SMALLCHANGEPERSISTENCE
c.LargeChange = LARGECHANGEPERSISTENCE
c.Value = gPersistence%
f!lblPersistence.Alignment = CENTER
updateValue c, f!lblPersistence

f!chkUseDDB.Value = boolToChk%(gUseDDB%)

Set c = f!hbarPollInterval
c.Min = MINPOLLINTERVAL
c.Max = MAXPOLLINTERVAL
c.SmallChange = SMALLCHANGEPOLLINTERVAL
c.LargeChange = LARGECHANGEPOLLINTERVAL
c.Value = gPollInterval%
f!lblPollInterval.Alignment = CENTER
updateValue c, f!lblPollInterval

f!lblCLI.Alignment = CENTER
s$ = "Command line options are documented the good old DOS (-?) way. ;-)"
f!lblCLI.caption = s$
End Sub

Sub updateLimits (ego As Form)
Dim s$
' screen dimensions are global as soon as program is run !
' get'em real time
s$ = fmtLimits$(XscreenInPixels%, YscreenInPixels%, ego!hbarTargetSize, ego!hbarSubstractedMargin, ego!hbarAddedMargin)
ego!lblAbsolute.caption = s$
End Sub

Sub updateValue (bar As Control, lbl As Control)
Dim s$
s$ = fmtInt$(bar.Value)
lbl.caption = s$
End Sub

Sub updateValueGamma (bar As Control, lbl As Control)
Dim s$
Dim v%
v% = bar.Value
v% = v% \ SMALLCHANGEGAMMA%
v% = v% * SMALLCHANGEGAMMA%
bar.Value = v%
' not a gamma value but a brightness one because of crap accusoft vbx's behavior
's$ = Format$((bar.Value / 100!), "0.00")
s$ = intToStr(bar.Value)
lbl.caption = s$
End Sub
