Option Explicit
DefInt A-Z

Function boolToChk% (ByVal flag%)
Select Case flag%
Case True
    flag% = CHECKED
Case False
    flag% = UNCHECKED
End Select
boolToChk% = flag%
End Function

Sub doSetupCancel ()
Unload f
End Sub

Sub doSetupMain ()
Set f = frmSetup

retrieveParameters

f.Visible = False
f.AutoRedraw = True
' f.ControlBox = False
' f.MaxButton = False
' f.MinButton = False
' f.BorderStyle = DOUBLEFIXED
f.Caption = title$ + " " + culprit$ + " : Setup"
f.WindowState = NORMAL

f.framePictureProcessing.Caption = picprocessing$ + " (" + thisVBX$ + " VBX)"

centerform f

showSetupParms

f.Show
f.Visible = True
End Sub

Sub doSetupOK ()
saveSetupParms
Unload f
End Sub

Sub doSetupRestoreDefaults ()
Dim flag%

' directory and masks

gDirectory$ = exedir$ ' default

gIncludeHidden% = dIncludeHidden%
gIncludeGIF% = dIncludeGIF%
gIncludeJPG% = dIncludeJPG%
gIncludeBMP% = dIncludeBMP%
gIncludePCX% = dIncludePCX%
gIncludePNG% = dIncludePNG%

' misc

gSortedFileNames% = dSortedFileNames%
gPickAtRandom% = dPickAtRandom%

gTargetSize% = dTargetSize%
gAddedMargin% = dAddedMargin%
gSubstractedMargin% = dSubstractedMargin%
gSkipOutOfRange% = dSkipOutOfRange%

gColorReduction% = dColorReduction%
gColorReductionCode% = dColorReductionCode%
gDither% = dDither%
gDitherCode% = dDitherCode%

gChangeGammaGIF% = dChangeGammaGIF%
gChangeGammaJPG% = dChangeGammaJPG%
gChangeGammaPNG% = dChangeGammaPNG%
gChangeGammaBMP% = dChangeGammaBMP%
gChangeGammaPCX% = dChangeGammaPCx%

gGammaGIF% = dGammaGIF%
gGammaJPG% = dGammaJPG%
gGammaBMP% = dGammaBMP%
gGammaPCX% = dGammaPCX%
gGammaPNG% = dGammaPNG%

gAutoPreview% = dAutoPreview%

gKillTmpBMP% = dKillTmpBMP%
gWriteBMPpath% = dWriteBMPpath%
gPersistence% = dPersistence%
gUseDDB% = dUseDDB%
gPollInterval% = dPollInterval%

gLastIndex% = dLastIndex%
gLastFileName$ = ""

showSetupParms
End Sub

Function fmtLimits$ (ByVal W%, H%, target As Control, minus As Control, plus As Control)
Dim a$, b$, c$
Dim x%, y%
Dim p& ' damn types ! to avoid overflow, we need at least one long

p& = target.value
x% = (W% * p&) \ 100
y% = (H% * p&) \ 100
a$ = fmtInt$(x%) + "x" + fmtInt$(y%)

p& = target.value - minus.value
x% = (W% * p&) \ 100
y% = (H% * p&) \ 100
b$ = fmtInt$(x%) + "x" + fmtInt$(y%)

p& = target.value + plus.value
x% = (W% * p&) \ 100
y% = (H% * p&) \ 100
c$ = fmtInt$(x%) + "x" + fmtInt$(y%)

fmtLimits$ = "Smallest = " + b$ + ", Target = " + a$ + ", Biggest = " + c$
End Function

Sub saveSetupParms ()
Dim rc%
Dim s$
Dim i%

' update all flags according to form

' directory and masks

s$ = gDirectory$ ' f!lblDirectory.caption
rc% = writeIni%(ini$, sSection$, eDirectory$, s$)

s$ = chkToStr$(f!chkIncludeHidden.value)
rc% = writeIni%(ini$, sSection$, eIncludeHidden$, s$)
s$ = chkToStr$(f!chkIncludeGIF.value)
rc% = writeIni%(ini$, sSection$, eIncludeGIF$, s$)
s$ = chkToStr$(f!chkIncludeJPG.value)
rc% = writeIni%(ini$, sSection$, eIncludeJPG$, s$)
s$ = chkToStr$(f!chkIncludeBMP.value)
rc% = writeIni%(ini$, sSection$, eIncludeBMP$, s$)
s$ = chkToStr$(f!chkIncludePCX.value)
rc% = writeIni%(ini$, sSection$, eIncludePCX$, s$)
s$ = chkToStr$(f!chkIncludePNG.value)
rc% = writeIni%(ini$, sSection$, eIncludePNG$, s$)

' misc

s$ = chkToStr$(f!chkSortedFileNames.value)
rc% = writeIni%(ini$, sSection$, eSortedFileNames$, s$)
s$ = chkToStr$(f!chkPickAtRandom.value)
rc% = writeIni%(ini$, sSection$, ePickAtRandom$, s$)

s$ = fmtInt$(f!hbarTargetSize.value)
rc% = writeIni%(ini$, sSection$, eTargetSize$, s$)
s$ = fmtInt$(f!hbarAddedMargin.value)
rc% = writeIni%(ini$, sSection$, eAddedMargin$, s$)
s$ = fmtInt$(f!hbarSubstractedMargin.value)
rc% = writeIni%(ini$, sSection$, eSubstractedMargin$, s$)
s$ = chkToStr$(f!chkSkipOutOfRange.value)
rc% = writeIni%(ini$, sSection$, eSkipOutOfRange$, s$)

i% = f!clstColorReduction.ListIndex
s$ = fmtInt$(i%)
rc% = writeIni%(ini$, sSection$, eColorReduction$, s$)
s$ = fmtInt$(f!clstColorReduction.ItemData(i%))
rc% = writeIni%(ini$, sSection$, eColorReductionCode$, s$)

i% = f!clstDither.ListIndex
s$ = fmtInt$(i%)
rc% = writeIni%(ini$, sSection$, eDither$, s$)
s$ = fmtInt$(f!clstDither.ItemData(i%))
rc% = writeIni%(ini$, sSection$, eDitherCode$, s$)

s$ = chkToStr$(f!chkChangeGammaGIF.value)
rc% = writeIni%(ini$, sSection$, eChangeGammaGIF$, s$)
s$ = fmtInt$(f!hbarGammaGIF.value)
rc% = writeIni%(ini$, sSection$, eGammaGIF$, s$)

s$ = chkToStr$(f!chkChangeGammaJPG.value)
rc% = writeIni%(ini$, sSection$, eChangeGammaJPG$, s$)
s$ = fmtInt$(f!hbarGammaJPG.value)
rc% = writeIni%(ini$, sSection$, eGammaJPG$, s$)

s$ = chkToStr$(f!chkChangeGammaPNG.value)
rc% = writeIni%(ini$, sSection$, eChangeGammaPNG$, s$)
s$ = fmtInt$(f!hbarGammaPNG.value)
rc% = writeIni%(ini$, sSection$, eGammaPNG$, s$)

s$ = chkToStr$(f!chkChangeGammaBMP.value)
rc% = writeIni%(ini$, sSection$, eChangeGammaBMP$, s$)
s$ = fmtInt$(f!hbarGammaBMP.value)
rc% = writeIni%(ini$, sSection$, eGammaBMP$, s$)

s$ = chkToStr$(f!chkChangeGammaPCX.value)
rc% = writeIni%(ini$, sSection$, eChangeGammaPCX$, s$)
s$ = fmtInt$(f!hbarGammaPCX.value)
rc% = writeIni%(ini$, sSection$, eGammaPCX$, s$)

' use gAutoPreview updated by pickdir.bas/frm
' instead of unloaded fff!chkAutoPreview.value
s$ = boolToStr$(gAutoPreview%)
rc% = writeIni%(ini$, sSection$, eAutoPreview$, s$)

s$ = chkToStr$(f!chkKilltmpBMP.value)
rc% = writeIni%(ini$, sSection$, eKillTmpBMP$, s$)
s$ = chkToStr$(f!chkWriteBMPpath.value)
rc% = writeIni%(ini$, sSection$, eWriteBMPpath$, s$)

s$ = fmtInt$(f!hbarPersistence.value)
rc% = writeIni%(ini$, sSection$, ePersistence$, s$)

s$ = chkToStr$(f!chkUseDDB.value)
rc% = writeIni%(ini$, sSection$, eUseDDB$, s$)

s$ = fmtInt$(f!hbarPollInterval.value)
rc% = writeIni%(ini$, sSection$, ePollInterval$, s$)

' index is reset if directory is changed
' no longer true : now, it's set to last selected picture

s$ = fmtInt$(gLastIndex%)
rc% = writeIni%(ini$, sSection$, eLastIndex$, s$)

s$ = gLastFileName$
rc% = writeIni%(ini$, sSection$, eLastFileName$, s$)

End Sub

Sub showSetupParms ()
Dim c As Control
Dim s$
Dim crlf$
Dim i%, flag%
Dim c2 As Control

' directory and masks

f!lblDirectory.Alignment = LEFT_JUSTIFY
f!lblDirectory.Caption = LCase$(gDirectory$)

f!lblLastWall.Alignment = LEFT_JUSTIFY
Select Case gLastFileName$
Case ""
    s$ = NOLASTWALL$
Case Else
    s$ = LASTWALL$ + LCase$(gLastFileName$)
End Select
f!lblLastWall.Caption = s$

f!lblLastIndex.Alignment = LEFT_JUSTIFY
Select Case gLastFileName$ ' gLastIndex$ would do too
Case ""
    s$ = NOLASTINDEX$
Case Else
    s$ = "( " + gLastPicInfos$ + LASTINDEX$ + fmtInt$(gLastIndex%) + " )"
End Select
f!lblLastIndex.Caption = s$

f!lblLastUnsupported.Alignment = LEFT_JUSTIFY
Select Case gLastUnsupported$
Case ""
    s$ = NOLASTUNSUPPORTED$
Case Else
    s$ = LASTUNSUPPORTED$ + LCase$(gLastUnsupported$) + " (" + gLastErrorCode$ + ")"
End Select
f!lblLastUnsupported.Caption = s$

f!chkIncludeHidden.value = boolToChk%(gIncludeHidden%)
f!chkIncludeGIF.value = boolToChk%(gIncludeGIF%)
f!chkIncludeJPG.value = boolToChk%(gIncludeJPG%)
f!chkIncludeBMP.value = boolToChk%(gIncludeBMP%)
f!chkIncludePCX.value = boolToChk%(gIncludePCX%)
f!chkIncludePNG.value = boolToChk%(gIncludePNG%)

' misc

f!chkSortedFileNames.value = boolToChk%(gSortedFileNames%)
f!chkPickAtRandom.value = boolToChk%(gPickAtRandom%)

For i% = 1 To 3
    Select Case i%
    Case 1: Set c = f!hbarTargetSize: Set c2 = f!lblTargetSize: flag% = gTargetSize%
    Case 2: Set c = f!hbarAddedMargin: Set c2 = f!lblAddedMargin: flag% = gAddedMargin%
    Case 3: Set c = f!hbarSubstractedMargin: Set c2 = f!lblSubstractedMargin: flag% = gSubstractedMargin%
    End Select
    Select Case i%
    Case 1:
        c.Min = MINTARGETSIZE
        c.Max = MAXTARGETSIZE
        c.SmallChange = SMALLCHANGETARGETSIZE
        c.LargeChange = LARGECHANGETARGETSIZE
    Case 2, 3:
        c.Min = MINMARGIN
        c.Max = MAXMARGIN
        c.SmallChange = SMALLCHANGEMARGIN
        c.LargeChange = LARGECHANGEMARGIN
    End Select
    c.value = flag%
    c2.Alignment = CENTER
    updateValue c, c2
Next
f!chkSkipOutOfRange.value = boolToChk%(gSkipOutOfRange%)

f!lblAbsolute.Alignment = LEFT_JUSTIFY
updateLimits f

Set c = f!clstColorReduction
'c.Sorted = False
'c.Style = dropdown list
c.Clear
c.AddItem "Original unmodified colors"
c.ItemData(c.NewIndex) = IM_NOREDUCTION
c.AddItem "256 colors (optimized palette)"
c.ItemData(c.NewIndex) = IM_REDUCE256
c.AddItem "256 colors (system palette)"
c.ItemData(c.NewIndex) = IM_REDUCE256SYSTEM
c.AddItem ("Grey")
c.ItemData(c.NewIndex) = IM_REDUCEGRAY
c.AddItem ("Black & White")
c.ItemData(c.NewIndex) = IM_REDUCEBW
c.AddItem "16 colors (optimized palette)"
c.ItemData(c.NewIndex) = IM_REDUCE256
c.AddItem "16 colors (system palette)"
c.ItemData(c.NewIndex) = IM_REDUCE256SYSTEM
c.ListIndex = gColorReduction%

Set c = f!clstDither
'c.Sorted = False
'c.Style = dropdown list
c.Clear
c.AddItem "No dithering"
c.ItemData(c.NewIndex) = IM_DITHERNONE
c.AddItem "Bayer"
c.ItemData(c.NewIndex) = IM_DITHERBAYER
c.AddItem "Burkes"
c.ItemData(c.NewIndex) = IM_DITHERBURKES
c.AddItem "Floyd/Steinberg"
c.ItemData(c.NewIndex) = IM_DITHERFLOYD
c.ListIndex = gDither%

s$ = "Gamma"' Gamma when we find out how to save it using accusoft
s$ = "Brightness"
For i% = 1 To 5
    Select Case i% ' yes, we know an array would have been easier
    Case 1: Set c = f!chkChangeGammaGIF: flag% = gChangeGammaGIF%
    Case 2: Set c = f!chkChangeGammaJPG: flag% = gChangeGammaJPG%
    Case 3: Set c = f!chkChangeGammaPNG: flag% = gChangeGammaPNG%
    Case 4: Set c = f!chkChangeGammaBMP: flag% = gChangeGammaBMP%
    Case 5: Set c = f!chkChangeGammaPCX: flag% = gChangeGammaPCX%
    End Select
    c.Caption = s$
    c.value = boolToChk%(flag%)
    Select Case i%
    Case 1: Set c = f!hbarGammaGIF: Set c2 = f!lblGammaGIF: flag% = gGammaGIF%
    Case 2: Set c = f!hbarGammaJPG: Set c2 = f!lblGammaJPG: flag% = gGammaJPG%
    Case 3: Set c = f!hbarGammaPNG: Set c2 = f!lblGammaPNG: flag% = gGammaPNG%
    Case 4: Set c = f!hbarGammaBMP: Set c2 = f!lblGammaBMP: flag% = gGammaBMP%
    Case 5: Set c = f!hbarGammaPCX: Set c2 = f!lblGammaPCX: flag% = gGammaPCX%
    End Select
    c.Min = MINGAMMA
    c.Max = MAXGAMMA
    c.SmallChange = SMALLCHANGEGAMMA
    c.LargeChange = LARGECHANGEGAMMA
    If flag% < MINGAMMA Then flag% = MINGAMMA
    If flag% > MAXGAMMA Then flag% = MAXGAMMA
    c.value = flag%
    c2.Alignment = CENTER
    updateValueGamma c, c2
Next

'fff!chkAutoPreview.Value = boolToChk%(gAutoPreview%)

f!chkKilltmpBMP.value = boolToChk%(gKillTmpBMP%)
f!chkWriteBMPpath.value = boolToChk%(gWriteBMPpath%)

Set c = f!hbarPersistence
c.Min = MINPERSISTENCE
c.Max = MAXPERSISTENCE
c.SmallChange = SMALLCHANGEPERSISTENCE
c.LargeChange = LARGECHANGEPERSISTENCE
c.value = gPersistence%
f!lblPersistence.Alignment = CENTER
updateValue c, f!lblPersistence

f!chkUseDDB.value = boolToChk%(gUseDDB%)

Set c = f!hbarPollInterval
c.Min = MINPOLLINTERVAL
c.Max = MAXPOLLINTERVAL
c.SmallChange = SMALLCHANGEPOLLINTERVAL
c.LargeChange = LARGECHANGEPOLLINTERVAL
c.value = gPollInterval%
f!lblPollInterval.Alignment = CENTER
updateValue c, f!lblPollInterval

f!lblCLI.Alignment = CENTER
s$ = "Command line options are documented the good old DOS (-?) way. ;-)"
f!lblCLI.Caption = s$
End Sub

Sub updateLimits (ego As Form)
Dim s$
' screen dimensions are global as soon as program is run !
' get'em real time
s$ = fmtLimits$(XscreenInPixels%, YscreenInPixels%, ego!hbarTargetSize, ego!hbarSubstractedMargin, ego!hbarAddedMargin)
ego!lblAbsolute.Caption = s$
End Sub

Sub updateValue (bar As Control, lbl As Control)
Dim s$
s$ = fmtInt$(bar.value)
lbl.Caption = s$
End Sub

Sub updateValueGamma (bar As Control, lbl As Control)
Dim s$
's$ = Format$((bar.Value / 100!), "0.00")
s$ = Format$((bar.value), "000")
lbl.Caption = s$
End Sub
