'--------------------------------------------------------------------
' Title       : Q&D Vision Clock mode X
' Author      : PhG
' Overview    : a screen-saver clock
' Notes       : see plotunit which address a silly bug when centering
'               a set of digits !!! I had forgotten to take the blank
'               column at right and the blank row down !!! shame on me !
'
'               darn, basic is definitely NOT modula-2 :-(
'
' Usage       : VCLOCK [options]
'
'--------------------------------------------------------------------

$CPU 80286

$OPTIMIZE SIZE
$COMPILE EXE

$DEBUG MAP OFF
$DEBUG PBDEBUG OFF

$LIB COM        OFF
$LIB CGA        OFF
$LIB EGA        ON
$LIB VGA        OFF
$LIB HERC       OFF
$LIB LPT        OFF
$LIB IPRINT     OFF
$LIB FULLFLOAT  ON

$ERROR BOUNDS   Off
$ERROR NUMERIC  Off
$ERROR OVERFLOW Off
$ERROR STACK    Off

$FLOAT PROCEDURE

$COM    0
$STRING 16
$STACK  8192 ' big stack for big local array in SUB
$SOUND  1

$DIM ARRAY

$DYNAMIC

$OPTION CNTLBREAK ON ' OFF in final EXE

'--------------------------------------------------------------------

DEFINT A-Z
OPTION ARRAY BASE 0
OPTION BINARY BASE 0
'
' %False = 0
' %True = NOT %False

'--------------------------------------------------------------------
' external functions

$LINK 		"QDBOX.PBU"
$INCLUDE 	"QDBOX.DEF"

$LINK 		"MODEX.PBL"
$INCLUDE 	"MODEX.INC"

%Debug = %false ' false in final exe

'--------------------------------------------------------------------
' internal functions

DECLARE SUB GetStrLoc() ' PowerBasic runtime library

'--------------------------------------------------------------------
' error handling

%eNone = 100
%eUsage = 101
%eTooManySame = 102
%eUnknownOpt = 103
%eNeedVGA = 104
%eBadRange = 105
%eDosTooOld = 106
%eBadExeName = 107
%eVertices= 108
%ehhmm = 109
%ePaperInk=110
%eCannotSet = 111

'--------------------------------------------------------------------
' constants

' working modes with pages
' 320x200, 320x400, 360x200, 320x240, 360x240
' 320x240 is 1:1 aspect ratio

%maxX=320-1
%maxY=240-1
%hires=%mode320x240

%minX=0
%minY=0

%page1=0
%page2=1
%PagesVirtual	= 2 ' request only two pages
%xMaxVirtual	= %maxX+1
%yMaxVirtual	= %maxY+1

%text=0
%cga=2 ' 640x200 CGA

%clockDotBlue	= 1
%clockDotRed 	= 2
%clockDotGreen	= 3
%clockDotCyan 	= 4
%clockDotYellow = 5
%clockDotEraser	= 6
%secondDotEraser= 7
%secondDot		= 8
%secondDotBlue 	= %secondDot+6
%secondDotRed  	= %secondDot+0
%secondDotGreen	= %secondDot+2
%secondDotCyan 	= %secondDot+5
%secondDotYellow= %secondDot+3
%secondsNone    = 0
%secondsYes     = 1
%secondsAlt     = 2

%mindisk        =1
%maxdisk        =5

%firstSS	=0 ' valid for 5 minutes interval i.e. colors for 0..30=6 colors
%lastSS		=5
%ss0 		=0
%ss59 		=59

%bestfont	=0
%normalfont	=1
%binfont        =2

%Preset = 0
%Random = 1
%User 	= 2

%Normal 	= 0
%Motion 	= 1
%MotionFull = 2

%soundoff	=0
%soundon	=1

%hhmm=5 ' hh:mm = 5, hh:mm:ss = 8

%MinDosVersion = 310 ' 3.10 or later

%myBLACK = 255

%SpriteWidth	= 6
%SpriteHeight	= 6

%cx=%maxX \ 2
%cy=%maxY \ 2
%radiusSSouter = %cy-%SpriteHeight
%radiusSSinner = %cy-%SpriteHeight-%SpriteHeight-(%SpriteHeight \ 2)

TYPE SpriteType
	SpriteData	AS STRING * 512 ' max width * height
    sWidth 		AS INTEGER ' %spritewidth
    sHeight 	AS INTEGER ' %spriteheight
END TYPE

'--------------------------------------------------------------------
' global variables

SHARED einfo$ ' error info

SHARED vSequence$,vOuterDot$,vInnerDot$,vPaper$,vInk$,vFont$
shared vClockMode$,vBeep$,vMotionSteps$,vDelay$
shared vUseMouse$,vMulti$,vInkHHMM$,vInkSS$
shared vMarkSS$,vInkMarkSS$,vAlternate$

shared viewpage,workpage
shared flagbeep
shared etapes
shared pause

shared Pi#,degToRad#
shared plotunit ' used to correct a silly bug when centering a set of digits !!!

shared radiusseconds,radiusmarks

'--------------------------------------------------------------------

DIM Icon AS SpriteType ' doton
SHARED Icon

DIM Eraser as SpriteType ' dotoff
shared Eraser

DIM EraserSS AS SpriteType
SHARED EraserSS

DIM IconSS(%firstSS:%lastSS) AS SpriteType
SHARED IconSS()

DIM MarkSS AS SpriteType
SHARED MarkSS

%firstVertex=1
%lastVertex=512 ' should be enough!

type VertexType ' coordinate of a dot
	x as integer
    y as integer
end type

' vertex contains coordinates of a dot from (0,0)++
' i.e. gives position of each "*" in shape profile
' will have to convert them later using plotsize for relative screen coors
DIM STATIC Vertex (%FirstVertex:%LastVertex) AS VertexType ' compile time
SHARED Vertex()

%FirstShape = 1
%LastShape = 11 ' 0..9 and ":"

TYPE ShapeInfoType
	offset AS INTEGER ' offset of first dot
    count AS INTEGER ' number of dots
    maxwide AS INTEGER
    maxheight AS INTEGER
END TYPE

'shapeinfo contains infos about a shape
DIM STATIC ShapeInfo (%FirstShape:%LastShape) AS ShapeInfoType ' compile time
SHARED ShapeInfo()

DIM lasttime$(%page1:%page2)
shared lasttime$()

%Origin=0
%Target=1

' points qui se transforment pendant le morphing
DIM STATIC Path(%FirstVertex:%LastVertex,%Origin:%Target) AS VertexType ' compile time
SHARED Path()

'--------------------------------------------------------------------

ProgramName$="Vision Clock (mode X)"
EXEName$="VCLOCK"
Version$="v1.0f"
Copyright$="par PhG"
Banner$=ProgramName$+" "+Version$+" "+Copyright$
credit$ = "(bibliothque Mode X v1.04 mise dans le domaine public par Matt Pritchard)"

'
ON ERROR GOTO Abort

GOTO Start: ' jump to main() ;-)

'--------------------------------------------------------------------

SUB StdOut ( BYVAL Text AS STRING )
! push DS                    ; save DS FOR PowerBASIC
! push WORD Ptr Text         ; push STRING handle ON stack
! CALL GetStrLoc
! jcxz ExitStdOut
! mov  DS, DX
! mov  DX, AX
! mov  AH, &H40              ; DOS WRITE TO file
! mov  BX, 1                 ; file handle 1 is CONS
! INT  &H21
ExitStdOut:
! pop  DS
END SUB

SUB StdOutLn( BYVAL s as string )
CALL StdOut (s + CHR$(13, 10) )
END SUB

Abort:
' call textmode ' should not be necessary
IF ERR = %eUsage THEN
    wi=69
    stdoutln ""
    stdoutln Banner$
    stdoutln ""
    stdoutln credit$
    stdoutln ""
    stdoutln "Syntaxe : "+ExeName$+" [option]..."
    stdoutln "                                                                    par dfaut"
    call dmp(wi,"/F:# Police (0..2)",vFont$)
    CALL Dmp(wi,"/M:# Animation (0=non, 1=oui, 2=OUI)",vClockMode$)
    CALL Dmp(wi,"/B:# Beep (0=non, 1=oui ou sans effet)",vBeep$)
    CALL Dmp(wi,"/N:# Nombre d'tapes dans une animation (2..500)",vMotionSteps$)
    CALL Dmp(wi,"/Z:# Souris (0=non, 1=oui)",vUseMouse$)
    call dmp(wi,"/C:# Secondes multicolores (0=non, 1=oui)",vMulti$)
    call dmp(wi,"/G:# Graduation des secondes (0=non, 1=oui, 2=OUI)",vMarkSS$)
    call dmp(wi,"/H:# Couleur des heures ([0..4]=bleu, rouge, vert, cyan, jaune)",vInkHHMM$)
    call dmp(wi,"/S:# Couleur des secondes ([0..4]=bleu, rouge, vert, cyan, jaune)",vInkSS$)
    call dmp(wi,"/T:# Couleur des graduations ([0..4]=bleu, rouge, vert, cyan, jaune)",vInkMarkSS$)
    call dmp(wi,"/A:# Autres couleurs (0=non, 1=oui)",vAlternate$)
	stdoutln ""
	stdoutln "Les touches + et - changent la figure utilise (option /M:2 requise)."

    END %eUsage-%eNone
END IF
SELECT CASE ERR
CASE %eUsage
    e$="Erreur impossible --  signaler au programmeur"
CASE %eTooManySame
	e$="Au moins une option rpte sans raison"
CASE %eUnknownOpt
	e$="Au moins une option imprvue"
case %eNeedVGA
	e$="Ce programme exige une carte graphique VGA"
case %eBadRange
	e$=einfo$
case %eDosTooOld
	e$="Ce programme exige un DOS version "+einfo$+" ou plus"
case %eBadexeName
	e$=einfo$+" n'est pas le nom original du fichier excutable"
case %eVertices
        e$="Trop de points sont dfinis --  signaler au programmeur"
CASE %ehhmm
	call textmode
    e$="L'cran n'est pas assez large pour hh:mm"
case %epaperink
	e$="Encre et papier doivent diffrer"
case %eCannotSet
	e$="Impossible d'initialiser le mode X"
CASE ELSE
    e$=HEX$(ERADR) ' ERADR is a longint (7fFFffFF)
    e$=MID$("00000000",1,8-LEN(e$))+e$
    e$= "Erreur inattendue #"+MID$(STR$(ERR),2)+"  l'adresse $"+e$
END SELECT
e$=EXEname$+" : "+e$+" !"
stdout e$
END ERR-%eNone

'--------------------------------------------------------------------

FUNCTION IsVGA                'test for EGA
  IF BIT (pbvScrnCard,5) = 0 THEN
  	IsVGA = %False
  ELSE
  	IsVGA = %True
  END IF
END FUNCTION

' *should* test for wide < 2 ! ;-)
SUB Dmp (BYVAL wide,BYVAL s1$,BYVAL s2$)
pad$=STRING$(wide," ")
length=LEN(s1$)
IF length > wide THEN
	s$=LEFT$(s1$,wide-2)+".."
ELSE
	s$=s1$+RIGHT$(pad$,wide-length)
END IF
s$=s$+" | "
s2$=ltrim$(rtrim$(s2$))
s2$=MID$("   ",1,3-LEN(s2$))+s2$
stdoutln s$+s2$ ' do not check if bigger than 80!
END SUB

' returns %True or %False if opt found or not, keep count of opt found
' vardest$ is not changed unless optstr$ found AND param <> ""

FUNCTION ChkOptStr (BYVAL cli$,BYVAL optstr$,BYVAL exactflag,vardest$,count)
var$=""
count=FindOptStr(cli$,optstr$,exactflag,var$)
SELECT CASE count
CASE 0
	ChkOptStr=%False
CASE 1
	if var$="" then
    	ChkOptStr=%False ' do not accept empty string as parameter
    else
		vardest$=var$
		ChkOptStr=%True
    end if
CASE ELSE
	ERROR %eTooManySame
END SELECT
END FUNCTION

SUB ChkRange (BYVAL param$,BYVAL value$,BYVAL minrange,BYVAL maxrange)
v#=VAL(value$)
IF v# < minrange OR v# > maxrange THEN
	range$="["+MID$(STR$(minrange),2)+".."+MID$(STR$(maxrange),2)+"]"
	einfo$="Le paramtre "+param$+" doit appartenir  l'intervalle "+range$
	ERROR %eBadRange
END IF
END SUB

'
SUB TextMode
CALL Set.Video.Mode (3)
SCREEN %cga ' reset width to 80
SCREEN %text
END SUB



sub ViewWork (byval vpage, byval wpage)
CALL Set.Active.Page (wpage)
CALL Set.Display.Page(vpage)
' CALL WaitVGARetrace ' must be AFTER and hopla, no longer flicker! ;-)
end sub

SUB WaitVGARetrace
!	mov dx,&h3DA
l1:
!   in al,dx
!   and al,&h08
!   jnz l1
l2:
!   in al,dx
!   and al,&h08
!   jz  l2
END SUB



'--------------------------------------------------------------------

SUB InitDefault
vSequence$=STR$(%Random)

vOuterDot$="3" ' outer half-width -- should depend upon sprite dimension !!!
vInnerDot$="3"   ' inner half-width -- idem !!!

vPaper$=str$(%c.BLACK)
vInk$="10"
vFont$=str$(%normalfont)
vClockMode$=str$(%MotionFull) ' %Motion wants 30, %motionFull wants 20
vBeep$=str$(%False)
vMotionSteps$=str$(25)
vDelay$="1"
vUseMouse$="1"
vMulti$="0"
vInkHHMM$="1" ' red
vInkSS$="2" ' green
vMarkSS$="0"
vInkMarkSS$="1" ' red
vAlternate$="1"

END SUB



sub SetHires(byval viewpage, byval workpage,byval paper)
if paper = %c.BLACK THEN paper = %MyBLACK
call viewwork(viewpage,workpage)
CALL Clear.VGA.Screen (paper)
end sub

sub InitIcon (BYVAL numicon, byval secondDotIndex,byval alternate)
s$=GetSpriteData$(numicon,alternate)
if numicon < %secondDotEraser then
	Icon.SpriteData$=s$
	Icon.sWidth=%spritewidth ' useless
	Icon.sHeight=%spriteheight
else
	IconSS(secondDotIndex).SpriteData$=s$
	IconSS(secondDotIndex).sWidth=%spritewidth ' useless
	IconSS(secondDotIndex).sHeight=%spriteheight
END if
end sub


' create a shape as an eraser with screen already blanked
sub InitEraser (byval numicon,byval alternate)
s$=GetSpriteData$(numicon,alternate)
SELECT CASE numicon
CASE %clockDotEraser
	Eraser.SpriteData$=s$
	Eraser.sWidth=%spritewidth ' useless
	Eraser.sHeight=%spriteheight
case %secondDotEraser
	EraserSS.SpriteData$=s$
	EraserSS.sWidth=%spritewidth ' useless
	EraserSS.sHeight=%spriteheight
END SELECT
end sub

sub InitMarkSS (BYVAL numicon,byval alternate)
s$=GetSpriteData$(numicon, alternate)
MarkSS.SpriteData$=s$
MarkSS.sWidth=%spritewidth ' useless
MarkSS.sHeight=%spriteheight
end sub


'--------------------------------------------------------------------
' [0..9] and ":" characters (ASCII order)

SUB InitShapes(byval sequencetype,byval fontnum)
' store vertices temporiraly here before we modify the plotting order
DIM DYNAMIC TmpVertex (%FirstVertex:%LastVertex) AS VertexType ' compile time
LOCAL TmpVertex()
select case fontnum
case %bestfont
	RESTORE BestFont
case %normalfont
	restore Normalfont
case %binfont
        restore Binfont
end select
endOfShape$="$"
RANDOMIZE TIMER ' in case %Random is selected
currvertex=%FirstVertex
FOR currshape=%FirstShape TO %LastShape
    startofdef=currvertex
    maxWidth=0
    y=0
	DO
		READ s$
        IF s$=EndOfShape$ THEN EXIT LOOP
        x=0
        FOR ndx=1 TO len(s$)
        	IF MID$(s$,ndx,1)<>" " THEN
       			Vertex(currvertex).x=x
                Vertex(currvertex).y=y
                INCR currvertex
                IF currvertex > %LastVertex THEN ERROR %eVertices
            END IF
            INCR x
        NEXT
        IF x > maxWidth THEN maxWidth=x
        INCR y
	LOOP
    ' now we have finished reading shape definition so actualize infos
    ShapeInfo(currshape).offset=startofdef
    count=currvertex-startofdef
	ShapeInfo(currshape).count=count
    ShapeInfo(currshape).maxwide=maxWidth
    ShapeInfo(currshape).maxheight=y
    '
    ' we now have each vertex making shape stored as defined
    ' we can build new order of sequence and reset Vertex accordingly
    '
    ' 8-ung! this trick limits the number of possible dots in a shape!!!
    ' but as our digit shapes are not too complex and in [1..255] ;-)
    '
    s$=""
    FOR k = 1 TO count
    	thisdot=k-1 ' important!
    	READ position ' from 1..count
    	SELECT CASE Sequencetype
    	CASE %Preset ' let them as they have been defined
        	TmpVertex(k)=Vertex(startofdef+thisdot)
	    CASE %Random ' randomly change order of vertex
            DO
            	' int((upper-lower+1)*rnd+lower)
				newpos=INT((count-1+1)*RND+1) ' [1..num] -> chr(1)..chr$(255)
				newpos=INT((count-1+1)*RND+1)
				newpos=INT((count-1+1)*RND+1)
            LOOP UNTIL INSTR(s$,CHR$(newpos)) = 0 ' find a NEW position
            s$=s$+CHR$(newpos)
            TmpVertex(newpos)=Vertex(startofdef+thisdot)
	    CASE %User ' use data to change order of points
        	TmpVertex(position)=Vertex(startofdef+thisdot)
		END SELECT
    NEXT
    ' now we can change order of sequence in array of positions
	FOR k = 1 TO count
    	thisdot=k-1
    	Vertex(startofdef+thisdot)=TmpVertex(k)
    NEXT
NEXT
' here we should change each coorset to screen resolution using plotsize

' 0..9 should have the SAME width & height, even though routines is general
BestFont:
DATA " ***  "
DATA "*   * "
DATA "*   * "
DATA "*   * "
DATA "*   * "
DATA "*   * "
DATA " ***  "
DATA "      "
DATA "$"
DATA 16,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1
DATA "  *   "
DATA "  *   "
DATA "  *   "
DATA "  *   "
DATA "  *   "
DATA "  *   "
DATA "  *   "
DATA "      "
DATA "$"
DATA 7,6,5,4,3,2,1
DATA " ***  "
DATA "    * "
DATA "    * "
DATA " ***  "
DATA "*     "
DATA "*     "
DATA " ***  "
DATA "      "
DATA "$"
DATA 13,12,11,10,9,8,7,6,5,4,3,2,1
DATA " ***  "
DATA "    * "
DATA "    * "
DATA " ***  "
DATA "    * "
DATA "    * "
DATA " ***  "
DATA "      "
DATA "$"
DATA 13,12,11,10,9,8,7,6,5,4,3,2,1
DATA "*   * "
DATA "*   * "
DATA "*   * "
DATA " **** "
DATA "    * "
DATA "    * "
DATA "    * "
DATA "      "
DATA "$"
DATA 13,12,11,10,9,8,7,6,5,4,3,2,1
DATA " ***  "
DATA "*     "
DATA "*     "
DATA " ***  "
DATA "    * "
DATA "    * "
DATA " ***  "
DATA "      "
DATA "$"
DATA 13,12,11,10,9,8,7,6,5,4,3,2,1
DATA " ***  "
DATA "*     "
DATA "*     "
DATA "****  "
DATA "*   * "
DATA "*   * "
DATA " ***  "
DATA "      "
DATA "$"
DATA 16,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1
DATA "****  "
DATA "    * "
DATA "    * "
DATA "    * "
DATA "    * "
DATA "    * "
DATA "    * "
DATA "      "
DATA "$"
DATA 10,9,8,7,6,5,4,3,2,1
DATA " ***  "
DATA "*   * "
DATA "*   * "
DATA " ***  "
DATA "*   * "
DATA "*   * "
DATA " ***  "
DATA "      "
DATA "$"
DATA 17,16,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1
DATA " ***  "
DATA "*   * "
DATA "*   * "
DATA " **** "
DATA "    * "
DATA "    * "
DATA " ***  "
DATA "      "
DATA "$"
DATA 16,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1
DATA "   "
DATA "   "
DATA "*  "
DATA "   "
DATA "*  "
DATA "   "
DATA "   "
DATA "   "
DATA "$"
DATA 2,1

' [0..9] and ":" characters (ASCII order) higher font here
normalfont:
DATA " ***  "
DATA "*   * "
DATA "*   * "
DATA "*   * "
DATA "*   * "
DATA "*   * "
DATA "*   * "
DATA "*   * "
DATA " ***  "
DATA "      "
DATA "$"
DATA 20,19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1
DATA "  *   "
DATA "  *   "
DATA "  *   "
DATA "  *   "
DATA "  *   "
DATA "  *   "
DATA "  *   "
DATA "  *   "
DATA "  *   "
DATA "      "
DATA "$"
DATA 9,8,7,6,5,4,3,2,1
DATA " ***  "
DATA "    * "
DATA "    * "
DATA "    * "
DATA " ***  "
DATA "*     "
DATA "*     "
DATA "*     "
DATA " ***  "
DATA "      "
DATA "$"
DATA 15,14,13,12,11,10,9,8,7,6,5,4,3,2,1
DATA " ***  "
DATA "    * "
DATA "    * "
DATA "    * "
DATA " ***  "
DATA "    * "
DATA "    * "
DATA "    * "
DATA " ***  "
DATA "      "
DATA "$"
DATA 15,14,13,12,11,10,9,8,7,6,5,4,3,2,1
DATA "*   * "
DATA "*   * "
DATA "*   * "
DATA "*   * "
DATA " **** "
DATA "    * "
DATA "    * "
DATA "    * "
DATA "    * "
DATA "      "
DATA "$"
DATA 16,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1
DATA " ***  "
DATA "*     "
DATA "*     "
DATA "*     "
DATA " ***  "
DATA "    * "
DATA "    * "
DATA "    * "
DATA " ***  "
DATA "      "
DATA "$"
DATA 15,14,13,12,11,10,9,8,7,6,5,4,3,2,1
DATA " ***  "
DATA "*     "
DATA "*     "
DATA "*     "
DATA "****  "
DATA "*   * "
DATA "*   * "
DATA "*   * "
DATA " ***  "
DATA "      "
DATA "$"
DATA 19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1
DATA "****  "
DATA "    * "
DATA "    * "
DATA "    * "
DATA "    * "
DATA "    * "
DATA "    * "
DATA "    * "
DATA "    * "
DATA "      "
DATA "$"
DATA 12,11,10,9,8,7,6,5,4,3,2,1
DATA " ***  "
DATA "*   * "
DATA "*   * "
DATA "*   * "
DATA " ***  "
DATA "*   * "
DATA "*   * "
DATA "*   * "
DATA " ***  "
DATA "      "
DATA "$"
DATA 21,20,19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1
DATA " ***  "
DATA "*   * "
DATA "*   * "
DATA "*   * "
DATA " **** "
DATA "    * "
DATA "    * "
DATA "    * "
DATA " ***  "
DATA "      "
DATA "$"
DATA 19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1
DATA "  "
DATA "  "
DATA "  "
DATA "* "
DATA "  "
DATA "* "
DATA "  "
DATA "  "
DATA "  "
DATA "  "
DATA "$"
DATA 2,1

binfont:
' note chardef must contain at least one dot
' 0
data "****"
data "    "
data "    "
data "    "
data "    "
data "    "
data "    "
data "    "
data "    "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
data "    "
data "****"
DATA "$"
DATA 1,2,3,4,5,6,7,8
' 1
data "****"
data "    "
data "    "
data "    "
data "    "
data "    "
data "    "
data "    "
data "    "
DATA "    "
DATA "    "
DATA " ** "
DATA " ** "
data "    "
data "****"
DATA "$"
DATA 1,2,3,4,5,6,7,8
data 9,10,11,12
' 2
data "****"
data "    "
data "    "
data "    "
data "    "
data "    "
data "    "
data "    "
data " ** "
DATA " ** "
DATA "    "
DATA "    "
DATA "    "
data "    "
data "****"
DATA "$"
DATA 1,2,3,4,5,6,7,8
data 9,10,11,12
' 3
data "****"
data "    "
data "    "
data "    "
data "    "
data "    "
data "    "
data "    "
data " ** "
DATA " ** "
DATA "    "
DATA " ** "
DATA " ** "
data "    "
data "****"
DATA "$"
DATA 1,2,3,4,5,6,7,8
data 9,10,11,12
data 13,14,15,16
' 4
data "****"
data "    "
data "    "
data "    "
data "    "
data " ** "
data " ** "
data "    "
data "    "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
data "    "
data "****"
DATA "$"
DATA 1,2,3,4,5,6,7,8
data 9,10,11,12
' 5
data "****"
data "    "
data "    "
data "    "
data "    "
data " ** "
data " ** "
data "    "
data "    "
DATA "    "
DATA "    "
DATA " ** "
DATA " ** "
data "    "
data "****"
DATA "$"
DATA 1,2,3,4,5,6,7,8
data 9,10,11,12
data 13,14,15,16
' 6
data "****"
data "    "
data "    "
data "    "
data "    "
data " ** "
data " ** "
data "    "
data " ** "
DATA " ** "
DATA "    "
DATA "    "
DATA "    "
data "    "
data "****"
DATA "$"
DATA 1,2,3,4,5,6,7,8
data 9,10,11,12
data 13,14,15,16
' 7
data "****"
data "    "
data "    "
data "    "
data "    "
data " ** "
data " ** "
data "    "
data " ** "
DATA " ** "
DATA "    "
DATA " ** "
DATA " ** "
data "    "
data "****"
DATA "$"
DATA 1,2,3,4,5,6,7,8
data 9,10,11,12
data 13,14,15,16
data 17,18,19,20
' 8
data "****"
data "    "
data " ** "
data " ** "
data "    "
data "    "
data "    "
data "    "
data "    "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
data "    "
data "****"
DATA "$"
DATA 1,2,3,4,5,6,7,8
data 9,10,11,12
' 9
data "****"
data "    "
data " ** "
data " ** "
data "    "
data "    "
data "    "
data "    "
data "    "
DATA "    "
DATA "    "
DATA " ** "
DATA " ** "
data "    "
data "****"
DATA "$"
DATA 1,2,3,4,5,6,7,8
data 9,10,11,12
data 13,14,15,16

' :
data "*  *"
data "    "
data "    "
data "    "
data "    "
data "    "
data "    "
data "    "
data "    "
DATA "    "
DATA "    "
DATA "    "
DATA "    "
data "    "
data "*  *"
DATA "$"
DATA 1,2,3,4


end sub

'--------------------------------------------------------------------

sub ScaleShapes (byval plotsize)
scale = plotsize*2 +1 ' radius * 2 !!! vclock : add ONE pixel here !!!
plotunit=scale
FOR currshape=%FirstShape TO %LastShape
    startofdef=ShapeInfo(currshape).offset
	count=ShapeInfo(currshape).count
    for k = 1 to count
    	currvertex=startofdef+k-1
    	x=vertex(currvertex).x
        y=vertex(currvertex).y
		vertex(currvertex).x=x*scale
        vertex(currvertex).y=y*scale
    next
    maxwide=ShapeInfo(currshape).maxwide
	maxheight=ShapeInfo(currshape).maxheight
    shapeinfo(currshape).maxwide=maxwide*scale
    shapeinfo(currshape).maxheight=maxheight*scale
next
end sub

'--------------------------------------------------------------------
' assume all digits are SAME SIZE!

' return rightest position(s) ; vclock redresses a previous silly bug
' i.e. not taking into account offsets added to width of char !!!
sub Chkdisplay(posright,postop)
chiffre=shapeinfo(%FirstShape).maxwide ' 0..9
deuxpoints=shapeinfo(%LastShape).maxwide ' :
oneline=shapeinfo(%FirstShape).maxheight
hhmm=chiffre*4+deuxpoints
limx=%maxX+1 ' because width is from 1
limy=%maxY+1
' IF oneline > limy THEN ERROR %eoneline
postop=(limy-oneline) \ 2 + plotunit
posright=(limx-hhmm) \ 2 + hhmm + plotunit ' remember we draw backwards !!!
end sub

'--------------------------------------------------------------------

sub flushkeyboard
do until inkey$ = ""
loop
end sub

'--------------------------------------------------------------------

function getshapenumber (byval c$)
p=INSTR("0123456789:",c$) ' 1..lastshape
getshapenumber=p-1+%firstshape
end function

'--------------------------------------------------------------------

' plot digit at coordinates fromx,fromy
SUB PlotShapexor(byval digit,byval fromx,byval fromy,byval opcode)
origin=shapeinfo(digit).offset
count =shapeinfo(digit).count
FOR k = 1 to count
	currdot=k-1
	wleft=Vertex(origin+currdot).x+fromx
	wtop=vertex(origin+currdot).y+fromy
    select case opcode
    case 0
    	CALL draw.Bitmap ( Eraser, wleft, wtop, %SpriteWidth,%SpriteHeight )
    case 1
    	CALL tdraw.Bitmap ( Icon, wleft, wtop, %SpriteWidth,%SpriteHeight )
    end select
NEXT
END SUB

'--------------------------------------------------------------------

sub InitFix (byval now$,byval posright,byval postop)
CALL InitDrawStr(now$,1,%hhmm,posright,postop) ' hh:mm:ss=8, now 5
END sub

SUB InitDrawStr(byval now$,byval first, byval last,byval fromx, byval fromy)
FOR n = last TO first STEP -1 ' <<
	c$=mid$(now$,n,1)
    digit=getshapenumber(c$)
    maxwidth=shapeinfo(digit).maxwide
   	DECR fromx,maxwidth ' <<
    CALL PlotShapexor(digit,fromx,fromy,1) ' <-- always a first DRAW here so...
NEXT
END SUB

'--------------------------------------------------------------------
' update only normal clock (without motion)

sub updateFix (byval new$,byval old$,byval posright,byval postop,byval multicolor,byval marks)
CALL DrawStr(new$,old$,1,%hhmm,posright,postop) ' hh:mm:ss=8, now 5
call showSeconds(new$,%cx,%cy,radiusseconds,radiusmarks,60,multicolor,marks)
END sub

SUB DrawStr(byval new$,byval old$,byval first, byval last,byval fromx, byval fromy)
	FOR n = last TO first STEP -1 ' <<
		c$=mid$(old$,n,1)
        olddigit=getshapenumber(c$)
		c$=mid$(new$,n,1)
        digit=getshapenumber(c$)
    	maxwidth=shapeinfo(digit).maxwide
    	DECR fromx,maxwidth ' << update here!!!
        IF digit<>olddigit THEN
        	' erase old on workpage
            CALL Plotshapexor(olddigit,fromx,fromy,0)
            ' draw new on workpage
			CALL Plotshapexor(digit,fromx,fromy,1)
        END IF
	NEXT
END SUB

'--------------------------------------------------------------------

' build list of vertices stored in Path, while morphing, returns this #
function buildMorphState (byval sourceshape, byval targetshape)
ptrSource =   ShapeInfo(sourceshape).offset
countSource = ShapeInfo(sourceshape).count
ptrTarget=    ShapeInfo(targetshape).offset
countTarget = ShapeInfo(targetshape).count
nVertex=max%(countsource,counttarget) ' number of vertices while morphing
zx2=nVertex
zy2=    min%(countSource,countTarget)
deltax = zx2 - 1
deltay = zy2 - 1
zd = (2 * deltay) - deltax
dinc1 = deltay * 2
dinc2 = (deltay - deltax) * 2
IF countSource < countTarget THEN
' use bresenham algorithm as if from 1,1 to big,small
	FOR p = %firstvertex TO nVertex
        Path(p,%Origin)=Vertex(ptrSource)
    	Path(p,%Target)=vertex(ptrTarget)
	    IF zd < 0 THEN
       		zd = zd + dinc1
		ELSE
       		zd = zd + dinc2
      		INCR ptrsource
		END IF
        INCR ptrTarget
	NEXT
ELSE
	FOR p = %firstvertex TO nVertex
        Path(p,%Origin)=vertex(ptrsource)
   		Path(p,%Target)=vertex(ptrtarget)
	    IF zd < 0 THEN
       		zd = zd + dinc1
		ELSE
       		zd = zd + dinc2
       		INCR ptrtarget
		END IF
        INCR ptrsource
	NEXT
END IF
buildmorphstate=nvertex
end function

'--------------------------------------------------------------------
' plot digit at coordinates fromx,fromy
SUB PlotState(byval digit,byval fromx,byval fromy,byval here, byval vertices, byval operation)
FOR k = %firstvertex to vertices
	wleft1=Path(k,%Origin).x
	wtop1=Path(k,%Origin).y
	wleft2=Path(k,%Target).x
    wtop2=Path(k,%Target).y
    deltax=wleft2-wleft1
    deltay=wtop2-wtop1
	wleft=wleft1+deltax*here/etapes ' BERK algorithm !!! ;-)
	wtop=wtop1+deltay*here/etapes ' must perform 0..etapes
    wleft=wleft+fromx
    wtop=wtop+fromy
    if operation = 0 then ' erase
    	CALL draw.Bitmap ( Eraser, wleft, wtop, %SpriteWidth,%SpriteHeight )
    else ' set
	    CALL tdraw.Bitmap ( Icon, wleft, wtop, %SpriteWidth,%SpriteHeight )
    end if
NEXT
END SUB

'--------------------------------------------------------------------

' program code begins here : main() ;-)

Start:
if isVGA = %False then error %eNeedVGA
einfo$=MID$(STR$(%MinDosVersion \ 100),2)+"."+MID$(STR$(%MinDosVersion MOD 100),2)
IF DosVersion < %MinDosVersion THEN ERROR %eDosTooOld
exepath$= GetArg0$
exepath$= Upper$(exepath$)
CALL SplitPath(exepath$,currunit$,currpath$,currfile$)
CALL SplitName(currfile$,filename$,ext$)
einfo$=filename$+".EXE"
IF filename$ <> ExeName$ THEN ERROR %eBadExeName

' now check command line for help

CALL InitDefault ' do it NOW!

cli$=COMMAND$
foundSOSarg=FindArg(cli$,"?|H|HELP|SOS|AIDE",%False)
foundSOSopt=FindOpt(cli$,"?|HELP|SOS|AIDE",%False) ' /H:# forces /H removal
SELECT CASE (foundSOSarg+foundSOSopt)
CASE 0
	' no help call
CASE 1
	ERROR %eUsage
CASE ELSE
	ERROR %eTooManySame
END SELECT

' check command line for options

if Chkoptstr(cli$,"F|FONT",%false,v$,n11)=%True then vFont$=v$
if ChkOptStr(cli$,"M|MOVE",%False,v$,n7)=%True THEN vClockMode$=v$
if ChkOptStr(cli$,"B|BEEP",%False,v$,n8)=%True THEN vBeep$=v$
if ChkOptStr(cli$,"N|STEPS",%False,v$,n9)=%True THEN vMotionSteps$=v$
if ChkOptStr(cli$,"Z|MOUSE",%False,v$,n12)=%True THEN vUseMouse$=v$
if ChkOptStr(cli$,"C|COLOR|MULTI",%false,v$,n13)=%True THEN vMulti$=v$
if ChkOptStr(cli$,"H|HHMM",%false,v$,n14)=%True THEN vInkHHMM$=v$
if ChkOptStr(cli$,"S|SS",%false,v$,n15)=%True THEN vInkSS$=v$
if ChkOptStr(cli$,"G|MARKS",%false,v$,n1)=%True THEN vMarkSS$=v$
if ChkOptStr(cli$,"T|DASHES",%false,v$,n2)=%True THEN vInkMarkSS$=v$
if ChkOptStr(cli$,"A|ALTERNATE",%false,v$,n99)=%true then vAlternate$=v$

' check for unknown commands/options on command line

optcount=n7+n8+n9+n11+n12+n13+n14+n15+n1+n2+n99
IF optcount <> ArgC(cli$) THEN ERROR %eUnknownOpt

' perform some checks

call ChkRange ("/O",vSequence$,%preset,%random) ' was %user but not useful
CALL ChkRange ("/W",vOuterDot$,2,22)
call ChkRange ("/R",vInnerDot$,2,22)
CALL ChkRange ("/P",vPaper$,0,15)
call ChkRange ("/I",vInk$,0,15)
call chkrange ("/F",vFont$,%bestfont,%binfont)
CALL ChkRange ("/M",vClockMode$,%normal,%motionFull)
call ChkRange ("/B",vBeep$,%soundoff,%soundon)
CALL ChkRange ("/N",vMotionSteps$,2,500)
call ChkRange ("/D",vDelay$,1,999)
call ChkRange ("/Z",vUseMouse$,0,1)
call ChkRange ("/C",vMulti$,0,1)
call ChkRange ("/H",vInkHHMM$,0,4)
call ChkRange ("/S",vInkSS$,0,4)
call ChkRange ("/G",vMarkSS$,0,2)
call ChkRange ("/T",vInkMarkSS$,0,4)
call ChkRange ("/A",vAlternate$,0,1)

ink=val(vink$)
paper=val(vpaper$)
if ink=paper then error %ePaperInk
fontnum=val(vfont$)
plotsize=VAL(vOuterDot$)
radius=VAL(vInnerDot$)
sequencetype=val(vSequence$)
clockmode=val(vClockmode$)
flagbeep=val(vbeep$)
etapes=val(vmotionsteps$)
pause=val(vdelay$) / 1000

i=VAL(vUseMouse$)
SELECT CASE i
CASE 0
	useMouse=%False
CASE 1
	useMouse=%True
END SELECT

i=VAL(vMulti$)
SELECT CASE i
CASE 0
	MultiColor=%False
CASE 1
	MultiColor=%True
END SELECT

i=VAL(vAlternate$)
SELECT CASE i
CASE 0
	alternate=%False
CASE 1
	alternate=%True
END SELECT

inkSS=val(vInkSS$)

IF Set.VGA.ModeX%(%hires,%xMaxVirtual,%yMaxVirtual,%PagesVirtual) = 0 THEN
	ERROR %eCannotSet
END IF

' weird : reading %c.black does not work so use force kludge
CALL SET.DAC.REGISTER (%MyBLACK, 0,0,0) ' force 0,0,0 use this (c.black is c.nil)

call initTrigo

call SetHires(%page1,%page1,paper) ' clear screen 1
call SetHires(%page1,%page2,paper) ' clear screen 2

call InitEraser(%clockDotEraser,alternate)
call initEraser(%secondDotEraser,alternate)

i=val(vInkHHMM$)
select case i
case 0
	numicon=%ClockDotBlue
case 1
	numicon=%ClockDotRed
case 2
	numicon=%ClockDotGreen
case 3
	numicon=%ClockDotCyan
case 4
	numicon=%ClockDotYellow
end select
call InitIcon  (numicon,0,alternate)

if MultiColor=%true then
	for i = %firstSS to %lastSS
		call InitIcon(%secondDot+i,i,alternate) ' #+[0..5]
	next
else
    select case val(vInkSS$)
    case 0
    	i=%secondDotBlue
    case 1
    	i=%secondDotRed
    case 2
    	i=%secondDotGreen
    case 3
    	i=%secondDotCyan
    case 4
    	i=%secondDotYellow
    end select
    call InitIcon(i,%firstSS,alternate)
end if

i=VAL(vMarkSS$)
SELECT CASE i
CASE 0
	flagMarkSS=%secondsNone
    radiusseconds=%radiusSSouter
    radiusmarks  =%radiusSSouter
CASE 1
	flagMarkSS=%secondsYes
    radiusseconds=%radiusSSouter
    radiusmarks  =%radiusSSouter
case 2
	flagMarkSS=%secondsAlt
    radiusseconds=%radiusSSinner
    radiusmarks  =%radiusSSouter
END SELECT

i=val(vInkMarkSS$)
select case i
case 0
	i=%secondDotBlue ' seconds mark, which will be overwritten as times goes by
case 1
	i=%secondDotRed
case 2
	i=%secondDotGreen
case 3
	i=%secondDotCyan
case 4
	i=%secondDotYellow
end select
call initMarkSS(i,alternate)


call SetHires(%page1,%page2,paper) ' clear screen 2 again
call InitShapes(sequencetype,fontnum)
CALL ScaleShapes(plotsize)
call Chkdisplay(posright,postop)
call FlushKeyboard

' init pages

viewpage=%page1
workpage=%page2
call viewwork(viewpage,workpage)

' draw current time on both pages to begin in a known state

currtime$=time$
lasttime$(%page1)=currtime$
lasttime$(%page2)=currtime$
previoustime$=currtime$ ' for animation
' display on hidden page
call showSeconds(currtime$,%cx,%cy,radiusseconds,radiusmarks,60,Multicolor,flagMarkSS)
call initfix (currtime$,posright,postop)
swap viewpage,workpage ' toggle pages now
' show updated page
call viewwork(viewpage,workpage)
' now display on newly hidden page too
call showSeconds(currtime$,%cx,%cy,radiusseconds,radiusmarks,60,MultiColor,flagMarkSS)
call initfix (currtime$,posright,postop)
' check if mouse

IF useMouse = %True THEN
	flagMouse=MouseHere
END IF

' update display now

do
	select case ClockMode
    case %normal
    	currtime$=TIME$
        if currtime$ <> lasttime$(viewpage) then
        	old$=lasttime$(workpage) ' get time on hidden page
			call updatefix (currtime$,old$,posright,postop,multicolor,flagMarkSS)
            lasttime$(workpage)=currtime$ ' keep time just written on workpage
	        swap viewpage,workpage ' toggle pages now
	    	call viewwork(viewpage,workpage) ' show updated page
			IF flagBeep=%soundon THEN SOUND 444,0.02
        end if
    case %motion
    	currtime$=TIME$
        if currtime$ <> previoustime$ then
            ' perform the page flipping in routines thanks to global vars
			call updatemov (currtime$,previoustime$,posright,postop,multicolor,flagMarkSS)
			previoustime$=currtime$ ' keep time just written on workpage
            ' delay pause ' wait a little after animation
            call newpaths(sequencetype) ' // v1.0h
        end if
	case %motionFull
    	currtime$=TIME$
        if currtime$ <> previoustime$ then
            ' perform the page flipping in routines thanks to global vars
			call updatemovFull (currtime$,previoustime$,posright,postop,multicolor,flagMarkSS)
			previoustime$=currtime$ ' keep time just written on workpage
            ' delay pause ' wait a little after animation
            call newpaths(sequencetype) ' // v1.0h
        end if
	end select

    IF instat THEN
        ch$=inkey$
        select case ch$
        case "+" , chr$(9) ' tab too
            if clockmode = %motionfull then
				incr numicon
            	if numicon > %maxdisk then numicon=%mindisk
				call InitIcon(numicon,0,alternate)
            end if
            ' //FIXME full redraw needed for other modes !
        case "-"
            if clockmode = %motionfull then
            	if numicon > %mindisk then
            		decr numicon
            	else
            		numicon = %maxdisk
	            end if
				call InitIcon(numicon,0,alternate)
        	end if
            ' //FIXME full redraw needed for other modes !
        case else
    		EXIT LOOP
        end select
    end if

    IF ( (useMouse=%True) AND (flagMouse = %True) ) THEN
        IF MouseButtonClicked=%True THEN EXIT LOOP
    END IF

loop
call SetHires(%page1,%page1,paper) ' clear screen 1
CALL TextMode
END %eNone-%eNone

sub updateMov (byval new$,byval old$,byval posright,byval postop,byval multicolor,byval marks)
' try and increase speed when simultaneous moves?
realetapes=etapes
mismatch=0
for i = 1 to len(new$)
	if mid$(new$,i,1) <> mid$(old$,i,1) then incr mismatch
next
' etapes=etapes \ mismatch ' reduce tempo when several dots
for currstep=1 to etapes+1 ' take care of overhead
	call showSeconds(new$,%cx,%cy,radiusseconds,radiusmarks,60,multicolor,marks) ' else flicker !
	CALL DrawStrMov(new$,old$,1,%hhmm,posright,postop,currstep) ' hh:mm:ss=8, now 5
	swap viewpage,workpage ' toggle pages now
	call viewwork(viewpage,workpage) ' show updated page
    ' delay 0.01 to try and avoid flickering ? according to etapes ?
next
etapes=realetapes
END sub

'--------------------------------------------------------------------
'
SUB DrawStrMov(byval new$,byval old$,byval first, byval last,byval fromx, byval fromy, byval currstep)
FOR n = last TO first STEP -1 ' <<
	c$=mid$(old$,n,1)
    olddigit=getshapenumber(c$)
	c$=mid$(new$,n,1)
    digit=getshapenumber(c$)
   	maxwidth=shapeinfo(digit).maxwide
   	DECR fromx,maxwidth ' << update here!!!
    IF digit<>olddigit THEN
       	' build polygon while morphing, return # of vertices stored in Path
		vertices=buildMorphState(olddigit,digit)
        select case currstep
        case 1
	        ' we erase previous number
    	    CALL PlotState(olddigit,fromx,fromy,currstep-1,vertices,0) ' erase source
        	' and set currstep 1
	       	CALL PlotState(digit,fromx,fromy,currstep,vertices,1)
        case (etapes+1)
	        ' we erase previous number
    	    CALL PlotState(olddigit,fromx,fromy,currstep-2,vertices,0)
        	' draw new on workpage at currstep
       		CALL PlotState(digit,fromx,fromy,currstep-1,vertices,1) ' draw target
        case else
	       	' erase old on workpage
    	    ' we erase previous previous drawn page
        	CALL PlotState(olddigit,fromx,fromy,currstep-2,vertices,0)
        	' draw new on workpage at currstep
       		CALL PlotState(digit,fromx,fromy,currstep,vertices,1)
        end select
    END IF
NEXT
END SUB

'--------------------------------------------------------------------

FUNCTION GetSpriteColor(BYVAL c$)
SELECT CASE c$
CASE "."
	c=%nil ' 0 is transparent AND black!!!
CASE " "
	c=%MyBLACK ' was %c.BLACK
CASE "b"
	c=%c.BLUE
CASE "g"
	c=%c.GREEN
CASE "c"
	c=%c.CYAN
CASE "r"
	c=%c.RED
CASE "p"
	c=%c.PURPLE
CASE "y"
	c=%c.BROWN
CASE "w"
	c=%c.WHITE
CASE "+"
	c=%c.GREY
CASE "B"
	c=%c.bBLUE
CASE "G"
	c=%c.bGREEN
CASE "C"
	c=%c.bCYAN
CASE "R"
	c=%c.bRED
CASE "P"
	c=%c.bPURPLE
CASE "Y"
	c=%c.YELLOW
CASE "W"
	c=%c.bWHITE
CASE "*"
	c=%c.BRIGHT
CASE ELSE
	c=%nil
END SELECT
GetSpriteColor=c
END FUNCTION

' n=1.. return $ if no data
FUNCTION GetSpriteData$ (BYVAL n, byval alternate)
DIM Grid(1:%SpriteWidth,1:%SpriteHeight)
select case alternate
case %false
	RESTORE SpriteData
case %true
	restore SpriteDataAlt
end select
i=0
DO
	FOR y=1 TO %SpriteHeight
		READ s$
    	FOR x = 1 TO %SpriteWidth
			c$=MID$(s$,x,1)
        	Grid(x,y)=GetSpriteColor(c$)
    	NEXT
	NEXT
	s$=STRING$(%SpriteWidth*%SpriteHeight,%nil)
	ndx=1
	FOR y=1 TO %SpriteHeight
    	FOR x = 1 TO %SpriteWidth
			MID$(s$,ndx,1)=CHR$(Grid(x,y))
			INCR ndx
    	NEXT
	NEXT
	INCR i
	IF i=n THEN EXIT LOOP
	READ s$
LOOP UNTIL s$="$"
GetSpriteData$=s$

' .=transparent
'  =black b=blue g=green r=red p=purple y=brown w=white +=grey
'         B      G       R     P        Y       W       *

SpriteData:
' dotclock=1 best with blue hue
' 6 * 6  .=color 0 for mask
DATA ".wwww." ' 1
DATA "wBbbWw"
DATA "wBBbbw"
DATA "wBBBbw"
DATA "wBBBBw"
DATA ".wwww."
DATA "*"
DATA ".rrrr." ' 2
DATA "rrRRWr"
DATA "rRRRRr"
DATA "rRRRRr"
DATA "rrRRrr"
DATA ".rrrr."
DATA "*"
DATA ".gggg." ' 3
DATA "ggGGWg"
DATA "gGGGGg"
DATA "gGGGGg"
DATA "ggGGgg"
DATA ".gggg."
DATA "*"
DATA ".cccc." ' 4
DATA "ccCCWc"
DATA "cCCCCc"
DATA "cCCCCc"
DATA "ccCCcc"
DATA ".cccc."
DATA "*"
DATA ".yyyy." ' 5
DATA "yyYYWy"
DATA "yYYYYy"
DATA "yYYYYy"
DATA "yyYYyy"
DATA ".yyyy."
DATA "*"

' dotclockeraser=5
' always erase all square
DATA ".    ."
DATA "      "
DATA "      "
DATA "      "
DATA "      "
DATA ".    ."
data "*"

' seconddoteraser=6
' always erase all square
DATA "......"
DATA "..  .."
DATA ".    ."
DATA ".    ."
DATA "..  .."
DATA "......"
data "*"

' seconddot+%firstSS  0..4, 5..9, 10..14, 15..19, 20..24, 25..29
DATA "......"  ' 7
DATA "..rr.."
DATA ".rRRr."
DATA ".rRRr."
DATA "..rr.."
DATA "......"
DATA "*"
DATA "......"  ' 8
DATA "..ww.."
DATA ".wWWw."
DATA ".wWWw."
DATA "..ww.."
DATA "......"
DATA "*"
DATA "......"  ' 9
DATA "..gg.."
DATA ".gGGg."
DATA ".gGGg."
DATA "..gg.."
DATA "......"
DATA "*"
DATA "......"  ' 10
DATA "..yy.."
DATA ".yYYy."
DATA ".yYYy."
DATA "..yy.."
DATA "......"
DATA "*"
DATA "......"  ' 11
DATA "..pp.."
DATA ".pPPp."
DATA ".pPPp."
DATA "..pp.."
DATA "......"
DATA "*"
DATA "......"  ' 12
DATA "..cc.."
DATA ".cCCc."
DATA ".cCCc."
DATA "..cc.."
DATA "......"
DATA "*"
DATA "......"  ' 13
DATA "..bb.."
DATA ".bBBb."
DATA ".bBBb."
DATA "..bb.."
DATA "......"
DATA "$"



SpriteDataAlt:
' dotclock=1 best with blue hue
' 6 * 6  .=color 0 for mask
DATA ".BBBB." ' 1
DATA "BWWBBB"
DATA "BWWBBB"
DATA "BBBBBB"
DATA "BBBBBB"
DATA ".BBBB."
DATA "*"
DATA ".RRRR." ' 2
DATA "RWWRRR"
DATA "RWWRRR"
DATA "RRRRRR"
DATA "RRRRRR"
DATA ".RRRR."
DATA "*"
DATA ".GGGG." ' 3
DATA "GWWGGG"
DATA "GWWGGG"
DATA "GGGGGG"
DATA "GGGGGG"
DATA ".GGGG."
DATA "*"
DATA ".CCCC." ' 4
DATA "CWWCCC"
DATA "CWWCCC"
DATA "CCCCCC"
DATA "CCCCCC"
DATA ".CCCC."
DATA "*"
DATA ".YYYY." ' 5
DATA "YWWYYY"
DATA "YWWYYY"
DATA "YYYYYY"
DATA "YYYYYY"
DATA ".YYYY."
DATA "*"

' dotclockeraser=5
' always erase all square
DATA ".    ."
DATA "      "
DATA "      "
DATA "      "
DATA "      "
DATA ".    ."
data "*"

' seconddoteraser=6
' always erase all square
DATA "......"
DATA "..  .."
DATA ".    ."
DATA ".    ."
DATA "..  .."
DATA "......"
data "*"

' seconddot+%firstSS  0..4, 5..9, 10..14, 15..19, 20..24, 25..29
DATA "......"  ' 7
DATA "..RR.."
DATA ".RWRR."
DATA ".RRRR."
DATA "..RR.."
DATA "......"
DATA "*"
DATA "......"  ' 8
DATA "..WW.."
DATA ".WWWW."
DATA ".WWWW."
DATA "..WW.."
DATA "......"
DATA "*"
DATA "......"  ' 9
DATA "..GG.."
DATA ".GWGG."
DATA ".GGGG."
DATA "..GG.."
DATA "......"
DATA "*"
DATA "......"  ' 10
DATA "..YY.."
DATA ".YWYY."
DATA ".YYYY."
DATA "..YY.."
DATA "......"
DATA "*"
DATA "......"  ' 11
DATA "..PP.."
DATA ".PWPP."
DATA ".PPPP."
DATA "..PP.."
DATA "......"
DATA "*"
DATA "......"  ' 12
DATA "..CC.."
DATA ".CWCC."
DATA ".CCCC."
DATA "..CC.."
DATA "......"
DATA "*"
DATA "......"  ' 13
DATA "..BB.."
DATA ".BWBB."
DATA ".BBBB."
DATA "..BB.."
DATA "......"
DATA "$"

END FUNCTION

'--------------------------------------------------------------------
' here, we succeed in morphing digits which are not changing !
' we avoid burning monitor! ;-)

' we replace drawstrmov by drawstrmovfull
sub updateMovFull (byval new$,byval old$,byval posright,byval postop,byval multicolor,byval marks)
' try and increase speed when simultaneous moves?
realetapes=etapes
mismatch=0
for i = 1 to len(new$)
	if mid$(new$,i,1) <> mid$(old$,i,1) then incr mismatch
next
' etapes=etapes \ mismatch ' reduce tempo when several dots
for currstep=1 to etapes+1 ' take care of overhead
	call showSeconds(new$,%cx,%cy,radiusseconds,radiusmarks,60,multicolor,marks) ' here, else flicker !
	CALL DrawStrMovFull(new$,old$,1,%hhmm,posright,postop,currstep) ' hh:mm:ss=8, now 5
	swap viewpage,workpage ' toggle pages now
	call viewwork(viewpage,workpage) ' show updated page
    ' delay 0.01 to try and avoid flickering ? according to etapes ?
next
etapes=realetapes
END sub

'--------------------------------------------------------------------
'
' we keep normal animation for changed digits but we use
' buildmorphstatefull for fixed digits
SUB DrawStrMovFull(byval new$,byval old$,byval first, byval last,byval fromx, byval fromy, byval currstep)
FOR n = last TO first STEP -1 ' <<
	c$=mid$(old$,n,1)
    olddigit=getshapenumber(c$)
	c$=mid$(new$,n,1)
    digit=getshapenumber(c$)
   	maxwidth=shapeinfo(digit).maxwide
   	DECR fromx,maxwidth ' << update here!!!
    IF digit<>olddigit THEN
       	' build polygon while morphing, return # of vertices stored in Path
		vertices=buildMorphState(olddigit,digit)
        select case currstep
        case 1
	        ' we erase previous number
    	    CALL PlotState(olddigit,fromx,fromy,currstep-1,vertices,0) ' erase source
        	' and set currstep 1
	       	CALL PlotState(digit,fromx,fromy,currstep,vertices,1)
        case (etapes+1)
	        ' we erase previous number
    	    CALL PlotState(olddigit,fromx,fromy,currstep-2,vertices,0)
        	' draw new on workpage at currstep
       		CALL PlotState(digit,fromx,fromy,currstep-1,vertices,1) ' draw target
        case else
	       	' erase old on workpage
    	    ' we erase previous previous drawn page
        	CALL PlotState(olddigit,fromx,fromy,currstep-2,vertices,0)
        	' draw new on workpage at currstep
       		CALL PlotState(digit,fromx,fromy,currstep,vertices,1)
        end select
    ELSE
    	' here we morph a digit with itself
       	' build polygon while morphing, return # of vertices stored in Path
		vertices=buildMorphStateFull(olddigit,digit)
        select case currstep
        case 1
	        ' we erase previous number
    	    CALL PlotState(olddigit,fromx,fromy,currstep-1,vertices,0) ' erase source
        	' and set currstep 1
	       	CALL PlotState(digit,fromx,fromy,currstep,vertices,1)
        case (etapes+1)
	        ' we erase previous number
    	    CALL PlotState(olddigit,fromx,fromy,currstep-2,vertices,0)
        	' draw new on workpage at currstep
       		CALL PlotState(digit,fromx,fromy,currstep-1,vertices,1) ' draw target
        case else
	       	' erase old on workpage
    	    ' we erase previous previous drawn page
        	CALL PlotState(olddigit,fromx,fromy,currstep-2,vertices,0)
        	' draw new on workpage at currstep
       		CALL PlotState(digit,fromx,fromy,currstep,vertices,1)
        end select

    END IF
NEXT
END SUB

'--------------------------------------------------------------------

' build list of vertices stored in Path, while morphing, returns this #
' same digit to same digit here
function buildMorphStateFull (byval sourceshape, byval targetshape)
ptrSource =   ShapeInfo(sourceshape).offset
countSource = ShapeInfo(sourceshape).count
nVertex=countsource ' number of vertices while morphing
FOR p = %firstvertex TO nVertex-1
    Path(p,%Origin)=Vertex(ptrSource)
  	Path(p,%Target)=vertex(ptrSource+1)
    INCR ptrSource
NEXT
p=nVertex
Path(p,%Origin)=Vertex(ptrSource)
Path(p,%Target)=Vertex( ShapeInfo(sourceshape).offset ) ' 1st ptrSource
buildmorphstateFull=nvertex
end function

'--------------------------------------------------------------------

sub InitTrigo ( )
PI# = 4.0 * ATn(1.0#)
DegToRad# = PI# / 180.0#
end sub

function DegreesToRadians# (angle#)
angle#=angle# * DegToRad#
end function

sub PolarToRectangular (byval angle#,byval radius,byval cx, byval cy, x,y)
alpha# = angle#+270.0#
call DegreesToRadians(alpha#)
xpos = cx+radius * Cos(alpha#)
ypos = cy+radius * Sin(alpha#)
x = xpos
y = ypos
END sub


sub showSeconds (byval hhmmss$,byval cx,byval cy,byval radiusseconds,byval radiusmarks,byval num,byval multicolor,byval marks)
s$=right$(hhmmss$,2)
seconds=val(s$) ' 00..59
for i = %ss0 to seconds
	angle#=i * 360 / num
    call PolarToRectangular(angle#,radiusseconds,%cx,%cy,x,y)
    select case multicolor
    case %true
		ndx=(i mod 30 ) \ %lastSS
    case else
    	ndx=%firstSS ' always the first initialized !
    end select
  	CALL draw.Bitmap ( IconSS( ndx ), x, y, %SpriteWidth,%SpriteHeight )
next

select case marks
case %secondsNone
	firstval = seconds+1
case %secondsYes
	firstval = seconds+1
case %secondsAlt
	firstval = %ss0
end select

for i = firstval to %ss59
	angle#=i * 360 / num
    call PolarToRectangular(angle#,radiusmarks,%cx,%cy,x,y) ' recalc for all
    select case marks ' v1.0b feature, not too pretty but well...
    case %secondsNone
  		CALL draw.Bitmap ( EraserSS, x, y, %SpriteWidth,%SpriteHeight )
    case %secondsYes
    	IF (i mod 5) = 0 then
		  	CALL draw.Bitmap ( MarkSS, x, y, %SpriteWidth,%SpriteHeight )
        else
  			CALL draw.Bitmap ( EraserSS, x, y, %SpriteWidth,%SpriteHeight )
        end if
    case %secondsAlt
    	IF (i mod 5) = 0 then
		  	CALL draw.Bitmap ( MarkSS, x, y, %SpriteWidth,%SpriteHeight )
        else
  			CALL draw.Bitmap ( EraserSS, x, y, %SpriteWidth,%SpriteHeight )
        end if
    	call PolarToRectangular(angle#,radiusseconds,%cx,%cy,x,y)
        if i >= (seconds+1) then
  			CALL draw.Bitmap ( EraserSS, x, y, %SpriteWidth,%SpriteHeight )
        end if
	end select
next
END sub

'--------------------------------------------------------------------

' // v1.0h

SUB newpaths(byval sequencetype)
' store vertices temporiraly here before we modify the plotting order
DIM DYNAMIC TmpVertex (%FirstVertex:%LastVertex) AS VertexType ' compile time
LOCAL TmpVertex()
if sequencetype <> %Random then exit sub

currvertex=%FirstVertex
FOR currshape=%FirstShape TO %LastShape
    startofdef = ShapeInfo(currshape).offset
	count      = ShapeInfo(currshape).count
    s$=""
    FOR k = 1 TO count
    	thisdot=k-1 ' important!
        DO
          	' int((upper-lower+1)*rnd+lower)
			newpos=INT((count-1+1)*RND+1) ' [1..num] -> chr(1)..chr$(255)
			newpos=INT((count-1+1)*RND+1)
			newpos=INT((count-1+1)*RND+1)
        LOOP UNTIL INSTR(s$,CHR$(newpos)) = 0 ' find a NEW position
        s$=s$+CHR$(newpos)
        TmpVertex(newpos)=Vertex(startofdef+thisdot)
    NEXT
    ' now we can change order of sequence in array of positions
	FOR k = 1 TO count
    	thisdot=k-1
    	Vertex(startofdef+thisdot)=TmpVertex(k)
    NEXT
NEXT
end sub


