(* ---------------------------------------------------------------
Title         Q&D Wipe CMOS
Overview      see help
Usage         see help
Notes         debug display is ugly but informative
              yes, yes, many functions should be in external libs...

              safety third, eh eh :
              nope, seriously, -apply is required in order to
              protect user from him/her/it-self

              this is a subset of WIPEDATA
Bugs
Wish List     other random generators ?

--------------------------------------------------------------- *)

MODULE WipeCMOS;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT IO;
IMPORT SYSTEM;

FROM QD_ASCII IMPORT dash, slash, nullchar, tabchar, cr, lf, nl, bs,
space, dot, deg, degree, doublequote, quote, colon, percent, vbar,
blank, equal, dquote, charnull, singlequote, antislash, dollar,
star, backslash, coma, question, underscore, underbar, tabul, hbar,
comma, semicolon, diese, pound, openbracket, closebracket, tilde, exclam,
stardotstar, dotdot, escCh, escSet, letters, digits,
lettersUpp, lettersLow, openbrace, closebrace, ampersand;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite, setReadOnly,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs, UpperCaseAlt, LowerCaseAlt,
completedInit, completedShow, completedSHOW, completedEnd, completed,
removeDups, isValidHDunit, removePhantoms, removeFloppies,
getCDROMunits, getCDROMletters, removeCDROMs, getAllHDunits,
getAllLegalUnits, metaproc, getCli, argc, argv,
metaproc, UpperCaseFR, LowerCaseFR, ASCIIonly;

FROM QD_LFN IMPORT path9X, huge9X, findDataRecordType,
unicodeConversionFlagType, w9XchangeDir,
w9XgetDOSversion, w9XgetTrueDOSversion, w9XisWindowsEnh, w9XisMSDOS7,
w9XfindFirst, w9XfindNext, w9XfindClose, w9XgetCurrentDirectory,
w9XlongToShort, w9XshortToLong, w9XtrueName, w9XchangeDir,
w9XmakeDir, w9XrmDir, w9Xrename, w9XopenFile, w9XcloseFile,
w9XsupportLFN;

FROM QD_File IMPORT pathtype, w9XnothingRequired,
fileOpenRead, fileOpen, fileExists, fileExistsAlt,
fileIsRO, fileSetRW, fileSetRO,
fileErase, fileCreate, fileRename, fileGetFileSize, fileGetFileStamp,
fileIsDirectorySpec, fileClose, fileFlush, fileSupportLFN;

FROM QD_rand IMPORT InitRnd, GetRnd,
GetRndCardRange, GetRndLngCardRange,
GetRndLngRealRange, GetRndRealRange,
GetRndIntRange, GetRndLngIntRange;

FROM IO IMPORT WrStr, WrLn;

FROM Storage IMPORT Available, ALLOCATE, DEALLOCATE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    ENABLEREALUPDATE    = TRUE; (* if FALSE, CMOS and hard disk are protected against updates *)
    UBCD                = TRUE;  (* "proudly powered by JPI TopSpeed" :-) *)

CONST
    databuffersize      = 512;
    sDATABUFFERSIZE     = "512";
    firstdatabuffer     = 0;
    maxdatabuffer       = databuffersize-1;
CONST
    minIOdelayValue     = 50;
    maxIOdelayValue     = 50000;
    defaultIOdelayValue = 500;   (* ok for P4 *)
    sDefaultIOdelayValue= "500";
    sIOdelayValueRange  = "[50..50000]";
    defaultCMOSsize     = 128;
    sDefaultCMOSsize    = "128";
CONST
    sOK                 = "+++ ";
    sPROBLEM            = "--- ";
    sINFO               = "::: ";
    sCANCELLED          = "--- ";  (* not a problem but show nothing was done *)
    sWARN               = "*** ";
    sNOTICE             = "    ";  (* question to user *)
    sFAKE               = " ;-)";  (* suffix *)
    sDBG                = "// ";
CONST
    sRANDBYTE           = "??";
    sRANDBUFFER         = "**";
    sRANDBUFFERREGEN    = "@@"; (* will be slower, much slower *)
    sDefaultBytePattern = "$00";
CONST
    flagPATBYTE         = 0; (* $## *)
    flagPATRNDBYTE      = 1; (* ?? *)
    flagPATRNDBUFF      = 2; (* ** *)
    flagPATRNDBUFFREGEN = 3; (* @@ *)
CONST
    extDOC              = dot+"DOC";
    extEXE              = dot+"EXE";

(* ------------------------------------------------------------ *)

CONST
    progEXEname      = "WIPECMOS";
    progTitle        = "Q&D Zero CMOS Data";
    progVersion      = "v1.0";
(*%F UBCD *)
    progCopyright    = "by PhG";
(*%E  *)
(*%T UBCD  *)
    progCopyright    = "by Philippe Guiochon";
(*%E  *)
    progBanner       = progTitle+" "+progVersion+" "+progCopyright;

CONST
    errNone            = 0;
    errHelp            = 1;
    errMissingParm     = 2;
    errOption          = 3;
    errTooManyParms    = 4;
    errBadBytePattern  = 5;
    errDoc             = 6;
    errRedirected      = 7;
    errBadVal          = 8;
    errBadCMOSsize     = 9;
    errBadIOdelayValue = 10;
    errCMOSbuffer      = 11;
    errNoBufferHere    = 12;

    errCancelled       = 192;

    errAborted         = 255;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
    placeholder     = "|";
    helpplaceholder = "~"; (* vbar is used in text *)
    msgBEWARE =
"BE SURE TO KNOW WHAT YOU ARE DOING ! USE THIS OPTION AT YOUR OWN RISK !";
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)

msgHelp =
progBanner+nl+
nl+
"Syntax : "+progEXEname+" [size] [option]..."+nl+
nl+
"This program overwrites CMOS memory using specified byte pattern"+nl+
'(default pattern is "'+sDefaultBytePattern+'").'+nl+
nl+
"-apply REALLY apply any requested modification to existing data"+nl+
'       (default is to fake requested modification, as shown by "'+sFAKE+'" trailer)'+nl+
"       "+msgBEWARE+nl+
"-yes   skip keyboard confirmation (unwise !)"+nl+
"       "+msgBEWARE+nl+
'-b:$   byte pattern (default is "'+sDefaultBytePattern+'")'+nl+
"-a     use alternate random number generator"+nl+
"-io:#  delay after each CMOS access operation ("+sIOdelayValueRange+", default is "+sDefaultIOdelayValue+")"+nl+
(*%T UBCD  *)
"-doc   show "+progEXEname+extDOC+" file then terminate"+nl+
(*%E  *)
nl+
(*%F ENABLEREALUPDATE *)
"PLEASE NOTE THAT OVERWRITING CMOS IS NOT ENABLED !"+nl+
nl+
(*%E  *)
"a) For safety, program does NOT really overwrite data"+nl+
"   unless any of -apply, -doit or -really options is specified."+nl+
"b) Optional CMOS [size] is : 64, 128, 256, 512 (default is "+sDefaultCMOSsize+")."+nl+
"c) -b:$ option accepts a string with one hexadecimal value :"+nl+
'   first "$" is mandatory as a reminder whatever data follows ;'+nl+
'   "'+sRANDBYTE+'" = one random byte.'+nl+
"d) -yes option should NOT be used and is NOT recommended."+nl+
"e) -yesIdo and -dwIm options are shortcuts for -yes -really : use with caution."+nl+
(*%T UBCD  *)
"f) This DOS program was written with J.P.I. TopSpeed Modula-2 compiler."+nl+
(*%E  *)
nl+
"Examples : "+progEXEname+" 64 -b:$aa"+nl+
"           "+progEXEname+" -b:$?? -yes"+nl;

VAR
    S : str1024; (* oversized for possible LFN *)
    ok : BOOLEAN;
    p:CARDINAL;
BEGIN
    CASE e OF
    | errHelp :
        WrStr(msgHelp);
    | errMissingParm:   S := "<CMOS>, <unit> or <file(s)> expected !";
    | errOption:        S := 'Unknown "|" option !';
    | errTooManyParms:  S := '"|" is one parameter too many !';
    | errBadBytePattern:S := 'Illegal "|" pattern !';

    | errDoc:           S := progEXEname+extDOC+" was not found !";
    | errRedirected:    S := "Redirection is not allowed with | command !";
                        Str.Subst(S,placeholder,einfo);
                        video(progEXEname+" : ",TRUE);video(S,TRUE); (* send message to screen anyway ! *)

    | errBadVal:        S := 'Illegal "|" value !';
    | errBadCMOSsize:   S := 'Unsupported "|" CMOS size !';
    | errBadIOdelayValue:S:= '"|" is out of "+sIOdelayValueRange+" legal range !';
    | errCMOSbuffer:    S := "CMOS zeroing buffer cannot contain more than one value !";
    | errNoBufferHere:  S := "CMOS zeroing buffer must be a value or a random byte !";

    | errCancelled:     S:="Cancelled by user !"; (* never displayed *)

    ELSE
        S := "This is illogical, Captain !";
    END;

    CASE e OF
    | errNone, errHelp, errCancelled :
        ;
    ELSE
        Str.Subst(S,placeholder,einfo);
        WrStr(progEXEname+" : "); WrStr(S); WrLn;
    END;
    Lib.SetReturnCode(SHORTCARD(e));
    HALT;
END abort;

(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (16 * 512) + FIO.BufferOverhead; (* was 8 *)
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBufferType = ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
VAR
    ioBufferIn  : ioBufferType;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE dmp (S1:ARRAY OF CHAR   );
BEGIN
    WrStr(S1);WrLn;
END dmp;

PROCEDURE dmp2 (S1,S2:ARRAY OF CHAR   );
BEGIN
    WrStr(S1);WrStr(S2);WrLn;
END dmp2;

PROCEDURE dmp3 (S1,S2,S3:ARRAY OF CHAR   );
BEGIN
    WrStr(S1);WrStr(S2);WrStr(S3);WrLn;
END dmp3;

PROCEDURE dmp5 (S1,S2,S3,S4,S5:ARRAY OF CHAR);
BEGIN
    WrStr(S1);WrStr(S2);WrStr(S3);WrStr(S4);WrStr(S5);WrLn;
END dmp5;

PROCEDURE dmp6 (S1,S2,S3,S4,S5,S6:ARRAY OF CHAR);
BEGIN
    WrStr(S1);WrStr(S2);WrStr(S3);WrStr(S4);WrStr(S5);WrStr(S6);WrLn;
END dmp6;

PROCEDURE fmtlc (v:LONGCARD;base:CARDINAL;wi:INTEGER;ch,prefix:CHAR) : str80;
VAR
    R : str80;
    ok: BOOLEAN;
    i : CARDINAL;
BEGIN
    Str.CardToStr(v,R,base,ok);
    FOR i:= Str.Length(R)+1 TO ABS(wi) DO
        IF wi < 0 THEN
            Str.Append(R,ch);
        ELSE
            Str.Prepend(R,ch);
        END;
    END;
    IF base=16 THEN Str.Lows(R);END;
    Str.Prepend(R,prefix);
    RETURN R;
END fmtlc;

PROCEDURE fmtcard (v:CARDINAL;base:CARDINAL;wi:INTEGER;ch,prefix:CHAR) : str80;
BEGIN
    RETURN fmtlc(LONGCARD(v),base,wi,ch,prefix);
END fmtcard;

PROCEDURE fmtbignum (base,wi:CARDINAL;v:LONGCARD):str16;
VAR
    i : CARDINAL;
    R:str16;
    ok,lo:BOOLEAN;
    pad,prefix,suffix:CHAR;
BEGIN
    CASE base OF
    | 16: pad:="0";prefix:="$"; suffix:=""; lo:=TRUE;
    ELSE
          pad:=" ";prefix:= ""; suffix:=""; lo:=FALSE;
    END;
    Str.CardToStr ( v, R, base, ok);
    FOR i:=Str.Length(R)+1 TO wi DO Str.Prepend(R,pad);END;
    IF lo THEN Str.Lows(R); END;
    Str.Prepend(R,prefix);Str.Append(R,suffix);
    RETURN R;
END fmtbignum;

PROCEDURE fmtnum (base,wi:CARDINAL;v:CARDINAL):str16;
BEGIN
    RETURN fmtbignum(base,wi,LONGCARD(v));
END fmtnum;

(* ------------------------------------------------------------ *)

PROCEDURE dbg (DEBUG,enquote:BOOLEAN;S1,S2:ARRAY OF CHAR );
CONST
    wi = 25-3-1;
VAR
    i:CARDINAL;
BEGIN
    IF NOT(DEBUG) THEN RETURN; END;
    WrStr(sDBG);
    WrStr(S1);
    FOR i:=Str.Length(S1)+1 TO wi DO WrStr(" ");END;
    WrStr(' : ');
    IF enquote THEN WrStr('"');END;
    WrStr(S2);
    IF enquote THEN WrStr('"');END;
    WrLn;
END dbg;

PROCEDURE dbgbool (DEBUG,TF:BOOLEAN;S1,ST,SF:ARRAY OF CHAR   );
BEGIN
    IF TF THEN
        dbg(DEBUG,FALSE,S1,ST);
    ELSE
        dbg(DEBUG,FALSE,S1,SF);
    END;
END dbgbool;

PROCEDURE dbgc (DEBUG:BOOLEAN;S1:ARRAY OF CHAR;v:CARDINAL);
BEGIN
    dbg(DEBUG,FALSE,S1,fmtcard(v,10,1,"",""));
END dbgc;

PROCEDURE dbglc (DEBUG:BOOLEAN;S1:ARRAY OF CHAR;v:LONGCARD);
BEGIN
    dbg(DEBUG,FALSE,S1,fmtlc(v,10,1,"",""));
END dbglc;

PROCEDURE dbgpat (DEBUG:BOOLEAN;i,flag:CARDINAL;b:BYTE);
VAR
    S:str16;
BEGIN
    IF NOT(DEBUG) THEN RETURN; END;
    WrStr(sDBG);
    WrStr(fmtcard(i,10,2,"",""));
    WrStr(" : ");
    CASE flag OF
    | flagPATBYTE:
                          S:="byte (|)";
                          Str.Subst(S,"|",fmtcard(CARDINAL(b),16,2,"0","$"));
    | flagPATRNDBYTE:     S:="random byte";
    | flagPATRNDBUFF:     S:="random buffer";
    | flagPATRNDBUFFREGEN:S:="RANDOM buffer";
    END;
    WrStr(S);WrLn;
END dbgpat;

PROCEDURE runningManager (  ):BOOLEAN;
BEGIN
    RETURN FALSE; (* //FIXME *)
END runningManager;


(* ------------------------------------------------------------ *)

(* adapted from VITAL *)

PROCEDURE getkbd (VAR c1,c2:CHAR);
BEGIN
    BiosFlushkey(); (* useless against DOSKEY ! *)
    BiosWaitkey(c1,c2);
END getkbd;

(* we can use video here because we know redirection cannot happen here *)

PROCEDURE ShallWeProceed (firsttime:BOOLEAN):BOOLEAN;
CONST
    acceptA = "<^F9>"; acceptA1 = CHR(0); acceptA2 = CHR(102);
    acceptB = "<^F1>"; acceptB1 = CHR(0); acceptB2 = CHR(94);
VAR
    S : str128;
    c1,c2 , expected1,expected2:CHAR;
BEGIN
    CASE firsttime OF
    | TRUE:
        S:=sNOTICE+acceptA+" to perform requested operation : ";
        expected1:=acceptA1;
        expected2:=acceptA2;
    | FALSE:
        S:=sNOTICE+"Now, "+acceptB+" to _perform_ requested operation : ";
        expected1:=acceptB1;
        expected2:=acceptB2;
    END;
    video(S,TRUE);
    getkbd(c1,c2);
    video(S,FALSE);
    IF ((c1=expected1) AND (c2=expected2) ) THEN
        RETURN TRUE;
    ELSE
        RETURN FALSE;
    END;
END ShallWeProceed;

PROCEDURE queryUser (AUTOCONFIRM:BOOLEAN;msg:ARRAY OF CHAR):BOOLEAN;
VAR
    letsdoit:BOOLEAN;
BEGIN
    IF AUTOCONFIRM THEN
        letsdoit := TRUE;
    ELSE
        dmp(msg);
        letsdoit := FALSE;
        IF ShallWeProceed(TRUE) THEN
            IF ShallWeProceed(FALSE) THEN
                (* dmp(sINFO+"Update confirmed twice !"); *)
                letsdoit:=TRUE;
            ELSE
                dmp(sCANCELLED+"Update cancelled"); (* " at second thought" *)
            END;
        ELSE
            dmp(sCANCELLED+"Update cancelled");
        END;
    END;
    RETURN letsdoit;
END queryUser;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE showDoc (  ):BOOLEAN ;
CONST
    sb = 040H; (* segBiosData *)
CONST
    msgprompt = "(* Hit (almost) any key to continue or Escape to abort listing *) ";
    msgaborted= "(* Listing aborted by user ! *)";
    sCancel = str2( CHR(27) );
    initpagingcounter = 1; (* take msg into account *)
VAR
    biosCurrentRows       [sb:084H]  : BYTE;     (* add 1 *)
VAR
    hin:FIO.File;
    F,N:str128;
    S:str1024;
    p,lastrow,rowcount:CARDINAL;
    zekey:str2;
BEGIN
    Lib.ParamStr(F,0);
    p:=Str.RCharPos(F,dot);
    F[p] := charnull;
    Str.Append(F,extDOC);
    Str.Copy(N,F);
    p:=Str.RCharPos(N,antislash);
    Str.Delete(N,0,p+1);
    IF FIO.Exists(N)=FALSE THEN
        Str.Copy(N,F);
        IF FIO.Exists(N)=FALSE THEN RETURN FALSE;END;
    END;
    lastrow:=CARDINAL(biosCurrentRows)+1;
    rowcount:=initpagingcounter;
    hin:=FIO.OpenRead(N);
    FIO.EOF:=FALSE;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hin,S);
        WrStr(S);WrLn;
        INC(rowcount);
        IF rowcount >= lastrow THEN (* = is enough *)
            rowcount:=initpagingcounter;
            video(msgprompt,TRUE);
            Flushkey;
            zekey:=Waitkey();
            video(msgprompt,FALSE);
            IF same(zekey,sCancel) THEN WrStr(msgaborted);WrLn;EXIT;END;
        END;
    END;
    FIO.Close(hin);
    RETURN TRUE;
END showDoc;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* code adapted from UCLONE *)

PROCEDURE getvallc (VAR v : LONGCARD;
                   allowsepcosmetic:BOOLEAN;sepcosmetic:CHAR;
                   S:ARRAY OF CHAR):BOOLEAN;
VAR
    lc   : LONGCARD;
    base : CARDINAL;
    ok   : BOOLEAN;
BEGIN
    IF S[0]="$" THEN
        Str.Delete(S,0,1);
        base := 16;
    ELSE
        base := 10;
    END;
    IF sepcosmetic = "" THEN allowsepcosmetic:=FALSE;END; (* better safe than sorry *)
    IF allowsepcosmetic THEN ReplaceChar(S,sepcosmetic,"");END; (* clean cosmetic separators *)
    lc:=Str.StrToCard(S,base,ok);
    IF NOT(ok) THEN RETURN FALSE; END;
    IF lc > MAX(LONGCARD) THEN RETURN FALSE; END; (* gloups... how could such a thing be ? ;-) *)
    v := lc;
    RETURN TRUE;
END getvallc;

PROCEDURE getval (VAR v : CARDINAL;
                 allowsepcosmetic:BOOLEAN;sepcosmetic:CHAR;
                 S:ARRAY OF CHAR):BOOLEAN;
VAR
    lc:LONGCARD;
BEGIN
    lc := LONGCARD(v);
    IF getvallc(lc,allowsepcosmetic,sepcosmetic,S) THEN
        IF lc > MAX(CARDINAL) THEN
            RETURN FALSE;
        ELSE
            v := CARDINAL(lc);
            RETURN TRUE;
        END;
    ELSE
        RETURN FALSE;
    END;
END getval;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    firstpass = 1;
    maxpass   = 48;
VAR (* globerks *)
    bytepat    : ARRAY[firstpass..maxpass] OF BYTE;
    flagpat    : ARRAY[firstpass..maxpass] OF CARDINAL;
    databuffer : ARRAY[firstdatabuffer..maxdatabuffer] OF BYTE;

CONST
    MINBYTE = MIN(BYTE);
    MAXBYTE = MAX(BYTE);
CONST
    TSRAND = 0;
    QDRAND = 1;

PROCEDURE getRndByte ( randmethod:CARDINAL ):BYTE;
VAR
    v:CARDINAL;
BEGIN
    CASE randmethod OF
    | TSRAND:  v:=Lib.RANDOM(MAXBYTE+1);
    | QDRAND:  v:=GetRndCardRange(MINBYTE,MAXBYTE);
    END;
    RETURN BYTE(v);
END getRndByte;

PROCEDURE initRandom ( randmethod:CARDINAL  );
BEGIN
    CASE randmethod OF
    | TSRAND : Lib.RANDOMIZE();
    | QDRAND : InitRnd;
    END;
END initRandom;

PROCEDURE initDataBuffer (pass,randmethod:CARDINAL);
VAR
    i:CARDINAL;
    b:BYTE;
BEGIN
    CASE flagpat[pass] OF
    | flagPATBYTE  :
        b:=bytepat[pass];
        Lib.Fill(ADR(databuffer),databuffersize,b);
    | flagPATRNDBYTE   :
        b:=getRndByte(randmethod);
        Lib.Fill(ADR(databuffer),databuffersize,b);
    | flagPATRNDBUFF,flagPATRNDBUFFREGEN:
        FOR i:=firstdatabuffer TO maxdatabuffer DO
            databuffer[i]:=getRndByte(randmethod);
        END;
    END;
END initDataBuffer;

(* "$" + hexvalues either ## concatenated or separated with [ ,.] "??" "**" *)
(* assume S is already uppercased *)

CONST
    SEPCOSMETICFORBIDDEN = FALSE;
    SEPCOSMETICALLOWED   = TRUE;

PROCEDURE goodBytePattern (VAR lastpass:CARDINAL;
                          DEBUG:BOOLEAN;S:ARRAY OF CHAR):BOOLEAN;
CONST
    wihex = 2; (* "##", "??", "**" *)
VAR
    v,i:CARDINAL;
    useblank:BOOLEAN;
    N:str16;
    b:BYTE;
    flag:CARDINAL;
BEGIN
    dbg(DEBUG,TRUE,"Byte pattern string",S);
    CASE S[0] OF
    | charnull: RETURN FALSE;
    | dollar:   Str.Delete(S,0,1);
    ELSE
                RETURN FALSE;
    END;
    ReplaceChar(S,coma,blank);
    ReplaceChar(S,dot ,blank);
    useblank:=( Str.CharPos(S,blank) # MAX(CARDINAL) );
    IF useblank THEN
        lastpass:=argc (S,FALSE);
    ELSE
        v:=Str.Length(S);
        lastpass:= v DIV wihex;
        IF (lastpass * wihex) # v THEN RETURN FALSE;END; (* don't get mad, get EVEN *)
    END;
    IF lastpass > maxpass THEN RETURN FALSE;END;

    flag:=flagPATBYTE;
    b   :=0;
    FOR i:=firstpass TO maxpass DO
        flagpat[i]:=flag;
        bytepat[i]:=b;
    END;

    FOR i:=firstpass TO lastpass DO
        IF useblank THEN
            argv(N, S,i,FALSE);
            IF same(N,sRANDBYTE[0]) THEN (* quietly fix lazy user *)
                N:=sRANDBYTE;
            ELSIF same(N,sRANDBUFFER[0]) THEN (* the same *)
                N:=sRANDBUFFER;
            ELSIF same(N,sRANDBUFFERREGEN[0]) THEN (* the same *)
                N:=sRANDBUFFERREGEN;
            ELSE
                IF Str.Length(N) < wihex THEN Str.Prepend(N,"0");END;
            END;
        ELSE
            Str.Slice(N, S,(i-1)*wihex,wihex);
        END;
        dbg(DEBUG,TRUE,"hexstr",N);
        IF same(N,sRANDBYTE) THEN
            flag:=flagPATRNDBYTE;
            b   := 0;
        ELSIF same(N,sRANDBUFFER) THEN
            flag:=flagPATRNDBUFF;
            b   := 0;
        ELSIF same(N,sRANDBUFFERREGEN) THEN
            flag:=flagPATRNDBUFFREGEN;
            b   := 0;
        ELSE
            Str.Prepend(N,dollar); (* uppercase "$##" *)
            IF getval (v, SEPCOSMETICFORBIDDEN,"",N)=FALSE THEN RETURN FALSE;END;
            IF v > MAXBYTE THEN RETURN FALSE;END; (* $00..$FF only of course *)
            flag:=flagPATBYTE;
            b:=BYTE(v);
        END;
        flagpat[i]:=flag;
        bytepat[i]:=b;

        dbgpat(DEBUG,i,flag,b);

    END;
    RETURN TRUE;
END goodBytePattern;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* adapted from VITAL *)

PROCEDURE isValidIOdelay(v:LONGCARD):BOOLEAN;
BEGIN
    RETURN ( (v >= minIOdelayValue) AND (v <= maxIOdelayValue) );
END isValidIOdelay;

PROCEDURE IODELAY (IOdelayValue:CARDINAL);
VAR
    i,k:CARDINAL;
BEGIN
    FOR i:=1 TO IOdelayValue DO
        k:=i; (* could be a Lib.Delay() in ms ? problems from WinXP anyway *)
    END;
END IODELAY;

CONST
    RTCaddrPort = 70H;
    RTCdataPort = 71H;
    DisableNMI  = 80H;
    EnableNMI   = 00H;
    SafeCMOSaddr= 0DH; (* status D register, battery power *)

(*

0072  RW  CMOS memory address, region 2 (256 bytes)
0073  RW  CMOS memory data, region 2

0074  RW  CMOS memory address, region 3 (256 bytes)
0075  RW  CMOS memory data, region 3

//FIXME : good old Ralf does not agree with CMOSpwd !

*)

PROCEDURE getIOfix ( addr:CARDINAL ):CARDINAL ;
VAR
    k:CARDINAL;
BEGIN
    CASE addr OF
    |   0..128-1: k:=0; (* $70 $71 *)
    | 128..256-1: k:=2; (* $72 $73 *)
    | 256..384-1: k:=4; (* $74 $75 *)
    | 384..512-1: k:=6; (* $76 $77 *)
    ELSE
                  k:=0; (* safety *)
    END;
    RETURN k;
END getIOfix;

PROCEDURE WriteToCMOS (addr,value,IOdelayValue : CARDINAL );
VAR
    k:CARDINAL;
BEGIN
(*%T ENABLEREALUPDATE *)
    k:=getIOfix(addr);
    SYSTEM.DI;
    SYSTEM.Out ( RTCaddrPort+k,SHORTCARD(addr + DisableNMI) );
    IODELAY (IOdelayValue);
    SYSTEM.Out ( RTCdataPort+k,SHORTCARD(value) );
    IODELAY (IOdelayValue);
    SYSTEM.Out ( RTCaddrPort+k,SHORTCARD(SafeCMOSaddr + EnableNMI));
    SYSTEM.EI;
(*%E *)
END WriteToCMOS;

PROCEDURE procWipeCMOS (REALLY:BOOLEAN;cmossize,IOdelayValue,value:CARDINAL);
VAR
    i:CARDINAL;
    what,msg,S:str128;
BEGIN
    what:="~-bytes CMOS";
    Str.Subst(what,"~",fmtcard(cmossize,10,1,"",""));
    msg :="Overwriting ~ with ~ value";
    Str.Subst(msg,"~",what);
    Str.Subst(msg,"~",fmtcard(value,16,2,"0","$"));
    video(msg,TRUE);
    IF REALLY THEN
        FOR i := 1 TO cmossize DO
            WriteToCMOS ( i-1 ,value,IOdelayValue ); (* 0-based *)
        END;
        S:="";
    ELSE
        S:=sFAKE;
    END;
    video(msg,FALSE);
    dmp6(sOK,what," overwritten with ",fmtcard(value,16,2,"0","$")," value",S);
END procWipeCMOS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    cmdtype = (cmdnone,
               cmdcmos);

PROCEDURE newcmd (VAR cmd:cmdtype;wanted:cmdtype):BOOLEAN;
VAR
    ok:BOOLEAN;
BEGIN
    ok:=TRUE;
    IF cmd = cmdnone THEN
        cmd:=wanted;
    ELSIF cmd = wanted THEN
        ;
    ELSE
        ok:=FALSE;
    END;
    RETURN ok;
END newcmd;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    msgWait    = "Please wait... ";
    sWARN_CMOS = sWARN+"About to wipe CMOS data";
CONST
    firstparm       = 1;
    maxparm         = 1;
VAR
    parm : ARRAY[firstparm..maxparm] OF pathtype;
    parmcount,i,opt,lastparm:CARDINAL;
    S,R:pathtype;
VAR
    rc:CARDINAL;
VAR
    ok,DEBUG : BOOLEAN;
    REALLY,AUTOCONFIRM:BOOLEAN;
    cSEPCOUNT,cSEPCOSMETIC:CHAR;
    pass,passcount,subpass : CARDINAL;
    cmd:cmdtype;
    sBytePattern:str128;
    lc:LONGCARD;
    randmethod,lastpass,IOdelayValue,cmossize:CARDINAL;
BEGIN
    (* Lib.DisableBreakCheck(); *)
    FIO.IOcheck := FALSE;
    FIO.ShareMode:=FIO.ShareDenyNone; (* very, very important ! *)
    WrLn;

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,"");END;

    cmd               := cmdcmos;
    REALLY            := FALSE;
    sBytePattern      := sDefaultBytePattern; (* "$00" *)
    cmossize          := defaultCMOSsize;
    IOdelayValue      := defaultIOdelayValue;
    randmethod        := QDRAND;
    AUTOCONFIRM       := FALSE;
    cSEPCOUNT         := coma;
    cSEPCOSMETIC      := dot;
    DEBUG             := FALSE;

    lastparm          := firstparm-1;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R, "?"+delim+"H"+delim+"HELP"+delim+
                                  "DEBUG"+delim+
                                  "A"+delim+"ALTERNATE"+delim+
                                  "B:"+delim+"BYTES:"+delim+
                                  "DOC"+delim+"MAN"+delim+
                                  "IO:"+delim+"IODELAY"+delim+
                                  "APPLY"+delim+"REALLY"+delim+"DOIT"+delim+
                                  "UPDATE"+delim+"WRITE"+delim+
                                  "YES"+delim+"OUI"+delim+"AUTOCONFIRM"+delim+
                                  "YESIDO"+delim+"DWIM"
                              );
            CASE opt OF
            | 1,2,3 :   abort(errHelp,"");
            | 4:        DEBUG             := TRUE;
            | 5,6:      randmethod        := TSRAND;
            | 7,8:      GetString(R,sBytePattern); (* too late now to fix silly parms order ! *)
                        ok:= goodBytePattern(lastpass, DEBUG,sBytePattern);
                        IF NOT(ok) THEN abort(errBadBytePattern,S); END;

            | 9,10:    IF IsRedirected() THEN abort(errRedirected,"-doc");END;
                        IF showDoc()=FALSE THEN abort(errDoc,"");END;
                        abort(errNone,"");

            | 11,12:    IF GetLongCard(R,lc)=FALSE THEN abort(errBadVal,S);END;
                        IF isValidIOdelay(lc)=FALSE THEN abort(errBadIOdelayValue,S);END;
                        IOdelayValue:=CARDINAL(lc);
            | 13,14,15: REALLY            := TRUE;
            | 16,17   : REALLY            := TRUE;
            | 18,19,20: AUTOCONFIRM       := TRUE;
            | 21,22:    REALLY            := TRUE; AUTOCONFIRM := TRUE;
            ELSE
                abort(errOption,S);
            END;
        ELSE
            INC(lastparm);
            IF lastparm > maxparm THEN abort(errTooManyParms,S);END;
            Str.Copy(parm[lastparm],S); (* keep case *)
        END;
    END;

    CASE lastparm OF
    | firstparm: (* [cmos_size] *)
        Str.Copy(S,parm[firstparm]);
        IF getval (cmossize, SEPCOSMETICFORBIDDEN,"",S)=FALSE THEN abort(errBadVal,S);END;
        CASE cmossize OF
        | 64,128,256,512 :
            ;
        ELSE
            abort(errBadCMOSsize,S);
        END;
    END;

    initRandom(randmethod);

    CASE cmd OF
    | cmdcmos:

        ok:=goodBytePattern(lastpass, FALSE,sBytePattern); (* ignore debug *)
        IF lastpass # firstpass THEN abort(errCMOSbuffer,"");END;

        CASE flagpat[firstpass] OF
        | flagPATBYTE,flagPATRNDBYTE:
             initDataBuffer(firstpass,randmethod);
             i :=CARDINAL( databuffer[firstdatabuffer] );
        | flagPATRNDBUFF,flagPATRNDBUFFREGEN:
             abort(errNoBufferHere,"");
        END;
        dbg  (DEBUG,TRUE,"cmd","CMOS");
        dbgc (DEBUG,"cmos size",cmossize);
        dbgc (DEBUG,"IOdelay",IOdelayValue);
        dbgc (DEBUG,"zeroing value",i);
        ok:=goodBytePattern(lastpass, DEBUG,sBytePattern);

        S:=sWARN_CMOS;
        IF queryUser(AUTOCONFIRM,S) = FALSE THEN abort(errCancelled,"");END;

        procWipeCMOS(REALLY,cmossize,IOdelayValue, i);

    END;

    abort(errNone,"");
END WipeCMOS.
