(* ---------------------------------------------------------------
Title         Q&D Slow Sort
Overview      self-explanatory !
Notes         Yet Another "Reinvent a not so round wheel" example !
              weird : rename wants full path
              compact model would no longer compile
              forcing "group exceeds 64kb" :
              we had to use xlarge model
              tempfiles "$DEL~.TMP"
Bugs
Wish List     by length ? bah... sort, explode by length, rebuild

--------------------------------------------------------------- *)

MODULE sSort;

IMPORT Str;
IMPORT Lib;
IMPORT FIO;
IMPORT Storage;

FROM IO IMPORT WrStr,WrLn;

FROM Storage IMPORT Available,ALLOCATE,DEALLOCATE;

FROM QD_ASCII IMPORT dash, slash, nullchar, tabchar, cr, lf, nl, bs,
space, dot, deg, degree, doublequote, quote, colon, percent, vbar,
blank, equal, dquote, charnull, singlequote, antislash, dollar,
star, backslash, coma, question, underscore, underbar, tabul, hbar,
comma, semicolon, diese, pound, openbracket, closebracket, tilde, exclam,
stardotstar, dotdot, escCh, escSet, letters, digits,
lettersUpp, lettersLow, openbrace, closebrace, ampersand;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite, setReadOnly,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs, UpperCaseAlt, LowerCaseAlt,
completedInit, completedShow, completedSHOW, completedEnd, completed,
removeDups, isValidHDunit, removePhantoms, removeFloppies,
getCDROMunits, getCDROMletters, removeCDROMs, getAllHDunits,
getAllLegalUnits, metaproc, getCli, argc, argv, qdSplitAllPath,
metaproc, UpperCaseFR, LowerCaseFR, ASCIIonly;

FROM QD_File IMPORT pathtype, w9XnothingRequired,
fileOpenRead, fileOpen, fileExists, fileExistsAlt,
fileIsRO, fileSetRW, fileSetRO,
fileErase, fileCreate, fileAppend,fileRename,
fileGetFileSize, fileGetFileStamp,
fileIsDirectorySpec, fileClose, fileFlush, fileSupportLFN;

FROM QD_LFN IMPORT path9X, huge9X, findDataRecordType,
unicodeConversionFlagType, w9XchangeDir,
w9XgetDOSversion, w9XgetTrueDOSversion, w9XisWindowsEnh, w9XisMSDOS7,
w9XfindFirst, w9XfindNext, w9XfindClose, w9XgetCurrentDirectory,
w9XlongToShort, w9XshortToLong, w9XtrueName, w9XchangeDir,
w9XmakeDir, w9XrmDir, w9Xrename, w9XopenFile, w9XcloseFile,
w9XsupportLFN;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    strmaxlen     = 4096-1;
    sMaxLen       = "4095";
    sEOL          = "*";
    sRANGE        = "[1..4095]";
CONST
    sTMP          = "TMP";
    sTEMP         = "TEMP";
    sTMPDIR       = "TMPDIR";
    sTEMPDIR      = "TEMPDIR";
CONST
    extBKBANG     = ".BK!";
    extBAK        = ".BAK";
    extCOM        = ".COM";
    extEXE        = ".EXE";
    extDLL        = ".DLL";
    extZIP        = ".ZIP";
    extARJ        = ".ARJ";
    extLZH        = ".LZH";
    ext7Z         = ".7Z";

    sSkippedExtensions = extBKBANG+delim+extBAK+delim+
                         extCOM+delim+extEXE+delim+
                         extDLL+delim+
                         extZIP+delim+extARJ+delim+extLZH+delim+ext7Z;
CONST
    progEXEname   = "SSORT";
    progTitle     = "Q&D Slow Sort";
    progVersion   = "v1.0b";
    progCopyright = "by PhG";
    banner        = progTitle+" "+progVersion+" "+progCopyright;
CONST
    errNone         = 0;
    errHelp         = 1;
    errOption       = 2;
    errParmOverflow = 3;
    errExpected     = 4;
    errJoker        = 5;
    errNotFound     = 6;
    errNotFile      = 7;
    errExt          = 8;
    errStrTooLong   = 9;
    errRO           = 10;
    errBadRange     = 11;
    errRangeDefinedAlready = 12;
    errAborted      = 255;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    helpmsg =
banner+nl+
nl+
"Syntax : "+progEXEname+" <file> [option]..."+nl+
nl+
"  -z       Heap sort method (default is Quick sort method)"+nl+
"  -d[d]    ignore accents and case (-dd = -d -w)"+nl+
"  -l[l]    sort by line length"+nl+
"  -w[w]    force internal conversion from Win OEM to DOS ASCII (-ww = -w -d)"+nl+
"  -r|-i    reverse sort order"+nl+
"  -o:#[,#] use only specified columns range (-c:#[,#] = -o:#[,#])"+nl+
"  -i:#[,#] ignore specified columns range"+nl+
"  -f       ignore <file> read-only attribute"+nl+
"  -b       keep <file> backup (default is to overwrite <file>)"+nl+
"  -c       force temporary files to be created in current directory"+nl+
"  -v       verbose"+nl+
"  -x       disable LFN support even if available"+nl+
nl+
"This program slowly sorts <file> DOS ASCII text lines."+nl+
nl+
"a) Temporary files are created in directory specified by, in that order,"+nl+
"   "+sTMP+", "+sTEMP+", "+sTMPDIR+", "+sTEMPDIR+" environment variables"+nl+
"   (if none of these variables is defined, or if -c option is specified,"+nl+
"   current directory will be used instead)."+nl+
"b) "+sSkippedExtensions+" are ignored."+nl+
"c) A line cannot be longer than "+sMaxLen+" characters."+nl+
"d) Note whatever the original line separator, it will become cr+lf ($0d0a)."+nl+
'e) -b option creates a backup with "'+extBKBANG+'" extension.'+nl+
"f) Range for -o:#[,#] and -i:#[,#] options is 1-based."+nl+
'   It can be specified as "column,count" or "first_column..last_column".'+nl+
'   Default count or last_column is "'+sEOL+'" for "end of line".'+nl+
"g) Please note this program does not handle any form of redirection."+nl+
"h) Safety requires free disk space to be about 3 times the size of <file>."+nl;

VAR
    S : str1024;
BEGIN
    CASE e OF
    | errHelp :        WrStr(helpmsg);
    | errOption :      S:='Illegal "~" option !';
    | errParmOverflow: S:='"~" is one parameter too many !';
    | errExpected:     S:='"~" expected !';
    | errJoker:        S:='"~" cannot contain any joker !';
    | errNotFound:     S:='"~" does not exist !';
    | errNotFile:      S:='"~" is not a file !';
    | errExt:          S:='"~" has a forbidden extension !';
    | errStrTooLong:   S:='"~" contains at least one line longer than '+sMaxLen+' characters !';
    | errRO:           S:='"~" is read-only !';
    | errBadRange:     S:='"~" is illegal or not in valid '+sRANGE+" range !";
    | errRangeDefinedAlready:
                       S:="Columns range cannot be defined more than once !";
    | errAborted:      S:="Aborted by user !";
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone, errHelp :
        ;
    ELSE
        Str.Subst(S,"~",einfo);
        WrStr(progEXEname+" : ");WrStr(S);WrLn;
    END;
    Lib.SetReturnCode(SHORTCARD(e));
    HALT;
END abort;

(* as usual, buffers must be outside procedure, else program bombs ! *)

CONST
    IObufferSize      = (16 * 512) + FIO.BufferOverhead;
    firstIObufferByte = 1;
    lastIObufferByte  = IObufferSize;
TYPE
    ioBufferType      = ARRAY [firstIObufferByte..lastIObufferByte] OF BYTE; (* for private M2 IO *)
VAR
    ioBufferIn, ioBufferInAlt, ioBufferOut : ioBufferType;

CONST
    firstDataByte = 0;
    lastDataByte  = 32*512-1;
    dataBufferSize= lastDataByte - firstDataByte + 1;
TYPE
    dataBufferType = ARRAY [firstDataByte..lastDataByte] OF BYTE;
VAR
    dataBuffer : dataBufferType;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* ripped and adapted from old PC2WIN v1.0a *)

TYPE
    chardef   = RECORD
                    Code    : BYTE;
                    Flag    : CHAR;
                    MapChar : BYTE;
                END;
    CharTable = ARRAY [0..255] OF chardef;

(* ripped and adapted from old WIN2PC v1.0a *)

CONST
    TwinTOpc  = CharTable(
    chardef(000H, "=", 000H),
    chardef(001H, "=", 001H),
    chardef(002H, "=", 002H),
    chardef(003H, "=", 003H),
    chardef(004H, "=", 004H),
    chardef(005H, "=", 005H),
    chardef(006H, "=", 006H),
    chardef(007H, "=", 007H),
    chardef(008H, "=", 008H),
    chardef(009H, "!", 009H),
    chardef(00AH, "=", 00AH),
    chardef(00BH, "=", 00BH),
    chardef(00CH, "=", 00CH),
    chardef(00DH, "=", 00DH),
    chardef(00EH, "=", 00EH),
    chardef(00FH, "=", 00FH),
    chardef(010H, "=", 010H),
    chardef(011H, "=", 011H),
    chardef(012H, "=", 012H),
    chardef(013H, "=", 013H),
    chardef(014H, "=", 014H),
    chardef(015H, "=", 015H),
    chardef(016H, "=", 016H),
    chardef(017H, "=", 017H),
    chardef(018H, "=", 018H),
    chardef(019H, "=", 019H),
    chardef(01AH, "=", 01AH),
    chardef(01BH, "=", 01BH),
    chardef(01CH, "=", 01CH),
    chardef(01DH, "=", 01DH),
    chardef(01EH, "=", 01EH),
    chardef(01FH, "=", 01FH),
    chardef(020H, "=",  " "),
    chardef(021H, "=",  "!"),
    chardef(022H, "=",  '"'),
    chardef(023H, "=",  "#"),
    chardef(024H, "=",  "$"),
    chardef(025H, "=",  "%"),
    chardef(026H, "=",  "&"),
    chardef(027H, "=",  "'"),
    chardef(028H, "=",  "("),
    chardef(029H, "=",  ")"),
    chardef(02AH, "=",  "*"),
    chardef(02BH, "=",  "+"),
    chardef(02CH, "=",  ","),
    chardef(02DH, "=",  "-"),
    chardef(02EH, "=",  "."),
    chardef(02FH, "=",  "/"),
    chardef(030H, "=",  "0"),
    chardef(031H, "=",  "1"),
    chardef(032H, "=",  "2"),
    chardef(033H, "=",  "3"),
    chardef(034H, "=",  "4"),
    chardef(035H, "=",  "5"),
    chardef(036H, "=",  "6"),
    chardef(037H, "=",  "7"),
    chardef(038H, "=",  "8"),
    chardef(039H, "=",  "9"),
    chardef(03AH, "=",  ":"),
    chardef(03BH, "=",  ";"),
    chardef(03CH, "=",  "<"),
    chardef(03DH, "=",  "="),
    chardef(03EH, "=",  ">"),
    chardef(03FH, "=",  "?"),
    chardef(040H, "=",  "@"),
    chardef(041H, "=",  "A"),
    chardef(042H, "=",  "B"),
    chardef(043H, "=",  "C"),
    chardef(044H, "=",  "D"),
    chardef(045H, "=",  "E"),
    chardef(046H, "=",  "F"),
    chardef(047H, "=",  "G"),
    chardef(048H, "=",  "H"),
    chardef(049H, "=",  "I"),
    chardef(04AH, "=",  "J"),
    chardef(04BH, "=",  "K"),
    chardef(04CH, "=",  "L"),
    chardef(04DH, "=",  "M"),
    chardef(04EH, "=",  "N"),
    chardef(04FH, "=",  "O"),
    chardef(050H, "=",  "P"),
    chardef(051H, "=",  "Q"),
    chardef(052H, "=",  "R"),
    chardef(053H, "=",  "S"),
    chardef(054H, "=",  "T"),
    chardef(055H, "=",  "U"),
    chardef(056H, "=",  "V"),
    chardef(057H, "=",  "W"),
    chardef(058H, "=",  "X"),
    chardef(059H, "=",  "Y"),
    chardef(05AH, "=",  "Z"),
    chardef(05BH, "=",  "["),
    chardef(05CH, "=",  "\"),
    chardef(05DH, "=",  "]"),
    chardef(05EH, "=",  "^"),
    chardef(05FH, "=",  "_"),
    chardef(060H, "=",  "`"),
    chardef(061H, "=",  "a"),
    chardef(062H, "=",  "b"),
    chardef(063H, "=",  "c"),
    chardef(064H, "=",  "d"),
    chardef(065H, "=",  "e"),
    chardef(066H, "=",  "f"),
    chardef(067H, "=",  "g"),
    chardef(068H, "=",  "h"),
    chardef(069H, "=",  "i"),
    chardef(06AH, "=",  "j"),
    chardef(06BH, "=",  "k"),
    chardef(06CH, "=",  "l"),
    chardef(06DH, "=",  "m"),
    chardef(06EH, "=",  "n"),
    chardef(06FH, "=",  "o"),
    chardef(070H, "=",  "p"),
    chardef(071H, "=",  "q"),
    chardef(072H, "=",  "r"),
    chardef(073H, "=",  "s"),
    chardef(074H, "=",  "t"),
    chardef(075H, "=",  "u"),
    chardef(076H, "=",  "v"),
    chardef(077H, "=",  "w"),
    chardef(078H, "=",  "x"),
    chardef(079H, "=",  "y"),
    chardef(07AH, "=",  "z"),
    chardef(07BH, "=",  "{"),
    chardef(07CH, "=",  "|"),
    chardef(07DH, "=",  "}"),
    chardef(07EH, "=",  "~"),
    chardef(07FH, "x",  " "),
    chardef(080H, "x",  " "),
    chardef(081H, "x",  " "),
    chardef(082H, "x",  " "),
    chardef(083H, "x",  " "),
    chardef(084H, "x",  " "),
    chardef(085H, "x",  " "),
    chardef(086H, "x",  " "),
    chardef(087H, "x",  " "),
    chardef(088H, "x",  " "),
    chardef(089H, "x",  " "),
    chardef(08AH, "x",  " "),
    chardef(08BH, "x",  " "),
    chardef(08CH, "x",  " "),
    chardef(08DH, "x",  " "),
    chardef(08EH, "x",  " "),
    chardef(08FH, "x",  " "),
    chardef(090H, "x",  " "),
    chardef(091H, "=",  "'"),
    chardef(092H, "=",  "'"),
    chardef(093H, "x",  " "),
    chardef(094H, "x",  " "),
    chardef(095H, "x",  " "),
    chardef(096H, "x",  " "),
    chardef(097H, "x",  " "),
    chardef(098H, "x",  " "),
    chardef(099H, "x",  " "),
    chardef(09AH, "x",  " "),
    chardef(09BH, "x",  " "),
    chardef(09CH, "x",  " "),
    chardef(09DH, "x",  " "),
    chardef(09EH, "x",  " "),
    chardef(09FH, "x",  " "),
    chardef(0A0H, "=",  " "),
    chardef(0A1H, "=",  ""),
    chardef(0A2H, "=",  ""),
    chardef(0A3H, "=",  ""),
    chardef(0A4H, "=",  ""),
    chardef(0A5H, "=",  ""),
    chardef(0A6H, "=",  "|"),
    chardef(0A7H, "!", 015H),
    chardef(0A8H, "?",  " "),
    chardef(0A9H, "!",  ""),
    chardef(0AAH, "=",  ""),
    chardef(0ABH, "=",  ""),
    chardef(0ACH, "=",  ""),
    chardef(0ADH, "=",  "-"),
    chardef(0AEH, "!",  ""),
    chardef(0AFH, "!",  "-"),
    chardef(0B0H, "=",  ""),
    chardef(0B1H, "=",  ""),
    chardef(0B2H, "=",  ""),
    chardef(0B3H, "?",  " "),
    chardef(0B4H, "?",  " "),
    chardef(0B5H, "=",  ""),
    chardef(0B6H, "!", 014H),
    chardef(0B7H, "?",  " "),
    chardef(0B8H, "?",  " "),
    chardef(0B9H, "?",  " "),
    chardef(0BAH, "=",  ""),
    chardef(0BBH, "=",  ""),
    chardef(0BCH, "=",  ""),
    chardef(0BDH, "=",  ""),
    chardef(0BEH, "?",  " "),
    chardef(0BFH, "=",  ""),
    chardef(0C0H, "=",  "A"),
    chardef(0C1H, "=",  "A"),
    chardef(0C2H, "=",  "A"),
    chardef(0C3H, "=",  "A"),
    chardef(0C4H, "=",  ""),
    chardef(0C5H, "=",  ""),
    chardef(0C6H, "=",  ""),
    chardef(0C7H, "=",  ""),
    chardef(0C8H, "=",  "E"),
    chardef(0C9H, "=",  ""),
    chardef(0CAH, "=",  "E"),
    chardef(0CBH, "=",  "E"),
    chardef(0CCH, "=",  "I"),
    chardef(0CDH, "=",  "I"),
    chardef(0CEH, "=",  "I"),
    chardef(0CFH, "=",  "I"),
    chardef(0D0H, "?",  " "),
    chardef(0D1H, "=",  ""),
    chardef(0D2H, "=",  "O"),
    chardef(0D3H, "=",  "O"),
    chardef(0D4H, "=",  "O"),
    chardef(0D5H, "=",  "O"),
    chardef(0D6H, "=",  ""),
    chardef(0D7H, "=",  "X"),
    chardef(0D8H, "=",  "O"),
    chardef(0D9H, "=",  "U"),
    chardef(0DAH, "=",  "U"),
    chardef(0DBH, "=",  "U"),
    chardef(0DCH, "=",  ""),
    chardef(0DDH, "=",  "Y"),
    chardef(0DEH, "?",  " "),
    chardef(0DFH, "=",  ""),
    chardef(0E0H, "=",  ""),
    chardef(0E1H, "=",  ""),
    chardef(0E2H, "=",  ""),
    chardef(0E3H, "=",  "a"),
    chardef(0E4H, "=",  ""),
    chardef(0E5H, "=",  ""),
    chardef(0E6H, "=",  ""),
    chardef(0E7H, "=",  ""),
    chardef(0E8H, "=",  ""),
    chardef(0E9H, "=",  ""),
    chardef(0EAH, "=",  ""),
    chardef(0EBH, "=",  ""),
    chardef(0ECH, "=",  ""),
    chardef(0EDH, "=",  ""),
    chardef(0EEH, "=",  ""),
    chardef(0EFH, "=",  ""),
    chardef(0F0H, "?",  " "),
    chardef(0F1H, "=",  ""),
    chardef(0F2H, "=",  ""),
    chardef(0F3H, "=",  ""),
    chardef(0F4H, "=",  ""),
    chardef(0F5H, "=",  "o"),
    chardef(0F6H, "=",  ""),
    chardef(0F7H, "=",  ""),
    chardef(0F8H, "=",  "o"),
    chardef(0F9H, "=",  ""),
    chardef(0FAH, "=",  ""),
    chardef(0FBH, "=",  ""),
    chardef(0FCH, "=",  ""),
    chardef(0FDH, "=",  "y"),
    chardef(0FEH, "?",  " "),
    chardef(0FFH, "=",  ""));

(* we don't care about flag here *)

PROCEDURE remap2ascii (ch:CHAR):CHAR;
BEGIN
    RETURN TwinTOpc[ ORD(ch) ].MapChar;
END remap2ascii;

(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

CONST
    TlowerSORT= "                                "+
             "                                "+
             " abcdefghijklmnopqrstuvwxyz     "+
             " abcdefghijklmnopqrstuvwxyz     "+
             "cueaaaaceeeiiiaaeooouuyou     "+ (* no "" for sort *)
             "aiounn                          "+
             "                                "+
             "                               ";

PROCEDURE LowerCaseSORT (VAR S : ARRAY OF CHAR);
CONST
    ignore   = " ";
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,TlowerSORT);
        IF ch # ignore THEN S[i] := ch; END;
    END;
END LowerCaseSORT;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE fmtlc (v:LONGCARD;base:CARDINAL;wi:INTEGER;ch,prefix:CHAR) : str80;
VAR
    R : str80;
    ok: BOOLEAN;
    i : CARDINAL;
BEGIN
    Str.CardToStr(v,R,base,ok);
    FOR i:= Str.Length(R)+1 TO ABS(wi) DO
        IF wi < 0 THEN
            Str.Append(R,ch);
        ELSE
            Str.Prepend(R,ch);
        END;
    END;
    IF base=16 THEN Str.Lows(R);END;
    Str.Prepend(R,prefix);
    RETURN R;
END fmtlc;

PROCEDURE fmt (v:CARDINAL;base:CARDINAL;wi:INTEGER;ch,prefix:CHAR) : str80;
BEGIN
    RETURN fmtlc(LONGCARD(v),base,wi,ch,prefix);
END fmt;

PROCEDURE showmem(S:ARRAY OF CHAR );
VAR
    heapsize    : CARDINAL; (* in PARAGRAPHS and not in bytes ! help is wrong ! *)
    n           : LONGCARD;
BEGIN
    heapsize :=Storage.HeapTotalAvail(Storage.MainHeap);
    n := 16 * LONGCARD(heapsize);
    WrStr("::: ");
    WrStr(fmtlc(n,10,9,"",""));
    WrStr(" byte(s) free -- ");WrStr(S);WrLn;
END showmem;

CONST
    sINFO  = "::: ";
    wiINFO = 24;

PROCEDURE padstr (VAR R:ARRAY OF CHAR;padwi:CARDINAL  );
VAR
    i:CARDINAL;
BEGIN
    FOR i:=Str.Length(R)+1 TO padwi DO Str.Append(R," ");END;
    Str.Append(R," : ");
END padstr;

PROCEDURE dmpval ( S:ARRAY OF CHAR;v:CARDINAL  );
VAR
    R:str128;
    i:CARDINAL;
BEGIN
    Str.Concat(R,sINFO,S);
    padstr(R,wiINFO);
    Str.Append(R,fmt(v,10,1," ",""));
    WrStr(R);WrLn;
END dmpval;

PROCEDURE dmpbool (S,Y,N:ARRAY OF CHAR;v:BOOLEAN);
VAR
    R:str128;
BEGIN
    Str.Concat(R,sINFO,S);
    padstr(R,wiINFO);
    IF v THEN
        Str.Append(R,Y);
    ELSE
        Str.Append(R,N);
    END;
    WrStr(R);WrLn;
END dmpbool;

PROCEDURE dmp (S,S2:ARRAY OF CHAR);
VAR
    R:str128;
BEGIN
    Str.Concat(R,sINFO,S);
    padstr(R,wiINFO);
    Str.Append(R,S2);
    WrStr(R);WrLn;
END dmp;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    MINCOLUMN = 1;
    MAXCOLUMN = strmaxlen; (* 4095 *)
    sMAXCOL   = sMaxLen; (* "4095" *)
TYPE
    rangetype = (norange,rangeignore,rangeonly);

(* legal : column,count  first..last  first-last  column *)

PROCEDURE parseRange (VAR firstcol,countcol:CARDINAL; VAR range:rangetype;
                     newrange:rangetype;R:ARRAY OF CHAR):CARDINAL;
VAR
    S2:str128;
    p:CARDINAL;
    rangesep,pattern,snum:str16;
    lc:LONGCARD;
    try : (trycount, tryrange, tryrangealt, trycolumn);
BEGIN
    IF range # norange THEN RETURN errRangeDefinedAlready;END;

    GetString(R,S2);

    firstcol  := MINCOLUMN-1;
    countcol  := MAXCOLUMN;

    try:=trycount;
    LOOP
        CASE try OF
        | trycount:    rangesep:=",";
        | tryrange:    rangesep:="..";
        | tryrangealt: rangesep:="-";
        | trycolumn:   rangesep:=",";
                       Str.Append(S2,rangesep);Str.Append(S2,sMAXCOL);
        END;
        Str.Concat(pattern,"*",rangesep); Str.Append(pattern,"*");
        IF Str.Match(S2, pattern) THEN
            p:=Str.Pos(S2,rangesep);
            IF p > 0 THEN
                Str.Slice(snum,S2,0,p);
                Str.Delete(S2,0,p);
            ELSE
                snum:="";
            END;
            Str.Subst(S2,rangesep,"");
            Str.Prepend(snum,"="); (* ugly trick *)
            IF GetLongCard(snum,lc)=FALSE THEN RETURN errBadRange;END;
            IF ( (lc < MINCOLUMN) OR (lc > MAXCOLUMN) ) THEN RETURN errBadRange;END;
            firstcol:=CARDINAL(lc)-1; (* remember : 1-based for user, 0-based for Str library *)

            IF same(S2,sEOL) THEN S2:=sMAXCOL;END;
            Str.Concat(snum,"=",S2);
            IF GetLongCard(snum,lc)=FALSE THEN RETURN errBadRange;END;
            IF ( (lc < MINCOLUMN) OR (lc > MAXCOLUMN) ) THEN RETURN errBadRange;END;
            CASE try OF
            | trycount,trycolumn:
                countcol:=CARDINAL(lc);
            | tryrange, tryrangealt:
                IF CARDINAL(lc) < (firstcol+1) THEN RETURN errBadRange;END;
                countcol:=(CARDINAL(lc)-1) -firstcol+1;
            END;
            range:=newrange;
            EXIT;
        END;
        IF try=trycolumn THEN EXIT; END;
        INC(try);
    END;
    IF range # newrange THEN RETURN errBadRange;END;
    RETURN errNone;
END parseRange;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE doGetCurrent (useLFN:BOOLEAN;drive:SHORTCARD;
                       VAR unit:str2; VAR current:pathtype);
VAR
    rc:CARDINAL;
    longform:pathtype;
BEGIN
    Str.Concat(unit, CHR( ORD("A")-1+ORD(drive) ),colon);

    FIO.GetDir(drive,current); (* \path without u: nor trailing \ except at root *)
    IF current[1] # colon THEN Str.Prepend(current,unit); END; (* safety *)
    IF useLFN THEN
        IF w9XshortToLong(current,rc,longform) THEN (* if error, keep DOS current *)
            Str.Copy(current,longform);
        END;
    END;
    (* LFN function seems to always return "u:\*" form except at root *)
    IF current[1] = colon THEN Str.Delete(current,0,2);END; (* safety *)
    fixDirectory(current);
END doGetCurrent;

(* we don't check for TMP validity *)

PROCEDURE buildWorkDir (useLFN,forcecurrent:BOOLEAN; VAR workdir:pathtype);
CONST
    numvars = 4;
VAR
    i:CARDINAL;
    D:str128;
    drive:SHORTCARD;
    unit:str2;
    current:pathtype;
BEGIN
    IF forcecurrent THEN
        i:=numvars+1;
    ELSE
        i:=1;
        LOOP
            CASE i OF
            | 1: D:=sTMP;
            | 2: D:=sTEMP;
            | 3: D:=sTMPDIR;
            | 4: D:=sTEMPDIR;
            END;
            Lib.EnvironmentFind(D,workdir);
            IF same(workdir,"")=FALSE THEN EXIT; END;
            INC(i);
            IF i > numvars THEN EXIT; END;
        END;
    END;
    IF i > numvars THEN
        drive := FIO.GetDrive();
        doGetCurrent(useLFN,drive, unit,current); (* "u:" and "\" or "\*\" *)
        Str.Concat(workdir,unit,current);
    END;
    fixDirectory(workdir);
END buildWorkDir;

(* ------------------------------------------------------------ *)

PROCEDURE chkExt (S,skipem:ARRAY OF CHAR ):BOOLEAN;
VAR
    p,pb,n : CARDINAL;
    ext:str16;
BEGIN
    p:=Str.RCharPos(S, "." );
    IF p=MAX(CARDINAL) THEN RETURN TRUE; END;
    Str.Delete(S, 0,p+1);
    Str.Caps(S);

    pb:=0;
    n:=0;
    LOOP
        isoleItemS(ext, skipem,delim,n);
        Str.Subst(ext, "." , "" ); (* remove leading dot *)
        IF same(ext,"") THEN EXIT; END;
        IF same(ext,S) THEN INC(pb);END;
        INC(n);
    END;
    RETURN (pb=0);
END chkExt;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* 0001 to FFFF, could also be smaller range extension .001 to .FFF *)

PROCEDURE buildTarget (VAR dst:pathtype; count:CARDINAL;workdir:pathtype);
CONST
    pat="$DEL~.TMP";
BEGIN
    Str.Copy(dst,pat);
    Str.Subst(dst,"~",fmt(count,16,4,"0",""));
    Str.Prepend(dst,workdir);
END buildTarget;

TYPE
    strPtr = POINTER TO str4096;
CONST
    minentry = 1;
    maxentry = 10000; (* should DO *)
    indexA   = 1;
    indexB   = 2;
    strsafety= 1;
TYPE
    strarrayType = ARRAY[minentry..maxentry] OF strPtr;

VAR
    orgentry   : strarrayType; (* avoid object too big *)
    cookedentry: strarrayType;
VAR
    orgstr    : ARRAY[indexA..indexB] OF str4096; (* globerks as to avoid crash in PROC *)
    cookedstr : ARRAY[indexA..indexB] OF str4096; (* working copies of orgstr *)

CONST
    rcStrTooLong = MAX(CARDINAL);
    rcAlcatraz   = MAX(CARDINAL)-1;

(* ------------------------------------------------------------ *)

TYPE
    options      = (forceAZ,oemtoascii,reverse,altsort,bylength);
    setOfOptions = SET OF options;

VAR
    globsortmode : setOfOptions; (* ugly globerk for doLess() and isLess() *)

PROCEDURE doSwap (i,j:CARDINAL);
VAR
    tmp:strPtr;
BEGIN
    tmp:=orgentry[i];
    orgentry[i]:=orgentry[j];
    orgentry[j]:=tmp;

    tmp:=cookedentry[i];
    cookedentry[i]:=cookedentry[j];
    cookedentry[j]:=tmp;
END doSwap;

(* use globerks : work on working copies *)

PROCEDURE doLess (i,j:CARDINAL):BOOLEAN;
VAR
    ok,okx:BOOLEAN;
    leni,lenj:CARDINAL;
BEGIN
    ok :=  (Str.Compare(cookedentry[i]^,cookedentry[j]^) < 0 );
    IF (bylength IN globsortmode) THEN
        leni:=Str.Length(cookedentry[i]^);lenj:=Str.Length(cookedentry[j]^);
        IF leni # lenj THEN
            ok:=(leni < lenj);
        END;
    END;
    IF (reverse IN globsortmode) THEN ok:=NOT(ok);END;
    RETURN ok;
END doLess;

(* use globerks : work on working copies *)

PROCEDURE isLess (iA,jB:CARDINAL ):BOOLEAN;
VAR
    ok,okx:BOOLEAN;
    leni,lenj:CARDINAL;
BEGIN
    ok:= (Str.Compare(cookedstr[iA],cookedstr[jB]) < 0 );
    IF (bylength IN globsortmode) THEN
        leni:=Str.Length(cookedstr[iA]);lenj:=Str.Length(cookedstr[jB]);
        IF leni # lenj THEN
            ok:=(leni < lenj);
        END;
    END;
    IF (reverse IN globsortmode) THEN ok:=NOT(ok);END;
    RETURN ok;
END isLess;

(* ------------------------------------------------------------ *)

PROCEDURE processMe (ndx,firstcol,countcol:CARDINAL;
                    sortmode:setOfOptions;whatrange:rangetype):CARDINAL;
VAR
    i,len:CARDINAL;
    ch:CHAR;
BEGIN
    CASE whatrange OF
    | norange:
        Str.Copy(cookedstr[ndx],orgstr[ndx]);
    | rangeignore:
        Str.Copy(cookedstr[ndx],orgstr[ndx]);
        Str.Delete(cookedstr[ndx],firstcol,countcol);
    | rangeonly:
        Str.Slice(cookedstr[ndx],orgstr[ndx],firstcol,countcol);
    END;
    len:=Str.Length(cookedstr[ndx]);
    IF (oemtoascii IN sortmode) THEN
        FOR i:=1 TO len DO
            ch:=cookedstr[ndx][i-1];
            cookedstr[ndx][i-1]:= remap2ascii (ch);
        END;
    END;
    IF (forceAZ IN sortmode) THEN LowerCaseSORT(cookedstr[ndx]);END;
    RETURN len;
END processMe;

(* ------------------------------------------------------------ *)

PROCEDURE doPresort (useLFN:BOOLEAN;sortmode:setOfOptions;whatrange:rangetype;
                    firstcol,countcol:CARDINAL;
                    src,workdir:pathtype ):CARDINAL;
CONST
    msgSorting = "Sorting ~... ";
VAR
    hin,hout:FIO.File;
    ndx,count,i,rc:CARDINAL;
    dst:pathtype;
    fsize,anchor:LONGCARD;
    dmp,done:BOOLEAN;
    msg:str80;
    len,needed,lencooked,neededcooked:CARDINAL;
BEGIN
    globsortmode:=sortmode; (* ugly but vital for doLess() ! *)
    FOR i:=minentry TO maxentry DO orgentry[i]:=NIL;END;

    hin:=fileOpen(useLFN,src);
    FIO.AssignBuffer(hin,ioBufferIn);
    fsize:=FIO.Size(hin);

    dmp:=FALSE;
    count:=1;
    ndx:=minentry-1;

    LOOP
        anchor:=FIO.GetPos(hin);
        done:=NOT ( anchor < fsize);
        IF done THEN
            dmp:=TRUE;
        ELSE
            FIO.RdStr(hin,orgstr[indexA]);
            len:=Str.Length(orgstr[indexA]);
            IF len > strmaxlen THEN rc:=rcStrTooLong;EXIT;END;

            INC(ndx);
            IF ndx > maxentry THEN
                DEC(ndx);
                FIO.Seek(hin,anchor);
                dmp:=TRUE;
            ELSE
                lencooked:=processMe(indexA,firstcol,countcol,sortmode,whatrange);
                neededcooked := lencooked+strsafety;
                (*
                    two calls seem required,
                    for checking added sizes can force a crash
                    when allocating
                *)
                needed := len+strsafety;
                IF Available(needed) THEN
		            ALLOCATE(orgentry[ndx],needed);
    		        Lib.Move(ADR(orgstr[indexA]), ADR(orgentry[ndx]^),needed);
                    IF Available(neededcooked) THEN
    		            ALLOCATE(cookedentry[ndx],neededcooked);
                        Lib.Move(ADR(cookedstr[indexA]),ADR(cookedentry[ndx]^),neededcooked);
                        dmp:=FALSE;
                    ELSE
                        DEALLOCATE(orgentry[ndx],needed);
                        DEC(ndx);
                        FIO.Seek(hin,anchor);
                        dmp:=TRUE;
                    END;
                ELSE
                    DEC(ndx);
                    FIO.Seek(hin,anchor);
                    dmp:=TRUE;
                END;
            END;
        END;
        IF dmp THEN
            Str.Copy(msg,msgSorting);
            Str.Subst(msg,"~",fmt(count,10,1," ",""));
            video(msg,TRUE);

            IF (altsort IN sortmode) THEN
                Lib.HSort(ndx,doLess,doSwap); (* handle globsortmode *)
            ELSE
                Lib.QSort(ndx,doLess,doSwap); (* handle globsortmode *)
            END;

            buildTarget(dst,count,workdir);
            hout:=fileCreate(useLFN,dst);
            FIO.AssignBuffer(hout,ioBufferOut);
            FOR i:=minentry TO ndx DO
                FIO.WrStr(hout,orgentry[i]^);FIO.WrLn(hout);

                len:=Str.Length(orgentry[i]^);
                needed:=len+strsafety;
                DEALLOCATE(orgentry[i],needed);
                lencooked:=Str.Length(cookedentry[i]^);
                needed:=lencooked+strsafety;
                DEALLOCATE(cookedentry[i],needed);
            END;
            fileClose(useLFN,hout);
            video(msg,FALSE);
            IF done THEN rc:=count;EXIT;END;
            IF ChkEscape() THEN rc:=rcAlcatraz;EXIT;END;
            INC(count);
            ndx:=minentry-1;
        END;
    END;

    fileClose(useLFN,hin);
    CASE rc OF
    | rcStrTooLong,rcAlcatraz:
        FOR i:=1 TO count DO
            buildTarget(dst,i,workdir);
            IF fileExists(useLFN,dst) THEN fileErase(useLFN,dst); END;
        END;
    END;
    RETURN rc;
END doPresort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE dbg (S1,S2:ARRAY OF CHAR  );
BEGIN
    WrStr("::: ");WrStr(S1);WrStr("  ");WrStr(S2);WrLn;
END dbg;

PROCEDURE doMerge (DEBUG,useLFN:BOOLEAN;sortmode:setOfOptions;whatrange:rangetype;
                  ndxsrc,ndxsrcalt, ndxdst,firstcol,countcol:CARDINAL;
                  workdir:pathtype);
CONST
    msgMerging = "Merging ~ and ~ to ~...";
VAR
    hin,hinalt,hout:FIO.File; (* yes, yes, we could use indexed ARRAY *)
    msg:str80;
    src,srcalt,dst:pathtype;
    anchor,anchoralt:LONGCARD;
    fsize,fsizealt:LONGCARD;
    ok,done,donealt:BOOLEAN;
    state:(waiting,compare,dump,dumpalt);
    lencooked:CARDINAL;
BEGIN
    globsortmode:=sortmode; (* ugly but vital for isLess() ! *)
    Str.Copy(msg,msgMerging);
    Str.Subst(msg,"~",fmt(ndxsrc,10,1," ",""));
    Str.Subst(msg,"~",fmt(ndxsrcalt,10,1," ",""));
    Str.Subst(msg,"~",fmt(ndxdst,10,1," ",""));
    video(msg,TRUE);

    buildTarget(src,ndxsrc,workdir);
    buildTarget(srcalt,ndxsrcalt,workdir);
    buildTarget(dst,ndxdst,workdir);

    hin:=fileOpenRead(useLFN,src);
    FIO.AssignBuffer(hin,ioBufferIn);
    hinalt:=fileOpenRead(useLFN,srcalt);
    FIO.AssignBuffer(hinalt,ioBufferInAlt);
    hout:=fileCreate(useLFN,dst);
    FIO.AssignBuffer(hout,ioBufferOut);

    fsize:=FIO.Size(hin);
    fsizealt:=FIO.Size(hinalt);

    Str.Copy(orgstr[indexA],"");
    Str.Copy(orgstr[indexB],"");

    state:=waiting;
    LOOP
        anchor    := FIO.GetPos(hin);
        done      := NOT ( anchor < fsize);
        anchoralt := FIO.GetPos(hinalt);
        donealt   := NOT ( anchoralt < fsizealt);

        CASE state OF
        | waiting:
            IF done THEN
                IF donealt THEN EXIT;END;
                state:=dumpalt;
            ELSE
                FIO.RdStr(hin,orgstr[indexA]);
                lencooked:=processMe(indexA,firstcol,countcol,sortmode,whatrange);
                state:=compare;
            END;
        | compare:
            IF donealt THEN
                FIO.WrStr(hout,orgstr[indexA]);FIO.WrLn(hout);
                state:=dump;
            ELSE
                FIO.RdStr(hinalt,orgstr[indexB]);
                lencooked:=processMe(indexB,firstcol,countcol,sortmode,whatrange);

                ok:= isLess(indexA,indexB); (* use cookedstr, handle globsortmode *)

                IF ok THEN
                    FIO.WrStr(hout,orgstr[indexA]);FIO.WrLn(hout);
                    FIO.Seek(hinalt,anchoralt); (* ugly but NOT slower than grabalt flag *)
                    state:=waiting;
                ELSE
                    FIO.WrStr(hout,orgstr[indexB]);FIO.WrLn(hout);
                END;
            END;
        | dump:
            IF done THEN EXIT;END;
            FIO.RdStr(hin,orgstr[indexA]);
            FIO.WrStr(hout,orgstr[indexA]);FIO.WrLn(hout);
        | dumpalt:
            IF donealt THEN EXIT;END;
            FIO.RdStr(hinalt,orgstr[indexB]);
            FIO.WrStr(hout,orgstr[indexB]);FIO.WrLn(hout);
        END;
    END;

    fileClose(useLFN,hout);
    fileClose(useLFN,hinalt);
    fileClose(useLFN,hin);
    video(msg,FALSE);

    IF NOT(DEBUG) THEN
        fileErase(useLFN,src);
        fileErase(useLFN,srcalt);
    END;
END doMerge;

PROCEDURE doPostSort (DEBUG,useLFN:BOOLEAN;sortmode:setOfOptions;whatrange:rangetype;
                     firstcol,countcol,count:CARDINAL;
                     src,workdir:pathtype ):CARDINAL;
VAR
    i:CARDINAL;
BEGIN
    i:=1;
    LOOP
        IF i >= count THEN EXIT;END;
        INC(count);
        doMerge(DEBUG,useLFN,sortmode,whatrange,i,i+1,count,firstcol,countcol,workdir);
        INC(i,2);
        IF ChkEscape() THEN i:=rcAlcatraz;EXIT;END;
    END;
    RETURN i;
END doPostSort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE copyFile (useLFN,verbose:BOOLEAN;src,dst:pathtype );
CONST
    msgCopying = "Copying, please wait... ";
VAR
    hin,hout:FIO.File;
    got:CARDINAL;
BEGIN
    hin:=fileOpenRead(useLFN,src);
    FIO.AssignBuffer(hin,ioBufferIn);
    hout:=fileCreate(useLFN,dst);
    FIO.AssignBuffer(hout,ioBufferOut);
    IF verbose THEN video(msgCopying,TRUE); END;
    LOOP
        got:=FIO.RdBin(hin,dataBuffer,dataBufferSize);
        IF got = 0 THEN EXIT; END;
        FIO.WrBin(hout,dataBuffer,got);
        IF got # dataBufferSize THEN EXIT; END;
    END;
    IF verbose THEN video(msgCopying,FALSE); END;
    fileClose(useLFN,hout);
    fileClose(useLFN,hin);
END copyFile;

PROCEDURE doFinal (DEBUG,useLFN,keepbackup,wasRO:BOOLEAN;totalcount:CARDINAL;
                   src,workdir:pathtype );
CONST
    showmsg=TRUE;
VAR
    sorted:pathtype;
    u,d,n,e,ne:pathtype;
BEGIN
    buildTarget(sorted,totalcount,workdir); (* last tmp created *)
    fileSetRW(useLFN,src);
    IF keepbackup THEN
        qdSplitAllPath(src, u,d,n,e);
        Lib.MakeAllPath(ne,u,d,n,extBKBANG); (* just NE does NOT work !!! *)
        fileRename(useLFN,src,ne);
    ELSE
        fileErase(useLFN,src);
    END;
    copyFile(useLFN,showmsg,sorted,src); (* src is target *)
    IF NOT(DEBUG) THEN fileErase(useLFN,sorted); END;
    IF wasRO THEN fileSetRO(useLFN,src);END;
END doFinal;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    msgWorking = "Working, please wait... ";
VAR
    sortmode : setOfOptions;
VAR
    i,opt,parmcount:CARDINAL;
    S,R:pathtype;
    src,workdir:pathtype;
    state:(waiting,gotsource);
    wasRO,ignoreRO,verbose,keepbackup,forcecurrent:BOOLEAN;
    DEBUG,useLFN:BOOLEAN;
    rc,count,totalcount,firstcol,countcol:CARDINAL;
    whatrange:rangetype;
BEGIN
    WrLn;
    FIO.IOcheck:=FALSE;
    FIO.ShareMode:=FIO.ShareDenyNone;

    useLFN       := TRUE;
    forcecurrent := FALSE;
    keepbackup   := FALSE;
    verbose      := FALSE;
    ignoreRO     := FALSE;
    whatrange    := norange;
    firstcol     := MINCOLUMN-1;
    countcol     := MAXCOLUMN;
    sortmode     := setOfOptions{};
    DEBUG        := FALSE;

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,"");END;

    state:=waiting;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex (R,"?"+delim+"H"+delim+"HELP"+delim+
                                  "X"+delim+"LFN"+delim+
                                  "C"+delim+"CURRENT"+delim+
                                  "B"+delim+"BACKUP"+delim+
                                  "V"+delim+"VERBOSE"+delim+
                                  "F"+delim+"RO"+delim+"READONLY"+delim+
                                  "I:"+delim+"IGNORE:"+delim+
                                  "O:"+delim+"ONLY:"+delim+
                                  "C:"+delim+"COLUMN:"+delim+
                                  "D"+delim+"DOS"+delim+"ASCII"+delim+
                                  "W"+delim+"WIN"+delim+"OEM"+delim+
                                  "I"+delim+"R"+delim+
                                  "DD"+delim+"WW"+delim+
                                  "Z"+delim+"ALTSORT"+delim+"HEAP"+delim+"HEAPSORT"+delim+
                                  "L"+delim+"LEN"+delim+"LENGTH"+delim+"LL"+delim+
                                  "DEBUG"
                               );
            CASE opt OF
            | 1,2,3 : abort(errHelp,"");
            | 4,5   : useLFN       := FALSE;
            | 6,7   : forcecurrent := TRUE;
            | 8,9   : keepbackup   := TRUE;
            | 10,11 : verbose      := TRUE;
            | 12,13,14:ignoreRO    := TRUE;
            | 15,16 : rc:=parseRange (firstcol,countcol,whatrange,  rangeignore,R);
                      IF rc # errNone THEN abort(rc,S);END;
            | 17,18 : rc:=parseRange (firstcol,countcol,whatrange,  rangeonly,R);
                      IF rc # errNone THEN abort(rc,S);END;
            | 19,20 : rc:=parseRange (firstcol,countcol,whatrange,  rangeonly,R);
                      IF rc # errNone THEN abort(rc,S);END;

            | 21,22,23 :   INCL (sortmode,forceAZ);
            | 24,25,26 :   INCL (sortmode,oemtoascii);
            | 27,28 :      INCL (sortmode,reverse);
            | 29,30 :      INCL (sortmode,forceAZ); INCL(sortmode,oemtoascii);
            | 31,32,33,34: INCL (sortmode,altsort);
            | 35,36,37,38: INCL (sortmode,bylength);
            | 39    : DEBUG        := TRUE;
            ELSE
                abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            CASE state OF
            | waiting:   Str.Copy(src,S);
            | gotsource: abort(errParmOverflow,S);
            END;
            INC(state);
        END;
    END;
    CASE state OF
    | waiting:  abort(errExpected,"<file>");
    | gotsource : ;
    END;

    useLFN := ( useLFN AND fileSupportLFN() );

    IF chkJoker(src) THEN abort(errJoker,src);END;
    IF fileExists(useLFN,src)=FALSE THEN abort(errNotFound,src);END;
    IF fileIsDirectorySpec(useLFN,src) THEN abort(errNotFile,src);END;
    IF chkExt(src,sSkippedExtensions)=FALSE THEN abort(errExt,src);END;
    wasRO:=fileIsRO(useLFN,src);
    IF wasRO THEN
        IF NOT(ignoreRO) THEN abort(errRO,src);END;
    END;

    buildWorkDir(useLFN,forcecurrent,workdir);

    IF DEBUG THEN
        showmem("Start");WrLn;
        dmp     ("File",src);
        dmp     ("Workdir",workdir);
        dmpbool ("Local TMPdir"    , "yes"  , "no"   , forcecurrent);
        dmpbool ("Keep backup"     , "yes"  , "no"   , keepbackup);
        dmpbool ("LFNs"            , "yes"  , "no"   , useLFN);
        CASE whatrange OF
        | norange:    S:="none";
        | rangeonly:  S:="only";
        | rangeignore:S:="ignore";
        END;
        dmpbool ("Sort method"    ,  "Heap","Quick",altsort IN sortmode);
        dmp     ("Range mode"      , S);
        dmpval  ("First column"    , firstcol+1);
        dmpval  ("Column count"    , countcol);
        dmpbool ("Force [a..z] set", "yes" ,"no",forceAZ IN sortmode);
        dmpbool ("Win OEM to DOS ASCII"  , "yes" ,"no",oemtoascii IN sortmode);
        dmpbool ("By line length"  , "yes", "no",bylength IN sortmode);
        dmpbool ("Reverse"         , "yes" ,"no",reverse IN sortmode);
        WrLn;
    END;

    video(msgWorking,TRUE);
    count:=doPresort(useLFN,sortmode,whatrange,firstcol,countcol,src,workdir);
    video(msgWorking,FALSE);
    CASE count OF
    | rcStrTooLong : abort(errStrTooLong,src);
    | rcAlcatraz   : abort(errAborted,"");
    END;

    video(msgWorking,TRUE);
    totalcount:=doPostSort (DEBUG,useLFN,sortmode,whatrange,
                           firstcol,countcol,count,
                           src,workdir);
    video(msgWorking,FALSE);
    CASE totalcount OF
    | rcAlcatraz   : abort(errAborted,"");
    END;

    doFinal(DEBUG,useLFN,keepbackup,wasRO,totalcount,src,workdir);

    IF DEBUG THEN
        dmpval ("Initial split count",count);
        dmpval ("Total split count",totalcount);
    END;

    IF DEBUG THEN WrLn;showmem("Exit");END;

    abort(errNone,"");
END sSort.
