(* ---------------------------------------------------------------
Title         Q&D Wipe File
Overview      see help
Usage         see help
Notes         debug display is ugly but informative
              note we're limited to <= 4Gb files
              yes, yes, many functions should be in external libs...

              safety third, eh eh :
              nope, seriously, -apply is required in order to
              protect user from him/her/it-self

              file not found is not betrayed but silently ignored

              this is a subset of WIPEDATA
Bugs
Wish List     other random generators ?
              overwriting free space by creating files
              until no free space is left ?

              a win32 version of wipefile with reserve32 companion ?

--------------------------------------------------------------- *)

MODULE WipeFile;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT IO;
IMPORT SYSTEM;

FROM QD_ASCII IMPORT dash, slash, nullchar, tabchar, cr, lf, nl, bs,
space, dot, deg, degree, doublequote, quote, colon, percent, vbar,
blank, equal, dquote, charnull, singlequote, antislash, dollar,
star, backslash, coma, question, underscore, underbar, tabul, hbar,
comma, semicolon, diese, pound, openbracket, closebracket, tilde, exclam,
stardotstar, dotdot, escCh, escSet, letters, digits,
lettersUpp, lettersLow, openbrace, closebrace, ampersand;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite, setReadOnly,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs, UpperCaseAlt, LowerCaseAlt,
completedInit, completedShow, completedSHOW, completedEnd, completed,
removeDups, isValidHDunit, removePhantoms, removeFloppies,
getCDROMunits, getCDROMletters, removeCDROMs, getAllHDunits,
getAllLegalUnits, metaproc, getCli, argc, argv,
metaproc, UpperCaseFR, LowerCaseFR, ASCIIonly;

FROM QD_LFN IMPORT path9X, huge9X, findDataRecordType,
unicodeConversionFlagType, w9XchangeDir,
w9XgetDOSversion, w9XgetTrueDOSversion, w9XisWindowsEnh, w9XisMSDOS7,
w9XfindFirst, w9XfindNext, w9XfindClose, w9XgetCurrentDirectory,
w9XlongToShort, w9XshortToLong, w9XtrueName, w9XchangeDir,
w9XmakeDir, w9XrmDir, w9Xrename, w9XopenFile, w9XcloseFile,
w9XsupportLFN;

FROM QD_File IMPORT pathtype, w9XnothingRequired,
fileOpenRead, fileOpen, fileExists, fileExistsAlt,
fileIsRO, fileSetRW, fileSetRO,
fileErase, fileCreate, fileRename, fileGetFileSize, fileGetFileStamp,
fileIsDirectorySpec, fileClose, fileFlush, fileSupportLFN;

FROM QD_rand IMPORT InitRnd, GetRnd,
GetRndCardRange, GetRndLngCardRange,
GetRndLngRealRange, GetRndRealRange,
GetRndIntRange, GetRndLngIntRange;

FROM IO IMPORT WrStr, WrLn;

FROM Storage IMPORT Available, ALLOCATE, DEALLOCATE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    ENABLEREALUPDATE    = TRUE; (* if FALSE, data protected against updates *)
    UBCD                = TRUE;  (* "proudly powered by JPI TopSpeed" :-) *)

CONST
    databuffersize      = 16384;
    sDATABUFFERSIZE     = "16384";
    firstdatabuffer     = 0;
    maxdatabuffer       = databuffersize-1;
CONST
    sOK                 = "+++ ";
    sPROBLEM            = "--- ";
    sINFO               = "::: ";
    sCANCELLED          = "--- ";  (* not a problem but show nothing was done *)
    sWARN               = "*** ";
    sNOTICE             = "    ";  (* question to user *)
    sFAKE               = " ;-)";  (* suffix *)
    sDBG                = "// ";
CONST
    sRANDBYTE           = "??";
    sRANDBUFFER         = "**";
    sRANDBUFFERREGEN    = "@@"; (* will be slower, much slower *)
    sDefaultBytePattern = "$00";
    sPassesRange        = "[1..48]"; (* insane upper value for paranoiacs ! *)
CONST
    flagPATBYTE         = 0; (* $## *)
    flagPATRNDBYTE      = 1; (* ?? *)
    flagPATRNDBUFF      = 2; (* ** *)
    flagPATRNDBUFFREGEN = 3; (* @@ *)
CONST
    allitemsperpass  = 0; (* all items for each pass step : default *)
    allpassesperitem = 1; (* all passes one item at a time *)
CONST
    extDOC              = dot+"DOC";
    extEXE              = dot+"EXE";
    extINI              = dot+"INI";
CONST
    (* lowercasealt *)
    fSwapWin92    = "386spart.par";
    fSwapWin98    = "win386.swp";
    fSwapWinXP    = "pagefile.sys";
    patSwapWin92  = "*\"+fSwapWin92;
    patSwapWin98  = "*\"+fSwapWin98;
    patSwapWinXP  = "*\"+fSwapWinXP;
CONST
    minProtected    = 1;
    maxProtected    = 64; (* at least 3 ! *)
    strMaxProtected = "64";

(* ------------------------------------------------------------ *)

CONST
    progEXEname      = "WIPEFILE";
    progTitle        = "Q&D Zero File Data";
    progVersion      = "v1.0";
(*%F UBCD  *)
    progCopyright    = "by PhG";
(*%E *)
(*%T UBCD  *)
    progCopyright    = "by Philippe Guiochon";
(*%E *)
    progBanner       = progTitle+" "+progVersion+" "+progCopyright;

CONST
    errNone            = 0;
    errHelp            = 1;
    errMissingParm     = 2;
    errOption          = 3;
    errTooManyParms    = 4;
    errBadBytePattern  = 5;
    errNoMatch         = 6;
    errProtection      = 7;
    errStorage         = 8;
    errNetSlash        = 9;
    errPhantomUnit     = 10;
    errBadUnit         = 11;
    errColon           = 12;
    errNoParent        = 13;
    errInnerParent     = 14;
    errDirJoker        = 15;
    errEntryIsFile     = 16;
    errEntryNotFound   = 17;
    errMoreHelp        = 18;

    errDoc             = 19;
    errRedirected      = 20;

    errCancelled       = 192;

    errAborted         = 255;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
    placeholder     = "|";
    helpplaceholder = "~"; (* vbar is used in text *)
    msgBEWARE =
"BE SURE TO KNOW WHAT YOU ARE DOING ! USE THIS OPTION AT YOUR OWN RISK !";
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)

msgHelp =
progBanner+nl+
nl+
"Syntax : "+progEXEname+" <file(s)> [option]..."+nl+
nl+
"This program overwrites file(s) data using specified byte pattern"+nl+
'(one byte per pass, default pattern is "'+sDefaultBytePattern+'").'+nl+
nl+
"-apply REALLY apply any requested modification to existing data"+nl+
'       (default is to fake requested modification, as shown by "'+sFAKE+'" trailer)'+nl+
"       "+msgBEWARE+nl+
"-yes   skip keyboard confirmation (unwise !)"+nl+
"       "+msgBEWARE+nl+
'-b:$   byte pattern (default is "'+sDefaultBytePattern+'")'+nl+
"-p     perform all passes one file at a time"+nl+
"-a     use alternate random number generator"+nl+
"-esc   disable ESCape polling (unwise but may be necessary with Win9X/WinXP)"+nl+
"-s     recurse subdirectories"+nl+
"-x     ignore existing "+progEXEname+extINI+nl+
"-swaps do not default to swapfiles protection"+nl+
'       ("'+patSwapWin92+'", "'+patSwapWin98+'" and "'+patSwapWinXP+'")'+nl+
"-w     do not process read-only files (default is to ignore read-only status)"+nl+
"-k     delete file once its data have been overwritten"+nl+
"-j     filter files using operating system jokers (read note infra)"+nl+
"-l     disable LFN support even if available"+nl+
"-mem   ignore any Storage.ALLOCATE() error (unwise !)"+nl+
(*%T UBCD  *)
"-doc   show "+progEXEname+extDOC+" file then terminate"+nl+
(*%E  *)
"-??    more help (to be read at least once !)"+nl+
nl+
(*%F ENABLEREALUPDATE *)
"PLEASE NOTE THAT OVERWRITING FILES IS NOT ENABLED !"+nl+
nl+
(*%E  *)
"a) For safety, program does NOT really overwrite data"+nl+
"   unless any of -apply, -doit or -really options is specified."+nl+
"b) -b:$ option accepts a string with one hexadecimal value per pass :"+nl+
'   first "$" is mandatory as a reminder whatever data follows ;'+nl+
'   values can be either concatenated or separated with "'+space+'", "'+dot+'" or "'+coma+'" ;'+nl+
'   "'+sRANDBYTE+'" = one random byte, "'+sRANDBUFFER+'" = a '+sDATABUFFERSIZE+"-bytes repeated random buffer,"+nl+
'   "'+sRANDBUFFERREGEN+'" = a '+sDATABUFFERSIZE+"-bytes unique random buffer (slower). "+
"Passes range is "+sPassesRange+"."+nl+
"c) Without -e option, program allows the ESCape key to abort."+nl+
"   Overwriting is not reversible : data already overwritten is lost forever !"+nl+
'd) Without -j option, "?" and "*" jokers do NOT work the DOS or Win9X way :'+nl+
'   "?" matches exactly one character, "*" matches any sequence of characters.'+nl+
"e) -mem option may help with huge Win9X and WinXP directories,"+nl+
"   although all matching files will not be processed."+nl+
"f) -yes, -esc, -x and -mem options should NOT be used and are NOT recommended."+nl+
"g) -yesIdo and -dwIm options are shortcuts for -yes -really : use with caution."+nl+
"h) Data overwriting takes very long a time, especially with multiple passes :"+nl+
"   program may be best left unattended for hours while working."+nl+
'   Note "'+sRANDBUFFERREGEN+'" regularly recreates random buffer and is therefore very slow.'+nl;

msgMoreHelp =
"i) Up to "+strMaxProtected+" entries (M2 jokers supported) may be protected against overwriting,"+nl+
"   if they are specified in "+progEXEname+extINI+" file located in executable directory."+nl+
"   If such a file does not exist, these entries are protected by default :"+nl+
'   "'+patSwapWin92+'", "'+patSwapWin98+'" and "'+patSwapWinXP+'".'+nl+
"   Note this safety is not required if program is run from an alternate OS."+nl+
"j) "+helpplaceholder+nl+
"   "+helpplaceholder+nl+
(*%T UBCD  *)
"k) This DOS program was written with J.P.I. TopSpeed Modula-2 compiler."+nl+
(*%E  *)
nl+
"Example : "+progEXEname+' -s -e c:\SRC\*.cpp -b:"$de ad BE EF"'+nl+
nl+
"Here is an example of "+progEXEname+extINI+" file :"+nl+
nl+
"   ;"+nl+
"   ; Entries matching these patterns will NOT be overwritten."+nl+
"   ; M2 jokers are allowed :"+nl+
'   ; "?" matches exactly one character, "*" matches any sequence of characters.'+nl+
"   ; Entries may be enclosed with double quotes if necessary."+nl+
"   ;"+nl+
"   ; Vindoze swap files should always be protected in this INI file,"+nl+
"   ; unless program is run from another OS such as a DOS boot disk."+nl+
"   ;"+nl+
"   *\386spart.par"+nl+
"   *\win386.swp"+nl+
"   *\pagefile.sys"+nl+
"   ;"+nl+
'   "*\index.dat"'+nl+
"   *\desktop.ini"+nl;

VAR
    S : str1024; (* oversized for possible LFN *)
    ok : BOOLEAN;
    SS : str4096; (* should DO *)
    p:CARDINAL;
BEGIN
    CASE e OF
    | errHelp,errMoreHelp :
        WrStr(msgHelp);
        IF e # errHelp THEN
            Str.Copy(SS,msgMoreHelp);

            (* now tell user about WIPEFILE.INI *)

            Lib.ParamStr(S,0); (* retrieve executable location : yes, we assume it ! *)
            p:=Str.RCharPos(S,dot);
            IF p # MAX(CARDINAL) THEN S[p]:=charnull;END;
            Str.Append(S,extINI);

            IF FIO.Exists(S) THEN
                S:=progEXEname+extINI+" was found in executable directory :";
                Str.Subst(SS,helpplaceholder,S);
                S:="protection against overwriting is available for its entries (unless -x).";
            ELSE
                S:=progEXEname+extINI+" was NOT found in executable directory :";
                Str.Subst(SS,helpplaceholder,S);
                S:="protection against overwriting is limited to swapfiles (unless -swaps).";
            END;
            Str.Subst(SS,helpplaceholder,S);
            WrStr(SS);
        END;
        e:=errHelp;
    | errMissingParm:   S := "<file(s)> expected !";
    | errOption:        S := 'Unknown "|" option !';
    | errTooManyParms:  S := '"|" is one parameter too many !';
    | errBadBytePattern:S := 'Illegal "|" pattern !';
    | errNoMatch:       S := 'No legal match for "|" specification !';
    | errProtection:    S := progEXEname+extINI+" should be checked for problems !";
    | errStorage :      S := 'Storage.ALLOCATE() failure while processing "|" specification !';
    | errNetSlash :     S := 'Illegal server "\\" in "|" specification !';
    | errPhantomUnit :  S := 'Unavailable unit in "|" specification !';
    | errBadUnit :      S := 'Illegal unit in "|" specification !';
    | errColon :        S := 'Unexpected ":" in "|" specification !';
    | errNoParent :     S := 'Unresolvable ".." in "|" specification !';
    | errInnerParent :  S := 'Illegal ".." in "|" specification !';
    | errDirJoker :     S := 'Illegal "|" directory joker(s) !';
    (* next two are never displayed *)
    | errEntryIsFile:   S := '"|" specification is not a directory !';
    | errEntryNotFound: S := '"|" specification does not exist !';

    | errDoc:           S := progEXEname+extDOC+" was not found !";
    | errRedirected:    S := "Redirection is not allowed with | command !";
                        Str.Subst(S,placeholder,einfo);
                        video(progEXEname+" : ",TRUE);video(S,TRUE); (* send message to screen anyway ! *)

    | errCancelled:     S:="Cancelled by user !"; (* never displayed *)

    | errAborted  :     S:="Aborted by user !";
    ELSE
        S := "This is illogical, Captain !";
    END;

    CASE e OF
    | errNone, errHelp, errCancelled :
        ;
    ELSE
        Str.Subst(S,placeholder,einfo);
        WrStr(progEXEname+" : "); WrStr(S); WrLn;
    END;
    Lib.SetReturnCode(SHORTCARD(e));
    HALT;
END abort;

(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (16 * 512) + FIO.BufferOverhead; (* was 8 *)
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBufferType = ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
VAR
    ioBufferIn  : ioBufferType;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE dmp (S1:ARRAY OF CHAR   );
BEGIN
    WrStr(S1);WrLn;
END dmp;

PROCEDURE dmp2 (S1,S2:ARRAY OF CHAR   );
BEGIN
    WrStr(S1);WrStr(S2);WrLn;
END dmp2;

PROCEDURE dmp3 (S1,S2,S3:ARRAY OF CHAR   );
BEGIN
    WrStr(S1);WrStr(S2);WrStr(S3);WrLn;
END dmp3;

PROCEDURE dmp5 (S1,S2,S3,S4,S5:ARRAY OF CHAR);
BEGIN
    WrStr(S1);WrStr(S2);WrStr(S3);WrStr(S4);WrStr(S5);WrLn;
END dmp5;

PROCEDURE dmp6 (S1,S2,S3,S4,S5,S6:ARRAY OF CHAR);
BEGIN
    WrStr(S1);WrStr(S2);WrStr(S3);WrStr(S4);WrStr(S5);WrStr(S6);WrLn;
END dmp6;

PROCEDURE fmtlc (v:LONGCARD;base:CARDINAL;wi:INTEGER;ch,prefix:CHAR) : str80;
VAR
    R : str80;
    ok: BOOLEAN;
    i : CARDINAL;
BEGIN
    Str.CardToStr(v,R,base,ok);
    FOR i:= Str.Length(R)+1 TO ABS(wi) DO
        IF wi < 0 THEN
            Str.Append(R,ch);
        ELSE
            Str.Prepend(R,ch);
        END;
    END;
    IF base=16 THEN Str.Lows(R);END;
    Str.Prepend(R,prefix);
    RETURN R;
END fmtlc;

PROCEDURE fmtcard (v:CARDINAL;base:CARDINAL;wi:INTEGER;ch,prefix:CHAR) : str80;
BEGIN
    RETURN fmtlc(LONGCARD(v),base,wi,ch,prefix);
END fmtcard;

PROCEDURE fmtbignum (base,wi:CARDINAL;v:LONGCARD):str16;
VAR
    i : CARDINAL;
    R:str16;
    ok,lo:BOOLEAN;
    pad,prefix,suffix:CHAR;
BEGIN
    CASE base OF
    | 16: pad:="0";prefix:="$"; suffix:=""; lo:=TRUE;
    ELSE
          pad:=" ";prefix:= ""; suffix:=""; lo:=FALSE;
    END;
    Str.CardToStr ( v, R, base, ok);
    FOR i:=Str.Length(R)+1 TO wi DO Str.Prepend(R,pad);END;
    IF lo THEN Str.Lows(R); END;
    Str.Prepend(R,prefix);Str.Append(R,suffix);
    RETURN R;
END fmtbignum;

PROCEDURE fmtnum (base,wi:CARDINAL;v:CARDINAL):str16;
BEGIN
    RETURN fmtbignum(base,wi,LONGCARD(v));
END fmtnum;

(* ------------------------------------------------------------ *)

PROCEDURE dbg (DEBUG,enquote:BOOLEAN;S1,S2:ARRAY OF CHAR );
CONST
    wi = 25-3-1;
VAR
    i:CARDINAL;
BEGIN
    IF NOT(DEBUG) THEN RETURN; END;
    WrStr(sDBG);
    WrStr(S1);
    FOR i:=Str.Length(S1)+1 TO wi DO WrStr(" ");END;
    WrStr(' : ');
    IF enquote THEN WrStr('"');END;
    WrStr(S2);
    IF enquote THEN WrStr('"');END;
    WrLn;
END dbg;

PROCEDURE dbgbool (DEBUG,TF:BOOLEAN;S1,ST,SF:ARRAY OF CHAR   );
BEGIN
    IF TF THEN
        dbg(DEBUG,FALSE,S1,ST);
    ELSE
        dbg(DEBUG,FALSE,S1,SF);
    END;
END dbgbool;

PROCEDURE dbgc (DEBUG:BOOLEAN;S1:ARRAY OF CHAR;v:CARDINAL);
BEGIN
    dbg(DEBUG,FALSE,S1,fmtcard(v,10,1,"",""));
END dbgc;

PROCEDURE dbglc (DEBUG:BOOLEAN;S1:ARRAY OF CHAR;v:LONGCARD);
BEGIN
    dbg(DEBUG,FALSE,S1,fmtlc(v,10,1,"",""));
END dbglc;

PROCEDURE dbgpat (DEBUG:BOOLEAN;i,flag:CARDINAL;b:BYTE);
VAR
    S:str16;
BEGIN
    IF NOT(DEBUG) THEN RETURN; END;
    WrStr(sDBG);
    WrStr(fmtcard(i,10,2,"",""));
    WrStr(" : ");
    CASE flag OF
    | flagPATBYTE:
                          S:="byte (|)";
                          Str.Subst(S,"|",fmtcard(CARDINAL(b),16,2,"0","$"));
    | flagPATRNDBYTE:     S:="random byte";
    | flagPATRNDBUFF:     S:="random buffer";
    | flagPATRNDBUFFREGEN:S:="RANDOM buffer";
    END;
    WrStr(S);WrLn;
END dbgpat;

CONST
    CHKEVERY9X = 64; (* let's call chkEscape every CHKEVERY LOOP *)
    CHKEVERYDOS= 4;  (* safety *)

PROCEDURE pollEscape (VAR chkrounds:CARDINAL; useLFN,ignoreESC:BOOLEAN):BOOLEAN;
VAR
    alcatraz:BOOLEAN;
    every:CARDINAL;
BEGIN
    (*
    9x really does NOT like ChkEscape() and randomly hangs till a keypress
    Flushkey() does NOT help
    *)
    (*
    IF useLFN THEN
        hit:=FALSE;
    ELSE
        hit:=ChkEscape();
    END;
    *)
    IF ignoreESC THEN RETURN FALSE;END;
    IF useLFN THEN
        every:=CHKEVERY9X;
    ELSE
        every:=CHKEVERYDOS;
    END;
    INC(chkrounds);
    IF (chkrounds MOD every) = 0 THEN
        chkrounds:=0;
        alcatraz:=ChkEscape();
    ELSE
        alcatraz:=FALSE;
    END;
    RETURN alcatraz;
END pollEscape;

PROCEDURE runningManager (  ):BOOLEAN;
BEGIN
    RETURN FALSE; (* //FIXME *)
END runningManager;

(* ------------------------------------------------------------ *)

(* adapted from VITAL *)

PROCEDURE getkbd (VAR c1,c2:CHAR);
BEGIN
    BiosFlushkey(); (* useless against DOSKEY ! *)
    BiosWaitkey(c1,c2);
END getkbd;

(* we can use video here because we know redirection cannot happen here *)

PROCEDURE ShallWeProceed (firsttime:BOOLEAN):BOOLEAN;
CONST
    acceptA = "<^F9>"; acceptA1 = CHR(0); acceptA2 = CHR(102);
    acceptB = "<^F1>"; acceptB1 = CHR(0); acceptB2 = CHR(94);
VAR
    S : str128;
    c1,c2 , expected1,expected2:CHAR;
BEGIN
    CASE firsttime OF
    | TRUE:
        S:=sNOTICE+acceptA+" to perform requested operation : ";
        expected1:=acceptA1;
        expected2:=acceptA2;
    | FALSE:
        S:=sNOTICE+"Now, "+acceptB+" to _perform_ requested operation : ";
        expected1:=acceptB1;
        expected2:=acceptB2;
    END;
    video(S,TRUE);
    getkbd(c1,c2);
    video(S,FALSE);
    IF ((c1=expected1) AND (c2=expected2) ) THEN
        RETURN TRUE;
    ELSE
        RETURN FALSE;
    END;
END ShallWeProceed;

PROCEDURE queryUser (AUTOCONFIRM:BOOLEAN;msg:ARRAY OF CHAR):BOOLEAN;
VAR
    letsdoit:BOOLEAN;
BEGIN
    IF AUTOCONFIRM THEN
        letsdoit := TRUE;
    ELSE
        dmp(msg);
        letsdoit := FALSE;
        IF ShallWeProceed(TRUE) THEN
            IF ShallWeProceed(FALSE) THEN
                (* dmp(sINFO+"Update confirmed twice !"); *)
                letsdoit:=TRUE;
            ELSE
                dmp(sCANCELLED+"Update cancelled"); (* " at second thought" *)
            END;
        ELSE
            dmp(sCANCELLED+"Update cancelled");
        END;
    END;
    RETURN letsdoit;
END queryUser;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* clever is not always faster : dynamic string allocation is much slower here -- and yes, we've tried it *)

VAR
    entryprotected      : ARRAY [minProtected..maxProtected] OF pathtype;

PROCEDURE preprocessLine (VAR S:pathtype);
VAR
    len:CARDINAL;
BEGIN
    LtrimBlanks(S);
    RtrimBlanks(S);
    (* we could use Str.Match(S,dquote+"*"+dquote) but... *)
    len:=Str.Length(S);
    IF len < 2 THEN RETURN; END; (* at least 1+1 for possible dquote+dquote *)
    IF S[len-1] # dquote THEN RETURN; END;
    IF S[0] # dquote THEN RETURN; END;
    S[len-1]:=charnull;
    Str.Delete(S,0,1);
    (* just in case *)
    LtrimBlanks(S);
    RtrimBlanks(S);
END preprocessLine;

(*
             ignoreini    forceswapfilesprotection
default      FALSE        TRUE
-swap        ?            FALSE
-x           TRUE         ?

if ini exists, its content override default protection unless -x was specified
if no ini, swapfiles protected unless -swaps
*)

PROCEDURE swapfilesprotectionFIX (forceswapfilesprotection,inihere,ignoreini:BOOLEAN):BOOLEAN;
BEGIN
    IF inihere THEN
        IF NOT(ignoreini) THEN
            forceswapfilesprotection:=FALSE; (* override possible default : user is responsible for ini entries *)
        END;
    END;
    RETURN forceswapfilesprotection;
END swapfilesprotectionFIX;

PROCEDURE initProtected (VAR lastprotected:CARDINAL;
                        ignoreini,forceswapfilesprotection,useLFN,DEBUG:BOOLEAN):BOOLEAN;
VAR
    ini,fpat : pathtype;
    hin:FIO.File;
    p,i,pb:CARDINAL;
    S:str1024;
    inihere:BOOLEAN;
BEGIN
    Lib.ParamStr(ini,0);
    p:=Str.RCharPos(ini,dot);
    IF p # MAX(CARDINAL) THEN ini[p]:=charnull;END;
    Str.Append(ini,extINI);
    inihere:=fileExists(useLFN,ini);

    forceswapfilesprotection:=swapfilesprotectionFIX(forceswapfilesprotection, inihere,ignoreini);
    dbgbool(DEBUG,forceswapfilesprotection,"force swapfiles protection","yes","no");

    lastprotected := minProtected-1;

    IF forceswapfilesprotection THEN
        FOR i:= 1 TO 3 DO
            CASE i OF
            | 1: S:=patSwapWin92;
            | 2: S:=patSwapWin98;
            | 3: S:=patSwapWinXP;
            END;
            INC(lastprotected);
            Str.Copy(entryprotected[lastprotected],S);
            IF DEBUG THEN
                WrStr("forced protected entry : ");WrStr(S);WrLn;
            END;
        END;
    END;

    IF ignoreini THEN RETURN TRUE; END;
    IF NOT(inihere) THEN RETURN TRUE; END;

    hin:=fileOpenRead(useLFN,ini);
    FIO.AssignBuffer(hin,ioBufferIn);

    pb:=0;

    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hin,fpat);
        IF FIO.EOF THEN EXIT; END;

        preprocessLine (fpat);

        CASE fpat[0] OF
        | CHR(0), semicolon,pound :
            ;
        ELSE
            LowerCaseAlt(fpat); (* keep accents *)

            INC(lastprotected);
            IF lastprotected > maxProtected THEN INC(pb);EXIT;END;
            entryprotected[lastprotected]:=fpat;
            IF DEBUG THEN
                S:="Protected entry | : |";
                Str.Subst(S,"|",fmtnum(10,2,lastprotected));
                IF useLFN THEN Str.Subst(S,"|",'"|"');END;
                Str.Subst(S,"|",fpat);
                WrStr(S);WrLn;
            END;
        END;
    END;
    FIO.Close(hin);
    RETURN (pb=0);
END initProtected;

PROCEDURE processMe (lastentry:CARDINAL;S:pathtype):BOOLEAN; (* ok=process it *)
VAR
    i:CARDINAL;
    rc,ok:BOOLEAN;
BEGIN
    rc:=TRUE;
    IF lastentry < minProtected THEN RETURN rc; END;
    LowerCaseAlt(S);
    i:=minProtected-1;
    LOOP
        INC(i);
        IF i > lastentry THEN EXIT; END;
        ok:=Str.Match(S,entryprotected[i]);
        IF ok THEN
            rc:=FALSE;
            EXIT;
        END;
    END;
    RETURN rc;
END processMe;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* code adapted from NEWLINE *)

PROCEDURE doGetDir (useLFN:BOOLEAN;currdrive:SHORTCARD;
                   VAR currdir: pathtype);
VAR
    longform:pathtype;
    rc:CARDINAL;
BEGIN
    FIO.GetDir(currdrive,currdir); (* we could use 0 for default drive *)
    IF useLFN THEN
        IF w9XshortToLong(currdir,rc,longform) THEN
            Str.Copy(currdir,longform);
            (* seems this function always returns "u:\*" form  *)
            IF currdir[1]=colon THEN Str.Delete(currdir,0,2);END;
        END;
    END;
END doGetDir;

(* u, "\*\", "u:\*\" *)

PROCEDURE getAnchor (useLFN:BOOLEAN;
                     VAR currdrive:SHORTCARD;
                     VAR currdir,currpath:pathtype);
VAR
    driveletter:CHAR;
BEGIN
    currdrive := FIO.GetDrive(); (* 1=A, etc. *)
    doGetDir(useLFN,currdrive, currdir);
    fixDirectory(currdir);
    driveletter := CHAR (currdrive+ORD("A")-1);
    Str.Concat(currpath, driveletter,colon);
    Str.Append(currpath, currdir);
END getAnchor;

(* code adapted from FCOMP v1.3c *)

(* minimalist *)

PROCEDURE buildParent (VAR parent:pathtype; current:pathtype):BOOLEAN;
VAR
    p:CARDINAL;
BEGIN
    IF Str.Match(current,"\") THEN RETURN FALSE; END;
    unfixDirectory(current);
    p:=Str.RCharPos(current,"\");
    Str.Slice(parent,current,0,p+1); (* keep final "\" *)
    RETURN TRUE;
END buildParent;

PROCEDURE doGetCurrent (useLFN:BOOLEAN;drive:SHORTCARD;
                       VAR unit:str2; VAR current:pathtype);
VAR
    rc:CARDINAL;
    longform:pathtype;
BEGIN
    Str.Concat(unit, CHR( ORD("A")-1+ORD(drive) ),colon);

    FIO.GetDir(drive,current); (* \path without u: nor trailing \ except at root *)
    IF current[1] # colon THEN Str.Prepend(current,unit); END; (* safety *)
    IF useLFN THEN
        IF w9XshortToLong(current,rc,longform) THEN (* if error, keep DOS current *)
            Str.Copy(current,longform);
        END;
    END;
    (* LFN function seems to always return "u:\*" form except at root *)
    IF current[1] = colon THEN Str.Delete(current,0,2);END; (* safety *)
    fixDirectory(current);
END doGetCurrent;

(*
    remember dirs can have an extension, and LFNs can have inner dots !
    we handle (whether u: or not) :

    .        current
    ..       parent
    .\xxx    current\xxx       F/D
    ..\xxx   parent\xxx        F/D

    xxx\     current\xxx\
    xxx\.    current\xxx\
    xxx      current\xxx       F/D

    \xxx\    \xxx\
    \xxx     \xxx              F/D
*)

PROCEDURE chkfixSpec (VAR base,spec:pathtype;
                     useLFN:BOOLEAN;orgS:pathtype;HDletters:ARRAY OF CHAR):CARDINAL;
VAR
    p,len,rc:CARDINAL;
    drive:SHORTCARD;
    u:CHAR;
    unit:str2;
    current,parent,S:pathtype;
    ok:BOOLEAN;
BEGIN
    Str.Copy(S,orgS);
    IF Str.Pos(S,"\\") # MAX(CARDINAL) THEN RETURN errNetSlash;END;

    (* process u: in S *)

    CASE CharCount(S,colon) OF
    | 0 :
        drive := FIO.GetDrive();
        rc:=errNone;
    | 1 :
        IF Str.CharPos(S,colon) = 1 THEN
            u:=CAP( S[0] );
            CASE u OF
            | "A".."Z" :
                IF verifyString(u,HDletters) THEN
                    drive := SHORTCARD( ORD(u) - ORD("A") +1 );
                    Str.Delete(S,0,2); (* remove u: *)
                    rc:=errNone;
                ELSE
                    rc:=errPhantomUnit;
                END;
            ELSE
                rc:=errBadUnit;
            END;
        ELSE
            rc:=errColon;
        END;
    ELSE
        rc:=errColon;
    END;
    IF rc # errNone THEN RETURN rc; END;

    (* note S no longer has u: *)

    doGetCurrent(useLFN,drive, unit,current); (* "u:" and "\" or "\*\" *)
    ok:=buildParent(parent, current);

    IF same(S,".") THEN Str.Copy(S,current);END;
    IF same(S,"..") THEN
        IF ok THEN Str.Copy(S,parent) ELSE RETURN errNoParent; END;
    END;
    IF Str.Match(S,".\*") THEN Str.Subst(S,".\",current); END;
    IF Str.Match(S,"..\*") THEN
        IF ok THEN Str.Subst(S,"..\",parent) ELSE RETURN errNoParent;END;
    END;
    IF Str.Match(S,"\*")=FALSE THEN Str.Prepend(S,current);END;
    IF Str.Match(S,"*\.") THEN
        (* S[Str.Length(S)-1]:=0C; *)
        len:=Str.Length(S);
        Str.Delete(S,len-1,1);
    END;
    (* we don't want inner or trailing ".." now *)
    IF Str.Pos(S,"..") # MAX(CARDINAL) THEN RETURN errInnerParent;END;

    (* base = "u:\xxx\" and spec = "xxx" *)

    IF Str.Match(S,"*\") THEN
        Str.Concat(base,unit,S);
        Str.Copy(spec,"*.*");
    ELSE
        Str.Prepend(S,unit);
        (* S is u:[\xxx]... without trailing "\" *)
        len:=Str.Length(S);
        p:=Str.RCharPos(S,"\");
        Str.Slice(base,S,0,p+1);
        Str.Slice(spec,S,p+1,len-p);
        IF chkJoker(spec)=FALSE THEN (* if spec has joker(s), assume files *)
            (* spec has no joker : dir or file ? *)
            IF fileIsDirectorySpec(useLFN,S) THEN
                Str.Copy(base,S);
                fixDirectory(base); (* safety *)
                Str.Copy(spec,"*.*");
            ELSE
                (* //FIXED hopefully : either entry not found, or found a file *)
                IF fileExists(useLFN,S) THEN
                    IF Str.RCharPos(spec,".")=MAX(CARDINAL) THEN
                        Str.Append(spec,"."); (* file extension *)
                    END;
                    RETURN errEntryIsFile;
                ELSE
(* T FIXCHKFIXSPEC *)
                    IF Str.RCharPos(spec,".")=MAX(CARDINAL) THEN
                        Str.Append(spec,".*");
                        Str.Append(S   ,".*");
                    END;
                    IF fileExists(useLFN,S) THEN
                        RETURN errEntryIsFile;
                    ELSE
                        RETURN errEntryNotFound;
                    END;
(* E  *)
(* F FIXCHKFIXSPEC
                    RETURN errEntryNotFound;
   E  *)
                END;
            END;
        END;
    END;
    IF chkJoker(base) THEN RETURN errDirJoker; END;
    (* //FIXED hopefully *)
    IF Str.Length(base) > 3 THEN (* "u:\" is assumed to always exist *)
        unfixDirectory(base);
        IF fileExists(useLFN,base)=FALSE THEN RETURN errEntryNotFound;END;
        fixDirectory(base);
    END;
    RETURN errNone;
END chkfixSpec;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    firstindex = 1; (* because we'll need 1-1 *)
TYPE
    pEntry = POINTER TO entryType;
    entryType = RECORD
        next      : pEntry;
        index     : CARDINAL;  (* [1.. is ID of base dir for files *)
        slen      : SHORTCARD;
        str       : CHAR;
    END;

PROCEDURE initList (VAR anchor : pEntry );
BEGIN
    anchor := NIL;
END initList;

PROCEDURE freeList (anchor : pEntry);
VAR
    needed : CARDINAL;
    p      : pEntry;
BEGIN
    (* p:=anchor; *)
    WHILE anchor # NIL DO
        needed := SIZE(entryType) - SIZE(anchor^.str) + CARDINAL(anchor^.slen);
        p := anchor^.next;
        DEALLOCATE(anchor,needed);
        anchor:=p;
    END
END freeList;

PROCEDURE buildNewPtr (VAR anchor,p:pEntry; len:CARDINAL):BOOLEAN;
VAR
    needed : CARDINAL;
BEGIN
    needed := SIZE(entryType) - SIZE(p^.str) + len;
    IF Available(needed)=FALSE THEN RETURN FALSE; END;
    IF anchor = NIL THEN
        ALLOCATE(anchor,needed);
        p:=anchor;
    ELSE
        p:=anchor;
        WHILE p^.next # NIL DO
            p:=p^.next;
        END;
        ALLOCATE(p^.next,needed);
        p:=p^.next;
    END;
    p^.next := NIL;
    RETURN TRUE;
END buildNewPtr;

(* ------------------------------------------------------------ *)

(* assume p is valid *)

PROCEDURE getStr (VAR S : pathtype; p:pEntry);
VAR
    len:CARDINAL;
BEGIN
    len := CARDINAL(p^.slen);
    Lib.FastMove( ADR(p^.str),ADR(S),len);
    S[len] := nullchar; (* REQUIRED safety ! *)
END getStr;

PROCEDURE findByIndex(wanted:CARDINAL;anchor:pEntry) : pEntry;
VAR
    p:pEntry;
BEGIN
    p := anchor;
    LOOP
        IF p = NIL THEN EXIT;END; (* gloups ! should NEVER happen ! *)
        IF p^.index = wanted THEN EXIT; END;
        p := p^.next;
    END;
    RETURN p;
END findByIndex;

PROCEDURE isReservedEntry (S:ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dotdot);
END isReservedEntry;

PROCEDURE buildDirList (VAR lastdir:CARDINAL; VAR anchor:pEntry;
                       useLFN,recurse:BOOLEAN;base:pathtype):CARDINAL;
VAR
    p: pEntry;
    len : CARDINAL;
    root,rootspec,entryname,newroot : pathtype;
    entry : FIO.DirEntry;
    ok,found : BOOLEAN;
    w9Xentry : findDataRecordType;
    unicodeconversion:unicodeConversionFlagType;
    dosattr:FIO.FileAttr;
    w9Xhandle,errcode:CARDINAL;
    rc : CARDINAL;
BEGIN
    Str.Copy(root,base);
    fixDirectory(root); (* safety *)

    (* assume base exists ! *)

    len:=Str.Length(root);
    IF buildNewPtr(anchor,p,len)=FALSE THEN RETURN errStorage; END;
    INC(lastdir);
    p^.index     := lastdir;
    p^.slen      := SHORTCARD(len);
    Lib.FastMove ( ADR(root),ADR(p^.str),len );

    IF NOT(recurse) THEN RETURN errNone; END;

    Str.Concat(rootspec,root,"*.*");
    IF useLFN THEN
        found := w9XfindFirst (rootspec,SHORTCARD(everything),SHORTCARD(w9XnothingRequired),
                              unicodeconversion,w9Xentry,w9Xhandle,errcode);
    ELSE
        found := FIO.ReadFirstEntry(rootspec,everything,entry);
    END;
    WHILE found DO
        IF useLFN THEN
            Str.Copy(entryname,w9Xentry.fullfilename);
        ELSE
            Str.Copy(entryname,entry.Name);
        END;
        IF isReservedEntry (entryname) = FALSE THEN (* skip "." AND ".." *)
            IF useLFN THEN
                dosattr:=FIO.FileAttr(w9Xentry.attr AND 0FFH);
            ELSE
                dosattr:=entry.attr;
            END;
            IF (aD IN dosattr) THEN
                Str.Concat(newroot,root,entryname); (* u:\xx\ + xxx *)
                fixDirectory(newroot);
                rc:= buildDirList (lastdir,anchor,
                                  useLFN,recurse,newroot);
                IF rc # errNone THEN
                    IF useLFN THEN ok:=w9XfindClose(w9Xhandle,errcode); END;
                    RETURN rc;
                END;
            END;
        END;
        IF useLFN THEN
            found :=w9XfindNext(w9Xhandle, unicodeconversion,w9Xentry,errcode);
        ELSE
            found :=FIO.ReadNextEntry(entry);
        END;
    END;
    IF useLFN THEN ok:=w9XfindClose(w9Xhandle,errcode); END;
    RETURN errNone;
END buildDirList;

PROCEDURE dmpDirs (anchor:pEntry;useLFN:BOOLEAN);
CONST
    sInfo = 'DIR  index= ~  "~"'; (* file must always be last with this placeholder *)
VAR
    p : pEntry;
    R: pathtype;
    ok:BOOLEAN;
    S:str1024;   (* oversized *)
BEGIN
    p:=anchor;
    WHILE p # NIL DO
        getStr(R,p);
        Str.Copy(S, sInfo);  Str.Subst(S,"~",fmtcard(p^.index,10,5," ",""));
        Str.Subst(S,"~", R);
        WrStr(S);WrLn;
        p:=p^.next;
    END;
END dmpDirs;

PROCEDURE dmpFiles (fileanchor,diranchor:pEntry;dirindex:CARDINAL;useLFN:BOOLEAN);
CONST
    sInfo = 'File index= ~  "~"'; (* file must always be last with this placeholder *)
VAR
    p : pEntry;
    base,R: pathtype;
    ok:BOOLEAN;
    S:str1024;   (* oversized *)
BEGIN
    p:=findByIndex(dirindex,diranchor);
    getStr(base,p);

    p:=fileanchor;
    WHILE p # NIL DO
        getStr(R,p);
        Str.Copy(S, sInfo);
        Str.Subst(S,"~",fmtcard(p^.index,10,5," ",""));
        Str.Prepend(R,base);
        Str.Subst(S,"~", R);
        WrStr(S);WrLn;
        p:=p^.next;
    END;
END dmpFiles;

(* modified DD v1.0h sub *)

PROCEDURE storeFiles (VAR lastfile:CARDINAL;
                     VAR fileanchor : pEntry;
                     useLFN,OSJOKERS:BOOLEAN; base,spec:pathtype):CARDINAL;
VAR
    matchspec,rootspec,entryname : pathtype;
    w9Xentry : findDataRecordType;
    unicodeconversion:unicodeConversionFlagType;
    dosattr:FIO.FileAttr;
    w9Xhandle,errcode:CARDINAL;
    entry : FIO.DirEntry;
    ok,keepit,found : BOOLEAN;
    len:CARDINAL;
    pp:pEntry;
BEGIN
    lastfile     := firstindex-1; (* 0 *)
    initList(fileanchor);

    IF OSJOKERS THEN
        Str.Concat(rootspec,base,spec);
        Str.Copy(matchspec,"*");         (* match everything *)
    ELSE
        Str.Concat(rootspec,base,"*.*"); (* was spec before osjoker option *)
        Str.Copy(matchspec,spec);
    END;

    (* allfiles is a better choice than everything here *)
    IF useLFN THEN
        found := w9XfindFirst (rootspec,SHORTCARD(allfiles),SHORTCARD(w9XnothingRequired),
        unicodeconversion,w9Xentry,w9Xhandle,errcode);
    ELSE
        found := FIO.ReadFirstEntry(rootspec,allfiles,entry);
    END;
    WHILE found DO
        IF useLFN THEN
            Str.Copy(entryname,w9Xentry.fullfilename);
        ELSE
            Str.Copy(entryname,entry.Name);
        END;
        IF isReservedEntry (entryname) = FALSE THEN (* skip "." AND ".." *)
            IF useLFN THEN
                dosattr:=FIO.FileAttr(w9Xentry.attr AND 0FFH);
            ELSE
                dosattr:=entry.attr;
            END;

            ok := NOT (aD IN dosattr); (* was valid when we used everything attribute *)

            IF ok THEN
                (* if file has no extension, add it as a marker *)
                IF Str.RCharPos(entryname,".")=MAX(CARDINAL) THEN
                    Str.Append(entryname,".");
                END;
                ok:=Str.Match(entryname,matchspec); (* was spec *)
                IF ok THEN
                    len:=Str.Length(entryname);
                    IF buildNewPtr(fileanchor,pp,len)=FALSE THEN
                        IF useLFN THEN ok:=w9XfindClose(w9Xhandle,errcode); END;
                        RETURN errStorage;
                    END;
                    INC(lastfile);
                    pp^.index     := lastfile;
                    pp^.slen      := SHORTCARD(len);
                    Lib.FastMove ( ADR(entryname),ADR(pp^.str),len );
                END;
            END;
        END;
        IF useLFN THEN
            found :=w9XfindNext(w9Xhandle, unicodeconversion,w9Xentry,errcode);
        ELSE
            found :=FIO.ReadNextEntry(entry);
        END;
    END;
    IF useLFN THEN ok:=w9XfindClose(w9Xhandle,errcode); END;
    RETURN errNone;
END storeFiles;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* code adapted from UCLONE *)

PROCEDURE getvallc (VAR v : LONGCARD;
                   allowsepcosmetic:BOOLEAN;sepcosmetic:CHAR;
                   S:ARRAY OF CHAR):BOOLEAN;
VAR
    lc   : LONGCARD;
    base : CARDINAL;
    ok   : BOOLEAN;
BEGIN
    IF S[0]="$" THEN
        Str.Delete(S,0,1);
        base := 16;
    ELSE
        base := 10;
    END;
    IF sepcosmetic = "" THEN allowsepcosmetic:=FALSE;END; (* better safe than sorry *)
    IF allowsepcosmetic THEN ReplaceChar(S,sepcosmetic,"");END; (* clean cosmetic separators *)
    lc:=Str.StrToCard(S,base,ok);
    IF NOT(ok) THEN RETURN FALSE; END;
    IF lc > MAX(LONGCARD) THEN RETURN FALSE; END; (* gloups... how could such a thing be ? ;-) *)
    v := lc;
    RETURN TRUE;
END getvallc;

PROCEDURE getval (VAR v : CARDINAL;
                 allowsepcosmetic:BOOLEAN;sepcosmetic:CHAR;
                 S:ARRAY OF CHAR):BOOLEAN;
VAR
    lc:LONGCARD;
BEGIN
    lc := LONGCARD(v);
    IF getvallc(lc,allowsepcosmetic,sepcosmetic,S) THEN
        IF lc > MAX(CARDINAL) THEN
            RETURN FALSE;
        ELSE
            v := CARDINAL(lc);
            RETURN TRUE;
        END;
    ELSE
        RETURN FALSE;
    END;
END getval;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    firstpass = 1;
    maxpass   = 48;
VAR (* globerks *)
    bytepat    : ARRAY[firstpass..maxpass] OF BYTE;
    flagpat    : ARRAY[firstpass..maxpass] OF CARDINAL;
    databuffer : ARRAY[firstdatabuffer..maxdatabuffer] OF BYTE;

CONST
    MINBYTE = MIN(BYTE);
    MAXBYTE = MAX(BYTE);
CONST
    TSRAND = 0;
    QDRAND = 1;

PROCEDURE getRndByte ( randmethod:CARDINAL ):BYTE;
VAR
    v:CARDINAL;
BEGIN
    CASE randmethod OF
    | TSRAND:  v:=Lib.RANDOM(MAXBYTE+1);
    | QDRAND:  v:=GetRndCardRange(MINBYTE,MAXBYTE);
    END;
    RETURN BYTE(v);
END getRndByte;

PROCEDURE initRandom ( randmethod:CARDINAL  );
BEGIN
    CASE randmethod OF
    | TSRAND : Lib.RANDOMIZE();
    | QDRAND : InitRnd;
    END;
END initRandom;

PROCEDURE initDataBuffer (pass,randmethod:CARDINAL);
VAR
    i:CARDINAL;
    b:BYTE;
BEGIN
    CASE flagpat[pass] OF
    | flagPATBYTE  :
        b:=bytepat[pass];
        Lib.Fill(ADR(databuffer),databuffersize,b);
    | flagPATRNDBYTE   :
        b:=getRndByte(randmethod);
        Lib.Fill(ADR(databuffer),databuffersize,b);
    | flagPATRNDBUFF,flagPATRNDBUFFREGEN:
        FOR i:=firstdatabuffer TO maxdatabuffer DO
            databuffer[i]:=getRndByte(randmethod);
        END;
    END;
END initDataBuffer;

(* "$" + hexvalues either ## concatenated or separated with [ ,.] "??" "**" *)
(* assume S is already uppercased *)

CONST
    SEPCOSMETICFORBIDDEN = FALSE;
    SEPCOSMETICALLOWED   = TRUE;

PROCEDURE goodBytePattern (VAR lastpass:CARDINAL;
                          DEBUG:BOOLEAN;S:ARRAY OF CHAR):BOOLEAN;
CONST
    wihex = 2; (* "##", "??", "**" *)
VAR
    v,i:CARDINAL;
    useblank:BOOLEAN;
    N:str16;
    b:BYTE;
    flag:CARDINAL;
BEGIN
    dbg(DEBUG,TRUE,"Byte pattern string",S);
    CASE S[0] OF
    | charnull: RETURN FALSE;
    | dollar:   Str.Delete(S,0,1);
    ELSE
                RETURN FALSE;
    END;
    ReplaceChar(S,coma,blank);
    ReplaceChar(S,dot ,blank);
    useblank:=( Str.CharPos(S,blank) # MAX(CARDINAL) );
    IF useblank THEN
        lastpass:=argc (S,FALSE);
    ELSE
        v:=Str.Length(S);
        lastpass:= v DIV wihex;
        IF (lastpass * wihex) # v THEN RETURN FALSE;END; (* don't get mad, get EVEN *)
    END;
    IF lastpass > maxpass THEN RETURN FALSE;END;

    flag:=flagPATBYTE;
    b   :=0;
    FOR i:=firstpass TO maxpass DO
        flagpat[i]:=flag;
        bytepat[i]:=b;
    END;

    FOR i:=firstpass TO lastpass DO
        IF useblank THEN
            argv(N, S,i,FALSE);
            IF same(N,sRANDBYTE[0]) THEN (* quietly fix lazy user *)
                N:=sRANDBYTE;
            ELSIF same(N,sRANDBUFFER[0]) THEN (* the same *)
                N:=sRANDBUFFER;
            ELSIF same(N,sRANDBUFFERREGEN[0]) THEN (* the same *)
                N:=sRANDBUFFERREGEN;
            ELSE
                IF Str.Length(N) < wihex THEN Str.Prepend(N,"0");END;
            END;
        ELSE
            Str.Slice(N, S,(i-1)*wihex,wihex);
        END;
        dbg(DEBUG,TRUE,"hexstr",N);
        IF same(N,sRANDBYTE) THEN
            flag:=flagPATRNDBYTE;
            b   := 0;
        ELSIF same(N,sRANDBUFFER) THEN
            flag:=flagPATRNDBUFF;
            b   := 0;
        ELSIF same(N,sRANDBUFFERREGEN) THEN
            flag:=flagPATRNDBUFFREGEN;
            b   := 0;
        ELSE
            Str.Prepend(N,dollar); (* uppercase "$##" *)
            IF getval (v, SEPCOSMETICFORBIDDEN,"",N)=FALSE THEN RETURN FALSE;END;
            IF v > MAXBYTE THEN RETURN FALSE;END; (* $00..$FF only of course *)
            flag:=flagPATBYTE;
            b:=BYTE(v);
        END;
        flagpat[i]:=flag;
        bytepat[i]:=b;

        dbgpat(DEBUG,i,flag,b);

    END;
    RETURN TRUE;
END goodBytePattern;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE wipefile (ndx,randmethod:CARDINAL;
                   useLFN,REALLY,forceNEWRND:BOOLEAN;source:pathtype  );
CONST
    msg = "Overwriting, please wait... ";
VAR
    hnd:FIO.File;
    count,remaining:LONGCARD;
BEGIN
    video(msg,TRUE);
    count := fileGetFileSize(useLFN,source);

    hnd :=fileOpen(useLFN,source);
    FIO.AssignBuffer(hnd,ioBufferIn);
    FIO.EOF:=FALSE; (* useless safety *)

    remaining := count;
    LOOP
        IF forceNEWRND THEN initDataBuffer(ndx,randmethod);END;
        IF remaining <= LONGCARD(databuffersize) THEN
            IF REALLY THEN
(*%T ENABLEREALUPDATE  *)
                FIO.WrBin(hnd,databuffer, CARDINAL(remaining) );
(*%E  *)
            END;
            EXIT;
        END;
        IF REALLY THEN
(*%T ENABLEREALUPDATE  *)
            FIO.WrBin(hnd,databuffer,CARDINAL(databuffersize));
(*%E  *)
        END;
        DEC(remaining,LONGCARD(databuffersize));
    END;
    fileClose(useLFN,hnd);
    video(msg,FALSE);
END wipefile;

PROCEDURE procWipeFile (lastprotected,ndx,lastndx,randmethod:CARDINAL;
                       DEBUG,useLFN,SKIPRO,KILL,REALLY:BOOLEAN;
                       source:pathtype  );
VAR
    header,trailer,sval : str16;
    msg1,msg2:str80;
    forceNEWRND,wasRO,ok:BOOLEAN;
    v:CARDINAL;
BEGIN
    (* dbg(DEBUG,TRUE,"file",source); *)
    IF REALLY THEN
        trailer:="";
    ELSE
        trailer:=sFAKE;
    END;

    IF processMe(lastprotected,source)=FALSE THEN
        header:=sINFO;
        msg1:="Ignoring "+dquote;
        msg2:=dquote;
        dmp5(header,msg1,source,msg2,trailer);
        RETURN;
    END;

    ok:=TRUE;
    wasRO:=fileIsRO(useLFN,source);

    IF wasRO THEN
        IF SKIPRO THEN (* ignore it *)
            header:=sINFO;
            msg1:="Skipping RO "+dquote;
            msg2:=dquote;
            ok:=FALSE;
        ELSE
            header:=sOK;
            msg1:="Overwriting RO "+dquote;
            msg2:=dquote+" with |, pass |";

            fileSetRW(useLFN,source);

        END;
    ELSE
        header:=sOK;
        msg1:="Overwriting "+dquote;
        msg2:=dquote+" with |, pass |";
    END;
    forceNEWRND := FALSE;
    CASE flagpat[ndx] OF
    | flagPATBYTE :
        v:= CARDINAL( databuffer[ndx] );
        Str.Copy(sval,   fmtcard( v,16,2,"0","$") );
    | flagPATRNDBYTE:
        v:= CARDINAL( databuffer[ndx] );
        Str.Concat(sval, fmtcard( v,16,2,"0","$") , " (random)");
    | flagPATRNDBUFF:
        sval:="random bytes";
    | flagPATRNDBUFFREGEN:
        forceNEWRND := TRUE;
        sval:="RANDOM bytes";
    END;
    Str.Subst(msg2,"|",sval);
    Str.Subst(msg2,"|",fmtcard(ndx,10,1,"",""));

    dmp5(header,msg1,source,msg2,trailer);
    IF ok THEN
        wipefile(ndx,randmethod,useLFN,REALLY,forceNEWRND,source);
        IF ndx=lastndx THEN
            IF KILL THEN
                IF REALLY THEN
(*%T ENABLEREALUPDATE  *)
                    fileErase(useLFN,source);
(*%E  *)
                END;
                header:=sOK;
                IF wasRO THEN
                    msg1:='Deleted RO "';
                ELSE
                    msg1:='Deleted "';
                END;
                msg2:='"';
                dmp5(header,msg1,source,msg2,trailer);
            ELSE
                IF wasRO THEN fileSetRO(useLFN,source);END; (* reset RO attribute *)
            END;
        END;
    END;
END procWipeFile;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE showDoc (  ):BOOLEAN ;
CONST
    sb = 040H; (* segBiosData *)
CONST
    msgprompt = "(* Hit (almost) any key to continue or Escape to abort listing *) ";
    msgaborted= "(* Listing aborted by user ! *)";
    sCancel = str2( CHR(27) );
    initpagingcounter = 1; (* take msg into account *)
VAR
    biosCurrentRows       [sb:084H]  : BYTE;     (* add 1 *)
VAR
    hin:FIO.File;
    F,N:str128;
    S:str1024;
    p,lastrow,rowcount:CARDINAL;
    zekey:str2;
BEGIN
    Lib.ParamStr(F,0);
    p:=Str.RCharPos(F,dot);
    F[p] := charnull;
    Str.Append(F,extDOC);
    Str.Copy(N,F);
    p:=Str.RCharPos(N,antislash);
    Str.Delete(N,0,p+1);
    IF FIO.Exists(N)=FALSE THEN
        Str.Copy(N,F);
        IF FIO.Exists(N)=FALSE THEN RETURN FALSE;END;
    END;
    lastrow:=CARDINAL(biosCurrentRows)+1;
    rowcount:=initpagingcounter;
    hin:=FIO.OpenRead(N);
    FIO.EOF:=FALSE;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hin,S);
        WrStr(S);WrLn;
        INC(rowcount);
        IF rowcount >= lastrow THEN (* = is enough *)
            rowcount:=initpagingcounter;
            video(msgprompt,TRUE);
            Flushkey;
            zekey:=Waitkey();
            video(msgprompt,FALSE);
            IF same(zekey,sCancel) THEN WrStr(msgaborted);WrLn;EXIT;END;
        END;
    END;
    FIO.Close(hin);
    RETURN TRUE;
END showDoc;

(* ------------------------------------------------------------ *)

PROCEDURE fixStorageError (VAR rc:CARDINAL; ignoredstoragepb:CARDINAL;
                          fakeokstorage:BOOLEAN);
BEGIN
    IF rc=errStorage THEN
        IF fakeokstorage THEN
            rc:=errNone;
            INC(ignoredstoragepb);
        END;
    END;
END fixStorageError;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    cmdtype = (cmdnone,
               cmdfiles);

PROCEDURE newcmd (VAR cmd:cmdtype;wanted:cmdtype):BOOLEAN;
VAR
    ok:BOOLEAN;
BEGIN
    ok:=TRUE;
    IF cmd = cmdnone THEN
        cmd:=wanted;
    ELSIF cmd = wanted THEN
        ;
    ELSE
        ok:=FALSE;
    END;
    RETURN ok;
END newcmd;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    msgWait    = "Please wait... ";
    sWARN_FILES= sWARN+"About to wipe FILE(S) data";
CONST
    firstparm       = 1;
    maxparm         = 1;
VAR
    parm : ARRAY[firstparm..maxparm] OF pathtype;
    parmcount,i,opt,lastparm:CARDINAL;
    S,R:pathtype;
VAR
    currdrive:SHORTCARD;
    currdir,currpath,specbase,orgspec,spec,rootspec,basepath,zefile:pathtype;
    pdir,diranchor,pf,fileanchor:pEntry;
    rc,lastdir,dirindex,lastfile,fileindex:CARDINAL;
    sValidUnitsList : str80;
VAR
    bye,ok,DEBUG,useLFN : BOOLEAN;
    RECURSE,SKIPRO,OSJOKERS,KILL:BOOLEAN;
    flagIGNOREINI,flagFORCESWAPFILESPROTECTION : BOOLEAN;
    REALLY,IGNOREESCAPE,AUTOCONFIRM:BOOLEAN;
    FAKEOKSTORAGE : BOOLEAN;
    cSEPCOUNT,cSEPCOSMETIC:CHAR;
    chkrounds,IGNOREDSTORAGEPB,pass,passcount,subpass : CARDINAL;
    cmd:cmdtype;
    sBytePattern:str128;
    lc:LONGCARD;
    lastprotected,processmethod,randmethod,lastpass:CARDINAL;
BEGIN
    (* Lib.DisableBreakCheck(); *)
    FIO.IOcheck := FALSE;
    FIO.ShareMode:=FIO.ShareDenyNone; (* very, very important ! *)
    WrLn;

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,"");END;

    useLFN            := TRUE;

    cmd               := cmdfiles;
    REALLY            := FALSE;
    SKIPRO            := FALSE;
    RECURSE           := FALSE;
    OSJOKERS          := FALSE;
    sBytePattern      := sDefaultBytePattern; (* "$00" *)
    randmethod        := QDRAND;
    processmethod     := allitemsperpass;
    IGNOREESCAPE      := FALSE;
    AUTOCONFIRM       := FALSE;
    chkrounds         := 0;
    FAKEOKSTORAGE     := FALSE;
    IGNOREDSTORAGEPB  := 0;
    KILL              := FALSE;
    cSEPCOUNT         := coma;
    cSEPCOSMETIC      := dot;
    flagIGNOREINI     := FALSE; (* -x will force existing ini to be ignored *)
    flagFORCESWAPFILESPROTECTION := TRUE;
    DEBUG             := FALSE;

    lastparm          := firstparm-1;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R, "?"+delim+"H"+delim+"HELP"+delim+
                                  "DEBUG"+delim+
                                  "A"+delim+"ALTERNATE"+delim+
                                  "B:"+delim+"BYTES:"+delim+
                                  "L"+delim+"LFN"+delim+

                                  "APPLY"+delim+"REALLY"+delim+"DOIT"+delim+
                                  "UPDATE"+delim+"WRITE"+delim+
                                  "W"+delim+"SKIPRO"+delim+"IGNORERO"+delim+
                                  "S"+delim+"RECURSE"+delim+"SUBDIRS"+delim+

                                  "J"+delim+"JOKERS"+delim+"OS"+delim+
                                  "??"+delim+
                                  "MEM"+delim+"FAKE"+delim+
                                  "E"+delim+"ESC"+delim+"ESCAPE"+delim+
                                  "P"+delim+"ALLPASSES"+delim+"PERITEM"+delim+
                                  "K"+delim+"KILL"+delim+

                                  "YES"+delim+"OUI"+delim+"AUTOCONFIRM"+delim+
                                  "YESIDO"+delim+"DWIM"+delim+
                                  "X"+delim+"INI"+delim+"IGNOREINI"+delim+
                                  "SF"+delim+"SWAPS"+delim+"SWAPFILES"+delim+
                                  "DOC"+delim+"MAN"
                              );
            CASE opt OF
            | 1,2,3 :   abort(errHelp,"");
            | 4:        DEBUG             := TRUE;
            | 5,6:      randmethod        := TSRAND;
            | 7,8:      GetString(R,sBytePattern); (* too late now to fix silly parms order ! *)
                        ok:= goodBytePattern(lastpass, DEBUG,sBytePattern);
                        IF NOT(ok) THEN abort(errBadBytePattern,S); END;
            | 9,10:     useLFN            := FALSE;

            | 11,12,13: REALLY            := TRUE;
            | 14,15   : REALLY            := TRUE;
            | 16,17,18: SKIPRO            := TRUE;
            | 19,20,21: RECURSE           := TRUE;

            | 22,23,24: OSJOKERS          := TRUE;
            | 25:       abort(errMoreHelp,"");
            | 26,27:    FAKEOKSTORAGE     := TRUE;
            | 28,29,30: IGNOREESCAPE      := TRUE;
            | 31,32,33: processmethod     := allpassesperitem;
            | 34,35:    KILL              := TRUE;

            | 36,37,38: AUTOCONFIRM       := TRUE;
            | 39,40:    REALLY            := TRUE; AUTOCONFIRM := TRUE;
            | 41,42,43: flagIGNOREINI     := TRUE;
            | 44,45,46: flagFORCESWAPFILESPROTECTION := FALSE;
(*%T UBCD  *)
            | 47,48:    IF IsRedirected() THEN abort(errRedirected,"-doc");END;
                        IF showDoc()=FALSE THEN abort(errDoc,"");END;
                        abort(errNone,"");
(*%E  *)
            ELSE
                abort(errOption,S);
            END;
        ELSE
            INC(lastparm);
            IF lastparm > maxparm THEN abort(errTooManyParms,S);END;
            Str.Copy(parm[lastparm],S); (* keep case *)
        END;
    END;
    CASE lastparm OF
    | firstparm-1:
        abort(errMissingParm,"");
    | firstparm:   (* spec *)
        (* cmd:=cmdfiles; *)
        Str.Copy(orgspec,parm[firstparm]);
    END;

    useLFN:=( useLFN AND w9XsupportLFN() );

    initRandom(randmethod);

    CASE cmd OF
    | cmdfiles:

        dbg  (DEBUG,TRUE,"cmd","FILES");
        dbg  (DEBUG,TRUE,"orgspec",orgspec);
        ok:=goodBytePattern(lastpass, DEBUG,sBytePattern);

        IF initProtected (lastprotected,
                         flagIGNOREINI,flagFORCESWAPFILESPROTECTION,
                         useLFN,DEBUG)=FALSE THEN
            abort(errProtection,"");
        END;

        getAnchor(useLFN, currdrive,currdir, currpath); (* u, "\*\", "u:\*\" *)
        getAllLegalUnits(TRUE,TRUE,TRUE,sValidUnitsList); (* floppy,hd,CDROM *)

        rc:= chkfixSpec( specbase,spec, useLFN,orgspec,sValidUnitsList );
        CASE rc OF
        | errNone,errEntryIsFile,errEntryNotFound:
            ;
        ELSE
            abort(rc,orgspec);
        END;

        dbg  (DEBUG,TRUE,"specbase",specbase);
        dbg  (DEBUG,TRUE,"spec",spec);


        initList(diranchor); (* global *)
        lastdir            := firstindex-1; (* we can't init count in recursive buildDirList() *)

        video(msgWait,TRUE);
        rc:= buildDirList (lastdir, diranchor,  useLFN,RECURSE, specbase);
        video(msgWait,FALSE);

        fixStorageError (rc,IGNOREDSTORAGEPB,  FAKEOKSTORAGE);

        IF rc # errNone THEN abort(rc, orgspec); END;
        IF DEBUG THEN dmpDirs(diranchor,useLFN); END;
        (* first minimalist "no match" check *)
        IF lastdir < firstindex THEN abort(errNoMatch,orgspec);END;

        S:=sWARN_FILES;
        IF queryUser(AUTOCONFIRM,S) = FALSE THEN
            freeList(diranchor); (* yes we can NOW ! yes we MUST NOW TOO ! *)
            abort(errCancelled,"");
        END;

        CASE processmethod OF
        | allitemsperpass:  passcount:=lastpass;
        | allpassesperitem: passcount:=firstpass;
        END;

        FOR pass:=firstpass TO passcount DO
            pdir:=findByIndex(firstindex,diranchor); (* we know we've got at least one dir now *)
            getStr(rootspec,pdir);

            dirindex:=firstindex;
            LOOP
                IF dirindex > lastdir THEN EXIT; END;
                pdir:=findByIndex(dirindex,diranchor);
                getStr(basepath,pdir);

                rc:= storeFiles (lastfile, fileanchor,
                                useLFN,OSJOKERS, basepath,spec);

                fixStorageError (rc,IGNOREDSTORAGEPB,  FAKEOKSTORAGE);

                IF rc # errNone THEN abort(rc, orgspec); END;

                IF DEBUG THEN dmpFiles(fileanchor,diranchor,dirindex,useLFN); END;

                fileindex:=firstindex;
                LOOP
                    IF fileindex > lastfile THEN EXIT; END;
                    pf := findByIndex(fileindex,fileanchor);

                    getStr(zefile,pf);
                    Str.Prepend(zefile,basepath);

                    CASE processmethod OF
                    | allitemsperpass:
                        initDataBuffer(pass,randmethod);
                        procWipeFile (lastprotected,pass,lastpass,randmethod,
                                     DEBUG,useLFN,SKIPRO,KILL,REALLY,zefile);
                        bye:=pollEscape (chkrounds, useLFN,IGNOREESCAPE);
                        IF bye THEN abort(errAborted,"");END;
                    | allpassesperitem:
                        FOR subpass:=firstpass TO lastpass DO
                            initDataBuffer(subpass,randmethod);
                            procWipeFile (lastprotected,subpass,lastpass,randmethod,
                                         DEBUG,useLFN,SKIPRO,KILL,REALLY,zefile);
                            bye:=pollEscape (chkrounds, useLFN,IGNOREESCAPE);
                            IF bye THEN abort(errAborted,"");END;
                        END;
                    END;

                    INC(fileindex);
                END;
                freeList(fileanchor);
                INC(dirindex);
            END;
        END;

        (* // yes, we know we let good old DOS handle this with earlier abort() calls *)
        freeList(diranchor); (* yes we can NOW ! *)

        IF IGNOREDSTORAGEPB # 0 THEN
            dmp2(sPROBLEM,"Storage.ALLOCATE() failure errors did happen and were ignored !");
        END;

    END;

    abort(errNone,"");
END WipeFile.

