MODULE JPIsplit;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT IO;

FROM QD_ASCII IMPORT dash, slash, nullchar, tabchar, cr, lf, nl, bs,
space, dot, deg, degree, doublequote, quote, colon, percent, vbar,
blank, equal, dquote, charnull, singlequote, antislash, dollar,
star, backslash, coma, question, underscore, underbar, tabul, hbar,
comma, semicolon, diese, pound, openbracket, closebracket, tilde, exclam,
stardotstar, dotdot, escCh, escSet, letters, digits,
lettersUpp, lettersLow, openbrace, closebrace, ampersand;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite, setReadOnly,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs, UpperCaseAlt, LowerCaseAlt,
completedInit, completedShow, completedSHOW, completedEnd, completed,
removeDups, isValidHDunit, removePhantoms, removeFloppies,
getCDROMunits, getCDROMletters, removeCDROMs, getAllHDunits,
getAllLegalUnits, metaproc, getCli, argc, argv,
metaproc, UpperCaseFR, LowerCaseFR, ASCIIonly;

FROM IO IMPORT WrStr, WrLn;

(* ------------------------------------------------------------ *)

CONST
    exe      = "JPISPLIT";
    extTXT   = ".TXT";
    datafile = exe+extTXT;

PROCEDURE abort (errcode:CARDINAL; S:ARRAY OF CHAR);
BEGIN
    IF errcode # 0 THEN
        WrStr(exe+" : ");WrStr(S);WrLn;
    END;
    Lib.SetReturnCode(SHORTCARD(errcode));
    HALT;
END abort;

(* ------------------------------------------------------------ *)

(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;

(* ------------------------------------------------------------ *)

VAR
    S,R,udne,u,d,n,e:str1024;
    uu,dd,nn,ee:str1024;
    hin:FIO.File;
    ok:BOOLEAN;
BEGIN
    Lib.DisableBreakCheck();
    FIO.IOcheck := FALSE;
    WrLn;

    IF Lib.ParamCount() # 0 THEN abort(1,"JPI Lib.SplitAllPath()");END;
    IF FIO.Exists(datafile)=FALSE THEN abort(2,datafile+" does not exist !");END;

    hin:=FIO.OpenRead(datafile);
    WHILE NOT (FIO.EOF) DO
        FIO.RdStr(hin,S);
        LtrimBlanks(S);RtrimBlanks(S);
        CASE S[0] OF
        | charnull,semicolon,pound:
            ;
        ELSE
            R:='::: "$"';
            Str.Subst(R,"$",S);
            WrStr(R);WrLn;

            Lib.SplitAllPath(S,u,d,n,e);
            Lib.MakeAllPath(R,u,d,n,e);
            IF Str.Compare(S,R) # 0 THEN
                WrStr("--- rebuilt Lib seems wrong");WrLn;
                WrLn;
            END;
            qdSplitAllPath(S,uu,dd,nn,ee);

            ok:=same(u,uu);
            ok:=(ok AND same(d,dd));
            ok:=(ok AND same(n,nn));
            ok:=(ok AND same(e,ee));
            IF ok THEN
                WrStr("+++ Lib and QD results match");WrLn;
                R:='    U = "$"';  Str.Subst(R,"$",u);  WrStr(R);WrLn;
                R:='    D = "$"';  Str.Subst(R,"$",d);  WrStr(R);WrLn;
                R:='    N = "$"';  Str.Subst(R,"$",n);  WrStr(R);WrLn;
                R:='    E = "$"';  Str.Subst(R,"$",e);  WrStr(R);WrLn;
                WrLn;
            ELSE
                R:='    u = "$"';  Str.Subst(R,"$",u);  WrStr(R);WrLn;
                R:='    d = "$"';  Str.Subst(R,"$",d);  WrStr(R);WrLn;
                R:='    n = "$"';  Str.Subst(R,"$",n);  WrStr(R);WrLn;
                R:='    e = "$"';  Str.Subst(R,"$",e);  WrStr(R);WrLn;
                WrLn;
                R:='    uu= "$"';  Str.Subst(R,"$",uu);  WrStr(R);WrLn;
                R:='    dd= "$"';  Str.Subst(R,"$",dd);  WrStr(R);WrLn;
                R:='    nn= "$"';  Str.Subst(R,"$",nn);  WrStr(R);WrLn;
                R:='    ee= "$"';  Str.Subst(R,"$",ee);  WrStr(R);WrLn;
                WrLn;
            END;
        END;
    END;
    FIO.Close(hin);

    abort(0,"");
END JPIsplit.




(*


; classic cases

c:\z
foo.bar
foo
foo.
foo\bar.e
foo\bar
\foo\bar.baz

; inner dots

\foo.bar/baz.ext
\foobar/baz.ext

cd:foo.bar/baz.
cd:foobar/baz.

cd:foo.bar\baz
cd:foobar\baz

c:foo.bar/baz.bix\
c:foobar/bazbix\

c:foo.bar/baz.bix/eh
c:foobar/bazbix/eh

c:foo.bar/baz.bix/eh.
c:foobar/bazbix/eh.

*)