(* ---------------------------------------------------------------
Title         Q&D Roman Numerals Converter
Overview
Notes         now, everyone will be able to check MGM's movies dates ;-)
              stand alone (no QD_* code) version of ROMAN.MOD

              yet another overcomplicated development environment
              no autocap for reserved words (same as XDS)
              yet another probable definite no-no to me
              great : in the good old C tradition, you must bother to read DEFs
              in order to know what a library can do : not help for libs forces
              us to have a text editor with .DEFs opened ! how convenient !
              compiler is slow, compared to PBW
              libs don't seem prepared for real world programming but for (ahem) so-called academics
              no wonder demo programs from both ADW and XDS are so poorly made
              remember to check console app (options/linker/win32)
              glad := seems to be like Str.Copy() or Str.Assign() !
              curiouser and curiouser : when checking 1..3999, output to video is ok
              but redirected output misses last 3 lines !!!
Bugs
Wish List
--------------------------------------------------------------- *)

MODULE RomanADW;

IMPORT Strings;
IMPORT STextIO;
IMPORT WholeStr;
IMPORT Environment;
IMPORT ConvTypes;
IMPORT WIN32;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    cr            = CHR(13);
    lf            = CHR(10);
    nl            = cr+lf;
    digits        = "0123456789";
    nullchar      = 0C; (* CHR(0) *)
    charnull      = nullchar;
    space         = " ";
    blank         = space;
    slash         = "/";
    dash          = "-";
    delim         = ",";
    equal         = "=";
    colon         = ":";
    tabul         = CHR(9);
    doublequote   = '"';
    singlequote   = "'";

TYPE
    str1024= ARRAY [0..1023] OF CHAR;
    str256 = ARRAY [0..255] OF CHAR;
    str128 = ARRAY [0..127] OF CHAR;
    str16  = ARRAY [0..15] OF CHAR;
    str80  = ARRAY [0..79] OF CHAR;

PROCEDURE WrStr(S:ARRAY OF CHAR);
BEGIN
    STextIO.WriteString(S);    (* //ADW WriteString but WriteLn : go figure ! *)
END WrStr;

PROCEDURE WrLn();
BEGIN
    STextIO.WriteLn();
END WrLn;

PROCEDURE Prepend(VAR R : ARRAY OF CHAR; S:ARRAY OF CHAR);
VAR
    Z : str1024; (* hack should do -- we don't feel like really programming with ADW *)
BEGIN
    Z:=S;
    Strings.Append(R,Z);
    R:=Z;
END Prepend;

(* note we want TS mode : replacing fist occurrence, not all occurrences *)
PROCEDURE Subst (VAR S : ARRAY OF CHAR; oldstr,newstr : ARRAY OF CHAR);
VAR
    found:BOOLEAN;
    foundat, p,len : CARDINAL;
BEGIN
    Strings.FindNext(oldstr,S,0,found,foundat);
    IF found THEN
        len:=Strings.Length(oldstr);
        Strings.Delete(S,foundat,len);
        Strings.Insert(newstr,foundat,S); (* //ADW reversed logic here *)
    END;
END Subst;

PROCEDURE CharPos(S : ARRAY OF CHAR; c:CHAR) : CARDINAL;
VAR
    found : BOOLEAN;
    foundat : CARDINAL;
BEGIN
    (* //ADW yet another overcomplicated library forcing us to reinvent wheel *)
    Strings.FindNext (c, S, 0, found, foundat);
    IF NOT(found) THEN foundat := MAX(CARDINAL); END; (* let's hope it's okay with ADW *)
    RETURN foundat;
END CharPos;

PROCEDURE Pos(S,wanted : ARRAY OF CHAR) : CARDINAL;
VAR
    found : BOOLEAN;
    foundat : CARDINAL;
BEGIN
    (* //ADW yet another overcomplicated library forcing us to reinvent wheel *)
    Strings.FindNext (wanted, S, 0, found, foundat);
    IF NOT(found) THEN foundat := MAX(CARDINAL); END; (* let's hope it's okay with ADW *)
    RETURN foundat;
END Pos;

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Strings.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Strings.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

PROCEDURE ItemS(VAR str:ARRAY OF CHAR; options:ARRAY OF CHAR;delim:CHAR;i:CARDINAL);
BEGIN
    (* //TODO *)
    isoleItemS(str, options,delim,i);
END ItemS;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    RETURN ( CharPos(S,c) # MAX(CARDINAL) );
END Belongs;

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Strings.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    RETURN ( Strings.Equal(S1,S2) );
END same;

(* try and fix TopSpeed bug when tabs are in command line *)
(* try and fix our NEVER using tabs in any command line too ! *)

PROCEDURE cleantabs (VAR S : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=CharPos(S,tabul);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        (* S[p]:=Str.Delete(S,p,1); (* delete unwanted tabulation *) *)
        S[p]:=space;
    END;
END cleantabs;

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

CONST
    ignore = " ";
    (* darn, DOS and OEM are different but this should do for our test *)
    Tupper = "                                "+
             "                                "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             "CUEAAAACEEEIIIAAE  OOOUUYOU     "+ (* use "ae" *)
             "AIOUNN                          "+
             "                                "+
             "                              Y ";
    Tlower = "                                "+
             "                                "+
             " abcdefghijklmnopqrstuvwxyz     "+
             " abcdefghijklmnopqrstuvwxyz     "+
             "cueaaaaceeeoooaae  ooouuyou     "+ (* use "ae" *)
             "aiounn                          "+
             "                                "+
             "                              y ";

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Strings.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,Tupper);
        IF ch # ignore THEN S[i] := ch; END;
    END;
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Strings.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,Tlower);
        IF ch # ignore THEN S[i] := ch; END;
    END;
END LowerCase;


PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Strings.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i,p   : CARDINAL;
    str : str80; (* option tested against s *)
    tmp : str256; (* oversized *)
BEGIN
    Strings.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Strings.Append(delim, options); (* //ADW reversed logic *)

    Subst(S,equal,colon); (* command line option xxx= becomes xxx: *)
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        ItemS(str,options,delim,i);
        IF Strings.Length(str)=0 THEN RETURN 0; END;
        p:=CharPos(str,colon);
        IF p = MAX(CARDINAL) THEN (* normal option *)
            IF same(str,S) THEN RETURN (i+1); END;
        ELSE (* option with a number : cut S at colon *)
            Strings.Extract(S,0,p+1,tmp);
            IF same(str,tmp) THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;

(* //ADW passim : reversed logic for Strings.Append() *)

PROCEDURE argc (cli : ARRAY OF CHAR) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    cliLen   := Strings.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                (* arg:=ch; //ADW does not want us to concatenate a string and a char *)
                Strings.Assign(ch,arg);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Strings.Assign(ch,arg);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Strings.Append(ch,arg); (* //ADW reversed logic *)
            ELSIF code > ORD(blank) THEN
                Strings.Append(ch,arg);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Strings.Append(ch,arg);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Strings.Append(ch,arg);
            ELSE
                Strings.Append(blank,arg);    (* remove TAB and controls if any *)
            END;
        END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli)) ) THEN
        argument:="";
        RETURN;
    END;
    cliLen   := Strings.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Strings.Assign(ch,arg);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Strings.Assign(ch,arg);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Strings.Append(ch,arg);
            ELSIF code > ORD(blank) THEN
                Strings.Append(ch,arg);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Strings.Append(ch,arg);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Strings.Append(ch,arg);
            ELSE
                Strings.Append(blank,arg);    (* remove TAB and controls if any *)
            END;
        END;
        INC(cliPos);
    END;
    argument:=arg;
END argv;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    ProgEXEname   = "ROMAN";
    ProgTitle     = "Q&D Roman Numerals Converter";
    ProgVersion   = "v1.0";
    ProgCopyright = "by PhG";
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;

CONST
    errNone         = 0;
    errHelp         = 1;
    errOption       = 2;
    errParmOverflow = 3;
    errBadNum       = 4;
    errRomanRange   = 5;
    errBadRomanNum  = 6;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    helpmsg =
Banner+nl+
nl+
"Syntax 1 : "+ProgEXEname+" <number>... [option]..."+nl+
"Syntax 2 : "+ProgEXEname+" <first..last> [option]..."+nl+
nl+
"With syntax 1, this program converts a number from decimal to roman numerals"+nl+
"and from roman numerals to decimal. With syntax 2, it converts a range,"+nl+
"provided it is a valid one."+nl+
nl+
"   -l show output roman as lowercase roman (default is uppercase)"+nl+
"   -u show input roman as uppercase (default is lowercase)"+nl+
nl+
"a) Note valid range for roman numerals is [1..3999]."+nl+
nl+
"Examples : "+ProgEXEname+" -l 1963 3888"+nl+
"           "+ProgEXEname+" -u mcmlxiii mmmdccclxxxviii"+nl+
"           "+ProgEXEname+" 1..3999"+nl;

VAR
    S : str256;
BEGIN
    CASE e OF
    | errHelp :
        WrStr(helpmsg);
    | errOption :
        S:='Illegal "~" option !';
    | errParmOverflow:
        S:='"~" is one parameter too many !';
    | errBadNum:
        S:='Illegal "~" number !';
    | errRomanRange:
        S:='"~" does not belong to valid roman numerals range !';
    | errBadRomanNum:
        S:='"~" does not look like a valid roman number !';
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone, errHelp : ;
    ELSE
        Subst(S,"~",einfo);
        WrStr(ProgEXEname+" : ");WrStr(S);WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); *)
    WIN32.ExitProcess( VAL(WIN32.UINT, e ) );
    HALT;
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    strERROR = "??? ERROR ???";

PROCEDURE padstr (VAR R:ARRAY OF CHAR;wi:INTEGER;padchar:CHAR   );
VAR
    i:CARDINAL;
BEGIN
    FOR i:=Strings.Length(R)+1 TO VAL( CARDINAL , ABS(wi) ) DO (* //ADW why can't ABS be CARDINAL by default ? *)
        IF wi < 0 THEN
            Strings.Append(padchar, R); (* //ADW reversed logic *)
        ELSE
            Prepend(R,padchar);
        END;
    END;
END padstr;

PROCEDURE bignum2str (v:LONGCARD;base:CARDINAL;wi:INTEGER;padchar:CHAR):str16;
VAR
    R:str16;
    ok:BOOLEAN;
BEGIN
    WholeStr.CardToStr( v,R); (* //ADW less general than TS *)
    padstr(R,wi,padchar);
    RETURN R;
END bignum2str;

PROCEDURE num2str (v:CARDINAL;base:CARDINAL;wi:INTEGER;padchar:CHAR):str16;
BEGIN
    RETURN bignum2str( VAL(LONGCARD,v),base,wi,padchar);
END num2str;

PROCEDURE isValidDecimalNumber (VAR v:CARDINAL; S:ARRAY OF CHAR ):BOOLEAN;
CONST
    decdigits = digits;
VAR
    rc:BOOLEAN;
    okrc: ConvTypes.ConvResults;
BEGIN
    rc:=FALSE;
    IF verifyString(S,decdigits) THEN
        WholeStr.StrToCard( S, v, okrc);
        rc := (okrc = ConvTypes.strAllRight);
    END;
    RETURN rc;
END isValidDecimalNumber;

PROCEDURE isValidRomanNumber (S:ARRAY OF CHAR   ):BOOLEAN ;
CONST
    romandigits = "IVXLCDMivxlcdm"; (* how clever ! :-) *)
BEGIN
    RETURN verifyString(S,romandigits);
END isValidRomanNumber;

PROCEDURE isValidRange (VAR mini,maxi:CARDINAL;  S:ARRAY OF CHAR  ):BOOLEAN;
CONST
    seprange = "..";
VAR
    rc:BOOLEAN;
    p:CARDINAL;
    N:str128; (* oversized for safety *)
BEGIN
    rc:=FALSE;
    p:=Pos(S,seprange);
    IF p # MAX(CARDINAL) THEN
        N:=S;
        N[p]:=charnull;
        IF isValidDecimalNumber(mini,N) THEN
            N:=S;
            Strings.Delete(N,0,p+2); (* delete ".." too *)
            rc:=isValidDecimalNumber(maxi,N);
        END;
    END;
    RETURN rc;
END isValidRange;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    minRomanNumber = 1;
    maxRomanNumber = 4000-1;

PROCEDURE isInRomanRange (v:LONGCARD):BOOLEAN;
BEGIN
    RETURN ( (v >= minRomanNumber) AND (v <= maxRomanNumber) );
END isInRomanRange;

(* adapted from my old 6502 PhilPrinter code, 1981 *)

CONST
    maxromanwidth    = 15; (*  *)
    maxdecromanwidth = 4;  (* 3999 *)

(* yes, we know there are a few inscriptions with faulty "iiii" instead of "iv" *)

PROCEDURE dec2rom (v:LONGCARD;wi:CARDINAL;flagLOWER:BOOLEAN):str16;
CONST
    numeral = "MCXI";
    special = " DLV";
VAR
    N,R:str16;
    i,j,k:CARDINAL;
BEGIN
    IF isInRomanRange(v) THEN
        N:=bignum2str(v,10,4,"0");
        R:="";
        FOR i:=(1-1) TO (maxdecromanwidth-1) DO
            k:=ORD( N[i] ) - ORD( "0" );
            CASE k OF   (* //ADW passim reversed logic for Append() *)
            | 0:     ;
            | 1,2,3: FOR j:=1 TO k DO Strings.Append(numeral[i],R); END;
            | 4:     Strings.Append(numeral[i],R);
                     Strings.Append(special[i],R);
            | 5:     Strings.Append(special[i],R);
            | 6,7,8: Strings.Append(special[i],R);
                     FOR j:=1 TO (k-5) DO Strings.Append(numeral[i],R); END;
            | 9:     Strings.Append(numeral[i],R);
                     Strings.Append(numeral[i-1],R);
            ELSE
                ; (* should never happen *)
            END;
        END;
        padstr(R,wi,space);
        IF flagLOWER THEN LowerCase(R);END;
    ELSE
        R:=strERROR;
    END;
    RETURN R;
END dec2rom;

(* yes, we could write a more clever sub but this ugly code WORKS ! :-) *)

PROCEDURE rom2dec (S:ARRAY OF CHAR ):LONGCARD;
VAR
    N:str16;
    i:CARDINAL;
BEGIN
    LowerCase(S);
    FOR i := minRomanNumber TO maxRomanNumber DO
        N:=dec2rom( i,1,TRUE);
        IF same(S,N) THEN RETURN i;END;
    END;
    RETURN MAX(CARDINAL);
END rom2dec;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    minparm = 1;
    maxparm = 32;
VAR
    parm : ARRAY [minparm..maxparm] OF str128;
    lastparm,parmcount,i,opt:CARDINAL;
    S,R:str128;
    flagLOWERdst,flagLOWERsrc:BOOLEAN;
    mode : (convert,showrange);
    v,mini,maxi:CARDINAL;
    okdec,okrom:BOOLEAN;
    pass:CARDINAL;
    currval:CARDINAL;
    maxlen : CARDINAL;
    cli : str256; (* should do *)
BEGIN
    WrLn;
    Environment.GetCommandLine(cli);
    parmcount := argc(cli);
    (* IF parmcount=0 THEN abort(errHelp,"");END; *)

    flagLOWERdst := FALSE;
    flagLOWERsrc := TRUE;

    lastparm  := minparm-1;
    FOR i := 1 TO parmcount DO
        argv(S, cli,i);
        R:=S;
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   "L"+delim+"LOWER"+delim+"LOWERCASE"+delim+"LOWS"+delim+
                                   "U"+delim+"UPPER"+delim+"UPPERCASE"+delim+"CAPS"
                               );
            CASE opt OF
            | 1,2,3   :    abort(errHelp,"");
            | 4,5,6,7 :    flagLOWERdst := TRUE;
            | 8,9,10,11:   flagLOWERsrc := FALSE;
            ELSE           abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            INC(lastparm);
            IF lastparm > maxparm THEN abort(errParmOverflow,S);END;
            parm[lastparm]:=S; (* keep case *)
        END;
    END;

    mode:=convert;
    CASE lastparm OF
    | minparm-1 :
        abort(errHelp,"");
    | minparm :
        S:=parm[minparm];
        IF isValidRange(mini,maxi,S) THEN
           mode:=showrange;
        END;
    ELSE
        ;
    END;
    CASE mode OF
    | convert:
        FOR pass:=1 TO 2 DO
            FOR i:=minparm TO lastparm DO
                S:=parm[i];
                CASE pass OF
                | 1:
                    okdec:=isValidDecimalNumber(v,S);
                    IF okdec THEN
                        IF isInRomanRange(v)=FALSE THEN abort(errRomanRange,S);END;
                    END;
                    okrom:=isValidRomanNumber(S);
                    IF okrom THEN
                        IF rom2dec(S)=MAX(CARDINAL) THEN abort(errBadRomanNum,S);END;
                    END;
                    IF ( (okdec = FALSE) AND (okrom = FALSE) ) THEN abort(errBadNum,S);END;
                | 2:
                    (* both can't be true at the same time, eh eh *)
                    IF isValidDecimalNumber(v,S) THEN
                        okdec:=isValidDecimalNumber(v,S);
                        S:="~  ==>  ~";
                        Subst(S,"~",bignum2str(v,10,maxdecromanwidth,space) );
                        Subst(S,"~",dec2rom(v,1,flagLOWERdst) );
                        WrStr(S);WrLn;
                    END;
                    IF isValidRomanNumber(S) THEN
                        IF flagLOWERsrc = TRUE THEN
                            LowerCase(S);
                        ELSE
                            UpperCase(S);
                        END;
                        v:=rom2dec(S);
                        padstr(S,maxromanwidth,space);
                        R:="~  ==>  ~";
                        Subst(R,"~",S);
                        Subst(R,"~",bignum2str(v,10,maxdecromanwidth,space));
                        WrStr(R);WrLn;
                    END;
                ELSE
                    ; (* //ADW silly ISO standard ! *)
                END;
            END;
        END;
    | showrange:
        S:=parm[minparm];
        IF isInRomanRange(mini)=FALSE THEN abort(errRomanRange,S);END;
        IF isInRomanRange(maxi)=FALSE THEN abort(errRomanRange,S);END;

        (* maxlen:=0; *)
        currval:=mini;
        LOOP
            (*
            Str.Copy(S,dec2rom(currval,1,flagLOWER));
            i:=Str.Length(S);
            IF i > maxlen THEN maxlen:=i;END;
            *)

            (*
            S:="~ ~ ~";
            Str.Subst(S,"~",bignum2str(currval,10,maxdecromanwidth,space));
            Str.Subst(S,"~",dec2rom(currval, maxromanwidth,TRUE));
            Str.Subst(S,"~",dec2rom(currval,-maxromanwidth,FALSE));
            WrStr(S);WrLn;
            *)

            S:="~  ==>  ~";
            Subst(S,"~",bignum2str(currval,10,maxdecromanwidth,space));
            Subst(S,"~",dec2rom(currval, 1,flagLOWERdst));
            WrStr(S);WrLn;

            IF maxi < mini THEN
                DEC(currval);
                IF currval < maxi THEN EXIT; END;
            ELSE
                INC(currval);
                IF currval > maxi THEN EXIT; END;
            END;
        END;
        (* WrStr("maxlen = ");WrStr(num2str(maxlen,10,1,""));WrLn; *)
    END;

    abort(errNone,"");
END RomanADW.
