' ---------------------------------------------------------------
' Title         Q&D Roman Numerals Converter
' Overview
' Notes         now, everyone will be able to check MGM's movies dates ;-)
'               stand alone version of ROMANTS.MOD
'               M2, where are you ?
'               darn, after all those years of programming in Modula-2,
'               going back to Basic syntax is a huge step backwards :-(
'               note windows strongly forces us to use longints when mere integers were more than enough :-(
' Bugs          pbcc parser is crap : unable to catch overlapping cases, among other things...
'               this crap won't even catch a string without final "_" concatenator symbol !
'               it is not able to clearly detect missing or exessive parameters in functions
'               using colors may be corrupted by previous screen attributes : another PB "feature" !
'               constants cannot be defined in subs !
' Wish List     a JPI TS-like M2 compiler for Vindoze
' ---------------------------------------------------------------

#COMPILER   PBCC 5
#COMPILE    EXE
#DIM        ALL
#OPTION     VERSION3    ' 98SE for ever !

#INCLUDE    "WIN32API.INC"

'----------------------------------------------------------------------
'----------------------------------------------------------------------

' awful globerks, awful language, awful operating system...

'----------------------------------------------------------------------
'----------------------------------------------------------------------

MACRO CONST     = MACRO
MACRO boolean   = INTEGER
MACRO char      = STRING * 1
'MACRO longint   = LONG
'MACRO longcard  = DWORD

'MACRO str256    = STRING * 256
'MACRO str128    = STRING * 128
'MACRO str32     = STRING * 32
'MACRO str16     = STRING * 16

CONST false     = 0
CONST true      = NOT(false)

CONST nl            = $CRLF
CONST digits        = "0123456789"
CONST decdigits     = digits
CONST space         = $SPC
CONST slash         = "/"
CONST dash          = "-"
CONST delim         = ","
CONST equal         = "="
CONST colon         = ":"
CONST tabul         = $TAB
CONST dquote        = $DQ

CONST seprange      = ".."

CONST MAXLONG       = 2147483647 ' max(longint)
CONST strERROR      = "??? ERROR ???"

CONST minRomanNumber = 1
CONST maxRomanNumber = 4000-1
CONST maxromanwidth    = 15
CONST maxdecromanwidth = 4  ' 3999

CONST minparm       = 1
CONST maxparm       = 32

CONST convert       = 1
CONST showrange     = 2

'----------------------------------------------------------------------
'----------------------------------------------------------------------

CONST ProgEXEname       = "ROMAN" ' yes, yes, exe.name$ gives it but we don't like possible renaming
CONST ProgTitle         = "Q&D Roman Numerals Converter"
CONST ProgVersion       = "v1.0"
CONST ProgCopyright     = "by PhG"
CONST Banner            = ProgTitle+" "+ProgVersion+" "+ProgCopyright

CONST errNone           = 0
CONST errHelp           = 1
CONST errOption         = 2
CONST errParmOverflow   = 3
CONST errBadNum         = 4
CONST errRomanRange     = 5
CONST errBadRomanNum    = 6

SUB abort (BYVAL e AS LONG, BYVAL einfo AS STRING)
    LOCAL S, errmsg AS STRING

    SELECT CASE e
    CASE errHelp
        '00000000011111111112222222222333333333344444444445555555555666666666677777777778
        '1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
        errmsg = Banner + nl +                                                              _
        nl+                                                                                 _
        "Syntax 1 : "+ProgEXEname+" <number>... [option]..."+nl+                            _
        "Syntax 2 : "+ProgEXEname+" <first..last> [option]..."+nl+                          _
        nl+                                                                                 _
        "With syntax 1, this program converts a number from decimal to roman numerals"+nl+  _
        "and from roman numerals to decimal. With syntax 2, it converts a range,"+nl+       _
        "provided it is a valid one."+nl+                                                   _
        nl+                                                                                 _
        "   -l show output roman as lowercase roman (default is uppercase)"+nl+             _
        "   -u show input roman as uppercase (default is lowercase)"+nl+                    _
        nl+                                                                                 _
        "a) Note valid range for roman numerals is [1..3999]."+nl+                          _
        nl+                                                                                 _
        "Examples : "+ProgEXEname+" -l 1963 3888"+nl+                                       _
        "           "+ProgEXEname+" -u mcmlxiii mmmdccclxxxviii"+nl+                        _
        "           "+ProgEXEname+" 1..3999"+nl
    CASE errOption          : S="Illegal ~ option !"
    CASE errParmOverflow    : S="~ is one parameter too many !
    CASE errBadNum          : S="Illegal ~ number !"
    CASE errRomanRange      : S="~ does not belong to valid roman numerals range !"
    CASE errBadRomanNum     : S="~ does not look like a valid roman number !"
    CASE ELSE
                              S="This is illogical, Captain !"
    END SELECT

    SELECT CASE e
    CASE errNone
        '
    CASE errHelp
        wrstr errmsg
    CASE ELSE
        subst (s , "~" , dquote+einfo+dquote )
        s=ProgEXEname+" : "+s+nl
        wrstr s
    END SELECT
    exitProcess e ' cdwd
END SUB

'----------------------------------------------------------------------
'----------------------------------------------------------------------

SUB wrstr (BYVAL s AS STRING)
STDOUT s; ' yes, a semicolon here just to remind us of M2 syntax -- ah ah, only serious...
END SUB

SUB wrln ()
STDOUT nl; ' see wrstr() supra
END SUB

' replace first because REPLACE replaces all -- case sensitive

SUB subst(BYREF s AS STRING, BYVAL oldstr AS STRING, BYVAL newstr AS STRING)
    LOCAL p AS LONG
    LOCAL r AS STRING

    p = INSTR(s,oldstr)
    IF p <> 0 THEN
        r = LEFT$(s,p-1)+newstr+MID$(s,p+LEN(oldstr))
        s = r
    END IF
END SUB

SUB replaceall (BYREF s AS STRING, BYVAL oldstr AS STRING, BYVAL newstr AS STRING)
REPLACE oldstr WITH newstr IN s
END SUB

FUNCTION getParamCount() AS LONG
    LOCAL n AS LONG
    LOCAL s AS STRING

    n=0
    DO
        s=COMMAND$(n+1)
        IF s="" THEN EXIT LOOP
        INCR n
    LOOP
    FUNCTION=n
END FUNCTION

SUB uppercase (BYREF s AS STRING)
    s = UCASE$(s)
END SUB

SUB lowercase (BYREF s AS STRING)
    s = LCASE$(s)
END SUB

FUNCTION isOption(BYVAL s AS STRING) AS boolean
    LOCAL c AS char
    LOCAL rc AS boolean

    c = LEFT$(s,1)
    SELECT CASE c
    CASE dash,slash
        rc=true
    CASE ELSE
        rc=false
    END SELECT
    FUNCTION=rc
END FUNCTION

' if what has leading "/" or "-", we assume it's an option

FUNCTION getOptIndex (BYVAL ignorecase AS boolean, BYVAL separateur AS char, BYVAL what AS STRING, BYVAL list AS STRING) AS LONG
IF isOption(what)=true THEN what=MID$(what,2) ' how elegant... :-(
FUNCTION = getListIndex(ignorecase,separateur,what,list)
END FUNCTION

FUNCTION getListIndex (BYVAL ignorecase AS boolean, BYVAL separateur AS char, BYVAL what AS STRING, BYVAL list AS STRING) AS LONG
    LOCAL i AS LONG
    LOCAL s AS STRING
    LOCAL p AS LONG

    IF ignorecase = true THEN
        uppercase (what)
        uppercase (list)
    END IF
    subst (what, equal,colon)       ' cli xxx= becomes xxx:
    replaceall (list, equal,colon)  ' all xxx= become xxx:

    what=TRIM$(what,ANY space+tabul)
    i=1
    DO
        s=PARSE$(list,separateur,i)
        s=TRIM$(s, ANY space+tabul)
        IF s = "" THEN
            i=0
            EXIT LOOP
        END IF
        IF INSTR(what,colon) = 0 THEN  ' normal option
            IF s = what THEN EXIT LOOP
        ELSE                        ' option with a number
            ' check what ("c:3") against s ("c:")
            p=INSTR(what,colon)
            IF LEFT$(what,p) = s THEN EXIT LOOP
        END IF
        INCR i
    LOOP
    FUNCTION = i ' cint
END FUNCTION

FUNCTION verifyString (BYVAL s AS STRING, BYVAL allowed AS STRING) AS boolean
    LOCAL rc AS boolean

    IF VERIFY (s, allowed) = 0 THEN
        rc= true
    ELSE
        rc= false
    END IF
    FUNCTION = rc
END FUNCTION

'----------------------------------------------------------------------
'----------------------------------------------------------------------

SUB padstr (BYREF r AS STRING, BYVAL wi AS LONG, BYVAL padchar AS char)
    LOCAL i AS LONG
    FOR i=LEN(R)+1 TO ABS(wi)
        IF wi < 0 THEN
            r=r+padchar
        ELSE
            r=padchar+r
        END IF
    NEXT
END SUB

FUNCTION bignum2str (BYVAL v AS LONG, BYVAL wi AS LONG, BYVAL padchar AS char) AS STRING
    LOCAL r AS STRING
    LOCAL ok AS boolean

    r=STR$(v)
    r=TRIM$(r)
    padstr(R,wi,padchar)
    FUNCTION = r
END FUNCTION

FUNCTION num2str (BYVAL v AS LONG, BYVAL wi AS LONG, BYVAL padchar AS char) AS STRING
    FUNCTION=bignum2str(v,wi,padchar)
END FUNCTION

FUNCTION isValidDecimalNumber (BYREF v AS LONG, BYVAL s AS STRING) AS boolean
    LOCAL rc,ok AS boolean

    rc=FALSE
    IF verifyString(S,decdigits)=true THEN
        v=VAL(S)
        rc=true
    END IF
    FUNCTION = rc
END FUNCTION

FUNCTION isValidRomanNumber (BYVAL s AS STRING ) AS boolean
    LOCAL romandigits AS STRING
    romandigits = "IVXLCDMivxlcdm" ' how clever ;-)
    FUNCTION = verifyString(S,romandigits)
END FUNCTION

FUNCTION isValidRange (BYREF mini AS LONG,maxi AS LONG, BYVAL s AS STRING) AS BOOLEAN
    LOCAL rc AS BOOLEAN
    LOCAL p AS LONG
    LOCAL n AS STRING

    rc=FALSE
    p=INSTR(S,seprange)
    IF p <> 0 THEN
        n=LEFT$(s,p-1)
        IF isValidDecimalNumber(mini,N)=true THEN
            n=MID$(s,p+2)
            rc=isValidDecimalNumber(maxi,N)
        END IF
    END IF
    FUNCTION = rc
END FUNCTION

FUNCTION isInRomanRange (BYVAL v AS LONG) AS BOOLEAN
    LOCAL rc AS boolean
    IF ( (v >= minRomanNumber) AND (v <= maxRomanNumber) ) THEN
        rc = true
    ELSE
        rc = false
    END IF
    FUNCTION = rc
END FUNCTION

' adapted FROM my old 6502 PhilPrinter CODE, 1981
' yes, we know there are a few inscriptions with faulty "iiii" instead of "iv"

FUNCTION dec2rom (BYVAL v AS LONG, BYVAL wi AS LONG, flagLOWER AS boolean) AS STRING
    LOCAL numeral, special AS STRING
    LOCAL N,R AS STRING
    LOCAL i,j,k AS LONG

    numeral = "MCXI"
    special = " DLV"

    IF isInRomanRange(v)=true THEN
        N=bignum2str(v,4,"0")
        R=""
        FOR i=1 TO maxdecromanwidth
            k=ASC( MID$(N,i,1) ) - ASC( "0" )
            SELECT CASE k
            CASE 0
                '
            CASE 1,2,3
                FOR j=1 TO k
                    r=r+MID$(numeral,i,1)
                NEXT
            CASE 4
                r=r+MID$(numeral,i,1)
                r=r+MID$(special,i,1)
            CASE 5
                r=r+MID$(special,i,1)
            CASE 6,7,8
                r=r+MID$(special,i,1)
                FOR j=1 TO (k-5)
                    r=r+MID$(numeral,i,1)
                NEXT
            CASE 9
                r=r+MID$(numeral,i,1)
                r=r+MID$(numeral,i-1,1)
            END SELECT
        NEXT
        padstr(R,wi,space)
        IF flagLOWER = true THEN lowercase(R)
    ELSE
        R=strERROR
    END IF
    FUNCTION = r
END FUNCTION

' yes, we could write a more clever sub but this ugly code WORKS ! :-)

FUNCTION rom2dec (BYVAL S AS STRING) AS LONG
    LOCAL n AS STRING
    LOCAL i AS LONG
    lowercase(s)
    FOR i = minRomanNumber TO maxRomanNumber
        n = dec2rom(i,1,true)
        IF s=n THEN FUNCTION=i:EXIT FUNCTION
    NEXT
    FUNCTION = MAXLONG
END FUNCTION

'----------------------------------------------------------------------
'----------------------------------------------------------------------

FUNCTION PBMAIN()
    LOCAL lastparm,parmcount,i,optndx AS LONG
    LOCAL S,R AS STRING
    LOCAL flagLOWERdst,flagLOWERsrc AS boolean
    LOCAL mode AS LONG
    LOCAL v,mini,maxi AS LONG
    LOCAL okdec,okrom AS BOOLEAN
    LOCAL pass AS LONG
    LOCAL currval AS LONG
    LOCAL maxlen AS LONG
    LOCAL parm() AS STRING

    DIM parm (minparm TO maxparm) AS STRING

    WrLn
    parmcount = getParamCount()

    flagLOWERdst = FALSE
    flagLOWERsrc = TRUE

    lastparm  = minparm-1
    FOR i = 1 TO parmcount
        s=COMMAND$(i)
        r=s
        UpperCase(R)
        IF isOption(R) = true THEN
            OPTndx = GetOptIndex (true,delim,R,                                             _
                                    "?"+delim+"H"+delim+"HELP"+delim+                       _
                                    "L"+delim+"LOWER"+delim+"LOWERCASE"+delim+"LOWS"+delim+ _
                                    "U"+delim+"UPPER"+delim+"UPPERCASE"+delim+"CAPS"        _
                                  )
            SELECT CASE optndx
            CASE 1,2,3  :   abort(errHelp,"")
            CASE 4,5,6,7 :  flagLOWERdst = TRUE
            CASE 8,9,10,11: flagLOWERsrc = FALSE
            CASE ELSE :     abort(errOption,S) ' could be errHelp, eh eh !
            END SELECT
        ELSE
            INCR lastparm
            IF lastparm > maxparm THEN abort(errParmOverflow,S)
            parm(lastparm) = S ' keep CASE
        END IF
    NEXT

    mode=convert
    SELECT CASE lastparm
    CASE minparm-1
        abort(errHelp,"")
    CASE minparm
        S=parm(minparm)
        IF isValidRange(mini,maxi,S)=true THEN mode=showrange
    CASE ELSE
        '
    END SELECT
    SELECT CASE mode
    CASE convert
        FOR pass =1 TO 2
            FOR i=minparm TO lastparm
                S=parm(i)
                SELECT CASE pass
                CASE  1
                    okdec =isValidDecimalNumber(v,S)
                    IF okdec = true THEN
                        IF isInRomanRange(v)=FALSE THEN abort(errRomanRange,S)
                    END IF
                    okrom=isValidRomanNumber(S)
                    IF okrom = true THEN
                        IF rom2dec(S)=MAXLONG THEN abort(errBadRomanNum,S)
                    END IF
                    IF ( (okdec = FALSE) AND (okrom = FALSE) ) THEN abort(errBadNum,S)
                CASE 2
                    ' both can't be true at the same time, eh eh
                    IF isValidDecimalNumber(v,S) = true THEN
                        okdec=isValidDecimalNumber(v,S)
                        S="~  ==>  ~"
                        subst (s, "~", bignum2str(v,maxdecromanwidth,space) )
                        subst (s, "~", dec2rom(v,1,flagLOWERdst) )
                        WrStr(S)
                        WrLn
                    END IF
                    IF isValidRomanNumber(S) = true THEN
                        IF flagLOWERsrc = true THEN
                            lowercase (S)
                        ELSE
                            uppercase (S)
                        END IF
                        v=rom2dec(S)
                        padstr(S,maxromanwidth,space)
                        R="~  ==>  ~"
                        subst (r, "~", s )
                        subst (r, "~", bignum2str(v,maxdecromanwidth,space) )
                        WrStr(R)
                        WrLn
                    END IF
                END SELECT
            NEXT
        NEXT
    CASE showrange
        S=parm(minparm)
        IF isInRomanRange(mini)=FALSE THEN abort(errRomanRange,S)
        IF isInRomanRange(maxi)=FALSE THEN abort(errRomanRange,S)

        currval=mini
        DO
            S="~  ==>  ~"
            subst (s, "~", bignum2str(currval,maxdecromanwidth,space) )
            subst (s, "~", dec2rom(currval, 1,flagLOWERdst) )
            WrStr(S)
            WrLn
            IF maxi < mini THEN
                DECR currval
                IF currval < maxi THEN EXIT LOOP
            ELSE
                INCR currval
                IF currval > maxi THEN EXIT LOOP
            END IF
        LOOP
    END SELECT

    abort errNone,""
END FUNCTION
