(* ---------------------------------------------------------------
Title         Q&D Discordian date
Author        PhG
Overview
Notes         should be ok
Bugs          yes, in DDATE Erisian program : "Malheur aux unixiens !"
Wish List

--------------------------------------------------------------- *)

IMPLEMENTATION MODULE QD_Eris;

IMPORT Str;

FROM QD_ASCII IMPORT dash, slash, nullchar, tabchar, cr, lf, nl, bs,
space, dot, deg, doublequote, quote, colon, percent, vbar,
blank, equal, dquote, charnull, singlequote, antislash, dollar,
star, backslash, coma, question, underscore, tabul, hbar,
comma, semicolon, diese, pound, openbracket, closebracket, tilde, exclam,
stardotstar, dotdot, escCh, escSet, letters, digits,
lettersUpp, lettersLow, openbrace, closebrace;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite, setReadOnly,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs, UpperCaseAlt, LowerCaseAlt,
completedInit, completedShow, completedSHOW, completedEnd, completed,
removeDups, isValidHDunit, removePhantoms, removeFloppies,
getCDROMunits, getCDROMletters, removeCDROMs, getAllHDunits,
getAllLegalUnits, metaproc, getCli, argc, argv;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    gregorian calendar rule according to Jean Meeus :
    leap 366 years if divisible by 4
    but centurial years NOT divisible by 4 are common
    Leap years are divisible by 400, or by 4 and not by 100 :
    1900 is common, 2000 is leap

    Note DDATE Erisian program is WRONG here !
    I thought of supporting their bug too
    (in addition to the RIGHT algorithm coming from Jean Meeus)
    but on second thought, I decided that no : no silly legacy code !

    note those master unixians should be ashamed of themselves !
    this was STUPID, especially considering the number of programmers
    who "revised" or ported the ugly original C code !
    now, talk about "Open Source" for anyone to "fix" other's code !
    besides, they could easily forge a reason so Discordian calendar
    matches ALL rules of Gregorian calendar, especially since,
    according to kikipedia, Discordian is really SUPPOSED
    to match Gregorian -- as show by its very structure.
    they don't even check wrong dates such as 29 2 1903 = 1 3 1903 !
    they use (annee-1900+3066)=(annee-1166) THEN check (result MOD 4) = 2 !

    it's funny for one of the DDATE programmers to play the smart guy
    about missing days in 1752 and year 0 when he forgets
    a) most Western countries changed for Gregorian calendar in 1582 ;
    b) he was not able to apply *all* gregorian rules for leap years,
    thus allowing errors, wrong input and wrong output (and they
    don't even respect their own language's rules for cardinal formation !)

    ok, ok, DDATE is not vital to anyone,
    but who is to trust people who don't even have their small programs ok,
    and for years ? the one who does not care about details
    should not be trusted either for the big picture.

    should anyone find an error here... well, *I* never said
    I was a "hacker extraordinaire" and I'm no longer an unixian, eh eh... ;-)

*)

PROCEDURE erisGetDaysInFebruary (annee:CARDINAL):CARDINAL;
CONST
    common = 28;
    leap   = 29;
BEGIN
    IF (annee MOD 400) = 0 THEN RETURN leap; END;
    IF (((annee MOD 4) = 0) AND ((annee MOD 100) # 0)) THEN RETURN leap; END;
    RETURN common;
END erisGetDaysInFebruary;

PROCEDURE erisGetDaysInMonth (mois,annee:INTEGER ):INTEGER;
TYPE
    daysinmonthtype = ARRAY [1..12] OF INTEGER;
CONST
    (*                    JanFevMarAprMayJunJulAugSepOctNovDec *)
    (*                     1  2  3  4  5  6  7  8  9 10 11 12  *)
    dpm = daysinmonthtype(31, 0,31,30,31,30,31,31,30,31,30,31);
VAR
    m : INTEGER;
BEGIN
    m:= dpm[mois];
    IF m=0 THEN m:=erisGetDaysInFebruary(annee);END;
    RETURN m;
END erisGetDaysInMonth;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE using (n : CARDINAL; digits : CARDINAL; pad : CHAR) : str16;
VAR
    ok   : BOOLEAN;
    v    : LONGCARD;
    len  : CARDINAL;
    S    : str16;     (* was str80 *)
BEGIN
    v := LONGCARD(n);
    Str.CardToStr(v,S,10,ok);
    IF pad="" THEN RETURN S; END;
    len := Str.Length(S);
    LOOP
        IF Str.Length(S) >= digits THEN EXIT; END;
        Str.Prepend(S,pad);
    END;
    RETURN S;
END using;

PROCEDURE substring (S1,S2:ARRAY OF CHAR) : BOOLEAN;
BEGIN
    Str.Caps(S2);
    IF Str.Pos(S1,S2) # MAX(CARDINAL) THEN RETURN TRUE; END;
    Str.Lows(S2);
    IF Str.Pos(S1,S2) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END substring;

PROCEDURE newstring (VAR R:ARRAY OF CHAR; old,new:ARRAY OF CHAR);
BEGIN
    Str.Caps(old);
    IF Str.Pos(R,old) # MAX(CARDINAL) THEN
        Str.Subst(R,old,new);
    ELSE
        Str.Lows(old);
        IF Str.Pos(R,old) = MAX(CARDINAL) THEN RETURN; END;
        Str.Subst(R,old,new);
    END;
END newstring;

PROCEDURE oldnew (sOld,sNew:ARRAY OF CHAR;VAR R:ARRAY OF CHAR);
BEGIN
    LOOP
        IF substring(R,sOld)=FALSE THEN EXIT;END;
        newstring(R,sOld,sNew);
    END;
END oldnew;

(* ------------------------------------------------------------ *)

PROCEDURE buildOrdinalEnding (DiS : CARDINAL;eng:BOOLEAN ):str16;
VAR
    X:str16;
    i:CARDINAL;
BEGIN
    X:="?"; (* error ! *)
    IF eng THEN
        i:=DiS;
        CASE i OF
        | 0:       X:="th";
        | 1:       X:="st";
        | 2:       X:="nd";
        | 3:       X:="rd";
        | 4..9:    X:="th";
        | 10..19:  X:="th";
        ELSE
            i:=(i MOD 10);
            CASE i OF
            | 0:    X:="th";
            | 1:    X:="st";
            | 2:    X:="nd";
            | 3:    X:="rd";
            | 4..9: X:="th";
            END;
        END;
    ELSE
        CASE DiS OF
        | 1:
            X:="er";
        ELSE
            X:="e";
        END;
    END;
    RETURN X;
END buildOrdinalEnding;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*

DinS        1..73      ( note 365 = 73 * 5 )
season      1..5
YOLD        year+1166
DofW        1..5
DinYOLD     1..365 or 1..366
isExtraDay  Saint Tib's day

*)

PROCEDURE gregorianToDiscordian (VAR DinS,season,YOLD,DofW,DinYOLD:CARDINAL;
                                 VAR isExtraDay:BOOLEAN;
                                 jour,mois,annee:CARDINAL);
CONST
    janmonth            = 1;
    febmonth            = 2;
    febcountforleapyear = 29;
CONST
    YOLDoffset    = 1166;
    daysPerSeason = 73;
    daysPerWeek   = 5;
VAR
    hasanextraday : BOOLEAN;
    extradaypos   : CARDINAL; (* 59+1 *)
    i,total: CARDINAL;
BEGIN
    YOLD   := annee + YOLDoffset;

    hasanextraday := ( erisGetDaysInMonth(febmonth, annee) = febcountforleapyear );

    (* see page 34 ! *)

    extradaypos := erisGetDaysInMonth(janmonth,annee);
    INC(extradaypos, erisGetDaysInMonth(febmonth,annee) );

    DinYOLD:=0;
    FOR i := janmonth TO mois-1 DO
        INC(DinYOLD, erisGetDaysInMonth (i,annee) );
    END;
    INC(DinYOLD,jour);

    IF hasanextraday THEN
        IF DinYOLD > extradaypos THEN
            total:=DinYOLD-1;
        ELSE
            total:=DinYOLD;
        END;
    ELSE
        total := DinYOLD;
    END;
    DEC(total); (* 0-based now *)

    season := total DIV daysPerSeason; INC(season);
    DofW   := total MOD daysPerWeek;   INC(DofW);
    DinS   := total MOD daysPerSeason; INC(DinS);

    isExtraDay := ( hasanextraday AND (DinYOLD = extradaypos) );
END gregorianToDiscordian;

PROCEDURE discordianToType (VAR d :discordianType;
                           DinS,season,YOLD,DofW:CARDINAL;
                           isExtraDay:BOOLEAN);
BEGIN
    d.DinS      := DinS;
    d.season    := season;
    d.YOLD      := YOLD;
    d.DofW      := DofW;
    d.isExtraDay:= isExtraDay;
END discordianToType;

(*
    assume "d" infos are ok
    note Feb 29 tokens strings are nonsensical :
    program should check for isExtraDay i.e. Saint Tib's day
    and process strings accordingly
    now, if Discordians had not decided this was an *extra* day
    without day/season/dayofweek... :-( & ;-)

*)

PROCEDURE buildDiscordianTokens (VAR d:discordianType;
                                 rndnum:CARDINAL; eng:BOOLEAN);
CONST
    usSeasons       = "Chaos,Discord,Confusion,Bureaucracy,The Aftermath";
    frSeasons       = "du Chaos,de la Discorde,de la Confusion,de la Bureaucratie,des Consquences";

    usSeasonsAbrev  = "Chs,Dsc,Cfn,Bcy,Afm";
    frSeasonsAbrev  = "Cha,Dis,Cnf,Bur,Csq"; (* //FIXME *)

    usDoWs          = "Sweetmorn,Boomtime,Pungenday,Prickle-Prickle,Setting Orange";
    frDoWs          = "Douxmat,Croissheure,Mordi,Pointe-de-Frisson,Dcorange"; (* //FIXME *)

    usDoWsAbrev     = "SM,BT,PD,PP,SO";
    frDoWsAbrev     = "Do,Cr,Mo,Po,D"; (* //FIXME *)

    usExtraDay      = "Saint Tib's day";
    frExtraDay      = "la saint Tib";

    usExtraDayAbrev = "St Tib";
    frExtraDayAbrev = "St Tib"; (* //FIXME *)

    (* use "/" separator here for we need "," *)

    us5             = "Mungday to honor Hung Mung the Apostle/"+
                      "Mojoday to honor Doctor Van Van Mojo the Apostle/"+
                      "Syaday to honor Sri Syadasti the Apostle/"+ (* guliday saint gulik ??? *)
                      "Zaraday to honor Zarathud the Apostle/"+
                      "Maladay to honor Malaclypse the Elder";
    fr5             = "Mungdi, en l'honneur de l'Aptre Hung Mung/"+
                      "Mojodi, en l'honneur du Docteur Van Van Mojo/"+ (* shortened for display : no irreverence intended ! ;-) *)
                      "Syadi, en l'honneur de l'Aptre Sri Syadasti/"+
                      "Zaradi, en l'honneur de l'Aptre Zarathud/"+
                      "Maladi, en l'honneur de l'Aptre Malaclypse l'Ancien";

    us5abrev        = "Mungday/Mojoday/Syaday/Zaraday/Maladay";
    fr5abrev        = "Mungdi/Mojodi/Syadi/Zaradi/Maladi";

    us50            = "Chaoflux/Discoflux/Confuflux/Bureflux/Afflux";
    fr50            = us50;

    us50abrev       = us50;
    fr50abrev       = fr50;

    lstSlogans      = "Hail Eris !/"+
                      "All Hail Discordia !/"+
                      "Kallisti !/"+
                      "Fnord./"+
                      "Or Not./"+
                      "Wibble./"+
                      "Pzat !/"+
                      "P'tang !/"+
                      "Frink !/"+
                      "Slack !/"+
                      'Praise "Bob" !/'+
                      "Or kill me./"+
                      "Grudnuk demand sustenance !/"+
                      "Keep the Lasagna flying !/"+
                      "Umlaut Zebra ber alles !/"+
                      "Bozozo !/"+
                      "GAFIA !/"+
                      "FUWI !";

CONST
    TIBWARNVALUE  = 0;
    TIBWARNSTRING = "0";
    TIBWARNING    = "?";

VAR
    lstSeasons,lstSeasonsAbrev  : str128;
    lstDoWs,lstDoWsAbrev        : str128;
    extraday                    : str80;
    extradayAbrev               : str16;
    lst5                        : str256;
    lst5abrev                   : str128;
    lst50,lst50abrev            : str128;
    i                           : CARDINAL;
BEGIN
    IF eng THEN
        lstSeasons      := usSeasons;
        lstSeasonsAbrev := usSeasonsAbrev;
        lstDoWs         := usDoWs;
        lstDoWsAbrev    := usDoWsAbrev;
        extraday        := usExtraDay;
        extradayAbrev   := usExtraDayAbrev;
        lst5            := us5;
        lst5abrev       := us5abrev;
        lst50           := us50;
        lst50abrev      := us50abrev;
    ELSE
        lstSeasons      := frSeasons;
        lstSeasonsAbrev := frSeasonsAbrev;
        lstDoWs         := frDoWs;
        lstDoWsAbrev    := frDoWsAbrev;
        extraday        := frExtraDay;
        extradayAbrev   := frExtraDayAbrev;
        lst5            := fr5;
        lst5abrev       := fr5abrev;
        lst50           := fr50;
        lst50abrev      := fr50abrev;
    END;

    Str.Copy   (d.strDinS,        using(d.DinS,1,""));
    Str.Concat (d.strDinSordinal, d.strDinS,buildOrdinalEnding(d.DinS,eng));

    isoleItemS (d.strSeason,      lstSeasons,     comma,d.season-1);
    isoleItemS (d.strshortSeason, lstSeasonsAbrev,comma,d.season-1);

    Str.Copy   (d.strYOLD,        using(d.YOLD,1,""));

    isoleItemS (d.strDofW,        lstDoWs,        comma,d.DofW-1);
    isoleItemS (d.strshortDofW,   lstDoWsAbrev,   comma,d.DofW-1);

    CASE d.DinS OF
    | 5:
        isoleItemS(d.strHolyDay,        lst5,       slash, d.season-1);
        isoleItemS(d.strshortHolyDay,   lst5abrev,  slash, d.season-1);
    | 50:
        isoleItemS(d.strHolyDay,        lst50,      slash, d.season-1);
        isoleItemS(d.strshortHolyDay,   lst50abrev, slash, d.season-1);
    ELSE (* applies to Saint Tib's day too seen as 60 *)
        d.strHolyDay      :="";
        d.strshortHolyDay :="";
    END;
    d.isHolyday := NOT (same(d.strHolyDay,"") );

    i:=CharCount(lstSlogans,slash);
    INC(i); (* make sure we get the right count and never 0 *)
    isoleItemS(d.strSlogan, lstSlogans,slash, (rndnum MOD i) );

    (* now we can process this damn EXTRA day without numbering ! *)

    IF d.isExtraDay THEN
        Str.Copy   (d.strExtraDay,    extraday);
        Str.Copy   (d.strshortExtraDay,extradayAbrev);
        (* //FIXME should be some UNDEFINED token as to prevent nonsensical display *)
        (* we've decided on warnings with impossible values *)
        d.DinS             :=TIBWARNVALUE;
        d.season           :=TIBWARNVALUE;
        d.DofW             :=TIBWARNVALUE;

        d.strDinS          :=TIBWARNSTRING; (* or "59+1" ? *)
        d.strDinSordinal   :=TIBWARNSTRING; (* +"th" ? ah ah only serious ! *);
        d.strSeason        :=TIBWARNING;
        d.strshortSeason   :=TIBWARNING;

        d.strDofW          :=TIBWARNING;
        d.strshortDofW     :=TIBWARNING;

        (* strHolyDay and strshortHolyDay are "" because DinS seems 59+1 i.e. 60 *)

    ELSE
        d.strExtraDay      :="";
        d.strshortExtraDay :="";
    END;

END buildDiscordianTokens;

(* assume *all* "d" infos are ok *)

PROCEDURE buildDiscordianStrings (VAR strDate,strHolyday,strSlogan:ARRAY OF CHAR;
                                  d:discordianType;erispat:CARDINAL;eng:BOOLEAN);
CONST
    (*
        as we allow user to set date, we have removed such strings :
        "Today", "Nous sommes"
        and while we were at it :
        "It's", "C'est"

        "~" = ordinal
        "#" = cardinal
        "@" = season
        "|" = year
        "%" = dofw
        "*" = holyday (other than saint Tib's day)
        "&" = short form holyday

        "+" = "Apostle" or "Season" // special case : ALT only and LOCAL !

    *)

    usDateFmt        = "%, the ~ day of @ in the YOLD |.";    (* Year of Our Lady Of Discord *)
    frDateFmt        = "%, le ~ jour @ en l'an | de NDdlD.";

    usDateFmtAbrev   = "%, @ #, | YOLD";    (* Year of Our Lady Of Discord *)
    frDateFmtAbrev   = "%, le ~ jour @, | NDdlD";

    usDateExtra      = "Saint Tib's day in the Year | of Our Lady of Discord."; (* between Chaos 59 and Chaos 60 *)
    frDateExtra      = "La Saint Tib en cette anne | de Notre Dame de la Discorde.";

    usDateExtraAbrev = "Saint Tib's day, | YOLD"; (* between Chaos 59 and Chaos 60 *)
    frDateExtraAbrev = "Saint Tib, | NDdlD";

    usDateFmtAlt     = "Today is %, day # in the season of @, |.";
    frDateFmtAlt     = "% # @ |";
    usDateExtraAlt   = "Today is Saint Tib's Day, day between 59 and 60"+
                       " in the season of Chaos, |."; (* "@" would force "?" *)
    frDateExtraAlt   = "Saint Tib, jour intercalaire entre les 59 et 60 du Chaos |.";

CONST
    usCeleb          = "Celebrate *.";
    frCeleb          = "C'est fte : *.";

    usCelebAbrev     = "&";
    frCelebAbrev     = "&";

    usCelebNIL       = "No celebration this day.";
    frCelebNIL       = "Aucune fte en ce jour.";

    usCelebNILabrev  = "No celebration.";
    frCelebNILabrev  = "Aucune fte.";

    usCelebAlt       = "It is the sacred + Holyday of &."; (* "+" is a special case *)
    frCelebAlt       = "C'est fte pour honorer + &.";

    usCelebNILalt    = "No celebration.";
    frCelebNILalt    = "Aucune fte.";

    (* hack to handle alt format *)

    usApostle        = "Apostle";
    frApostle        = "l'aptre";
    usSeason         = "Season";
    frSeason         = "la saison";
VAR
    patDate,patCelebrate,S:str128;
    kindOfHolyDay : str16;
    i:CARDINAL;
BEGIN
    kindOfHolyDay := "";
    IF eng THEN
        CASE erispat OF
        | ErisFmtTerse:
            IF d.isExtraDay THEN
            patDate           := usDateExtraAbrev;
            ELSE
            patDate           := usDateFmtAbrev;
            END;
            IF d.isHolyday THEN
            patCelebrate      := usCelebAbrev;
            ELSE
            patCelebrate      := usCelebNILabrev;
            END;
        | ErisFmtDefault:
            IF d.isExtraDay THEN
            patDate           := usDateExtra;
            ELSE
            patDate           := usDateFmt;
            END;
            IF d.isHolyday THEN
            patCelebrate      := usCeleb;
            ELSE
            patCelebrate      := usCelebNIL;
            END;
        | ErisFmtAlt:
            IF d.isExtraDay THEN
            patDate           := usDateExtraAlt;
            ELSE
            patDate           := usDateFmtAlt;
            END;
            IF d.isHolyday THEN
            patCelebrate      := usCelebAlt;
                CASE d.DinS OF
                | 5:  kindOfHolyDay := usApostle;
                | 50: kindOfHolyDay := usSeason;
                END;
            ELSE
            patCelebrate      := usCelebNILalt;
            END;
        END;
    ELSE
        CASE erispat OF
        | ErisFmtTerse:
            IF d.isExtraDay THEN
            patDate           := frDateExtraAbrev;
            ELSE
            patDate           := frDateFmtAbrev;
            END;
            IF d.isHolyday THEN
            patCelebrate      := frCelebAbrev;
            ELSE
            patCelebrate      := frCelebNILabrev;
            END;
        | ErisFmtDefault:
            IF d.isExtraDay THEN
            patDate           := frDateExtra;
            ELSE
            patDate           := frDateFmt;
            END;
            IF d.isHolyday THEN
            patCelebrate      := frCeleb;
            ELSE
            patCelebrate      := frCelebNIL;
            END;
        | ErisFmtAlt:
            IF d.isExtraDay THEN
            patDate           := frDateExtraAlt;
            ELSE
            patDate           := frDateFmtAlt;
            END;
            IF d.isHolyday THEN
            patCelebrate      := frCelebAlt;
                CASE d.DinS OF
                | 5:  kindOfHolyDay := frApostle;
                | 50: kindOfHolyDay := frSeason;
                END;
            ELSE
            patCelebrate      := frCelebNILalt;
            END;
        END;
    END;


    FOR i:=1 TO 2 DO
        CASE i OF
        | 1 : Str.Copy(S, patDate);
        | 2 : Str.Copy(S, patCelebrate);
        END;
        oldnew ( "~" , d.strDinSordinal , S );
        oldnew ( "#" , d.strDinS        , S );
        oldnew ( "@" , d.strSeason      , S );
        oldnew ( "|" , d.strYOLD        , S );
        oldnew ( "%" , d.strDofW        , S );
        oldnew ( "*" , d.strHolyDay     , S );
        oldnew ( "&" , d.strshortHolyDay, S );
        oldnew ( "+" , kindOfHolyDay    , S );
        CASE i OF
        | 1 : Str.Copy (strDate    ,S);
        | 2 : Str.Copy (strHolyday ,S);
        END;
    END;

    Str.Copy(strSlogan, d.strSlogan);
END buildDiscordianStrings;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

BEGIN
    ;
END QD_Eris.



