(* ---------------------------------------------------------------
Title         see help
Overview      see help
Usage         see help
Notes         very, very, very quick & dirty... :-(
              minimal error messages and checking, etc.
Bugs
Wish List     a check for entries with wrong decimal sep ?
              enhanced directory reading ? bah...

--------------------------------------------------------------- *)

MODULE Columns;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT SYSTEM;
IMPORT IO;

FROM QD_ASCII IMPORT dash, slash, nullchar, tabchar, cr, lf, nl, bs,
space, dot, deg, degree, doublequote, quote, colon, percent, vbar,
blank, equal, dquote, charnull, singlequote, antislash, dollar,
star, backslash, coma, question, underscore, underbar, tabul, hbar,
comma, semicolon, diese, pound, openbracket, closebracket, tilde, exclam,
stardotstar, dotdot, escCh, escSet, letters, digits,
lettersUpp, lettersLow, openbrace, closebrace, ampersand;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite, setReadOnly,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs, UpperCaseAlt, LowerCaseAlt,
completedInit, completedShow, completedSHOW, completedEnd, completed,
removeDups, isValidHDunit, removePhantoms, removeFloppies,
getCDROMunits, getCDROMletters, removeCDROMs, getAllHDunits,
getAllLegalUnits, metaproc, getCli, argc, argv, qdSplitAllPath,
metaproc, UpperCaseFR, LowerCaseFR, ASCIIonly;

FROM QD_File IMPORT pathtype, w9XnothingRequired,
fileOpenRead, fileOpen, fileExists, fileExistsAlt,
fileIsRO, fileSetRW, fileSetRO,
fileErase, fileCreate, fileAppend,fileRename,
fileGetFileSize, fileGetFileStamp,
fileIsDirectorySpec, fileClose, fileFlush, fileSupportLFN;

(* shortened list *)

FROM QD_LFN IMPORT unicodeConversionFlagType, findDataRecordType,
w9XfindFirst, w9XfindClose, w9XfindNext, w9XshortToLong;

FROM IO IMPORT WrStr, WrLn;

(* ------------------------------------------------------------ *)

CONST
    progEXEname     = "COLUMNS";
    progTitle       = "Q&D Columns Processor";
    progVersion     = "v1.1";
    progCopyright   = "by PhG";
    banner          = progTitle+" "+progVersion+" "+progCopyright;

CONST
    EOLcmd          = "*";
    extBAK          = ".BK!";
    extCOM          = ".COM";
    extEXE          = ".EXE";
    extDLL          = ".DLL";
    extOVR          = ".OVR";
    extOVL          = ".OVL";
    extDRV          = ".DRV";
    extZIP          = ".ZIP";
    extARJ          = ".ARJ";
    extLZH          = ".LZH";
    ignoredextensions=extBAK+delim+extCOM+delim+extEXE+delim+
                      extDLL+delim+extOVR+delim+extOVL+delim+extDRV+delim+
                      extZIP+delim+extARJ+delim+extLZH;
CONST
    doDelete = 1;
    doExtract= 2;
    doCard   = 3;
    doInt    = 4;
    doFloat  = 5;
CONST
    steps    = 10;
    chFiller = "."; (* because of vindoze ! *)
CONST
    errNone         = 0;
    errHelp         = 1;
    errOption       = 2;
    errTooManyParms = 3;
    errBadCard      = 4;
    errTabRange     = 5;
    errConflict     = 6;
    errColumnRange  = 7;
    errSyntax       = 8;
    errMissingCmd   = 9;
    errNonsenseRange= 10;
    errJoker        = 11;
    errNotFound     = 12;
    errAlready      = 13;
    errSame         = 14;
    errTooMany      = 15;
    errNonsense     = 16;
    errAddToTarget  = 17;
    errRawUntab     = 18;
    errTotalMode    = 19;
    errSubMode      = 20;
    errBadSourceExt = 21;
    errBadTargetExt = 22;
    errSubMethod    = 23;
    errAborted      = 24;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)

errmsg =
banner+nl+
nl+
"Syntax : "+progEXEname+" <command> <first> <last|"+EOLcmd+"> <source> [target] [option]..."+nl+
nl+
"This program deletes or keeps text from <first> column to <last> column,"+nl+
"or it adds values found in specified column range after triming."+nl+
nl+
"  -d[t]   delete (-dt = -d -t)"+nl+
"  -k|e[t] keep (-kt = -k -t = -et = -e -t)"+nl+
"  -a      add decimal LONGCARD values"+nl+
"  -ai     add decimal LONGINT values"+nl+
"  -af[f]  add decimal LONGREAL values (-aff = -af -us)"+nl+
"  -s[g]   show each subtotal when <first..last> is empty (-sg = -s -g)"+nl+
"  -z[g]   show each subtotal when out of <first..last> changes (-zg = -z -g)"+nl+
"  -i      insert subtotals in <source> dumped to standard output"+nl+
"  -g      show grand total"+nl+
"  -c      see <last> value as a count, not as an absolute position (default)"+nl+
"  -t:#    tabulation width ([1..64], default is 8)"+nl+
"  -r      do not expand tab into spaces, interpreting it as a raw single space"+nl+
"  -t      test mode (dump result to screen without changing file)"+nl+
"  -o      overwrite existing <target>"+nl+
"  -v      verbose (slower)"+nl+
'  -us     when adding, delimit fractional part with "'+dot+'" (default is "'+coma+'")'+nl+
"  -f[f]   when adding, format total (-ff = -f -us)"+nl+
"  -l      disable LFN support even if available"+nl+
nl+
"a) Maximum line length is 4096 characters."+nl+
'b) In command line, "'+EOLcmd+'" marker stands for End of line.'+nl+
"c) Without [target] specification, a "+extBAK+" backup will be created."+nl+
"d) Note program defaults to tab expansion, unless -r is specified."+nl+
"e) When adding, each substring is filtered to [0..9+-"+coma+dot+"] character set."+nl+
"f) With -a and -ai, any character from [ "+coma+dot+"] set is a valid cosmetic separator."+nl+
"g) "+ignoredextensions+" files will be ignored."+nl+
"h) Program will handle up to 250 files."+nl+ (* //V11 *)
"i) Warning : when adding, invalid data will lead to weird and wrong results !"+nl+
"   With -af, double check decimal separators and cosmetic separators !"+nl;

VAR
    S : str256;
BEGIN
    CASE e OF
    | errHelp :        WrStr(errmsg);
    | errOption:       S := 'Unknown "~" option !';
    | errTooManyParms: S := '"~" parameter is one too many !';
    | errBadCard:      S := 'Illegal "~" value !';
    | errTabRange:     S := "Tabulation count must be in [1..64] range !";
    | errConflict:     S := "-d, -e, -a, -ai and -af commands are mutually exclusive !";
    | errColumnRange:  S := "Column must be in [1..4096] range !";
    | errSyntax:       S := "Syntax error !"; (* in fact, missing parms *)
    | errMissingCmd:   S := "Missing <command> !";
    | errNonsenseRange:S := "<last> column is smaller than <first> column !";
    | errJoker    :    S := 'At least one illegal joker in "~" !';
    | errNotFound :    S := 'No match (or ignored extensions) for "~" !';
    | errAlready  :    S := '"~" already exists !';
    | errSame:         S := "<source> and <target> are identical !";
    | errTooMany:      S := "Too many files match <source> !";
    | errNonsense:     S := "-t and -v commands are mutually exclusive !";
    | errAddToTarget:  S := "Target specification is a nonsense with any add command !";
    | errRawUntab:     S := "-r and -t:# options are mutually exclusive !";
    | errTotalMode:    S := "-g option requires -s option !";
    | errSubMode:      S := "-i option requires -s option !";
    | errBadSourceExt: S := 'Illegal extension in "~" <source> !';
    | errBadTargetExt: S := 'Illegal extension in "~" <target> !';
    | errSubMethod:    S := "-s[g] and -z[g] options are mutually exclusive !";
    | errAborted:      S := "Aborted by user !";
    ELSE
                       S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp:
        ;
    ELSE
        Str.Subst(S,"~",einfo);
        WrStr(progEXEname+" : ");WrStr(S);WrLn;
    END;
    Lib.SetReturnCode(SHORTCARD(e));
    HALT;
END abort;

(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBufferType  = ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
VAR
    bufferIn  : ioBufferType;
    bufferOut : ioBufferType;

(* ------------------------------------------------------------ *)

PROCEDURE detab (tabwidth:CARDINAL;S:ARRAY OF CHAR; VAR R : ARRAY OF CHAR  );
VAR
    i,j,add: CARDINAL;
    c : CHAR;
BEGIN
    Str.Copy(R,"");
    j:=0; (* yes, 0 and not 1 ! *)
    FOR i:=1 TO Str.Length(S) DO
        c := S[i-1];
        IF c = tabchar THEN
            add := tabwidth - (j MOD tabwidth);
            WHILE add > 0 DO
                Str.Append(R,space); INC(j);
                DEC(add);
            END;
        ELSE
            Str.Append(R,c); INC(j);
        END;
    END;
END detab;

(* we already know test and verbose cannot be the same *)

PROCEDURE process (cmd,lower,upper,tabwidth:CARDINAL;
                  useLFN,test,verbose,expandtab:BOOLEAN;
                  source,target:pathtype );
VAR
    hin,hout : FIO.File;
    S,R      : str4096;
    pos,count    : CARDINAL;
    fsize,portion,lastportion,currportion,addr : LONGCARD;
BEGIN
    fsize := getFileSize(source);
    portion:=fsize DIV LONGCARD(steps); INC(portion); (* avoid DIV 0 ! *)
    lastportion := LONGCARD(steps+1);

    (* IF verbose THEN Work(cmdInit); END; *)
    IF verbose THEN animInit(steps, "[", "]", chFiller, "", "\/" ); END;

    pos   := lower -1;
    count := upper - lower + 1;

    hin := fileOpenRead(useLFN,source);
    FIO.AssignBuffer(hin,bufferIn);
  IF NOT(test) THEN (* yes, yes, we could have used stdout or stderr handle *)
    hout:= fileCreate(useLFN,target);
    FIO.AssignBuffer(hout,bufferOut);
  END;

    FIO.EOF:=FALSE;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        (* IF verbose THEN Work(cmdShow); END; *)
        IF verbose THEN
            addr:=FIO.GetPos(hin);
            anim(animShow);
            currportion:=addr DIV portion;
            IF currportion # lastportion THEN
                anim(animAdvance);
                lastportion:=currportion;
            END;
        END;

        FIO.RdStr(hin,S);
        IF FIO.EOF THEN EXIT; END;

        IF expandtab THEN detab(tabwidth,S,R); END;

        CASE cmd OF
        | doDelete:
            Str.Delete(R,pos,count);
            IF test THEN
                WrStr(R);WrLn;
            ELSE
                FIO.WrStr(hout,R);FIO.WrLn(hout);    (* R *)
            END;
        | doExtract:
            Str.Slice(S,  R,pos,count);
            IF test THEN
                WrStr(S);WrLn;
            ELSE
                FIO.WrStr(hout,S);FIO.WrLn(hout);    (* S ! *)
            END;
        END;

    END;
  IF NOT(test) THEN
    fileFlush(useLFN,hout);
    fileClose(useLFN,hout);
  END;
    fileClose(useLFN,hin);

    (* IF verbose THEN Work(cmdStop); END; *)
    IF verbose THEN anim(animEnd);anim(animClear); END;
END process;

(* ------------------------------------------------------------ *)

PROCEDURE fmtlc (v : LONGCARD; pad:CHAR; sep:CHAR; field:INTEGER) : str80;
VAR
    S,R   : str80;
    len,i : CARDINAL;
    ok  : BOOLEAN;
    ch  : CHAR;
BEGIN
    Str.CardToStr(v,S,10,ok);
    len:=Str.Length(S);
    R := "";
    FOR i := 1 TO len DO
        Str.Prepend(R,S[len-i]);
        IF i < len THEN
            IF (i MOD 3) = 0 THEN
                Str.Prepend(R,sep);
            END;
        END;
    END;
    LOOP
        IF INTEGER(Str.Length(R)) >= ABS(field) THEN EXIT; END;
        IF field < 0 THEN
            Str.Append(R,pad);  (* right alignment *)
        ELSE
            Str.Prepend(R,pad);
        END;
    END;
    RETURN R;
END fmtlc;

PROCEDURE fmtli (v : LONGINT; pad:CHAR; sep:CHAR; field:INTEGER) : str80;
VAR
    S,R   : str80;
    len,i : CARDINAL;
    ok  : BOOLEAN;
    ch  : CHAR;
BEGIN
    Str.IntToStr(v,S,10,ok);
    len:=Str.Length(S);
    R := "";
    FOR i := 1 TO len DO
        Str.Prepend(R,S[len-i]);
        IF i < len THEN
            IF (i MOD 3) = 0 THEN
                Str.Prepend(R,sep);
            END;
        END;
    END;
    LOOP
        IF INTEGER(Str.Length(R)) >= ABS(field) THEN EXIT; END;
        IF field < 0 THEN
            Str.Append(R,pad);  (* right alignment *)
        ELSE
            Str.Prepend(R,pad);
        END;
    END;
    RETURN R;
END fmtli;

PROCEDURE fmthc (v : LONGREAL; pad:CHAR; sep,fracsep:CHAR; field,prec:INTEGER) : str80;
VAR
    S,SF,R   : str80;
    len,i,p : CARDINAL;
    ok,frachere  : BOOLEAN;
    ch  : CHAR;
BEGIN
    Str.FixRealToStr( v,prec,S,ok);
    p:=Str.RCharPos(S,dot);
    IF p=MAX(CARDINAL) THEN
        frachere:=FALSE;
    ELSE
        Str.Copy(SF,S); Str.Delete(SF,0,p+1);
        S[p]:=CHR(0); (* brutal ! *)
        frachere:=(prec # 0);
    END;

    len:=Str.Length(S);
    R := "";
    FOR i := 1 TO len DO
        Str.Prepend(R,S[len-i]);
        IF i < len THEN
            IF (i MOD 3) = 0 THEN
                Str.Prepend(R,sep);
            END;
        END;
    END;
    LOOP
        IF INTEGER(Str.Length(R)) >= ABS(field) THEN EXIT; END;
        IF field < 0 THEN
            Str.Append(R,pad);  (* right alignment *)
        ELSE
            Str.Prepend(R,pad);
        END;
    END;

    IF frachere THEN
        Str.Append(R,fracsep);Str.Append(R,SF);
    END;

    RETURN R;
END fmthc;

PROCEDURE dmptotal (beautify:BOOLEAN;errors,opcode:CARDINAL;
                    totalcard:LONGCARD;totalint:LONGINT;totalfloat:LONGREAL;
                    killfrac,fracsep:CHAR;fieldfmt,fracwi,field,lfield:CARDINAL;
                    prefix,suffix,source:ARRAY OF CHAR);
VAR
    ok:BOOLEAN;
    R:str128;
BEGIN
    IF errors = 0 THEN
        Str.Copy(R,"::: ");
    ELSE
        Str.Copy(R,"--- ");
    END;
    Str.Append(R,prefix);
    Str.Append(R," = ");
    WrStr(R);

    IF beautify THEN
        CASE opcode OF
        | doCard: Str.Copy(R,fmtlc (totalcard ," ",killfrac, fieldfmt ));
        | doInt:  Str.Copy(R,fmtli (totalint  ," ",killfrac, fieldfmt ));
        | doFloat:Str.Copy(R,fmthc (totalfloat," ",killfrac,fracsep, fieldfmt,fracwi));
        END;
        WrStr(R);
    ELSE
        CASE opcode OF
        | doCard: IO.WrLngCard(totalcard,field);
        | doInt:  IO.WrLngInt (totalint,field);
        | doFloat:Str.FixRealToStr(totalfloat,fracwi,R,ok);WrStr(R);
        END;
    END;

    WrStr(" (");WrStr(source);WrStr(")");
    IF errors = 0 THEN
        WrStr(suffix);
    ELSE
        WrStr(" --- ");
        IO.WrCard(errors,lfield);
        WrStr(" error(s)");
    END;
    WrLn;

END dmptotal;

(* ------------------------------------------------------------ *)

PROCEDURE DMPDBG ( prefix,S:ARRAY OF CHAR  );
BEGIN
    WrStr(prefix); WrStr('"'); WrStr(S); WrStr('"'); WrLn;
END DMPDBG;

PROCEDURE swap (VAR i,j:CARDINAL   );
VAR
    tmp:CARDINAL;
BEGIN
    tmp:=i;
    i:=j;
    j:=tmp;
END swap;

PROCEDURE addlines (opcode,lower,upper,tabwidth:CARDINAL;
                   useLFN,test,verbose,expandtab,beautify,
                   subtotals,smarttotals,insertmode,grandtotal,DEBUG:BOOLEAN;
                   fracsep:CHAR;source:pathtype);
CONST
    ndxfirst= 1;
    ndxlast = 2;
VAR
    orgS    :ARRAY [ndxfirst..ndxlast] OF str4096;
    category:ARRAY [ndxfirst..ndxlast] OF str4096;
CONST
    field    = 1+3*3+1;     (* " # ### ### ###" *)
    fieldfmt = 1+3*3+1+3;   (* "+#,###,###,###" *)
    lfield   = 5;           (* "#####" *)
    prefTotal      = "Total";
    prefGrandTotal = "Grand Total";
    prefSubTotal   = "Sub Total";
    prefSubGrand   = "Sub Total  ";
    remark         = " ; ";
VAR
    pos,count:CARDINAL;
    hin:FIO.File;
    S,R      : str4096;
    ndxcurr,ndxprev:CARDINAL;
VAR
    Z:str256;
    grandcard, vlc,totalcard : LONGCARD;
    grandint,  vli,totalint  : LONGINT;
    grandfloat,vlf,totalfloat: LONGREAL;
    fixvalue,reread,doswap,dmpsubtotal,dmpcurrline,ok:BOOLEAN;
    base:CARDINAL;
    currline,fracwi,p,wi,errors,granderrors:CARDINAL;
    killfrac:CHAR;
    prefix,suffix:str128;
    dmpmethod:(nothing,onlysubs,subsatsepempty,subsatsepchange);
    grabbing:(waiting,gotref,newref);
    fanchor:LONGCARD;
BEGIN
    IF DEBUG THEN verbose:=FALSE;END;

    CASE fracsep OF
    | coma: killfrac:=dot;   (* search "," decimal sep, thus remove "." *)
    | dot:  killfrac:=coma;  (* search "." decimal sep, thus remove "," *)
    END;

    IF subtotals THEN
        IF insertmode THEN
            IF smarttotals THEN
                dmpmethod:=subsatsepchange;
            ELSE
                dmpmethod:=subsatsepempty;
            END;
        ELSE
            dmpmethod:=onlysubs;
        END;
    ELSE
        dmpmethod:=nothing;
    END;
IF DEBUG THEN
CASE dmpmethod OF
| nothing: S:="nothing;"
| onlysubs: S:="onlysubs";
|subsatsepempty: S:="subs at sep empty";
|subsatsepchange: S:="subs at sep change";
END;
DMPDBG("??? ",S);
END;

    IF subtotals THEN
        IF grandtotal THEN
           prefix:=prefSubGrand;
        ELSE
           prefix:=prefSubTotal;
        END;
    ELSE
        prefix:=prefTotal;
    END;

    granderrors := 0;
    grandcard   := 0;
    grandint    := 0;
    grandfloat  := 0.0;

    errors:=0;

    CASE opcode OF
    | doCard:  totalcard :=0;   Z:="LONGCARD";
    | doInt:   totalint  :=0;   Z:="LONGINT";
    | doFloat: totalfloat:=0.0; Z:="LONGREAL";
    END;
    Str.Prepend(Z,"Adding "); Str.Append(Z,"s from "); Str.Append(Z,source);

    pos      := lower -1;
    count    := upper - lower + 1;

    base     := 10; (* for now *)
    currline := 0;
    fracwi   := 0;

    grabbing := waiting;
    ndxcurr  := ndxfirst;
    ndxprev  := ndxlast;
    FOR p:=ndxfirst TO ndxlast DO
         orgS[p]:="";
         category[p]:="";
    END;

    IF verbose THEN video(Z,TRUE); END;

    hin := fileOpenRead(useLFN,source);
    FIO.AssignBuffer(hin,bufferIn);

    FIO.EOF:=FALSE;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        IF dmpmethod = subsatsepchange THEN fanchor:=FIO.GetPos(hin);END;
        FIO.RdStr(hin,S);
IF DEBUG THEN DMPDBG("<<< ",S);END;
        IF FIO.EOF THEN EXIT; END;
        Str.Copy(orgS[ndxcurr],S);
        INC(currline);

        IF expandtab THEN
            detab(tabwidth,S,R);
        ELSE
            Str.Copy(R,S);
        END;
        Str.Slice(S,  R,pos,count);

IF DEBUG THEN DMPDBG("::: ",S);END;

        IF dmpmethod = subsatsepchange THEN
            Str.Copy(category[ndxcurr],R);
            Str.Delete(category[ndxcurr],pos,count);
            LtrimBlanks(category[ndxcurr]);
            RtrimBlanks(category[ndxcurr]);
            LowerCase(category[ndxcurr]);
        END;

        ReplaceChar(S,space,"");
        ReplaceChar(S,tabchar,"");
        IF S[0]="+" THEN Str.Delete(S,0,1);END;

        CASE opcode OF
        | doCard,doInt:
            ReplaceChar(S,dot,"");
            ReplaceChar(S,coma,"");
        | doFloat:
            ReplaceChar(S,killfrac,"");
            IF fracsep=coma THEN Str.Subst(S,coma,dot); END;
            p:=Str.RCharPos(S,dot);
            IF p # MAX(CARDINAL) THEN
                wi:=Str.Length(S)-(p+1);
                IF wi > fracwi THEN fracwi:=wi;END;
            END;
        END;

IF DEBUG THEN DMPDBG(">>> ",S);END; (* S is extracted number *)

        reread := FALSE;
        suffix:="";
        CASE dmpmethod OF
        | nothing:
             dmpsubtotal:=FALSE;
             dmpcurrline:=FALSE;
        | onlysubs:
             dmpsubtotal:=same(S,"");
             dmpcurrline:=FALSE;
        | subsatsepempty:
             dmpsubtotal:=same(orgS[ndxcurr],""); (* was S before fix v1.0l *)
             dmpcurrline:=NOT(dmpsubtotal);
        | subsatsepchange:

IF DEBUG THEN DMPDBG("PREV ",category[ndxprev]);END;
IF DEBUG THEN DMPDBG("CURR ",category[ndxcurr]);END;

            CASE grabbing OF
            | waiting: (* only once *)
                Str.Copy(orgS[ndxprev],orgS[ndxcurr]);
                Str.Copy(category[ndxprev],category[ndxcurr]);
                dmpsubtotal:=FALSE;
                dmpcurrline:=TRUE;
                grabbing:=gotref;
            | gotref:
                IF same(category[ndxcurr],category[ndxprev]) THEN
                    dmpsubtotal := FALSE;
                    dmpcurrline := TRUE;
                ELSE
                    dmpsubtotal := TRUE;
                    dmpcurrline := FALSE; (* not yet *)
                    grabbing:=newref;
                    reread  := TRUE; (* trick *)
                    Str.Concat(suffix,remark,category[ndxprev]); (* easier to read *)
                END;
            | newref : ; (* never here *)
            END;
        END;
IF DEBUG THEN
DMPDBG("+++ ",orgS[ndxcurr]);
END;
        IF dmpcurrline THEN
            IF verbose THEN video(Z,FALSE);END;
            WrStr(orgS[ndxcurr]);WrLn;
            IF verbose THEN video(Z,TRUE);END;
        END;

        IF reread THEN
            fixvalue:=TRUE; (* fake it... *)
        ELSE
            fixvalue:=same(S,"");
        END;
        IF fixvalue THEN Str.Copy(S,"0"); END; (* extract *)

        CASE opcode OF
        | doCard:
            IF S[0]="-" THEN
                ok:=FALSE;
            ELSE
                vlc:=Str.StrToCard(S,base,ok); IF ok THEN INC(totalcard,vlc);END;
            END;
        | doInt:
            vli:=Str.StrToInt(S,base,ok);  IF ok THEN INC(totalint,vli);END;
        | doFloat:
            vlf:=Str.StrToReal(S,ok); IF ok THEN totalfloat:=totalfloat+vlf;END;
        END;
        IF NOT(ok) THEN
            IF verbose THEN video(Z,FALSE); END;
            WrStr("--- Problem at line ");
            IO.WrCard(currline,1);
            WrStr(' ("');WrStr(S);WrStr('")');WrLn;
            IF verbose THEN video(Z,TRUE); END;
            INC(errors);
        END;
        IF dmpsubtotal THEN

            IF verbose THEN video(Z,FALSE); END;
            dmptotal (beautify,errors,opcode,
                      totalcard,totalint,totalfloat,
                      killfrac,fracsep,fieldfmt,fracwi,field,lfield,
                      prefix,suffix,source);
            IF verbose THEN video(Z,TRUE); END;

            INC(granderrors,errors);
            INC(grandcard,totalcard);
            INC(grandint,totalint);
            grandfloat:=grandfloat+totalfloat;

            errors:=0;

            CASE opcode OF
            | doCard:  totalcard :=0;
            | doInt:   totalint  :=0;
            | doFloat: totalfloat:=0.0;
            END;

        END;

        doswap:=FALSE;
        CASE dmpmethod OF
        | nothing,onlysubs: ;
        | subsatsepempty:
            IF dmpcurrline THEN dmpcurrline:=FALSE;END;
        | subsatsepchange:

            dmpcurrline:=NOT(dmpcurrline);
            CASE grabbing OF
            | waiting: ; (* never here *)
            | gotref :
                dmpcurrline:= FALSE;
            | newref :
                dmpcurrline:=FALSE; (* we'll reread it *)
                grabbing:=gotref;   (* waiting works too *)
                doswap:=TRUE;
                FIO.Seek(hin,fanchor); (* be sure to reread current line *)
            END;
        END;
        IF dmpcurrline THEN
            IF verbose THEN video(Z,FALSE);END;
            WrStr(orgS[ndxcurr]);WrLn;
            IF verbose THEN video(Z,TRUE);END;
        END;
        IF doswap THEN swap(ndxcurr,ndxprev);END;
    END;
    fileClose(useLFN,hin);

    (* reread trick removes need to check subsatsepchange state *)

    IF dmpmethod = subsatsepchange THEN
        Str.Concat(suffix,remark,category[ndxcurr]);
    ELSE
        suffix:=""; (* useless safety *)
    END;

    IF verbose THEN video(Z,FALSE); END;

    dmptotal (beautify,errors,opcode,
              totalcard,totalint,totalfloat,
              killfrac,fracsep,fieldfmt,fracwi,field,lfield,
              prefix,suffix,source);

    INC(granderrors,errors);
    INC(grandcard,totalcard);
    INC(grandint,totalint);
    grandfloat:=grandfloat+totalfloat;

    suffix:="";
    IF grandtotal THEN
        dmptotal (beautify,granderrors,opcode,
                 grandcard,grandint,grandfloat,
                 killfrac,fracsep,fieldfmt,fracwi,field,lfield,
                 prefGrandTotal,suffix,source);
    END;

END addlines;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE isReservedExtension (S:pathtype):BOOLEAN;
VAR
    u,d,n,e:pathtype;
    e3 : str16;
    ndx:CARDINAL;
    rc:BOOLEAN;
BEGIN
    qdSplitAllPath(S,u,d,n,e);
    Str.Caps(e);
    rc:=FALSE;
    ndx:=0;
    LOOP
        isoleItemS(e3, ignoredextensions,delim,ndx);
        IF same(e3,"") THEN EXIT; END;
        IF same(e3,e) THEN rc:=TRUE;EXIT; END;
        INC(ndx);
    END;
    RETURN rc;
END isReservedExtension;

PROCEDURE doGetCurrent (useLFN:BOOLEAN;drive:SHORTCARD;
                       VAR unit:str2; VAR current:pathtype);
VAR
    rc:CARDINAL;
    longform:pathtype;
BEGIN
    Str.Concat(unit, CHR( ORD("A")-1+ORD(drive) ),colon);

    FIO.GetDir(drive,current); (* \path without u: nor trailing \ except at root *)
    IF current[1] # colon THEN Str.Prepend(current,unit); END; (* safety *)
    IF useLFN THEN
        IF w9XshortToLong(current,rc,longform) THEN (* if error, keep DOS current *)
            Str.Copy(current,longform);
        END;
    END;
    (* LFN function seems to always return "u:\*" form except at root *)
    IF current[1] = colon THEN Str.Delete(current,0,2);END; (* safety *)
    fixDirectory(current);
END doGetCurrent;

PROCEDURE makebase (useLFN:BOOLEAN;spec:pathtype;VAR basepath:pathtype);
VAR
    u,d,n,e,current:pathtype;
    unit:str2;
    drive:SHORTCARD;
BEGIN
    qdSplitAllPath(spec,u,d,n,e);
    Lib.MakeAllPath(basepath,u,d,"","");
    IF same(basepath,"") THEN
        drive:=FIO.GetDrive(); (* yes we could use 0 as default drive *)
        doGetCurrent(useLFN,drive,  unit,current); (* "u:" and "\" or "\*\" *)
        Str.Concat(basepath, unit,current);
    END;
END makebase;

CONST
    firstfile = 1;
    maxfile   = 250; (* was 2000 but out OF lazyness... *)
VAR
    filename  : ARRAY [firstfile..maxfile] OF pathtype;

(* yes, yes, we could have used our "clever" dynamic allocation but we don't care *)

PROCEDURE isReservedEntry (S:ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dotdot);
END isReservedEntry;

PROCEDURE buildFileList (useLFN,DEBUG :BOOLEAN;spec:pathtype):CARDINAL;
VAR
    last:CARDINAL; (* should do ! *)
    ok,found:BOOLEAN;
    unicodeconversion:unicodeConversionFlagType;
    w9Xentry : findDataRecordType;
    w9Xhandle,errcode:CARDINAL;
    entry : FIO.DirEntry;
    dosattr:FIO.FileAttr;
    entryname:pathtype;
    excludeme,excludemetoo,gloups:BOOLEAN; (* ;-) *)
BEGIN
    last:=firstfile-1;
    IF useLFN THEN
        found := w9XfindFirst (spec,SHORTCARD(everything),SHORTCARD(w9XnothingRequired),
                              unicodeconversion,w9Xentry,w9Xhandle,errcode);
    ELSE
        found := FIO.ReadFirstEntry(spec,everything,entry);
    END;
    WHILE found DO
        IF useLFN THEN
            Str.Copy(entryname,w9Xentry.fullfilename);
        ELSE
            Str.Copy(entryname,entry.Name);
        END;
        excludeme   := isReservedEntry    (entryname);  (* skip "." and ".." *)
        excludemetoo:= isReservedExtension(entryname);
        gloups:=(excludeme OR excludemetoo);
        IF NOT(gloups) THEN
            IF useLFN THEN
                dosattr:=FIO.FileAttr(w9Xentry.attr AND 0FFH);
            ELSE
                dosattr:=entry.attr;
            END;
            IF NOT (aD IN dosattr) THEN
                (* if file has no extension, add it as a marker *)
                IF Str.RCharPos(entryname,".")=MAX(CARDINAL) THEN
                    Str.Append(entryname,".");
                END;
                INC(last);
                IF last > maxfile THEN
                    IF useLFN THEN ok:=w9XfindClose(w9Xhandle,errcode); END;
                    RETURN MAX(CARDINAL);
                END;
                Str.Copy(filename[last],entryname);
            END;
        END;
        IF useLFN THEN
            found :=w9XfindNext(w9Xhandle, unicodeconversion,w9Xentry,errcode);
        ELSE
            found :=FIO.ReadNextEntry(entry);
        END;
    END;
    IF useLFN THEN ok:=w9XfindClose(w9Xhandle,errcode); END;
    RETURN last;
END buildFileList;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkRange (lc:LONGCARD;lower,upper:CARDINAL;VAR v:CARDINAL):BOOLEAN ;
BEGIN
    IF lc < LONGCARD (lower) THEN RETURN FALSE; END;
    IF lc > LONGCARD (upper) THEN RETURN FALSE; END;
    v := CARDINAL(lc);
    RETURN  TRUE;
END chkRange;

(* ------------------------------------------------------------ *)

CONST
    undefinedcard=MAX(CARDINAL);
    defaulttabwidth = 8;
    mintabwidth = 1;
    maxtabwidth = 64;
    mincolumn   = 1;
    maxcolumn   = 4096;
    ascmaxcol   = "4096";
VAR
    cmd         : (undefined,delete,extract,addcard,addint,addfloat);
    absolute    : BOOLEAN;
    tabwidth    : CARDINAL;
    test        : BOOLEAN;
    overwrite   : BOOLEAN;
    verbose     : BOOLEAN;
    fracsep     : CHAR;
    expandtab   : BOOLEAN;
    beautify    : BOOLEAN;
    subtotals   : BOOLEAN;
    smarttotals : BOOLEAN;
    insertmode  : BOOLEAN;
    grandtotal  : BOOLEAN;
    useLFN      : BOOLEAN;
    DEBUG       : BOOLEAN;
    firstcolumn : CARDINAL;
    lastcolumn  : CARDINAL;
    source,target,bakfile : pathtype;
    lastfile    : CARDINAL;
    opcode      : CARDINAL;
    u,path,f8,e3: pathtype; (* oversized just in case *)
    basepath    : pathtype;
    redirON     : BOOLEAN;
VAR
    parmcount,i,opt : CARDINAL;
    S,R             : pathtype;
    state           : (waiting,gotfirst,gotlast,gotsource,gottarget);
    v               : LONGCARD;
BEGIN
    Lib.DisableBreakCheck(); (* if enabled, Ctrl-C forces an ERRORINF.$$$ creation ! *)
    FIO.IOcheck := FALSE;
    WrLn;

    redirON := IsRedirected();

    cmd       := undefined;
    absolute  := TRUE;
    tabwidth  := undefinedcard;
    test      := FALSE;
    overwrite := FALSE;
    verbose   := FALSE;
    fracsep   := coma;
    expandtab := TRUE;
    beautify  := FALSE;
    subtotals := FALSE;
    smarttotals:=FALSE;
    insertmode:= FALSE;
    grandtotal:= FALSE;
    useLFN    := TRUE;
    DEBUG     := FALSE;

    state     := waiting;
    parmcount := Lib.ParamCount();
    IF parmcount=0 THEN abort(errHelp,"");END;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i);
        Str.Copy(R,S);
        UpperCase(R);
        cleantabs(R);
        IF isOption(R) THEN
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   "C"+delim+"COUNT"+delim+
                                   "T:"+delim+"TAB:"+delim+
                                   "O"+delim+"OVERWRITE"+delim+
                                   "D"+delim+"DELETE"+delim+
                                   "E"+delim+"EXTRACT"+delim+"X"+delim+
                                   "V"+delim+"VERBOSE"+delim+
                                   "T"+delim+"TEST"+delim+
                                   "DT"+delim+
                                   "ET"+delim+"XT"+delim+
                                   "A"+delim+
                                   "AI"+delim+
                                   "AF"+delim+
                                   "AFF"+delim+
                                   "US"+delim+
                                   "R"+delim+"RAW"+delim+
                                   "F"+delim+"FORMAT"+delim+"BEAUTIFY"+delim+
                                   "S"+delim+"SUBTOTAL"+delim+
                                   "SG"+delim+
                                   "G"+delim+"GRANDTOTAL"+delim+
                                   "I"+delim+"INSERT"+delim+
                                   "Z"+delim+"SMARTSUBTOTAL"+delim+
                                   "ZG"+delim+
                                   "K"+delim+"KEEP"+delim+
                                   "KT"+delim+
                                   "FF"+delim+
                                   "L"+delim+"LFN"+delim+
                                   "DEBUG"
                               );
            CASE opt OF
            | 1,2,3 :
                abort(errHelp,"");
            | 4,5   :
                absolute := FALSE;
            | 6,7   :
                IF GetLongCard(S,v)=FALSE THEN abort(errBadCard,S);END;
                IF chkRange(v,mintabwidth,maxtabwidth,tabwidth)=FALSE THEN
                    abort(errTabRange,S);
                END;
            | 8,9   :
                overwrite := TRUE;
            | 10,11 :
                CASE cmd OF
                | undefined,delete: cmd:=delete;
                ELSE                abort(errConflict,"");END;
            | 12,13,14 :
                CASE cmd OF
                | undefined,extract:cmd:=extract;
                ELSE                abort(errConflict,"");END;
            | 15,16 :
                verbose := TRUE;
            | 17,18:
                test := TRUE;
            | 19:
                CASE cmd OF
                | undefined,delete: cmd:=delete; test:=TRUE;
                ELSE                abort(errConflict,"");END;
            | 20,21:
                CASE cmd OF
                | undefined,extract:cmd:=extract;test:=TRUE;
                ELSE                abort(errConflict,"");END;
            | 22:
                CASE cmd OF
                | undefined,addcard:cmd:=addcard;
                ELSE                abort(errConflict,"");END;
            | 23:
                CASE cmd OF
                | undefined,addint:cmd:=addint;
                ELSE                abort(errConflict,"");END;
            | 24:
                CASE cmd OF
                | undefined,addfloat:cmd:=addfloat;
                ELSE                abort(errConflict,"");END;
            | 25:
                CASE cmd OF
                | undefined,addfloat:cmd:=addfloat;fracsep:=dot;
                ELSE                abort(errConflict,"");END;
            | 26:       fracsep:=dot;
            | 27,28:    expandtab:=FALSE;
            | 29,30,31: beautify:=TRUE;
            | 32,33:    subtotals:=TRUE;
            | 34:       subtotals:=TRUE;grandtotal:=TRUE;
            | 35,36:    grandtotal:=TRUE;
            | 37,38:    insertmode:=TRUE;
            | 39,40:    smarttotals:=TRUE;
            | 41:       smarttotals:=TRUE;grandtotal:=TRUE;
            | 42,43 :
                CASE cmd OF
                | undefined,extract:cmd:=extract;
                ELSE                abort(errConflict,"");END;
            | 44:
                CASE cmd OF
                | undefined,extract:cmd:=extract;test:=TRUE;
                ELSE                abort(errConflict,"");END;
            | 45: beautify:=TRUE; fracsep:=dot; (* -ff = -f -us *)
            | 46,47:     useLFN:=FALSE;
            | 48:        DEBUG:=TRUE;
            ELSE
                abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            CASE state OF
            | waiting :
                Str.Prepend(R,"=");
                IF GetLongCard(R,v)=FALSE THEN abort(errBadCard,S);END;
                IF chkRange(v,mincolumn,maxcolumn,firstcolumn)= FALSE THEN
                    abort(errColumnRange,S);
                END;
            | gotfirst:
                IF same(R,EOLcmd) THEN R:=ascmaxcol; END;
                Str.Prepend(R,"=");
                IF GetLongCard(R,v)=FALSE THEN abort(errBadCard,S);END;
                IF chkRange(v,mincolumn,maxcolumn,lastcolumn)= FALSE THEN
                    abort(errColumnRange,S);
                END;
            | gotlast:
                Str.Copy(source,S);
            | gotsource:
                Str.Copy(target,S);
            | gottarget:
                abort(errTooManyParms,S);
            END;
            INC(state);
        END;
    END;
    (* check nonsense *)

    IF smarttotals THEN
        IF subtotals THEN abort(errSubMethod,"");END;
        subtotals:=TRUE;
    END;

    IF ( grandtotal AND (subtotals=FALSE) ) THEN abort(errTotalMode,"");END;
    IF ( insertmode AND (subtotals=FALSE) ) THEN abort(errSubMode,"");END;

    IF cmd = undefined THEN  abort(errMissingCmd,""); END;

    useLFN := ( useLFN AND fileSupportLFN() );

    CASE state OF
    | gotsource: (* autobak *)
        IF same(source,dot) THEN Str.Copy(source,stardotstar);END;
        IF chkJoker(source)=FALSE THEN
            IF isReservedExtension(source) THEN abort(errBadSourceExt,source);END;
        END;
    | gottarget: (* "There can be only one !" *)
        CASE cmd OF
        | extract,delete: ;
        ELSE
            abort(errAddToTarget,"");
        END;
        IF same(source,dot) THEN Str.Copy(source,stardotstar);END;
        IF same(target,dot) THEN Str.Copy(target,stardotstar);END;

        IF isReservedExtension(source) THEN abort(errBadSourceExt,source);END;
        IF isReservedExtension(target) THEN abort(errBadTargetExt,target);END;

        Str.Copy(S,source); UpperCaseAlt(source);
        Str.Copy(R,target); UpperCaseAlt(target);
        IF same(S,R) THEN abort(errSame,"");END; (* well, minimum check *)
        IF chkJoker(source) THEN abort(errJoker,source);END;
        IF fileExists(useLFN,source)=FALSE THEN abort(errNotFound,source);END;
        IF chkJoker(target) THEN abort(errJoker,target);END;
        IF fileExists(useLFN,target) THEN
            IF overwrite THEN
                IF fileIsRO(useLFN,target) THEN fileSetRW(useLFN,target);END;
                fileErase(useLFN,target);
            ELSE
                abort(errAlready,target);
            END;
        END;
    ELSE
        abort(errSyntax,"");
    END;

    IF expandtab = FALSE THEN
        IF tabwidth # undefinedcard THEN abort(errRawUntab,"");END;
    END;
    IF tabwidth = undefinedcard THEN tabwidth:=defaulttabwidth; END;

    IF absolute=FALSE THEN lastcolumn := firstcolumn + lastcolumn -1; END;
    IF lastcolumn < firstcolumn THEN abort(errNonsenseRange,"");END;

    IF test THEN verbose:=FALSE; END; (* cancel -v *)

    makebase(useLFN,source,basepath);
    lastfile := buildFileList(useLFN,DEBUG,source);
    CASE lastfile OF
    | firstfile-1 :  abort(errNotFound,source);
    | MAX(CARDINAL): abort(errTooMany,source);
    END;

    CASE cmd OF
    | delete:  i:=doDelete;
    | extract: i:=doExtract;
    | addcard: i:=doCard;
    | addint:  i:=doInt;
    | addfloat:i:=doFloat;
    END;
    opcode:=i;

    qdSplitAllPath(source,u,path,f8,e3);
    Str.Concat(basepath,u,path);

    IF NOT (redirON) THEN
        WrStr(banner);WrLn;
        WrLn;
    END;

FOR i := firstfile TO lastfile DO
    Str.Concat(source,basepath,filename[i]);
    IF Str.CharPos(source,dot)=MAX(CARDINAL) THEN Str.Append(source,dot);END;
    CASE cmd OF
    | delete,extract:
        CASE state OF
        | gotsource:
            Str.Copy(target,source);
            qdSplitAllPath(source,u,path,f8,e3);
            Lib.MakeAllPath(bakfile,u,path,f8,extBAK);
            IF NOT(test) THEN
                IF fileExists(useLFN,bakfile) THEN
                    IF fileIsRO(useLFN,bakfile) THEN fileSetRW(useLFN,bakfile);END;
                    fileErase(useLFN,bakfile);
                END;
                fileRename(useLFN,source,bakfile);
                Str.Copy(source,bakfile);
            END;
            IF NOT(test) THEN
                WrStr("Processing ");WrStr(target);
            END;
        | gottarget:
            IF NOT(test) THEN
                WrStr("Creating ");WrStr(target);WrStr(" from ");WrStr(source);
            END;
        END;

        WrStr(" "); (* gap between filename and animation *)

        process (opcode,firstcolumn,lastcolumn,tabwidth,
                useLFN,test,verbose,expandtab,
                source,target);
        IF NOT(test) THEN
            (* WrStr(": Done !"); *) WrLn;
        END;
    ELSE
        addlines (opcode,firstcolumn,lastcolumn,tabwidth,
                 useLFN,test,verbose,expandtab,beautify,
                 subtotals,smarttotals,insertmode,grandtotal,DEBUG,
                 fracsep,source);
        IF ChkEscape() THEN abort(errAborted,"");END;
    END;
END;

    abort(errNone,"");
END Columns.

