(* ---------------------------------------------------------------
Title         Q&D File Usage
Author        PhG
Overview      show disk usage
Usage         see help
Notes         very, very, very quick & dirty... :-(
              minimal error messages and checking, etc.
              we handle floppy/hd/CDROM
Bugs          yes, TopSpeed did it again !
              if a tab ends command line (and therefore last parameter),
              it is included by Lib.ParamStr() !!!
              we must only specify legal existing drives !

Wish List     "cosmetic" display quirk : long paths trash paging
              (seen with win9X systems)

              check flagLessThanUpper
              unbeautified numbers ?

--------------------------------------------------------------- *)

MODULE fu;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT IO;

FROM FIO IMPORT FIXEDLIBS;

FROM Storage IMPORT ALLOCATE,DEALLOCATE,Available;

(* filter out duplicates found IN QD_TEXT *)
FROM QD_ASCII IMPORT dash, slash, nullchar, tabchar, (* cr, lf, nl, *)
space, dot, deg, doublequote, quote, colon, percent, vbar,
(* bs, *) blank, equal, dquote, charnull, singlequote, antislash, dollar,
star, backslash, coma, question, underscore, tabul, hbar,
comma, semicolon, diese, pound,
stardotstar, dotdot, escCh, escSet, letters, digits;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory, qdSplitAllPath,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite, setReadOnly,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs, UpperCaseAlt, LowerCaseAlt,
completedInit, completedShow, completedSHOW, completedEnd, completed,
removeDups, isValidHDunit, removePhantoms, removeFloppies,
getCDROMunits, getCDROMletters, removeCDROMs, getAllHDunits,
getAllLegalUnits, metaproc, getCli, argc, argv;

FROM QD_Text IMPORT
colortype, cursorshapetype, scrolltype,
ff, cr, lf, bs, tab, nl, mincolor, maxcolor,
BW40, CO40, BW80, CO80, CO80x43, CO80x50, MONO,
vesa80x60, vesa132x25, vesa132x43, vesa132x50, vesa132x60,
selectCursorEmulation, setCursorShape,
handleVesa, setBrightPaper, setBlinkMode,
setFillChar, setFillInk, setFillPaper,
setFillInkPaper, setTxtInk, setTxtPaper, setTxtInkPaper, setWrapMode,
setUseBiosMode, setTabWidth, getScreenData, setWindow,
setMode, restoreMode,
gotoXY, xyToHtabVtab, home, setVisualPage, setActivePage,
scrollWindow, fillTextAttr, cls, writeStr, writeLn, getScreenWidth,
getScreenHeight, getScreenMinX, getScreenMinY, getScreenMaxX, getScreenMaxY,
getMinHtab, getMaxHtab, getMinVtab, getMaxVtab, getUseBiosMode,
getMinHtab, getMaxHtab, getMinVtab, getMaxVtab, getHtab, getVtab,
getWindowWidth, getWindowHeight, initScreenConsole,
findInkPaperAtStartup, getInkAtStartup, getPaperAtStartup;

FROM QD_LFN IMPORT path9X, huge9X, findDataRecordType,
unicodeConversionFlagType, w9XchangeDir,
w9XgetDOSversion, w9XgetTrueDOSversion, w9XisWindowsEnh, w9XisMSDOS7,
w9XfindFirst, w9XfindNext, w9XfindClose, w9XgetCurrentDirectory,
w9XlongToShort, w9XshortToLong, w9XtrueName, w9XchangeDir,
w9XmakeDir, w9XrmDir, w9Xrename, w9XsupportLFN;

FROM QD_File IMPORT pathtype, w9XnothingRequired,
fileOpenRead, fileOpen, fileExists, fileExistsAlt,
fileIsRO, fileSetRW, fileSetRO,
fileErase, fileCreate, fileAppend,fileRename,
fileGetFileSize, fileGetFileStamp,
fileIsDirectorySpec, fileClose, fileFlush, fileSupportLFN;

(* ------------------------------------------------------------ *)

TYPE
    HUGECARD = LONGREAL;
CONST
    HUGEZERO = 0.0;

CONST
    CONSOLE = TRUE; (* if FALSE, do not use QD_Text library *)

(*%F CONSOLE  *)

PROCEDURE vidinit ( useBios:BOOLEAN );
BEGIN
END vidinit;

PROCEDURE print (S : ARRAY OF CHAR  );
BEGIN
    IO.WrStr(S);
END print;

PROCEDURE newline (  );
BEGIN
    IO.WrLn;
END newline;

PROCEDURE colorheader ();
BEGIN
END colorheader;

PROCEDURE colorhelp ();
BEGIN
END colorhelp;

PROCEDURE colortext ();
BEGIN
END colortext;

PROCEDURE colorwarning ();
BEGIN
END colorwarning;

PROCEDURE getRows (  ):CARDINAL ;
CONST
    segBIOSdata = 040H;
VAR
    vrows  [segBIOSdata:0084H] : SHORTCARD; (* add 1 *)
BEGIN
    RETURN ( CARDINAL(vrows) +1 ); (* 25, 43, 50, etc. *)
END getRows;

PROCEDURE getColumns (  ):CARDINAL ;
CONST
    segBIOSdata = 040H;
VAR
    vcolumns [segBIOSdata:004AH] : CARDINAL; (* a word *)
BEGIN
    RETURN vcolumns;
END getColumns;

(*%E  *)

(*%T CONSOLE  *)

PROCEDURE vidinit ( useBios:BOOLEAN  );
BEGIN
    (* handleVesa; *) (* useless, because we won't change video mode *)
    setUseBiosMode ( useBios );
    findInkPaperAtStartup();
END vidinit;

PROCEDURE print (S : ARRAY OF CHAR  );
BEGIN
    writeStr(S);
END print;

PROCEDURE newline (  );
BEGIN
    writeLn;
END newline;

PROCEDURE colorhelp ();
BEGIN
    setTxtInk(getInkAtStartup());      (* was green *)
    setTxtPaper(getPaperAtStartup());  (* was black *)
    setFillInkPaper(getInkAtStartup(),getPaperAtStartup());
END colorhelp;

PROCEDURE colorheader ();
BEGIN
    setTxtInk(yellow);
    setTxtPaper(black);
    setFillInkPaper(getInkAtStartup(),getPaperAtStartup());
END colorheader;

PROCEDURE colortext ();
BEGIN
    setTxtInk(cyan);
    setTxtPaper(black);
    setFillInkPaper(getInkAtStartup(),getPaperAtStartup());
END colortext;

PROCEDURE colorwarning ();
BEGIN
    setTxtInk(red);
    setTxtPaper(white);
    setFillInkPaper(getInkAtStartup(),getPaperAtStartup());
END colorwarning;

PROCEDURE getRows (  ):CARDINAL ;
BEGIN
    RETURN getWindowHeight();
END getRows;

PROCEDURE getColumns (  ):CARDINAL ;
BEGIN
    RETURN getWindowWidth();
END getColumns;

(*%E  *)

(* ------------------------------------------------------------ *)

CONST
    ProgEXEname   = "FU";
    ProgTitle     = "Q&D File Usage";
    ProgVersion   = "v1.1b";
    ProgCopyright = "by PhG";
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;
CONST
    extEXE        = ".EXE";
    extINI        = ".INI";
    lineseparator = dollar;
    minndxdistri  = 1;
    maxndxdistri  = 50;
    strmaxndxrange= "50";
    cosmeticseparators = coma+dot+underscore;
CONST
    initpagingcounter = 1; (* account for message *)
    kbdmsg = "Hit (almost) any key to continue or Escape to abort listing : ";
    cancel = CHR(27);
    msgsort = "Sorting, please wait (possibly a few minutes)... ";
CONST
    errNone             = 0;
    errHelp             = 1;
    errOption           = 2;
    errBadUnitSpec      = 3;
    errTooManyUnits     = 4;
    errAlreadySpecified = 5;
    errNotFound         = 6;
    errNoUnitSpecified  = 7;
    errSortConflict     = 8;
    errTooManyDirs      = 9;
    errAllocate         = 10;
    errAbortedByUser    = 11;
    errAttr             = 12;
    errBadFileMask      = 13;
    errPhantomUnit      = 14;
    errTooManyParms     = 15;
    errBadPath          = 16;
    errJoker            = 17;
    errIsFile           = 18;
    errIsNotDir         = 19;
    errByDirRequired    = 20;
    errEitherDirOrUnit  = 21;
    errMissingCLIsep    = 22;
    errMissingDistributionSep = 23;
    errTooManyRanges    = 24;
    errRangeBadNum      = 25;
    errMissingRanges    = 26;
    errModernity        = 27;
    errThereCannotBeOnlyOne = 28; (* unused *)
    errRepeated         = 29;
TYPE
    scantype = (normalandspecial,normal,special);

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    msgHelp =
Banner+nl+
nl+
"Syntax : "+ProgEXEname+" <u:...|path> <-d[d]|-e[e]|-y[y]|-i[i]|-f[f]|-v|-m[m]> [option]..."+nl+
nl+
"-d[d] by directory (default), -dd = by root directory"+nl+
"-f[f] by path (-d[d] forced accordingly, case-insensitive, accents ignored)"+nl+
"-v    by directory filecount"+nl+
"-e[e] by extension (use yearly total or just extension)"+nl+
"-y[y] by year (use yearly total or just year)"+nl+
"-i[i] by case-insensitive initial (-ii = sort by count instead of character)"+nl+
"-m[m] by filesize distribution"+nl+
'      (-mm = decrease upper limit by 1 except for 0 and "*" 4Gb alias)'+nl+
"-f:$  file mask (????????.??? format, default is "+stardotstar+")"+nl+
"--    reverse order"+nl+
"-s    do not show sum of all sizes and counts for specified files"+nl+
"-c    do not show count of files"+nl+
"-p    show percentage of used file space"+nl+
"-g[g] show bar graph (-gg = -g -t)"+nl+
"-a[a] do not use graphics separator lines (-aa = -a -t)"+nl+
"-t    do not use graphics characters in bar graph"+nl+
"-n    list only normal files (H and S excluded, default is -n -z)"+nl+
"-z    list only special files (H or S required, default is -n -z)"+nl+
"-u    paths and extensions in uppercase (real DOS or -l required)"+nl+
"-w    shorten paths according to columns count (-d[d], -f[f] or -v required)"+nl+
"-r|-j do not recurse"+nl+
"-k    paging (ignored if output redirected)"+nl+
"-l    disable LFN support even if available"+nl+
(*%T CONSOLE  *)
"-b    monochrome BIOS output (no colors)"+nl+
(*%E  *)
nl+
"a) If program is run without any parameter, command line will be read from"+nl+
"   "+ProgEXEname+extINI+", searched for first in current, then in "+ProgEXEname+extEXE+" directory."+nl+
'   Note a single line containing "'+lineseparator+'" separator is required after command line.'+nl+
"b) Note R and A attributes are always ignored when building the list of files."+nl+
"c) -e[e] option does not support extension more than 16 characters long."+nl+
"d) -m[m] option ignores irrelevant options."+nl+
"e) Warning : results will NOT be significant for CD-ROM and network drives."+nl+
"f) "+ProgEXEname+extINI+' file format (comments may start with any of "'+semicolon+pound+'")'+nl+
"   -- optional command line if program is run with an empty command line"+nl+
'   -- required "'+lineseparator+'" line separator'+nl+
"   -- up to "+strmaxndxrange+' upper limit(s) in decimal or hexadecimal ("'+dollar+'" prefix)'+nl+
'      supported inner cosmetic separators are any of "'+cosmeticseparators+'" ;'+nl+
"      supported suffixes for multiples of 1000 are K, M, G ;"+nl+
"      supported suffixes for multiples of 1024 are Kb, Mb, Gb ;"+nl+
'      supported alias for 4Gb MAX(LONGCARD) is "*" ;'+nl+
"      lower limit is previous upper limit +1 (default = 0 unless 0 defined) ;"+nl+
"      if defined, 0 forces count of empty files."+nl+
'   -- required "'+lineseparator+'" line separator'+nl;
VAR
    S : str1024; (* str256 *)
BEGIN
    colorhelp;
    CASE e OF
    | errHelp :
        print(msgHelp);
    | errOption :
        S:='Unknown "~" option !';
    | errBadUnitSpec:
        S:='Illegal "~" unit specification !';
    | errTooManyUnits:
        S:='Overflow with "~" unit specification !';
    | errAlreadySpecified:
        S:='Duplicated "~" unit specification !';
    | errNotFound:
        S:='File "~" does not exist !';
    | errNoUnitSpecified:
        S := "No unit specified !";
    | errSortConflict:
        S := "-d[d][f], -e[e], -y[y], -i[i], -f[f] and -v options are mutually exclusive !";
    | errTooManyDirs:
        (*
        S:='Too many subdirectories in "~" !';
        *)
        S:="Too many directories while limit is 16000 !";
    | errAllocate:
        S:='Storage.ALLOCATE() failure while processing "~" directory !';
    | errAbortedByUser:
        S:="Aborted by user !";
    | errAttr:
        S := "-n and -z options are mutually exclusive !";
    | errBadFileMask:
        S:='Illegal "~" file mask !';
    | errPhantomUnit:
        S:='~: unit does not exist !';
    | errTooManyParms:
        S:='"~" is one parameter too many !';
    | errBadPath:
        S:='Illegal "~" path !';
    | errJoker:
        S:='At least one illegal joker in "~" path !';
    | errIsFile:
        S:='"~" is a file !';
    | errIsNotDir:
        S:='"~" has no directory match !';
    | errByDirRequired:
        S:="-w option requires any of -d[d], -f[f] or -v option !";
    | errEitherDirOrUnit:
        S:="If <path> is specified, it must be the only parameter !";
    | errMissingCLIsep:
        S:='Missing command line "'+lineseparator+'" separator in "~" !';
    | errMissingDistributionSep:
        S:='Missing distribution "'+lineseparator+'" separator in "~" !';
    | errTooManyRanges:
        S:="More than "+strmaxndxrange+' limits defined in "~" !';
    | errRangeBadNum:
        S:='At least one illegal limit defined in "~" !';
    | errMissingRanges:
        S:='Missing upper limits in "~" !';
    | errModernity:
        S:='No limits were defined in "~" !';
    | errThereCannotBeOnlyOne:
        S:='There cannot be only one limit defined in "~" !';
    | errRepeated:
        S:='At least one duplicate upper limit in "~" !';
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp: ;
    ELSE
        Str.Subst(S,"~",einfo);
        print(ProgEXEname+" : "); print(S);
        newline;
    END;
    Lib.SetReturnCode(SHORTCARD(e));
    HALT;
END abort;

TYPE
    distritype = RECORD
        upperlimit : LONGCARD;
        fcount     : LONGCARD;
        accufsize  : HUGECARD;
    END;
VAR
    lastndxdistri:CARDINAL;
    distri : ARRAY[minndxdistri..maxndxdistri] OF distritype; (* globerks *)

PROCEDURE updateDistribution (fsize:LONGCARD);
VAR
    lowerfsize,upperfsize:LONGCARD;
    i:CARDINAL;
BEGIN
    (*
    if first index upper limit is 0, we count 0-length files
    IF anything ELSE, we assume previous is 0
    *)
    i:=minndxdistri;
    IF fsize=0 THEN
        IF distri[i].upperlimit = 0 THEN INC(distri[i].fcount);RETURN;END;
    END;
    LOOP
        IF i = minndxdistri THEN
            lowerfsize:=0;
        ELSE
            lowerfsize:=distri[i-1].upperlimit;
        END;
        INC(lowerfsize);
        upperfsize := distri[i].upperlimit;
        IF ( (fsize >= lowerfsize) AND (fsize <= upperfsize)) THEN
            INC(distri[i].fcount);
            distri[i].accufsize:=distri[i].accufsize+HUGECARD(fsize);
            EXIT;
        END;
        INC(i);
        IF i > lastndxdistri THEN EXIT; END;
    END;
END updateDistribution;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we expect a canonical path u:\xxx...xxx\ *)

PROCEDURE shortenVid (VAR R:ARRAY OF CHAR;
                     wiscreen,wimsg:CARDINAL;S:ARRAY OF CHAR );
VAR
    len:CARDINAL;
BEGIN
    len:=Str.Length(S);
    IF (wimsg+len) < (wiscreen DIV 2) THEN
        Str.Copy(R, S);
    ELSE
        Str.Slice(R, S,0,wiscreen-wimsg-3-1);
        Str.Append(R,"..."); (* not pretty but functional *)
    END;
END shortenVid;

(* ------------------------------------------------------------ *)

PROCEDURE HUGEINC (VAR r:HUGECARD;n:HUGECARD );
BEGIN
    r := r + n;
END HUGEINC;

PROCEDURE fmthc (v : HUGECARD; pad:CHAR; sep:CHAR; field:INTEGER) : str80;
VAR
    S,R   : str80;
    len,i : CARDINAL;
    ok  : BOOLEAN;
    ch  : CHAR;
BEGIN
    Str.FixRealToStr( LONGREAL(v),0,S,ok);
    len:=Str.Length(S);
    R := "";
    FOR i := 1 TO len DO
        Str.Prepend(R,S[len-i]);
        IF i < len THEN
            IF (i MOD 3) = 0 THEN
                Str.Prepend(R,sep);
            END;
        END;
    END;
    LOOP
        IF INTEGER(Str.Length(R)) >= ABS(field) THEN EXIT; END;
        IF field < 0 THEN
            Str.Append(R,pad);  (* right alignment *)
        ELSE
            Str.Prepend(R,pad);
        END;
    END;
    RETURN R;
END fmthc;

PROCEDURE fmtlc (v : LONGCARD; pad:CHAR; sep:CHAR; field:INTEGER) : str80;
VAR
    S,R   : str80;
    len,i : CARDINAL;
    ok  : BOOLEAN;
    ch  : CHAR;
BEGIN
    Str.CardToStr(v,S,10,ok);
    len:=Str.Length(S);
    R := "";
    FOR i := 1 TO len DO
        Str.Prepend(R,S[len-i]);
        IF i < len THEN
            IF (i MOD 3) = 0 THEN
                Str.Prepend(R,sep);
            END;
        END;
    END;
    LOOP
        IF INTEGER(Str.Length(R)) >= ABS(field) THEN EXIT; END;
        IF field < 0 THEN
            Str.Append(R,pad);  (* right alignment *)
        ELSE
            Str.Prepend(R,pad);
        END;
    END;
    RETURN R;
END fmtlc;

PROCEDURE fmtstring (S:ARRAY OF CHAR; pad:CHAR; n:INTEGER ) : str80;
VAR
    R : str80;
BEGIN
    Str.Copy(R,S);
    LOOP
        IF INTEGER(Str.Length(R)) >= ABS(n) THEN EXIT; END;
        IF n < 0 THEN
            Str.Append(R,pad); (* right alignment *)
        ELSE
            Str.Prepend(R,pad);
        END;
    END;
    RETURN R;
END fmtstring;

PROCEDURE fmtpercent (v:LONGREAL;pad:CHAR;sep:CHAR;field:INTEGER):str80;
CONST
    digits = 1; (* after dot/coma *)
VAR
    R : str80;
    ok: BOOLEAN;
BEGIN
    Str.FixRealToStr(v,digits,R,ok);
    Str.Subst(R,dot,sep);
    RETURN fmtstring(R,pad,field);
END fmtpercent;

PROCEDURE fmtbar (percentused:LONGREAL;used,free:CHAR;field:CARDINAL):str80;
VAR
    R : str80;
    p,i : CARDINAL;
BEGIN
    percentused := (percentused / 100.0 ) * LONGREAL(field);
    p := CARDINAL(percentused + 0.5 ); (* round ! *)
    R := "";
    FOR i := 1 TO field DO
        IF i <= p THEN
           Str.Append(R,used);
        ELSE
           Str.Append(R,free);
        END;
    END;
    RETURN R;
END fmtbar;

(*
Year stored relative to 1980 (ex. 1988 stores as 8)
    year      month    day   

 F E D C B A 9 8 7 6 5 4 3 2 1 0   <-- Bit Number
*)

CONST
    yyMask=BITSET{9..15};
    yyShft=9;
    mmMask=BITSET{5..8};
    mmShft=5;
    ddMask=BITSET{0..4};
    ddShft=0;
CONST
    BIOSbaseYear = 1980;

PROCEDURE unpackdate (ymd:CARDINAL;VAR y,m,d:SHORTCARD);
BEGIN
    y := SHORTCARD( CARDINAL(BITSET(ymd) * yyMask) >> yyShft );
    m := SHORTCARD( CARDINAL(BITSET(ymd) * mmMask) >> mmShft );
    d := SHORTCARD( CARDINAL(BITSET(ymd) * ddMask) >> ddShft );
END unpackdate;

(* ------------------------------------------------------------ *)

CONST
    maxhash = 65535;

TYPE
    ptrLogEntry = POINTER TO LogEntry;
    LogEntry = RECORD
        next         : ptrLogEntry;
        rank         : CARDINAL;
        year         : SHORTCARD;
        totalforyear : HUGECARD;  (* was LONGCARD *)
        countforyear : LONGCARD;  (* was cardinal *)
        hash         : CARDINAL;
        extension    : str16;      (* ignore LFN : we use DOS directory FIO sub *)
        totalforext  : HUGECARD;  (* was LONGCARD *)
        countforext  : LONGCARD;  (* was cardinal *)
        totalforinitial:HUGECARD;
        countforinitial:LONGCARD; (* was cardinal *)
        initial      : CHAR;
    END;

CONST
    firstPath = 1;     (* was 0, but 1 required by Lib.QSort and by firstPath-1 of course ! *)
    maxPath   = 16000; (* could be 16383... *)

TYPE
    ptrPathInfoType = POINTER TO pathinfotype;
    pathinfotype  = RECORD
        totalsize : HUGECARD; (* was LONGCARD *)
        filecount : LONGCARD; (* safety : a cardinal should do but who knows what evil etc. *)
        showme    : BOOLEAN;
        slen      : SHORTCARD;
        string    : CHAR; (* variable length *)
    END;

VAR
    Path : ARRAY[firstPath..maxPath] OF ptrPathInfoType;

(* ------------------------------------------------------------ *)

PROCEDURE getentry (i:CARDINAL; VAR R : ARRAY OF CHAR);
VAR
    len:CARDINAL;
BEGIN
    len := CARDINAL(Path[i]^.slen);
    Lib.FastMove( ADR(Path[i]^.string),ADR(R),len);
    R[len]:=nullchar; (* REQUIRED safety ! *)
END getentry;

PROCEDURE setentry (i:CARDINAL; S : ARRAY OF CHAR  ) : BOOLEAN ;
VAR
    len,needed:CARDINAL;
BEGIN
    len    := Str.Length(S);
    needed := SIZE(pathinfotype)-SIZE(CHAR)+len;
    IF Available(needed) THEN
        ALLOCATE(Path[i],needed);
        Path[i]^.slen := SHORTCARD(len);
        Lib.FastMove( ADR(S),ADR(Path[i]^.string),len);
    ELSE
        Path[i]:=NIL;
    END;
    RETURN (Path[i] # NIL);
END setentry;

(* ------------------------------------------------------------ *)

PROCEDURE isLessPath (i,j : CARDINAL) : BOOLEAN;
VAR
    SI,SJ:pathtype;
BEGIN
    getentry(i,SI);
    getentry(j,SJ);

    LowerCase(SI); (* ignore accents when sorting *)
    LowerCase(SJ);

    RETURN ( Str.Compare(SI,SJ) < 0 );  (* -1 is less *)
END isLessPath;

PROCEDURE doSwapPath (i,j : CARDINAL);
VAR
    S : ptrPathInfoType;
BEGIN
    S:=Path[i];
    Path[i]:=Path[j];
    Path[j]:=S;
END doSwapPath;

PROCEDURE fixDirPath (VAR S : ARRAY OF CHAR);
BEGIN
    IF Str.Length(S)=0 THEN Str.Copy(S,backslash); END;
    fixDirectory(S);
END fixDirPath;

PROCEDURE isDirEntry (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dotdot);
END isDirEntry;

PROCEDURE doDir (DEBUG,useLFN:BOOLEAN; root : ARRAY OF CHAR;
                 VAR index:CARDINAL;VAR err:BOOLEAN);
VAR
    S,path,entryname   : pathtype;
    entry   : FIO.DirEntry;
    ok,found   : BOOLEAN;
    w9Xentry : findDataRecordType;
    unicodeconversion:unicodeConversionFlagType;
    dosattr:FIO.FileAttr;
    w9Xhandle,errcode:CARDINAL;
BEGIN
    IF err THEN RETURN; END;
    IF index > maxPath THEN
        err:=TRUE;
        RETURN;
    END;
    (*
    Str.Copy(Path[index],root);
    fixDirPath(Path[index]); (* add required \ because it will be REQUIRED *)
    *)
    fixDirPath(root); (* add required \ because it will be REQUIRED *)
    IF DEBUG THEN print(root);newline;END;
    IF setentry(index,root)=FALSE THEN
        err:=TRUE;
        RETURN;
    END;

    Str.Copy(path,root);
    fixDirPath(path); (* add required \ *)
    Str.Append(path,stardotstar); (* root\*.* *)

    IF useLFN THEN
        found := w9XfindFirst (path,SHORTCARD(everything),SHORTCARD(w9XnothingRequired),
                              unicodeconversion,w9Xentry,w9Xhandle,errcode);
    ELSE
        found := FIO.ReadFirstEntry(path,everything,entry);
    END;
    WHILE found DO
        Work(cmdShow);
        Str.Copy(S,root);
        fixDirPath(S);

        IF useLFN THEN
            Str.Copy(entryname,w9Xentry.fullfilename);
            dosattr:=FIO.FileAttr(w9Xentry.attr AND 0FFH);
        ELSE
            Str.Copy(entryname,entry.Name);
            dosattr:=entry.attr;
        END;

        Str.Append(S,entryname); (* root\f8e3 *)

        IF isDirEntry(entryname)=FALSE THEN (* skip . and .. *)
            IF (aD IN dosattr) THEN
                INC(index);
                doDir(DEBUG,useLFN,S,index,err);
            END;
        END;
        IF useLFN THEN
            found :=w9XfindNext(w9Xhandle, unicodeconversion,w9Xentry,errcode);
        ELSE
            found :=FIO.ReadNextEntry(entry);
        END;
    END;
    IF useLFN THEN ok:=w9XfindClose(w9Xhandle,errcode); END;
END doDir;

PROCEDURE buildPathList (rootdir : ARRAY OF CHAR;
                         useLFN,flagRecurse,flagSorted,DEBUG:BOOLEAN;
                         VAR lastpath:CARDINAL) : BOOLEAN;
VAR
    i        : CARDINAL;
    error    : BOOLEAN;
BEGIN
    error := FALSE;
    (* i     := firstPath; *)
    i := lastpath;

    IF flagRecurse THEN
        Work(cmdInit);
        doDir(DEBUG,useLFN,rootdir,i,error);
        Work(cmdStop);
        IF error=FALSE THEN
            IF flagSorted THEN Lib.QSort(i,isLessPath,doSwapPath); END;
        END;
    ELSE
        fixDirPath(rootdir); (* just in case ! but should not be necessary here *)
        (* Str.Copy(Path[i],rootdir); *)
        IF setentry(i,rootdir)=FALSE THEN RETURN FALSE;END;
    END;
    lastpath := i;
    error := NOT (error); (* reverse flag and return true if no error *)
    RETURN error;
END buildPathList;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE foundYear (year: SHORTCARD; anchor:ptrLogEntry;
                     VAR newInList:ptrLogEntry) : BOOLEAN;
BEGIN
    newInList := anchor;
    WHILE newInList <> NIL DO
        IF newInList^.year = year THEN RETURN TRUE; END;
        newInList := newInList^.next;
    END;
    RETURN FALSE;
END foundYear;

PROCEDURE foundExt (hash:CARDINAL;ext:ARRAY OF CHAR;anchor:ptrLogEntry;
                    VAR newInList:ptrLogEntry  ) : BOOLEAN ;
BEGIN
    newInList := anchor;
    WHILE newInList <> NIL DO
        IF newInList^.hash = hash THEN
            IF same(newInList^.extension,ext) THEN RETURN TRUE; END;
        END;
        newInList := newInList^.next;
    END;
    RETURN FALSE;
END foundExt;

PROCEDURE foundInitial (c: CHAR;anchor:ptrLogEntry;
                    VAR newInList:ptrLogEntry  ) : BOOLEAN ;
BEGIN
    newInList := anchor;
    WHILE newInList <> NIL DO
        IF newInList^.initial = c THEN RETURN TRUE; END;
        newInList := newInList^.next;
    END;
    RETURN FALSE;
END foundInitial;

(* ------------------------------------------------------------ *)

CONST
    buildmodeDIR    = 0;
    buildmodeDISTRI = 1;

PROCEDURE buildDataDir (scanmode:scantype;
                        spec,filemask:ARRAY OF CHAR;currdirndx,buildmode:CARDINAL;
                        useLFN,DEBUG:BOOLEAN):BOOLEAN ;
VAR
    S : pathtype;
    found,ok: BOOLEAN;
    entry : FIO.DirEntry;
    total : HUGECARD;
    n     : LONGCARD;
    dosattr:FIO.FileAttr;
    w9Xentry : findDataRecordType;
    unicodeconversion:unicodeConversionFlagType;
    w9Xhandle,errcode:CARDINAL;
    entryfsize:LONGCARD;
    entryname:pathtype;
BEGIN

    (* Work(cmdInit); *)
    Str.Concat(S,spec,filemask); (* assume u:\xxx\ -- was stardotstar *)
    total := HUGEZERO;
    n     := 0;
    IF useLFN THEN
        found := w9XfindFirst (S,SHORTCARD(allfiles),SHORTCARD(w9XnothingRequired),
                              unicodeconversion,w9Xentry,w9Xhandle,errcode);
    ELSE
        found := FIO.ReadFirstEntry(S,allfiles,entry);
    END;
    WHILE found DO
        (* Work(cmdShow); *)
        IF useLFN THEN
            dosattr:=FIO.FileAttr(w9Xentry.attr AND 0FFH);
            entryfsize:=w9Xentry.fsize.lo;
        ELSE
            dosattr := entry.attr;
            entryfsize := entry.size;
        END;
        CASE scanmode OF
        | special: ok:=((aH IN dosattr) OR (aS IN dosattr));
        | normal : ok:=NOT ((aH IN dosattr) OR (aS IN dosattr));
        | normalandspecial:ok:=TRUE ;
        END;
        IF ok THEN
            CASE buildmode OF
            | buildmodeDIR :
                HUGEINC (total, HUGECARD(entryfsize) );
                INC(n);
            | buildmodeDISTRI:
                updateDistribution(entryfsize);
            END;
        END;
        IF useLFN THEN
            found :=w9XfindNext(w9Xhandle, unicodeconversion,w9Xentry,errcode);
        ELSE
            found:=FIO.ReadNextEntry(entry);
        END;
    END;
    IF useLFN THEN ok:=w9XfindClose(w9Xhandle,errcode); END;

    Path[currdirndx]^.totalsize := total;
    Path[currdirndx]^.filecount := n;
    Path[currdirndx]^.showme    := TRUE;
    (* Work(cmdStop); *)
IF DEBUG THEN
    print("n= ");print ( fmtlc(n," ","",-5));
    print("currdirndx= ");print ( fmtlc(LONGCARD(currdirndx)," ","",-5));
    print("  //buildDataDir() : spec ");print(spec);newline;
END;
    RETURN TRUE;
END buildDataDir;

PROCEDURE buildDataYear (useLFN:BOOLEAN;scanmode:scantype;
                         spec,filemask:ARRAY OF CHAR;currdirndx:CARDINAL;
                         VAR anchor,newInList:ptrLogEntry;
                         VAR count:CARDINAL ):BOOLEAN;
VAR
    S : pathtype;
    found,ok: BOOLEAN;
    entry : FIO.DirEntry;
    len,needed : CARDINAL;
    year,month,day:SHORTCARD;
    ptr : ptrLogEntry;
    fsize:HUGECARD;
    dosattr:FIO.FileAttr;
    w9Xentry : findDataRecordType;
    unicodeconversion:unicodeConversionFlagType;
    w9Xhandle,errcode:CARDINAL;
    entryfsize:LONGCARD;
    entryname:pathtype;
    entrydate:CARDINAL;
    dosdt:LONGCARD;
BEGIN
    (* Work(cmdInit); *)
    Str.Concat(S,spec,filemask); (* assume u:\xxx\ -- was stardotstar *)
    IF useLFN THEN
        found := w9XfindFirst (S,SHORTCARD(everything),SHORTCARD(w9XnothingRequired),
                              unicodeconversion,w9Xentry,w9Xhandle,errcode);
    ELSE
        found := FIO.ReadFirstEntry(S,everything,entry);
    END;
    WHILE found DO
        (* Work(cmdShow); *)
        IF useLFN THEN
            dosattr:=FIO.FileAttr(w9Xentry.attr AND 0FFH);
            entryfsize:=w9Xentry.fsize.lo;
            dosdt:=w9Xentry.lastmod.lo; (* glad we use dtformatDOS IN QD_LFN ! *)
            dosdt:=(dosdt >> 16);
            entrydate:=CARDINAL(dosdt);
        ELSE
            dosattr := entry.attr;
            entryfsize := entry.size;
            entrydate:=entry.date;
        END;
        CASE scanmode OF
        | special: ok:=((aH IN dosattr) OR (aS IN dosattr));
        | normal : ok:=NOT ((aH IN dosattr) OR (aS IN dosattr));
        | normalandspecial:ok:=TRUE ;
        END;
        IF ( (aD) IN dosattr ) THEN ok:=FALSE;END; (* v1.0l fix *)
      IF ok THEN
        needed := SIZE(LogEntry);
        IF Available(needed)=FALSE THEN
             (* Work(cmdStop); *)
             RETURN FALSE;
        END;
        fsize:=HUGECARD(entryfsize);
        unpackdate(entrydate,year,month,day); (* we'll add BIOSbaseYear later ! *)
        IF anchor=NIL THEN
            count                       := 1;
            ALLOCATE(newInList,needed);
            newInList^.rank             := count;
            newInList^.year             := year;
            newInList^.totalforyear     := fsize;
            newInList^.countforyear     := 1;
            newInList^.next             := NIL;

            anchor    := newInList;
        ELSE
            IF foundYear(year,anchor,ptr) THEN
                HUGEINC(ptr^.totalforyear, fsize );
                INC(ptr^.countforyear);
            ELSE
                INC(count);
                ALLOCATE(newInList^.next,needed);
                newInList                   := newInList^.next;
                newInList^.rank             := count;
                newInList^.year             := year;
                newInList^.totalforyear     := fsize;
                newInList^.countforyear     := 1;
                newInList^.next             := NIL;
            END;
        END;
      END;
        IF useLFN THEN
            found :=w9XfindNext(w9Xhandle, unicodeconversion,w9Xentry,errcode);
        ELSE
            found:=FIO.ReadNextEntry(entry);
        END;
    END;
    IF useLFN THEN ok:=w9XfindClose(w9Xhandle,errcode); END;
    (* Work(cmdStop); *)
    RETURN TRUE;
END buildDataYear;

PROCEDURE buildDataExt (useLFN:BOOLEAN;scanmode:scantype;
                        spec,filemask:ARRAY OF CHAR;currdirndx:CARDINAL;
                        VAR anchor,newInList:ptrLogEntry;
                        VAR count:CARDINAL ):BOOLEAN;
VAR
    S,u,d,n,e : pathtype;
    found,ok: BOOLEAN;
    entry : FIO.DirEntry;
    needed,hash : CARDINAL;
    ptr : ptrLogEntry;
    fsize:HUGECARD;
    dosattr:FIO.FileAttr;
    w9Xentry : findDataRecordType;
    unicodeconversion:unicodeConversionFlagType;
    w9Xhandle,errcode:CARDINAL;
    entryfsize:LONGCARD;
    entryname:pathtype;
BEGIN
    (* Work(cmdInit); *)
    Str.Concat(S,spec,filemask); (* assume u:\xxx\ -- was stardotstar *)
    IF useLFN THEN
        found := w9XfindFirst (S,SHORTCARD(everything),SHORTCARD(w9XnothingRequired),
                              unicodeconversion,w9Xentry,w9Xhandle,errcode);
    ELSE
        found := FIO.ReadFirstEntry(S,everything,entry);
    END;
    WHILE found DO
        (* Work(cmdShow); *)
        IF useLFN THEN
            dosattr:=FIO.FileAttr(w9Xentry.attr AND 0FFH);
            entryfsize:=w9Xentry.fsize.lo;
            Str.Copy(entryname,w9Xentry.fullfilename);
        ELSE
            dosattr := entry.attr;
            entryfsize := entry.size;
            Str.Copy(entryname,entry.Name);
        END;
        CASE scanmode OF
        | special: ok:=((aH IN dosattr) OR (aS IN dosattr));
        | normal : ok:=NOT ((aH IN dosattr) OR (aS IN dosattr));
        | normalandspecial:ok:=TRUE ;
        END;
        IF ( (aD) IN dosattr ) THEN ok:=FALSE;END; (* v1.0l fix *)
      IF ok THEN
        needed := SIZE(LogEntry);
        IF Available(needed)=FALSE THEN
            (* Work(cmdStop); *)
            RETURN FALSE;
        END;
        fsize:=HUGECARD(entryfsize);
        qdSplitAllPath(entryname,u,d,n,e);
        Str.Delete(e,0,1); (* remove leading "." *)
        Str.Lows(e);

        hash := Lib.HashString(e,maxhash);
        IF anchor=NIL THEN
            count                       := 1;
            ALLOCATE(newInList,needed);
            newInList^.rank             := count;
            Str.Copy(newInList^.extension,e);
            newInList^.hash             := hash;
            newInList^.totalforext      := fsize;
            newInList^.countforext      := 1;
            newInList^.next             := NIL;

            anchor    := newInList;
        ELSE
            IF foundExt(hash,e,anchor,ptr) THEN
                HUGEINC(ptr^.totalforext, fsize);
                INC(ptr^.countforext);
            ELSE
                INC(count);
                ALLOCATE(newInList^.next,needed);
                newInList                   := newInList^.next;
                newInList^.rank             := count;
                Str.Copy(newInList^.extension,e);
                newInList^.hash             := hash;
                newInList^.totalforext      := fsize;
                newInList^.countforext      := 1;
                newInList^.next             := NIL;
            END;
        END;
      END;
        IF useLFN THEN
            found :=w9XfindNext(w9Xhandle, unicodeconversion,w9Xentry,errcode);
        ELSE
            found:=FIO.ReadNextEntry(entry);
        END;
    END;
    IF useLFN THEN ok:=w9XfindClose(w9Xhandle,errcode); END;
    (* Work(cmdStop); *)
    RETURN TRUE;
END buildDataExt;

PROCEDURE buildDataInitial (useLFN:BOOLEAN;scanmode:scantype;
                        spec,filemask:ARRAY OF CHAR;currdirndx:CARDINAL;
                        VAR anchor,newInList:ptrLogEntry;
                        VAR count:CARDINAL ):BOOLEAN;
VAR
    S,u,d,n,e : pathtype;
    found,ok: BOOLEAN;
    entry : FIO.DirEntry;
    needed,hash : CARDINAL;
    ptr : ptrLogEntry;
    fsize:HUGECARD;
    c:CHAR;
    dosattr:FIO.FileAttr;
    w9Xentry : findDataRecordType;
    unicodeconversion:unicodeConversionFlagType;
    w9Xhandle,errcode:CARDINAL;
    entryfsize:LONGCARD;
    entryname:pathtype;
BEGIN
    (* Work(cmdInit); *)
    Str.Concat(S,spec,filemask); (* assume u:\xxx\ -- was stardotstar *)
    IF useLFN THEN
        found := w9XfindFirst (S,SHORTCARD(everything),SHORTCARD(w9XnothingRequired),
                              unicodeconversion,w9Xentry,w9Xhandle,errcode);
    ELSE
        found := FIO.ReadFirstEntry(S,everything,entry);
    END;
    WHILE found DO
        (* Work(cmdShow); *)
        IF useLFN THEN
            dosattr:=FIO.FileAttr(w9Xentry.attr AND 0FFH);
            entryfsize:=w9Xentry.fsize.lo;
            Str.Copy(entryname,w9Xentry.fullfilename);
        ELSE
            dosattr := entry.attr;
            entryfsize := entry.size;
            Str.Copy(entryname,entry.Name);
        END;
        CASE scanmode OF
        | special: ok:=((aH IN dosattr) OR (aS IN dosattr));
        | normal : ok:=NOT ((aH IN dosattr) OR (aS IN dosattr));
        | normalandspecial:ok:=TRUE ;
        END;
        IF ( (aD) IN dosattr ) THEN ok:=FALSE;END; (* v1.0l fix *)
      IF ok THEN
        needed := SIZE(LogEntry);
        IF Available(needed)=FALSE THEN
            (* Work(cmdStop); *)
            RETURN FALSE;
        END;
        fsize:=HUGECARD(entryfsize);
        qdSplitAllPath(entryname,u,d,n,e);
        Str.Copy(c,n[0]);
        LowerCase(c);
(* print(c);print(" -> ");print(n);newline; *)
        IF anchor=NIL THEN
            count                       := 1;
            ALLOCATE(newInList,needed);
            newInList^.rank             := count;
            Str.Copy(newInList^.initial,c);
            newInList^.totalforinitial  := fsize;
            newInList^.countforinitial  := 1;
            newInList^.next             := NIL;

            anchor    := newInList;
        ELSE
            IF foundInitial(c,anchor,ptr) THEN
                HUGEINC(ptr^.totalforinitial, fsize);
                INC(ptr^.countforinitial);
            ELSE
                INC(count);
                ALLOCATE(newInList^.next,needed);
                newInList                   := newInList^.next;
                newInList^.rank             := count;
                Str.Copy(newInList^.initial,c);
                newInList^.totalforinitial  := fsize;
                newInList^.countforinitial  := 1;
                newInList^.next             := NIL;
            END;
        END;
      END;
        IF useLFN THEN
            found :=w9XfindNext(w9Xhandle, unicodeconversion,w9Xentry,errcode);
        ELSE
            found:=FIO.ReadNextEntry(entry);
        END;
    END;
    IF useLFN THEN ok:=w9XfindClose(w9Xhandle,errcode); END;
    (* Work(cmdStop); *)
    RETURN TRUE;
END buildDataInitial;

(* ------------------------------------------------------------ *)

PROCEDURE freeData (newInList:ptrLogEntry  );
VAR
    nextInList:ptrLogEntry;
    needed:CARDINAL;
BEGIN
    WHILE newInList <> NIL DO
        needed := SIZE(LogEntry);
        nextInList := newInList^.next;
        DEALLOCATE(newInList,needed);
        newInList := nextInList;
    END
END freeData;

PROCEDURE freePaths (lastpath:CARDINAL);
VAR
    i,len,needed:CARDINAL ;
    newInList,nextInList : ptrLogEntry;
    R : str16;
BEGIN
    FOR i := firstPath TO lastpath DO
        len := CARDINAL( Path[i]^.slen);
        needed := SIZE(pathinfotype)-SIZE(CHAR)+len;
        DEALLOCATE(Path[i],needed);
        Path[i]:=NIL;
    END;
END freePaths;

(* ------------------------------------------------------------ *)

(*
adapted from dmppath() in TOTAL v1.0s
we brutally start with "..." but we could perform an inner cut too
0123456789
c:\z\x      ok
c:\z\xxxx   ok
c:\z\xxxxx  shorten or leave as is without newline ?
c:\z\xxxxxx shorten
*)

PROCEDURE dofixpath (shortenpaths,enclose:BOOLEAN;wi:CARDINAL;
                    VAR S:ARRAY OF CHAR);
CONST
    prefix    = "...";
    prefixlen = 3;
VAR
    le,colcount:CARDINAL;
BEGIN
    IF shortenpaths THEN
        colcount:=getColumns();
        le:=Str.Length(S);
        IF enclose THEN INC(le,2);END;
        IF (wi+le) >= colcount THEN
            Str.Delete(S,0,wi+le-colcount+1);
            Str.Delete(S,0,prefixlen);
            Str.Prepend(S,prefix);
        END;
    END;
    IF enclose THEN Str.Append(S,dquote);Str.Prepend(S,dquote);END;
END dofixpath;

(* ------------------------------------------------------------ *)

CONST
    graphdash  = CHR(196);  txtdash  = "-";
    graphbar   = CHR(205);  txtbar   = "=";
    chUsed     = CHR(176);  chUsedTxt = "+";
    chFree     = CHR(219);  chFreeTxt = "-";
    filler     = "$";
    sepa       = "  ";
    wisepa     = 2; (* used if shortenpaths is TRUE *)
CONST
    modeDir = 0;
    modeYear= 1;
    modeExt = 2;
    modeInitial=3;
CONST
    usedfiller      =       "$$,$$$,$$$,$$$";
    filecountfiller =              "$$$,$$$";
    percentfiller   =                "$$$,$";
    barfiller       = "$$$$$$$$$$$$$$$$$$$$"; (* //V10U was 20 spaces *)
    lastfiller      = "$$$$$$$$$$$$$$$$$$$$$$$$";  (* 2 chars more and we hit 80 columns ! *)
                   (*  path (hsra ????????.???) *)
CONST
    usedheader      =       "    Used bytes";
    filecountheader =              "  Files";
    percentheader   =                "%Used";
    barheader       = 'Used="$"   Total="$"';
    pathheader      = "Path";
    yearheader      = "Year";
    extensionheader = "Extension"; (* was "Ext." check hit 80 columns wall *)
    initialheader   = "Initial";
CONST
    norecurseheader = "-r ";
    recurseheader   = "";
    norecursetrailer= "-r, ";
    recursetrailer  = "";
    HSRAheader      = "HSRA";
    RAheader        = "RA";
    HSheader        = "HS";
    HSRAlong        = sepa+"(~all files, including system and/or hidden)";
    RAlong          = sepa+"(~all files, excluding system and/or hidden)";
    HSlong          = sepa+"(~only system and/or hidden files)";
    sAttrMask       = ' (~~ -- "~")';

PROCEDURE getWidths (VAR  wi,wic,wip,wib:CARDINAL   );
BEGIN
    wi := Str.Length(usedfiller);
    wic:= Str.Length(filecountfiller);
    wip:= Str.Length(percentfiller);
    wib:= Str.Length(barfiller);
END getWidths;


(* bytes, count, percentage, bar, sort_type (mask, files) *)

PROCEDURE doHeader (bymode:CARDINAL;filemask:ARRAY OF CHAR;
                    showcount,showpercent,showgraph,
                    ascii,semigraphics,flagRecurse:BOOLEAN;
                    scanmode:scantype);
VAR
    H1,H2:str128; (* 80 should do but... *)
    T1,T2:str80;
    i:CARDINAL;
    ch:CHAR;
BEGIN
    H1:=usedheader;
    H2:=usedfiller;
    IF showcount THEN
        Str.Append(H1,sepa);Str.Append(H1,filecountheader);
        Str.Append(H2,sepa);Str.Append(H2,filecountfiller);
    END;
    IF showpercent THEN
        Str.Append(H1,sepa);Str.Append(H1,percentheader);
        Str.Append(H2,sepa);Str.Append(H2,percentfiller);
    END;
    IF showgraph THEN
        Str.Append(H1,sepa);Str.Append(H1,barheader);
        Str.Append(H2,sepa);Str.Append(H2,barfiller);
    END;

    CASE bymode OF
    | modeDir:    T1:=pathheader;
    | modeYear:   T1:=yearheader;
    | modeExt:    T1:=extensionheader;
    | modeInitial:T1:=initialheader;
    END;
    Str.Append(H1,sepa);Str.Append(H1,T1);
    Str.Append(H2,sepa);Str.Append(H2,lastfiller);

    CASE scanmode OF
    | normalandspecial:  T1:=HSRAheader;
    | normal:            T1:=RAheader;
    | special:           T1:=HSheader;
    END;
    Str.Append(H1,sAttrMask); (* //V110 *)
    IF flagRecurse THEN
        Str.Subst(H1,"~",recurseheader);
    ELSE
        Str.Subst(H1,"~",norecurseheader);
    END;
    Str.Subst (H1,"~",T1);
    Str.Subst (H1,"~",filemask);

    IF semigraphics THEN
        Str.Subst(H1,filler,chUsed);
        Str.Subst(H1,filler,chFree);
    ELSE
        Str.Subst(H1,filler,chUsedTxt);
        Str.Subst(H1,filler,chFreeTxt);
    END;

    IF ascii THEN
        ch := txtdash;
    ELSE
        ch := graphdash;
    END;
    ReplaceChar(H2,filler,ch);
    ReplaceChar(H2,coma,ch);

    colorheader;

    print(H1);newline;
    print(H2);newline;

    colortext;
END doHeader;

(* bytes, count, percentage, bar, sort_type (mask, files) *)

PROCEDURE doTrailer (sum:HUGECARD;files:LONGCARD;
                    showcount,showpercent,showgraph,ascii,flagRecurse:BOOLEAN;
                    scanmode:scantype);
VAR
    H1,H2:str128;
    SC:str80;
    i,wisep,n,wi,wic,wip,wib : CARDINAL;
    ch:CHAR;
BEGIN
    wisep:=Str.Length(sepa);
    getWidths(wi,wic,wip,wib);
    Str.Copy(H1, fmthc (sum, blank, dot, wi) );
    Str.Copy(H2,usedfiller);

    n:=0;
    IF showcount THEN
        SC := fmtlc ( LONGCARD(files), blank, dot, wic);
        Str.Append(H1,sepa);Str.Append(H1,SC);
        INC(n,wisep);INC(n,wic);
    END;
    IF showpercent THEN INC(n,wisep);INC(n,wip); END;
    IF showgraph THEN INC(n,wisep);INC(n,wib); END;
    INC(n,wisep);INC(n,Str.Length(lastfiller));
    IF n > wisep THEN
        Str.Append(H2,sepa);
        FOR i:=wisep+1 TO n DO Str.Append(H2,filler);END;
    END;

    IF ascii THEN
        ch := txtbar;
    ELSE
        ch := graphbar;
    END;
    ReplaceChar(H2,filler,ch);
    ReplaceChar(H2,coma,ch);

    CASE scanmode OF
    | normalandspecial: SC:=HSRAlong;
    | normal:           SC:=RAlong;
    | special:          SC:=HSlong;
    END;
    IF flagRecurse THEN
        Str.Subst(SC,"~",recursetrailer);
    ELSE
        Str.Subst(SC,"~",norecursetrailer);
    END;
    Str.Append(H1,SC);

    colorheader;
    print(H2);newline; (* bar first *)
    print(H1);newline; (* then values *)
    colortext;
END doTrailer;

(* ------------------------------------------------------------ *)

VAR
    globalAnchor : ptrLogEntry;

PROCEDURE getlogentry (n:CARDINAL):ptrLogEntry;
VAR
    newInList:ptrLogEntry;
BEGIN
    newInList := globalAnchor;
    WHILE newInList <> NIL DO
        IF newInList^.rank = n THEN RETURN newInList; END;
        newInList := newInList^.next;
    END;
    RETURN NIL;
END getlogentry;

(* ------------------------------------------------------------ *)

PROCEDURE isLessDir (i,j:CARDINAL   ):BOOLEAN ;
VAR
    si,sj:pathtype;
BEGIN
    getentry(i,si);
    getentry(j,sj);
    UpperCase(si);
    UpperCase(sj);
    RETURN ( Str.Compare(si,sj) < 0 );
END isLessDir;

PROCEDURE isLessDirReversed (i,j:CARDINAL   ):BOOLEAN ;
VAR
    si,sj:pathtype;
BEGIN
    getentry(i,si);
    getentry(j,sj);
    UpperCase(si);
    UpperCase(sj);
    RETURN ( Str.Compare(si,sj) > 0 );
END isLessDirReversed;

PROCEDURE isLessDirSize (i,j:CARDINAL   ):BOOLEAN ;
BEGIN
    RETURN ( Path[i]^.totalsize < Path[j]^.totalsize );
END isLessDirSize;

PROCEDURE isLessDirSizeReversed (i,j:CARDINAL   ):BOOLEAN ;
BEGIN
    RETURN ( Path[i]^.totalsize > Path[j]^.totalsize );
END isLessDirSizeReversed;

PROCEDURE isLessDirFilecount (i,j:CARDINAL   ):BOOLEAN ;
BEGIN
    RETURN ( Path[i]^.filecount < Path[j]^.filecount );
END isLessDirFilecount;

PROCEDURE isLessDirFilecountReversed (i,j:CARDINAL   ):BOOLEAN ;
BEGIN
    RETURN ( Path[i]^.filecount > Path[j]^.filecount );
END isLessDirFilecountReversed;

PROCEDURE doSwapDirs (i,j:CARDINAL);
VAR
    tmp : ptrPathInfoType;
BEGIN
    tmp       := Path[i];
    Path[i]   := Path[j];
    Path[j]   := tmp;
END doSwapDirs;

PROCEDURE doByDir (filemask:ARRAY OF CHAR;lastpath:CARDINAL;
                   reversed,showcount,showpercent,showgraph,
                   ascii,semigraphics,usefilecount,useLFN,uppercase,
                   showsum,paging,flagRecurse,usedirpath,shortenpaths:BOOLEAN;
                   scanmode:scantype);
VAR
    wibefore,i,wi,wic,wip,wib : CARDINAL;
    R:str1024; (* oversized *)
    S:pathtype;
    udne,shortform,longform : pathtype;
    S1,S2,S3,SC : str80;
    dirsize,sum : HUGECARD;
    percentused:LONGREAL;
    rc : CARDINAL;
    totalfiles,filesperdir : LONGCARD;
    charUsed,charFree:CHAR;
    enclose:BOOLEAN;
VAR
    lastRow               : CARDINAL;
    rowcount              : CARDINAL;
    key                   : str2;
BEGIN
    IF semigraphics THEN
        charUsed:=chUsed;     charFree:=chFree;
    ELSE
        charUsed:=chUsedTxt;  charFree:=chFreeTxt;
    END;
    video(msgsort,TRUE);
    IF usedirpath THEN
        IF reversed THEN
            IF usefilecount THEN
                Lib.QSort(lastpath,isLessDirFilecountReversed,doSwapDirs);
            ELSE
                Lib.QSort(lastpath,isLessDirReversed,doSwapDirs);
            END;
        ELSE
            IF usefilecount THEN
                Lib.QSort(lastpath,isLessDirFilecount,doSwapDirs);
            ELSE
                Lib.QSort(lastpath,isLessDir,doSwapDirs);
            END;
        END;
    ELSE
        IF reversed THEN
            IF usefilecount THEN
                Lib.QSort(lastpath,isLessDirFilecountReversed,doSwapDirs);
            ELSE
                Lib.QSort(lastpath,isLessDirSizeReversed,doSwapDirs);
            END;
        ELSE
            IF usefilecount THEN
                Lib.QSort(lastpath,isLessDirFilecount,doSwapDirs);
            ELSE
                Lib.QSort(lastpath,isLessDirSize,doSwapDirs);
            END;
        END;
    END;
    video(msgsort,FALSE);

    sum:=HUGEZERO;
    FOR i:=firstPath TO lastpath DO
        IF Path[i]^.showme THEN HUGEINC(sum,Path[i]^.totalsize); END;
    END;

    doHeader (modeDir,filemask,
             showcount,showpercent,showgraph,ascii,semigraphics,flagRecurse,
             scanmode);
    getWidths(wi,wic,wip,wib);

    IF paging THEN
        lastRow  := getWindowHeight();
        rowcount := initpagingcounter;
    END;

    totalfiles := 0;
    FOR i:=firstPath TO lastpath DO
      IF Path[i]^.showme THEN
        getentry(i,S);
(* print( fmtlc( LONGCARD(i)," ","",-5));print(S);newline; *)
        enclose:=FALSE;
        IF useLFN THEN
            Str.Copy(shortform,S);
            IF w9XshortToLong(shortform,rc,longform) THEN
                Str.Copy(udne,longform);
            ELSE
                Str.Copy(udne,S);
            END;
            enclose:=TRUE;
        ELSE
            IF uppercase THEN
                UpperCase(S);
            ELSE
                LowerCase(S);
            END;
            Str.Copy(udne,S);
        END;

        dirsize := Path[i]^.totalsize;
        filesperdir:=Path[i]^.filecount;
        INC(totalfiles,filesperdir);

        IF sum = HUGEZERO THEN (* //V10U fix ! *)
            percentused := HUGEZERO;
        ELSE
            percentused := (LONGREAL(dirsize) / LONGREAL(sum) ) * 100.0;
        END;

        S1 := fmthc (dirsize, blank, dot, wi);
        SC := fmtlc (filesperdir, blank, dot, wic);
        S2 := fmtpercent(percentused,blank,coma,wip);
        S3 := fmtbar(percentused,charUsed,charFree,wib);
        Str.Copy(R,S1);
        wibefore:=Str.Length(S1);
        IF showcount THEN
            Str.Append(R,sepa);Str.Append(R,SC);
            INC(wibefore,wisepa);INC(wibefore,Str.Length(SC));
        END;
        IF showpercent THEN
            Str.Append(R,sepa);Str.Append(R,S2);
            INC(wibefore,wisepa);INC(wibefore,Str.Length(S2));
        END;
        IF showgraph THEN
            Str.Append(R,sepa);Str.Append(R,S3);
            INC(wibefore,wisepa);INC(wibefore,Str.Length(S3));
        END;
        Str.Append(R,sepa);
        INC(wibefore,wisepa);

        dofixpath(shortenpaths,enclose,wibefore, udne);
        Str.Append(R,udne);
        print(R);newline;

        IF paging THEN
            INC(rowcount);
            IF rowcount >= lastRow THEN (* = is enough but who knows what evil lurks in the heart of BIOS *)
                rowcount := initpagingcounter;
                video(kbdmsg,TRUE);
                Flushkey;
                key:=Waitkey();
                video(kbdmsg,FALSE);
                IF same(key,cancel) THEN abort(errAbortedByUser,"");END;
            END;
        END;
      END;
    END;
    IF showsum THEN doTrailer(sum,totalfiles,showcount,showpercent,showgraph,ascii,flagRecurse,scanmode); END;
END doByDir;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE isLessYear (i,j:CARDINAL   ):BOOLEAN ;
VAR
    pi,pj:ptrLogEntry;
BEGIN
    pi:=getlogentry(i);
    pj:=getlogentry(j);
    RETURN ( pi^.year < pj^.year );
END isLessYear;

PROCEDURE isLessYearReversed (i,j:CARDINAL   ):BOOLEAN ;
VAR
    pi,pj:ptrLogEntry;
BEGIN
    pi:=getlogentry(i);
    pj:=getlogentry(j);
    RETURN ( pi^.year > pj^.year );
END isLessYearReversed;

PROCEDURE isLessYearSize (i,j:CARDINAL   ):BOOLEAN ;
VAR
    pi,pj:ptrLogEntry;
BEGIN
    pi:=getlogentry(i);
    pj:=getlogentry(j);
    RETURN ( pi^.totalforyear < pj^.totalforyear );
END isLessYearSize;

PROCEDURE isLessYearSizeReversed (i,j:CARDINAL   ):BOOLEAN ;
VAR
    pi,pj:ptrLogEntry;
BEGIN
    pi:=getlogentry(i);
    pj:=getlogentry(j);
    RETURN ( pi^.totalforyear > pj^.totalforyear );
END isLessYearSizeReversed;

PROCEDURE doSwapYearSize (i,j:CARDINAL);
VAR
    pi,pj:ptrLogEntry;
    tmp : CARDINAL;
BEGIN
    pi:=getlogentry(i);
    pj:=getlogentry(j);
    tmp       := pi^.rank;
    pi^.rank  := pj^.rank;
    pj^.rank  := tmp;
END doSwapYearSize;

PROCEDURE doByYear (filemask:ARRAY OF CHAR;anchor:ptrLogEntry;
                    count,lastpath:CARDINAL;
                    reversed,showcount,showpercent,showgraph,
                    ascii,semigraphics,showsum,paging,flagRecurse,justyear:BOOLEAN;
                    scanmode:scantype);
VAR
    i,wi,wic,wip,wib : CARDINAL;
    H1,H2 : str128;
    R: str128;
    S,S1,S2,S3,SC : str80;
    yearsize,sum : HUGECARD;
    yyyy : LONGCARD;
    percentused:LONGREAL;
    ptr : ptrLogEntry;
    filesperyear,totalfiles : LONGCARD;
    charUsed,charFree:CHAR;
VAR
    lastRow               : CARDINAL;
    rowcount              : CARDINAL;
    key                   : str2;
BEGIN
    IF semigraphics THEN
        charUsed:=chUsed;     charFree:=chFree;
    ELSE
        charUsed:=chUsedTxt;  charFree:=chFreeTxt;
    END;

    globalAnchor := anchor;
    video(msgsort,TRUE);
    IF justyear THEN
        IF reversed THEN
            Lib.QSort(count,isLessYearReversed,doSwapYearSize);
        ELSE
            Lib.QSort(count,isLessYear,doSwapYearSize);
        END;
    ELSE
        IF reversed THEN
            Lib.QSort(count,isLessYearSizeReversed,doSwapYearSize);
        ELSE
            Lib.QSort(count,isLessYearSize,doSwapYearSize);
        END;
    END;
    video(msgsort,FALSE);

    sum:=HUGEZERO;
    FOR i:=1 TO count DO
        ptr:=getlogentry(i);
        HUGEINC(sum,ptr^.totalforyear);
    END;

    doHeader (modeYear,filemask,
             showcount,showpercent,showgraph,ascii,semigraphics,flagRecurse,
             scanmode);
    getWidths(wi,wic,wip,wib);

    IF paging THEN
        lastRow  := getWindowHeight();
        rowcount := initpagingcounter;
    END;

    totalfiles := 0;

    FOR i:=1 TO count DO
        ptr:=getlogentry(i);
        yyyy := BIOSbaseYear+LONGCARD ( ptr^.year);
        S:=fmtlc(yyyy,blank,"",4);
        yearsize := ptr^.totalforyear;
        filesperyear := ptr^.countforyear;
        INC(totalfiles,filesperyear);

        IF sum = HUGEZERO THEN (* //V110 fix ! *)
            percentused := HUGEZERO;
        ELSE
            percentused := (LONGREAL(yearsize) / LONGREAL(sum) ) * 100.0;
        END;
        S1 := fmthc (yearsize, blank, dot, wi);
        SC := fmtlc ( LONGCARD(filesperyear), blank,dot,wic);
        S2 := fmtpercent(percentused,blank,coma,wip);
        S3 := fmtbar(percentused,charUsed,charFree,wib);
        Str.Copy(R,S1);
        SC := fmtlc ( LONGCARD(filesperyear), blank, dot, wic);
        IF showcount THEN Str.Append(R,sepa);Str.Append(R,SC);END;
        IF showpercent THEN Str.Append(R,sepa);Str.Append(R,S2);END;
        IF showgraph THEN Str.Append(R,sepa);Str.Append(R,S3);END;
        Str.Append(R,sepa);Str.Append(R,S);
        print(R);newline;

        IF paging THEN
            INC(rowcount);
            IF rowcount >= lastRow THEN (* = is enough but who knows what evil lurks in the heart of BIOS *)
                rowcount := initpagingcounter;
                video(kbdmsg,TRUE);
                Flushkey;
                key:=Waitkey();
                video(kbdmsg,FALSE);
                IF same(key,cancel) THEN abort(errAbortedByUser,"");END;
            END;
        END;

    END;
    IF showsum THEN doTrailer(sum,totalfiles,showcount,showpercent,showgraph,ascii,flagRecurse,scanmode); END;
END doByYear;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE isLessExt (i,j:CARDINAL   ):BOOLEAN ;
VAR
    pi,pj:ptrLogEntry;
    ei,ej:str16;
BEGIN
    pi:=getlogentry(i);
    pj:=getlogentry(j);
    ei:=pi^.extension;
    ej:=pj^.extension;
    (*
    Str.Caps(ei);
    Str.Caps(ej);
    *)
    RETURN ( Str.Compare (ei,ej) < 0 );
END isLessExt;

PROCEDURE isLessExtReversed (i,j:CARDINAL   ):BOOLEAN ;
VAR
    pi,pj:ptrLogEntry;
    ei,ej:str16;
BEGIN
    pi:=getlogentry(i);
    pj:=getlogentry(j);
    ei:=pi^.extension;
    ej:=pj^.extension;
    (*
    Str.Caps(ei);
    Str.Caps(ej);
    *)
    RETURN ( Str.Compare (ei,ej) > 0 );
END isLessExtReversed;

PROCEDURE isLessExtSize (i,j:CARDINAL   ):BOOLEAN ;
VAR
    pi,pj:ptrLogEntry;
BEGIN
    pi:=getlogentry(i);
    pj:=getlogentry(j);
    RETURN ( pi^.totalforext < pj^.totalforext );
END isLessExtSize;

PROCEDURE isLessExtSizeReversed (i,j:CARDINAL   ):BOOLEAN ;
VAR
    pi,pj:ptrLogEntry;
BEGIN
    pi:=getlogentry(i);
    pj:=getlogentry(j);
    RETURN ( pi^.totalforext > pj^.totalforext );
END isLessExtSizeReversed;

PROCEDURE doSwapExtSize (i,j:CARDINAL);
VAR
    pi,pj:ptrLogEntry;
    tmp : CARDINAL;
BEGIN
    pi:=getlogentry(i);
    pj:=getlogentry(j);
    tmp       := pi^.rank;
    pi^.rank  := pj^.rank;
    pj^.rank  := tmp;
END doSwapExtSize;

PROCEDURE doByExt  (filemask:ARRAY OF CHAR;anchor:ptrLogEntry;
                    count,lastpath:CARDINAL;
                    reversed,showcount,showpercent,showgraph,ascii,
                    semigraphics,uppercase,showsum,paging,flagRecurse,justext:BOOLEAN;
                    scanmode:scantype);
VAR
    i,wi,wic,wip,wib : CARDINAL;
    H1,H2,R : str128;
    S1,S2,S3,SC : str80;
    extsize,sum : HUGECARD;
    percentused:LONGREAL;
    ptr : ptrLogEntry;
    e : pathtype; (* was str16 *)
    filesperext,totalfiles:LONGCARD;
    charUsed,charFree:CHAR;
VAR
    lastRow               : CARDINAL;
    rowcount              : CARDINAL;
    key                   : str2;
BEGIN
    IF semigraphics THEN
        charUsed:=chUsed;     charFree:=chFree;
    ELSE
        charUsed:=chUsedTxt;  charFree:=chFreeTxt;
    END;

    globalAnchor := anchor;
    video(msgsort,TRUE);
    IF justext THEN
        IF reversed THEN
            Lib.QSort(count,isLessExtReversed,doSwapExtSize);
        ELSE
            Lib.QSort(count,isLessExt,doSwapExtSize);
        END;
    ELSE
        IF reversed THEN
            Lib.QSort(count,isLessExtSizeReversed,doSwapExtSize);
        ELSE
            Lib.QSort(count,isLessExtSize,doSwapExtSize);
        END;
    END;
    video(msgsort,FALSE);

    sum:=HUGEZERO;
    FOR i:=1 TO count DO
        ptr:=getlogentry(i);
        HUGEINC(sum,ptr^.totalforext);
    END;

    doHeader (modeExt,filemask,
             showcount,showpercent,showgraph,ascii,semigraphics,flagRecurse,
             scanmode);
    getWidths(wi,wic,wip,wib);

    IF paging THEN
        lastRow  := getWindowHeight();
        rowcount := initpagingcounter;
    END;

    totalfiles:=0;

    FOR i:=1 TO count DO
        ptr:=getlogentry(i);
        Str.Copy(e,ptr^.extension);
        IF uppercase THEN
            UpperCase(e);
        ELSE
            LowerCase(e);
        END;
        Str.Prepend(e,dquote);Str.Append(e,dquote);

        extsize := ptr^.totalforext;
        filesperext:= ptr^.countforext;
        INC(totalfiles,filesperext);
        IF sum = HUGEZERO THEN (* //V110 fix ! *)
            percentused := HUGEZERO;
        ELSE
            percentused := (LONGREAL(extsize) / LONGREAL(sum) ) * 100.0;
        END;
        S1 := fmthc (extsize, blank, dot, wi);
        SC := fmtlc ( LONGCARD(filesperext), blank,dot,wic);
        S2 := fmtpercent(percentused,blank,coma,wip);
        S3 := fmtbar(percentused,charUsed,charFree,wib);
        Str.Copy(R,S1);
        IF showcount THEN Str.Append(R,sepa);Str.Append(R,SC);END;
        IF showpercent THEN Str.Append(R,sepa);Str.Append(R,S2);END;
        IF showgraph THEN Str.Append(R,sepa);Str.Append(R,S3);END;
        Str.Append(R,sepa);Str.Append(R,e);
        print(R);newline;

        IF paging THEN
            INC(rowcount);
            IF rowcount >= lastRow THEN (* = is enough but who knows what evil lurks in the heart of BIOS *)
                rowcount := initpagingcounter;
                video(kbdmsg,TRUE);
                Flushkey;
                key:=Waitkey();
                video(kbdmsg,FALSE);
                IF same(key,cancel) THEN abort(errAbortedByUser,"");END;
            END;
        END;

    END;
    IF showsum THEN doTrailer(sum,totalfiles,showcount,showpercent,showgraph,ascii,flagRecurse,scanmode); END;
END doByExt;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE isLessInitialChar (i,j:CARDINAL   ):BOOLEAN ;
VAR
    pi,pj:ptrLogEntry;
BEGIN
    pi:=getlogentry(i);
    pj:=getlogentry(j);
    (* RETURN ( pi^.totalforinitial < pj^.totalforinitial ); *)
    RETURN ( ORD(pi^.initial) < ORD(pj^.initial) );
END isLessInitialChar;

PROCEDURE isLessInitialCharReversed (i,j:CARDINAL   ):BOOLEAN ;
VAR
    pi,pj:ptrLogEntry;
BEGIN
    pi:=getlogentry(i);
    pj:=getlogentry(j);
    (* RETURN ( pi^.totalforinitial > pj^.totalforinitial ); *)
    RETURN ( ORD(pi^.initial) > ORD(pj^.initial) );
END isLessInitialCharReversed;

PROCEDURE isLessInitialCount (i,j:CARDINAL   ):BOOLEAN ;
VAR
    pi,pj:ptrLogEntry;
BEGIN
    pi:=getlogentry(i);
    pj:=getlogentry(j);
    RETURN ( pi^.countforinitial < pj^.countforinitial );
END isLessInitialCount;

PROCEDURE isLessInitialCountReversed (i,j:CARDINAL   ):BOOLEAN ;
VAR
    pi,pj:ptrLogEntry;
BEGIN
    pi:=getlogentry(i);
    pj:=getlogentry(j);
    RETURN ( pi^.countforinitial > pj^.countforinitial );
END isLessInitialCountReversed;

PROCEDURE doSwapInitial (i,j:CARDINAL);
VAR
    pi,pj:ptrLogEntry;
    tmp : CARDINAL;
BEGIN
    pi:=getlogentry(i);
    pj:=getlogentry(j);
    tmp       := pi^.rank;
    pi^.rank  := pj^.rank;
    pj^.rank  := tmp;
END doSwapInitial;

PROCEDURE doByInitial  (filemask:ARRAY OF CHAR;anchor:ptrLogEntry;
                    count,lastpath:CARDINAL;
                    reversed,showcount,showpercent,showgraph,ascii,
                    semigraphics,uppercase,showsum,paging,flagRecurse,bychar:BOOLEAN;
                    scanmode:scantype);
VAR
    i,wi,wic,wip,wib : CARDINAL;
    H1,H2,R : str128;
    S1,S2,S3,SC : str80;
    initialsize,sum : HUGECARD;
    percentused:LONGREAL;
    ptr : ptrLogEntry;
    sc : str16;
    filesperinitial,totalfiles:LONGCARD;
    charUsed,charFree,c:CHAR;
VAR
    lastRow               : CARDINAL;
    rowcount              : CARDINAL;
    key                   : str2;
BEGIN
    IF semigraphics THEN
        charUsed:=chUsed;     charFree:=chFree;
    ELSE
        charUsed:=chUsedTxt;  charFree:=chFreeTxt;
    END;

    globalAnchor := anchor;
    video(msgsort,TRUE);
    IF reversed THEN
        IF bychar THEN
        Lib.QSort(count,isLessInitialCharReversed,doSwapInitial);
        ELSE
        Lib.QSort(count,isLessInitialCountReversed,doSwapInitial);
        END;
    ELSE
        IF bychar THEN
        Lib.QSort(count,isLessInitialChar,doSwapInitial);
        ELSE
        Lib.QSort(count,isLessInitialCount,doSwapInitial);
        END;
    END;
    video(msgsort,FALSE);

    sum:=HUGEZERO;
    FOR i:=1 TO count DO
        ptr:=getlogentry(i);
        HUGEINC(sum,ptr^.totalforinitial);
    END;

    doHeader (modeInitial,filemask,
             showcount,showpercent,showgraph,ascii,semigraphics,flagRecurse,
             scanmode);
    getWidths(wi,wic,wip,wib);

    IF paging THEN
        lastRow  := getWindowHeight();
        rowcount := initpagingcounter;
    END;

    totalfiles:=0;

    FOR i:=1 TO count DO
        ptr:=getlogentry(i);
        Str.Copy(sc,ptr^.initial);
        IF uppercase THEN
            UpperCase(sc);
        ELSE
            LowerCase(sc); (* useless *)
        END;
        Str.Prepend(sc,dquote);Str.Append(sc,dquote);

        initialsize := ptr^.totalforinitial;
        filesperinitial:= ptr^.countforinitial;
        INC(totalfiles,filesperinitial);
        IF sum = HUGEZERO THEN (* //V10U fix ! *)
            percentused := HUGEZERO;
        ELSE
            percentused := (LONGREAL(initialsize) / LONGREAL(sum) ) * 100.0;
        END;
        S1 := fmthc (initialsize, blank, dot, wi);
        SC := fmtlc ( LONGCARD(filesperinitial), blank,dot,wic);
        S2 := fmtpercent(percentused,blank,coma,wip);
        S3 := fmtbar(percentused,charUsed,charFree,wib);
        Str.Copy(R,S1);
        IF showcount THEN Str.Append(R,sepa);Str.Append(R,SC);END;
        IF showpercent THEN Str.Append(R,sepa);Str.Append(R,S2);END;
        IF showgraph THEN Str.Append(R,sepa);Str.Append(R,S3);END;
        Str.Append(R,sepa);Str.Append(R,sc);
        print(R);newline;

        IF paging THEN
            INC(rowcount);
            IF rowcount >= lastRow THEN (* = is enough but who knows what evil lurks in the heart of BIOS *)
                rowcount := initpagingcounter;
                video(kbdmsg,TRUE);
                Flushkey;
                key:=Waitkey();
                video(kbdmsg,FALSE);
                IF same(key,cancel) THEN abort(errAbortedByUser,"");END;
            END;
        END;

    END;
    IF showsum THEN doTrailer(sum,totalfiles,showcount,showpercent,showgraph,ascii,flagRecurse,scanmode); END;
END doByInitial;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE doBySizeRange (showsum,ascii,flagRecurse:BOOLEAN;
                        scanmode:scantype;filemask:ARRAY OF CHAR;
                        zepath:pathtype);
CONST
    Istat   = "~"+sepa+"~"+sepa+"~"+sepa+"~"+sepa+"~"+sepa+"~";
CONST
    Hpercentnum ="$$$,$";        wip = 3+1+1;
    Hpercent    ="    %";
    sepPercent  ="     ";
CONST
    Hsmallnum="$$$,$$$";         wismallnum= 3+1+3;
    Hfcount = "  Files";
CONST
    Hnum    = "$,$$$,$$$,$$$";   winum     = 1+1+3+1+3+1+3;
    Hlower  = "  Lower range";
    Hupper  = "  Upper range";
CONST
    Hhugenum= "$$$,$$$,$$$,$$$"; wihugenum = 3+1+3+1+3+1+3;
    Hftotal = "          Bytes";
VAR
    i:CARDINAL;
    totalfilecount,lowerfsize,upperfsize:LONGCARD;
    totalfilesize:HUGECARD;
    percentused:LONGREAL;
    S,Z:str128;
    S1,S2:str16;
    ch:CHAR;
BEGIN
    totalfilecount:=0;
    totalfilesize:=HUGEZERO;
    FOR i:=minndxdistri TO lastndxdistri DO
        INC(totalfilecount,distri[i].fcount);
        totalfilesize:=totalfilesize+HUGECARD(distri[i].accufsize);
    END;
    colorheader;


    S:="";
    IF NOT(flagRecurse) THEN Str.Append(S,"-r ");END;
    Str.Append(S,'~ "~" -- "~"');
    CASE scanmode OF
    | normalandspecial:  S1:=HSRAheader;
    | normal:            S1:=RAheader;
    | special:           S1:=HSheader;
    END;
    Str.Subst(S,"~",S1);
    Str.Subst(S,"~",filemask);
    Str.Subst(S,"~",zepath);
    print(S);newline;

    Str.Copy(S,Istat);
    Str.Subst(S,"~",Hnum);
    Str.Subst(S,"~",Hnum);
    Str.Subst(S,"~",Hsmallnum);
    Str.Subst(S,"~",Hpercentnum);
    Str.Subst(S,"~",Hhugenum);
    Str.Subst(S,"~",Hpercentnum);
    IF ascii THEN
        ch := txtdash;
    ELSE
        ch := graphdash;
    END;
    ReplaceChar(S,filler,ch);
    ReplaceChar(S,coma,ch);
    Str.Copy(Z,S);
    ReplaceChar(S,blank,ch);
    print(S);newline;

    Str.Copy(S,Istat);
    Str.Subst(S,"~",Hlower);
    Str.Subst(S,"~",Hupper);
    Str.Subst(S,"~",Hfcount);
    Str.Subst(S,"~",Hpercent);
    Str.Subst(S,"~",Hftotal);
    Str.Subst(S,"~",Hpercent);
    print(S);newline;

    print(Z);newline;

    colortext;
    i:=minndxdistri;
    upperfsize:=distri[i].upperlimit;
    IF upperfsize = 0 THEN
        lowerfsize:=0;
    ELSE
        lowerfsize:=0+1;
    END;
    LOOP
        IF totalfilecount = 0 THEN
            percentused := HUGEZERO;
        ELSE
            percentused := (LONGREAL(distri[i].fcount) / LONGREAL(totalfilecount) ) * 100.0;
        END;
        Str.Copy(S1,fmtpercent(percentused,blank,coma,wip));

        IF totalfilesize = HUGEZERO THEN
            percentused := HUGEZERO;
        ELSE
            percentused := (distri[i].accufsize / totalfilesize ) * 100.0;
        END;
        Str.Copy(S2,fmtpercent(percentused,blank,coma,wip));

        Str.Copy(S,Istat);
        Str.Subst(S,"~",fmtlc(lowerfsize,blank,dot,winum));
        Str.Subst(S,"~",fmtlc(upperfsize,blank,dot,winum));
        Str.Subst(S,"~",fmtlc(distri[i].fcount,blank,dot,wismallnum));
        Str.Subst(S,"~",S1);
        Str.Subst(S,"~",fmthc(distri[i].accufsize,blank,dot,wihugenum));
        Str.Subst(S,"~",S2);
        print(S);newline;
        INC(i);
        IF i > lastndxdistri THEN EXIT;END;
        lowerfsize:=upperfsize+1;
        upperfsize:=distri[i].upperlimit;
    END;

  IF showsum THEN
    colorheader;
    Str.Copy(S,Istat);
    Str.Subst(S,"~",Hnum);
    Str.Subst(S,"~",Hnum);
    Str.Subst(S,"~",Hsmallnum);
    Str.Subst(S,"~",Hpercentnum);
    Str.Subst(S,"~",Hhugenum);
    Str.Subst(S,"~",Hpercentnum);
    IF ascii THEN
        ch := txtbar;
    ELSE
        ch := graphbar;
    END;
    ReplaceChar(S,filler,ch);
    ReplaceChar(S,coma,ch);
    print(S);newline;
    Str.Concat(S,Hnum,sepa);Str.Append(S,Hnum);Str.Append(S,sepa);
    ReplaceChar(S,filler,blank);
    ReplaceChar(S,coma,blank);
    Str.Append(S,fmtlc(totalfilecount,blank,dot,wismallnum));
    Str.Append(S,sepa);
    Str.Append(S,sepPercent);
    Str.Append(S,sepa);
    Str.Append(S,fmthc(totalfilesize,blank,dot,wihugenum));
    print(S);newline;
  END;
    colortext;
END doBySizeRange;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE buildINI (VAR R:pathtype  );
VAR
    p:CARDINAL;
    S:pathtype;
BEGIN
    Lib.ParamStr(R,0); (* argh ! no longer okay when qd_text is used ! weird... *)
    UpperCase(R); (* useless ! *)
    Str.Subst(R,extEXE,extINI); (* kludgy -- let's pray for no inner ".EXE" in path ! *)
    p:=Str.RCharPos(R,antislash);
    IF p # MAX(CARDINAL) THEN
        Str.Copy(S,R);
        Str.Delete(S,0,p+1);
        IF FIO.Exists(S) THEN Str.Copy(R,S); RETURN; END;
    END;
    IF FIO.Exists(R) = FALSE THEN Str.Copy(R,"");END;
END buildINI;

PROCEDURE grabCLI (VAR cli:str256;S:pathtype):BOOLEAN;
CONST
    dbg = FALSE;
VAR
    hin:FIO.File;
    gotsep:BOOLEAN;
    R:pathtype;
BEGIN
    Str.Copy(cli,"");
    gotsep:=FALSE;
    FIO.EOF:=FALSE;
    hin:=FIO.OpenRead(S);
    LOOP
        IF FIO.EOF THEN EXIT;END;
        FIO.RdStr(hin,R);
        LtrimBlanks(R);
        RtrimBlanks(R);
        CASE R[0] OF
        | charnull: ; (* empty line *)
        | semicolon,pound: ; (* comment *)
        | lineseparator : gotsep:=same(R,lineseparator);IF gotsep THEN EXIT;END;
        ELSE
            Str.Copy(cli,R);
            IF dbg THEN print(cli);newline;END;
        END;
    END;
    FIO.Close(hin);
    RETURN gotsep;
END grabCLI;

(* ------------------------------------------------------------ *)

PROCEDURE strToLC (VAR v:LONGCARD;S:ARRAY OF CHAR):BOOLEAN ;
CONST
    bmul  = 1;
    Kbmul = 1024;  Mbmul = Kbmul * Kbmul;  Gbmul = Kbmul * Mbmul;
    rKmul = 1000;  rMmul = rKmul * rKmul;  rGmul = rKmul * rMmul;
CONST
    sMul  = "KB KO MB MO GB GO KK K MM M GG G"; (* uppercase, longest first, us and fr *)
VAR
    base,i,p:CARDINAL;
    ok:BOOLEAN;
    vmax,mul:LONGCARD;
    abrev:str2;
BEGIN
    IF same(S,"*") THEN v:=MAX(LONGCARD);RETURN TRUE;END;
    Str.Caps(S);
    (* now for prefix *)
    base:=16;
    IF Str.Match(S,dollar+"*") THEN
        Str.Delete(S,0,1);
    ELSIF Str.Match(S,"0X*") THEN
        Str.Delete(S,0,2);
    ELSIF Str.Match(S,"*H") THEN
        p:=Str.RCharPos(S,"H");
        Str.Delete(S,p,1);
    ELSE
        base:=10;
    END;
    (* now for cosmetix *)
    FOR i:=1 TO Str.Length(cosmeticseparators) DO
        ReplaceChar(S,cosmeticseparators[i-1],"");
    END;
    (* now for suffixes *)
    mul:=bmul;
    IF base = 10 THEN
        i:=0;
        LOOP
            isoleItemS(abrev, sMul,blank,i);
            IF same(abrev,"") THEN EXIT; END;
            IF Str.Pos(S,abrev) # MAX(CARDINAL) THEN
                Str.Subst(S,abrev,"");
                CASE i OF
                | 0,1:  mul:= Kbmul;
                | 2,3:  mul:= Mbmul;
                | 4,5:  mul:= Gbmul;
                | 6,7:  mul:= rKmul;
                | 8,9:  mul:= rMmul;
                |10,11: mul:= rGmul;
                END;
               EXIT;
            END;
            INC(i);
        END;
    END;
    v:=Str.StrToCard(S,base,ok);
    IF ok THEN
        IF mul # bmul THEN
            vmax:=MAX(LONGCARD) DIV mul;
            IF v > vmax THEN
                ok:=FALSE; (* too big *)
            ELSE
                v :=v * mul;
            END;
        END;
    END;
    RETURN ok;
END strToLC;

PROCEDURE isLessDistribution (i,j:CARDINAL):BOOLEAN ;
BEGIN
    RETURN distri[i].upperlimit < distri[j].upperlimit;
END isLessDistribution;

PROCEDURE swapDistribution ( i,j:CARDINAL );
VAR
    v:distritype;
BEGIN
    v:=distri[i];
    distri[i]:=distri[j];
    distri[j]:=v;
END swapDistribution;

PROCEDURE grabRanges (DEBUG,flagLessThanUpper:BOOLEAN;S:pathtype  ):CARDINAL;
VAR
    rc,i,n:CARDINAL;
    v:LONGCARD;
    hin:FIO.File;
    R:str256; (* oversized just in case *)
    state:(wait,gotfirstsep,gotsecondsep);
BEGIN
    rc:=errHelp;
    FIO.EOF:=FALSE;
    hin:=FIO.OpenRead(S);
    state:=wait;
    lastndxdistri:=minndxdistri-1;
    LOOP
        IF FIO.EOF THEN EXIT;END;
        FIO.RdStr(hin,R);
        LtrimBlanks(R);
        RtrimBlanks(R);
        CASE R[0] OF
        | charnull : ; (* empty line *)
        | semicolon,pound : ; (* comment *)
        | lineseparator :
            CASE state OF
            | wait: INC(state);
            | gotfirstsep: INC(state); EXIT;
            END;
        ELSE
            IF state = gotfirstsep THEN
                INC(lastndxdistri);
                IF lastndxdistri > maxndxdistri THEN
                    rc:=errTooManyRanges;
                    EXIT;
                ELSE
                    IF strToLC(v,R) THEN
                        IF flagLessThanUpper THEN
                            IF (v > 0) AND (v < MAX(LONGCARD)) THEN DEC(v);END;
                        END;
                        distri[lastndxdistri].upperlimit:=v;
                        distri[lastndxdistri].fcount := 0;
                        distri[lastndxdistri].accufsize:=HUGEZERO;
                    ELSE
                        rc:=errRangeBadNum;
                        EXIT;
                    END;
                END;
            END;
        END;
    END;
    FIO.Close(hin);
    CASE state OF
    | wait:
        rc:=errMissingRanges;
    | gotfirstsep:
        CASE rc OF
        | errTooManyRanges: ;
        | errRangeBadNum:   ;
        ELSE
            rc:=errMissingDistributionSep;
        END;
    | gotsecondsep :
        CASE lastndxdistri OF
        | minndxdistri-1 :
            rc:=errModernity; (* no limits ! ;-) *)
        | minndxdistri :
            (* rc:=errThereCannotBeOnlyOne; *)
            rc:=errNone;
        ELSE
            (* silently sort in order to fix possible user errors *)
            Lib.QSort(lastndxdistri,isLessDistribution,swapDistribution);
            rc:=errNone;
        END;
        IF rc = errNone THEN
            n:=0;
            FOR i:=minndxdistri+1 TO lastndxdistri DO
                IF distri[i].upperlimit=distri[i-1].upperlimit THEN INC(n);END;
            END;
            IF n # 0 THEN rc:=errRepeated;END;
        END;
    END;
(*
    IF rc=errNone THEN
        newline;
        FOR i:= minndxrange TO lastndxrange DO
            IO.WrCard(i,4);IO.WrLngCard(range[i],15);newline;
        END;
    END;
*)
    RETURN rc;
END grabRanges;

(* ------------------------------------------------------------ *)

PROCEDURE sumroot (VAR lastpath : CARDINAL);
VAR
    i,j:CARDINAL;
    filesperdir:LONGCARD;
    count : LONGCARD;
    S,R : pathtype;
    dirsize,total:HUGECARD;
BEGIN
    (*
        note to the Code Police : we sum up sizes for each root directory "?:\*\"
        the Q&D way, where count of "\" is 2
    *)
    FOR i:=firstPath TO lastpath DO
        getentry(i,S);
        total := Path[i]^.totalsize;
        count := Path[i]^.filecount;
        IF CharCount(S,backslash)=2 THEN (* for each "?:\*\" *)
            FOR j:=firstPath TO lastpath DO
                IF j # i THEN            (* ignore oneself *)
                    IF Path[j]^.showme THEN
                        getentry(j,R);
                        IF CharCount(R,backslash) > 2 THEN (* ignore "?:\" *)
                            IF Str.Pos(R,S)=0 THEN (* find root *)
                                dirsize    := Path[j]^.totalsize;
                                filesperdir:= Path[j]^.filecount;
                                HUGEINC( total, dirsize);
                                INC( count, filesperdir);
                                Path[j]^.showme := FALSE;
                            END;
                        END;
                    END;
                END;
            END;
        END;
        Path[i]^.totalsize:=total;
        Path[i]^.filecount:=count;
    END;
    (* now we force disk to only have the root directories *)

END sumroot;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* assume S is already in uppercase *)

PROCEDURE isUnitSpec ( S : ARRAY OF CHAR ) : BOOLEAN;
BEGIN
    IF Str.Length(S) # 2 THEN RETURN FALSE; END; (* not xx *)
    IF S[1] # colon THEN RETURN FALSE; END;      (* not x: *)
    RETURN Str.CharPos(letters,S[0]) # MAX(CARDINAL);
END isUnitSpec;

(* assume S is already in uppercase, minimalist f8e3 check *)

PROCEDURE chkF8E3 (S:ARRAY OF CHAR):BOOLEAN;
CONST
    maxspeclen = 8+1+3;
    legalset = letters+digits+dot+question+star;
VAR
    pb,i,len:CARDINAL;
BEGIN
    pb:=0;
    IF CharCount(S,dot) > 1 THEN INC(pb);END;
    len:=Str.Length(S);
    IF len > maxspeclen THEN INC(pb);END;
    FOR i:=1 TO len DO
        IF Str.CharPos(legalset, S[i-1])= MAX(CARDINAL) THEN INC(pb);END;
    END;
    RETURN (pb = 0);
END chkF8E3;

PROCEDURE getUnitChar (u:SHORTCARD):CHAR;
BEGIN
    RETURN CHR(u+ORD("A")-1);
END getUnitChar;

PROCEDURE getAnchor (VAR current:ARRAY OF CHAR);
VAR
    unit:SHORTCARD;
    rc:BOOLEAN;
    errcode:CARDINAL;
BEGIN
    unit:=FIO.GetDrive();
    FIO.GetDir(unit, current); (* 0=default, 1=A:, 2=B:, etc. *)
    IF Str.CharPos(current,colon)=MAX(CARDINAL) THEN (* always true, but who knows with win9X ? *)
        Str.Prepend(current,colon);
        Str.Prepend(current,getUnitChar(unit));
    END;
END getAnchor;

PROCEDURE LFNtoShort (VAR R:pathtype;useLFN:BOOLEAN );
VAR
    longname,shortname:pathtype;
    errcode:CARDINAL;
BEGIN
    IF useLFN THEN
        IF w9XlongToShort(R,errcode,shortname) THEN Str.Copy(R,shortname);END;
    END;
END LFNtoShort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    placeholder = "$";
    msgScanningDirs = "Scanning "+placeholder+" directories..."; (* $ is unit placeholder *)
    msgScanningFiles= "Scanning files in ";
TYPE
    sorttype  = SET OF (byextension, bydirectory, byyear,
                        byinitialchar, byinitialcount, byfilecount,
                        bysizerange);
CONST
    firstUnit = 1;
    maxUnit   = 26; (* A..Z at most *)
    firstparm = 1;
    maxparm   = 1;
VAR
    unit      : ARRAY [firstUnit..maxUnit] OF CHAR;
    lastUnit  : CARDINAL;
    parm      : ARRAY [firstparm..maxparm] OF pathtype;
    lastparm  : CARDINAL;
    msg,sHD,sCD,sValidUnits,sUnits    : str80;
    cdcount:CARDINAL;
    cdfirst:CHAR;
    sortcmd   : sorttype;
    DEBUG,reversed,showcount,showpercent,showgraph,ascii,semigraphics:BOOLEAN;
    shortenpaths,onlyroot,flagRecurse,flagLessThanUpper : BOOLEAN;
    useLFN,uppercase,showsum,paging,justyear,justext,usedirpath : BOOLEAN;
    scanmode : scantype;
    lastdirndx,count                   : CARDINAL;
    anchor,newInList : ptrLogEntry;
    rc                : BOOLEAN;
    filemask          : str16; (* f8e3=8+1+3=12 *)
    wimsg,wiscreen:CARDINAL;
VAR
    parmcount,i,opt : CARDINAL;
    S,R,zeOnePath,ini   : pathtype;
    useCLI          : BOOLEAN;
    cli             : str256; (* false cli, oversized just in case *)
BEGIN
    Lib.DisableBreakCheck();
    FIO.IOcheck := FALSE;

    vidinit ( IsRedirected() );
    newline; (* here for pretty output *)
    colortext;

    parmcount := Lib.ParamCount();
    useCLI    := TRUE;

    IF parmcount = 0 THEN (* q&d : we should in fact allow for options *)
        buildINI(ini);
        IF same(ini,"") THEN
            (* abort(errNotFound,S); *)
            abort(errHelp,"");
        END;

        IF grabCLI(cli,ini)=FALSE THEN abort(errMissingCLIsep,ini);END;
        parmcount := argc(cli,FALSE); (* FALSE because already trimed *)
        useCLI := (parmcount = 0); (* trap empty cli in file *)
    END;

    DEBUG := FALSE;

    lastUnit  := firstUnit-1;
    Str.Copy(sUnits,"");
    sortcmd     := sorttype{};
    reversed    := FALSE;
    showcount   := TRUE;
    showpercent := FALSE;
    showgraph   := FALSE;
    ascii       := FALSE;
    semigraphics:= TRUE;
    uppercase   := FALSE;
    showsum     := TRUE;
    paging      := FALSE;
    onlyroot    := FALSE;
    scanmode    := normalandspecial;
    filemask    := stardotstar;
    flagRecurse := TRUE;
    justyear    := FALSE;
    justext     := FALSE;
    usedirpath  := FALSE;
    shortenpaths:= FALSE;
    flagLessThanUpper:=FALSE;
    useLFN      := TRUE;
    lastparm    := firstparm-1;

    FOR i := 1 TO parmcount DO
        IF useCLI THEN
            Lib.ParamStr(S,i);
        ELSE
            argv(S,cli,i,FALSE); (* FALSE because already trimed *)
        END;
        Str.Copy(R,S);
        UpperCase(R);
        cleantabs(R); (* YATB : Yet Another TopSpeed Bug ! *)
        IF isOption(R) THEN
            opt := GetOptIndex(R, "?"+delim+"H"+delim+"HELP"+delim+
                                  "DEBUG"+delim+"DEBUG"+delim+
                                  "D"+delim+"DIRECTORY"+delim+
                                  "E"+delim+"EXTENSION"+delim+
                                  "Y"+delim+"YEAR"+delim+
                                  "-"+delim+"REVERSE"+delim+
                                  "P"+delim+"PERCENTAGE"+delim+
                                  "G"+delim+"BARGRAPH"+delim+
                                  "A"+delim+"ASCII"+delim+
                                  "N"+delim+"NORMAL"+delim+
                                  "U"+delim+"UPPERCASE"+delim+
                                  "C"+delim+"COUNT"+delim+
                                  "S"+delim+"SUM"+delim+
                                  "K"+delim+"P"+delim+"PAGING"+delim+
                                  "DD"+delim+"ROOT"+delim+
                                  "F:"+delim+"FILE:"+delim+
                                  "L"+delim+"LFN"+delim+
                                  "Z"+delim+"SPECIAL"+delim+
                                  "T"+delim+"TEXT"+delim+
                                  "GG"+delim+
                                  "J"+delim+"R"+delim+
                                  "I"+delim+"INITIAL"+delim+
                                  "II"+delim+
                                  "AA"+delim+
                                  "YY"+delim+
                                  "EE"+delim+
                                  "F"+delim+"PATH"+delim+
                                  "FF"+delim+
                                  "DF"+delim+
                                  "DDF"+delim+
                                  "V"+delim+"FILECOUNT"+delim+
                                  "W"+delim+"COLUMNS"+delim+
                                  "M"+delim+"DISTRIBUTION"+delim+"SIZERANGE"+delim+
                                  "MM"
(*%T CONSOLE  *)
                                                    +delim+
                                  "B"+delim+"BIOS"
(*%E  *)
                              );
            CASE opt OF
            | 1,2,3 : abort(errHelp,"");
            | 4,5   : DEBUG := TRUE;
            | 6,7   : INCL (sortcmd,bydirectory);
            | 8,9   : INCL (sortcmd,byextension);
            | 10,11 : INCL (sortcmd,byyear);
            | 12,13 : reversed :=TRUE;
            | 14,15 : showpercent  :=TRUE;
            | 16,17 : showgraph    :=TRUE;
            | 18,19 : ascii    :=TRUE;
            | 20,21 : CASE scanmode OF
                      | normalandspecial,normal:
                          scanmode:=normal;
                      ELSE
                          abort(errAttr,"");
                      END;
            | 22,23 : uppercase:=TRUE;
            | 24,25 : showcount:=FALSE;
            | 26,27 : showsum  :=FALSE;
            | 28,29,30:paging  :=TRUE;
            | 31,32 : INCL (sortcmd,bydirectory);onlyroot :=TRUE;
            | 33,34 : GetString(R,filemask);
                      IF chkF8E3(filemask)=FALSE THEN abort(errBadFileMask,R);END;
            | 35,36 : useLFN:=FALSE;
            | 37,38 : CASE scanmode OF
                      | normalandspecial,special:
                          scanmode:=special;
                      ELSE
                          abort(errAttr,"");
                      END;
            | 39,40: semigraphics := FALSE;
            | 41:    showgraph :=TRUE; semigraphics:=FALSE;
            | 42,43: flagRecurse:=FALSE;
            | 44,45: INCL (sortcmd,byinitialchar);
            | 46:    INCL (sortcmd,byinitialcount);
            | 47:    ascii :=TRUE; semigraphics:=FALSE;
            | 48:    INCL (sortcmd,byyear);       justyear:=TRUE;
            | 49:    INCL (sortcmd,byextension);  justext :=TRUE;
            | 50,51: INCL (sortcmd,bydirectory);  usedirpath :=TRUE; (* -f forces -d *)
            | 52:    INCL (sortcmd,bydirectory);  usedirpath :=TRUE; onlyroot:=TRUE; (* -ff forces -dd *)
            | 53:    INCL (sortcmd,bydirectory);  usedirpath :=TRUE; (* -df *)
            | 54:    INCL (sortcmd,bydirectory);  usedirpath :=TRUE; onlyroot :=TRUE; (* -ddf *)
            | 55,56: INCL (sortcmd,byfilecount);
            | 57,58: shortenpaths:=TRUE;
            | 59,60,61: INCL (sortcmd,bysizerange);
            | 62:       INCL (sortcmd,bysizerange); flagLessThanUpper:=TRUE; (* //FIXME TO do *)
(*%T CONSOLE  *)
            | 63,64: vidinit( TRUE);
(*%E  *)
            ELSE
                abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            IF isUnitSpec(R) THEN (* "u:" *)
                INC(lastUnit);
                IF lastUnit > maxUnit THEN abort(errTooManyUnits,S); END; (* extremely unlikely and even impossible ! *)
                IF Str.CharPos(sUnits,R[0]) # MAX(CARDINAL) THEN
                    abort(errAlreadySpecified,S); (* we could just ignore it, but... *)
                END;
                unit[lastUnit] := R[0]; (* keep uppercase *)
                Str.Append(sUnits,R[0]);
            ELSE
                INC(lastparm);
                IF lastparm > maxparm THEN abort(errTooManyParms,S);END;
                Str.Copy(parm[lastparm],S);
            END;
        END;
    END;

    useLFN := ( useLFN AND w9XsupportLFN() );

    IF lastparm = maxparm THEN
        IF lastUnit < firstUnit THEN

            Str.Copy(R,parm[lastparm]);
            CASE Str.CharPos(R,colon) OF
            | 1,MAX(CARDINAL):
                ;
            ELSE
                abort(errBadPath,R);
            END;
            IF same(R,stardotstar) THEN R:=dot; END;
            IF same(R,dot) THEN getAnchor(R);END;
            IF chkJoker(R) THEN abort(errJoker,R);END;
            IF same(R,backslash)=FALSE THEN
                LFNtoShort(R,useLFN);
                IF isDirectory(R)=FALSE THEN
                    IF FIO.Exists(R) THEN
                        abort(errIsFile,R);
                    ELSE
                        abort(errIsNotDir,R);
                    END;
               END;
            END;
            fixDirectory(R);
            Str.Copy(zeOnePath,R);

        ELSE
            abort(errEitherDirOrUnit,"");
        END;

    ELSE  (* no dir specified *)
        IF lastUnit < firstUnit THEN abort(errNoUnitSpecified,"");END;
    END;

    IF    sortcmd=sorttype{} THEN
        INCL(sortcmd,bydirectory);
    ELSIF sortcmd=sorttype{byextension} THEN
        ;
    ELSIF sortcmd=sorttype{bydirectory} THEN
        ;
    ELSIF sortcmd=sorttype{byyear}      THEN
        ;
    ELSIF sortcmd=sorttype{byinitialchar}   THEN
        ;
    ELSIF sortcmd=sorttype{byinitialcount}  THEN
        ;
    ELSIF sortcmd=sorttype{byfilecount} THEN
        ;
    ELSIF sortcmd=sorttype{bysizerange} THEN
        buildINI(ini);
        IF same(ini,"") THEN abort(errNotFound,ProgEXEname+extINI); END;
        i:=grabRanges(DEBUG,flagLessThanUpper,ini);
        IF i # errNone THEN abort(i,ini);END;
    ELSE
        abort(errSortConflict,"");
    END;

    IF shortenpaths THEN
        IF    sortcmd = sorttype{bydirectory} THEN
            ;
        ELSIF sortcmd = sorttype{byfilecount} THEN
            ;
        ELSE
            abort(errByDirRequired,"");
        END;
    END;

    (*
    print(Banner);newline;
    newline;
    *)

    lastdirndx:=firstPath;

    IF lastparm = maxparm THEN
        Str.Copy(S,zeOnePath);
        Str.Copy(msg,msgScanningDirs);
        Str.Subst(msg,placeholder, S);
        video(msg,TRUE);
        (* recurse, sort *)
        IF buildPathList (S, useLFN,flagRecurse, TRUE, DEBUG,lastdirndx)=FALSE THEN
            video(msg,FALSE);
            abort(errTooManyDirs,S);
        END;
        video(msg,FALSE);
    ELSE
        getCDROMletters(cdcount,cdfirst,sCD);
        getAllHDunits(sHD);
        Str.Concat(sValidUnits,"AB",sHD);Str.Append(sValidUnits,sCD);

        FOR i := firstUnit TO lastUnit DO
            IF Str.CharPos( sValidUnits, unit[i] ) = MAX(CARDINAL) THEN
                abort(errPhantomUnit,unit[i]);
            END;
        END;

        FOR i := firstUnit TO lastUnit DO
            Str.Copy(msg,msgScanningDirs);
            Str.Subst(msg,placeholder, unit[i]);
            video(msg,TRUE);
            Str.Concat(S,unit[i],colon);
            Str.Append(S,backslash);
            (* recurse, sort *)
            IF buildPathList (S, useLFN,flagRecurse, TRUE, DEBUG,lastdirndx)=FALSE THEN
                video(msg,FALSE);
                abort(errTooManyDirs,S);
            END;
            video(msg,FALSE);
        END;
    END;

IF DEBUG THEN
    FOR i:=firstPath TO lastdirndx DO
        getentry(i,S);

        print(fmtlc( LONGCARD(i)," ","",-5));
        print(S);newline;
    END;
END;

    wiscreen:=getColumns();
    wimsg:=Str.Length(msgScanningFiles);

    anchor := NIL; (* required default *)

    video(msgScanningFiles,TRUE);
    FOR i:=firstPath TO lastdirndx DO
        getentry(i,S);
        shortenVid(R, wiscreen,wimsg,S);
        video(R,TRUE );
        IF sortcmd=sorttype{byextension} THEN
            rc:=buildDataExt    (useLFN,scanmode,S,filemask,i,anchor,newInList,count);
        ELSIF sortcmd=sorttype{bydirectory} THEN
            rc:=buildDataDir    (scanmode,S,filemask,i,buildmodeDIR,useLFN,DEBUG);
        ELSIF sortcmd=sorttype{byyear}     THEN
            rc:=buildDataYear   (useLFN,scanmode,S,filemask,i,anchor,newInList,count);
        ELSIF sortcmd=sorttype{byinitialchar}  THEN
            rc:=buildDataInitial(useLFN,scanmode,S,filemask,i,anchor,newInList,count);
        ELSIF sortcmd=sorttype{byinitialcount}  THEN
            rc:=buildDataInitial(useLFN,scanmode,S,filemask,i,anchor,newInList,count);
        ELSIF sortcmd=sorttype{byfilecount} THEN
            rc:=buildDataDir    (scanmode,S,filemask,i,buildmodeDIR,useLFN,DEBUG); (* same as bydirectory *)
        ELSIF sortcmd=sorttype{bysizerange} THEN
            rc:=buildDataDir    (scanmode,S,filemask,i,buildmodeDISTRI,useLFN,DEBUG); (* same as bydirectory *)
        END;
        IF rc=FALSE THEN
             video(R,FALSE); (* prior to //V11A we were dumping S *)
             video(msgScanningFiles,FALSE);
             abort(errAllocate,S);
        END;
        video(R,FALSE);
    END;
    video(msgScanningFiles,FALSE);

    IF paging THEN
        IF IsRedirected() THEN paging:=FALSE;END;
    END;

    (* ok let's go now ! *)

    IF sortcmd=sorttype{byextension}    THEN
        doByExt (filemask,anchor,count,lastdirndx,
                 reversed,showcount,showpercent,showgraph,ascii,semigraphics,
                 uppercase,showsum,paging,flagRecurse,justext,scanmode);
    ELSIF sortcmd=sorttype{bydirectory} THEN
        IF onlyroot THEN sumroot(lastdirndx);END;
        doByDir (filemask,lastdirndx,
                 reversed,showcount,showpercent,showgraph,ascii,semigraphics,
                 FALSE,useLFN,
                 uppercase,showsum,paging,flagRecurse,usedirpath,shortenpaths,
                 scanmode);
    ELSIF sortcmd=sorttype{byyear}      THEN
        doByYear (filemask,anchor,count,lastdirndx,
                  reversed,showcount,showpercent,showgraph,ascii,semigraphics,
                  showsum,paging,flagRecurse,justyear,scanmode);
    ELSIF sortcmd=sorttype{byinitialchar}   THEN
        doByInitial (filemask,anchor,count,lastdirndx,
                 reversed,showcount,showpercent,showgraph,ascii,semigraphics,
                 uppercase,showsum,paging,flagRecurse,TRUE,scanmode);
    ELSIF sortcmd=sorttype{byinitialcount}   THEN
        doByInitial (filemask,anchor,count,lastdirndx,
                 reversed,showcount,showpercent,showgraph,ascii,semigraphics,
                 uppercase,showsum,paging,flagRecurse,FALSE,scanmode);
    ELSIF sortcmd=sorttype{byfilecount} THEN
        doByDir (filemask,lastdirndx,
                 reversed,showcount,showpercent,showgraph,ascii,semigraphics,
                 TRUE,useLFN,
                 uppercase,showsum,paging,flagRecurse,usedirpath,shortenpaths,scanmode);
    ELSIF sortcmd=sorttype{bysizerange} THEN
        doBySizeRange(showsum,ascii,flagRecurse,scanmode,filemask,zeOnePath);
    END;

    freeData(anchor); (* no problemo for bydirectory because anchor will be NIL *)
    freePaths(lastdirndx);

    abort(errNone,"");
END fu.

(*

c:\bat
$
0
1K
10K
100000
1M
10000000
100000000
1G
*
$

*)



