(* ---------------------------------------------------------------
Title         Q&D HTML to ASCII
Author        PhG
Overview      try and convert an HTML file to mere ASCII
Usage         see help
Notes         very, very, very quick & dirty... :-(
              minimal error messages and checking, etc.
              ini is HTMSTRIP.INI data THEN star THEN FIXHTM data THEN star
              warning : hash can be unique for different strings ! check twice !
              keep case for entities
              handle /* */
              check //FIXME AND //FIXHTM

              time for a complete rewrite as to support newer overcomplicated HTML files

Bugs          with compact model, compiler would say no for buffers beyond 16384 bytes
              but would say ok for 64000 bytes, thus leading to weird crashes !
              a pragma threshold 16384 was required in project file
Wish List     check -ns for scripts sometimes appearing as text
              remove frames ?
              handle gt and lt in strings and in code ?
              <script> a<b </script> forces problems FOR now...

--------------------------------------------------------------- *)

MODULE HTM2ASC;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT IO;

FROM IO IMPORT WrStr, WrLn;

FROM Storage IMPORT ALLOCATE,DEALLOCATE,Available;

FROM QD_ASCII IMPORT dash, slash, nullchar, tabchar, cr, lf, nl, bs,
space, dot, deg, degree, doublequote, quote, colon, percent, vbar,
blank, equal, dquote, charnull, singlequote, antislash, dollar,
star, backslash, coma, question, underscore, underbar, tabul, hbar,
comma, semicolon, diese, pound, openbracket, closebracket, tilde, exclam,
stardotstar, dotdot, escCh, escSet, letters, digits,
lettersUpp, lettersLow, openbrace, closebrace, ampersand;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory, qdSplitAllPath,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite, setReadOnly,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs, UpperCaseAlt, LowerCaseAlt,
completedInit, completedShow, completedSHOW, completedEnd, completed,
removeDups, isValidHDunit, removePhantoms, removeFloppies,
getCDROMunits, getCDROMletters, removeCDROMs, getAllHDunits,
getAllLegalUnits, metaproc, getCli, argc, argv,
metaproc, UpperCaseFR, LowerCaseFR, ASCIIonly;

FROM QD_File IMPORT pathtype, w9XnothingRequired,
fileOpenRead, fileOpen, fileExists, fileExistsAlt,
fileIsRO, fileSetRW, fileSetRO,
fileErase, fileCreate, fileAppend,fileRename,
fileGetFileSize, fileGetFileStamp,
fileIsDirectorySpec, fileClose, fileFlush, fileSupportLFN;

FROM QD_LFN IMPORT path9X, huge9X, findDataRecordType,
unicodeConversionFlagType, w9XchangeDir,
w9XgetDOSversion, w9XgetTrueDOSversion, w9XisWindowsEnh, w9XisMSDOS7,
w9XfindFirst, w9XfindNext, w9XfindClose, w9XgetCurrentDirectory,
w9XlongToShort, w9XshortToLong, w9XtrueName, w9XchangeDir,
w9XmakeDir, w9XrmDir, w9Xrename, w9XopenFile, w9XcloseFile,
w9XsupportLFN;

(* ------------------------------------------------------------ *)

CONST
    ProgEXEname   = "HTM2ASC";
    ProgTitle     = "Q&D HTML to ASCII";
    ProgVersion   = "v1.2k";
    ProgCopyright = "by PhG";
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;
CONST
    imgMarker     = "<[i]>";
    vbarsep       = " | "; (* td etajvpc fix CHR(124) $7c *)
CONST
    maxentry      = 500;
    sMaxEntry     = "500";
CONST
    extHTM        = ".HTM";
    extASC        = ".ASC";
    extTXT        = ".TXT";
    extKOD        = ".KOD";
CONST
    extINI        = ".INI";
    extBAK        = ".BK!";
    extCOM        = ".COM";
    extEXE        = ".EXE";
    extDLL        = ".DLL";
    extOVR        = ".OVR";
    extOVL        = ".OVL";
    extDRV        = ".DRV";
    extZIP        = ".ZIP";
    extARJ        = ".ARJ";
    extLZH        = ".LZH";
    skippedextensions = extINI+delim+extBAK+delim+extCOM+delim+extEXE+delim+
                        extDLL+delim+extOVR+delim+extOVL+delim+extDRV+delim+
                        extZIP+delim+extARJ+delim+extLZH;
CONST
    sTMP          = "TMP";
    sTEMP         = "TEMP";
    sTMPDIR       = "TMPDIR";
    sTEMPDIR      = "TEMPDIR";
CONST
    sTMPNAME      = "$DELME$.TMP";
CONST
    nltabul         = nl+tabul;
CONST
    lennl           = 2;
    lennltabul      = 3;
CONST
    errNone         = 0;
    errHelp         = 1;
    errOption       = 2;
    errTooManyParms = 3;
    errMissingName  = 4;
    errTooManyFiles = 5;
    errNoMatch      = 6;
    errMissingIni   = 7;
    errTooManyEntities=8;
    errEntityParse  = 9;
    errTooManyCodes = 10;
    errProcessConflict=11;
    errBadExt       = 12;
    errETAJVconflict= 13;
    errMissingSeparator=14;
    errTooManyXlats = 15;
    errXlatParse    = 16;
    errConflict     = 17;
    errAborted      = 64;
    errValidHTML    = 128;
    errInvalidHTML  = 255;

(* ------------------------------------------------------------ *)

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
CONST
    msghelp=
Banner+nl+
nl+
"Syntax 1 : "+ProgEXEname+" <file["+extHTM+"]> [option]..."+nl+
"Syntax 2 : "+ProgEXEname+" <-c[c]> <file["+extHTM+"]>"+nl+
"Syntax 3 : "+ProgEXEname+" <-ns[u]> <file["+extHTM+"] [-u]>"+nl+
nl+
"This program converts HTML to ASCII, ignoring all formatting (syntax 1) ;"+nl+
"tries and checks basic HTML validity (syntax 2) ;"+nl+
"or filters out scripts in HTML files (syntax 3)."+nl+
nl+
"   -c[c]  check basic HTML conformity (all other options ignored)"+nl+
"   -ns[u] filter out scripts (all other options ignored except -u)"+nl+
"   -p     convert <P> to a CR+LF sequence"+nl+
"   -t     convert <P> to a CR+LF+TAB sequence"+nl+
"   -hr    convert <HR> to a tilde+CR+LF sequence"+nl+
"   -tr    convert <TR> and </TR> to a CR+LF sequence"+nl+
(* //FIXFIX
"   -fix   preprocess file so sequences are translated (FIXHTM emulation)"+nl+
*)
"   -oem   convert entities and sequences to Windows ANSI OEM"+nl+
"   -wp    keep <B>, <I>, <EM> and <STRONG> text attributes for word processing"+nl+
"          (find and replace $b_..._b$, $i_..._i$, $e_..._e$, $s_..._s$ codes)"+nl+
"   -i     keep <IMG*> references (-ii = insert "+imgMarker+" marker)"+nl+
"   -f     filter out CRs and LFs found in HTML codes"+nl+
"   -o     overwrite existing target"+nl+
"   -r     reverse processing (dump HTML codes, ignoring script code if any)"+nl+
"   -d     while processing, dump HTML codes to screen"+nl+
"   -s     dump script code (if any) with text"+nl+
"   -y     dump style code (if any) with text"+nl+
"   -k     create target in current directory instead of source directory"+nl+
"   -u     update date/time stamp (-ns[u] option only)"+nl+
(* //FIXFIX
"   -z     force temporary files to be created in current directory (-fix only)"+nl+
*)
"   -w     disable ESCape polling (may be necessary with Win9X/WinXP)"+nl+
"   -etajv undocumented special processing"+nl+
"   -x     disable LFN support even if available"+nl+
nl+
"a) "+skippedextensions+" files are ignored."+nl+
"b) "+ProgEXEname+extINI+" file must exist in executable directory :"+nl+
"   it contains up to "+sMaxEntry+" HTML entities and up to "+sMaxEntry+" sequences."+nl+
(* //FIXFIX
"c) Temporary files are created in directory specified by, in that order,"+nl+
"   "+sTMP+", "+sTEMP+", "+sTMPDIR+", "+sTEMPDIR+" environment variables"+nl+
"   (if none of these variables is defined, or if -z option is specified,"+nl+
"   current directory will be used instead). This applies to -fix option only."+nl+
*)
"c) Created files will have the following extensions (according to options) :"+nl+
'   "'+extASC+'" (DOS), "'+extTXT+'" (Windows) and "'+extKOD+'" (codes).'+nl+
'   -ns[u] option keeps original files with "'+extBAK+'" extension.'+nl+
"d) -c[c] option checks the following pattern :"+nl+
'   "<html*>*<head*>*</head>*<body*>*</body>*</html>" (*=any string).'+nl+
"   It returns code is 255 if there was at least one mismatch, 128 if none."+nl+
"   -cc alternate option does not display successes."+nl+
"   Note filenames with unexpected characters cannot be opened :"+nl+
"   check will then fail even if file is valid."+nl+
"e) This simple program was not meant to try and keep HTML formatting :"+nl+
"   result may not be pretty and will almost always require editing,"+nl+
"   especially with newer HTML complicated files"+nl+
"   (many of which requiring preprocessing for character conversion)."+nl+
'   A better tool could then be HTMSTRIP by Bruce "Wayne Software" Guthrie,'+nl+
"   although it unfortunately crashes on many newer HTML files. :-("+nl;

VAR
    S : str1024;
BEGIN
    CASE e OF
    | errHelp :
        WrStr(msghelp);
    | errOption :
        Str.Concat(S,"Illegal ",einfo);
        Str.Append(S," option !");
    | errTooManyParms :
        Str.Concat(S,einfo," is just one parameter too far !");
    | errMissingName :
        S := "Missing file specification !";
    | errTooManyFiles :
        Str.Concat(S,"Too many files match ",einfo);
        Str.Append(S," specification !");
    | errNoMatch :
        Str.Concat(S,"No file matches ",einfo);
        Str.Append(S," specification !");
    | errMissingIni :
        Str.Concat(S,"Missing ",einfo);
        Str.Append(S," file !");
    | errTooManyEntities :
        S:="Too many entities are defined in INI file !";
    | errEntityParse :
        Str.Concat(S,"Entity parsing error ! ",einfo);
    | errTooManyCodes:
        S:="Too many codes are defined !";
    | errProcessConflict:
        S:="-p and -t options are mutually exclusive !";
    | errBadExt :
        S:="File extension would prevent file(s) from being processed !";
    | errETAJVconflict:
        S:="-tr and -etajv options are mutually exclusive !";
    | errMissingSeparator:
        S:='Missing "*" separator in INI file !';
    | errTooManyXlats :
        S:="Too many sequences are defined in INI file !";
    | errXlatParse:
        Str.Concat(S,"Sequence parsing error ! ",einfo);
    | errConflict:
        S:="-c[c] and -ns[u] options are mutually exclusive !";

    | errAborted:
        S:="Aborted by user !";

    | errValidHTML:
        S:="Returning 128 (no HTML problem detected) !"; (* never displayed *)
    | errInvalidHTML:
        S:="Returning 255 (at least one HTML problem detected) !";
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp:
        ;
    | errValidHTML,errInvalidHTML:
        ;
    ELSE
        WrStr(ProgEXEname+" : "); WrStr(S); WrLn;
    END;
    Lib.SetReturnCode(SHORTCARD(e));
    HALT;
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE doGetCurrent (useLFN:BOOLEAN;drive:SHORTCARD;
                       VAR unit:str2; VAR current:pathtype);
VAR
    rc:CARDINAL;
    longform:pathtype;
BEGIN
    Str.Concat(unit, CHR( ORD("A")-1+ORD(drive) ),colon);

    FIO.GetDir(drive,current); (* \path without u: nor trailing \ except at root *)
    IF current[1] # colon THEN Str.Prepend(current,unit); END; (* safety *)
    IF useLFN THEN
        IF w9XshortToLong(current,rc,longform) THEN (* if error, keep DOS current *)
            Str.Copy(current,longform);
        END;
    END;
    (* LFN function seems to always return "u:\*" form except at root *)
    IF current[1] = colon THEN Str.Delete(current,0,2);END; (* safety *)
    fixDirectory(current);
END doGetCurrent;

(* we don't check for TMP validity *)

PROCEDURE buildWorkDir (useLFN,forcecurrent:BOOLEAN; VAR workdir:pathtype);
CONST
    numvars = 4;
VAR
    i:CARDINAL;
    D:str128;
    drive:SHORTCARD;
    unit:str2;
    current:pathtype;
BEGIN
    IF forcecurrent THEN
        i:=numvars+1;
    ELSE
        i:=1;
        LOOP
            CASE i OF
            | 1: D:=sTMP;
            | 2: D:=sTEMP;
            | 3: D:=sTMPDIR;
            | 4: D:=sTEMPDIR;
            END;
            Lib.EnvironmentFind(D,workdir);
            IF same(workdir,"")=FALSE THEN EXIT; END;
            INC(i);
            IF i > numvars THEN EXIT; END;
        END;
    END;
    IF i > numvars THEN
        drive := FIO.GetDrive();
        doGetCurrent(useLFN,drive, unit,current); (* "u:" and "\" or "\*\" *)
        Str.Concat(workdir,unit,current);
    END;
    fixDirectory(workdir);
END buildWorkDir;

(* ------------------------------------------------------------ *)

(* ripped and adapted from old PC2WIN v1.0a last revised 29 Apr 00 *)

TYPE
    chardef   = RECORD
                    Code    : BYTE;
                    Flag    : CHAR;
                    MapChar : BYTE;
                END;
    CharTable = ARRAY [0..255] OF chardef;

CONST
    TpcTOwin  = CharTable (
    chardef(000H, "=", 000H),
    chardef(001H, "=", 001H),
    chardef(002H, "=", 002H),
    chardef(003H, "=", 003H),
    chardef(004H, "=", 004H),
    chardef(005H, "=", 005H),
    chardef(006H, "=", 006H),
    chardef(007H, "=", 007H),
    chardef(008H, "=", 008H),
    chardef(009H, "!", 009H),
    chardef(00AH, "=", 00AH),
    chardef(00BH, "=", 00BH),
    chardef(00CH, "=", 00CH),
    chardef(00DH, "=", 00DH),
    chardef(00EH, "=", 00EH),
    chardef(00FH, "=", 00FH),
    chardef(010H, "=", 010H),
    chardef(011H, "=", 011H),
    chardef(012H, "=", 012H),
    chardef(013H, "=", 013H),
    chardef(014H, "!", 0B6H),
    chardef(015H, "!", 0A7H),
    chardef(016H, "=", 016H),
    chardef(017H, "=", 017H),
    chardef(018H, "=", 018H),
    chardef(019H, "=", 019H),
    chardef(01AH, "=", 01AH),
    chardef(01BH, "=", 01BH),
    chardef(01CH, "=", 01CH),
    chardef(01DH, "=", 01DH),
    chardef(01EH, "=", 01EH),
    chardef(01FH, "=", 01FH),
    chardef(020H, "=",  " "),
    chardef(021H, "=",  "!"),
    chardef(022H, "=",  '"'),
    chardef(023H, "=",  "#"),
    chardef(024H, "=",  "$"),
    chardef(025H, "=",  "%"),
    chardef(026H, "=",  "&"),
    chardef(027H, "=",  "'"),
    chardef(028H, "=",  "("),
    chardef(029H, "=",  ")"),
    chardef(02AH, "=",  "*"),
    chardef(02BH, "=",  "+"),
    chardef(02CH, "=",  ","),
    chardef(02DH, "=",  "-"),
    chardef(02EH, "=",  "."),
    chardef(02FH, "=",  "/"),
    chardef(030H, "=",  "0"),
    chardef(031H, "=",  "1"),
    chardef(032H, "=",  "2"),
    chardef(033H, "=",  "3"),
    chardef(034H, "=",  "4"),
    chardef(035H, "=",  "5"),
    chardef(036H, "=",  "6"),
    chardef(037H, "=",  "7"),
    chardef(038H, "=",  "8"),
    chardef(039H, "=",  "9"),
    chardef(03AH, "=",  ":"),
    chardef(03BH, "=",  ";"),
    chardef(03CH, "=",  "<"),
    chardef(03DH, "=",  "="),
    chardef(03EH, "=",  ">"),
    chardef(03FH, "=",  "?"),
    chardef(040H, "=",  "@"),
    chardef(041H, "=",  "A"),
    chardef(042H, "=",  "B"),
    chardef(043H, "=",  "C"),
    chardef(044H, "=",  "D"),
    chardef(045H, "=",  "E"),
    chardef(046H, "=",  "F"),
    chardef(047H, "=",  "G"),
    chardef(048H, "=",  "H"),
    chardef(049H, "=",  "I"),
    chardef(04AH, "=",  "J"),
    chardef(04BH, "=",  "K"),
    chardef(04CH, "=",  "L"),
    chardef(04DH, "=",  "M"),
    chardef(04EH, "=",  "N"),
    chardef(04FH, "=",  "O"),
    chardef(050H, "=",  "P"),
    chardef(051H, "=",  "Q"),
    chardef(052H, "=",  "R"),
    chardef(053H, "=",  "S"),
    chardef(054H, "=",  "T"),
    chardef(055H, "=",  "U"),
    chardef(056H, "=",  "V"),
    chardef(057H, "=",  "W"),
    chardef(058H, "=",  "X"),
    chardef(059H, "=",  "Y"),
    chardef(05AH, "=",  "Z"),
    chardef(05BH, "=",  "["),
    chardef(05CH, "=",  "\"),
    chardef(05DH, "=",  "]"),
    chardef(05EH, "=",  "^"),
    chardef(05FH, "=",  "_"),
    chardef(060H, "=",  "`"),
    chardef(061H, "=",  "a"),
    chardef(062H, "=",  "b"),
    chardef(063H, "=",  "c"),
    chardef(064H, "=",  "d"),
    chardef(065H, "=",  "e"),
    chardef(066H, "=",  "f"),
    chardef(067H, "=",  "g"),
    chardef(068H, "=",  "h"),
    chardef(069H, "=",  "i"),
    chardef(06AH, "=",  "j"),
    chardef(06BH, "=",  "k"),
    chardef(06CH, "=",  "l"),
    chardef(06DH, "=",  "m"),
    chardef(06EH, "=",  "n"),
    chardef(06FH, "=",  "o"),
    chardef(070H, "=",  "p"),
    chardef(071H, "=",  "q"),
    chardef(072H, "=",  "r"),
    chardef(073H, "=",  "s"),
    chardef(074H, "=",  "t"),
    chardef(075H, "=",  "u"),
    chardef(076H, "=",  "v"),
    chardef(077H, "=",  "w"),
    chardef(078H, "=",  "x"),
    chardef(079H, "=",  "y"),
    chardef(07AH, "=",  "z"),
    chardef(07BH, "=",  "{"),
    chardef(07CH, "=",  "|"),
    chardef(07DH, "=",  "}"),
    chardef(07EH, "=",  "~"),
    chardef(07FH, "?",  " "),
    chardef(080H, "=", 0C7H),
    chardef(081H, "=", 0FCH),
    chardef(082H, "=", 0E9H),
    chardef(083H, "=", 0E2H),
    chardef(084H, "=", 0E4H),
    chardef(085H, "=", 0E0H),
    chardef(086H, "=", 0E5H),
    chardef(087H, "=", 0E7H),
    chardef(088H, "=", 0EAH),
    chardef(089H, "=", 0EBH),
    chardef(08AH, "=", 0E8H),
    chardef(08BH, "=", 0EFH),
    chardef(08CH, "=", 0EEH),
    chardef(08DH, "=", 0ECH),
    chardef(08EH, "=", 0C4H),
    chardef(08FH, "=", 0C5H),
    chardef(090H, "=", 0C9H),
    chardef(091H, "=", 0E6H),
    chardef(092H, "=", 0C6H),
    chardef(093H, "=", 0F4H),
    chardef(094H, "=", 0F6H),
    chardef(095H, "=", 0F2H),
    chardef(096H, "=", 0FBH),
    chardef(097H, "=", 0F9H),
    chardef(098H, "=", 0FFH),
    chardef(099H, "=", 0D6H),
    chardef(09AH, "=", 0DCH),
    chardef(09BH, "=", 0A2H),
    chardef(09CH, "=", 0A3H),
    chardef(09DH, "=", 0A5H),
    chardef(09EH, "?",  " "),
    chardef(09FH, "?",  " "),
    chardef(0A0H, "=", 0E1H),
    chardef(0A1H, "=", 0EDH),
    chardef(0A2H, "=", 0F3H),
    chardef(0A3H, "=", 0FAH),
    chardef(0A4H, "=", 0F1H),
    chardef(0A5H, "=", 0D1H),
    chardef(0A6H, "=", 0AAH),
    chardef(0A7H, "=", 0BAH),
    chardef(0A8H, "=", 0BFH),
    chardef(0A9H, "?",  " "),
    chardef(0AAH, "=", 0ACH),
    chardef(0ABH, "=", 0BDH),
    chardef(0ACH, "=", 0BCH),
    chardef(0ADH, "=", 0A1H),
    chardef(0AEH, "=", 0ABH),
    chardef(0AFH, "=", 0BBH),
    chardef(0B0H, "@",  " "),
    chardef(0B1H, "@",  " "),
    chardef(0B2H, "@",  " "),
    chardef(0B3H, "@",  " "),
    chardef(0B4H, "@",  " "),
    chardef(0B5H, "@",  " "),
    chardef(0B6H, "@",  " "),
    chardef(0B7H, "@",  " "),
    chardef(0B8H, "@",  " "),
    chardef(0B9H, "@",  " "),
    chardef(0BAH, "@",  " "),
    chardef(0BBH, "@",  " "),
    chardef(0BCH, "@",  " "),
    chardef(0BDH, "@",  " "),
    chardef(0BEH, "@",  " "),
    chardef(0BFH, "@",  " "),
    chardef(0C0H, "@",  " "),
    chardef(0C1H, "@",  " "),
    chardef(0C2H, "@",  " "),
    chardef(0C3H, "@",  " "),
    chardef(0C4H, "@",  " "),
    chardef(0C5H, "@",  " "),
    chardef(0C6H, "@",  " "),
    chardef(0C7H, "@",  " "),
    chardef(0C8H, "@",  " "),
    chardef(0C9H, "@",  " "),
    chardef(0CAH, "@",  " "),
    chardef(0CBH, "@",  " "),
    chardef(0CCH, "@",  " "),
    chardef(0CDH, "@",  " "),
    chardef(0CEH, "@",  " "),
    chardef(0CFH, "@",  " "),
    chardef(0D0H, "@",  " "),
    chardef(0D1H, "@",  " "),
    chardef(0D2H, "@",  " "),
    chardef(0D3H, "@",  " "),
    chardef(0D4H, "@",  " "),
    chardef(0D5H, "@",  " "),
    chardef(0D6H, "@",  " "),
    chardef(0D7H, "@",  " "),
    chardef(0D8H, "@",  " "),
    chardef(0D9H, "@",  " "),
    chardef(0DAH, "@",  " "),
    chardef(0DBH, "@",  " "),
    chardef(0DCH, "@",  " "),
    chardef(0DDH, "@",  " "),
    chardef(0DEH, "@",  " "),
    chardef(0DFH, "@",  " "),
    chardef(0E0H, "?",  " "),
    chardef(0E1H, "=", 0DFH),
    chardef(0E2H, "?",  " "),
    chardef(0E3H, "?",  " "),
    chardef(0E4H, "?",  " "),
    chardef(0E5H, "?",  " "),
    chardef(0E6H, "=", 0B5H),
    chardef(0E7H, "?",  " "),
    chardef(0E8H, "?",  " "),
    chardef(0E9H, "?",  " "),
    chardef(0EAH, "?",  " "),
    chardef(0EBH, "?",  " "),
    chardef(0ECH, "?",  " "),
    chardef(0EDH, "=", 0D8H),
    chardef(0EEH, "?",  " "),
    chardef(0EFH, "?",  " "),
    chardef(0F0H, "?",  " "),
    chardef(0F1H, "=", 0B1H),
    chardef(0F2H, "?",  " "),
    chardef(0F3H, "?",  " "),
    chardef(0F4H, "?",  " "),
    chardef(0F5H, "?",  " "),
    chardef(0F6H, "=", 0F7H),
    chardef(0F7H, "?",  " "),
    chardef(0F8H, "=", 0B0H),
    chardef(0F9H, "?",  " "),
    chardef(0FAH, "?",  " "),
    chardef(0FBH, "?",  " "),
    chardef(0FCH, "?",  " "),
    chardef(0FDH, "=", 0B2H),
    chardef(0FEH, "?",  " "),
    chardef(0FFH, "=",  " "));

(* we don't care about flag here *)

PROCEDURE remap2oem (ch:CHAR):CHAR;
BEGIN
    RETURN TpcTOwin[ ORD(ch) ].MapChar;
END remap2oem;

(* ------------------------------------------------------------ *)

PROCEDURE legalextension (S,skipthem:ARRAY OF CHAR):BOOLEAN;
VAR
    e3 : str16;
    n:CARDINAL;
    rc:BOOLEAN;
BEGIN

    Str.Caps(S); (* ah, lowercase LFNs... *)

    rc:=TRUE;
    n:=0;
    LOOP
        isoleItemS(e3, skipthem,delim,n);
        IF same(e3,"") THEN EXIT; END;
        IF Str.Pos(S,e3) # MAX(CARDINAL) THEN rc:=FALSE;EXIT; END;
        INC(n);
    END;
    RETURN rc;
END legalextension;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pFname = POINTER TO fnameType;
    fnameType = RECORD
        next      : pFname;
        slen      : SHORTCARD;
        str       : CHAR;
    END;

PROCEDURE initList (VAR anchor : pFname );
BEGIN
    anchor := NIL;
END initList;

PROCEDURE freeList (anchor : pFname);
VAR
    needed : CARDINAL;
    p      : pFname;
BEGIN
    (* p:=anchor; *)
    WHILE anchor # NIL DO
        needed := SIZE(fnameType) - SIZE(anchor^.str) + CARDINAL(anchor^.slen);
        p := anchor^.next;
        DEALLOCATE(anchor,needed);
        anchor:=p;
    END
END freeList;

PROCEDURE buildNewPtr (VAR anchor,p:pFname; len:CARDINAL):BOOLEAN;
VAR
    needed : CARDINAL;
BEGIN
    needed := SIZE(fnameType) - SIZE(p^.str) + len;
    IF Available(needed)=FALSE THEN RETURN FALSE; END;
    IF anchor = NIL THEN
        ALLOCATE(anchor,needed);
        p:=anchor;
    ELSE
        p:=anchor;
        WHILE p^.next # NIL DO
            p:=p^.next;
        END;
        ALLOCATE(p^.next,needed);
        p:=p^.next;
    END;
    p^.next := NIL;
    RETURN TRUE;
END buildNewPtr;

(* assume p is valid *)

PROCEDURE getStr (VAR S : pathtype; p:pFname);
VAR
    len:CARDINAL;
BEGIN
    len := CARDINAL(p^.slen);
    Lib.FastMove( ADR(p^.str),ADR(S),len);
    S[len] := nullchar; (* REQUIRED safety ! *)
END getStr;

(* ------------------------------------------------------------ *)

PROCEDURE isReservedEntry (S:ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dotdot);
END isReservedEntry;

PROCEDURE buildFileList (VAR anchor:pFname;
                        DEBUG,useLFN:BOOLEAN;spec:pathtype;skipext:ARRAY OF CHAR):CARDINAL;
VAR
    count:CARDINAL; (* should do ! *)
    ok,found:BOOLEAN;
    unicodeconversion:unicodeConversionFlagType;
    w9Xentry : findDataRecordType;
    w9Xhandle,errcode:CARDINAL;
    entry : FIO.DirEntry;
    dosattr:FIO.FileAttr;
    entryname:pathtype;
    len : CARDINAL;
    pp:pFname;
    includeme:BOOLEAN;
BEGIN
    count:=0;
    IF useLFN THEN
        found := w9XfindFirst (spec,SHORTCARD(everything),SHORTCARD(w9XnothingRequired),
                              unicodeconversion,w9Xentry,w9Xhandle,errcode);
    ELSE
        found := FIO.ReadFirstEntry(spec,everything,entry);
    END;
    WHILE found DO
        IF useLFN THEN
            Str.Copy(entryname,w9Xentry.fullfilename);
        ELSE
            Str.Copy(entryname,entry.Name);
        END;
        includeme := NOT( isReservedEntry(entryname) ); (* skip "." and ".." *)
        includeme := includeme AND legalextension(entryname,skipext);
        IF includeme THEN
            IF useLFN THEN
                dosattr:=FIO.FileAttr(w9Xentry.attr AND 0FFH);
            ELSE
                dosattr:=entry.attr;
            END;
            IF NOT (aD IN dosattr) THEN
                (* if file has no extension, add it as a marker *)
                IF Str.RCharPos(entryname,".")=MAX(CARDINAL) THEN
                    Str.Append(entryname,".");
                END;
                len:=Str.Length(entryname);
                IF buildNewPtr(anchor,pp,len)=FALSE THEN
                    IF useLFN THEN ok:=w9XfindClose(w9Xhandle,errcode); END;
                    RETURN MAX(CARDINAL); (* errStorage *)
                END;
                INC(count);
                pp^.slen      := SHORTCARD(len);
                Lib.FastMove ( ADR(entryname),ADR(pp^.str),len );
IF DEBUG THEN WrStr("added : ");WrStr(entryname);WrLn; END;
            END;
        END;
        IF useLFN THEN
            found :=w9XfindNext(w9Xhandle, unicodeconversion,w9Xentry,errcode);
        ELSE
            found :=FIO.ReadNextEntry(entry);
        END;
    END;
    IF useLFN THEN ok:=w9XfindClose(w9Xhandle,errcode); END;
    RETURN count;
END buildFileList;

PROCEDURE buildPath (VAR path:pathtype; spec:pathtype);
VAR
    u,d,n,e:pathtype;
BEGIN
    qdSplitAllPath(spec, u,d,n,e);
    Str.Concat(path, u,d);
    fixDirectory(path); (* safety *)
END buildPath;

(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBuffer  = ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
VAR
    bufferIn,bufferOut : ioBuffer;

(* ------------------------------------------------------------ *)

CONST
    MAXHASH= 65535; (* max(cardinal) is really enough ! *)
TYPE
    str8 = ARRAY [1-1..8-1] OF CHAR;
    str4 = ARRAY [1-1..4-1] OF CHAR;
TYPE
    entitytype = RECORD
        hash : CARDINAL;
        string : str8;
        DOSreplacement : str4;
        WINreplacement : str4;
    END;
    xlattype = RECORD
        org:str8;
        lenorg:CARDINAL;
        dstDOS:str8;
        dstWIN:str8;
    END;
CONST
    maxstring     = 8;
    maxnew        = 4;
    minHtmlEntity = 1;
    maxHtmlEntity = maxentry;
CONST
    minXlatSeq    = minHtmlEntity;
    maxXlatSeq    = maxHtmlEntity;
VAR
    entity        : ARRAY[minHtmlEntity..maxHtmlEntity] OF entitytype;
    lastHtmlEntity: CARDINAL;
VAR
    xlat          : ARRAY[minXlatSeq..maxXlatSeq] OF xlattype;
    lastXlatSeq   : CARDINAL;

(* ------------------------------------------------------------ *)

PROCEDURE gotstr (S : ARRAY OF CHAR; VAR R : ARRAY OF CHAR) : BOOLEAN;
CONST
    markdec  = "\";
    markhex1 = "&";
    markhex2 = "H";
    decdigits="0123456789";
    hexdigits=decdigits+"ABCDEF";
VAR
    new    : str128;
    i      : CARDINAL;
    len    : CARDINAL;
    p      : CARDINAL;
    ch     : CHAR;
    status : (waiting,indec,inhex1,inhex2);
    number : str16;
    n      : LONGCARD;
    ok     : BOOLEAN;
BEGIN
    len    := Str.Length(S);
    i      := 0;
    p      := 0;
    status := waiting;
    LOOP
        IF i = len THEN EXIT; END;
        ch := S[i];
        CASE status OF
        | waiting :
            CASE ch OF
            | markdec :
                status:=indec;
                number:="";
            | markhex1:
                status:=inhex1;
                number:="";
            ELSE
                new[p]:=ch;
                INC(p);
            END;
            INC(i);
        | indec :
            IF Str.CharPos(decdigits,ch)#MAX(CARDINAL)THEN
                Str.Append(number,ch);
                INC(i);
            ELSE
                IF same(number,"") THEN
                    new[p]:=markdec;
                ELSE
                    n:=Str.StrToCard(number,10,ok);
                    IF ok=FALSE THEN RETURN FALSE; END;
                    n := n MOD 256;
                    new[p]:=CHR( CARDINAL(n));
                END;
                INC(p);
                status:=waiting;
            END;
        | inhex1 :
            IF ch=markhex2 THEN
                status:=inhex2;
                INC(i);
            ELSE
                new[p]:=markhex1;
                INC(p);
                status:=waiting;
            END;
        | inhex2 :
            IF Str.CharPos(hexdigits,ch)#MAX(CARDINAL)THEN
                Str.Append(number,ch);
                INC(i);
            ELSE
                IF same(number,"") THEN
                    new[p]:=markhex1;
                    INC(p);
                    new[p]:=markhex2;
                ELSE
                    n:= Str.StrToCard(number,16,ok);
                    IF ok=FALSE THEN RETURN FALSE; END;
                    n := n MOD 256;
                    new[p]:=CHR( CARDINAL(n));
                END;
                INC(p);
                status:=waiting;
            END;
        END;
    END;
    CASE status OF
    | indec :
        IF same(number,"") THEN
            new[p]:=markdec;
        ELSE
            n:=Str.StrToCard(number,10,ok);
            IF ok=FALSE THEN RETURN FALSE; END;
            n := n MOD 256;
            new[p]:=CHR( CARDINAL(n));
        END;
        INC(p);
    | inhex1 :
        new[p]:=markhex1;
        INC(p);
    | inhex2 :
        IF same(number,"") THEN
            new[p]:=markhex1;
            INC(p);
            new[p]:=markhex2;
        ELSE
            n:=Str.StrToCard(number,16,ok);
            IF ok=FALSE THEN RETURN FALSE; END;
            n := n MOD 256;
            new[p]:=CHR( CARDINAL(n));
        END;
        INC(p);
    END;
    IF p > maxnew THEN RETURN FALSE; END;
    new[p]:=CHR(0);
    Str.Copy(R,new);
    RETURN TRUE;
END gotstr;

PROCEDURE parseAndStoreEntity (S : ARRAY OF CHAR;index:CARDINAL) : BOOLEAN;
CONST
    sep = "_";
VAR
    R : str128;
    i : CARDINAL;
    newDOS : str4;
    newWIN : str4;
    tmp : str128;
BEGIN
    Str.ItemS(R,S,space+tabul,0);
    IF Str.Length(R) > maxstring THEN RETURN FALSE; END;
    entity[index].hash:=Lib.HashString(R,MAXHASH);
    entity[index].string:=str8(R);
    Str.ItemS(R,S,space+tabul,2);     (* skip the = sign ! *)
    i := CharCount(R,sep);
    IF i >= 4 THEN (* _7bit_DOS_WIN_ *)
        Str.ItemS(tmp,R,sep,1);
        IF gotstr(tmp,newDOS)=FALSE THEN RETURN FALSE; END;
        Str.ItemS(tmp,R,sep,2);
        IF gotstr(tmp,newWIN)=FALSE THEN RETURN FALSE; END;
    ELSE (* char or \### *)
        IF gotstr(R,newDOS)=FALSE THEN RETURN FALSE; END;
        Str.Copy(newWIN,newDOS);
    END;
    entity[index].DOSreplacement:=newDOS;
    entity[index].WINreplacement:=newWIN;
    RETURN TRUE;
END parseAndStoreEntity;

(* ------------------------------------------------------------ *)

PROCEDURE parseAndStoreXlat (S : ARRAY OF CHAR;index:CARDINAL) : BOOLEAN;
VAR
    R:str128;
    Z:str8;
    i:CARDINAL;
    ch:CHAR;
BEGIN
    IF argc(S,FALSE) # 2 THEN RETURN FALSE;END;

    argv (R,S,1,FALSE);
    IF metaproc(R)=FALSE THEN RETURN FALSE;END;
    Str.Copy(xlat[index].org,str8(R));
    xlat[index].lenorg:=Str.Length(xlat[index].org);

    argv (R,S,2,FALSE);
    IF metaproc(R)=FALSE THEN RETURN FALSE;END;
    Str.Copy(Z,str8(R));
    Str.Copy(xlat[index].dstDOS,Z);

    FOR i:=1 TO Str.Length(Z) DO
         ch:=Z[i-1];
         Z[i-1]:=remap2oem(ch); (* should do *)
    END;
    Str.Copy(xlat[index].dstWIN,Z);

    RETURN TRUE;
END parseAndStoreXlat;

(* ------------------------------------------------------------ *)

PROCEDURE isLessXlatSeq (i,j:CARDINAL):BOOLEAN;
BEGIN
    IF xlat[i].lenorg > xlat[j].lenorg THEN RETURN TRUE;END;
    IF Str.Compare(xlat[i].org,xlat[j].org) < 0 THEN RETURN TRUE; END;
    RETURN FALSE;
END isLessXlatSeq;

PROCEDURE swapXlatSeq ( i,j:CARDINAL  );
VAR
    tmp:xlattype;
BEGIN
    tmp := xlat[i];
    xlat[i]:=xlat[j];
    xlat[j]:=tmp;
END swapXlatSeq;

PROCEDURE readINI (VAR sErr: ARRAY OF CHAR;
                  useLFN:BOOLEAN;ini : pathtype):CARDINAL;
CONST
    rem1 = "#";
    rem2 = ";";
VAR
    hnd : FIO.File;
    S   : str128;
    i   : CARDINAL;
    rc:CARDINAL;
    state:(inEntities,inXlat,done);
BEGIN
    rc:=errNone;
    Str.Copy(sErr,"");

    lastHtmlEntity := minHtmlEntity-1;
    lastXlatSeq    := minXlatSeq-1;
    state:=inEntities;

    hnd := fileOpenRead(useLFN,ini);
    FIO.AssignBuffer(hnd,bufferIn);
    FIO.EOF:=FALSE;
    LOOP
        IF FIO.EOF=TRUE THEN EXIT; END;
        FIO.RdStr(hnd,S);
        LtrimBlanks(S);
        RtrimBlanks(S);
        IF same(S,"")=FALSE THEN
            CASE S[0] OF
            | rem1, rem2 :
                ;
            | star :
                CASE state OF
                | inEntities: state:=inXlat;  (* //FIXFIX *) state:=done;EXIT;
                | inXlat:     state:=done; EXIT;
                END;
            ELSE
                CASE state OF
                | inEntities :
                    INC(lastHtmlEntity);
                    IF lastHtmlEntity > maxHtmlEntity THEN (* = was enough ! ;-) *)
                        rc:=errTooManyEntities;
                        EXIT;
                    END;
                    IF parseAndStoreEntity(S,lastHtmlEntity)=FALSE THEN
                        Str.Copy(sErr,S);
                        rc:=errEntityParse;
                        EXIT;
                    END;
                | inXlat:
                    INC(lastXlatSeq);
                    IF lastXlatSeq > maxXlatSeq THEN
                        rc:=errTooManyXlats;
                        EXIT;
                    END;
                    IF parseAndStoreXlat(S,lastXlatSeq)=FALSE THEN
                        Str.Copy(sErr,S);
                        rc:=errXlatParse;
                        EXIT;
                    END;
                END;
            END;
        END;
    END;
    fileClose(useLFN,hnd);
    IF rc=errNone THEN
        IF state = done THEN
            Lib.QSort(lastXlatSeq,isLessXlatSeq,swapXlatSeq);
        ELSE
            rc:=errMissingSeparator;
        END;
    END;
    RETURN rc;
END readINI;

(* ------------------------------------------------------------ *)

PROCEDURE dmpstr (showascii:BOOLEAN;wi:CARDINAL;S:ARRAY OF CHAR);
CONST
    gremlin = CHR(168);
VAR
    i,v:CARDINAL;
    ch:CHAR;
BEGIN
    FOR i:=Str.Length(S)+1 TO wi DO
        IF showascii THEN
            WrStr(blank);
        ELSE
            WrStr(blank+blank);
        END;
    END;
    IF showascii THEN
        WrStr(dquote);
    ELSE
        WrStr(dollar);
    END;
    FOR i:=1 TO Str.Length(S) DO
         ch:=S[i-1];
         v:=ORD(ch);
         IF showascii THEN
             IF v < ORD(blank) THEN
                 WrStr(gremlin);
             ELSE
                 WrStr(ch);
             END;
         ELSE
             IF v < 10H THEN WrStr("0");END;
             IO.WrHex(v,1);
         END;
    END;
    IF showascii THEN WrStr(dquote);END;
END dmpstr;

PROCEDURE dmpINI();
VAR
    i:CARDINAL;
BEGIN
    FOR i:=minHtmlEntity TO lastHtmlEntity DO
        WrStr("[");IO.WrCard(i,3);WrStr("]");
        WrStr(tabul);
        dmpstr(TRUE,8,entity[i].string);    WrStr(tabul);
        IO.WrCard(entity[i].hash,6);        WrStr(tabul);
        dmpstr(TRUE,4,entity[i].DOSreplacement);    WrStr(tabul);
        dmpstr(TRUE,4,entity[i].WINreplacement);    WrLn;
    END;
    WrLn;
    FOR i:=minXlatSeq TO lastXlatSeq DO
        WrStr("[");IO.WrCard(i,3);WrStr("]");
        WrStr(tabul);
        dmpstr(FALSE,8,xlat[i].org); WrStr(tabul);
        dmpstr(TRUE ,8,xlat[i].dstDOS); WrStr(tabul);
        dmpstr(TRUE ,8,xlat[i].dstWIN); WrLn;
    END;
END dmpINI;

(* ------------------------------------------------------------ *)

TYPE
    entrycode = RECORD
        org : str16;
        new : str16;
        len : CARDINAL;
    END;
CONST
    firstcode = 1; (* must be 1 because may be decreased *)
    maxcode   = 32;
VAR
    lastcode  : CARDINAL;
    code      : ARRAY [firstcode..maxcode] OF entrycode;

PROCEDURE addit (find,replace:ARRAY OF CHAR; VAR current:CARDINAL):BOOLEAN;
VAR
    S : str16;
BEGIN
    IF current > maxcode THEN RETURN FALSE; END;
    Str.Concat(S,"<",find);
    Str.Append(S,">");
    Str.Copy(code[current].org, S);
    Str.Copy(code[current].new,replace);
    code[current].len := Str.Length(replace);
    INC(current);
    RETURN TRUE;
END addit;

(*
should never return FALSE
caller must check tr and etajvfix are not both TRUE
*)

PROCEDURE initWPlist (hr,wp,tr,etajvfix:BOOLEAN ) : BOOLEAN;
VAR
    pb:CARDINAL;
BEGIN
    pb:=0;
    lastcode := firstcode;
    (* always handle forced line break ! *)
    IF addit( "BR"   , nl     ,lastcode)=FALSE THEN INC(pb); END;

    IF tr THEN
        IF addit( "TR"   , nl     ,lastcode)=FALSE THEN INC(pb); END;
        IF addit("/TR"   , nl     ,lastcode)=FALSE THEN INC(pb); END;
    END;

    IF etajvfix  THEN
        IF addit( "TR"   , nl     ,lastcode)=FALSE THEN INC(pb); END;
        IF addit( "TD"   , vbarsep,lastcode)=FALSE THEN INC(pb); END;
    END;

    IF wp THEN
        IF addit(  "B"     , "$b_"  ,lastcode)=FALSE THEN INC(pb); END;
        IF addit( "/B"     , "_b$"  ,lastcode)=FALSE THEN INC(pb); END;
        IF addit(  "I"     , "$i_"  ,lastcode)=FALSE THEN INC(pb); END;
        IF addit( "/I"     , "_i$"  ,lastcode)=FALSE THEN INC(pb); END;
        IF addit( "EM"     , "$e_"  ,lastcode)=FALSE THEN INC(pb); END;
        IF addit("/EM"     , "_e$"  ,lastcode)=FALSE THEN INC(pb); END;
        IF addit(  "P"     , tabul  ,lastcode)=FALSE THEN INC(pb); END;
        IF addit( "STRONG" , "$s_"  ,lastcode)=FALSE THEN INC(pb); END;
        IF addit("/STRONG" , "_s$"  ,lastcode)=FALSE THEN INC(pb); END;
    END;

    IF hr THEN
        IF addit( "HR"     ,tilde+nl,lastcode)=FALSE THEN INC(pb);END;
    END;

    DEC(lastcode);
    RETURN (pb=0);
END initWPlist;

(* ------------------------------------------------------------ *)

PROCEDURE wrQ (useLFN:BOOLEAN;S:ARRAY OF CHAR   );
BEGIN
    IF useLFN THEN WrStr(dquote);END;
    WrStr(S);
    IF useLFN THEN WrStr(dquote);END;
END wrQ;

CONST
    highest  = 49152-4; (* was 1024 then 4096 //BUG see bugs section *)

VAR (* here for safety *)
    stmp    : ARRAY [0..highest] OF CHAR;
    stmporg : ARRAY [0..highest] OF CHAR;
    scode   : ARRAY [0..highest] OF CHAR;

PROCEDURE doConvert (source,target:pathtype;
                   oem,verbose,wp,para,paratab,keepcodes,keepscript,keepstyle,
                   keepimg,imgabrev,filterCRLF,useLFN,DEBUG:BOOLEAN);
CONST
    steps = 10;
    animcmd=animShow;
CONST
    entityON = "&";
    entityOFF= ";";
    codeON   = "<";
    codeOFF  = ">";
    scriptON = codeON+"SCRIPT*"+codeOFF; (* //V12D fix *)
    scriptOFF= codeON+"/SCRIPT"+codeOFF;
    styleON  = codeON+"STYLE*"+codeOFF;
    styleOFF = codeON+"/STYLE"+codeOFF;
    paracode = codeON+"P"+codeOFF;
    imgcode  = codeON+"IMG"; (* trailing space ? *)
    lenimgcode=4;
VAR
    lastportion,portion,currportion:LONGCARD;
VAR
    hndIn : FIO.File;
    hndOut: FIO.File;
    got   : CARDINAL;
    ch	  : CHAR;
    status: (waiting,inentity,incode);
    i     : CARDINAL;
    hash  : CARDINAL;
    n     : CARDINAL;
    ndx   : CARDINAL;
    ch4   : str4;
    addr  : LONGCARD;
    normal: BOOLEAN;
    dmp   : BOOLEAN; (* <script*>...</script> and <style*>...</style> *)
    S2    : str16;
BEGIN
    dmp   :=TRUE; (* obvious default ! *)
    normal:=NOT(keepcodes);
    IF verbose=FALSE THEN
        (* Work(cmdInit); *)
        (* completed (completedInit, getFileSize(source)); *)
        animInit(steps, "[", "]", CHR(46), "", "\/" );
        portion:=fileGetFileSize(useLFN,source) DIV steps; INC(portion); (* avoid DIV 0 ! *)
        lastportion := steps+1;

        addr := 0;
    END;
    IF verbose THEN
        WrLn;
        WrStr("Source file : "); wrQ(useLFN,source); WrLn;
        WrStr("Target file : "); wrQ(useLFN,target); WrLn;
        WrLn;
    END;
    hndIn :=fileOpenRead(useLFN,source);
    FIO.AssignBuffer(hndIn,bufferIn);
    hndOut:=fileCreate(useLFN,target);
    FIO.AssignBuffer(hndOut,bufferOut);
    FIO.EOF:=FALSE;
    status:=waiting;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        got:=FIO.RdBin(hndIn,ch,1);
        IF got # 1 THEN EXIT;END;
        CASE status OF
        | waiting :
            CASE ch OF
            | entityON :
                stmp[0]:=ch;
                i:=1;
                status:=inentity;
            | codeON :
                stmp[0]:=ch;
                i:=1;
                status:=incode;
            ELSE
                IF (normal AND dmp) THEN
                    (*
                    IF filterCRLF THEN
                        CASE ch OF
                        | cr,lf : ;
                        ELSE
                        FIO.WrBin(hndOut,ch,1);
                        END;
                    ELSE
                        FIO.WrBin(hndOut,ch,1);
                    END;
                    *)
                    FIO.WrBin(hndOut,ch,1);
                END;
            END;
        | inentity :
            IF i < maxstring THEN
                stmp[i]:=ch;
                INC(i);
                IF ch = entityOFF THEN
                    stmp[i]:=CHR(0); (* maxstring < highest, so always mark end of string *)
                    hash:=Lib.HashString(stmp,MAXHASH);
                    n:=minHtmlEntity;
                    LOOP
                        IF n > lastHtmlEntity THEN EXIT; END;
                        IF hash=entity[n].hash THEN
                            IF same(stmp,entity[n].string) THEN EXIT; END;
                        END;
                        INC(n);
                    END;
                    IF n > lastHtmlEntity THEN
                        IF normal THEN FIO.WrBin(hndOut,stmp,i); END;
                        status:=waiting;
                    ELSE
                        CASE oem OF
                        | FALSE :
                            ch4:=entity[n].DOSreplacement;
                        | TRUE :
                            ch4:=entity[n].WINreplacement;
                        END;
                        IF normal THEN FIO.WrStr(hndOut,ch4); END;
                        status:=waiting;
                    END;
                END;
            ELSE
                IF normal THEN
                    FIO.WrBin(hndOut,stmp,maxstring);
                    FIO.WrBin(hndOut,ch,1);
                END;
                status:=waiting;
            END;
        | incode :
            IF i < highest THEN
                stmp[i]:=ch;
                INC(i);
                IF ch=codeOFF THEN
                    IF i < highest THEN stmp[i]:=CHR(0); END;
                    Str.Copy(stmporg,stmp);
                    Str.Caps(stmp);
                    IF filterCRLF THEN
                        WHILE Str.CharPos(stmp,cr) # MAX(CARDINAL) DO
                             Str.Subst(stmp,cr,"");
                        END;
                        WHILE Str.CharPos(stmp,lf) # MAX(CARDINAL) DO
                             Str.Subst(stmp,lf,"");
                        END;

                        WHILE Str.CharPos(stmporg,cr) # MAX(CARDINAL) DO
                             Str.Subst(stmporg,cr,"");
                        END;
                        WHILE Str.CharPos(stmporg,lf) # MAX(CARDINAL) DO
                             Str.Subst(stmporg,lf,"");
                        END;
                    END;

                    (* //FIXME check conditions *)
                    IF DEBUG THEN
                        WrStr("!!! ");WrStr(stmp);WrLn;
                    END;
                    IF keepscript=FALSE THEN
                        IF Str.Match(stmp,scriptON) THEN (* //V12D fix : was same() *)
                            dmp:=FALSE;
                        ELSIF same(stmp,scriptOFF) THEN
                            dmp:=TRUE;
                        END;
                    END;

                    IF keepstyle=FALSE THEN
                        IF Str.Match(stmp,styleON) THEN
                            dmp:=FALSE;
                        ELSIF same(stmp,styleOFF) THEN
                            dmp:=TRUE;
                        END;
                    END;

                    (* <BR> is always handled now *)

                    (* IF wp THEN *)
                        ndx := firstcode;
                        LOOP
                            IF ndx > lastcode THEN EXIT; END;
                            IF same(stmp,code[ndx].org) THEN
                                IF normal THEN
                                    FIO.WrBin(hndOut,code[ndx].new,code[ndx].len);
                                END;
                            END;
                            INC(ndx);
                        END;
                    (* END; *)

                    IF keepimg THEN
                        Str.Slice(S2,stmp,0,lenimgcode);
                        IF same(S2,imgcode) THEN
                            IF normal THEN
                                IF imgabrev THEN
                                    FIO.WrStr(hndOut,imgMarker);
                                ELSE
                                    FIO.WrStr(hndOut,stmp);
                                END;
                                FIO.WrLn(hndOut);
                            END;
                        END;
                    END;

                    IF para THEN
                        IF same(stmp,paracode) THEN
                            IF normal THEN FIO.WrBin(hndOut,nl,lennl); END;
                        END;
                    END;
                    IF paratab THEN
                        IF same(stmp,paracode) THEN
                            IF normal THEN FIO.WrBin(hndOut,nltabul,lennltabul); END;
                        END;
                    END;

                    IF keepcodes THEN
                        FIO.WrStr(hndOut,stmporg);FIO.WrLn(hndOut); (* //V12G was stmp *)
                    END;

                    IF verbose THEN
                        IF normal THEN WrStr(stmporg);WrLn; END; (* //V12G was stmp *)
                    END;
                    status:=waiting;
                END;
            ELSE                          (* too long for an html code ! *)
                IF (normal AND dmp) THEN
                    FIO.WrBin(hndOut,stmp,highest);
                    FIO.WrBin(hndOut,ch,1);
                END;
                status:=waiting;
            END;
        END;
        IF verbose=FALSE THEN
            (* Work(cmdShow); *)
            (* completed(completedSHOW,addr); *)
            anim(animcmd);
            currportion:=addr DIV portion;
            IF currportion # lastportion THEN
                anim(animAdvance);
                lastportion:=currportion;
            END;

            INC(addr);
        END;
    END;

    (* //FIXME we should check status ! *)

    FIO.Flush(hndOut);
    fileClose(useLFN,hndOut);
    fileClose(useLFN,hndIn);
    IF verbose=FALSE THEN
        (* Work(cmdStop); *)
        (* completed(completedEnd,0); *)
        anim(animEnd);anim(animClear);
    END;
END doConvert;

(* ------------------------------------------------------------ *)

(*
"<html*>*<head*>*</head>*<body*>*</body>*</html>" *=any string

yes, we don't handle special chars in a string for now
*)

PROCEDURE chkValidity (DEBUG,useLFN:BOOLEAN;source:pathtype):BOOLEAN;
CONST
    msgWait   = "Working, please wait...";
    codeON    = "<";
    codeOFF   = ">";
    codeCLOSE = "/";
    sHTML     = "html";
    sHEAD     = "head";
    sBODY     = "body";
    ANYTHINGJOKER  = "*";
    highest = 1024-1;
VAR
    hndIn : FIO.File;
    ndx,got   : CARDINAL;
    ch	  : CHAR;
    stmp  : ARRAY [0..highest] OF CHAR;
    pat   : str128; (* oversized *)
    state: (waiting,incode);
    chkstate : (nada,
               htmlopen,
               headopen,headclose,
               bodyopen,bodyclose,
               htmlclose,
               beyond);
BEGIN
    video(msgWait,TRUE);
    hndIn :=fileOpenRead(useLFN,source);
    FIO.AssignBuffer(hndIn,bufferIn);
    FIO.EOF:=FALSE;
    state:=waiting;
    chkstate:=nada;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        got:=FIO.RdBin(hndIn,ch,1);
        IF got # 1 THEN EXIT;END;
        CASE state OF
        | waiting :
            CASE ch OF
            | codeON :
                ndx:=0;
                stmp[ndx]:=ch;
                state:=incode;
            END;
        | incode :
            INC(ndx);
            IF ndx > highest THEN DEC(ndx);END; (* don't advance *)
            stmp[ndx]:=ch;
            CASE ch OF
            | codeOFF:
                IF ndx < highest THEN stmp[ndx+1]:=CHR(0); END;
                (* seems <html> AND the like have extended syntax <html foo> *)
                CASE chkstate OF
                | nada:      pat:=sHTML+ANYTHINGJOKER;
                | htmlopen:  pat:=sHEAD+ANYTHINGJOKER;
                | headopen:  pat:=codeCLOSE+sHEAD;
                | headclose: pat:=sBODY+ANYTHINGJOKER;
                | bodyopen:  pat:=codeCLOSE+sBODY;
                | bodyclose: pat:=codeCLOSE+sHTML;
                | htmlclose: pat:=ANYTHINGJOKER; (* will match html token *)
                | beyond:    EXIT;
                END;
                Str.Prepend(pat,codeON);
                Str.Append(pat,codeOFF);
                IF DEBUG THEN
                    WrStr("// ");WrStr(pat);WrStr(" : ");WrStr(stmp);WrLn;
                END;
                IF Str.Match(stmp,pat) THEN INC(chkstate); END;
                state:=waiting;
            END;
        END;
    END;
    fileClose(useLFN,hndIn);
    video(msgWait,FALSE);
    RETURN (chkstate=htmlclose);
END chkValidity;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    dtoptype = (dtget,dtset);

PROCEDURE doStampOp (VAR stamp:LONGCARD; cmd:dtoptype;useLFN:BOOLEAN;S:pathtype);
VAR
    hnd:FIO.File;
BEGIN
    hnd:=fileOpenRead(useLFN,S);
    CASE cmd OF
    | dtget:
        stamp:=FIO.GetFileDate(hnd);
    | dtset:
        FIO.SetFileDate(hnd,stamp);
    END;
    fileClose(useLFN,hnd);
END doStampOp;

PROCEDURE unscript (DEBUG,useLFN,updatestamp:BOOLEAN;org,bak,path:pathtype  );
CONST
    codeON   = "<";
    codeOFF  = ">";
    scriptON = codeON+"SCRIPT*"+codeOFF; (* //V12D fix *)
    scriptOFF= codeON+"/SCRIPT"+codeOFF;
VAR
    hin,hout:FIO.File;
    dmp   : BOOLEAN;
    i,got   : CARDINAL;
    ch    : CHAR;
    src,dst,tmpfile:pathtype;
    stamp:LONGCARD;
    status:(waiting,grabcode);
BEGIN
    Str.Concat(src,path,org);
    Str.Concat(dst,path,bak);
    Str.Concat(tmpfile,path,sTMPNAME);

    IF fileExists(useLFN,dst) THEN fileErase(useLFN,dst);END;
    IF DEBUG THEN
        WrStr("src : "); WrStr(src);WrLn;
        WrStr("bak : "); WrStr(dst);WrLn;
    END;

    IF NOT(updatestamp) THEN doStampOp(stamp,dtget,useLFN,src);END;

    hin :=fileOpenRead(useLFN,src);
    FIO.AssignBuffer(hin,bufferIn);
    hout:=fileCreate(useLFN,dst);
    FIO.AssignBuffer(hout,bufferOut);
    dmp   :=TRUE; (* obvious default ! *)
    status:=waiting;
    LOOP
        got:=FIO.RdBin(hin,ch,1);
        IF got # 1 THEN EXIT;END;
        CASE status OF
        | waiting :
            CASE ch OF
            | codeON :
                i:=0;
                stmp[i]:=ch;
                INC(i);
                status:=grabcode;
            ELSE
                IF dmp THEN FIO.WrBin(hout,ch,1); END;
            END;
        | grabcode :
            IF i < highest THEN
                stmp[i]:=ch;
                INC(i);
                IF ch=codeOFF THEN
                    IF i < highest THEN stmp[i]:=CHR(0); END;
                    Str.Copy(scode,stmp);
                    Str.Caps(scode);
                    (*
                    ReplaceChar(scode,cr,"");
                    ReplaceChar(scode,lf,"");
                    *)
                    IF Str.Match(scode,scriptON) THEN
                        dmp:=FALSE;
                    ELSIF same(scode,scriptOFF) THEN
                        dmp:=TRUE;
                    ELSE
                        FIO.WrBin(hout,stmp,i);
                    END;
                    status:=waiting;
                END;
            ELSE                          (* too long for an html code ! *)
                IF dmp THEN
                    FIO.WrBin(hout,stmp,highest);
                    FIO.WrBin(hout,ch,1);
                END;
                status:=waiting;
            END;
        END;
    END;
    IF status = grabcode THEN
        IF i > 0 THEN
            IF dmp THEN FIO.WrBin(hout,stmp,i); END;
        END;
    END;

    fileClose(useLFN,hout);
    fileClose(useLFN,hin);

    fileRename(useLFN,dst,sTMPNAME); (* .bk! => .tmp *)
    fileRename(useLFN,src,bak);      (* .htm => .bk! *)
    fileRename(useLFN,tmpfile,org);  (* .tmp => .htm *)

    IF NOT(updatestamp) THEN doStampOp(stamp,dtset,useLFN,src);END;

END unscript;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

VAR
    ignoreESC,verbose,oem,flagOverwrite : BOOLEAN;
    wp,para,paratab,TRpara : BOOLEAN;
    keepcodes,keepscript,keepstyle,keepimg,imgabrev,filterCRLF:BOOLEAN;
    chkvalid,hidevalids,etajvfix,fixhtm:BOOLEAN;
    noscript,HRtilde,dstincurrentdir,forcecurrent,updatestamp : BOOLEAN;
    chkrounds:CARDINAL;
    DEBUG : BOOLEAN;

PROCEDURE InitDefault ();
BEGIN
    verbose       := FALSE;
    oem           := FALSE;
    flagOverwrite := FALSE;
    wp            := FALSE;
    para          := FALSE;
    paratab       := FALSE;
    TRpara        := FALSE;
    keepcodes     := FALSE;
    keepscript    := FALSE;
    keepstyle     := FALSE;
    keepimg       := FALSE;
    imgabrev      := FALSE;
    filterCRLF    := FALSE;
    chkvalid      := FALSE;
    hidevalids    := FALSE;
    etajvfix      := FALSE;
    fixhtm        := FALSE;
    HRtilde       := FALSE;
    dstincurrentdir    := FALSE;
    forcecurrent  := FALSE;
    ignoreESC     := FALSE;
    noscript      := FALSE;
    updatestamp   := FALSE;
    DEBUG         := FALSE;
    chkrounds     := 0;     (* yet another globerk *)
END InitDefault;

PROCEDURE pollEsc (useLFN,ignoreESC:BOOLEAN):BOOLEAN;
CONST
    CHKEVERY9X = 64; (* let's call chkEscape every CHKEVERY LOOP *)
    CHKEVERYDOS= 4;  (* safety *)
VAR
    alcatraz:BOOLEAN;
    every:CARDINAL;
BEGIN
    (*
    9x really does NOT like ChkEscape() and randomely hangs till a keypress
    Flushkey() does NOT help
    *)
    IF ignoreESC THEN RETURN FALSE;END;
    IF useLFN THEN
        every:=CHKEVERY9X;
    ELSE
        every:=CHKEVERYDOS;
    END;
    INC(chkrounds);
    IF (chkrounds MOD every) = 0 THEN
        chkrounds:=0;
        alcatraz:=ChkEscape();
    ELSE
        alcatraz:=FALSE;
    END;
    RETURN alcatraz;
END pollEsc;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    msgProcessing     = "::: Processing     : ";
    msgCreated        = "+++ Created        : ";
    msgPostProcessing = "::: Postprocessing : ";
    msgPostProcessed  = "+++ Postprocessed  : ";
    msgSkipping       = "::: Skipping       : ";
    msgAlready        = "--- (exists !)     : ";
CONST
    msgValid          = "+++ Passed : ";
    msgInvalid        = "--- Failed : ";
CONST
    msgCleaned        = "+++ Cleaned : ";
VAR
    parmcount,i,opt : CARDINAL;
    workdir,S,R,spec,path,inifile,tmpfile : pathtype;
    state     : (waiting,gotspec);
    alcatraz,showme,ok,useLFN    : BOOLEAN;
    invalidhtml,countFile : CARDINAL;
    anchor,ptr:pFname;
BEGIN
    Lib.DisableBreakCheck();
    FIO.IOcheck := FALSE;
    WrLn;

    InitDefault;
    useLFN := TRUE;
    state:=waiting;

    parmcount := Lib.ParamCount();
    IF parmcount=0 THEN abort(errHelp,"");END;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R,"?"+delim+"H"+delim+"HELP"+delim+
                                 "D"+delim+"DUMP"+delim+
                                 "OEM"+delim+"WIN"+delim+
                                 "O"+delim+"OVERWRITE"+delim+
                                 "WP"+delim+"CHARFORMAT"+delim+
                                 "P"+delim+"CRLF"+delim+
                                 "T"+delim+"CRLFTAB"+delim+
                                 "R"+delim+"REVERSE"+delim+
                                 "S"+delim+"SCRIPT"+delim+
                                 "I"+delim+"IMAGE"+delim+"IMG"+delim+
                                 "II"+delim+
                                 "F"+delim+"NOCRLF"+delim+
                                 "TR"+delim+
                                 "X"+delim+"LFN"+delim+
                                 "C"+delim+"CHK"+delim+"CHKHTML"+delim+
                                 "CC"+delim+
                                 "ETAJV"+delim+
                                 "Y"+delim+"STYLE"+delim+
                                 "FIX"+delim+"FIXHTM"+delim+"XLAT"+delim+"POST"+delim+
                                 "HR"+delim+
                                 "K"+delim+"CURRDIR"+delim+
                                 "W"+delim+"ESC"+delim+"WINQUIRK"+delim+
                                 "Z"+delim+"FORCECURRENT"+delim+
                                 "NS"+delim+"NOSCRIPT"+delim+
                                 "U"+delim+"UPDATE"+delim+"STAMP"+delim+
                                 "NSU"+delim+
                                 "DEBUG"
                              );
            CASE opt OF
            | 1,2,3 : abort(errHelp,"");
            | 4,5 :   verbose:=TRUE;
            | 6,7 :   oem:=TRUE;
            | 8,9 :   flagOverwrite := TRUE;
            | 10,11:  wp:=TRUE;
            | 12,13:  para:=TRUE;
            | 14,15:  paratab:=TRUE;
            | 16,17:  keepcodes:=TRUE;
            | 18,19:  keepscript:=TRUE;
            | 20,21,22:keepimg:=TRUE; imgabrev:=FALSE;
            | 23:      keepimg:=TRUE; imgabrev:=TRUE;
            | 24,25:  filterCRLF:=TRUE;
            | 26:     TRpara:=TRUE;
            | 27,28:  useLFN:=FALSE;
            | 29,30,31: chkvalid:=TRUE;
            | 32:     chkvalid:=TRUE; hidevalids:=TRUE;
            | 33:     etajvfix:=TRUE;
            | 34,35:  keepstyle:=TRUE;
            | 36,37,38,39: (* //FIXFIX fixhtm:=TRUE *) ;
            | 40:     HRtilde:=TRUE;
            | 41,42:  dstincurrentdir:=TRUE;
            | 43,44,45:ignoreESC:=TRUE;
            | 46,47:  forcecurrent:=TRUE;
            | 48,49:  noscript := TRUE;
            | 50,51,52:updatestamp:=TRUE;
            | 53:     noscript := TRUE;
                      updatestamp:=TRUE;
            | 54:     DEBUG:=TRUE;
            ELSE
                abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            CASE state OF
            | waiting : Str.Copy(spec,S);
            | gotspec : abort(errTooManyParms,S);
            END;
            INC(state);
        END;
    END;

    useLFN := ( useLFN AND w9XsupportLFN() );

    (* check nonsense *)

    IF state=waiting THEN abort(errMissingName,""); END;

    IF (para AND paratab) THEN abort(errProcessConflict,"");END;

    IF (TRpara AND etajvfix) THEN abort(errETAJVconflict,"");END;

    IF (chkvalid AND noscript) THEN abort(errConflict,"");END;

    Lib.ParamStr(inifile,0);
    i:=Str.RCharPos(inifile,dot);
    IF i # MAX (CARDINAL) THEN inifile[i]:=nullchar;END;
    Str.Append(inifile,extINI);
    IF fileExists(useLFN,inifile)=FALSE THEN abort(errMissingIni,inifile); END;

    IF legalextension (spec,skippedextensions)=FALSE THEN abort(errBadExt,"");END;

    IF same(spec,".") THEN spec:="*"+extHTM; END;
    IF Str.Match(spec,"*\") THEN Str.Append(spec,"*"+extHTM); END;
    IF Str.Match(spec,"*\.") THEN
        i:=Str.Length(spec);
        spec[i-1]:=nullchar;
        Str.Append(spec,"*"+extHTM);
    END;
    IF Str.RCharPos(spec,dot)=MAX(CARDINAL) THEN Str.Append(spec,extHTM);END;

    initList(anchor);
    countFile:=buildFileList(anchor,DEBUG,useLFN,spec,skippedextensions);
    IF countFile=MAX(CARDINAL) THEN abort(errTooManyFiles,spec);END; (* errStorage *)
    IF countFile=0 THEN abort(errNoMatch,spec); END;

    buildPath(path,  spec);

    buildWorkDir(useLFN,forcecurrent,workdir);

    (*
    WrStr(Banner);WrLn;
    WrLn;
    *)

    i:=readINI(S,useLFN,inifile);
    IF i # errNone THEN abort(i,S);END;

    IF DEBUG THEN dmpINI();END;

    IF initWPlist(HRtilde,wp,TRpara,etajvfix)=FALSE THEN abort(errTooManyCodes,""); END;

    IF chkvalid THEN invalidhtml:=0; END;

    ptr:=anchor;
    WHILE ptr # NIL DO
        (* ------------------------------------------------------------ *)
        IF chkvalid THEN (* handle -c[c] *)
        (* ------------------------------------------------------------ *)
            getStr(S,ptr);
            Str.Prepend(S,path);

            ok:=chkValidity(DEBUG,useLFN,S);
            IF ok THEN
                R:=msgValid;
                showme:=NOT(hidevalids);
            ELSE
                R:=msgInvalid;
                INC(invalidhtml);
                showme:=TRUE;
            END;
            IF showme THEN WrStr(R);wrQ(useLFN,S);WrLn; END;
        (* ------------------------------------------------------------ *)
        ELSIF noscript THEN (* handle -ns[u] *)
        (* ------------------------------------------------------------ *)
            getStr(R,ptr);
            i := Str.RCharPos(R,dot);
            IF i # MAX(CARDINAL) THEN
                Str.Slice(S,R,0,i);
                Str.Concat(R,S,extBAK);
            END;
            getStr(S,ptr);
            unscript(DEBUG,useLFN,updatestamp,S,R,path); (* S=org,R=bak *)
            WrStr(msgCleaned);wrQ(useLFN,S);WrLn;
        (* ------------------------------------------------------------ *)
        ELSE (* neither -c[c] nor -ns[u] *)
        (* ------------------------------------------------------------ *)
            getStr(R,ptr);
            i := Str.RCharPos(R,dot);
            IF i # MAX(CARDINAL) THEN
                Str.Slice(S,R,0,i);
                Str.Copy(R,S);
            END;
            getStr(S,ptr);
            Str.Prepend(S,path);

            IF keepcodes THEN
                Str.Append(R,extKOD);
            ELSE
                CASE oem OF
                | FALSE : Str.Append(R,extASC);
                | TRUE :  Str.Append(R,extTXT);
                END;
            END;
            IF NOT(dstincurrentdir) THEN Str.Prepend(R,path); END;

            i := 0;
            IF fileExists(useLFN,R) THEN
                IF fileIsRO(useLFN,R)=FALSE THEN
                    IF flagOverwrite=FALSE THEN
                        INC(i);
                    END;
                ELSE
                    INC(i);
                END;
            END;
            IF same(S,R) THEN INC(i); END;

            IF i=0 THEN

                WrStr(msgProcessing);wrQ(useLFN,S);
                doConvert (S,R,
                           oem,verbose,wp,para,paratab,
                           keepcodes,keepscript,keepstyle,keepimg,
                           imgabrev,filterCRLF,useLFN,DEBUG);
                WrLn;
                WrStr(msgCreated);wrQ(useLFN,R);WrLn;
                (*
                IF fixhtm THEN
                    fileErase(useLFN,tmpfile);
                END;
                *)
            ELSE
                WrStr(msgSkipping);wrQ(useLFN,S);WrLn;
                WrStr(msgAlready);wrQ(useLFN,R);WrLn;
            END;
        (* ------------------------------------------------------------ *)
        END;
        (* ------------------------------------------------------------ *)
        ptr:=ptr^.next;

        alcatraz:=pollEsc(useLFN,ignoreESC);
        IF alcatraz THEN ptr:=NIL;END; (* force exit *)

    END;

    freeList(anchor);

    IF alcatraz THEN abort(errAborted,"");END;

    IF chkvalid THEN
        IF invalidhtml = 0 THEN
            i:=errValidHTML;
            S:="::: Return code is 128 (success).";
        ELSE
            i:=errInvalidHTML;
            S:="::: Return code is 255 (failure).";
        END;
        WrStr(S);WrLn;
    ELSE
        i:=errNone;
    END;

    abort(i,"");
END HTM2ASC.





