(* ---------------------------------------------------------------
Title         see help
Author
Overview      self-explanatory
Usage         see help
Notes         this applies to current French loto
              (provided I've understood its rules, eh eh)
Bugs
Wish List     to WIN !!! ah ah, only serious... :-(
              how could I when I don't even play ? ;-)
              allow more than 28 years for -i[i] ?

              seriously : statistics analysis ?

              as of mars 6th, 2017, there's yet another loto ! how strange...

--------------------------------------------------------------- *)

MODULE Loto;

IMPORT Lib;
IMPORT Str;
IMPORT FIO;
IMPORT Graph;
IMPORT SYSTEM;
IMPORT BiosIO;

FROM IO IMPORT WrStr,WrLn;

FROM Storage IMPORT Available,ALLOCATE,DEALLOCATE;

FROM QD_ASCII IMPORT dash, slash, nullchar, tabchar, cr, lf, nl,
space, dot, deg, doublequote, quote, colon, percent, vbar,
bs, blank, equal, dquote, charnull, singlequote, antislash, dollar,
star, backslash, coma, question, underscore, tabul, hbar,
comma, semicolon, diese, pound, openbracket, closebracket, tilde, exclam,
stardotstar, dotdot, escCh, escSet, letters, digits;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory, qdSplitAllPath,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite, setReadOnly,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs, UpperCaseAlt, LowerCaseAlt,
completedInit, completedShow, completedSHOW, completedEnd, completed,
removeDups, isValidHDunit, removePhantoms, removeFloppies,
getCDROMunits, getCDROMletters, removeCDROMs, getAllHDunits,
getAllLegalUnits, metaproc, getCli, argc, argv;

FROM QD_rand IMPORT InitRnd, GetRnd,
GetRndCardRange, GetRndLngCardRange,
GetRndLngRealRange, GetRndRealRange;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    progEXEname   = "LOTO";
    progTitle     = "Q&D Loto (France)";
    progVersion   = "v2.0e";
    progCopyright = "par PhG";
    progBanner    = progTitle+space+progVersion+space+progCopyright;

    progDatfile   = "LOTO.CSV"; (* to be downloaded *)
    progDatfile76 = "LOTO.76";
    extBIN        = ".BIN";
    extDAT        = ".DAT";
    extINI        = ".INI";
    extTXT        = ".TXT";
    fileBIN       = progEXEname+extBIN;
    fileDAT       = progEXEname+extDAT;
    fileINI       = progEXEname+extINI;
    luckynumchars = "+=*";
CONST
    sLotolife     = "28";   (* see lotolife constant infra *)
    sMaxgrid      = "2800"; (* see maxgrid constant infra *)
CONST
    mintry        = 1;
    maxtry        = 5000;
    sMaxtry       = "5000";
CONST
    errNone           = 0;
    errHelp           = 1;
    errOption         = 2;
    errParameter      = 3;
    errNotFound       = 4;
    errNoTirage       = 5;
    errTooManyTirages = 6;
    errStorage        = 7;
    errRedefined      = 8;
    errBadNum         = 9;
    errRefIDconflict  = 10;
    errBadRefID       = 11;
    errRefIDredefined = 12;
    errSyntax         = 13;
    errBouleUserCount = 14;
    errLuckyUserCount = 15;
    errBouleLuckyUserCount = 16;
    errBadNumero      = 17;
    errBadNumeroChance= 18;
    errNoRefID        = 19;
    errJoker          = 20;
    errNoSuchRefID    = 21;
    errIllegalUserGrid= 22;
    errDupBouleUser   = 23;
    errDupLuckynumUser= 24;
    errBadVal         = 25;
    errOutOfRange     = 26;
    errNoRefIDgengrid = 27;
    errInfiniteLoop   = 28;
    errNoRefIDuniq    = 29;
    errTooManyEntriesToChk=30;
    errVGAneeded      = 31;
    errCannotSet      = 32;

    errHelper         = 128;
    errHelpest        = 129;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
    (*
    MODULE message;
    IMPORT Str;
    EXPORT msg3;

    PROCEDURE msg3 (VAR R:ARRAY OF CHAR;S1,S2,S3:ARRAY OF CHAR);
    BEGIN
        Str.Concat(R,S1,S2);Str.Append(R,S3);
    END msg3;

    END message;
    *)
CONST
    sluck = '"chance"'; (* les guillemets s'imposent ! *)
    sjok  = '"Joker+"';
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    helpmsg=
progBanner+nl+
nl+
"Syntaxe 1 : [-g] [<grilles> [<numros> [<numros_chance>]]] [-tt]|-t:$]"+nl+
"Syntaxe 2 : <-c> <grille> [-t[t]|-t:$] [-p]"+nl+
"Syntaxe 3 : <-v> <fichier["+extTXT+"]> [-t[t]|-t:$] [-p]"+nl+
"Syntaxe 4 : <-f> <fichier["+extTXT+"]> [-p]"+nl+
"Syntaxe 5 : <-l>"+nl+
"Syntaxe 6 : <-s>"+nl+
"Syntaxe 7 : <-d> <fichier["+extTXT+"]>"+nl+
"Syntaxe 8 : <-i[i]>"+nl+
nl+
"  -g     cration de grilles (avec ou sans vrification dans un tirage)"+nl+
'         (par dfaut, une grille de 5 numros avec un numro "chance" :'+nl+
"         grilles [1.."+sMaxgrid+"], numros [5..9], numros_chance [1..10])"+nl+
"  -c     vrification de la <grille> spcifie"+nl+
"  -v     vrification des grilles contenues dans le <fichier>"+nl+
"  -f     vrification des grilles contenues dans le <fichier>"+nl+
"         (la premire ligne du <fichier> tant le tirage de rfrence)"+nl+
"  -l     liste des tirages (rfrences et dates)"+nl+
"  -s     cration de statistiques : "+progEXEname+extBIN+" (analyse de l'entropie),"+nl+
"         "+progEXEname+extDAT+" (rpartition) et "+progEXEname+extINI+" (consultation)."+nl+
"  -d     vrification de l'unicit des grilles contenues dans le <fichier>"+nl+
"  -i[i]  reprsentation graphique de tous les tirages (-ii = numros "+sluck+")"+nl+
nl+
"  -t     vrification avec tous les tirages"+nl+
"  -tt    vrification avec le tirage le plus rcent"+nl+
"  -t:$   vrification avec un tirage de rfrence (-t:"+star+" = -t:"+colon+" = -tt)"+nl+
"  -p     affichage de tous les tirages, qu'ils soient gagnants ou non"+nl+
"  -u     aprs la cration d'une grille, vrification de son unicit (-g)"+nl+
"  -m[m]  affichage (encore plus) sommaire (-g)"+nl+
"  -??[?] remarques puis mises et gains"+nl+
nl+
"***************************************************************"+nl+
"* Le loto est un impt : sur la misre, sur le dsespoir,     *"+nl+
"* sur l'ignorance en mathmatiques, sur la sottise aussi.     *"+nl+
"* Mais c'est quand mme un impt volontaire :                 *"+nl+
"* il est donc moins immoral que tous les impts forcs.       *"+nl+
"* Sur ce sujet, lire les pages dcisives de Lysander Spooner. *"+nl+
"* Sur les statistiques, lire les excellentes pages            *"+nl+
'* du site "fourmilab.ch" de John Walker                       *'+nl+
"* (dont le programme ENT est fort instructif).                *"+nl+
"***************************************************************"+nl;

    morehelpmsg = nl+
"a) Le fichier "+progDatfile+" de la Franaise des Jeux est indispensable,"+nl+
"   qui sera cherch dans le rpertoire en cours puis dans celui du programme."+nl+
"   Si l'option -i[i]76 traite les donnes de l'ancienne formule du loto,"+nl+
"   aucune option n'existe pour traiter celles de la nouvelle formule 2017."+nl+
"b) Une <grille> simple comporte 5 numros appartenant  l'intervalle [1..49],"+nl+
"   ainsi qu'entre 1 et 10 numros "+sluck+" appartenant  lintervalle [1..10]"+nl+
"   (un numro "+sluck+" est signal par l'un des caractres "+doublequote+luckynumchars+doublequote+","+nl+
"   mis en prfixe ou en suffixe)."+nl+
"   Une <grille> multiple comporte entre 6 et 9 numros,"+nl+
"   ainsi qu'entre 1 et 10 numros "+sluck+nl+
"   (toutes les combinaisons possibles ne sont pas autorises)."+nl+
"c) La simulation (option -g) ne pourra attribuer un gain imaginaire"+nl+
"    une combinaison gagnante qui n'avait pas t remporte."+nl+
"d) Par dfaut, le tirage de rfrence est le tirage le plus rcent"+nl+
"   (sauf avec l'option -g)."+nl+
"e) Le "+sjok+" n'est pas pris en compte."+nl+
"f) Ce programme traitera au plus "+sLotolife+" annes de tirages et "+sMaxgrid+" grilles."+nl+
"g) Les options dnues de sens pour une commande donne sont ignores."+nl+
"h) Avec -i[i], la touche TAB bascule l'affichage (rel ou proportionnel),"+nl+
'   et la touche "*" change le type de tri.'+nl+
"i) En manire de clin d'oeil, l'option -i[i] accepte le suffixe "+'"76"'+nl+
"   pour traiter le fichier "+progDatfile76+" (6 numros avec un numro complmentaire)."+nl+
nl+
"Exemples : "+progEXEname+" -c 1 2 3 4 5 +6 7*"+nl+
"           "+progEXEname+" -c 11 4 8 35 12 +3 -t:2008109"+nl+
"           "+progEXEname+" -v 2BCHKED -t"+nl+
"           "+progEXEname+" -g -u -mm "+sMaxgrid+" /t:2008081"+nl;

(* let's hope I've understood the rules... ;-) *)

    evenmorehelpmsg=nl+
'(* Mises : N = nombre de numros par grille, C = nombre de numros "chance" *)'+nl+
nl+
" N    5    6    7    8    9"+nl+
"C"+nl+
"1     2   12   42  112  252"+nl+
"2     4   24   84  224"+nl+
"3     6   36  126  336"+nl+
"4     8   48  168"+nl+
"5    10   60  210"+nl+
"6    12   72  252"+nl+
"7    14   84  294"+nl+
"8    16   96  336"+nl+
"9    18  108"+nl+
"10   20  120"+nl+
nl+
'(* Gains : N = nombre de numros gagnants, C = numro "chance" gagnant *)'+nl+
nl+
" C   oui          non"+nl+
"N"+nl+
"0    mise         rien"+nl+
"1    mise         rien"+nl+
"2    rang5+mise   rang5"+nl+
"3    rang4+mise   rang4"+nl+
"4    rang3+mise   rang3"+nl+
"5    rang1        rang2"+nl;

VAR
    S : str128;
BEGIN
    CASE e OF
    | errNone:           S:="1963"; (* well, this WAS an error in fact *)
    | errHelp,errHelper,errHelpest :
         WrStr(helpmsg);
         IF e # errHelp THEN WrStr(morehelpmsg); END;
         IF e = errHelpest THEN WrStr(evenmorehelpmsg);END;
         e := errHelp;
    | errOption:          S:="L'option ~ est inconnue !";
    | errParameter:       S:="Le paramtre ~ est de trop !";
    | errNotFound:        S:="Le fichier ~ n'existe pas !";
    | errNoTirage:        S:="Le fichier ~ ne contient aucun tirage !";
    | errTooManyTirages:  S:="Le fichier ~ contient plus de "+sLotolife+" ans de tirages !";
    | errStorage:         S:="La mmoire est insuffisante pour stocker le fichier ~ !";
    | errRedefined:       S:="Les options -g, -c, -v, -f, -l, -s, -d et -i[i] sont incompatibles !";
    | errBadNum:          S:="L'option ~ comporte une valeur illgale !";
    | errRefIDconflict:   S:="Une seule des options -t, -tt ou -t:$ peut tre spcifie !";
    | errBadRefID:        S:="L'option ~ comporte une valeur impossible !";
    | errRefIDredefined:  S:="L'option -t:$ ne peut tre spcifie qu'une seule fois !";
    | errSyntax:          S:="La syntaxe attendue par l'option ~ n'est pas respecte !";
    | errBouleUserCount:  S:="Le nombre de numros est hors de l'intervalle [5..9] !";
    | errLuckyUserCount:  S:="Le nombre de numros "+sluck+" est hors de l'intervalle [1..10] !";
    | errBouleLuckyUserCount:S:="La grille est incorrecte ([5..9] et [1..10]) !";
    | errBadNumero:       S:="Le numro ~ est incorrect ou hors de l'intervalle [1..49] !";
    | errBadNumeroChance: S:="Le numro "+sluck+" ~ est incorrect ou hors de l'intervalle [1..10] !";
    | errNoRefID:         S:="L'option -f ne tolre pas les options -t, -tt ou -t:$ !";
    | errJoker:           S:="Le fichier ~ ne doit comporter aucun caractre gnrique !";
    | errNoSuchRefID:     S:="Le tirage de rfrence [~] est introuvable !";
    | errIllegalUserGrid: S:="La grille ainsi dfinie ne serait pas accepte !";
    | errDupBouleUser   : S:="Le numro ~ apparat plusieurs fois !";
    | errDupLuckynumUser: S:="Le numro "+sluck+" ~ apparat plusieurs fois !";
    | errBadVal:          S:="La valeur ~ ne semble pas un nombre !";
    | errOutOfRange:      S:="La valeur ~ n'est pas dans l'intervalle attendu !";
    | errNoRefIDgengrid:  S:="L'option -g ne tolre pas l'option -t !";
    | errInfiniteLoop:    S:="Impossible de crer une grille unique malgr "+sMaxtry+" tentatives !";
    | errNoRefIDuniq:     S:="L'option -d ne tolre aucune des options -t, -tt ou -t:$ !";
    | errTooManyEntriesToChk: S:="Le fichier ~ contient plus de "+sMaxgrid+" grilles !";
    | errVGAneeded :      S := "VGA adapter needed !";
    | errCannotSet :      S:="Cannot set ~ video mode !";
    ELSE
                          S:="Cette erreur ne saurait survenir ! ;-)";
    END;
    CASE e OF
    | errNone, errHelp :
        ;
    ELSE
        Str.Subst(S,"~",einfo);
        WrStr(progEXEname+" : "); WrStr(S); WrLn;
    END;
    Lib.SetReturnCode(SHORTCARD(e));
    HALT;
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBufferType = ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
VAR
    ioBufferIn,ioBufferOut : ioBufferType;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    tiragesperweek   = 3; (* lun mer sam *)
    weeksperyear     = 52;
    lotolife         = 28; (* we'll hopefully be dead before *)
    firsttirage      = 1;
    maxtirage        = tiragesperweek * weeksperyear * lotolife;
CONST
    PBALLOC          = MAX(CARDINAL); (* always bigger than maxtirage *)
CONST
    firstlotoval     = 1;
    lastlotoval      = 49;
    firstluckynumval = 1;
    lastluckynumval  = 10;
    firstboule       = 1;
    lastboule        = 5;
CONST
    firstrapport     = 1;
    lastrapport      = 6;
TYPE
    rapporttype = ARRAY[firstrapport..lastrapport] OF LONGCARD;
    pRapport    = POINTER TO rapporttype;
CONST
    rapportsize = SIZE(rapporttype);
TYPE
    lotoentrytype = RECORD
        ymd      : LONGCARD;
        yearid   : SHORTCARD; (* 3*52 max *)
        boule    : ARRAY[firstboule..lastboule] OF SHORTCARD;
        luckynum : SHORTCARD;
        pR       : pRapport;
    END;
VAR
    lototally     : ARRAY [firstlotoval..lastlotoval] OF LONGCARD;
    lucktally     : ARRAY [firstluckynumval..lastluckynumval] OF LONGCARD;
    lotoentry     : ARRAY [firsttirage..maxtirage] OF lotoentrytype;

(* ------------------------------------------------------------ *)

CONST
    refiddefault   = MAX(LONGCARD);
    refidall       = refiddefault-1;
    refidgen       = refiddefault-2;
    refidlatest    = 0;
CONST
    NOSUCHREFID    = MAX(CARDINAL);
    IGNOREREFID    = NOSUCHREFID-1;
    ALLREFIDS      = firsttirage-1; (* 0 *)
CONST
    firstbouleUser    = firstboule;
    minibouleUser     = lastboule;
    maxbouleUser      = 9;
    firstluckynumUser = 1;
    maxluckynumUser   = 10;
CONST
    maxcountnums     = maxbouleUser+maxluckynumUser;

TYPE
    mpn       = ARRAY [minibouleUser..maxbouleUser] OF INTEGER;
    misesType = ARRAY [firstluckynumUser..maxluckynumUser] OF mpn;
CONST
                          (* 5     6     7     8     9 *)
    mises = misesType (
                      mpn(   2 ,  12 ,  42 , 112 , 252 ),  (* 1 numro "chance" *)
                      mpn(   4 ,  24 ,  84 , 224 ,  -1 ),
                      mpn(   6 ,  36 , 126 , 336 ,  -1 ),
                      mpn(   8 ,  48 , 168 ,  -1 ,  -1 ),
                      mpn(  10 ,  60 , 210 ,  -1 ,  -1 ),
                      mpn(  12 ,  72 , 252 ,  -1 ,  -1 ),
                      mpn(  14 ,  84 , 294 ,  -1 ,  -1 ),
                      mpn(  16 ,  96 , 336 ,  -1 ,  -1 ),
                      mpn(  18 , 108 ,  -1 ,  -1 ,  -1 ),
                      mpn(  20 , 120 ,  -1 ,  -1 ,  -1 )   (* 10 numros "chance" *)
                      );
TYPE
    gridtype  = RECORD
        lastbouleUser    : CARDINAL;
        lastluckynumUser : CARDINAL;
        bouleUser        : ARRAY[firstbouleUser..maxbouleUser] OF SHORTCARD;
        luckynumUser     : ARRAY[firstluckynumUser..maxluckynumUser] OF SHORTCARD;
    END;

(* ------------------------------------------------------------ *)

PROCEDURE isLess (i,j:CARDINAL):BOOLEAN;
BEGIN
    RETURN ( lotoentry[i].ymd < lotoentry[j].ymd );
END isLess;

PROCEDURE doSwap (i,j:CARDINAL);
VAR
    tmp:lotoentrytype;
BEGIN
    tmp:=lotoentry[i];
    lotoentry[i]:=lotoentry[j];
    lotoentry[j]:=tmp;
END doSwap;

PROCEDURE sortswapc (VAR i,j:CARDINAL);
VAR
    tmp:CARDINAL;
BEGIN
    IF i > j THEN
        tmp:=i;
        i:=j;
        j:=tmp;
    END;
END sortswapc;

PROCEDURE sortswapb (VAR i,j:SHORTCARD);
VAR
    tmp:SHORTCARD;
BEGIN
    IF i > j THEN
        tmp:=i;
        i:=j;
        j:=tmp;
    END;
END sortswapb;

PROCEDURE sortswapl (VAR i,j:LONGCARD);
VAR
    tmp:LONGCARD;
BEGIN
    IF i > j THEN
        tmp:=i;
        i:=j;
        j:=tmp;
    END;
END sortswapl;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE calcmise (ndxluck,ndxboule:CARDINAL  ):CARDINAL;
VAR
    mise:INTEGER;
    v:CARDINAL;
BEGIN
    mise:=mises[ndxluck][ndxboule];
    IF mise < 0 THEN
        v:=0;
    ELSE
        v:=CARDINAL(mise);
    END;
    RETURN v;
END calcmise;

PROCEDURE inrange (VAR v:SHORTCARD;mini,maxi:LONGCARD;S:str16):BOOLEAN;
VAR
    ok:BOOLEAN;
    lc:LONGCARD;
BEGIN
    lc:=Str.StrToCard(S,10,ok);
    IF ok THEN
        IF (lc < mini) OR (lc > maxi) THEN
            ok:=FALSE;
        ELSE
            v:=SHORTCARD(lc);
        END;
    END;
    RETURN ok;
END inrange;

PROCEDURE initusergrid ( VAR g: gridtype );
VAR
    i:CARDINAL;
BEGIN
    g.lastbouleUser    := firstbouleUser-1;
    g.lastluckynumUser := firstluckynumUser-1;
    FOR i:= firstboule TO maxbouleUser DO
        g.bouleUser[i]:=0;
    END;
    FOR i:=firstluckynumUser TO maxluckynumUser DO
        g.luckynumUser[i]:=0;
    END;
END initusergrid;

(* luckynumchars [?]# or #[?] *)

PROCEDURE addusergrid (VAR g:gridtype; S:str16):CARDINAL;
VAR
    i,n,total,p : CARDINAL;
    ch : CHAR;
    v  : SHORTCARD;
BEGIN

    total := 0;
    FOR i:= 0 TO Str.Length(luckynumchars)-1 DO
        ch := luckynumchars[i];
        n  := CharCount(S,ch);
        INC(total,n);
        IF n = 1 THEN p:=Str.CharPos(S,ch); END;
    END;

    CASE total OF
    | 0:
            IF inrange(v, firstlotoval,lastlotoval,S) THEN
                FOR n:=firstbouleUser TO g.lastbouleUser DO
                    IF g.bouleUser[n] = v THEN RETURN errDupBouleUser;END;
                END;
                INC(g.lastbouleUser);
                IF g.lastbouleUser > maxbouleUser THEN
                    i:=errBouleUserCount;
                ELSE
                    g.bouleUser[g.lastbouleUser]:=v;
                    i:=errNone;
                END;
            ELSE
                i:=errBadNumero;
            END;
    | 1:
        IF (p = 0) OR (p = Str.Length(S)-1) THEN
            Str.Delete(S,p,1);
            IF inrange(v,firstluckynumval,lastluckynumval,S) THEN
                FOR n:=firstluckynumUser TO g.lastluckynumUser DO
                    IF g.luckynumUser[n] = v THEN RETURN errDupLuckynumUser;END;
                END;

                INC(g.lastluckynumUser);
                IF g.lastluckynumUser > maxluckynumUser THEN
                    i:=errLuckyUserCount;
                ELSE
                    g.luckynumUser[g.lastluckynumUser]:=v;
                    i:=errNone;
                END;
            ELSE
                i:=errBadNumeroChance;
            END;
        ELSE
            i:=errBadNumeroChance;
        END;
    ELSE
        i:=errBadNumeroChance;
    END;
    RETURN i;
END addusergrid;

PROCEDURE chksortusergrid (VAR g:gridtype ):CARDINAL;
VAR
    ok,okboule,oklucky:BOOLEAN;
    mise,rc,ndx,i,j:CARDINAL;
BEGIN
    CASE g.lastbouleUser OF
    | minibouleUser..maxbouleUser: ok:=TRUE;
    ELSE ok:=FALSE;
    END;
    okboule:=ok;

    CASE g.lastluckynumUser OF
    | firstluckynumUser..maxluckynumUser : ok:=TRUE;
    ELSE ok:=FALSE;
    END;
    oklucky:=ok;

    IF okboule THEN
        IF oklucky THEN
            mise:=calcmise(g.lastluckynumUser,g.lastbouleUser);
            IF mise = 0 THEN
                rc:=errIllegalUserGrid;
            ELSE

                ndx:=g.lastbouleUser;
                (* BFIQD bubble sort *)
                FOR i:=firstbouleUser TO ndx-1 DO
                    FOR j:=i+1 TO ndx DO
                        sortswapb( g.bouleUser[i] , g.bouleUser[j] );
                    END;
                END;

                ndx:=g.lastluckynumUser;
                (* BFIQD bubble sort *)
                FOR i:=firstluckynumUser TO ndx-1 DO
                    FOR j:=i+1 TO ndx DO
                        sortswapb( g.luckynumUser[i] , g.luckynumUser[j] );
                    END;
                END;

                rc:=errNone;
            END;
        ELSE
            rc:=errLuckyUserCount;
        END;
    ELSE
        IF oklucky THEN
            rc:=errBouleUserCount;
        ELSE
            rc:=errBouleLuckyUserCount;
        END;
    END;
    RETURN rc;
END chksortusergrid;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE num2str (n:LONGCARD; base:CARDINAL; wi:INTEGER; pad:CHAR):str16;
VAR
    R:str16;
    ok:BOOLEAN;
    i:CARDINAL;
BEGIN
    Str.CardToStr(n, R,base,ok);
    FOR i:=Str.Length(R)+1 TO ABS(wi) DO
        IF wi < 0 THEN
            Str.Append(R,pad);
        ELSE
            Str.Prepend(R,pad);
        END;
    END;
    RETURN R;
END num2str;

(* ymd = yyyymmdd *)

PROCEDURE parseymd (VAR y,m,d:LONGCARD;ymd:LONGCARD  );
BEGIN
    y := ymd DIV 10000;
    d := ymd MOD 100;
    m := (ymd - y * 10000) DIV 100;
END parseymd;

(* id = yyyy### where ### is 3*52 max *)

PROCEDURE parseyearid (id:LONGCARD):SHORTCARD;
BEGIN
    RETURN SHORTCARD (id MOD 1000);
END parseyearid;

PROCEDURE remakeid (ymd:LONGCARD;yearid:SHORTCARD  ):LONGCARD;
VAR
    y,m,d:LONGCARD;
BEGIN
    parseymd(y,m,d,ymd);
    RETURN ( (y * 1000) + LONGCARD(yearid) );
END remakeid;

PROCEDURE plainymd (ymd:LONGCARD):str80; (* "## septembre ####" *)
CONST
    mois = "janvier,fvrier,mars,avril,mai,juin,"+
           "juillet,aot,septembre,octobre,novembre,dcembre,???";
VAR
    R:str80;
    y,m,d:LONGCARD;
    MM:str16;
BEGIN
    parseymd(y,m,d, ymd);

    isoleItemS ( MM, mois, comma, CARDINAL(m-1) );
    R:="~ ~ ~";
    Str.Subst(R, tilde,num2str(d,10,1,"") );
    Str.Subst(R, tilde,MM );
    Str.Subst(R, tilde,num2str(y,10,1,"") );
    RETURN R;
END plainymd;

PROCEDURE itemstr (VAR R:ARRAY OF CHAR; n:CARDINAL; S:ARRAY OF CHAR);
BEGIN
    isoleItemS( R,  S,semicolon,n-1);
    LtrimBlanks(R);
    RtrimBlanks(R);
END itemstr;

PROCEDURE itemnum (VAR v:SHORTCARD; n:CARDINAL; S:ARRAY OF CHAR);
VAR
    lc:LONGCARD;
    ok:BOOLEAN;
    R:str16;
BEGIN
    isoleItemS( R,  S,semicolon,n-1);
    LtrimBlanks(R);
    RtrimBlanks(R);
    lc := Str.StrToCard(R,10,ok); (* assume FdJ is always right ! *)
    v:=SHORTCARD(lc);
END itemnum;

PROCEDURE itembignum (VAR lc:LONGCARD; n:CARDINAL; S:ARRAY OF CHAR);
VAR
    ok:BOOLEAN;
    R:str16;
BEGIN
    isoleItemS( R,  S,semicolon,n-1);
    LtrimBlanks(R);
    RtrimBlanks(R);
    lc := Str.StrToCard(R,10,ok);
END itembignum;

(* handle jj/mm/aaaa and jjmmaaaa forms *)

PROCEDURE itemdate2bignum (VAR lc:LONGCARD; n:CARDINAL; S:ARRAY OF CHAR) ;
VAR
    ok:BOOLEAN;
    R,Z:str16;
    i,p:CARDINAL;
    j,m,a:LONGCARD;
BEGIN
    isoleItemS( R,  S,semicolon,n-1);
    LtrimBlanks(R);
    RtrimBlanks(R);
    IF Str.CharPos(R,slash) = MAX(CARDINAL) THEN
        lc := Str.StrToCard(R,10,ok);
    ELSE
        (* jj/mm/aaaa *)
        FOR i := 1 TO 3 DO
            CASE i OF
            | 1: p:=3;
            | 2: p:=2;
            | 3: p:=1;
            END;
            isoleItemS(Z, R,slash,p-1);
            LtrimBlanks(Z);
            RtrimBlanks(Z);
            lc:=Str.StrToCard(Z,10,ok);
            CASE i OF
            | 1: a:=lc;
            | 2: m:=lc;
            | 3: j:=lc;
            END;
        END;
        lc:= (10000 * a) + (100 * m) + j;
    END;
END itemdate2bignum;

PROCEDURE itemfloatfix1 (VAR lc:LONGCARD;n:CARDINAL;S:ARRAY OF CHAR);
CONST
    fix1 = LONGREAL(10.0);
    kround=LONGREAL(0.5);
VAR
    ok:BOOLEAN;
    R:str16; (* should be enough *)
    p:CARDINAL;
    fl:LONGREAL;
BEGIN
    itemstr(R, n, S);
    Str.Subst(R, comma, dot);
    fl:=Str.StrToReal(R,ok);
    lc:=VAL (LONGCARD , ( fl * fix1 + kround) );
END itemfloatfix1;

PROCEDURE dmpval (S:ARRAY OF CHAR;v:LONGCARD);
CONST
    wipad=20;
VAR
    i:CARDINAL;
BEGIN
    WrStr(S);
    FOR i:=Str.Length(S)+1 TO wipad DO WrStr(space);END;
    WrStr( num2str(v,10,1,""));WrLn;
END dmpval;

PROCEDURE fmtamount(vby10:LONGCARD):str80;
VAR
    Z:str80;
BEGIN
    Str.Copy(Z,num2str(vby10,10,1,"") );
    Str.Insert(Z,comma,Str.Length(Z)-1);
    Str.Subst(Z,comma+"0","");
    IF same(Z,"") THEN Z:="0";END;
    Str.Append(Z," dollaro");
    IF vby10 > 10 THEN Str.Append(Z,"s");END; (* plural *)
    RETURN Z;
END fmtamount;

PROCEDURE doRelease (lasttirage:CARDINAL );
VAR
    i,wanted:CARDINAL;
BEGIN
    wanted:=rapportsize;
    FOR i:=firsttirage TO lasttirage DO
        DEALLOCATE (lotoentry[i].pR,wanted);
    END;
END doRelease;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE filecreated (F:ARRAY OF CHAR);
CONST
    srpt = "Le fichier ~ a t cr."+nl;
VAR
    R:str128;
BEGIN
    R:=srpt;
    Str.Subst(R,tilde,F);
    WrStr(R);
END filecreated;

PROCEDURE genBin (lasttirage:CARDINAL);
VAR
    hout:FIO.File;
    i,j:CARDINAL;
BEGIN
    hout:=FIO.Create(fileBIN);
    FIO.AssignBuffer(hout,ioBufferOut);
    FOR i:=firsttirage TO lasttirage DO
        FOR j:=firstboule TO lastboule DO (* original output order *)
            FIO.WrBin(hout, lotoentry[i].boule[j], SIZE(SHORTCARD));
        END;
    END;
    FIO.Close(hout);
    filecreated(fileBIN)
END genBin;

TYPE
    stattype = RECORD
        value : CARDINAL; (* wasteful *)
        count : LONGCARD;
    END;
VAR
    freq : ARRAY [firstlotoval..lastlotoval] OF stattype; (* will contain luckynum *)

PROCEDURE genFreq (counttirages:CARDINAL; minymd,maxymd:LONGCARD);
CONST
    padch = space;
VAR
    hout:FIO.File;
    i,j,k,method,mini,maxi:CARDINAL;
    R,RR:str128;
    countboules:LONGCARD;
    swap:BOOLEAN;
    tmp:stattype;
BEGIN
    hout:=FIO.Create(fileDAT);
    FIO.AssignBuffer(hout,ioBufferOut);

    R:=nl+"; ~ tirages entre le ~ et le ~"+nl;
    Str.Subst(R,tilde, num2str( LONGCARD(counttirages),10,1,"") );
    Str.Subst(R,tilde, plainymd(minymd) );
    Str.Subst(R,tilde, plainymd(maxymd) );
    FIO.WrStr(hout,R);

    FOR method := 1 TO 3 DO
        CASE method OF
        | 1 : RR:="numro";
        | 2 : RR:="frquence croissante";
        | 3 : RR:="frquence dcroissante";
        END;
        FOR k:=1 TO 2 DO
            CASE k OF
            | 1 :
                 R:= "boules";
                 countboules := lastboule-firstboule+1;
                 mini:=firstlotoval;
                 maxi:=lastlotoval;
            | 2 :
                 R:= 'boules "chance"';
                 countboules := 1;
                 mini:=firstluckynumval;
                 maxi:=lastluckynumval;
            END;
            Str.Prepend(R,nl+"; ~ ");
            Str.Append(R," tries par ~"+nl+nl);

            countboules := LONGCARD(counttirages) * countboules;

            Str.Subst(R,tilde, num2str( countboules,10,1,"") );
            Str.Subst(R,tilde, RR);
            FIO.WrStr(hout,R);

            FOR i:=mini TO maxi DO
                freq[i].value:=i;
                CASE k OF
                | 1 : freq[i].count:=lototally[i];
                | 2 : freq[i].count:=lucktally[i];
                END;
            END;

            (* BFIQD bubble sort *)
            FOR i:=mini TO maxi-1 DO
                FOR j:=i+1 TO maxi DO
                    CASE method OF
                    | 1 : swap:=FALSE;
                    | 2 : swap:= ( freq[i].count > freq[j].count );
                    | 3 : swap:= ( freq[j].count > freq[i].count );
                    END;
                    IF swap THEN
                        tmp:=freq[i];
                        freq[i]:=freq[j];
                        freq[j]:=tmp;
                    END;
                END;
            END;

            FOR i:= mini TO maxi DO
                R:="~ = ~"+nl; (* ## = ###### *)
                Str.Subst(R,tilde, num2str( LONGCARD(freq[i].value),10,2,padch) );
                Str.Subst(R,tilde, num2str( freq[i].count,10,6,padch) );
                FIO.WrStr(hout,R);
            END;
        END;
    END;
    FIO.WrLn(hout);
    FIO.Close(hout);
    filecreated(fileDAT);
END genFreq;

PROCEDURE dumpdata (h:FIO.File;S:ARRAY OF CHAR );
CONST
    ssection  = nl+openbracket+"~"+closebracket+nl+nl;
    sdate     = "date     = ~ ~"+nl;
    stirage   = "tirage   = ~ ~ ~ ~ ~ (~)"+nl;
    stri      = "tri      = ~ ~ ~ ~ ~ (~)"+nl;
    srapport  = "rapport~ = ~"+nl;
    sjoker    = "joker    = ~"+nl;
    sgagnants = "gagnants = ~ ~ ~ ~ ~ ~"+nl;
    padch     = space;
VAR
    Z:str128;
    R:str16;
    i,j:CARDINAL;
    v:LONGCARD;
    numero : ARRAY[firstboule..lastboule] OF LONGCARD;
BEGIN
    Z:=ssection;
    itemstr(R,  1,S);
    Str.Subst(Z,tilde,R);
    FIO.WrStr(h,Z);


    Z:=sdate;
    itemstr    ( R, 2,S);
    LowerCase(R);           (* assume day is french and not abbreviated *)
    Str.Subst(Z,tilde, R);

    itemdate2bignum(v,3,S);
    Str.Subst(Z,tilde, plainymd(v) );
    FIO.WrStr(h,Z);


    Z:=stirage;
    j:=5;
    FOR i:= firstboule TO lastboule DO
        itembignum ( v, j,S);
        numero[i]:=v;
        Str.Subst(Z,tilde,num2str(v,10,2,padch ));
        INC(j);
    END;
    itembignum (v,10,S);
    Str.Subst(Z,tilde,num2str(v,10,2,padch ));
    FIO.WrStr(h,Z);


    (* BFIQD bubble sort *)
    FOR i:=firstboule TO lastboule-1 DO
        FOR j:=i+1 TO lastboule DO
            sortswapl(numero[i], numero[j] );
        END;
    END;

    Z:=stri;
    FOR i:= firstboule TO lastboule DO
        Str.Subst(Z,tilde,num2str( numero[i],10,2,padch));
    END;
    itembignum (v,10,S);
    Str.Subst(Z,tilde,num2str(v,10,2,padch ));
    FIO.WrStr(h,Z);


    j:=13;
    FOR i:=firstrapport TO lastrapport DO
        itemstr(R,j,S);
        INC(j,2);
        Z:=srapport;
        Str.Subst(Z,tilde,num2str( LONGCARD(i),10,1,""));
        Str.Subst(Z,tilde,R);
        FIO.WrStr(h,Z);
    END;


    Z:=sgagnants;
    j:=12;
    FOR i:=firstrapport TO lastrapport DO
        itembignum (v, j,S);
        INC(j,2);
        Str.Subst(Z,tilde,num2str(v,10,1,""));
    END;
    FIO.WrStr(h,Z);


    Z:=sjoker;
    itemstr(R,24,S);
    ReplaceChar(R,space,""); (* debeautify *)
    IF same(R,"") THEN R:="???";END;
    Str.Subst(Z,tilde,R);
    FIO.WrStr(h,Z);

END dumpdata;



(*
// older format (partial)
1  annee_numero_de_tirage
2  1er_ou_2eme_tirage
3  jour_de_tirage
4  date_de_tirage
5  date_de_forclusion

6  boule_1
7  boule_2
8  boule_3
9  boule_4
10 boule_5
11 boule_6
12 boule_complementaire

// newer format (full)

1   annee_numero_de_tirage;                     2008109;
2   jour_de_tirage;                             MERCREDI; LUNDI SAMEDI // remove blanks
3   date_de_tirage;                             20081210; // 10/12/2008 too !
4   date_de_forclusion;                         20090209; // 09/02/2009 too !

5   boule_1;                                    41;
6   boule_2;                                    38;
7   boule_3;                                    10;
8   boule_4;                                    35;
9   boule_5;                                    11;
10  numero_chance;                              3;
11  combinaison_gagnante_en_ordre_croissant;    10-11-35-38-41+3;

12  nombre_de_gagnant_au_rang1;                 1;
13  rapport_du_rang1;                           3000000;
14  nombre_de_gagnant_au_rang2;                 0;
15  rapport_du_rang2;                           0;
16  nombre_de_gagnant_au_rang3;                 373;
17  rapport_du_rang3;                           2454;
18  nombre_de_gagnant_au_rang4;                 19291;
19  rapport_du_rang4;                           13,1;
20  nombre_de_gagnant_au_rang5;                 320851;
21  rapport_du_rang5;                           5,6;       // handle . or ,
22  nombre_de_gagnant_au_rang6;                 560891;
23  rapport_du_rang6;                           2;         // mise in fact

24  numero_jokerplus;                           9 195 734;
25  devise;                                     eur;       // frf anyone ? ;-)
*)

PROCEDURE getData (doBin,doStats,doIni,cmdView,format76,DEBUG:BOOLEAN;F:ARRAY OF CHAR):CARDINAL;
CONST
    countOfItems = 25-1; (* 25 should do but play it safe *)
    minymdval=0;
    maxymdval=99999999;
    padch=space;
    srpt = "Le fichier ~ a t cr."+nl;
VAR
    hin,hout:FIO.File;
    S:str1024; (* required for first long line, else garbage would be grabbed after *)
    R:str128;
    i,j,n,lasttirage,counttirages,wanted:CARDINAL;
    id,ymd,minymd,maxymd:LONGCARD;
    rapport : rapporttype;
    pb:BOOLEAN;
    lotobj:lotoentrytype;
BEGIN
    IF cmdView THEN
        doBin   := FALSE;
        doStats := FALSE;
        doIni   := FALSE;
    END;

    wanted:=rapportsize;

    minymd:=maxymdval;
    maxymd:=minymdval;
    lasttirage:=firsttirage-1;
    FOR i:= firstlotoval TO lastlotoval DO lototally[i]:=0;END;
    FOR i:= firstluckynumval TO lastluckynumval DO lucktally[i]:=0;END;

    IF doIni THEN
        hout:=FIO.Create(fileINI);
        FIO.AssignBuffer(hout,ioBufferOut);
    END;

    hin:=FIO.OpenRead(F);
    FIO.AssignBuffer(hin,ioBufferIn);

    FIO.RdStr(hin,S); (* ignore first line assuming FdJ export format is ok *)

    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hin,S); (* TS library handles unix lf *)
        IF CharCount(S,semicolon) >= countOfItems THEN

            INC(lasttirage); (* global for all cmds *)

            IF cmdView THEN

                IF format76 THEN (* hard coded *)
                    j:=6;
                    FOR i:= 1 TO 6 DO
                        itemnum ( lotobj.boule[i], j,S);
                        IF DEBUG THEN dmpval("boule",LONGCARD(lotobj.boule[i]));END;
                        INC ( lototally[ CARDINAL(lotobj.boule[i]) ] );
                        INC(j);
                    END;

                    itemnum ( lotobj.luckynum, 10,S);
                    INC ( lucktally[ CARDINAL(lotobj.luckynum) ] );
                    IF DEBUG THEN dmpval("complementarynum",LONGCARD(lotobj.luckynum));END;

                ELSE
                    j:=5;
                    FOR i:= firstboule TO lastboule DO
                        itemnum ( lotobj.boule[i], j,S);
                        IF DEBUG THEN dmpval("boule",LONGCARD(lotobj.boule[i]));END;
                        INC ( lototally[ CARDINAL(lotobj.boule[i]) ] );
                        INC(j);
                    END;

                    itemnum ( lotobj.luckynum, 10,S);
                    INC ( lucktally[ CARDINAL(lotobj.luckynum) ] );
                    IF DEBUG THEN dmpval("luckynum",LONGCARD(lotobj.luckynum));END;
                END;
            ELSE
                IF lasttirage > maxtirage THEN EXIT; END;
                IF DEBUG THEN dmpval("lasttirage",LONGCARD(lasttirage));END;

                itemdate2bignum ( ymd, 3,S);
                lotoentry[lasttirage].ymd:=ymd;
                IF DEBUG THEN dmpval("ymd",ymd);END;
                IF ymd < minymd THEN minymd:=ymd;END;
                IF ymd > maxymd THEN maxymd:=ymd;END;

                (* id = yyyy### *)
                itembignum ( id,  1,S);
                IF DEBUG THEN dmpval("id",id);END;
                lotoentry[lasttirage].yearid := parseyearid(id);
                IF DEBUG THEN dmpval("yearid",LONGCARD(lotoentry[lasttirage].yearid));END;

                j:=5;
                FOR i:= firstboule TO lastboule DO
                    itemnum ( lotoentry[lasttirage].boule[i], j,S);
                    IF DEBUG THEN dmpval("boule",LONGCARD(lotoentry[lasttirage].boule[i]));END;
                    INC ( lototally[ CARDINAL(lotoentry[lasttirage].boule[i]) ] );
                    INC(j);
                END;

                itemnum ( lotoentry[lasttirage].luckynum, 10,S);
                INC ( lucktally[ CARDINAL(lotoentry[lasttirage].luckynum) ] );
                IF DEBUG THEN dmpval("luckynum",LONGCARD(lotoentry[lasttirage].luckynum));END;

                j:=13;
                FOR i:= firstrapport TO lastrapport DO
                    itemfloatfix1( rapport[i],j,S); (* "#[,#]" *)
                    IF DEBUG THEN dmpval("rapport*10",rapport[i]);END;
                    INC(j,2);
                END;
                IF Available( wanted ) THEN
                    ALLOCATE (lotoentry[lasttirage].pR,wanted);
                    lotoentry[lasttirage].pR^:=rapport;
                ELSE
                    lasttirage:=PBALLOC; (* Storage.ALLOCATE() failure *)
                    EXIT;
                END;

                IF doIni THEN dumpdata(hout,S);END;
            END;
        END;
    END;
    FIO.Close(hin);

    IF cmdView THEN (* handle this cmd now ! *)
        R:="+++ OK";
        pb:=FALSE;
        RETURN lasttirage ; (* handled at exit *)
    END;

    IF doIni THEN
        FIO.WrLn(hout);
        FIO.Close(hout);
        IF lasttirage < firsttirage THEN
            FIO.Erase(fileINI); (* clean useless empty file *)
        ELSE
            filecreated(fileINI);
        END;
    END;

    pb:=TRUE;
    IF lasttirage = PBALLOC THEN
        R:="--- Storage";
    ELSIF lasttirage < firsttirage THEN
        R:="--- Empty";
    ELSIF lasttirage > maxtirage THEN
        R:="--- Overflow";
    ELSE
        R:="+++ OK";
        pb:=FALSE;
    END;
    (* WrStr(R);WrLn; *)
    IF pb THEN RETURN lasttirage;END;

    counttirages := lasttirage-firsttirage+1;
    Lib.QSort(counttirages,isLess,doSwap);

    IF doBin THEN genBin(lasttirage);END; (* original order required of course *)

    IF doStats THEN genFreq(counttirages,minymd,maxymd);END;

    (* we can sort tirages now raw data was dumped in original order if required *)

    FOR n:=firsttirage TO lasttirage DO
        (* BFIQD bubble sort *)
        FOR i:=firstboule TO lastboule-1 DO
            FOR j:=i+1 TO lastboule DO
                sortswapb( lotoentry[n].boule[i] , lotoentry[n].boule[j] );
            END;
        END;
    END;

    RETURN lasttirage;
END getData;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE showList (lasttirage:CARDINAL);
VAR
    i:CARDINAL;
    R:str128;
    Z:str16;
    ymd,y,m,d:LONGCARD;
BEGIN

    FOR i:=firsttirage TO lasttirage DO
        R:="Tirage [~] du ~"+nl;
        ymd:=lotoentry[i].ymd;
        parseymd(y,m,d, ymd);

        Str.Concat(Z,num2str(y,10,4,"0"),num2str( LONGCARD(lotoentry[i].yearid),10,3,"0") );
        Str.Subst(R,tilde,Z);

        Str.Subst(R,tilde, plainymd(ymd));
        WrStr(R);
    END;
END showList;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkRefID (lasttirage:CARDINAL;refid:LONGCARD;VAR R:ARRAY OF CHAR):CARDINAL;
VAR
    rc,i:CARDINAL;
    yearid:SHORTCARD;
    ymd,id:LONGCARD;
BEGIN
    IF  refid = refidall THEN
        rc:=ALLREFIDS; (* 0 *)
    ELSIF refid=refidlatest THEN
        rc:=lasttirage; (* latest *)
    ELSIF refid=refiddefault THEN
        rc:=lasttirage;
    ELSIF refid=refidgen THEN
        rc:=IGNOREREFID;
    ELSE
        FOR i:=firsttirage TO lasttirage DO
             yearid:=lotoentry[i].yearid;
             ymd:=lotoentry[i].ymd;
             id:=remakeid(ymd,yearid);
             IF id=refid THEN RETURN i; END;
        END;
        Str.Copy(R,num2str(refid,10,1,""));
        rc:=NOSUCHREFID;
    END;
    RETURN rc;
END chkRefID;

(*
         numro "chance" gagnant
           oui          non
numros
0                mise   rien
1                mise   rien
2          rang5+mise   rang5
3          rang4+mise   rang4
4          rang3+mise   rang3
5          rang1        rang2

*)

PROCEDURE calcgain (VAR won:BOOLEAN;VAR gainsby10:LONGCARD; VAR R:ARRAY OF CHAR;
                   matches,chance,mise:CARDINAL;p:pRapport );
CONST
     splain = "rien,rien,rang5,rang4,rang3,rang2,"+
              "mise,mise,rang5+mise,rang4+mise,rang3+mise,rang1,"+
              "???";
VAR
     n,newmise:LONGCARD; (* both * 10 *)
     i:CARDINAL;
BEGIN
     won:=TRUE;
     newmise:=LONGCARD(mise * 10);
     IF chance = 0 THEN
         CASE matches OF
         | 0 :  n:=0;                           i:=1; won:=FALSE;
         | 1 :  n:=0;                           i:=2; won:=FALSE;
         | 2 :  n:=p^[firstrapport+4];          i:=3;
         | 3 :  n:=p^[firstrapport+3];          i:=4;
         | 4 :  n:=p^[firstrapport+2];          i:=5;
         | 5 :  n:=p^[firstrapport+1];          i:=6;
         ELSE
                n:=0;                                 won:=FALSE;
         END;
     ELSE
         CASE matches OF
         | 0 :  n:=newmise;                     i:=7;
         | 1 :  n:=newmise;                     i:=8;
         | 2 :  n:=p^[firstrapport+4]+newmise;  i:=9;
         | 3 :  n:=p^[firstrapport+3]+newmise;  i:=10;
         | 4 :  n:=p^[firstrapport+2]+newmise;  i:=11;
         | 5 :  n:=p^[firstrapport];            i:=12;
         ELSE
                n:=0;                                 won:=FALSE;
         END;
     END;
     gainsby10:=n;
     isoleItemS(R, splain, comma,i-1);
END calcgain;

PROCEDURE showusergrid (rawdataonly:BOOLEAN;  g:gridtype):str128;
CONST
    sSimple   = "simple";
    sMultiple = "multiple";
    sRpt      = "Grille ~ :";
VAR
    R:str128;
    i,mise:CARDINAL;
BEGIN
    IF rawdataonly THEN
        R:="";
    ELSE
        R:=sRpt;
        IF g.lastbouleUser > minibouleUser THEN
            Str.Subst(R,tilde,sMultiple);
        ELSE
            Str.Subst(R,tilde,sSimple);
        END;
        Str.Subst(R,tilde,num2str( LONGCARD(mise),10,1,"") );
    END;

    FOR i:=firstbouleUser TO g.lastbouleUser DO
        Str.Append(R," ");
        Str.Append(R, num2str( LONGCARD(g.bouleUser[i]),10,2,space));
    END;

    FOR i:=firstluckynumUser TO g.lastluckynumUser DO
        Str.Append(R," (");
        Str.Append(R, num2str( LONGCARD(g.luckynumUser[i]),10,2,space));
        Str.Append(R,")");
    END;

    IF NOT(rawdataonly) THEN
        mise:=calcmise(g.lastluckynumUser,g.lastbouleUser);
        Str.Append(R," = ");
        Str.Append(R,num2str( LONGCARD(mise),10,1,"") );
        Str.Append(R," dollaros"); (* akways plural *)
    END;

    RETURN R;
END showusergrid;

PROCEDURE showtirage (VAR gainsby10:LONGCARD;
                     matches,chance,mise:CARDINAL;
                     onlywin,anonymous,dontshowgrid:BOOLEAN;e:lotoentrytype);
CONST
    padch = space;
VAR
    INFO:str16;
    S:str128;
    Z:str80;
    i:CARDINAL;
    yearid:SHORTCARD;
    ymd,id:LONGCARD;
    won:BOOLEAN;
BEGIN
    calcgain(won,gainsby10,INFO,  matches,chance,mise,e.pR);
    IF won=FALSE THEN
        IF onlywin THEN RETURN;END;
    END;
    (*
    IF gainsby10 = 0 THEN (* warning ! gain can be 0 if there was no winner for grid found ! *)
        IF onlywin THEN RETURN;END;
    END;
    *)

    S:="[~] : ~ ~ ~ ~ ~ (~) = ~+~ = ~ = ~";

    IF anonymous THEN
        Str.Subst(S,tilde,"?");
    ELSE
        yearid:=e.yearid;
        ymd:=e.ymd;
        id:=remakeid(ymd,yearid);
        Str.Subst(S,tilde,num2str(id,10,1,"") );
    END;

    FOR i:=firstboule TO lastboule DO
        Str.Subst(S,tilde, num2str ( LONGCARD(e.boule[i]) ,10,2,padch) );
    END;
    Str.Subst(S,tilde,num2str( LONGCARD(e.luckynum),10,2,padch ));

    Str.Subst(S,tilde,num2str(LONGCARD(matches),10,1,""));
    Str.Subst(S,tilde,num2str(LONGCARD(chance),10,1,""));

    Str.Subst(S,tilde,INFO);

    IF anonymous THEN
        Z:="?";
    ELSE
        IF gainsby10 = 0 THEN
            Z:="rien";
        ELSE
            Z:=fmtamount(gainsby10);
         END;
    END;
    Str.Subst(S,tilde,Z);

    IF NOT (dontshowgrid) THEN WrStr(S);WrLn; END;

    (*
    CASE matches OF
    | 0 :
        S := "aucun numro";
    | 1 :
        S := "1 numro";
    ELSE
        S := "~ numros";
        Str.Subst(S,tilde,num2str(LONGCARD(matches),10,1,""));
    END;
    Str.Prepend(S, "; ");
    Str.Append(S,' ~ le numro "chance" = ~');
    IF chance = 0 THEN
        Str.Subst(S,tilde,"sans");
    ELSE
        Str.Subst(S,tilde,"avec");
    END;
    Str.Subst(S,tilde,INFO);

    WrStr(S);WrLn;
    *)
END showtirage;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* look if e appears in g *)

PROCEDURE scangrid (VAR matches,chance:CARDINAL; g:gridtype;e:lotoentrytype );
VAR
    i,j:CARDINAL;
    v:SHORTCARD;
BEGIN
    matches:=0;
    FOR i:=firstboule TO lastboule DO
        v:=e.boule[i];
        FOR j:=firstbouleUser TO g.lastbouleUser DO
            IF v = g.bouleUser[j] THEN INC(matches);END;
        END;
    END;

    chance:=0;
    v:=e.luckynum;
    FOR i:=firstluckynumUser TO g.lastluckynumUser DO
        IF v = g.luckynumUser[i] THEN INC(chance);END;
    END;
END scangrid;

PROCEDURE doScanCli (DEBUG,onlywin,anonymous:BOOLEAN;ndxtirage,lasttirage:CARDINAL;g:gridtype);
CONST
    DONTSHOWGRID = FALSE;
VAR
    i,first,last,matches,chance,mise:CARDINAL;
    S:str128;
    gainsby10:LONGCARD;
BEGIN
    S:=showusergrid(FALSE,g);
    WrStr(S);WrLn;
    WrLn;

    CASE ndxtirage OF
    | ALLREFIDS :   first:=firsttirage; last:=lasttirage;
    ELSE
                    first:=ndxtirage;   last:=ndxtirage;
    END;
    mise:=calcmise(g.lastluckynumUser,g.lastbouleUser);
    FOR i:=first TO last DO
        scangrid(matches,chance, g,lotoentry[i]);
        showtirage (gainsby10,
                   matches,chance,mise,onlywin,anonymous,DONTSHOWGRID,lotoentry[i]);
    END;
END doScanCli;

PROCEDURE doScanFile (DEBUG,onlywin,anonymous:BOOLEAN;
                     ndxtirage,lasttirage:CARDINAL;F:ARRAY OF CHAR);
CONST
    sChk = '--- Grille  vrifier : "';
    sCast= '--- Tirage  vrifier : "';
VAR
    hin:FIO.File;
    S:str128;
    R:str16;
    pb,rc,count,i:CARDINAL;
    g:gridtype;
    state:(waiting,grabbing);
    ok:BOOLEAN;
BEGIN
    IF anonymous THEN
        state:=waiting;   (* first line is a reference tirage *)
    ELSE
        state:=grabbing;  (* we're checking grids *)
    END;
    FIO.EOF:=FALSE; (* safety ! *)
    hin:=FIO.OpenRead(F);
    FIO.AssignBuffer(hin,ioBufferIn);
    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hin,S);
        LtrimBlanks(S);
        RtrimBlanks(S);
        CASE S[0] OF
        | semicolon,pound,nullchar: ;
        ELSE
            pb:=0;
            count:=argc(S,TRUE);
            IF count >  maxcountnums THEN
                INC(pb);
            ELSE
                initusergrid(g);
                FOR i:=1 TO count DO
                    argv (R,  S,i,TRUE);
                    rc:=addusergrid(g,R);
                    IF rc # errNone THEN INC(pb);END;
                END;
                rc:=chksortusergrid(g);
                IF rc # errNone THEN INC(pb);END;

                CASE state OF
                | waiting:
                    ok:= (g.lastbouleUser=minibouleUser) ;
                    ok:= ( ok AND (g.lastluckynumUser=firstluckynumUser) );
                    IF ok THEN
                        ndxtirage:=firsttirage;
                        FOR i:=firstbouleUser TO g.lastbouleUser DO
                            lotoentry[ndxtirage].boule[i]:=g.bouleUser[i];
                        END;
                        lotoentry[ndxtirage].luckynum:=g.luckynumUser[firstluckynumUser];
                        state:=grabbing;
                    ELSE
                        WrStr(sCast);WrStr(S);WrStr('"');WrLn;
                        EXIT; (* abort here *)
                    END;
                | grabbing:
                    IF pb = 0 THEN
                        doScanCli(DEBUG,onlywin,anonymous,ndxtirage,lasttirage,g);
                        WrLn;
                    ELSE
                        WrStr(sChk);WrStr(S);WrStr('"');WrLn;
                    END;
                END;
            END;
        END;
    END;
    FIO.Close(hin);

END doScanFile;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    sDefaultGridCount    = "1";
    sDefaultNumsPerGrid  = "5";
    sDefaultLucksPerGrid = "1";
CONST
    firstgrid = 1;
    maxgrid   = 2800;
VAR
    grid        : ARRAY[firstgrid..maxgrid] OF gridtype; (* sorted *)

PROCEDURE createGrid (tirage,nboule,nchance:CARDINAL) ;
VAR
    g:gridtype;
    S:str80;
    ndx,i,j,p,lastpos,hashN,hashC:CARDINAL;
BEGIN
    g.lastbouleUser    := nboule;
    g.lastluckynumUser := nchance;

    S:="";
    FOR i:=firstlotoval TO lastlotoval DO Str.Append(S,CHR(i));END;

    lastpos:= Str.Length(S)-1;
    FOR i:= firstbouleUser TO nboule DO
        p :=GetRndCardRange(0,lastpos);
        g.bouleUser[i]:=SHORTCARD( ORD(S[p]) );
        Str.Delete(S,p,1);
        DEC(lastpos);
    END;

    S:="";
    FOR i:=firstluckynumval TO lastluckynumval DO Str.Append(S,CHR(i));END;

    lastpos:= Str.Length(S)-1;
    FOR i:= firstluckynumUser TO nchance DO
        p :=GetRndCardRange(0,lastpos);
        g.luckynumUser[i]:=SHORTCARD( ORD(S[p]) );
        Str.Delete(S,p,1);
        DEC(lastpos);
    END;

                ndx:=g.lastbouleUser;
                (* BFIQD bubble sort *)
                FOR i:=firstbouleUser TO ndx-1 DO
                    FOR j:=i+1 TO ndx DO
                        sortswapb( g.bouleUser[i] , g.bouleUser[j] );
                    END;
                END;
                (* zero unused for later comparison *)
                FOR i:=ndx+1 TO maxbouleUser DO g.bouleUser[i]:=0;END;

                ndx:=g.lastluckynumUser;
                (* BFIQD bubble sort *)
                FOR i:=firstluckynumUser TO ndx-1 DO
                    FOR j:=i+1 TO ndx DO
                        sortswapb( g.luckynumUser[i] , g.luckynumUser[j] );
                    END;
                END;
                FOR i:=ndx+1 TO maxluckynumUser DO g.luckynumUser[i]:=0;END;

    grid[tirage]:=g;
END createGrid;

PROCEDURE isUniqueGrid (ndx:CARDINAL):BOOLEAN ;
VAR
    i:CARDINAL;
    ok:BOOLEAN;
    g:gridtype;
    hash:LONGCARD;
BEGIN
    g:=grid[ndx];

    FOR i:=firstgrid TO ndx-1 DO
        IF g = grid[i] THEN RETURN FALSE; END;
    END;
    RETURN TRUE;
END isUniqueGrid;

PROCEDURE doBuild (ndxtirage,gridCount,numsPerGrid,lucksPerGrid:CARDINAL;
                  flagUniques,flagVerbose,flagEvenTerser: BOOLEAN  ) : BOOLEAN;
CONST
    sG = "Nombre de grilles           : ~"+nl;
    sN = "Numros par grille          : ~"+nl;
    sC = 'Numros "chance" par grille : ~'+nl;
    sR = "Tirage de rfrence         : [~]"+nl;
    sU = "Cration de grilles uniques : ~"+nl;
    padch = space;
    msgWorking = "...";
VAR
    onlywin,anonymous,justgen,ok:BOOLEAN;
    S:str128;
    Z:str80;
    ymd,id:LONGCARD;
    yearid:SHORTCARD;
    i,retry,mise,matches,chance : CARDINAL;
    totalmises,totalgainsby10,gainsby10,totalmisesby10,sumby10:LONGCARD;
BEGIN
    justgen:=(ndxtirage = IGNOREREFID); (* was ALLREFIDS before v2.0a *)

    S:=sG; Str.Subst(S,tilde,num2str(LONGCARD(gridCount),10,1,"")); WrStr(S);
    S:=sN; Str.Subst(S,tilde,num2str(LONGCARD(numsPerGrid),10,1,"")); WrStr(S);
    S:=sC; Str.Subst(S,tilde,num2str(LONGCARD(gridCount),10,1,"")); WrStr(S);
    S:=sR;
    IF justgen THEN
        Str.Subst(S,"[~]","non");
    ELSE
        yearid:=lotoentry[ndxtirage].yearid;
        ymd:=lotoentry[ndxtirage].ymd;
        id:=remakeid(ymd,yearid);
        Str.Subst(S,tilde,num2str(id,10,1,""));

        totalmises:=0;
        totalgainsby10:=0;
        anonymous:=FALSE;
        onlywin:=TRUE;
    END;
    WrStr(S);
    S:=sU;
    IF flagUniques THEN
        Str.Subst(S,tilde,"oui");
    ELSE
        Str.Subst(S,tilde,"non");
    END;
    WrStr(S);

    WrLn;

    FOR i:=firstgrid TO gridCount DO

        video(msgWorking,TRUE);
        retry:=mintry;
        LOOP
            createGrid(i,numsPerGrid,lucksPerGrid);
            IF flagUniques=FALSE THEN EXIT; END;
            IF isUniqueGrid(i) THEN EXIT;END;
            INC(retry);
            IF retry > maxtry THEN video(msgWorking,FALSE);RETURN FALSE; END;
        END;
        video(msgWorking,FALSE);

        IF flagVerbose THEN
            S:="# ~ :";
            Str.Subst(S,tilde, num2str( LONGCARD(i),10,4,padch) );
            WrStr(S);
            S:=showusergrid(TRUE,grid[i]);
            WrStr(S);WrLn;
        END;
        IF NOT (justgen) THEN
            mise:=calcmise(grid[i].lastluckynumUser,grid[i].lastbouleUser);
            INC(totalmises, LONGCARD(mise));

            scangrid(matches,chance, grid[i],lotoentry[ndxtirage]);
            showtirage (gainsby10,
                       matches,chance,mise,onlywin,anonymous,flagEvenTerser,lotoentry[ndxtirage]);
            INC(totalgainsby10,gainsby10);
        END;
    END;

    IF NOT (justgen) THEN
        S:= nl+"::: Total des mises : ~ dollaros"+nl+
               "::: Total des gains : ~"+nl;

        Str.Subst( S, tilde, num2str(totalmises,10,1,""));

        Z:=fmtamount(totalgainsby10);
        Str.Subst(S,tilde,Z);

        WrStr(S);

        totalmisesby10:=totalmises * 10;

        (* show percentage ? *)

        IF    totalgainsby10 = totalmisesby10 THEN
            S:="=== Vous n'avez rien gagn... mais rien perdu non plus.~"+nl;
            Z:=" C'est la chance !";
        ELSIF totalgainsby10 > totalmisesby10 THEN
            S:="+++ Vous avez gagn ~. C'est trs anormal !"+nl;
            sumby10:=totalgainsby10-totalmisesby10;
            Z:=fmtamount(sumby10);
        ELSE
            S:="--- Vous avez perdu ~. C'est normal !"+nl;
            sumby10:=totalmisesby10-totalgainsby10;
            Z:=fmtamount(sumby10);
        END;
        Str.Subst(S,tilde,Z);
        WrLn;
        WrStr(S);
    END;

    RETURN TRUE;
END doBuild;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE doUnicity (DEBUG:BOOLEAN;F:ARRAY OF CHAR ):BOOLEAN;
CONST
    sChk = "--- Grille  vrifier : ";
VAR
    hin:FIO.File;
    S:str128;
    R:str16;
    g:gridtype;
    i,rc,pb,count,lastgrid:CARDINAL;
BEGIN

    lastgrid:=firstgrid-1;

    FIO.EOF:=FALSE; (* safety ! *)
    hin:=FIO.OpenRead(F);
    FIO.AssignBuffer(hin,ioBufferIn);
    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hin,S);
        LtrimBlanks(S);
        RtrimBlanks(S);
        CASE S[0] OF
        | semicolon,pound,nullchar: ;
        ELSE
            pb:=0;
            count:=argc(S,TRUE);
            IF count >  maxcountnums THEN
                INC(pb);
            ELSE
                initusergrid(g);
                FOR i:=1 TO count DO
                    argv (R,  S,i,TRUE);
                    rc:=addusergrid(g,R);
                    IF rc # errNone THEN INC(pb);END;
                END;
                rc:=chksortusergrid(g);
                IF rc # errNone THEN INC(pb);END;

                IF pb = 0 THEN
                    INC(lastgrid);
                    IF lastgrid > maxgrid THEN pb:=MAX(CARDINAL); EXIT;END;
                    grid[lastgrid]:=g;
                ELSE
                    WrStr(sChk);WrStr(S);WrStr('"');WrLn;
                END;
            END;
        END;
    END;
    FIO.Close(hin);
    IF pb = MAX(CARDINAL) THEN RETURN FALSE;END;
    S:=nl+"::: Nombre de grilles  examiner : ~"+nl+nl;
    Str.Subst(S,tilde, num2str(LONGCARD(lastgrid),10,1,""));
    WrStr(S);

    rc:=0;
    FOR i:=firstgrid TO lastgrid DO
        IF isUniqueGrid(i)=FALSE THEN
            INC(rc);
            S:="La grille # ~ est en double : ";
            Str.Subst(S,tilde,num2str(LONGCARD(i),10,4,""));
            WrStr(S);
            S:=showusergrid(TRUE,grid[i]);
            WrStr(S);WrLn;
        END;
    END;
    IF rc=0 THEN
        S:="+++ Toutes les grilles sont uniques."+nl;
    ELSE
        S:="--- Nombre de grilles en double : ~"+nl;
        Str.Subst(S,tilde,num2str(LONGCARD(rc),10,1,""));
    END;
    WrLn;
    WrStr(S);
    RETURN TRUE;
END doUnicity;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE sound (freq,duration,pause:CARDINAL);
BEGIN
    Lib.Sound(freq);
    Lib.Delay(duration);
    Lib.NoSound();
    Lib.Delay(pause);
END sound;

PROCEDURE errbip (okbeep:BOOLEAN);
CONST
    freq     = 55;
    duration = 55; (* was 300 *)
    tempo    = 100;
BEGIN
    IF okbeep THEN sound (freq,duration,tempo); END;
END errbip;

CONST
    wilc = 11+3;

(* sep ok if pad is space *)

PROCEDURE fmtlc (v : LONGCARD; pad:CHAR; sep:CHAR; field:INTEGER) : str80;
VAR
    S,R   : str80;
    len,i : CARDINAL;
    ok  : BOOLEAN;
    ch  : CHAR;
BEGIN
    Str.CardToStr(v,S,10,ok);
    len:=Str.Length(S);
    R := "";
    FOR i := 1 TO len DO
        Str.Prepend(R,S[len-i]);
        IF i < len THEN
            IF (i MOD 3) = 0 THEN
                Str.Prepend(R,sep);
            END;
        END;
    END;
    LOOP
        IF INTEGER(Str.Length(R)) >= ABS(field) THEN EXIT; END;
        IF field < 0 THEN
            Str.Append(R,pad);  (* right alignment *)
        ELSE
            Str.Prepend(R,pad);
        END;
    END;
    RETURN R;
END fmtlc;

PROCEDURE fmtstring (S:ARRAY OF CHAR; pad:CHAR; n:INTEGER ) : str80;
VAR
    R : str80;
BEGIN
    Str.Copy(R,S);
    LOOP
        IF INTEGER(Str.Length(R)) >= ABS(n) THEN EXIT; END;
        IF n < 0 THEN
            Str.Append(R,pad); (* right alignment *)
        ELSE
            Str.Prepend(R,pad);
        END;
    END;
    RETURN R;
END fmtstring;

PROCEDURE fmtpercent (v:LONGREAL;pad:CHAR;sep:CHAR;prec:CARDINAL;field:INTEGER):str80;
VAR
    R : str80;
    ok: BOOLEAN;
BEGIN
    Str.FixRealToStr(v,prec,R,ok);
    Str.Subst(R,dot,sep);
    RETURN fmtstring(R,pad,field);
END fmtpercent;

(* ------------------------------------------------------------ *)

CONST
    minicode = firstlotoval;
    maxiCode = lastlotoval;  (* 49 beats 10, of course *)

VAR (* in fact, code is ball *)
    firstcode   : CARDINAL;
    maxcode     : CARDINAL;
    countcode   : CARDINAL;
    widata      : CARDINAL; (* countcode *)
VAR
    gcode     ,orggcode  : ARRAY [minicode..maxiCode] OF CARDINAL;
    gcount    ,orggcount : ARRAY [minicode..maxiCode] OF LONGCARD;
    gtotal               : LONGCARD;
CONST
    SORTnone      = 0;
    SORTnormal    = 1;
    SORTreverse   = 2;

PROCEDURE realToCard (v:LONGREAL ):CARDINAL ;
CONST
    k = LONGREAL(0.5); (* was 0.5 *)
BEGIN
    RETURN VAL(CARDINAL, v + k);
END realToCard;

PROCEDURE plot (x,ybase,color:CARDINAL; v:LONGREAL );
VAR
    p,y:CARDINAL;
BEGIN
    p:=realToCard(v);
    y:=ybase-p+1;
    CASE p OF
    | 0 : ;
    (* | 1 : Graph.Plot(x,y,color); *)
    ELSE
          Graph.Line(x,ybase,x,y,color);
    END;
END plot;

CONST
    cBLACK	       =0;
    cBLUE 	       =1;
    cGREEN         =2;
    cCYAN          =3;
    cRED           =4;
    cMAGENTA       =5;
    cBROWN         =6;
    cWHITE         =7;
    cGRAY          =8;
    cLIGHTBLUE     =9;
    cLIGHTGREEN    =10;
    cLIGHTCYAN     =11;
    cLIGHTRED      =12;
    cLIGHTMAGENTA  =13;
    cLIGHTYELLOW   =14;
    cBRIGHTWHITE   =15;
    barcolor1      = cLIGHTRED;
    barcolor2      = cLIGHTYELLOW;

PROCEDURE WaitVGAretrace ();
BEGIN
    WHILE (SYSTEM.In(03DAH) AND 08H) # 0 DO
    END;
    WHILE (SYSTEM.In(03DAH) AND 08H) = 0 DO
    END;
END WaitVGAretrace;

PROCEDURE centerme (minhtab,wi:CARDINAL;S:ARRAY OF CHAR):CARDINAL;
VAR
    len,hpos:CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len < wi THEN
        hpos:=minhtab+(wi-len) DIV 2;
    ELSE
        hpos:=minhtab;
    END;
    RETURN hpos;
END centerme;

VAR
    gvideoconfig        : Graph.VideoConfig;
    gvmode              : CARDINAL;
VAR
    screenX, screenY    : CARDINAL;
    htabMin,htabWidth   : CARDINAL;
    vtabMin,vtabHeight  : CARDINAL;
    numColors           : CARDINAL;
    xmin,xmax,ymin,ymax : CARDINAL;
    screenCX,screenCY   : CARDINAL;

PROCEDURE setupVideoScreen();
VAR
    k : CARDINAL;
BEGIN
    Graph.GetVideoConfig(gvideoconfig);
    screenX  := gvideoconfig.numxpixels; (* 320 *)
    screenY  := gvideoconfig.numypixels; (* 200 *)
    CASE screenX OF
    | 320 : k :=2;
    | 640 : k :=1;
    ELSE
            k :=1;
    END;

    htabMin  := 1;
    htabWidth:= gvideoconfig.numtextcols; (* screenX DIV 8 i.e. 40 here *)
    vtabMin  := 1;
    vtabHeight:=gvideoconfig.numtextrows;

    numColors:= gvideoconfig.numcolors; (* 16 *)

    xmin     := 0;
    xmax     := screenX-1;
    ymin     := 0;
    ymax     := screenY-1;

    screenCX := screenX DIV 2;
    screenCY := screenY DIV 2;
END setupVideoScreen;

PROCEDURE isKeyWaiting (  ) : BOOLEAN;
BEGIN
    RETURN BiosIO.KeyPressed();
END isKeyWaiting;

CONST
    keyEscape = 1B00H;
    keyLeft   = 004BH;
    keyRight  = 004DH;
    keyHome   = 0047H;
    keyEnd    = 004FH;
    keyPgUp   = 0049H;
    keyPgDn   = 0051H;
    keyTab    = 0900H;
    keyStar   = 2A00H;

PROCEDURE ReadKeycode (  ) : CARDINAL;
VAR
    cl,ch : CARDINAL;
BEGIN
    ch := ORD(BiosIO.RdKey());
    IF ch = 0 THEN
        cl:=ORD(BiosIO.RdKey());
    ELSE
        cl:=0;
    END;
    RETURN cl+(ch << 8);
END ReadKeycode;

PROCEDURE nextcolor (VAR c :CARDINAL);
BEGIN
    CASE c OF
    | barcolor1 : c:=barcolor2;
    | barcolor2 : c:=barcolor1;
    END;
END nextcolor;

PROCEDURE newcode (VAR v:CARDINAL; k:INTEGER);
VAR
    i:CARDINAL;
BEGIN
    IF k < 0 THEN
        FOR i:=1 TO ABS(k) DO
            IF v > firstcode THEN
                DEC(v);
            ELSE
                v:=maxcode;
            END;
        END;
    ELSE
        FOR i:=1 TO k DO
            IF v < maxcode THEN
                INC(v);
            ELSE
                v:=firstcode;
            END;
        END;
    END;
END newcode;

PROCEDURE procSort (sortmode:CARDINAL);
VAR
    i : CARDINAL;
    exchange,test:BOOLEAN;
    ln1,ln2:LONGCARD;
    n1,n2:CARDINAL;
BEGIN
    FOR i := firstcode TO maxcode DO
        gcode [i]:=i;
    END;
    IF sortmode # SORTnone THEN
        exchange := TRUE;
        WHILE exchange DO
            exchange := FALSE;
            FOR i := firstcode TO maxcode-1 DO
                ln1 := gcount[i];
                ln2 := gcount[i+1];
                CASE sortmode OF
                | SORTnormal:
                    test := (ln1 < ln2);  (* keep A, B, C,... sequence *)
                | SORTreverse:
                    test := (ln2 < ln1); (* <= instead of < forces A, B, C,... sequence, but would provoke an infinite loop *)
                END;
                IF test THEN
                    gcount[i]   := ln2;
                    gcount[i+1] := ln1;
                    n1          := gcode[i];
                    n2          := gcode[i+1];
                    gcode[i]    := n2;
                    gcode[i+1]  := n1;
                    exchange    := TRUE;
                END;
            END;
        END;
    END;
END procSort;

PROCEDURE drawdata (VAR highest:LONGREAL;
                   xbase,ybase,hedata:CARDINAL;realsize,computehighest:BOOLEAN);
VAR
    v:LONGREAL;
    i,x,color:CARDINAL;
BEGIN
    IF computehighest THEN highest:=0.0; END;
    color := barcolor1;
    FOR i:=firstcode TO maxcode DO
        v := ( LONGREAL(gcount[i]) / LONGREAL(gtotal) ) * 100.0;
        IF computehighest THEN
            IF v > highest THEN highest:=v; END;
        ELSE
            IF  NOT(realsize) THEN v:=v * 100.0 / highest; END;
        END;
        x:=xbase+i;

        Graph.Line(x,ybase+1,x,ybase-hedata-1,cBLACK); (* erase old bar plus safety margins *)

        plot(x,ybase,color,v);
        nextcolor(color);
    END;
END drawdata;

(* we use gcode and gcount *)

PROCEDURE procView (sortmode:CARDINAL;luckyballs:BOOLEAN  );
CONST
    (*                    0        1         2         3         4 *)
    (*                    1234567890123456789012345678901234567890 *)
    msgHelpKbd         = "Flches Dbut Fin PgHaut PgBas Tab *";
CONST
    msgDec             = "Boule       : ~";
    msgCount           = "Frquence   : ~";
    msgPercentage      = "Pourcentage : ~%";
    msgTotal           = "Total       : ~";
    msgSort            = "Tri         : ~";
    msgSortnone        = "aucun                 "; (* include eraser *)
    msgSortnormal      = "frquence dcroissante";
    msgSortreverse     = "frquence croissante  ";
    nlines             = 5;
CONST
    hedata = 100; (* percentage *)
    k      = 1+2+1+1+1;
VAR
    realcode,prevcode,currcode,hpos,vpos,charcode : CARDINAL;
    color,i,x,mx,my:CARDINAL;
    xbase,ybase:CARDINAL;
    v,highest:LONGREAL;
    S:str128;
    xy:Graph.TextCoords;
    R:str80;
    ok,realsize:BOOLEAN;
BEGIN
    IF luckyballs THEN
        firstcode := firstluckynumval;
        maxcode   := lastluckynumval;
    ELSE
        firstcode := firstlotoval;
        maxcode   := lastlotoval;
    END;
    countcode   := maxcode - firstcode + 1;
    widata      := countcode;

    gtotal := 0;
    FOR i:=firstcode TO maxcode DO
        gcode[i] := i;
        gcount[i]:= lototally[i];
        INC(gtotal,gcount[i]);
    END;

    orggcode := gcode;   (* save original data *)
    orggcount:= gcount;

    setupVideoScreen();

    xbase := xmin + (screenX-widata) DIV 2;
    ybase := ymin + hedata + k*2;

    color := cLIGHTGREEN;
    i:=Graph.SetTextColor(color);
    vpos  := vtabMin+vtabHeight-1-1;
    S:=msgHelpKbd;
    hpos:=centerme(htabMin,htabWidth,S);
    xy:=Graph.SetTextPosition(vpos,hpos);
    Graph.OutText(S);
    DEC(vpos,nlines+1);

    color := cWHITE;
    Graph.Rectangle(xbase-k,ybase+k,xbase+widata+k,ybase-hedata-k,color,FALSE);
    FOR i:=firstcode TO maxcode DO
        (*
        IF i MOD 8 = 0 THEN (* inner hex *)
            color := cLIGHTYELLOW;
            Graph.Plot(xbase+i,ybase+k-1,color);
        END;
        *)
        IF i MOD 10 = 0 THEN (* outer dec *)
            color := cWHITE;
            Graph.Plot(xbase+i,ybase+k+1,color);
        END;
    END;

    color:=cWHITE;
    FOR i:=0 TO hedata DO
        IF i MOD 10 = 0 THEN
            Graph.Plot (xbase-k-1,ybase-i,color);
            Graph.Plot (xbase+widata+k+1,ybase-i,color);
        END;
    END;

    procSort(sortmode);

    realsize:=TRUE; (* not 0..100 *)
    drawdata (highest, xbase,ybase,hedata,realsize,TRUE );

    realsize:=FALSE;
    drawdata (highest, xbase,ybase,hedata,realsize,FALSE);

    color := cBRIGHTWHITE;
    i:=Graph.SetTextColor(color);

    currcode := firstcode;
    LOOP
        prevcode:=currcode;
            IF isKeyWaiting() THEN
                charcode:=ReadKeycode();
                CASE charcode OF

                | keyStar:
                    INC(sortmode);
                    IF sortmode > SORTreverse THEN sortmode:=SORTnone;END;
                    (* could be done for SORTnone only but... *)
                    gcode:=orggcode;
                    gcount:=orggcount;
                    procSort(sortmode);
                    drawdata (highest, xbase,ybase,hedata,realsize,FALSE );

                | keyHome: currcode:=firstcode;
                | keyEnd:  currcode:=maxcode;
                | keyEscape:
                    EXIT;
                | keyRight: newcode(currcode,1);
                | keyLeft:  newcode(currcode,-1);
                | keyPgUp:  newcode(currcode,-10);
                | keyPgDn:  newcode(currcode,10);
                | keyTab:
                    realsize := NOT(realsize);

                    drawdata (highest, xbase,ybase,hedata,realsize,FALSE );

                    FOR i:=0 TO hedata DO
                        CASE i OF
                        | 0,hedata: ok:=TRUE; color:=cWHITE; (* force 0 and 100 *)
                        ELSE
                            ok:=( ( i MOD 10 ) = 0);
                            IF realsize THEN
                                color:=cWHITE;
                            ELSE
                                color:=cBLACK;
                            END;
                        END;
                        IF ok THEN
                            Graph.Plot (xbase-k-1,ybase-i,color);
                            Graph.Plot (xbase+widata+k+1,ybase-i,color);
                        END;
                    END;
                ELSE
                    errbip(TRUE);
                END;
            END;

        FOR i:=1 TO 2 DO
            CASE i OF
            | 1: color:=cBLACK;         x:=prevcode;
            | 2: color:=cBRIGHTWHITE;   x:=currcode;
            END;
            Graph.Plot(xbase+x,ybase+2,color);
            Graph.Plot(xbase+x-1,ybase+2+1,color);
            Graph.Plot(xbase+x+1,ybase+2+1,color);
        END;

        realcode:=gcode[currcode];
        FOR i:=1 TO nlines DO
            CASE i OF
            | 1: S:=msgDec;
                 R:=fmtlc ( LONGCARD(realcode), space, "",3);
            | 2: S:=msgCount;
                 R:=fmtlc ( gcount[currcode], space, dot, wilc);
            | 3: S:=msgPercentage;
                 v := ( LONGREAL(gcount[currcode]) / LONGREAL(gtotal) ) * 100.0;
                 R:= fmtpercent (v, space, comma , 2,3+1+2);
            | 4: S:=msgTotal;
                 R:=fmtlc ( gtotal, space, dot, wilc);
            | 5: S:=msgSort;
                 CASE sortmode OF
                 | SORTnone :   R:=msgSortnone;
                 | SORTnormal:  R:=msgSortnormal;
                 | SORTreverse: R:=msgSortreverse;
                 END;

            END;
            Str.Subst(S,"~",R);
            hpos:=htabMin+2;
            xy:=Graph.SetTextPosition(vpos+i-1,hpos);
            Graph.OutText(S);
        END;
    END;
END procView;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    cmdtype = (undefined,gendat,list,chkcli,chkfile,chkfileref,
              gengrid,chkunicity,hiresview,hiresviewluck);

PROCEDURE setcmd (VAR cmd:cmdtype; newcmd:cmdtype):BOOLEAN;
VAR
    pb:BOOLEAN;
BEGIN
    pb:=FALSE;
    CASE cmd OF
    | undefined:
        cmd:=newcmd;
    ELSE
        IF cmd # newcmd THEN pb:=TRUE;END;
    END;
    RETURN pb;
END setcmd;

PROCEDURE chkSpec (VAR S:ARRAY OF CHAR ):CARDINAL;
VAR
    rc:CARDINAL;
BEGIN
    IF chkJoker(S) THEN
        rc:=errJoker;
    ELSE
        IF Str.CharPos(S,dot)=MAX(CARDINAL) THEN Str.Append(S,extTXT);END;
        IF FIO.Exists(S) THEN
            rc:=errNone;
        ELSE
            rc:=errNotFound;
        END;
    END;
    RETURN rc;
END chkSpec;

PROCEDURE chkDatfile (VAR R:ARRAY OF CHAR; S:ARRAY OF CHAR):BOOLEAN;
VAR
    u,d,n,e,nn,ee:str128; (* oversized *)
    ok:BOOLEAN;
BEGIN
    ok:=FIO.Exists(S);
    IF ok THEN
        Str.Copy(R,S);
    ELSE
        qdSplitAllPath (S,u,d,nn,ee);
        Lib.ParamStr(R,0);
        qdSplitAllPath (R,u,d,n,e);
        Lib.MakeAllPath  (R,u,d,nn,ee);
        ok:=FIO.Exists(R);
    END;
    RETURN ok;
END chkDatfile;

PROCEDURE chkValue (VAR v:CARDINAL; mini,maxi:CARDINAL;S:ARRAY OF CHAR):CARDINAL;
VAR
    lc:LONGCARD;
    ok:BOOLEAN;
BEGIN
    lc:=Str.StrToCard(S,10,ok );
    IF NOT(ok) THEN RETURN errBadVal;END;
    IF ( (lc < LONGCARD(mini)) OR (lc > LONGCARD(maxi)) ) THEN RETURN errOutOfRange;END;
    v:=CARDINAL(lc);
    RETURN errNone;
END chkValue;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    firstparm = 1;
    maxparm   = maxcountnums;
VAR
    parm : ARRAY [firstparm..maxparm] OF str16;
    parmcount,i,rc,opt,lastparm:CARDINAL;
    S,R,Z:str128;
    datfile,spec:str128;
    lasttirage:CARDINAL;
    onlywin,doBin,doStats,doIni:BOOLEAN;
    flagFormat76,flagCmdView:BOOLEAN;
    flagEvenTerser,flagUniques,flagVerbose,DEBUG:BOOLEAN;
    cmd : cmdtype;
    refid:LONGCARD;
    g:gridtype;
    ndxtirage:CARDINAL;
    gridCount,numsPerGrid,lucksPerGrid:CARDINAL;
BEGIN
    FIO.IOcheck:=FALSE;
    WrLn;

    InitRnd();

    doBin          := FALSE;
    doStats        := FALSE;
    doIni          := FALSE;
    onlywin        := TRUE;
    refid          := refiddefault;
    flagUniques    := FALSE;
    flagVerbose    := TRUE;
    flagEvenTerser := FALSE;
    flagCmdView    := FALSE;
    flagFormat76   := FALSE;
    DEBUG          := FALSE;
    cmd            := undefined;

    lastparm  := firstparm-1;

    parmcount := Lib.ParamCount();
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i);
        Str.Copy(R,S);
        UpperCase(R);
        cleantabs(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R, "?"+delim+"H"+delim+"HELP"+delim+
                                  "DEBUG"+delim+"DBG"+delim+
                                  "S"+delim+"STATS"+delim+"STATISTICS"+delim+
                                  "L"+delim+"LIST"+delim+
                                  "C"+delim+"CHK"+delim+"CHECK"+delim+"CLI"+delim+
                                  "V"+delim+"VER"+delim+"VERIFY"+delim+
                                  "F"+delim+"FILE"+delim+"VV"+delim+

                                  "T:"+delim+"TIRAGE:"+delim+
                                  "T"+delim+"TOUS"+delim+
                                  "P"+delim+"WONANDLOST"+delim+
                                  "??"+delim+
                                  "G"+delim+"GEN"+delim+
                                  "U"+delim+"UNIQUES"+delim+
                                  "GG"+delim+
                                  "D"+delim+

                                  "M"+delim+"MUET"+delim+"Q"+delim+
                                  "MM"+delim+"QQ"+delim+

                                  "TT"+delim+"LATEST"+delim+
                                  "???"+delim+
                                  "I"+delim+"VIEW"+delim+
                                  "II"+delim+"LUCKY"+delim+
                                  "I76"+delim+"VIEW76"+delim+
                                  "II76"+delim+"COMPLEMENTARY"
                              );
            CASE opt OF
            | 1..3 : abort(errHelp,"");
            | 4..5:  DEBUG   := TRUE;
            | 6..8:  IF setcmd(cmd,gendat) THEN abort(errRedefined,S);END;
                     doBin   := TRUE;
                     doStats := TRUE;
                     doIni   := TRUE;
            | 9..10: IF setcmd(cmd,list) THEN abort(errRedefined,S);END;
            |11..14: IF setcmd(cmd,chkcli) THEN abort(errRedefined,S);END;
            |15..17: IF setcmd(cmd,chkfile) THEN abort(errRedefined,S);END;
            |18..20: IF setcmd(cmd,chkfileref) THEN abort(errRedefined,S);END;

            |21..22: IF refid = refiddefault THEN      (* default *)
                         IF GetLongCard(R,refid) THEN
                             IF refid = refiddefault THEN abort(errBadRefID,S);END;
                             IF refid = refidlatest  THEN abort(errBadRefID,S);END;
                             IF refid = refidall     THEN abort(errBadRefID,S);END;
                         ELSE
                             GetString(R,Z);
                             IF Str.Length(Z)=1 THEN
                                 CASE Z[0] OF
                                 | star,colon,exclam,dollar:
                                     refid:=refidlatest;
                                 ELSE
                                     abort(errBadNum,S);
                                 END;
                             ELSE
                                 abort(errBadNum,S);
                             END;
                         END;
                     ELSIF refid = refidall THEN       (* -t was specified *)
                         abort(errRefIDconflict,"");
                     ELSIF refid = refidlatest THEN    (* -tt was specified *)
                         abort(errRefIDconflict,"");
                     ELSE                              (* -t:$ was specified *)
                         abort(errRefIDredefined,"");
                     END;
            |23..24: IF refid = refiddefault THEN      (* default *)
                         refid:=refidall;
                     ELSIF refid = refidall THEN       (* -t was specified *)
                         ;
                     ELSIF refid = refidlatest THEN    (* -tt was specified *)
                         abort(errRefIDconflict,"");
                     ELSE                              (* -t:$ already specified *)
                         abort(errRefIDconflict,"");
                     END;
            |25..26: onlywin:=FALSE;
            |27    : abort(errHelper,"");
            |28..29: IF setcmd(cmd,gengrid) THEN abort(errRedefined,S);END;
            |30..31: flagUniques:=TRUE;
            |32:     IF setcmd(cmd,gengrid) THEN abort(errRedefined,S);END;
                     flagUniques:=TRUE;
            |33:     IF setcmd(cmd,chkunicity) THEN abort(errRedefined,S);END;

            |34..36: flagVerbose:=FALSE;
            |37..38: flagVerbose:=FALSE; flagEvenTerser:=TRUE;

            |39..40: IF refid = refiddefault THEN    (* default *)
                         refid := refidlatest;
                     ELSIF refid = refidall THEN     (* -t was specified *)
                         abort(errRefIDconflict,S);
                     ELSIF refid = refidlatest THEN  (* -tt was specified *)
                         ;
                     ELSE                            (* -t:# was specified *)
                         abort(errRefIDconflict,"");
                     END;
            | 41    :abort(errHelpest,"");
            | 42..43: IF setcmd(cmd,hiresview) THEN abort(errRedefined,S);END;
                     flagCmdView:=TRUE;
            | 44..45: IF setcmd(cmd,hiresviewluck) THEN abort(errRedefined,S);END;
                     flagCmdView:=TRUE;
            | 46..47: IF setcmd(cmd,hiresview) THEN abort(errRedefined,S);END;
                     flagCmdView:=TRUE;  flagFormat76:=TRUE;
            | 48..49: IF setcmd(cmd,hiresviewluck) THEN abort(errRedefined,S);END;
                     flagCmdView:=TRUE;  flagFormat76:=TRUE;
            ELSE
                abort(errOption,S);
            END;
        ELSE
            INC(lastparm);
            IF lastparm > maxparm THEN abort(errParameter,S); END;
            IF lastparm = firstparm THEN spec:=S;END; (* this can be a file *)
            parm[lastparm]:=str16(S);
        END;
    END;

    IF cmd=undefined THEN cmd:=gengrid;END; (* abort(errHelp,"") *)

    CASE cmd OF
    | list:
        IF lastparm # (firstparm-1) THEN abort(errSyntax,"-l"); END;
    | gendat:
        IF lastparm # (firstparm-1) THEN abort(errSyntax,"-s"); END;
    | chkcli:
        initusergrid(g);
        FOR i:=firstparm TO lastparm DO
            rc:=addusergrid(g,parm[i]);
            IF rc # errNone THEN abort(rc,parm[i]);END;
        END;
        rc:=chksortusergrid(g);
        IF rc # errNone THEN abort(rc,"");END;
    | chkfile:
        IF lastparm # firstparm THEN abort(errSyntax,"-v");END;

        rc:=chkSpec(spec);
        IF rc # errNone THEN abort(rc,spec);END;
    | chkfileref:
        IF lastparm # firstparm THEN abort(errSyntax,"-f");END;
        IF refid # refiddefault THEN abort(errNoRefID,"");END;

        rc:=chkSpec(spec);
        IF rc # errNone THEN abort(rc,spec);END;
    | gengrid:

        CASE lastparm OF
        | firstparm-1:
            parm[firstparm]  :=sDefaultGridCount;
            parm[firstparm+1]:=sDefaultNumsPerGrid;
            parm[firstparm+2]:=sDefaultLucksPerGrid;
        | firstparm:
            parm[firstparm+1]:=sDefaultNumsPerGrid;
            parm[firstparm+2]:=sDefaultLucksPerGrid;
        | firstparm+1:
            parm[firstparm+2]:=sDefaultLucksPerGrid;
        | firstparm+2: ;
        ELSE
            abort(errSyntax,"-g");
        END;
        Str.Copy(R,parm[firstparm]);
        rc:=chkValue(gridCount, firstgrid,maxgrid,R);
        IF rc # errNone THEN abort(rc, R); END;
        Str.Copy(R,parm[firstparm+1]);
        rc:=chkValue(numsPerGrid, minibouleUser,maxbouleUser,R);
        IF rc # errNone THEN abort(rc, R); END;
        Str.Copy(R,parm[firstparm+2]);
        rc:=chkValue(lucksPerGrid, firstluckynumUser,maxluckynumUser,R);
        IF rc # errNone THEN abort(rc, R); END;

        IF calcmise(lucksPerGrid,numsPerGrid)=0 THEN abort(errIllegalUserGrid,"");END;

        IF refid = refiddefault THEN    (* default *)
            refid:=refidgen;
        ELSIF refid = refidall THEN     (* -t was specified *)
            abort(errNoRefIDgengrid,"");
        ELSIF refid = refidlatest THEN  (* -tt was specified *)
            ;
        ELSE                            (* -t:# was specified *)
            ;
        END;

    | chkunicity:
        IF lastparm # firstparm THEN abort(errSyntax,"-d");END;
        IF refid # refiddefault THEN abort(errNoRefIDuniq,"");END;

        rc:=chkSpec(spec);
        IF rc # errNone THEN abort(rc,spec);END;
    | hiresview :
        IF lastparm # (firstparm-1) THEN abort(errSyntax,"-i[76]");END;
    | hiresviewluck:
        IF lastparm # (firstparm-1) THEN abort(errSyntax,"-ii[76]");END;
    END;

    IF flagFormat76 THEN (* we know it's hiresview[luck] here *)
        IF chkDatfile(datfile,progDatfile76)=FALSE THEN abort(errNotFound,datfile);END;
    ELSE
        IF chkDatfile(datfile,progDatfile)  =FALSE THEN abort(errNotFound,datfile);END;
    END;

    lasttirage := getData(doBin,doStats,doIni,flagCmdView,flagFormat76,DEBUG,datfile);

    CASE cmd OF
    | hiresview,hiresviewluck :
        Graph.GetVideoConfig(gvideoconfig);
        IF gvideoconfig.adapter # Graph._VGA THEN abort(errVGAneeded,""); END;
        gvmode   := Graph._MRES16COLOR;
        S        := "320x200x8";
        IF Graph.SetVideoMode(gvmode)=FALSE THEN abort(errCannotSet,S); END;

        procView(SORTnone, (cmd=hiresviewluck) );

        gvmode   := Graph._DEFAULTMODE;
        S        := "original";
        IF Graph.SetVideoMode(gvmode)=FALSE THEN abort(errCannotSet,S); END;

        abort(errNone,"");
    END;

    IF lasttirage = PBALLOC THEN
        abort(errStorage,datfile); (* let DOS handle alloc *)
    ELSIF lasttirage < firsttirage THEN
        abort(errNoTirage,datfile);
    ELSIF lasttirage > maxtirage THEN
        doRelease(maxtirage); (* useless but cleaner *)
        abort(errTooManyTirages,datfile);
    END;

    CASE cmd OF
    | list:
        showList(lasttirage);
    | chkcli:
        ndxtirage:= chkRefID(lasttirage,refid,R);
        IF ndxtirage = NOSUCHREFID THEN abort(errNoSuchRefID,R);END;
        doScanCli(DEBUG,onlywin,FALSE,ndxtirage,lasttirage,g);
    | chkfile:
        ndxtirage:= chkRefID(lasttirage,refid,R);
        IF ndxtirage = NOSUCHREFID THEN abort(errNoSuchRefID,R);END;
        doScanFile (DEBUG,onlywin,FALSE,ndxtirage,lasttirage,spec);
    | chkfileref:
        doScanFile (DEBUG,onlywin,TRUE,ndxtirage,lasttirage,spec);
    | gengrid:
        ndxtirage:= chkRefID(lasttirage,refid,R);
        IF ndxtirage = NOSUCHREFID THEN abort(errNoSuchRefID,R);END;
        IF doBuild (ndxtirage,gridCount,numsPerGrid,lucksPerGrid,
                   flagUniques,flagVerbose,flagEvenTerser)= FALSE THEN
            abort(errInfiniteLoop,"");
        END;
    | chkunicity:
        IF doUnicity(DEBUG,spec)=FALSE THEN abort(errTooManyEntriesToChk,spec);END;
    END;

    doRelease(lasttirage); (* useless but cleaner *)

    abort(errNone,"");
END Loto.



