(* ---------------------------------------------------------------
Title         Q&D Make DEF
Author        PhG
Overview
Notes         model must be Compact or more
              general idea is :
              - reprer [implementation] module xxx
              - crer definition module xxx
              - reprer les squences mme sur plusieurs lignes de
                PROCEDURE ( [:;]-- ) [:]-- ;
              - prendre garde aux remarques, directives et chanes (bugs)

Bugs          cannot handle things like "PROCEDURE () ; IN lib;" but who cares ?
              still unable to parse itself anyway !
              can still overwrite src
              NOT really a bug : an empty liste gives "FROM $$$ IMPORT"
Wish List     rewrite the whole thing ? bah, it works, after all...
              flag procedures AND variables TO hide WITH (* HIDE/PRIVATE *) ?
              include global TYPEs

              could also keep TYPE and globerks ?

--------------------------------------------------------------- *)

MODULE MakeDEF;

IMPORT Lib;
IMPORT Str;
IMPORT FIO;
IMPORT IO;

FROM IO IMPORT WrStr,WrLn;

FROM QD_ASCII IMPORT dash, slash, nullchar, tabchar, cr, lf, nl, bs,
space, dot, deg, doublequote, quote, colon, percent, vbar,
blank, equal, dquote, charnull, singlequote, antislash, dollar,
star, backslash, coma, question, underscore, tabul, hbar,
comma, semicolon, diese, pound, openbracket, closebracket, tilde, exclam,
stardotstar, dotdot, escCh, escSet, letters, digits,
lettersUpp, lettersLow, openbrace, closebrace;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory, qdSplitAllPath,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite, setReadOnly,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs, UpperCaseAlt, LowerCaseAlt,
completedInit, completedShow, completedSHOW, completedEnd, completed,
removeDups, isValidHDunit, removePhantoms, removeFloppies,
getCDROMunits, getCDROMletters, removeCDROMs, getAllHDunits,
getAllLegalUnits, metaproc, getCli, argc, argv;

(* ------------------------------------------------------------ *)

CONST
    debug         = FALSE;
    beta          = CHR(225);
    ProgEXEname   = "MAKEDEF";
    ProgTitle     = "Q&D Make DEF file from MOD file";
    ProgVersion   = "v1.1d"; (* +beta *)
    ProgCopyright = "by PhG";
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;

    extDEF        = ".DEF";
    extMOD        = ".MOD";
    extIMP        = ".IMP";
    extBAK        = ".{";    (* "{" + "DE" or "IM" *)
CONST
    firstFile    = 1;
    maxFile      = 500;    sMaxFile     = "500";
    minWidth     = 20;
    maxWidth     = 254;    sRange       = "[20..254]";
    defaultwidth = 70;     sDefWidth    = "70";
CONST
    errNone         = 0;
    errHelp         = 1;
    errUnknown      = 2;
    errParmOverflow = 3;
    errTooManyFiles = 4;
    errNoMatchFile  = 5;
    errMissingSpec  = 6;
    errBadRange     = 7;
    errBadValue     = 8;

(* save and optimize _seems_ ok whether in or out of procedure *)

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
0        1         2         3         4         5         6         7         8
12345678901234567890123456789012345678901234567890123456789012345678901234567890
*)
    msgHelp = Banner+nl+
nl+
"Syntax : "+ProgEXEname+" <file(s)["+extMOD+"]> [option]..."+nl+
nl+
"This program builds "+extDEF+" and "+extIMP+" file(s) from "+extMOD+" file(s)."+nl+
nl+
"  -l|-i do not create "+extIMP+" importation list"+nl+
"  -r    keep remark just preceding PROCEDURE"+nl+
"  -p    pack lines (no CRLF between headers)"+nl+
"  -f    force program code to be parsed as if it was a module"+nl+
"  -w:#  specify IMPORT list width in characters (default is "+sDefWidth+")"+nl+
"  -v    verbose PROCEDURE listing while working"+nl+
nl+
"a) This program can process up to "+sMaxFile+" files at once"+nl+
"   (note files matching *"+extDEF+" and *"+extIMP+" are ignored)."+nl+
"b) Processing assumes each source file has correct Modula-2 syntax."+nl+
"c) This tool was written for TopSpeed J.P.I. Modula-2 source code :"+nl+
"   hand-editing will still be required for elements such as"+nl+
"   constants, types, global variables, private procedures."+nl;

VAR
    S : str128;
BEGIN
    CASE e OF
    | errHelp :           WrStr(msgHelp);
    | errUnknown :        S:='Unknown "|" option !';
    | errParmOverflow:    S:='"|" is one parameter too many !';
    | errTooManyFiles :   S:='Too many files match "|" specification !';
    | errNoMatchFile :    S:='No file matches "|" specification !';
    | errMissingSpec :    S:="Missing <file(s) specification !";
    | errBadRange :       S:="-w:# option must belong to "+sRange+" !";
    | errBadValue:        S:='Illegal "|" value !';
    ELSE
        S := "How did you get THERE ?";
    END;
    CASE e OF
    | errNone, errHelp :
        ;
    ELSE
        Str.Subst(S,"|",einfo);
        WrStr(ProgEXEname+" : "); WrStr(S); WrLn;
    END;
    Lib.SetReturnCode(SHORTCARD(e));
    HALT;
END abort;

(* ------------------------------------------------------------ *)

PROCEDURE handlebak (VAR fi:ARRAY OF CHAR; orgfi,ext:ARRAY OF CHAR );
VAR
    unit,f8,e3,extbk:str16;
    bk,path:str128;
BEGIN
    Str.Slice(extbk,ext,1,2);  (* ".123" becomes "12" *)
    Str.Prepend(extbk,extBAK); (* ".{12" now  *)

    Str.Copy(fi,orgfi);
    Str.Copy(bk,orgfi);
    qdSplitAllPath(orgfi,unit,path,f8,e3);  (* e3 contains . so length is 4 *)
    Str.Subst(fi,e3,ext);
    Str.Subst(bk,e3,extbk);
    IF FIO.Exists(fi) THEN
        IF FIO.Exists(bk) THEN FIO.Erase(bk); END;
        FIO.Rename(fi,bk);
    END;
END handlebak;

(* ------------------------------------------------------------ *)

(* Str.Subst replaces only first occurrence *)

PROCEDURE Replace (VAR s:ARRAY OF CHAR; target:CHAR; new:CHAR );
(*
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(s,target);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        s[p] := new;
    END;
*)
BEGIN
    Str.Subst(s,target,new);
END Replace;

PROCEDURE DmpTTX (hnd:FIO.File;
                  VAR s:ARRAY OF CHAR;
                  maxcount:CARDINAL);     (* 79 *)
VAR
    begpos: CARDINAL;
    count : CARDINAL;
    advance:CARDINAL;
    t : str80; (* never more than 80 chars *)
    i : CARDINAL;
BEGIN
    begpos:=0;
    LOOP
       count:=maxcount;
       advance:=maxcount;
       IF (begpos+count) < Str.Length(s) THEN (* not the last line to print *)
            LOOP
                IF s[begpos+count]=blank THEN (* found first space backwards *)
                    advance:=count+1;   (*' position after space *)
                    EXIT;
                END;
                DEC(count);
                IF count= 0 THEN (* no space at all in line to print *)
                    count:=maxcount;
                    EXIT;
                END;
            END;
       END;
       Str.Slice (t,s,begpos,count); (* slice good portion *)
       FIO.WrStr(hnd,t);
       FIO.WrLn(hnd);
       INC(begpos,advance); (* skip space if any *)
       IF begpos >= Str.Length(s) THEN EXIT; END;
    END;
END DmpTTX;

(* ------------------------------------------------------------ *)

PROCEDURE GetCardinal (VAR v : CARDINAL; S : ARRAY OF CHAR) : BOOLEAN;
VAR
    p : CARDINAL;
    lc : LONGCARD;
    ok : BOOLEAN;
BEGIN
    Replace(S,equal,colon); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(S,colon); (* MAX(CARDINAL) already excluded! *)
    Str.Delete(S,0,p+1);
    lc:=Str.StrToCard(S,10,ok);
    IF ok = FALSE THEN RETURN FALSE;END;
    IF lc > MAX(CARDINAL) THEN RETURN FALSE;END;
    v:=CARDINAL(lc);
    RETURN TRUE;
END GetCardinal;

PROCEDURE Appears (string,what:ARRAY OF CHAR;VAR p : CARDINAL) : BOOLEAN;
BEGIN
    p := Str.Pos(string,what);
    RETURN ( p # MAX(CARDINAL) );
END Appears;

(* ------------------------------------------------------------ *)

CONST
    IObufferSize = (8 * 512) + FIO.BufferOverhead; (* 4Kb is enough, 16Kb was oversized and useless *)
    firstIObufferByte = 1;
    lastIObufferByte  = IObufferSize;
VAR
    IObufferIn : ARRAY [firstIObufferByte..lastIObufferByte] OF BYTE; (* for private M2 IO *)
    IObufferOut: ARRAY [firstIObufferByte..lastIObufferByte] OF BYTE; (* for private M2 IO *)

(* ------------------------------------------------------------ *)

CONST
    (*
       each word is delimited by any characters except
       a digit, a letter, an underbar or a '.'
       this filter only leaves keywords without attached delimiters
    *)
    Filter    = Str.CHARSET{ 0C..CHAR(255) } -
                Str.CHARSET{ 'A'..'Z','a'..'z','_','0'..'9','.' }; (* //FIXME what about "_" here ? *)

    (* this filter keeps keywords with attached delimiters *)
    FilterAlt = Str.CHARSET{ cr,lf,tabul,blank};

PROCEDURE TokenAppears (VAR line:ARRAY OF CHAR;lookedfor:ARRAY OF CHAR  ): BOOLEAN;
VAR
    wordpos:CARDINAL;
    word : str80; (* should be enough! *)
BEGIN
    wordpos := 0;
    LOOP
        Str.Item(word,line,Filter,wordpos);
        IF (word[0] = 0C) THEN
            RETURN FALSE;
        END; (* Check that there was a word *)
        IF Str.Compare(word,lookedfor)=0 THEN
            RETURN TRUE;
        END;
        INC(wordpos);
    END;
END TokenAppears;

(* ------------------------------------------------------------ *)

CONST
    openREM 	   = "(*";
    closeREM 	   = "*)";
    procedure 	   = "PROCEDURE";
    pragma1         = openREM+"%";
    pragma2         = openREM+"#";
CONST
    firstline = 1;
    lastline  = 32;
VAR
    kept : ARRAY [firstline..lastline] OF str256;
    nextline : CARDINAL;
    state : (waiting,inremark,after);

PROCEDURE InitStack ();
BEGIN
    nextline := firstline;
    state := waiting;
END InitStack;

PROCEDURE Push (VAR s:ARRAY OF CHAR); (* var is faster but do not touch! *)
BEGIN
    IF nextline <= lastline THEN (* could abort but... *)
        Str.Copy(kept[nextline],s);
        INC(nextline);
    ELSE
        nextline := firstline; (* lose every previous stacked lines *)
    END;
END Push;

PROCEDURE IsStackEmpty (  ) : BOOLEAN;
BEGIN
    IF nextline = firstline THEN
        RETURN TRUE;
    ELSE
        RETURN FALSE;
    END;
END IsStackEmpty;

PROCEDURE Dump (hndo : FIO.File);
VAR
    i:CARDINAL ;
BEGIN
    IF IsStackEmpty()=FALSE THEN
        FOR i:=firstline TO (nextline-1) DO
            FIO.WrStr(hndo,kept[i]);
            FIO.WrLn(hndo);
        END;
    END;
    InitStack();
END Dump;

PROCEDURE ProcessREM (VAR s : ARRAY OF CHAR); (* var is faster but do not touch! *)
VAR
    pragmahere : BOOLEAN;
    beghere : BOOLEAN;
    endhere : BOOLEAN;
    p : CARDINAL;
BEGIN
    IF Appears(s,procedure,p) THEN
         Push(s);
         state := waiting;
         RETURN;
    END;
    pragmahere :=( Appears(s,pragma1,p) OR Appears(s,pragma2,p) );

    CASE pragmahere OF
    | TRUE :               (* force to false *)
        beghere := FALSE;
        endhere := FALSE;
    | FALSE :
        beghere := Appears(s,openREM,p);
        endhere := Appears(s,closeREM,p);
    END;
    CASE state OF
    | waiting :
         CASE beghere OF
         | TRUE :
             CASE endhere OF
             | TRUE :
                 InitStack();  (*    /* --- */     *)
                 Push(s);
                 state := after;
             | FALSE :         (*    /* ---        *)
                 Push(s);
                 state := inremark;
             END;
         | FALSE :
             CASE endhere OF   (*       --- */     ILLOGICAL! *)
             | TRUE :
             | FALSE :         (*       ---        *)
             END;
         END;
    | inremark :
         CASE beghere OF
         | TRUE :
             CASE endhere OF
             | TRUE :          (*    /* --- */     *)
                 Push(s);
             | FALSE :         (*    /* ---        *)
                 InitStack();
                 Push(s);
             END;
         | FALSE :
             CASE endhere OF
             | TRUE :          (*      --- */      *)
                 Push(s);
                 state := after;
             | FALSE :         (*      ---         *)
                 Push(s);
             END;
         END;
    | after :
         CASE beghere OF
         | TRUE :
             CASE endhere OF
             | TRUE :          (*    /* --- */     *)
                 InitStack();
                 Push(s);
                 state := after; (* keep same state! *)
             | FALSE :         (*    /* ---        *)
                 InitStack();
                 Push(s);
                 state := inremark;
             END;
         | FALSE :
             CASE endhere OF
             | TRUE :          (*       --- */     ILLOGICAL! *)
                 Push(s);
             | FALSE :         (*       ---        *)
                 Push(s);
             END;
         END;
    END;
END ProcessREM;

(* ------------------------------------------------------------ *)

PROCEDURE IsBlank (c : CHAR) : BOOLEAN;
CONST
    Blanks = cr+lf+tabul+blank;
BEGIN
    IF Str.CharPos(Blanks,c) = MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END IsBlank;

PROCEDURE IsDelimiter (c : CHAR) : BOOLEAN;
CONST
    Delimiters = "(),=+-*<>/\[]^:;."; (* //FIXED V11C removed "_" *)
BEGIN
    IF Str.CharPos(Delimiters,c) = MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END IsDelimiter;

(* filename is already in upper case *)
(* this is a VERY VERY VERY QUICK & DIRTY procedure *)

PROCEDURE Process (modfile : ARRAY OF CHAR;
                   keepREM,skipCR,verbose,relax,genlist,dbg : BOOLEAN;
                   listwidth : CARDINAL);
CONST
    sImplementation= "IMPLEMENTATION";
    sModule 	   = "MODULE";
    openparen 	   = "(";
    closeparen 	   = ")";
    sDefinition    = "DEFINITION";
    enddef         = "END";
    frommod        = "FROM ";
    importproc     = " IMPORT";
VAR
    S:str256;
    deffile : str128;
    impfile : str128;
    line    : str256;
    procname : str256;
    token : str256;
    wordpos : CARDINAL;
    header : str256;
    p      : CARDINAL;
    flagIN : BOOLEAN;
    liste : str4096; (* //V11B was str1024, was not always enough ! *)
    msg:str128;
    hndi,hndo:FIO.File;
BEGIN

    Str.Concat(msg,"Processing ",modfile);
    video(msg,TRUE);

    Str.Copy(liste,"");

    handlebak(deffile,  modfile,extDEF);

    hndi := FIO.OpenRead(modfile);
    FIO.AssignBuffer(hndi,IObufferIn);
    hndo:= FIO.Create(deffile);
    FIO.AssignBuffer(hndo,IObufferOut);

    (* ------------------------------------------------------------ *)

    (*
    assume here very, very, very basic code structure!!! ;-)
    absolutely no error checking for bad structure!!!
    assume source file is relatively correct -- no systematic EOF check
    *)

    (* if relax TRUE, do not take implementation into account *)
    LOOP
        FIO.RdStr(hndi,header);
        IF FIO.EOF = TRUE THEN EXIT; END;
        (* find IMPLEMENTATION MODULE line *)
        IF Appears(header,sModule,p) THEN
            CASE relax OF
            | TRUE :
                 (* write DEFINITION MODULE line *)
                 Str.Prepend (header,sDefinition+blank);
                 FIO.WrStr(hndo,header);
                 FIO.WrLn(hndo);
                 FIO.WrLn(hndo);
                 EXIT;
            | FALSE :
                 IF Appears(header,sImplementation,p) THEN
                     (* write DEFINITION MODULE line *)
                     Str.Subst (header,sImplementation,sDefinition);
                     FIO.WrStr(hndo,header);
                     FIO.WrLn(hndo);
                     FIO.WrLn(hndo);
                     EXIT;
                 END;
            END;
        END;
    END;
    IF keepREM = TRUE THEN InitStack(); END;
    LOOP
        FIO.RdStr(hndi,line);
        IF FIO.EOF = TRUE THEN EXIT; END;
        IF keepREM = TRUE THEN ProcessREM(line); END;
        (* find PROCEDURE line *)
        IF Appears(line,procedure,p) THEN
            Str.Copy(procname,line);
            IF keepREM = TRUE THEN
                 IF skipCR = TRUE THEN FIO.WrLn(hndo); END;
                 Dump(hndo); (* includes PROCEDURE line too *)
            ELSE
                 FIO.WrStr(hndo,line);
                 FIO.WrLn(hndo);
            END;
            Str.Subst(line,pragma1,""); (* avoid confusion! *)
            Str.Subst(line,pragma2,"");
            Str.Subst(line,openREM,""); (* q&d hack as not to confuse openREM with ( but not guaranteed! *)
            (* q&d check for procedures with parameters! *)
            IF Appears(line,openparen,p) THEN
                (* find next closeparen... and hope there's no comment in line! *)
                LOOP
                    Str.Subst(line,closeREM,""); (* q&d hack as not to confuse closeREM with ) but not guaranteed! *)
                    IF Appears(line,closeparen,p) THEN EXIT; END;
                    FIO.RdStr(hndi,line);
                    FIO.WrStr(hndo,line);
                    FIO.WrLn(hndo);
                END;
                (* last closeparen was found at p in line, now find last semicolon *)
                Str.Delete(line,0,p+1); (* 1 is ) len *)
                LOOP
                    IF Appears(line,semicolon,p) THEN EXIT; END;
                    FIO.RdStr(hndi,line);
                    FIO.WrStr(hndo,line);
                    FIO.WrLn(hndo);
                END;
            ELSE
                (* here, PROCEDURE without openparen, therefore find last semicolon *)
                (* assume logical layout!!! *)
                LOOP
                    IF Appears(line,semicolon,p) THEN EXIT; END;
                    FIO.RdStr(hndi,line);
                    FIO.WrStr(hndo,line);
                    FIO.WrLn(hndo);
                END;
            END;
            IF skipCR = FALSE THEN FIO.WrLn(hndo); END;

            (* here we should read till the end of the PROCEDURE *)
            (* but check first for special case of PROCEDURE IN *)

            flagIN := TokenAppears(procname,"IN");

            p:= Str.Pos(procname,procedure);
            Str.Delete(procname,0,p+Str.Length(procedure));
            (* retrieve token right after PROCEDURE *)
            Str.Item(procname,procname,Filter,0);
            (* add it to future import list *)
            Str.Append(liste,blank);
            Str.Append(liste,procname);
            Str.Append(liste,comma);
            IF verbose THEN
                video(msg,FALSE);
                WrStr("    "); WrStr(procname); WrLn;
                video(msg,TRUE);
            END;
            IF flagIN = FALSE THEN
                LOOP
                    FIO.RdStr(hndi,line);
                    IF FIO.EOF THEN EXIT; END;
                    Str.Item(token,line,Filter,0); (* try END *)
                    Str.Item(line,line,Filter,1); (* try procname *)
                    IF Str.Compare(token,enddef)=0 THEN
                       IF Str.Compare(line,procname)=0 THEN EXIT; END; (* end proc *)
                    END;
                END;
            END;
        END;
    END;
    IF skipCR = TRUE THEN FIO.WrLn(hndo); END;
    Str.Subst(header,sDefinition,"");
    Str.Subst(header,sModule,enddef);
    Str.Subst(header,semicolon,dot);
    Ltrim(header,blank);
    (* write END line *)
    FIO.WrStr(hndo,header);
    FIO.WrLn(hndo);
    FIO.WrLn(hndo);

    (* generate here in a comment the FROM module IMPORT procs *)

    Str.Subst(header,enddef,"");
    Str.Subst(header,dot,"");
    Ltrim(header,blank);
    Rtrim(header,blank);

    FIO.WrStr(hndo,openREM);
    FIO.WrLn(hndo);
    IF skipCR=FALSE THEN FIO.WrLn(hndo);END;

    (* reverse order *)
    Str.Prepend(liste,importproc);
    Str.Prepend(liste,header);
    Str.Prepend(liste,frommod);
    p:=Str.RCharPos(liste,comma);
    IF p # MAX(CARDINAL) THEN (* //V11D *)
        liste[p] := semicolon;
    END;
    DmpTTX(hndo,liste,listwidth);

    IF skipCR=FALSE THEN FIO.WrLn(hndo); END;
    FIO.WrStr(hndo,closeREM);
    FIO.WrLn(hndo);

    (* ------------------------------------------------------------ *)

    FIO.Flush(hndo);
    FIO.Close(hndi);
    FIO.Close(hndo);

    video(msg,FALSE);

    Str.Concat(S,"Created "+vbar+vbar+" from ",modfile);
    Str.Subst(S,vbar,deffile);
    IF genlist THEN
        handlebak (impfile, modfile,extIMP);

        hndo:= FIO.Create(impfile);
        FIO.AssignBuffer(hndo,IObufferOut);

        FIO.WrLn(hndo);
        DmpTTX(hndo,liste,listwidth);
        FIO.WrLn(hndo);

        FIO.Flush(hndo);
        FIO.Close(hndo);

        Str.Subst(S,vbar," and "+vbar);
        Str.Subst(S,vbar,impfile);
    ELSE
        Str.Subst(S,vbar,"");
    END;
    WrStr(S);WrLn;
END Process;

(* ------------------------------------------------------------ *)

VAR
    parmcount,i,opt   : CARDINAL;
    S           : str128;
    flagREM, flagPack, flagVerbose, flagForce, flagLIST : BOOLEAN;
    DEBUG    : BOOLEAN;
    filespec : str128;
    unit     : str16; (* 2 chars *)
    path     : str128;
    f8       : str16; (* 8 chars *)
    e3       : str16; (* 4 chars *)
    tmpunit  : str16; (* 2 chars *)
    tmppath  : str128;
    zewidth  : CARDINAL;
    clistate : (waitingspec,gotspec);
VAR
    filename  : ARRAY [firstFile..maxFile] OF str16;
    fileCount : CARDINAL;
    found     : BOOLEAN;
    Entry     : FIO.DirEntry;
BEGIN
    Lib.DisableBreakCheck();
    FIO.IOcheck := FALSE;

    WrLn;

    flagREM     := FALSE;
    flagPack    := FALSE;
    flagVerbose := FALSE;
    flagForce   := FALSE;
    flagLIST    := TRUE;
    zewidth     := defaultwidth;
    DEBUG       := FALSE;

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort (errHelp,""); END;

    clistate := waitingspec;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i);
        cleantabs(S);
        IF isOption(S) THEN
            UpperCase (S);
            opt := GetOptIndex (S,"?"+delim+"H"+delim+"HELP"+delim+
                                  "R"+delim+"REM"+delim+"REMARK"+delim+
                                  "P"+delim+"PACK"+delim+"NOCR"+delim+
                                  "V"+delim+"VERBOSE"+delim+
                                  "F"+delim+"FORCE"+delim+
                                  "W:"+delim+"WIDTH:"+delim+
                                  "L"+delim+"LIST"+delim+"I"+delim+"IMPORT"+delim+
                                  "DEBUG");
            CASE opt OF
            | 1,2,3 : abort(errHelp,"");
            | 4,5,6 : flagREM     := TRUE;
            | 7,8,9 : flagPack    := TRUE;
            | 10,11 : flagVerbose := TRUE;
            | 12,13 : flagForce   := TRUE;
            | 14,15 : IF GetCardinal(zewidth,S)=FALSE THEN abort(errBadValue,S);END;
                      IF (zewidth < minWidth) OR (zewidth > maxWidth) THEN abort(errBadRange,S); END;
            | 16,17,18,19:
                      flagLIST    := FALSE;
            | 20:     DEBUG       := TRUE;
            ELSE
                Lib.ParamStr(S,i); (* retrieve org parm *)
                abort(errUnknown,S);
            END;
        ELSE
            CASE clistate OF
            | waitingspec:
                UpperCase (S);
                IF same(S,"?") THEN abort(errHelp,"");END;
                IF same(S,".") THEN S:="*"+extMOD;END;
                Str.Copy (filespec, S);
                IF Str.CharPos(filespec,dot)=MAX(CARDINAL) THEN
                    Str.Append(filespec,extMOD);
                END;
                INC(clistate);
            | gotspec:
                abort(errParmOverflow,S);
            END;
        END;
    END;
    IF clistate=waitingspec THEN abort(errMissingSpec,""); END;

    fileCount := 0;
    found := FIO.ReadFirstEntry(filespec,FIO.FileAttr{},Entry);
    WHILE found DO
        IF fileCount = maxFile THEN abort(errTooManyFiles,filespec); END;
        qdSplitAllPath(Entry.Name,tmpunit,tmppath,f8,e3);
        i:=0;
        IF Str.Match(Entry.Name,"*"+extDEF) THEN INC(i);END;
        IF Str.Match(Entry.Name,"*"+extIMP) THEN INC(i);END;
        IF i = 0 THEN
            INC (fileCount);
            filename[fileCount]:=str16(Entry.Name);
        END;
        found := FIO.ReadNextEntry(Entry);
    END;
    IF fileCount = 0 THEN abort (errNoMatchFile,filespec); END;

    FOR i := firstFile TO fileCount DO
        Str.Concat(S,unit,path);
        Str.Append(S,filename[i]);
        Process(S,flagREM,flagPack,flagVerbose,flagForce,flagLIST,DEBUG,zewidth);
    END;

    abort(errNone,"");
END MakeDEF.

