(* ---------------------------------------------------------------
Title         Q&D Show Pictures Dimensions
Overview      Yet Another Completely Useless Program
Usage         see help
Notes         model cannot be small
              FLV format would require too much work :
              instead of having width and height as integers
              IN header, they seem TO be kept as floats
              WITH an encoding depending upon version
              AND a few resolutions as numbers associated to specific WxH :
              a nightmare of useless and stupid complication
              I've seeen very complicated code handling
              retrieval of dimensions, but it's not worth the time
              so FLV support was tried AND removed
              (code would only work for height anyway)
              see //FIXFLV
Bugs          yes, we know JPG data should not be hardcoded
              YATB : checking in a set does not work ! seen in chkTGA()
              jpeg APP14 adobe marker may/will require special handling
              seems a few JPG, while viewable, are not standard
              seems Adobe header is not standard (missing JFIF, etc.)
Wish List     clever external pattern database ?
              filter according to user-specified dimensions ?
              more formats (compressed JPEGs) ?
              more infos about pictures ? bah, we just need dimensions
              check //FIXME for len >= 16
              MP4 support is very limited, for I did not care about
              checking file format specifications nor decoder source codes,
              just relying on Q&D "reverse-engineering" of start of file,
              thus using hard-coded values : we should read all data
              and search for "tkhd" and possibly "avc1" but well...
              maybe in another life...
              the same applies to AVI support
              FLV ? BIK ?
--------------------------------------------------------------- *)

MODULE picDimS;

IMPORT Str;
IMPORT Lib;
IMPORT FIO;

FROM IO IMPORT WrStr, WrLn;

FROM Storage IMPORT Available,ALLOCATE,DEALLOCATE;

FROM QD_ASCII IMPORT dash, slash, nullchar, tabchar, cr, lf, nl, bs,
space, dot, deg, doublequote, quote, colon, percent, vbar,
blank, equal, dquote, charnull, singlequote, antislash, dollar,
star, backslash, coma, question, underscore, tabul, hbar,
comma, semicolon, diese, pound, openbracket, closebracket, tilde, exclam,
stardotstar, dotdot, escCh, escSet, letters, digits,
lettersUpp, lettersLow, openbrace, closebrace;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory, qdSplitAllPath,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite, setReadOnly,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs, UpperCaseAlt, LowerCaseAlt,
completedInit, completedShow, completedSHOW, completedEnd, completed,
removeDups, isValidHDunit, removePhantoms, removeFloppies,
getCDROMunits, getCDROMletters, removeCDROMs, getAllHDunits;

FROM QD_LFN IMPORT path9X, huge9X, findDataRecordType,
unicodeConversionFlagType, w9XchangeDir,
w9XgetDOSversion, w9XgetTrueDOSversion, w9XisWindowsEnh, w9XisMSDOS7,
w9XfindFirst, w9XfindNext, w9XfindClose, w9XgetCurrentDirectory,
w9XlongToShort, w9XshortToLong, w9XtrueName, w9XchangeDir,
w9XmakeDir, w9XrmDir, w9Xrename, w9XopenFile, w9XcloseFile,
w9XsupportLFN;

FROM QD_File IMPORT pathtype, w9XnothingRequired,
fileOpenRead, fileOpen, fileExists, fileExistsAlt,
fileIsRO, fileSetRW, fileSetRO,
fileErase, fileCreate, fileRename, fileGetFileSize, fileIsDirectorySpec,
fileClose;

(* ------------------------------------------------------------ *)

CONST
    ctrlZ       = CHR(26); (* $1a *)
    specSWP     = "*.SWP";
    specPAR     = "*.PAR";
    specPAGEFILE= "*\PAGEFILE.SYS"; (* was "?:\PAGEFILE.SYS" *)
    specLST     = "*.LST";
    specRPT     = "*.RPT";
    specBAT     = "*.BAT";
    extUNKNOWN  = ".RAW";  (* //V10W -b unknown format *)
    TOOMANY     = MAX(CARDINAL);
    (* //FIXFLV *)
    validPicExtensions  =".GIF,.PNG,.JPG,.PCX,.BMP,.TGA,.DDS,.JPEG,.WEBP,.AVI,.BIK,.MP4"; (* .???[,.???] *)
    supportedFormats    = "GIF, PNG, JPG, PCX, BMP, TGA, DDS, WEBP, AVI, BIK and MP4";
    partialsupport      = "JPG, PCX, TGA, DDS, WEBP and MP4";
CONST
    progEXEname   = "PICDIMS";
    progTitle     = "Q&D Show Pictures Dimensions";
    progVersion   = "v1.1";
    progCopyright = "by PhG";
    banner        = progTitle+" "+progVersion+" "+progCopyright;
CONST
    errNone            = 0;
    errHelp            = 1;
    errUnknownOption   = 2;
    errTooManyParms    = 3;
    errMissingSpec     = 4;
    errNotFound        = 5;
    errNotFile         = 6;
    errJokerPath       = 7;
    errAborted         = 8;
    errNoMatch         = 9;
    errTooMany         = 10;
    errFmt             = 11;
    errScreen          = 12;
    errInverseDimensions=13;
    errNonsense        = 14;
    errValue           = 15;
    errDefaultOrUser   = 16;
    errBadExtRequired  = 17;
    errFsize           = 18;
    errInverseFsize    = 19;
    errComp            = 20;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)

errmsg =
banner+nl+
nl+
"Syntax : "+progEXEname+" <pathspec> [option]..."+nl+
nl+
"This program tries and shows dimensions for the following formats :"+nl+
supportedFormats+"."+nl+
nl+
'  -f[f] pad "#### x ####" Width x Height dimensions using "0" instead of " "'+nl+
"        (-ff = no padding)"+nl+
"  -l    list all files (whether recognized or not)"+nl+
"  -ll   list files only if unrecognized format"+nl+
"  -lll  list files only if mismatch between extension and format"+nl+
"  -t    terse listing (-tl = -lt = -l -t)"+nl+
"  -b    batch-ready listing (-lllb = -blll = -lll -b)"+nl+
"  -#    list file only if one dimension is greater than specified screen size"+nl+
"        (320x[2]00  640x[4]80  800x[6]00  1024x[7]68  1280x[9]60  1600x[1]200)"+nl+
"  -s:#  list file only if filesize is greater than #"+nl+
"  -w:#  list file only if width is greater than # (-x:# = -w:#)"+nl+
"  -h:#  list file only if height is greater than # (-y:# = -h:#)"+nl+
"  -x?y  list file according to width compared to height"+nl+
"        (g = greater than, e = equal to, s = smaller than)"+nl+
"  -i[i] invert results for filter (-i = dimensions, -ii = filesize)"+nl+
"  -s    show filesize"+nl+
"  -z    ignore extensions not matching valid ones"+nl+
"        ("+validPicExtensions+")"+nl+
"  -c[z] show DIV 8 + delta values (-cz = show only if both deltas equal 0)"+nl+
"  -k[z] show DIV 2 + delta values (-kz = show only if both deltas equal 0)"+nl+
"  -d[?] show only deltas (-dc = -d -c, -dk = -d -k)"+nl+
"  -x    disable LFN support even if available"+nl+
nl+
"a) For obvious reasons, program will not try and analyze files matching"+nl+
"   "+specSWP+", "+specPAR+" and "+specPAGEFILE+" specifications."+nl+
"   Files matching "+specLST+", "+specRPT+" and "+specBAT+" will be skipped too."+nl+
"b) Dimensions formatting assumes both width and height are within [0..9999]."+nl+
"c) -b option requires -lll option and forces -t option."+nl+
"   Output should be redirected to a file with one of skipped extensions."+nl+
'   "'+extUNKNOWN+'" extension means file format was not recognized.'+nl+
"d) -s:# supports multiples of 1024 (Kb and Mb) and multiples of 1000 (K and M)."+nl+
"e) "+partialsupport+" support is limited : however unlikely,"+nl+
"   unexpected results may happen (especially with Adobe-generated files)."+nl+
"   MP4 files are not fully scanned : valid ones may not always be recognized."+nl;

VAR
    S  : str256; (* we may get a LFN *)
BEGIN
    CASE e OF
    | errHelp :
        WrStr(errmsg);
    | errUnknownOption:
        Str.Concat(S,"Unknown ",einfo);Str.Append(S," option !");
    | errTooManyParms:
        Str.Concat(S,einfo," is one parameter too many !");
    | errMissingSpec:
        S := "Missing <filespec> !";
    | errNotFound:
        Str.Concat(S,einfo," does not exist !");
    | errNotFile:
        Str.Concat(S,einfo," looks like a directory !");
    | errJokerPath:
        S := "Jokers are not allowed in path !";
    | errAborted:
        S := "Aborted by user !";
    | errNoMatch:
        S := "No file matches <filespec>";
    | errTooMany:
        S := "Storage.ALLOCATE() failure !"; (* or 65535 matches ! *)
        S := "Too many files !";
    | errFmt:
        S :="-f and -ff options are mutually exclusive !";
    | errScreen:
        S := "Screen dimensions defined more than once !";
    | errInverseDimensions:
        S := "-i option requires any of -#, -w:#, -x?y or -h:# options !";
    | errNonsense:
        Str.Concat(S,einfo," options are mutually exclusive !");
    | errValue:
        Str.Concat(S,"Illegal ",einfo);Str.Append(S," value !");
    | errDefaultOrUser:
        S := "-# option cannot be specified with any of -w:# or -h:# options !";
    | errBadExtRequired:
        S := "-b option is a nonsense without -lll option !";
    | errFsize:
        Str.Concat(S,"Illegal ",einfo);Str.Append(S," filesize !");
    | errInverseFsize:
        S := "-ii option requires -s:# option !";
    | errComp:
        S := "List mode cannot be specified more than once !";
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp :
        ;
    ELSE
        WrStr(progEXEname+" : ");WrStr(S);WrLn;
    END;
    Lib.SetReturnCode(SHORTCARD(e));
    HALT;
END abort;

(* ------------------------------------------------------------ *)

PROCEDURE wrq (tf:BOOLEAN;S:ARRAY OF CHAR   );
BEGIN
    IF tf THEN WrStr(doublequote);END;
    WrStr(S);
    IF tf THEN WrStr(doublequote);END;
END wrq;

PROCEDURE fmtbignum (v:LONGCARD; base:CARDINAL;wi:INTEGER; pad:CHAR ):str16;
VAR
    S:str16;
    ok:BOOLEAN;
    i : CARDINAL;
BEGIN
    Str.CardToStr( v, S, base,ok);
    FOR i:=Str.Length(S)+1 TO ABS(wi) DO
         IF wi < 0 THEN
             Str.Append(S,pad);
         ELSE
             Str.Prepend(S,pad);
         END;
    END;
    IF base=16 THEN Str.Lows(S);END;
    RETURN S;
END fmtbignum;

PROCEDURE fmtnum (v:CARDINAL; base:CARDINAL;wi:INTEGER; pad:CHAR ):str16;
BEGIN
    RETURN fmtbignum (LONGCARD(v), base,wi,pad);
END fmtnum;

PROCEDURE dwflip (v:LONGCARD):LONGCARD;
TYPE
    doubleword = RECORD (* boy, this is ugly... but effective ! *)
        CASE : BOOLEAN OF
        | TRUE:  n:LONGCARD;
        | FALSE: a,b,c,d:SHORTCARD;
        END;
    END;
VAR
    intel,motorola:doubleword;
BEGIN
    motorola.n:=v;
    intel.a := motorola.d;
    intel.b := motorola.c;
    intel.c := motorola.b;
    intel.d := motorola.a;
    RETURN intel.n;
END dwflip;

PROCEDURE wflip (v:CARDINAL):CARDINAL;
TYPE
    singleword = RECORD (* boy, this is ugly... but effective ! *)
        CASE : BOOLEAN OF
        | TRUE:  n:CARDINAL;
        | FALSE: a,b:SHORTCARD;
        END;
    END;
VAR
    intel,motorola:singleword;
BEGIN
    motorola.n:=v;
    intel.a := motorola.b;
    intel.b := motorola.a;
    RETURN intel.n;
END wflip;

PROCEDURE readByte (hin:FIO.File):BYTE;
VAR
    b:BYTE;
    got:CARDINAL;
BEGIN
    got:=FIO.RdBin(hin,b,SIZE(b));
    IF got # SIZE(b) THEN b:=0;END; (* ignore errors *)
    RETURN b;
END readByte;

PROCEDURE readWord (hin:FIO.File):WORD;
VAR
    w:WORD;
    got:CARDINAL;
BEGIN
    got:=FIO.RdBin(hin,w,SIZE(w));
    IF got # SIZE(w) THEN w:=0;END; (* ignore errors *)
    RETURN w;
END readWord;

PROCEDURE readDword (hin:FIO.File):LONGWORD;
VAR
    d:LONGWORD;
    got:CARDINAL;
BEGIN
    got:=FIO.RdBin(hin,d,SIZE(d));
    IF got # SIZE(d) THEN d:=0;END; (* ignore errors *)
    RETURN d;
END readDword;

(* ------------------------------------------------------------ *)

PROCEDURE chkJokerPath (spec:pathtype  ):BOOLEAN;
VAR
    S,u,d,n,e:pathtype;
BEGIN
    qdSplitAllPath(spec,u,d,n,e);
    Lib.MakeAllPath(S,u,d,"","");
    RETURN chkJoker(S);
END chkJokerPath;

(* Str.Match is not case sensitive *)

PROCEDURE isReservedPattern (S:ARRAY OF CHAR):BOOLEAN;
BEGIN
    IF Str.Match(S,specBAT) THEN RETURN TRUE; END;
    IF Str.Match(S,specLST) THEN RETURN TRUE; END;
    IF Str.Match(S,specRPT) THEN RETURN TRUE; END;
    IF Str.Match(S,specSWP) THEN RETURN TRUE; END;
    IF Str.Match(S,specPAR) THEN RETURN TRUE; END;
    RETURN Str.Match(S,specPAGEFILE);
END isReservedPattern;

PROCEDURE isReservedEntry (S : ARRAY OF CHAR) : BOOLEAN; (* assume uppercase *)
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    IF same(S,dotdot) THEN RETURN TRUE; END;
    RETURN isReservedPattern(S);
END isReservedEntry;

PROCEDURE isValidPicExt (S:ARRAY OF CHAR ):BOOLEAN;
VAR
    ext,spec:str16;
    i:CARDINAL;
BEGIN
    i:=0;
    LOOP
        isoleItemS(ext,validPicExtensions,coma,i);
        IF same(ext,"") THEN EXIT; END;
        Str.Concat(spec,star,ext);
        IF Str.Match(S,spec) THEN RETURN TRUE; END;
        INC(i);
    END;
    RETURN FALSE;
END isValidPicExt;

(* ------------------------------------------------------------ *)

CONST
    firstEntry = 1; (* 1..count *)
TYPE
    ptrToEntry = POINTER TO entryType;
    entryType = RECORD
        next   : ptrToEntry;
        slen   : CARDINAL; (* a SHORTCARD would do fine in almost all cases  *)
        string : CHAR;      (* here, after other data, because variable length *)
    END;

PROCEDURE store (VAR newInList,anchor:ptrToEntry; VAR lastEntry:CARDINAL;
                S:pathtype):BOOLEAN ;
VAR
    len,needed:CARDINAL;
    rc:BOOLEAN;
BEGIN
    INC(lastEntry);
    IF lastEntry=TOOMANY THEN RETURN FALSE;END; (* too many files but fake storage ALLOCATE failure here *)

    len:=Str.Length(S);
    needed:=SIZE(entryType)-SIZE(CHAR)+len;
    rc:= Available(needed);
    IF rc THEN
        CASE lastEntry OF
        | firstEntry :
            ALLOCATE( anchor,needed);
            newInList := anchor;
        ELSE
            ALLOCATE(newInList^.next,needed);
            newInList :=newInList^.next;
        END;
        Lib.FastMove( ADR(S),ADR(newInList^.string),len);
        newInList^.slen := len;
        newInList^.next := NIL;
    END;
    RETURN rc;
END store;

PROCEDURE buildMatchList (VAR anchor:ptrToEntry;
                          onlypicext,useLFN:BOOLEAN;spec:pathtype):CARDINAL;
VAR
    S,u,d,n,e,dirbase,filespec:pathtype; (* some are oversized but safety first ! *)
    newInList : ptrToEntry;
    lastEntry: CARDINAL;
    unicodeconversion:unicodeConversionFlagType;
    w9Xentry : findDataRecordType;
    w9Xhandle,errcode:CARDINAL;
    DOSentry     : FIO.DirEntry;
    rc,found,skipme:BOOLEAN;
    dosattr:FIO.FileAttr;
BEGIN
    qdSplitAllPath(spec,u,d,n,e);
    Lib.MakeAllPath(dirbase,u,d,"","");
    fixDirectory(dirbase);
    Lib.MakeAllPath(filespec,"","",n,e);

    lastEntry:=firstEntry-1;
    anchor:=NIL;

    IF useLFN THEN
        found := w9XfindFirst (spec,SHORTCARD(everything),SHORTCARD(w9XnothingRequired),
                              unicodeconversion,w9Xentry,w9Xhandle,errcode);
    ELSE
        found := FIO.ReadFirstEntry(spec,everything,DOSentry);
    END;
    WHILE found DO
        IF useLFN THEN
            Str.Copy(S,w9Xentry.fullfilename);
        ELSE
            Str.Copy(S,DOSentry.Name);
        END;
        skipme:=isReservedEntry(S); (* skip "." ".." "*.SWP" "*.PAR" *)
        IF NOT(skipme) THEN
            IF onlypicext THEN skipme:=NOT( isValidPicExt(S) ); END;
        END;
        IF NOT(skipme) THEN
            IF useLFN THEN
                dosattr:=FIO.FileAttr(w9Xentry.attr AND 0FFH);
            ELSE
                dosattr:=DOSentry.attr;
            END;
            IF NOT (aD IN dosattr) THEN
                Str.Prepend(S,dirbase);
                IF store(newInList,anchor,lastEntry,S)=FALSE THEN
                    IF useLFN THEN rc:=w9XfindClose(w9Xhandle,errcode); END;
                    RETURN TOOMANY; (* storage ALLOCATE failure or too many files *)
                END;
            END;
        END;
        IF useLFN THEN
            found :=w9XfindNext(w9Xhandle, unicodeconversion,w9Xentry,errcode);
        ELSE
            found :=FIO.ReadNextEntry(DOSentry);
        END;
    END;
    IF useLFN THEN rc:=w9XfindClose(w9Xhandle,errcode); END;
    RETURN lastEntry;
END buildMatchList;

PROCEDURE freeMatchList (anchor:ptrToEntry);
VAR
    len,needed      : CARDINAL;
    firstInList,newInList   : ptrToEntry;
BEGIN
    firstInList := anchor;
    newInList := firstInList;
    WHILE newInList # NIL DO
        len         := CARDINAL(newInList^.slen);
        needed      := SIZE(entryType)-SIZE(CHAR)+len;
        firstInList := firstInList^.next;
        DEALLOCATE (newInList,needed);
        newInList := firstInList;
    END
END freeMatchList;

PROCEDURE getMatchEntry (VAR R:pathtype;
                         n:CARDINAL; anchor:ptrToEntry);
VAR
    i,len:CARDINAL;
    newInList:ptrToEntry;
    S:pathtype;
BEGIN
    newInList := anchor;
    DEC(n); (* trick to force to anchor if 1, and locate correct string if > 1 *)
    FOR i:=firstEntry TO n DO
         newInList := newInList^.next;
    END;
    len         := newInList^.slen;
    Lib.FastMove( ADR(newInList^.string),ADR(S),len);
    S[len]      := nullchar; (* REQUIRED safety ! *)
    Str.Copy(R,S); (* yep, compiler won't let us fill R directly *)
END getMatchEntry;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    ioBufferSize      = (8 * 512) + FIO.BufferOverhead;
    firstioBufferByte = 1;
    lastioBufferByte  = ioBufferSize;
TYPE
    ioBufferType  = ARRAY [firstioBufferByte..lastioBufferByte] OF BYTE;
VAR
    ioBufferIn : ioBufferType;

(* ------------------------------------------------------------ *)

CONST
    idUNKNOWN = 0;
    idJPG     = 1;
    idGIF     = 2;
    idPNG     = 3;
    idPCX     = 4;
    idBMP     = 5;
    idDDS     = 6;
    idTGA     = 7;
    idAVI     = 8;
    idBIK     = 9;
    idMP4     = 10;
    idWEBP    = 11;
    (* //FIXFLV idFLV     = 12; *)
(*
TYPE
    JPGfalseHeaderType = RECORD
        mark : CARDINAL;            (* 2 $ff $?? *)
        mlen : CARDINAL;            (* 2 motorola, including mlen itself, >= $10 *)
        id:   ARRAY [0..3] OF CHAR; (* 4 "JFIF" or "Exif" *)
    END;
*)

TYPE
    GIFheaderType = RECORD
        sig:      ARRAY[0..5] OF CHAR;   (* 6 *)
        wi:       CARDINAL;              (* 2 *)
        he:       CARDINAL;              (* 2 *)
    END;

TYPE
    PNGheaderType = RECORD
        sig1:     ARRAY[0..6] OF CHAR;   (* 7 *)
        filler:   ARRAY[0..4] OF BYTE;   (* 5 *)
        sig2:     ARRAY[0..3] OF CHAR;   (* 4 *)
        wi:       LONGCARD;              (* 4 motorola *)
        he:       LONGCARD;              (* 4 motorola *)
    END;

TYPE
    PCXrgbType = RECORD
        red,green,blue:BYTE;
    END;
    (* (almost) useless fields are indented again *)

    PCXheaderType = RECORD
     manufacturer    : BYTE; (* constant 10=$0A=ZSoft *)
     version         : BYTE; (* constant 5=PC Paintbrush v3.0+ *)
     encoding        : BYTE; (* constant 1=RLE *)
    bitsPerPixel     : BYTE; (* 1, 2, 4 or 8, i.e. mono, 4, 16 OR 256 colors  *)
	                  (* window, i.e. image dimensions : xmin, ymin, xmax, ymax *)
    leftmargin       : WORD;
    uppermargin      : WORD;
    rightmargin      : WORD; (* do not use xmax-xmin ! *)
    lowermargin      : WORD;
     hDPIresolution  : WORD; (* put 300 for instance *)
     vDPIresolution  : WORD; (* idem *)
    colormap         : ARRAY[0..15] OF PCXrgbType;
     reserved1       : BYTE; (* must be 0 *)
    NCP              : BYTE; (* number of color planes, 1 or 4 *)
    NBS              : WORD; (* number of bytes per scanline, always even *)
                            (* from here, fields may contain rubbish *)
     paletteInfo     : WORD; (* 1=color or BW, 2=grayscale *)
     hscreensize     : WORD;
     vscreensize     : WORD;
     reserved2       : ARRAY[0..53] OF BYTE; (* must be 0 *)
    END;

TYPE
    BMPFileHeader = RECORD
        bfType 	     : ARRAY[0..1] OF CHAR; (* "BM" string *)
        bfSize 	     : LONGCARD;            (* file size in bytes *)
        bfReserved1  : CARDINAL;            (* must be set to 0 *)
        bfReserved2  : CARDINAL;            (* idem *)
        bfOffBits    : LONGCARD;            (* offset from this structure to the actual bitmap data in file *)
    END;
    BMPInfoHeader = RECORD
        biSize 	      : LONGCARD; (* size of this structure *)
        biWidth       : LONGINT;  (* # of pixels *)
        biHeight      : LONGINT;  (* # of pixels *)
        biPlanes      : CARDINAL; (* must be 1   *)
        biBitCount    : CARDINAL; (* bits per pixel (1=mono, 4=16 colors) *)
        biCompression : LONGCARD; (* 0=not compressed, 1=RLE8, 2=RLE4 *)
        (* from here, 0=default *)
        biSizeImage 	: LONGCARD; (* # of bytes in image (can be 0 if no compression) *)
        biXpelsPerMeter : LONGINT;  (* could be 0 *)
        biYpelsPerMeter : LONGINT;
        biClrUsed 	: LONGCARD; (* set to 0 to force use of all pallette *)
        biClrImportant 	: LONGCARD; (* 0=all colors are important *)
    END;
    BMPtotalHeaderType = RECORD (* assume following subheaders *)
       FILE:BMPFileHeader;
       INFO:BMPInfoHeader;
    END;

    TGAheaderType = RECORD
        info        : BYTE;
        colortyp    : BYTE;         (* 0,1 *)
        imagetyp    : BYTE;         (* 1,2,9,10 *)
        origin      : CARDINAL;
        colnumber   : CARDINAL;
        entrybits   : BYTE;         (* 16,24,32 *)
        xvalue      : CARDINAL;  (* lower left *)
        yvalue      : CARDINAL;  (* lower left *)
        width       : CARDINAL;
        height      : CARDINAL;
        pixelsize   : BYTE;         (* 8,16 or 16,24,32 *)
        descriptor  : BYTE;
    END;

    TYPE DDSheaderType = RECORD
        sig      : ARRAY[0..3] OF CHAR; (* "DDS " i.e. $44445320 *)
        (* now just enough of DDSURFACEDESC2 fields as to retrieve picdims *)
        dwSize   : LONGCARD; (* size of structure : always $7c (124) *)
        dwFlags  : LONGCARD;
        dwHeight : LONGCARD;
        dwWidth  : LONGCARD;
        (* we don't care of the rest *)
    END;

    (* out of lazyness, Q&D hypothesis from a few AVI files *)

    TYPE str4 = ARRAY[0..3] OF CHAR;

    TYPE AVIheaderType = RECORD
        idRIFF : str4;          (* "RIFF" *)
        myst1  : LONGCARD;
        idAVI  : str4;          (* "AVI " *)
        idLIST : str4;          (* "LIST" *)
        myst2  : LONGCARD;
        idHDRL : str4;          (* "hdrl" *)
        idAVIH : str4;          (* "avih" *)
        myst3  : ARRAY[1..9] OF LONGCARD;
        wi     : LONGCARD;
        he     : LONGCARD;
        myst4  : ARRAY[1..4] OF LONGCARD;
    END;

    TYPE BIKheaderType = RECORD
        idBIK   : str4; (* "BIK*" or "KB2" *)
        myst1   : ARRAY[1..4] OF LONGCARD;
        wi      : LONGCARD;
        he      : LONGCARD;
        myst2   : ARRAY[1..4] OF LONGCARD;
    END;

(* //FIXFLV
    CONST
         firstflvbuf = 0;
         lastflvbuf  = 2047-3-1;

    TYPE FLVheaderType = RECORD
       idFLV    : ARRAY[0..2] OF CHAR;
       ver      : BYTE; (* must be 1 *)
       buf      : ARRAY[firstflvbuf..lastflvbuf] OF BYTE;
       (* width,height,IEEE 64bits floats *)
    END;
*)

    (* //FIXME we should read more than a fixed SIZE header *)

    CONST
         mp4count = 4+4+4+2+2; (* see MP4headerType *)
         firstmp4buf = 0;
         lastmp4buf  = 511-mp4count; (* was 255 but safety *)

    TYPE MP4headerType = RECORD
        filler1 : LONGCARD;
        sFTYP   : str4;
        sDUMMY  : str4;
        filler2 : CARDINAL;
        version : CARDINAL;
        buf     : ARRAY[firstmp4buf..lastmp4buf] OF BYTE; (* should do *)
    END;

    (* //FIXME we should parse header *)

    TYPE WEBPheaderType = RECORD
        idRIFF   : str4; (* "RIFF" *)
        chunksize: LONGCARD;
        idWEBP   : str4; (* "WEBP" *)
        idVP8X   : str4; (* "VP8X" *)
        myst1    : LONGCARD;
        myst2    : LONGCARD;
        wi       : CARDINAL; (* add 1 *)
        wihi     : BYTE;
        he       : CARDINAL; (* add 1 *)
        hehi     : BYTE;
        (* ANIM *)
        (* ANMF *)
    END;

(* ------------------------------------------------------------ *)

CONST
    databufferlen = SIZE(MP4headerType); (* longest header was PCX *)
VAR
    databuffer : ARRAY[0..databufferlen-1] OF BYTE;

(* see jpeglib.h *)

CONST
    markJPEG  = 0FFH;
    markSOI   = 0D8H;
    markEOI   = 0D9H;
    markDQT   = 0DBH; (* adobe ? *)
    markSOF0  = 0C0H;
    markSOF1  = 0C1H;
    markSOF2  = 0C2H;
    markSOF3  = 0C3H;
    markCOM   = 0FEH;
    markAPP0  = 0E0H;
    markAPP1  = 0E1H;
    markAPP2  = 0E2H;
    markAPP13 = 0EDH; (* adobe ? *)

PROCEDURE friendlymarker ( b:BYTE  ):str16;
VAR
    R:str16;
BEGIN
    CASE CARDINAL(b) OF
    | markEOI    :R:="EOI";
    | markDQT    :R:="DQT";
    | markSOF0   :R:="SOF0";
    | markSOF1   :R:="SOF1";
    | markSOF2   :R:="SOF2";
    | markSOF3   :R:="SOF3";
    | markCOM    :R:="COM";
    | markAPP0   :R:="APP0";
    | markAPP1   :R:="APP1";
    | markAPP2   :R:="APP2";
    | markAPP13  :R:="APP13";
    ELSE
                  R:="???";
    END;
    RETURN R;
END friendlymarker;

(* far from perfect but we're fed up with this crappy header *)

PROCEDURE chkJPG (VAR x,y:LONGCARD; hin:FIO.File; DEBUG:BOOLEAN):BOOLEAN;
CONST
    maxretries = 10; (* maximum loop iteration : 10 should do *)
VAR
    retries,n,skiplen:CARDINAL;
    fsize,p:LONGCARD;
    b:BYTE;
    ok:BOOLEAN;
BEGIN
    fsize:=FIO.Size(hin);
    FIO.Seek(hin,0);
    b:=readByte(hin);
    IF CARDINAL(b) # markJPEG THEN RETURN FALSE;END;
    b:=readByte(hin);
    IF CARDINAL(b) # markSOI THEN RETURN FALSE;END;

    ok:=FALSE;
    retries:=0; (* safety *)
    LOOP
        INC(retries);
        IF retries > maxretries THEN EXIT; END;

        p:=FIO.GetPos(hin);
        b:=readByte(hin);
        IF CARDINAL(b) # markJPEG THEN EXIT; END;

        b:=readByte(hin);
IF DEBUG THEN
    WrStr("//    fpos    = $"); WrStr( fmtbignum(p+SIZE(b),16,8,"0"));
    WrStr("      marker  = $"); WrStr( fmtbignum ( LONGCARD(b), 16, 2, "0") );WrLn;
END;
        CASE CARDINAL(b) OF
        | markSOI  : (* $ffd8 should never happen here ! *)
            ;
        | markAPP0,markAPP1 : (* $ffe0 $ffe1 *)
            ; (* "JFIF" or "exif" *)
        | markAPP2 : (* $ffe2 *)
            ;
        | markAPP13: (* $ffed *)
            ;
        | markDQT  : (* $ffdb *)
            ;
        | markEOI: (* end of image *)
            EXIT;
        | markSOF0,markSOF1,markSOF2,markSOF3: (* start of frame *)
            n:=readWord(hin);
            b:=readByte(hin);
            n:=readWord(hin);
            y:=LONGCARD(wflip(n));
            n:=readWord(hin);
            x:=LONGCARD(wflip(n));
            ok:=TRUE;
            EXIT;
        | markCOM: (* comment *)
            ;
        ELSE
            ;
        END;
        n:=readWord(hin);
        skiplen:=wflip(n);
        INC(p, SIZE(n) );
        INC(p, LONGCARD(skiplen) );
IF DEBUG THEN
    WrStr("//    fpos    = $"); WrStr( fmtbignum(p,16,8,"0"));
    WrStr("      skiplen = $"); WrStr( fmtbignum ( LONGCARD(skiplen), 16, 2, "0") );WrLn;
END;
        IF p >= fsize THEN EXIT; END;
        FIO.Seek(hin,p);
    END;
    RETURN ok;
END chkJPG;

PROCEDURE chkGIF (VAR x,y:LONGCARD):BOOLEAN; (* ok *)
VAR
    h:GIFheaderType;
    ok:BOOLEAN;
BEGIN
    Lib.WordMove( ADR(databuffer), ADR(h), SIZE(h) DIV 2);
    ok:=FALSE;
    IF (same(h.sig,"GIF87a") OR same(h.sig,"GIF89a") ) THEN
        x:=LONGCARD (h.wi);
        y:=LONGCARD (h.he);
        ok:=TRUE;
    END;
    RETURN ok;
END chkGIF;

PROCEDURE chkPNG (VAR x,y:LONGCARD):BOOLEAN; (* ok *)
VAR
    h:PNGheaderType;
    ok:BOOLEAN;
BEGIN
    Lib.WordMove( ADR(databuffer), ADR(h), SIZE(h) DIV 2);
    ok:=FALSE;
    IF same(h.sig1,CHR(89H)+"PNG"+nl+ctrlZ) THEN
        IF same(h.sig2,"IHDR") THEN
            x:=dwflip(h.wi);
            y:=dwflip(h.he);
            ok:=TRUE;
        END;
    END;
    RETURN ok;
END chkPNG;

PROCEDURE chkPCX (VAR x,y:LONGCARD ):BOOLEAN;
CONST
    kTen = BYTE(0AH);
    kOne = BYTE(1);
    kZero= BYTE(0);
VAR
    h:PCXheaderType;
    ok:BOOLEAN;
BEGIN
    Lib.WordMove( ADR(databuffer), ADR(h), SIZE(h) DIV 2);
    ok:=FALSE;
    IF h.manufacturer = kTen THEN
        IF h.encoding = kOne THEN
            IF h.reserved1 = kZero THEN
                x:= LONGCARD(h.rightmargin-h.leftmargin)+1;
                y:= LONGCARD(h.lowermargin-h.uppermargin)+1;
                ok:=TRUE;
            END;
        END;
    END;
    RETURN ok;
END chkPCX;

PROCEDURE chkBMP (VAR x,y:LONGCARD ):BOOLEAN;
VAR
    h:BMPtotalHeaderType;
    ok:BOOLEAN;
BEGIN
    Lib.WordMove( ADR(databuffer), ADR(h), SIZE(h) DIV 2);
    ok:=FALSE;
    IF same(h.FILE.bfType,"BM") THEN
        IF h.FILE.bfReserved1 = 0 THEN
            IF h.FILE.bfReserved2 = 0 THEN
                x:=LONGCARD( h.INFO.biWidth );
                y:=LONGCARD( h.INFO.biHeight );
                ok:=TRUE;
            END;
        END;
    END;
    RETURN ok;
END chkBMP;

(* mere probability without guarantee *)

PROCEDURE chkTGA (VAR x,y:LONGCARD ):BOOLEAN;
VAR
    h:TGAheaderType;
    ok:BOOLEAN;
    n:CARDINAL;
BEGIN
    Lib.WordMove( ADR(databuffer), ADR(h), SIZE(h) DIV 2);
    n:=0;
    CASE CARDINAL( h.colortyp  ) OF
    | 0,1 : INC(n);
    END;
    CASE CARDINAL( h.imagetyp  ) OF
    | 1,2,9,10: INC(n);
    END;
    CASE CARDINAL( h.entrybits ) OF
    | 0,16,24,32 : INC(n);
    END;
    CASE CARDINAL( h.pixelsize ) OF (* checking 8,16,24,32 set would not work ! *)
    | 8, 16, 24, 32 : INC(n);
    END;
    ok:= (n = 4);
    IF ok THEN
        x:= LONGCARD(h.width);
        y:= LONGCARD(h.height);
    END;
    RETURN ok;
END chkTGA;

PROCEDURE chkDDS (VAR x,y:LONGCARD ):BOOLEAN;
CONST
    kStructSize = 124; (* $7c *)
VAR
    h:DDSheaderType;
    ok:BOOLEAN;
BEGIN
    Lib.WordMove( ADR(databuffer), ADR(h), SIZE(h) DIV 2);
    ok:=FALSE;
    IF (same(h.sig,"DDS ")) THEN
        IF h.dwSize = kStructSize THEN
            x:=h.dwHeight;
            y:=h.dwWidth;
            ok:=TRUE;
        END;
    END;
    RETURN ok;
END chkDDS;

PROCEDURE chkAVI (VAR x,y:LONGCARD):BOOLEAN;
VAR
    h:AVIheaderType;
    ok:BOOLEAN;
BEGIN
    Lib.WordMove( ADR(databuffer), ADR(h), SIZE(h) DIV 2);
    ok:=FALSE;
    IF (same(h.idRIFF,"RIFF")) THEN
        IF (same(h.idAVI,"AVI ")) THEN
            IF (same(h.idLIST,"LIST")) THEN
                IF(same(h.idHDRL,"hdrl")) THEN
                    IF(same(h.idAVIH,"avih")) THEN
                        x:=h.wi;
                        y:=h.he;
                        ok:=TRUE;
                    END;
                END;
            END;
        END;
    END;
    RETURN ok;
END chkAVI;

PROCEDURE chkBIK ( VAR x,y:LONGCARD  ):BOOLEAN;
VAR
    h:BIKheaderType;
    ok:BOOLEAN;
    Z:str4;
BEGIN
    Lib.WordMove( ADR(databuffer), ADR(h), SIZE(h) DIV 2);
    ok:=FALSE;

    Str.Slice(Z,h.idBIK,0,3);
    IF ( same(Z,"BIK") OR same(Z,"KB2") ) THEN
        x:=h.wi;
        y:=h.he;
        ok:=TRUE;
    END;
    RETURN ok;
END chkBIK;

(*

(* //FIXFLV *)

PROCEDURE flvdecodim(b1,b2:SHORTCARD):LONGCARD;
VAR
    hi1,hi2,lo1,mantissa:CARDINAL;
BEGIN
    hi1 := CARDINAL(b1) >> 4;
    hi2 := CARDINAL(b2) >> 4;
    lo1 := CARDINAL(b1) AND 0FH;
    mantissa := (lo1 << 4) OR hi2;
    RETURN LONGCARD( ((256 + mantissa) << hi1) >> 7 ); (* ok for height, almost never for width ! *)
END flvdecodim;

PROCEDURE chkFLV ( VAR x,y:LONGCARD  ):BOOLEAN;
VAR
    h:FLVheaderType;
    ok:BOOLEAN;
    Z:str4;
    id:str16;
    len,k,p,n,j:CARDINAL;
    b1,b2:SHORTCARD;
BEGIN
    Lib.WordMove( ADR(databuffer), ADR(h), SIZE(h) DIV 2);
    ok:=FALSE;

    x:=MAX(LONGCARD);y:=MAX(LONGCARD);

    Str.Copy(Z,h.idFLV);
    IF same(Z,"FLV") THEN
        IF CARDINAL( h.ver) = 1 THEN
            (* now find "width" and "height" THEN IEEE 64bits floats *)
            FOR k:=1 TO 2 DO
                CASE k OF
                |1 : id:="width";
                |2 : id:="height";
                END;
                len:=Str.Length(id);
                p:=firstflvbuf;
                LOOP
                    n:=0;
                    FOR j:=0 TO len-1 DO
                        IF CARDINAL(h.buf[p+j]) = ORD(id[j]) THEN INC(n);END;
                    END;
                    IF n = len THEN EXIT;END;
                    INC(p);
                    IF p > lastflvbuf THEN p:=MAX(CARDINAL); EXIT; END;
                END;
                IF p # MAX(CARDINAL) THEN
(*
WrStr(fmtnum (p+len+2,16,8,"0"));WrStr(" : ");
FOR j:=0 TO 7 DO WrStr(fmtnum(CARDINAL(h.buf[p+len+2+j]),16,2,"0"));WrStr(" ");END;WrLn;
*)
                    INC(p,len);
                    INC(p,2);
                    Lib.Move( ADR(h.buf[p]),ADR(b1), SIZE(b1));
                    Lib.Move( ADR(h.buf[p+1]),ADR(b2),SIZE(b2));
                    CASE k OF
                    |1 : x:=flvdecodim(b1,b2);
                    |2 : y:=flvdecodim(b1,b2);
                    END;
                END;
            END;
            IF (x # MAX(LONGCARD)) AND (y # MAX(LONGCARD) ) THEN ok:=TRUE;END;
        END;
    END;
    RETURN ok;
END chkFLV;

*)


(* hard-coded is UGLY because data was quickly reverse-engineered by hand :-( *)
(* I was too lazy to read file format specs or scan MP4 decoder code :-( *)

PROCEDURE chkMP4 (VAR x,y:LONGCARD):BOOLEAN;
CONST
    limit = lastmp4buf-78-4-4; (* offset to wi and he *)
    id    = "tkhd";
VAR
    h:MP4headerType;
    ok:BOOLEAN;
    p,j,n:CARDINAL;
    mark:str4;
    wi,he:LONGCARD;
BEGIN
    Lib.WordMove( ADR(databuffer), ADR(h), SIZE (h) DIV 2);
    ok:=FALSE;
    IF same(h.sFTYP, str4("ftyp")) THEN
        (* now find "tkhd" +78   "avc1" but bigger buffer needed *)
        p:=firstmp4buf;
        LOOP
            n:=0;
            FOR j:=0 TO 3 DO
                 IF CARDINAL(h.buf[p+j]) = ORD(id[j]) THEN INC(n);END;
            END;
            IF n = 4 THEN INC(p,78);EXIT;END; (* tkhd+78 *)
            INC(p);
            IF p > limit THEN p:=MAX(CARDINAL); EXIT; END;
        END;
        IF p # MAX(CARDINAL) THEN
            Lib.WordMove( ADR(h.buf[p]),ADR(wi), SIZE(wi) DIV 2);
            Lib.WordMove( ADR(h.buf[p+SIZE(LONGCARD)]),ADR(he),SIZE(he) DIV 2);
            x:=dwflip(wi) AND 00000FFFFH;
            y:=dwflip(he) AND 00000FFFFH;
            ok:=TRUE;
        END;
    END;
    RETURN ok;
END chkMP4;

PROCEDURE chkWEBP (VAR x,y:LONGCARD):BOOLEAN;
VAR
    h:WEBPheaderType;
    ok:BOOLEAN;
BEGIN
    Lib.WordMove( ADR(databuffer), ADR(h), SIZE (h) DIV 2);
    ok:=FALSE;
    IF (same(h.idRIFF,"RIFF")) THEN
        IF (same(h.idWEBP,"WEBP")) THEN
            IF (same(h.idVP8X,"VP8X")) THEN
                x:=LONGCARD(h.wi)+1;
                y:=LONGCARD(h.he)+1;
                ok:=TRUE;
            END;
        END;
    END;
    RETURN ok;
END chkWEBP;

(*
00000000 : 52 49 46 46   RIFF
           7e 37 04 00
           57 45 42 50   WEBP
           56 50 38 58   VP8X
00000010 : 0a 00 00 00
           12 00 00 00
           f1 01         wi
           00
           73 01         he
           00
           41 4e 49 4d   ANIM
           06 00 00 00
           00 00 00 ff
           00 00
           41 4e 4d 46   ANMF
00000030 : 68 3d 00 00
           00 00 00 00
           00 00
           f1 01         wi
           00
           73 01         he
           00
00000040 : 32 00 00 02
*)

(* ------------------------------------------------------------ *)

PROCEDURE fmtnewext (VAR S:pathtype;realext:str80);
VAR
    u,d,n,e:pathtype;
BEGIN
    qdSplitAllPath(S, u,d,n,e);
    Lib.MakeAllPath(S, "","",n,realext);
END fmtnewext;

CONST
    unsupportedextstr = "..."; (* was "???" *)

PROCEDURE idToExt (VAR Z:str80; id:CARDINAL );
BEGIN
    CASE id OF
    | idJPG: Z:="jpg";
    | idGIF: Z:="gif";
    | idPNG: Z:="png";
    | idPCX: Z:="pcx";
    | idBMP: Z:="bmp";
    | idDDS: Z:="dds";
    | idTGA: Z:="tga";
    | idAVI: Z:="avi";
    | idBIK: Z:="bik";
    | idMP4: Z:="mp4";
    | idWEBP:Z:="web"; (* "webp" *)
    (* //FIXFLV | idFLV: Z:="flv"; *)
    ELSE     Z:=unsupportedextstr;
    END;
END idToExt;

PROCEDURE chkIDext (VAR Z:str80;
                   id:CARDINAL;S:ARRAY OF CHAR ):BOOLEAN ;
VAR
    u,d,n,e:pathtype;
    i:CARDINAL;
    rc:BOOLEAN;
BEGIN
    qdSplitAllPath(S,u,d,n,e);
    Str.Caps(e);

    idToExt(Z, id);
    Str.Caps(Z);

    IF same(Z,unsupportedextstr) THEN RETURN FALSE;END;

    Str.Prepend(Z,dot);

    rc:=same(Z,e);
    IF NOT(rc) THEN (* ugly hack *)
        IF id=idJPG THEN
            rc:=same(".JPEG",e);
        ELSIF id=idWEBP THEN
            rc:=same(".WEBP",e);
        END;
    END;
    RETURN rc;
END chkIDext;

PROCEDURE handleExactModulo (clipmode,bothmodulo:BOOLEAN;
                            x,y,moduloclip:LONGCARD):BOOLEAN;
VAR
    ok:BOOLEAN;
BEGIN
    ok:=TRUE;
    IF clipmode THEN
        IF bothmodulo THEN
            ok:=( ( ( x MOD moduloclip)=0 ) AND ( ( y MOD moduloclip)= 0) );
        END;
    END;
    RETURN ok;
END handleExactModulo;

PROCEDURE fmtXY (VAR R:ARRAY OF CHAR;
                padchar:CHAR;padwi,moduloclip,id:CARDINAL;x,y,fsize:LONGCARD;
                onlydeltas,clipmode,showfsize:BOOLEAN);
CONST
    winormal = 2 + 4 + 3 + 4; (* "  #### x ####" *)
    wiclip   = winormal+2+2;  (* "  ####+# x ####+#" *)
    wifsize  = 10; (* #+###+###+### *)
    blanker  = "    "; (* "####" *)
VAR
    S : str128;
    Z : str80;
    wi,i:CARDINAL;
    xx,yy,dx,dy:LONGCARD;
BEGIN
    IF clipmode THEN
        dx:= x MOD LONGCARD(moduloclip); xx:=x - dx;
        dy:= y MOD LONGCARD(moduloclip); yy:=y - dy;
        wi:=wiclip;
    ELSE
        wi:=winormal;
    END;
    idToExt(Z, id);
    IF showfsize THEN
        Str.Prepend(Z,blank+blank);
        Str.Prepend(Z,fmtbignum(fsize,10,wifsize," "));
    END;
    IF id = idUNKNOWN THEN
        Str.Prepend(Z,"--- ");
        S:="";
    ELSE
        Str.Prepend(Z,"+++ ");
        IF clipmode THEN
            S:="~+! x ~+!";
            IF onlydeltas THEN
                Str.Subst(S,"~",blanker);
                Str.Subst(S,"~",blanker);
            ELSE
                Str.Subst(S,"~",fmtbignum(xx,10,padwi,padchar));
                Str.Subst(S,"~",fmtbignum(yy,10,padwi,padchar));
            END;
            IF dx = 0 THEN
                Str.Subst(S,"+!","  ");  (* "+!" *)
            ELSE
                Str.Subst(S,"!",fmtbignum(dx,10,1,""));
            END;
            IF dy = 0 THEN
                Str.Subst(S,"+!","  ");  (* "+!" *)
            ELSE
                Str.Subst(S,"!",fmtbignum(dy,10,1,""));
            END;
        ELSE
            S:="~ x ~";
            Str.Subst(S,"~",fmtbignum(x,10,padwi,padchar));
            Str.Subst(S,"~",fmtbignum(y,10,padwi,padchar));
        END;
    END;

    FOR i:=Str.Length(S)+1 TO wi DO
        Str.Prepend(S,blank);
    END;
    Str.Prepend(S,Z);
    Str.Append(S,blank+blank);
    Str.Copy(R,S);
END fmtXY;

CONST
   FZERO = 0; (* fsize flag *)
TYPE
    cmdType = (undefined,listpix,listall,listallbutpix,listbadext);
TYPE
    compType= (compNone,
              xGREATERthanVAL,yGREATERthanVAL,
              XorYgreater,
              xGREATERthanY,xEQUALtoY,xSMALLERthanY);

PROCEDURE showit (cmd:cmdType;compmode:compType;
                 useLFN,inversedimensions,inversefsize,terse,
                 onlydeltas,clipmode,bothmodulo,batchmode,showfsize,DEBUG:BOOLEAN;
                 padchar:CHAR;padwi,moduloclip,minW,minH:CARDINAL;
                 minfsize:LONGCARD;S:pathtype ):BOOLEAN;
CONST
    wanted = databufferlen;
VAR
    hin:FIO.File;
    got:CARDINAL;
    x,y:LONGCARD;
    id:CARDINAL;
    R:str128;
    goodext,okdim,oksize,okpic,showme:BOOLEAN;
    fsize,minX,minY:LONGCARD;
    realext : str80; (* really oversized *)
BEGIN
IF DEBUG THEN
    WrStr("// ");WrStr(S);WrLn;
END;
    minX:=LONGCARD(minW);
    minY:=LONGCARD(minH);

    showme := TRUE;

    hin:=fileOpenRead(useLFN,S);
    fsize:=FIO.Size(hin);
    Lib.WordFill( ADR(databuffer), databufferlen DIV 2, 00H); (* reset state *)
    got:=FIO.RdBin(hin,databuffer,wanted);

    IF chkJPG(x,y,hin,DEBUG) THEN (* should not be hard coded *)
        id:=idJPG;
    ELSIF chkGIF(x,y) THEN
        id:=idGIF;
    ELSIF chkPNG(x,y) THEN
        id:=idPNG;
    ELSIF chkPCX(x,y) THEN
        id:=idPCX;
    ELSIF chkBMP(x,y) THEN
        id:=idBMP;
    ELSIF chkDDS(x,y) THEN
        id:=idDDS;
    ELSIF chkTGA(x,y) THEN
        id:=idTGA;
    ELSIF chkAVI(x,y) THEN
        id:=idAVI;
    ELSIF chkBIK(x,y) THEN
        id:=idBIK;
    ELSIF chkMP4(x,y) THEN
        id:=idMP4;
    ELSIF chkWEBP(x,y) THEN
        id:=idWEBP;
(* //FIXFLV
    ELSIF chkFLV(x,y) THEN
        id:=idFLV;
*)
    ELSE
        id:=idUNKNOWN;
        x:=MAX(LONGCARD); (* force display *)
        y:=MAX(LONGCARD);
    END;
    fileClose(useLFN,hin);

    CASE compmode OF
    | compNone        : okdim:=TRUE;
    | xGREATERthanVAL : okdim:=(x > minX);
    | yGREATERthanVAL : okdim:=(y > minY);
    | XorYgreater     : okdim:=(x > minX) OR (y > minY);
    | xGREATERthanY   : okdim:=(x > y);
    | xEQUALtoY       : okdim:=(x = y);
    | xSMALLERthanY   : okdim:=(x < y);
    END;
    IF inversedimensions THEN okdim:=NOT(okdim);END;

    IF minfsize = FZERO THEN
        oksize := TRUE;
    ELSE
        oksize := (fsize > minfsize);
    END;
    IF inversefsize THEN oksize:=NOT(oksize);END;

    okpic := ( okdim AND oksize );

    CASE cmd OF
    | listpix:       showme := (id # idUNKNOWN); showme:=(showme AND okpic);
    | listall:       showme := okpic;
    | listallbutpix: showme := (id = idUNKNOWN);
    | listbadext:    goodext:=chkIDext(realext, id,S);
                     (* //V10V was : showme := (id # idUNKNOWN); showme:=(showme AND (NOT(goodext)) ); *)
                     showme := (id # idUNKNOWN);
                     IF showme THEN
                         showme := (showme AND (NOT(goodext)));
                     ELSE
                         showme := isValidPicExt (S);
                     END;
    END;

    showme := ( showme AND handleExactModulo(clipmode,bothmodulo,x,y,LONGCARD(moduloclip) ) );

    IF showme THEN
        fmtXY(R,padchar,padwi,moduloclip,id,x,y,fsize,onlydeltas,clipmode,showfsize);
        IF NOT (terse) THEN WrStr(R); END;
        IF cmd = listbadext THEN
            IF batchmode THEN
                WrStr("ren ");
                wrq(useLFN,S);
                WrStr(" ");
                IF id=idUNKNOWN THEN Str.Copy(realext,extUNKNOWN);END; (* //V10W *)
                fmtnewext(S,realext);
                wrq(useLFN,S);
            ELSE
                wrq(useLFN,S);
            END;
        ELSE
            wrq(useLFN,S);
        END;
        WrLn;
    END;
    RETURN showme;
END showit;

PROCEDURE showXY (VAR fcount:LONGCARD;
                 cmd:cmdType;compmode:compType;
                 useLFN,inversedimensions,inversefsize,terse,
                 onlydeltas,clipmode,bothmodulo,batchmode,showfsize,DEBUG:BOOLEAN;
                 padchar:CHAR;padwi,moduloclip,lastfile,minW,minH:CARDINAL;
                 minfsize:LONGCARD; anchor:ptrToEntry):BOOLEAN;
VAR
    S:pathtype;
    ismatch,flagAbort:BOOLEAN;
    i:CARDINAL;
BEGIN
    fcount:=0;
    flagAbort:=FALSE;
    i:=firstEntry-1;
    LOOP
        INC(i);
        IF i > lastfile THEN EXIT; END;
        getMatchEntry(S, i,anchor);
        ismatch:=showit (cmd,compmode,
                        useLFN,inversedimensions,inversefsize,terse,
                        onlydeltas,clipmode,bothmodulo,batchmode,showfsize,DEBUG,
                        padchar,padwi,moduloclip,minW,minH,minfsize,S);
        IF ismatch THEN INC(fcount);END;
        flagAbort:=ChkEscape();
        IF flagAbort THEN EXIT; END;
    END;
    RETURN flagAbort;
END showXY;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE getfsize (VAR v:LONGCARD;S:ARRAY OF CHAR   ):BOOLEAN ;
VAR
    ok:BOOLEAN;
    kmul:LONGCARD;
    i:CARDINAL;
    suffix:str16;
BEGIN
    i:=1-1;
    LOOP
        INC(i);
        IF i > 4 THEN kmul:=1; EXIT; END;
        CASE i OF
        | 1: suffix:="K"; kmul:=1000;
        | 2: suffix:="M"; kmul:=1000*1000;
        | 3: suffix:="KB";kmul:=1024;
        | 4: suffix:="MB";kmul:=1024*1024;
        END;
        Str.Prepend(suffix,"*");
        IF Str.Match(S,suffix) THEN
            i:=Str.Length(suffix);
            Str.Delete(S,Str.Length(S)-i+1,i);
            EXIT;
        END;
    END;
    ok:=GetLongCard(S,v);
    IF ok THEN v:=v*kmul; END;
    RETURN ok;
END getfsize;

PROCEDURE getcard (VAR v:CARDINAL; S:ARRAY OF CHAR):BOOLEAN;
VAR
    ok:BOOLEAN;
    lc:LONGCARD;
BEGIN
    ok:= GetLongCard(S,lc);
    IF ok THEN
        ok:= ( lc <= MAX(CARDINAL) );
        IF ok THEN v:=CARDINAL(lc); END;
    END;
    RETURN ok;
END getcard;

PROCEDURE newcmd (VAR cmd:cmdType;wanted:cmdType ):BOOLEAN;
VAR
    rc:BOOLEAN;
BEGIN
    rc:= ( (cmd = undefined) OR (cmd = wanted) );
    IF rc THEN cmd:=wanted;END;
    RETURN rc;
END newcmd;

PROCEDURE dmpme (terse,addnl:BOOLEAN;S:ARRAY OF CHAR   );
BEGIN
    IF NOT(terse) THEN
        WrStr(S);WrLn;
        IF addnl THEN WrLn;END;
    END;
END dmpme;

PROCEDURE newcompmode (VAR compmode:compType;wanted:compType  ):BOOLEAN;
VAR
    ok:BOOLEAN;
BEGIN
    ok:=TRUE;
    IF compmode = compNone THEN
        compmode := wanted;
    ELSIF compmode = wanted THEN
        compmode := wanted; (* ah ah ! *)
    ELSE
        ok:=FALSE;
    END;
    RETURN ok;
END newcompmode;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    msgListMode         = "::: List mode         : ~";
    msgDimensionsFilter = "::: Dimensions filter : ~";
    msgFilesizeFilter   = "::: Filesize filter   : ~";
    msgMatchesFound     = "::: Matches found     : ~";
CONST
    firstparm = 1;
    maxparm   = 1;
VAR
    parmcount,i,opt,lastparm:CARDINAL;
    S,R,spec:pathtype;
    showfsize,terse,inversedimensions,inversefsize:BOOLEAN;
    onlypicext,clipmode,bothmodulo,batchmode,onlydeltas,useLFN:BOOLEAN;
    DEBUG:BOOLEAN;
    parm:ARRAY [firstparm..maxparm] OF pathtype;
    anchor:ptrToEntry;
    alcatraz:BOOLEAN;
    lastfile:CARDINAL;
    fmtxy:(unset,rawxy,useblank,usezero);
    moduloclip,padwi:CARDINAL;
    padchar:CHAR;
    redef,redefusr, minW , minH : CARDINAL;
    XY:str16;
    fcount:LONGCARD; (* a CARDINAL would probably do, eh eh *)
    msgN,msgI:str128;
    cmd:cmdType;
    minfsize:LONGCARD;
    compmode:compType;
BEGIN
    Lib.DisableBreakCheck();
    FIO.IOcheck := FALSE; (* don't let topspeed handle problems *)
    WrLn;

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,"");END;

    lastparm    := firstparm-1;
    fmtxy       := unset;
    useLFN      := TRUE;
    compmode    := compNone;
    minW        := 0;
    minH        := 0;
    inversedimensions := FALSE;
    inversefsize:= FALSE;
    onlypicext  := FALSE;
    terse       := FALSE;
    redef       := 0;
    redefusr    := 0;
    clipmode    := FALSE;
    bothmodulo  := FALSE;
    batchmode   := FALSE;
    cmd         := undefined;
    minfsize    := FZERO;
    showfsize   := FALSE;
    onlydeltas  := FALSE;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R, "?"+delim+"H"+delim+"HELP"+delim+
                                  "X"+delim+"LFN"+delim+
                                  "L"+delim+"LIST"+delim+"ALL"+delim+
                                  "F"+delim+"BLANK"+delim+
                                  "FF"+delim+"ZERO"+delim+
                                  "I"+delim+"INVERSE"+delim+
                                  "2"+delim+"320X200"+delim+"320*200"+delim+"200"+delim+
                                  "4"+delim+"640X480"+delim+"640*480"+delim+"480"+delim+
                                  "6"+delim+"800X600"+delim+"800*600"+delim+"600"+delim+
                                  "7"+delim+"1024X768"+delim+"1024*768"+delim+"768"+delim+
                                  "9"+delim+"1280X960"+delim+"1280*960"+delim+"960"+delim+
                                  "1"+delim+"1600X1200"+delim+"1600*1200"+delim+"1200"+delim+
                                  "LL"+delim+
                                  "Z"+delim+"PICTURES"+delim+
                                  "T"+delim+"TERSE"+delim+
                                  "LT"+delim+"TL"+delim+
                                  "W:"+delim+"X:"+delim+
                                  "H:"+delim+"Y:"+delim+
                                  "LLL"+delim+"BADEXT"+delim+
                                  "C"+delim+"CLIP8"+delim+
                                  "B"+delim+"BATCH"+delim+
                                  "LLLB"+delim+"BLLL"+delim+
                                  "S:"+delim+"SIZE:"+delim+"FILESIZE:"+delim+
                                  "S"+delim+"SHOWSIZE"+delim+
                                  "II"+delim+"IS"+delim+
                                  "CZ"+delim+
                                  "K"+delim+"KLIP4"+delim+
                                  "KZ"+delim+
                                  "XGY"+delim+"WGH"+delim+"ITALIAN"+delim+
                                  "XEY"+delim+"WEH"+delim+"SQUARE"+delim+
                                  "XSY"+delim+"WSH"+delim+"PORTRAIT"+delim+
                                  "D"+delim+"DELTAS"+delim+
                                  "DC"+delim+"CC"+delim+
                                  "DK"+delim+"KK"+delim+
                                  "DEBUG"
                              );

            CASE opt OF
            | 1,2,3 : abort(errHelp,"");
            | 4,5:    useLFN     := FALSE;
            | 6,7,8:  IF newcmd(cmd,listall)=FALSE THEN
                          abort(errNonsense,"-l, -ll and -lll");
                      END;
            | 9,10:   CASE fmtxy OF
                      | unset,usezero: fmtxy:=usezero;
                      ELSE            abort(errFmt,"");
                      END;
            |11,12:   CASE fmtxy OF
                      | unset,rawxy:  fmtxy:=rawxy;
                      ELSE            abort(errFmt,"");
                      END;
            |13,14  : inversedimensions:=TRUE;
            |15..18 : minW:=320;  minH:=200;
                      IF newcompmode(compmode,XorYgreater)=FALSE THEN abort(errComp,"");END;
                      INC(redef);
            |19..22 : minW:=640;  minH:=480;
                      IF newcompmode(compmode,XorYgreater)=FALSE THEN abort(errComp,"");END;
                      INC(redef);
            |23..26 : minW:=800;  minH:=600;
                      IF newcompmode(compmode,XorYgreater)=FALSE THEN abort(errComp,"");END;
                      INC(redef);
            |27..30 : minW:=1024; minH:=768;
                      IF newcompmode(compmode,XorYgreater)=FALSE THEN abort(errComp,"");END;
                      INC(redef);
            |31..34 : minW:=1280; minH:=960;
                      IF newcompmode(compmode,XorYgreater)=FALSE THEN abort(errComp,"");END;
                      INC(redef);
            |35..38 : minW:=1600; minH:=1200;
                      IF newcompmode(compmode,XorYgreater)=FALSE THEN abort(errComp,"");END;
                      INC(redef);
            |39:      IF newcmd(cmd,listallbutpix)=FALSE THEN
                          abort(errNonsense,"-l, -ll and -lll");
                      END;
            |40,41:   onlypicext     := TRUE;
            |42,43:   terse          := TRUE;
            |44,45:   IF newcmd(cmd,listall)=FALSE THEN
                          abort(errNonsense,"-l, -ll and -lll");
                      END;
                      terse          := TRUE;
            |46,47:   IF getcard(minW,R)=FALSE THEN abort(errValue,S);END;
                      IF newcompmode(compmode, xGREATERthanVAL)=FALSE THEN abort(errComp,"");END;
                      INC(redefusr);
            |48,49:   IF getcard(minH,R)=FALSE THEN abort(errValue,S);END;
                      IF newcompmode(compmode, yGREATERthanVAL)=FALSE THEN abort(errComp,"");END;
                       INC(redefusr);
            |50,51:   IF newcmd(cmd,listbadext)=FALSE THEN
                          abort(errNonsense,"-l, -ll and -lll");
                      END;
            |52,53:   clipmode       := TRUE; moduloclip:=8;
            |54,55:   batchmode      := TRUE;
            |56,57:   IF newcmd(cmd,listbadext)=FALSE THEN
                          abort(errNonsense,"-l, -ll and -lll");
                      END;
                      batchmode      := TRUE;
            |58,59,60:IF getfsize(minfsize,R)=FALSE THEN abort(errFsize,S);END;
                      INC(redefusr);
            |61,62:   showfsize:=TRUE;
            |63,64:   inversefsize:=TRUE;
            |65:      clipmode       := TRUE; moduloclip:=8;
                      bothmodulo     := TRUE;
            |66,67:   clipmode       := TRUE; moduloclip:=2;
            |68:      clipmode       := TRUE; moduloclip:=2;
                      bothmodulo     := TRUE;
            |69,70,71:IF newcompmode(compmode, xGREATERthanY)=FALSE THEN abort(errComp,"");END;
                      INC(redefusr);
            |72,73,74:IF newcompmode(compmode, xEQUALtoY)=FALSE THEN abort(errComp,"");END;
                      INC(redefusr);
            |75,76,77:IF newcompmode(compmode, xSMALLERthanY)=FALSE THEN abort(errComp,"");END;
                      INC(redefusr);
            |78,79:   onlydeltas     := TRUE;
            |80,81:   onlydeltas     := TRUE;
                      clipmode       := TRUE; moduloclip:=8;
            |82,83:   onlydeltas     := TRUE;
                      clipmode       := TRUE; moduloclip:=2; (* was 4 *)
            |84:      DEBUG          := TRUE;
            ELSE
                abort(errUnknownOption,S);
            END;
        ELSE
            INC(lastparm);
            IF lastparm > maxparm THEN abort(errTooManyParms,S);END;
            Str.Copy(parm[lastparm],S); (* keep case *)
        END;
    END;
    IF lastparm < firstparm THEN abort(errMissingSpec,"");END;

    IF ( (redef # 0) AND (redefusr # 0) ) THEN abort(errDefaultOrUser,"");END;

    IF cmd = undefined THEN cmd:=listpix;END;

    CASE cmd OF
    | listpix,listall : ;
    | listallbutpix,listbadext:
        IF inversedimensions      THEN abort(errNonsense,"-ll[l] and -i");END;
        IF inversefsize           THEN abort(errNonsense,"-ll[l] and -ii");END;
        IF redef # 0              THEN abort(errNonsense,"-ll[l] and -#");END;
        IF redefusr # 0           THEN abort(errNonsense,"-ll[l] and any of -w:#, -h:#, x?y:# or -s:#");END;
    END;

    CASE cmd OF
    | listbadext:
        IF batchmode THEN terse:=TRUE;END;
    ELSE
        IF batchmode THEN abort(errBadExtRequired,"");END;
    END;

    CASE redef OF
    | 0 : ; (* no -# *)
    | 1 : ; (* one -# *)
    ELSE
        abort(errScreen,"");
    END;

    IF inversedimensions THEN
        IF ( (redef = 0) AND (redefusr = 0) ) THEN abort(errInverseDimensions,"");END;
    END;

    IF inversefsize THEN
        IF ( (redef = 0) AND (redefusr = 0) ) THEN abort(errInverseFsize,"");END;
    END;

    useLFN:=( useLFN AND w9XsupportLFN() );
    IF useLFN=FALSE THEN
        FOR i:=firstparm TO lastparm DO
            UpperCase( parm[i] );        (* //FIXME keep accents ? *)
        END;
    END;
    Str.Copy(spec,parm[firstparm]);

    IF same(spec,dot) THEN Str.Copy(spec,stardotstar); END;
    IF same(spec,star) THEN Str.Copy(spec,stardotstar);END;
    IF same(spec,stardotstar)=FALSE THEN
        IF fileIsDirectorySpec(useLFN,spec) THEN
            fixDirectory(spec);
            Str.Append(spec,stardotstar);
        END;
    END;
    IF chkJokerPath (spec) THEN abort(errJokerPath,spec);END;

    lastfile:=buildMatchList (anchor, onlypicext,useLFN,spec);
    CASE lastfile OF
    | firstEntry-1: freeMatchList(anchor); abort(errNoMatch,S);
    | TOOMANY:      freeMatchList(anchor); abort(errTooMany,S);
    END;
    IF fmtxy = unset THEN fmtxy:=useblank;END;
    CASE fmtxy OF
    | rawxy    : padwi:=1; padchar:="";
    | useblank : padwi:=4; padchar:=" ";
    | usezero  : padwi:=4; padchar:="0";
    END;

    S:=msgListMode;
    CASE cmd OF
    | listpix:       R:="recognized files";
    | listall:       R:="all files";
    | listallbutpix: R:="unrecognized files";
    | listbadext:    R:="files if mismatch between extension and format";
    END;
    IF onlypicext THEN Str.Append(R," (valid picture extensions only)");END;
    Str.Subst(S,"~",R);
    dmpme(terse,FALSE,S);

    XY:="";
    CASE compmode OF
    | compNone        : XY:="no";
    | xGREATERthanVAL : XY:="~";
                        msgN:="width greater than ";
                        msgI:="width smaller or equal to ";
    | yGREATERthanVAL : XY:="|";
                        msgN:="height greater than ";
                        msgI:="height smaller or equal to ";
    | XorYgreater     : XY:="~x|";
                        msgN:="one dimension greater than ";
                        msgI:="dimensions smaller or equal to ";
    | xGREATERthanY   : msgN:="width greater than height";
                        msgI:="width smaller than, or equal to, height";
    | xEQUALtoY       : msgN:="width equal to height";
                        msgI:="width different from height";
    | xSMALLERthanY   : msgN:="width smaller than height";
                        msgI:="width equal to, or greater than, height";
    END;
    Str.Subst( XY,"~",fmtnum(minW,10,1,"") );
    Str.Subst( XY,"|",fmtnum(minH,10,1,"") );

    S:=msgDimensionsFilter;
    CASE cmd OF
    | listallbutpix,listbadext:
        R:="not applicable";
    ELSE
        CASE compmode OF
        | compNone:
            R:="no";
        ELSE
            IF inversedimensions THEN
                Str.Concat(R,msgI,XY);
            ELSE
                Str.Concat(R,msgN,XY);
            END;
        END;
    END;
    Str.Subst(S,"~",R);
    dmpme(terse,FALSE,S);

    IF minfsize = FZERO THEN
        XY:="no";
    ELSE
        XY:="|";
        msgN:="filesize greater than ";
        msgI:="filesize smaller or equal to ";
    END;
    Str.Subst( XY,"|",fmtbignum(minfsize,10,1,"") );

    S:=msgFilesizeFilter;
    CASE cmd OF
    | listallbutpix,listbadext:
        R:="not applicable";
    ELSE
        IF minfsize = FZERO THEN
            R:="no";
        ELSE
            IF inversefsize THEN
                Str.Concat(R,msgI,XY);
            ELSE
                Str.Concat(R,msgN,XY);
            END;
        END;
    END;
    Str.Subst(S,"~",R);
    dmpme(terse,TRUE,S);

    (* //FIXME possibly insert here message about clipmode and modulo *)

    alcatraz:=showXY (fcount,cmd,compmode,
                     useLFN,inversedimensions,inversefsize,terse,
                     onlydeltas,clipmode,bothmodulo,batchmode,showfsize,DEBUG,
                     padchar,padwi,moduloclip,lastfile,minW,minH,minfsize,anchor);
    freeMatchList(anchor);

    IF alcatraz THEN abort(errAborted,"");END;

    S:=msgMatchesFound;
    Str.Subst(S,"~",fmtbignum(fcount,10,1,""));
    IF NOT(terse) THEN
        IF fcount # 0 THEN WrLn;END;
    END;
    dmpme(terse,FALSE,S);

    abort(errNone,"");
END picDimS.



