(* ---------------------------------------------------------------
Title         see help
Overview      see help
Usage         see help
Notes         very, very, very quick & dirty... :-(
              minimal error messages and checking, etc.
              darn... check if texts contain digits just in case !
Bugs
Wish List

--------------------------------------------------------------- *)

MODULE prepHIDN;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT SYSTEM;
IMPORT IO;

FROM QD_ASCII IMPORT dash, slash, nullchar, tabchar, cr, lf, nl, bs,
space, dot, deg, doublequote, quote, colon, percent, vbar,
blank, equal, dquote, charnull, singlequote, antislash, dollar,
star, backslash, coma, question, underscore, tabul, hbar,
comma, semicolon, diese, pound, openbracket, closebracket, tilde, exclam,
stardotstar, dotdot, escCh, escSet, letters, digits,
lettersUpp, lettersLow, openbrace, closebrace;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory, qdSplitAllPath,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite, setReadOnly,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs, UpperCaseAlt, LowerCaseAlt,
completedInit, completedShow, completedSHOW, completedEnd, completed,
removeDups, isValidHDunit, removePhantoms, removeFloppies,
getCDROMunits, getCDROMletters, removeCDROMs, getAllHDunits,
getAllLegalUnits, metaproc, getCli, argc, argv;

FROM IO IMPORT WrStr, WrLn;

(* ------------------------------------------------------------ *)

CONST
    progPREPROC     = "PREPHIDN";
    progREVEAL      = "FINDHIDN";
    progSHOW        = "SHOWHIDN";
CONST
    progEXEname     = progPREPROC;
    progTitle       = 'Q&D "Hidden" words preprocessor';
    progVersion     = "v1.0c";
    progCopyright   = "by PhG";
    banner          = progTitle+" "+progVersion+" "+progCopyright;

CONST
    extTXT          = ".TXT";
    extNEW          = ".NEW";
    extLAT          = ".LAT";
    extFRA          = ".FRA";
    extKJB          = ".KJB";
    extCOR          = ".COR";
    upperAE         = CHR(146);
    lowerAE         = CHR(145);
CONST
    errNone         = 0;
    errHelp         = 1;
    errOption       = 2;
    errParmOverflow = 3;
    errNotFound     = 4;
    errTooMany      = 5;
    errMissingSource= 6;
    errMissingHeader= 7;
    errHeader       = 8;
    errAborted      = 255;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)

errmsg =
banner+nl+
nl+
"Syntax : "+progEXEname+" <file["+extTXT+"]> <-n|-l|-f|-e> [-o] [-v]"+nl+
nl+
"This program processes a Bible DOS ASCII file for later use"+nl+
"by these two companion (un)utilities : "+progREVEAL+" and "+progSHOW+"."+nl+
"The three programs have been written in order to confirm"+nl+
'the nonsense of "hidden" words in the Bible or in any long text.'+nl+
"Note -k option expects a filtered Kasimirski French Alcoran file."+nl+
nl+
"Here are processing steps : 1) each character is converted to lowercase"+nl+
'ignoring accents and diacritical signs ; 2) each "'+lowerAE+'" is expanded to "ae" ;'+nl+
'3) each "*#:#" verset header pattern is removed ("#" being any number) ;'+nl+
"4) each character not belonging to the [a..z] set is filtered out."+nl+
nl+
"Note processed files are no longer human readable."+nl+
nl+
"    -n    create "+extNEW+" from a normal file (no verset header to remove)"+nl+
"    -l    create "+extLAT+' from a Latin Bible file ("#:#" header)'+nl+
"    -f    create "+extFRA+' from a French Bible file ("#:# "header)'+nl+
"    -e    create "+extKJB+' from an English Bible file ("*#:#" header)'+nl+
"    -k    create "+extCOR+' from Kasimirski French Alcoran file ("#. " header)'+nl+
"    -o[o] overwrite existing target (-oo = overwrite read-only target)"+nl+
"    -v    verbose"+nl+
"    -sa   do not sort filenames alphabetically"+nl+
nl+
"Examples : "+progEXEname+" GENESIS -l -o"+nl+
"           "+progEXEname+" JOKES*.TXT -n -o -v"+nl;

VAR
    S : str256;
BEGIN
    CASE e OF
    | errHelp :
        WrStr(errmsg);
    | errOption:
        S:="Unknown ~ option !";
    | errParmOverflow:
        S:="~ is one parameter too many !";
    | errNotFound:
        S:="No file matches ~ specification !";
    | errTooMany:
        S:="Too many files match ~ specification !";
    | errMissingSource:
        S := "Missing <file["+extTXT+"]> specification !";
    | errMissingHeader:
        S := "Missing <-n|-l|-f|-e> header specification !";
    | errHeader:
        S := "-n, -l, -f, -e and -k options are mutually exclusive !";
    | errAborted:
        S := "Aborted by user !";
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp: ;
    ELSE
        Str.Subst(S,"~",einfo);
        WrStr(progEXEname+" : ");WrStr(S);WrLn;
    END;
    Lib.SetReturnCode(SHORTCARD(e));
    HALT;
END abort;

(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBuffer  = ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
VAR
    bufferIn  : ioBuffer;
    bufferOut : ioBuffer;

(* ------------------------------------------------------------ *)

PROCEDURE isDigit (c:CHAR):BOOLEAN;
BEGIN
    RETURN Belongs(digits,c);
END isDigit;

(*
    check if source s$ and pattern fmt$ match together
    #=any number, ?=any char, [..]=one char from this charset, else exact
    if # or ? needed, use [#] or [?]

    yes, yes, we should have  "*" joker but we don' need it for now
*)

PROCEDURE MatchFormat (fmt,S:ARRAY OF CHAR  ) : BOOLEAN;
CONST
    setBegin = "[";
    setEnd   = "]";
    Number   = "#";
    anyChar  = "?";
VAR
    wasdigit : BOOLEAN;
    p        : CARDINAL;
    maxp     : CARDINAL;
    currchar : CHAR;
    i        : CARDINAL;
    maxi     : CARDINAL;
    currfmt  : CHAR;
    pclose   : CARDINAL;
    charset  : str128;
BEGIN
    IF same(S,"") THEN RETURN FALSE; END;
    IF same(fmt,"") THEN RETURN FALSE; END;
    IF CharCount(fmt,setBegin) # CharCount(fmt,setEnd) THEN RETURN FALSE; END;
    (* Q&D checks are done now... *)
    p        := 0;                (* index in source S *)
    maxp     := Str.Length(S)-1;
    wasdigit := FALSE;            (* flag for # pattern *)
    i        := 0;                (* index in pattern fmt *)
    maxi     := Str.Length(fmt)-1;
    LOOP
        currchar := S[p];
        currfmt  := fmt[i];
        CASE currfmt OF
        | anyChar :               (* any char so advance both pointers *)
            INC(i);
            INC(p);
        | Number :                (* any number *)
            CASE isDigit(currchar) OF
            | TRUE :
                wasdigit := TRUE;
                INC(p); (* advance only in source S *)
                IF p > maxp THEN (* if a digit was last char of source S... *)
                    INC(i);      (* ... then advance in fmt, just in case *)
                END;
            | FALSE :
                IF wasdigit=FALSE THEN RETURN FALSE; END; (* no digit at all *)
                wasdigit:=FALSE; (* reset flag *)
                INC (i); (* advance only in pattern fmt and keep new nondigit *)
            END;
        | setBegin : (* any char in charset [..] *)
            pclose:=Str.NextPos(fmt,setEnd,i+1);
            Str.Slice(charset,fmt,i+1,pclose-(i+1) );
            IF Str.CharPos(charset,currchar)=MAX(CARDINAL) THEN RETURN FALSE; END;
            i:=pclose+1;
            INC(p);
        ELSE (* exact *)
            IF currchar # currfmt THEN RETURN FALSE; END;
            INC (i); (* advance both pointers *)
            INC (p);
        END;
        IF (i > maxi) AND (p > maxp) THEN EXIT; END; (* all is ok, S and fmt match *)
        IF (i > maxi) OR (p > maxp) THEN RETURN FALSE; END; (* chars left in either S or fmt *)
    END;
    RETURN TRUE;
END MatchFormat;

(* ------------------------------------------------------------ *)

(* "ae" and "" already taken care OF *)

PROCEDURE onlyalpha (VAR S : ARRAY OF CHAR);
VAR
    R     : str4096; (* should be enough ! *)
    i,len : CARDINAL;
    c : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;
    Str.Copy(R,"");
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        IF Belongs(lettersLow,c) THEN Str.Append(R,c);END;
    END;
    Str.Copy(S,R);
END onlyalpha;

TYPE
    headerkindtype = (undefined,
                     noheader,
                     vulgateheader,kingjamesheader,frenchheader,
                     kasimirskiheader);

PROCEDURE process (headerkind:headerkindtype; verbose:BOOLEAN;
                   source,target:ARRAY OF CHAR );
VAR
    hin,hout : FIO.File;
    S,R      : str4096;
    header,header2   : str128; (* oversized *)
    dmp:BOOLEAN;
BEGIN
    IF verbose THEN Work(cmdInit); END;

    hin := FIO.OpenRead(source);
    FIO.AssignBuffer(hin,bufferIn);
    hout:= FIO.Create(target);
    FIO.AssignBuffer(hout,bufferOut);

    FIO.EOF:=FALSE;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        IF verbose THEN Work(cmdShow); END;
        FIO.RdStr(hin,S);
        IF FIO.EOF THEN EXIT; END;
        dmp:=TRUE;
        LowerCase(S);
        FixAE(S); (* this procedure handles lowercase only *)
        ReplaceChar(S,"","c"); (* french *)

        CASE headerkind OF
        | noheader : ;
        | vulgateheader,frenchheader :
            argv(header, S,1,TRUE);
            IF MatchFormat("#:#",header) THEN
                Str.Subst(S,header,""); (* useless because would be done infra *)
            END;
        | kingjamesheader:
            argv(header, S,1,TRUE);
            IF MatchFormat("#:#",header) THEN
                Str.Subst(S,header,"");
            ELSIF MatchFormat("?#:#",header) THEN   (* "*#:#" *)
                Str.Subst(S,header,"");
            ELSE
                argv(header2, S,2,TRUE);
                IF MatchFormat("#:#",header2) THEN  (* "* #:#" *)
                    Str.Subst(S,header,"");
                    Str.Subst(S,header2,"");
                END;
            END;
        | kasimirskiheader:
            argv(header, S,1,TRUE);
            IF MatchFormat("#.",header) THEN
                Str.Subst(S,header,"");
                dmp:=TRUE;
            ELSE
                S:="";
                dmp:=FALSE;
            END;
        END;
        onlyalpha(S);

        IF dmp THEN FIO.WrStr(hout,S); END;
    END;

    FIO.Flush(hout);
    FIO.Close(hout);
    FIO.Close(hin);

    IF verbose THEN Work(cmdStop); END;
END process;

(* ------------------------------------------------------------ *)

TYPE
    f8e3 = ARRAY [0..8+1+3-1] OF CHAR;
CONST
    firstFile = 1;
    lastFile  = 2000;
    maxFile   = lastFile-firstFile+1;
VAR
    fileArray : ARRAY [firstFile..lastFile] OF f8e3;

PROCEDURE buildList (VAR basepath:ARRAY OF CHAR;
                    spec:ARRAY OF CHAR):CARDINAL;
VAR
    countFile : CARDINAL;
    found     : BOOLEAN;
    entry     : FIO.DirEntry;
    u,path,f8,e3    : str128; (* oversized just in case *)
BEGIN
    qdSplitAllPath(spec,u,path,f8,e3);
    Str.Concat(basepath,u,path);

    countFile := 0;
    found := FIO.ReadFirstEntry(spec,allfiles,entry);
    WHILE found DO
        IF countFile = maxFile THEN RETURN MAX(CARDINAL); END;
        fileArray[firstFile+countFile]:=f8e3(entry.Name);
        Str.Caps(fileArray[firstFile+countFile]); (* useless ! *)
        INC (countFile);
        found :=FIO.ReadNextEntry(entry);
    END;
    RETURN countFile;
END buildList;

PROCEDURE isLessByName (i,j:CARDINAL):BOOLEAN;
VAR
    si,sj:f8e3;
BEGIN
    si:=fileArray[i];
    sj:=fileArray[j];
    RETURN ( Str.Compare(si,sj) < 0 );
END isLessByName;

PROCEDURE doSwapNames (i,j:CARDINAL);
VAR
    si,sj,tmp:f8e3;
BEGIN
    si:=fileArray[i];
    sj:=fileArray[j];
    tmp:=si;
    si:=sj;
    sj:=tmp;
    fileArray[i]:=si;
    fileArray[j]:=sj;
END doSwapNames;

(* ------------------------------------------------------------ *)

PROCEDURE newheader (VAR headerkind:headerkindtype ;
                    wanted:headerkindtype ):BOOLEAN;
VAR
    ok:BOOLEAN;
BEGIN
    ok:=TRUE;
    CASE headerkind OF
    | undefined : headerkind:=wanted;
    ELSE
        IF headerkind # wanted THEN ok:=FALSE;END;
    END;
    RETURN ok;
END newheader;

(* ------------------------------------------------------------ *)

VAR
    headerkind  : headerkindtype;
    DEBUG,alphasort,overwrite,overwriteRO,verbose   : BOOLEAN;
    filecount       : CARDINAL;
    basepath,source,target      : str128;
VAR
    ok              : BOOLEAN;
    p               : CARDINAL;
VAR
    parmcount,i,opt : CARDINAL;
    S,R,MSG         : str128;
    state           : (waiting,gotsource);
BEGIN
    FIO.IOcheck:=FALSE;
    WrLn;

    headerkind := undefined;
    overwrite  := FALSE;
    overwriteRO:= FALSE;
    verbose    := FALSE;
    alphasort  := TRUE;
    DEBUG      := FALSE;

    state     := waiting;

    parmcount := Lib.ParamCount();
    IF parmcount=0 THEN abort(errHelp,"");END;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   "N"+delim+"NORMAL"+delim+"NOHEADER"+delim+
                                   "L"+delim+"LATIN"+delim+"VULGATE"+delim+
                                   "E"+delim+"ENGLISH"+delim+"KINGJAMES"+delim+
                                   "O"+delim+"OVERWRITE"+delim+
                                   "V"+delim+"VERBOSE"+delim+
                                   "F"+delim+"FRENCH"+delim+"SEGOND"+delim+
                                   "OO"+delim+"READONLY"+delim+
                                   "SA"+delim+"NOALPHASORT"+delim+
                                   "K"+delim+"KASIMIRSKI"+delim+
                                   "DEBUG"
                               );
            CASE opt OF
            | 1,2,3 : abort(errHelp,"");
            | 4,5,6 : IF newheader(headerkind,noheader) = FALSE THEN abort(errHeader,"");END;
            | 7,8,9 : IF newheader(headerkind,vulgateheader)=FALSE THEN abort(errHeader,"");END;
            | 10,11,12:IF newheader(headerkind,kingjamesheader)=FALSE THEN abort(errHeader,"");END;
            | 13,14 : overwrite  := TRUE;
            | 15,16 : verbose    := TRUE;
            | 17,18,19 : IF newheader(headerkind,frenchheader)=FALSE THEN abort(errHeader,"");END;
            | 20,21 : overwrite  := TRUE;
                      overwriteRO:= TRUE;
            | 22,23 : alphasort  := FALSE;
            | 24,25 : IF newheader(headerkind,kasimirskiheader)=FALSE THEN abort(errHeader,"");END;
            | 26    : DEBUG      := TRUE;
            ELSE
                abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            CASE state OF
            | waiting : source:=R; (* keep upper case *)
            | gotsource:abort(errParmOverflow,S);
            END;
            INC(state);
        END;
    END;

    (* check nonsense *)
    IF state = waiting THEN abort(errMissingSource,"");END;
    IF headerkind = undefined THEN abort(errMissingHeader,"");END;

    IF same(source,dot) THEN source:=stardotstar;END;
    IF Str.CharPos(source,dot)=MAX(CARDINAL) THEN Str.Append(source,extTXT);END;

    filecount := buildList(basepath, source);
    CASE filecount OF
    | 0 : abort(errNotFound,source);
    | MAX(CARDINAL): abort(errTooMany,source);
    ELSE
        IF alphasort THEN Lib.QSort(filecount,isLessByName,doSwapNames);END;
    END;

    (*
    WrStr(banner);WrLn;
    WrLn;
    *)
    FOR i := 1 TO filecount DO
        Str.Concat(source,basepath,fileArray[firstFile+i-1]);
        Str.Copy(target,source);
        p:=Str.RCharPos(target,dot);
        IF p # MAX(CARDINAL) THEN target[p]:=charnull;END; (* brutal *)
        CASE headerkind OF
        | noheader:        R:=extNEW;
        | vulgateheader:   R:=extLAT;
        | frenchheader:    R:=extFRA;
        | kingjamesheader: R:=extKJB;
        | kasimirskiheader:R:=extCOR;
        END;
        Str.Append(target,R);

        S   :="Source : |"+nl;
        R   :="Target : |"+nl;
        MSG :="Status : |"+nl;
        Str.Subst(S,vbar,source);
        Str.Subst(R,vbar,target);
        WrStr(S);
        WrStr(R);

        ok := TRUE;
        IF same(source,target) THEN
            Str.Subst(MSG,vbar,"skipped (source would overwrite itself)");
            ok := FALSE;
        ELSE
            IF FIO.Exists(target) THEN
                IF overwrite THEN
                    IF isReadOnly(target) THEN
                        IF overwriteRO THEN
                            setReadWrite(target);
                            FIO.Erase(target);
                        ELSE
                            Str.Subst(MSG,vbar,"skipped (existing target is read-only)");
                            ok:=FALSE;
                        END;
                    ELSE
                        FIO.Erase(target);
                    END;
                ELSE
                    Str.Subst(MSG,vbar,"skipped (target already exists)");
                    ok := FALSE;
                END;
            END;
        END;
        IF ok THEN
            process(headerkind,verbose,source,target);
            Str.Subst(MSG,vbar,"processed OK");
        END;
        WrStr(MSG);
        IF ChkEscape() THEN abort(errAborted,"");END;
    END;

    abort(errNone,"");
END prepHIDN.



