(* ---------------------------------------------------------------
Title         Q&D remark processor for TS M2 source code
Overview      see help
Usage         see help
Notes         very, very, very quick & dirty... :-(

              use code from LCOUNT v1.0f

              MODrem or M2rem were better names
              but it's too late now : I'm used to REMMOD now !

              yes, Code Police, we're guilty of hard coded values
              we're not bullet-proof but, hell, we're a dev tool ! :-)
Bugs
Wish List     allow removal/edition of lines through line number ?
              crossref constants, variables, procedures ?

--------------------------------------------------------------- *)

MODULE remMOD;

IMPORT Str;
IMPORT Lib;
IMPORT FIO;
IMPORT IO;

FROM QD_ASCII IMPORT dash, slash, nullchar, tabchar, cr, lf, nl, bs,
space, dot, deg, doublequote, quote, colon, percent, vbar,
blank, equal, dquote, charnull, singlequote, antislash, dollar,
star, backslash, coma, question, underscore, tabul, hbar,
comma, semicolon, diese, pound, openbracket, closebracket, tilde, exclam,
stardotstar, dotdot, escCh, escSet, letters, digits,
lettersUpp, lettersLow, openbrace, closebrace, ampersand;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory, qdSplitAllPath,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite, setReadOnly,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs, UpperCaseAlt, LowerCaseAlt,
completedInit, completedShow, completedSHOW, completedEnd, completed,
removeDups, isValidHDunit, removePhantoms, removeFloppies,
getCDROMunits, getCDROMletters, removeCDROMs, getAllHDunits,
getAllLegalUnits, metaproc, getCli, argc, argv;

FROM QD_File IMPORT pathtype, w9XnothingRequired,
fileOpenRead, fileOpen, fileExists, fileExistsAlt,
fileIsRO, fileSetRW, fileSetRO,
fileErase, fileCreate, fileRename, fileGetFileSize, fileGetFileStamp,
fileIsDirectorySpec, fileClose, fileFlush, fileSupportLFN;

FROM QD_LFN IMPORT path9X, huge9X, findDataRecordType,
unicodeConversionFlagType, w9XchangeDir,
w9XgetDOSversion, w9XgetTrueDOSversion, w9XisWindowsEnh, w9XisMSDOS7,
w9XfindFirst, w9XfindNext, w9XfindClose, w9XgetCurrentDirectory,
w9XlongToShort, w9XshortToLong, w9XtrueName, w9XchangeDir,
w9XmakeDir, w9XrmDir, w9Xrename, w9XopenFile, w9XcloseFile,
w9XsupportLFN;

FROM IO IMPORT WrStr, WrLn;

FROM Storage IMPORT Available,ALLOCATE,DEALLOCATE;

(* ------------------------------------------------------------ *)

CONST
    winum          = 5; (* ##### = 99999... should DO ! *)
    sTagOnlyCode   = "??";
    sTagCodeHere   = "::"; (* code AND remark *)
    sTagREM        = "++"; (* only remark or remark open/close alone *)
    sTagINrem      = "!!"; (* between remark open/close *)
    taglen         = 2;    (* both tags are 2 chars long *)
CONST
    exe            = "REMMOD";
    extBAK         = ".ORG";
    extMOD         = ".MOD";
    title          = "Q&D M2 remarks and strings processor";
    version        = "v1.0n";
    culprit        = "by PhG";
    Banner         = title+" "+version+" "+culprit;
    sMaxFileCount  = "200"; (* should do ! *)
    maxFileCount   = 200;
    qui            = "who";
    quand          = "when";
    quoi           = "what";
    patWWW         = "*"+qui+"*"+quand+"*"+quoi+"*"; (* trick not to be parsed *)
    patREMclose    = "----------*---------- ?)"; (* beware of internal comments ! *)
    patLibStart    = "IMPLEMENTATION*MODULE*"+semicolon;
    patProgStart   = "MODULE*"+semicolon;
    patProgEnd     = "END*"+dot;
    arobase        = "@";
    dumpsepline    = '(* =========::: "$" *)'; (* $ is file *)
CONST
    (*
    extremely unlikely to already exist !
    used by dofilter() and doPasEnd() too
    *)
    tmpf8       = "~TMP~M2~";
    tmpe3       = ".TMP";
CONST
    extCOM      = ".COM";
    extEXE      = ".EXE";
    extDLL      = ".DLL";
    extOVR      = ".OVR";
    extOVL      = ".OVL";
    extDRV      = ".DRV";
    extVXD      = ".VXD";
    extBIN      = ".BIN";
    extZIP      = ".ZIP";
    extARJ      = ".ARJ";
    extLZH      = ".LZH";
    skippedextensions = extCOM+delim+extEXE+delim+
                        extDLL+delim+extOVR+delim+extOVL+delim+extDRV+delim+
                        extVXD+delim+extBIN+delim+
                        extZIP+delim+extARJ+delim+extLZH;

CONST
    help=
Banner+nl+
nl+
"Syntax 1 : "+exe+" <m2_source["+extMOD+"]> [-q]"+nl+
"Syntax 2 : "+exe+" <m2_source["+extMOD+"]> <remarks_file>"+nl+
"Syntax 3 : "+exe+" <m2_source["+extMOD+"]> <"+arobase+"|-w>"+nl+
"Syntax 4 : "+exe+" <m2_source["+extMOD+"]> <"+exclam+"|-f>"+nl+
"Syntax 5 : "+exe+" <m2_source["+extMOD+"]> <"+dollar+"|-c>"+nl+
"Syntax 6 : "+exe+" <m2_source["+extMOD+"]> <"+pound+"|-x[x]> [-k]"+nl+
"Syntax 7 : "+exe+" <m2_source["+extMOD+"]> <"+ampersand+"|-s[s]> [-t] [-n]"+nl+
"Syntax 8 : "+exe+" <m2_source["+extMOD+"]> <"+equal+"|-z>"+nl+
nl+
"    This program processes Modula-2 *"+extMOD+" files."+nl+
nl+
"    It dumps all remarks enclosed or not (-q) with double quotes (syntax 1) ;"+nl+
"    replaces lines using edited remarks enclosed with double quotes (syntax 2)"+nl+
"    provided lines have been dumped using syntax 1 first ;"+nl+
'    dumps code removing "Who When What" history header (syntax 3) ;'+nl+
'    removes "Who When What" history header from source (syntax 4) ;'+nl+
"    warns about any data left after end of program code (syntax 5) ;"+nl+
"    remove all remarks from source (syntax 6),"+nl+
"    possibly keeping separation lines (-k) ;"+nl+
"    dumps all lines containing strings whether double- or single- quoted"+nl+
"    (syntax 7), possibly trimming lines (-t) or keeping only strings (-n) ;"+nl+
"    deletes all data left after end of program code (syntax 8)."+nl+
nl+
"a) Source code is assumed to be correct (its compilation should be a success)."+nl+
"b) Syntax 1 flags each dumped line with a marker in this priority order :"+nl+
'   "'+sTagCodeHere+'" = code+remark ; "'+sTagREM+'" = remark ; "'+sTagINrem+'" = between remarks'+nl+
"c) Syntax 2 requires edited remarks to keep their line number and marker ;"+nl+
"   only text between outer double quotes may be changed (this is by design)."+nl+
"d) All syntaxes (except syntax 2) can process up to "+sMaxFileCount+" files."+nl+
"e) Syntax 4 keeps each original file with "+extBAK+" extension :"+nl+
"   other syntaxes (except syntax 2) dump processed source files to screen."+nl+
"   Should more than one source file be processed, this separator is inserted :"+nl+
nl+
"   "+dumpsepline+nl+
nl+
"   where $ is source filename."+nl+
'f) Syntax 6 can preserve separation lines remarks made only of "'+dash+'" or "'+equal+'".'+nl+
"g) Syntax 7 dumps any remark containing a string, including Modula-2 comments."+nl+
"h) Whatever the syntax, -lfn option disables LFN support even if available."+nl+
"i) Here are skipped extensions :"+nl+
"   "+skippedextensions+nl+
"j) Redirection, DIRBAT, WITH, and USERBRAIN utilities should help. ;-)"+nl+
"k) This program was written for TopSpeed J.P.I. Modula-2 source code,"+nl+
"   but it should be useful for newer Modula-2 compilers."+nl;

PROCEDURE abort (S:ARRAY OF CHAR);
VAR
    rc:CARDINAL;
BEGIN
    IF same(S,"") THEN
        rc:=0;
    ELSE
        WrStr(exe+" : ");WrStr(S);WrLn;
        rc:=1;
    END;
    Lib.SetReturnCode(SHORTCARD(rc));
    HALT;
END abort;

(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBufferType    = ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
VAR
    ioBufferIn  : ioBufferType;
    ioBufferOut : ioBufferType;

(* ------------------------------------------------------------ *)

PROCEDURE num2str (num,fix:CARDINAL;padchar:CHAR   ):str16;
VAR
    R:str16;
    ok:BOOLEAN;
BEGIN
    Str.CardToStr( LONGCARD(num),R,10,ok);
    WHILE Str.Length(R) < fix DO
        Str.Prepend(R,padchar);
    END;
    RETURN R;
END num2str;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    modularemopen   = "(*";
    modularemclose  = "*)";

(* assume S is already fully trimed *)

PROCEDURE atstart (substring,S : ARRAY OF CHAR   ) : BOOLEAN ;
VAR
    S2 : str128;
BEGIN
    IF S[0] # substring[0] THEN RETURN FALSE; END; (* quick test *)
    IF same(S,substring) THEN RETURN TRUE; END;
    Str.Concat(S2,substring,blank);
    IF Str.Pos(S,S2)=0 THEN RETURN TRUE; END;
    Str.Concat(S2,substring,tabul);
    IF Str.Pos(S,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END atstart;

PROCEDURE atend (substring,S : ARRAY OF CHAR   ) : BOOLEAN ;
VAR
    S2 : str128;
    len,lensub:CARDINAL;
BEGIN
    lensub:=Str.Length(substring);
    len:=Str.Length(S);
    IF len < lensub THEN RETURN FALSE; END;
    IF S[len-lensub] # substring[0] THEN RETURN FALSE; END; (* quick test *)
    IF same(S,substring) THEN RETURN TRUE; END;

    INC(lensub); (* we'll add a blank *)
    IF len < lensub THEN RETURN FALSE; END;
    Str.Concat(S2,blank,substring);
    IF Str.Pos(S,S2)=(len-lensub) THEN RETURN TRUE; END;
    Str.Concat(S2,tabul,substring);
    IF Str.Pos(S,S2)=(len-lensub) THEN RETURN TRUE; END;
    RETURN FALSE;
END atend;

PROCEDURE atstartandend (sub1,sub2,S:ARRAY OF CHAR   ):BOOLEAN ;
VAR
    len,sublen : CARDINAL;
    R : str128;
BEGIN
    (*
    IF atstart(sub1,S) THEN
        len:=Str.Length(S);
        sublen:=Str.Length(sub2);
        IF len >= sublen THEN
            Str.Slice(R, S, len-sublen, sublen);
            RETURN same(R,sub2);
        END;
    END;
    RETURN FALSE;
    *)
    RETURN ( atstart(sub1,S) AND atend(sub2,S) );
END atstartandend;

PROCEDURE herebutnotalone ( sub1,sub2,S:ARRAY OF CHAR  ):BOOLEAN ;
BEGIN
    IF Str.Pos(S,sub1)=MAX(CARDINAL) THEN RETURN FALSE; END;
    IF Str.Pos(S,sub2)=MAX(CARDINAL) THEN RETURN FALSE; END;
    (* ok, we've got both : now check if commenting code *)
    IF atstart(sub1,S) THEN
        IF atend(sub2,S) THEN
            RETURN FALSE;
        ELSE
            RETURN TRUE;
        END;
    ELSE
        IF atend(sub2,S) THEN
            RETURN TRUE;
        ELSE
            RETURN TRUE;
        END;
    END;
END herebutnotalone;

PROCEDURE isSeparationLine (S:ARRAY OF CHAR   ):BOOLEAN;
CONST
    allowed  = "(*)"+blank+tabul+dash+equal;
    openrem  = "(*";
    closerem = "*)";
    lenrem   = 2;
VAR
    group:str2;
    len:CARDINAL;
    ok:BOOLEAN;
BEGIN
    ok:=FALSE;
    IF verifyString(S,allowed)=FALSE THEN RETURN ok;END;
    LtrimBlanks(S);
    RtrimBlanks(S);
    Str.Slice(group,S,0,lenrem);
    IF same(group,openrem)=FALSE THEN RETURN ok;END;
    Str.Delete(S,0,lenrem);
    len:=Str.Length(S);
    IF len < lenrem THEN RETURN ok;END;
    Str.Slice(group,S,len-lenrem,lenrem);
    IF same(group,closerem)=FALSE THEN RETURN ok;END;
    S[len-lenrem]:=charnull;

    ReplaceChar(S,blank,"");
    ReplaceChar(S,tabul,"");

    IF verifyString(S,dash) THEN RETURN TRUE; END;
    RETURN verifyString(S,equal);
END isSeparationLine;

(* ------------------------------------------------------------ *)

(*
    this line contains both code and remarks possibly in succession or nested
    handle "!* *!" and "!* !* *! *!" and "!* *! !* *!"
    adapted from procline() in MOD2THM v1.0
*)

PROCEDURE dmpmecooked (S:ARRAY OF CHAR   );
CONST
    delimiters            = "(*)";
    openrem               = "(*";
    closerem              = "*)";
    lenrem                = 2;
VAR
    dmped,cpos,i,len,remdepth:CARDINAL;
    ch,stringdelimiter:CHAR;
    group:str2;
    parsingstate : (waitingdata,instring,inremark);
BEGIN
    remdepth:=0; (* //V10N *)
    dmped:=0;
    len:=Str.Length(S);
    cpos:=1-1;
    parsingstate:=waitingdata;
    LOOP
        IF cpos >= len THEN EXIT; END;
        ch:=S[cpos];
        CASE parsingstate OF
        | waitingdata:
            CASE ch OF
            | "(":
                Str.Slice(group,S,cpos,lenrem);
                IF same(group,openrem) THEN
                    INC(remdepth);
                    INC(cpos); (* pass "*" *)
                    parsingstate:=inremark;
                ELSE
                    WrStr(ch);INC(dmped);
                END;
            | singlequote,doublequote:
                stringdelimiter:=ch;
                parsingstate:=instring;
                WrStr(ch); INC(dmped);
            ELSE
                WrStr(ch); INC(dmped);
            END;

        | instring:
            WrStr(ch); INC(dmped);
            IF ch=stringdelimiter THEN parsingstate:=waitingdata; END;

        | inremark:
            CASE ch OF
            | "(" :
                Str.Slice(group,S,cpos,lenrem);
                IF same(group,openrem) THEN
                    INC(remdepth);
                    INC(cpos);
                END;
            | "*" :
                Str.Slice(group,S,cpos,lenrem);
                IF same(group,closerem) THEN
                    INC(cpos); (* pass ")" *)
                    IF remdepth # 0 THEN (* should always be here *)
                        DEC(remdepth);
                        IF remdepth = 0 THEN parsingstate:=waitingdata;END;
                    END;
                ELSE
                    (* WrStr(ch); //V10N *) (* INC(dmped); *)
                END;
            END;
        END;
        INC(cpos);
    END;
    IF dmped # 0 THEN WrLn; END;
END dmpmecooked;

(* ------------------------------------------------------------ *)

TYPE
    tagremtype = (tagonlycode,tagcodehere,tagrem,tagINrem,tagsepline);

PROCEDURE dmpme (okdmp,enclosed,unrem:BOOLEAN;
                n:LONGCARD;tag:tagremtype;S:ARRAY OF CHAR   );
VAR
    R:str16;
    stag:str2;
BEGIN
    IF unrem THEN
        CASE tag OF
        | tagcodehere:  dmpmecooked(S);
        | tagonlycode:  WrStr(S);WrLn;
        | tagsepline :  WrStr(S);WrLn;
        END;
    ELSE
        IF okdmp THEN
            CASE tag OF
            | tagcodehere : stag:=sTagCodeHere;
            | tagrem      : stag:=sTagREM;
            | tagINrem    : stag:=sTagINrem;
            | tagonlycode : stag:=sTagOnlyCode; (* should never happen here *)
            END;
            R:="~ ~ ";
            Str.Subst(R,"~",num2str( CARDINAL(n),winum," "));
            Str.Subst(R,"~",stag);
            WrStr(R);
            IF enclosed THEN WrStr(doublequote); END;
            WrStr(S);
            IF enclosed THEN WrStr(doublequote); END;
            WrLn;
        END;
    END;
END dmpme;

(* adapted from LCOUNT.MOD v1.0f countLines() *)

PROCEDURE dodump (useLFN,enclosed,unrem,keepseplines:BOOLEAN;f : pathtype);
VAR
    hin : FIO.File;
    comments,currline: LONGCARD;
    S,SORG : str4096;
    levels:CARDINAL;
    wasREMark:BOOLEAN;
    okdmp:BOOLEAN;
BEGIN
    okdmp:=TRUE;

    currline :=0;
    levels := 0;

    comments := 0;

    hin := fileOpenRead(useLFN,f);
    FIO.AssignBuffer(hin,ioBufferIn);
    FIO.EOF := FALSE;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        wasREMark:=TRUE; (* it's easier to set this variable to false ! *)
        FIO.RdStr(hin,S);
        IF ((S[0]=charnull) AND FIO.EOF) THEN EXIT; END;
        INC(currline);
        Str.Copy(SORG,S);
        LtrimBlanks(S); RtrimBlanks(S);
        IF Str.Length(S) = 0 THEN
            wasREMark:=FALSE;
            dmpme(NOT(okdmp),enclosed,unrem,currline,tagonlycode,SORG);
        ELSE
            (* ugly, unable to parse complex cases but who cares ? *)
            IF same(S,modularemopen) THEN (* "( *" alone *)
                INC(levels);
                INC(comments);
                dmpme(okdmp,enclosed,unrem,currline,tagrem,SORG);
            ELSIF same(S,modularemclose) THEN (* "* )" alone *)
                IF levels > 0 THEN DEC(levels);END; (* yes, this test should not be necessary *)
                INC(comments);
                dmpme(okdmp,enclosed,unrem,currline,tagrem,SORG);
            ELSIF atstartandend(modularemopen,modularemclose,S) THEN (* "( *...* )" *)
                (* //FIXME : separation line *)
                IF unrem THEN
                    IF isSeparationLine(S) THEN
                        IF keepseplines THEN
                            dmpme(okdmp,enclosed,unrem,currline,tagsepline,SORG);
                        END;
                    ELSE
                        dmpme(okdmp,enclosed,unrem,currline,tagcodehere,SORG);
                    END;
                ELSE
                    INC(comments);
                    dmpme(okdmp,enclosed,unrem,currline,tagrem,SORG);
                END;

            ELSIF herebutnotalone(modularemopen,modularemclose,S) THEN
                IF levels = 0 THEN
                    wasREMark:=FALSE;
                    dmpme(okdmp,enclosed,unrem,currline,tagcodehere,SORG); (* show it but let know it's counted *)
                ELSE
                    INC(comments);
                    dmpme(okdmp,enclosed,unrem,currline,tagrem,SORG);
                END;
            ELSIF atstart(modularemopen,S) THEN (* "( *..." *)
                INC(levels);
                INC(comments);
                dmpme(okdmp,enclosed,unrem,currline,tagrem,SORG);
            ELSIF atend(modularemclose,S) THEN (* "...* )" *)
                IF levels > 0 THEN DEC(levels); END; (* yes, this test should not be necessary *)
                INC(comments);
                dmpme(okdmp,enclosed,unrem,currline,tagrem,SORG);

            ELSE
                IF levels = 0 THEN
                    wasREMark:=FALSE;
                    dmpme(NOT(okdmp),enclosed,unrem,currline,tagonlycode,SORG);
                ELSE
                    INC(comments);
                    dmpme(okdmp,enclosed,unrem,currline,tagINrem,SORG);
                END;
            END;

        END;
    END;
    fileClose(useLFN,hin);
END dodump;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* ugly hack *)

PROCEDURE dofilter (useLFN,tofile:BOOLEAN; src:pathtype;onMatch,offString:ARRAY OF CHAR   );
VAR
    S:str4096;
    state:(waiting,inheader,done);
    hin,hout:FIO.File;
    u,d,n,e,target,tmpcanonical:pathtype;
BEGIN
    qdSplitAllPath(src, u,d,n,e);
    Lib.MakeAllPath(target,u,d,n,extBAK);
    Lib.MakeAllPath(tmpcanonical,u,d,tmpf8,tmpe3);

    IF tofile THEN
        hout:=fileCreate(useLFN,target);
        FIO.AssignBuffer(hout,ioBufferOut);
    END;

    hin := fileOpenRead(useLFN,src);
    FIO.AssignBuffer(hin,ioBufferIn);
    FIO.EOF := FALSE;
    state:=waiting;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hin,S);
        IF ((S[0]=0C) AND FIO.EOF) THEN EXIT; END;
        CASE state OF
        | waiting:
            IF Str.Match(S,onMatch) THEN
                state:=inheader;
            ELSE
                IF tofile THEN
                    FIO.WrStr(hout,S);FIO.WrLn(hout);
                ELSE
                    WrStr(S);WrLn;
                END;
            END;
        | inheader:
            IF Str.Match(S,offString) THEN
                IF tofile THEN
                    FIO.WrStr(hout,S);FIO.WrLn(hout);
                ELSE
                    WrStr(S);WrLn;
                END;
                state:=done;
            END;
        | done:
            IF tofile THEN
                FIO.WrStr(hout,S);FIO.WrLn(hout);
            ELSE
                WrStr(S);WrLn;
            END;
        END;

    END;
    fileClose(useLFN,hin);
    IF tofile THEN
        fileClose(useLFN,hout);
        IF fileExists(useLFN,tmpcanonical) THEN
            setReadWrite(tmpcanonical);
            fileErase(useLFN,tmpcanonical);
        END;
        fileRename(useLFN,src,tmpcanonical);        (* .MOD becomes .tmp *)
        fileRename(useLFN,target,src);              (* .org becomes .MOD *)
        fileRename(useLFN,tmpcanonical,target);     (* .tmp becomes .org *)
        WrStr("+++ Created  : ");WrStr(src);WrLn;
        WrStr("::: Original : ");WrStr(target);WrLn;
    END;
END dofilter;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we won't warn about illegal code : we assume it's ok *)

PROCEDURE doPastEnd (useLFN,tofile:BOOLEAN;
                    src:pathtype;patlibstart,patstart,patend:ARRAY OF CHAR);
VAR
    hin,hout:FIO.File;
    state:(waiting,gotname,gotend,datapastend);
    Z,S:str4096;
    modulename,maybe:str128;
    u,d,n,e,target,tmpcanonical:pathtype;
BEGIN
    qdSplitAllPath(src, u,d,n,e);
    Lib.MakeAllPath(target,u,d,n,extBAK);
    Lib.MakeAllPath(tmpcanonical,u,d,tmpf8,tmpe3);

    IF tofile THEN
        hout:=fileCreate(useLFN,target);
        FIO.AssignBuffer(hout,ioBufferOut);
    END;

    hin := fileOpenRead(useLFN,src);
    FIO.AssignBuffer(hin,ioBufferIn);
    FIO.EOF := FALSE;
    state:=waiting;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hin,S);
        Str.Copy(Z,S);
        LtrimBlanks(S);
        RtrimBlanks(S);
        IF ((S[0]=0C) AND FIO.EOF) THEN EXIT; END;
        CASE state OF
        | waiting:
            IF Str.Match(S,patstart) THEN
                argv(modulename, S,2,FALSE);
                ReplaceChar(modulename,semicolon,"");
                state:=gotname;
            ELSIF Str.Match(S,patlibstart) THEN
                argv(modulename, S,3,FALSE);
                ReplaceChar(modulename,semicolon,"");
                state:=gotname;
            END;
        | gotname:
            IF Str.Match(S,patend) THEN
                argv(maybe,  S,2,FALSE);
                ReplaceChar(maybe,dot,"");
                IF same(modulename,maybe) THEN state:=gotend; END;
            END;
        | gotend:
            IF same(S,"")=FALSE THEN state:=datapastend; EXIT;END;
        END;

        IF tofile THEN
            FIO.WrStr(hout,Z);FIO.WrLn(hout);
        END;

    END;
    fileClose(useLFN,hin);
    IF tofile THEN
        fileClose(useLFN,hout);
        IF state = datapastend THEN
            IF fileExists(useLFN,tmpcanonical) THEN
                setReadWrite(tmpcanonical);
                fileErase(useLFN,tmpcanonical);
            END;
            fileRename(useLFN,src,tmpcanonical);        (* .MOD becomes .tmp *)
            fileRename(useLFN,target,src);              (* .org becomes .MOD *)
            fileRename(useLFN,tmpcanonical,target);     (* .tmp becomes .org *)
            WrStr("+++ Created  : ");WrStr(src);WrLn;
            WrStr("::: Original : ");WrStr(target);WrLn;
        ELSE
            fileErase(useLFN,target); (* yes, we could make 2 passes with clever code instead *)
        END;
    ELSE
        IF state = datapastend THEN
            WrStr("::: Data past end of program : ");WrStr(src);WrLn;
        END;
    END;
END doPastEnd;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    remIDtype = (remcodehere,remrem,remINrem);

CONST
    firstEntry = 1; (* 1..count *)
TYPE
    ptrToEntry = POINTER TO entryType;
    entryType = RECORD
        next   : ptrToEntry;
        linenum: CARDINAL;
        remID  : remIDtype;
        slen   : CARDINAL;
        string : CHAR;      (* here, after other data, because variable length *)
    END;

PROCEDURE getfileentry (VAR R:ARRAY OF CHAR; VAR remID:remIDtype; VAR linenum:CARDINAL;
                        getall:BOOLEAN; n:CARDINAL; firstInList:ptrToEntry);
VAR
    i,len:CARDINAL;
    newInList:ptrToEntry;
    S:str4096; (* what about LFN, eh ? ;-) *)
BEGIN
    newInList := firstInList;
    DEC(n); (* trick to force to anchor if 1, and locate correct string if > 1 *)
    FOR i:=firstEntry TO n DO
         newInList := newInList^.next;
    END;
    IF getall THEN
        len         := newInList^.slen;
        Lib.FastMove( ADR(newInList^.string),ADR(S),len);
        S[len]      := 0C; (* REQUIRED safety ! *)
        Str.Copy(R,S); (* yep, we cannot fill R directly *)
        remID       := newInList^.remID;
    END;
    linenum     := newInList^.linenum;
END getfileentry;

PROCEDURE freeList (anchor:ptrToEntry);
VAR
    len,needed      : CARDINAL;
    firstInList,newInList   : ptrToEntry;
BEGIN
    firstInList := anchor;
    newInList := firstInList;
    WHILE newInList # NIL DO
         len         := CARDINAL(newInList^.slen);
         needed      := SIZE(entryType)-SIZE(CHAR)+len;
         firstInList := firstInList^.next;
         DEALLOCATE (newInList,needed);
         newInList := firstInList;
    END
END freeList;

PROCEDURE loadRemarks (VAR anchor:ptrToEntry;
                      useLFN,dbg:BOOLEAN;f:pathtype):CARDINAL;
VAR
    ok:BOOLEAN;
    CrashAndBurn:(Bangles,avoided);
    v:LONGCARD;
    lastEntry,len,needed : CARDINAL;
    newInList : ptrToEntry;
    S:str4096;
    p,linenum,count:CARDINAL;
    tag:str16;
    hin:FIO.File;
    whatline,whattag:str16;
    remID : remIDtype;
BEGIN
    hin:=fileOpenRead(useLFN,f);
    FIO.AssignBuffer(hin,ioBufferIn);
    lastEntry := firstEntry-1;
    anchor:=NIL;
    CrashAndBurn:=avoided;
    LOOP
        FIO.RdStr(hin,S);
        IF FIO.EOF THEN EXIT; END;

        argv(whatline, S,1,FALSE );
        argv(whattag , S,2,FALSE );

        count:=0;
        IF same(whattag,sTagCodeHere) THEN INC(count); remID:=remcodehere; END;
        IF same(whattag,sTagREM)      THEN INC(count); remID:=remrem; END;
        IF same(whattag,sTagINrem)    THEN INC(count); remID:=remINrem; END;
        ok:=(count = 1);

        IF ok THEN
            count:=Str.Pos(S,whattag) + taglen-1 +1;
            Str.Delete(S,0,count);
            LtrimBlanks(S); RtrimBlanks(S);
            ok:=Str.Match(S,dquote+"*"+dquote);
        END;

        IF ok THEN
            v:=Str.StrToCard(whatline,10,ok); (* assume ok *)
            linenum:=CARDINAL(v);
            (* IO.WrCard( linenum,wi);WrStr(tag);WrStr(S);WrLn; *)

            S[Str.Length(S)-1] := charnull;
            Str.Delete(S,0,1);

            INC(lastEntry);
            IF lastEntry=MAX(CARDINAL) THEN CrashAndBurn:=Bangles; EXIT; END;
            len:=Str.Length(S);
            needed:=SIZE(entryType)-SIZE(CHAR)+len;
            IF Available(needed)=FALSE THEN CrashAndBurn:=Bangles; EXIT; END;
            CASE lastEntry OF
            | firstEntry :
                ALLOCATE( anchor,needed);
                newInList := anchor;
            ELSE
                ALLOCATE(newInList^.next,needed);
                newInList :=newInList^.next;
            END;
            Lib.FastMove( ADR(S),ADR(newInList^.string),len);
            newInList^.slen    := len;
            newInList^.remID   := remID;
            newInList^.linenum := linenum;
            newInList^.next    := NIL;
        ELSE
            IF dbg THEN
                WrStr('-- Problem ! "');
                WrStr(whatline);
                WrStr(" ");
                WrStr(whattag);
                WrStr(" ");
                WrStr(S);WrStr('"');WrLn;
            END;
        END;
    END;
    fileClose(useLFN,hin);
    CASE CrashAndBurn OF
    | Bangles : RETURN MAX(CARDINAL);
    | avoided:  RETURN lastEntry;
    END;
END loadRemarks;

(* we expect (no, we require) ordered lines *)

PROCEDURE doapply (useLFN,dbg:BOOLEAN; file,remfile:pathtype ):BOOLEAN;
VAR
    i,lastEntry:CARDINAL;
    anchor:ptrToEntry;
    S,S2:str4096;
    linenum:CARDINAL;
    currline:CARDINAL;
    hin:FIO.File;
    remID:remIDtype;
    stag:str16;
BEGIN
    lastEntry:=loadRemarks(anchor, useLFN,dbg,remfile);
    IF lastEntry=MAX(CARDINAL) THEN RETURN FALSE; END;

    IF dbg THEN
        WrLn;
        FOR i:=firstEntry TO lastEntry DO
            getfileentry(S,remID,linenum,  TRUE,i,anchor);

            IO.WrCard( linenum,winum);
            WrStr(" ");
            CASE remID OF
            | remcodehere: stag:=sTagCodeHere;
            | remrem:      stag:=sTagREM;
            | remINrem:    stag:=sTagINrem;
            END;
            WrStr(stag);
            WrStr(" ");
            WrStr(S);WrLn;
        END;
    END;

    hin:=fileOpenRead(useLFN,file);
    FIO.AssignBuffer(hin,ioBufferIn);
    currline:=0;
    FIO.EOF:=FALSE;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hin,S);
        (* was IF FIO.EOF THEN EXIT; END; *)
        IF ((S[0]=charnull) AND FIO.EOF) THEN EXIT; END;
        INC(currline);

        i:=firstEntry;
        LOOP
            IF i> lastEntry THEN EXIT; END;
            getfileentry(S2,remID,linenum,FALSE,i,anchor);
            IF currline=linenum THEN
                getfileentry(S,remID,linenum,TRUE,i,anchor);
                EXIT;
            END;
            INC(i);
        END;
        WrStr(S);WrLn;
    END;
    fileClose(useLFN,hin);

    freeList(anchor);

    RETURN TRUE;
END doapply;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    patstring = "*~*~*";

PROCEDURE grabnextstring (VAR Z,S:ARRAY OF CHAR   ):BOOLEAN;
VAR
    p,q:CARDINAL;
    strdelim:CHAR;
    pat:str16;
BEGIN
    p:=Str.CharPos(S,doublequote);
    q:=Str.CharPos(S,singlequote);
    IF p = MAX(CARDINAL) THEN
        IF q = MAX(CARDINAL) THEN
            RETURN FALSE;           (* no quote at all *)
        ELSE
            strdelim:=singlequote;
        END;
    ELSE
        IF q = MAX(CARDINAL) THEN
            strdelim:=doublequote;
        ELSE
            IF p < q THEN
                strdelim:=doublequote;
            ELSE
                strdelim:=singlequote;
            END;
        END;
    END;
    pat:=patstring;
    ReplaceChar(pat,"~",strdelim);
    IF Str.Match(S,pat)=FALSE THEN RETURN FALSE; END; (* only one quote *)

    Str.Delete(S,0,p+1);
    p:=Str.CharPos(S,strdelim);
    IF p = MAX(CARDINAL) THEN RETURN FALSE;END; (* cannot happen here, see supra *)
    Str.Slice(Z,S,0,p);
    Str.Delete(S,0,p+1);

    Str.Append(Z,strdelim);
    Str.Prepend(Z,strdelim);

    RETURN TRUE ;
END grabnextstring;

PROCEDURE dostrings (useLFN,stringsonly,dotrim:BOOLEAN; f:pathtype);
CONST
    separ  = " ::: ";
    separM = "  :: ";
VAR
    hin : FIO.File;
    currline,n: CARDINAL;
    S,SORG,Z: str4096;
    ok,okdq,oksq:BOOLEAN;
    pat:str16;
BEGIN
    currline :=0;

    hin := fileOpenRead(useLFN,f);
    FIO.AssignBuffer(hin,ioBufferIn);
    FIO.EOF := FALSE;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hin,S);
        IF ((S[0]=charnull) AND FIO.EOF) THEN EXIT; END;
        INC(currline);
        IF stringsonly THEN
            Str.Copy(SORG,S);
            n:=0;
            LOOP
                IF grabnextstring(Z, S)=FALSE THEN EXIT; END;
                INC(n);
            END;
            ok:=(n # 0);
        ELSE
            (* this is very quick and dirty a test but it should do here *)
            pat:=patstring;
            ReplaceChar(pat,"~",doublequote);
            okdq := Str.Match(S,pat);
            pat:=patstring;
            ReplaceChar(pat,"~",singlequote);
            oksq := Str.Match(S,pat);
            ok:= (okdq OR oksq);
        END;
        IF ok THEN
            IF stringsonly THEN
                Str.Copy(S,SORG);
                n:=0;
                LOOP
                    IF grabnextstring(Z, S)=FALSE THEN EXIT; END;
                    INC(n);
                    IO.WrCard( currline,winum);
                    IF n = 1 THEN
                        WrStr(separ);
                    ELSE
                        WrStr(separM);
                    END;
                    WrStr(Z);WrLn;
                END;
            ELSE
                IO.WrCard( currline,winum);WrStr(separ);
                IF dotrim THEN
                    LtrimBlanks(S);
                    RtrimBlanks(S);
                END;
                WrStr(S);WrLn;
            END;
        END;
    END;
    fileClose(useLFN,hin);

END dostrings;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkUD (S:pathtype):BOOLEAN ;
VAR
    u,d,n,e:pathtype;
    pb:CARDINAL;
BEGIN
    qdSplitAllPath(S , u,d,n,e);
    pb:=0;
    IF chkJoker(u) THEN INC(pb);END;
    IF chkJoker(d) THEN INC(pb);END;
    RETURN (pb=0);
END chkUD;

PROCEDURE doGetCurrent (useLFN:BOOLEAN;drive:SHORTCARD;
                       VAR unit:str2; VAR current:pathtype);
VAR
    rc:CARDINAL;
    longform:pathtype;
BEGIN
    Str.Concat(unit, CHR( ORD("A")-1+ORD(drive) ),colon);

    FIO.GetDir(drive,current); (* \path without u: nor trailing \ except at root *)
    IF current[1] # colon THEN Str.Prepend(current,unit); END; (* safety *)
    IF useLFN THEN
        IF w9XshortToLong(current,rc,longform) THEN (* if error, keep DOS current *)
            Str.Copy(current,longform);
        END;
    END;
    (* LFN function seems to always return "u:\*" form except at root *)
    IF current[1] = colon THEN Str.Delete(current,0,2);END; (* safety *)
    fixDirectory(current);
END doGetCurrent;

PROCEDURE makebase (useLFN:BOOLEAN;spec:pathtype;VAR basepath:pathtype);
VAR
    u,d,n,e,current:pathtype;
    unit:str2;
    drive:SHORTCARD;
BEGIN
    qdSplitAllPath(spec,u,d,n,e);
    Str.Concat(basepath,u,d);
    IF same(basepath,"") THEN
        drive:=FIO.GetDrive(); (* yes we could use 0 as default drive *)
        doGetCurrent(useLFN,drive,  unit,current); (* "u:" and "\" or "\*\" *)
        Str.Concat(basepath, unit,current);
    END;
END makebase;

CONST
    firstFile = 1;
    maxFile   = firstFile-1+maxFileCount;
VAR
    fileentry : ARRAY [firstFile..maxFile] OF pathtype;

(* Str.Match is not case sensitive *)

PROCEDURE isReservedPattern (S,skipthem:ARRAY OF CHAR):BOOLEAN;
VAR
    e3 : str16;
    n:CARDINAL;
    rc:BOOLEAN;
BEGIN
    rc:=FALSE;
    n:=0;
    LOOP
        isoleItemS(e3, skipthem,delim,n);
        IF same(e3,"") THEN EXIT; END;
        Str.Prepend(e3,"*");
        IF Str.Match(S,e3) THEN rc:=TRUE;EXIT; END;
        INC(n);
    END;
    RETURN rc;
END isReservedPattern;

PROCEDURE isReservedEntry (S:ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dotdot);
END isReservedEntry;

PROCEDURE buildFileList (noskip,useLFN :BOOLEAN;spec:pathtype):CARDINAL;
VAR
    lastentry:CARDINAL;
    ok,found:BOOLEAN;
    unicodeconversion:unicodeConversionFlagType;
    w9Xentry : findDataRecordType;
    w9Xhandle,errcode:CARDINAL;
    entry : FIO.DirEntry;
    dosattr:FIO.FileAttr;
    entryname:pathtype;
    excludeme1,excludeme2:BOOLEAN;
BEGIN
    lastentry:=firstEntry-1;
    IF useLFN THEN
        found := w9XfindFirst (spec,SHORTCARD(everything),SHORTCARD(w9XnothingRequired),
                              unicodeconversion,w9Xentry,w9Xhandle,errcode);
    ELSE
        found := FIO.ReadFirstEntry(spec,everything,entry);
    END;
    LOOP
        IF found=FALSE THEN EXIT;END;
        IF useLFN THEN
            Str.Copy(entryname,w9Xentry.fullfilename);
        ELSE
            Str.Copy(entryname,entry.Name);
        END;
        excludeme1 := isReservedEntry   (entryname);  (* skip "." and ".." *)
        IF noskip THEN
            excludeme2 := FALSE;
        ELSE
            excludeme2 := isReservedPattern (entryname,skippedextensions );
        END;
        IF NOT(excludeme1 OR excludeme2) THEN
            IF useLFN THEN
                dosattr:=FIO.FileAttr(w9Xentry.attr AND 0FFH);
            ELSE
                dosattr:=entry.attr;
            END;
            IF NOT (aD IN dosattr) THEN
                (* if file has no extension, add it as a marker *)
                IF Str.RCharPos(entryname,".")=MAX(CARDINAL) THEN
                    Str.Append(entryname,".");
                END;
                INC(lastentry);
                IF lastentry > maxFile THEN lastentry:=MAX(CARDINAL);EXIT;END;
                fileentry[lastentry]:=entryname;
            END;
        END;
        IF useLFN THEN
            found :=w9XfindNext(w9Xhandle, unicodeconversion,w9Xentry,errcode);
        ELSE
            found :=FIO.ReadNextEntry(entry);
        END;
    END;
    IF useLFN THEN ok:=w9XfindClose(w9Xhandle,errcode); END;
    RETURN lastentry;
END buildFileList;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    shortcuts = arobase+exclam+dollar+pound+ampersand+equal;
CONST
    minparm = 1;
    maxparm = 2;
VAR
    parm : ARRAY [minparm..maxparm] OF str128;
    mfile,remfile,basedir:pathtype;
    cmd : (undefined,
          dump,apply,www,wwwfile,chkpastend,unrem,dumpstrings,delpastend);
    S,R:str128;
    Z:str1024;
    lastparm,lastfile,i,opt:CARDINAL;
    useLFN,stringsonly,keepseplines,enclosed,dotrim,DEBUG:BOOLEAN;
BEGIN
    FIO.IOcheck:=FALSE;
    FIO.ShareMode:=FIO.ShareDenyNone;
    WrLn;

    DEBUG        := FALSE;
    enclosed     := TRUE;
    keepseplines := FALSE;
    stringsonly  := FALSE;
    dotrim       := FALSE;
    cmd          := undefined;
    useLFN       := TRUE;

    lastparm := minparm-1;
    FOR i:=1 TO Lib.ParamCount() DO
        Lib.ParamStr(S,i);cleantabs(S);
        IF isOption(S) = FALSE THEN
            IF Str.Length(S)=SIZE(CHAR) THEN
                IF Str.CharPos(shortcuts,S[0]) # MAX(CARDINAL) THEN
                    Str.Prepend(S,dash);
                END;
            END;
        END;
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   arobase+delim+"W"+delim+"WWW"+delim+
                                   exclam+delim +"F"+delim+"FILTER"+delim+
                                   dollar+delim +"C"+delim+"CHECK"+delim+
                                   pound+delim  +"X"+delim+"UNREM"+delim+"NOREM"+delim+
                                   "XX"+delim+
                                   "K"+delim+"SEPARATION"+delim+
                                   "Q"+delim+"UNQUOTE"+delim+
                                             "NOQUOTES"+delim+"RAW"+delim+

                                   ampersand+delim+"S"+delim+"STRINGS"+delim+
                                   "SS"+delim+
                                   "N"+delim+"NOCODE"+delim+
                                   "L"+delim+"LFN"+delim+
                                   "T"+delim+"TRIM"+delim+
                                   equal+delim+"Z"+delim+"ZAP"+delim+
                                   "DEBUG"
                               );
            CASE opt OF
            | 1,2,3      : WrStr(help);
                           abort("");
            | 4,5,6      : cmd:=www;
            | 7,8,9      : cmd:=wwwfile;
            | 10,11,12   : cmd:=chkpastend;
            | 13,14,15,16: cmd:=unrem;
            | 17         : cmd:=unrem;        keepseplines:=TRUE;
            | 18,19      :                    keepseplines:=TRUE;
            | 20,21,22,23: enclosed:=FALSE;

            | 24,25,26   : cmd:=dumpstrings;
            | 27         : cmd:=dumpstrings;  stringsonly := TRUE;
            | 28,29      :                    stringsonly := TRUE;
            | 30,31      : useLFN := FALSE;
            | 32,33      : dotrim := TRUE;
            | 34,35,36   : cmd:=delpastend;
            | 37         : DEBUG := TRUE;
            ELSE
                abort("Illegal option !");
            END;
        ELSE
            INC(lastparm);
            IF lastparm > maxparm THEN abort("Too many parameters !");END;
            parm[lastparm]:=S;
        END;
    END;

    useLFN := (useLFN AND fileSupportLFN() );

    CASE lastparm OF
    | minparm-1:
        (* abort("Parameters expected !"); *)
        WrStr(help);
        abort("");
    | minparm:
        Str.Copy(mfile, parm[minparm]);
        IF cmd = undefined THEN
            cmd:=dump;
        ELSE
            IF enclosed=FALSE THEN abort("-q requires syntax 1 !");END;
        END;
    | minparm+1:
        Str.Copy(mfile, parm[minparm]);
        Str.Copy(remfile,parm[minparm+1]);
        IF cmd = undefined THEN
            cmd:=apply;
        ELSE
            abort("Unexpected command for syntax 2 !");
        END;
        IF enclosed=FALSE THEN abort("-q requires syntax 1 !");END;
    END;

    IF chkUD(mfile)=FALSE THEN abort("Bad file specification !");END;

    IF same(mfile,dot) THEN abort('For user safety, "." is not allowed !');END;
    IF same(mfile,stardotstar) THEN abort('For user safety, "*.*" is not allowed !');END;
    IF Str.Match(mfile,"*"+antislash) THEN Str.Append(mfile,stardotstar); END;
    IF Str.RCharPos(mfile,dot)=MAX(CARDINAL) THEN Str.Append(mfile,extMOD);END;

    IF chkJoker(mfile)=FALSE THEN
        IF fileIsDirectorySpec ( useLFN,mfile) THEN
            fixDirectory(mfile);
            Str.Append(mfile,stardotstar);
        END;
    END;
    makebase(useLFN,mfile,basedir);

    CASE cmd OF
    | apply:
        IF chkJoker(mfile) THEN abort("Jokers are not allowed with syntax 2 !");END;
    ELSE
        ;
    END;

    (* let's go now ! *)

    lastfile := buildFileList(FALSE, useLFN,mfile); (* FALSE is noskip *)
    CASE lastfile OF
    | firstFile-1:
         Str.Concat(S,"No match for ",mfile);Str.Append (S," !");
         abort(S);
    | MAX(CARDINAL) :
         Str.Concat(S,"Too many files match ",mfile);Str.Append(S," !");
         abort(S);
    END;

    CASE cmd OF
    | apply:                                             (* syntax 2 *)
        IF chkJoker(remfile) THEN
            S:="Jokers not allowed !";
            abort(S);
        END;
        IF fileExists(useLFN,remfile)=FALSE THEN
            Str.Concat(S,remfile," does not exist !");
            abort(S);
        END;
        IF doapply(useLFN,DEBUG,mfile,remfile)=FALSE THEN
            S:="Storage.ALLOCATE() failure while reading edited remarks !";
            abort(S);
        END;
    ELSE
        FOR i:=firstFile TO lastfile DO
            Str.Concat(mfile,basedir,fileentry[i]);
            IF lastfile > firstFile THEN
                Z:=dumpsepline;
                Str.Subst(Z,dollar,mfile);
                WrLn;
                WrLn;
                WrStr(Z);WrLn;
                WrLn;
                WrLn;
            END;
            CASE cmd OF
            | dump:        dodump(useLFN,enclosed,FALSE,FALSE,mfile);
            | www:         dofilter(useLFN,FALSE,mfile,patWWW,patREMclose);
            | wwwfile:     dofilter(useLFN,TRUE ,mfile,patWWW,patREMclose);
            | chkpastend:  doPastEnd(useLFN,FALSE,mfile,patLibStart,patProgStart,patProgEnd);
            | delpastend:  doPastEnd(useLFN,TRUE ,mfile,patLibStart,patProgStart,patProgEnd);
            | unrem:       dodump(useLFN,enclosed,TRUE,keepseplines,mfile);
            | dumpstrings: dostrings(useLFN,stringsonly,dotrim,mfile);
            END;
        END;
    END;
    abort("");
END remMOD.




(*

// TEST.BAT

c:
cd \z

set _s=c:\z\qd_box.mod

echo OLD

set _p=f:\uc\modula\remmod.exe
set _e=.old

copy /B c:\modula\src\qd_box.mod c:\z

%_p% %_s%     > src%_e%
%_p% %_s% -w  > srcW%_e%
%_p% %_s% -c  > srcC%_e%
%_p% %_s% -f
copy *.mod      srcF%_e%
del *.org

echo NEW

set _p=c:\modula\remmod.exe
set _e=.new

copy /B c:\modula\src\qd_box.mod c:\z

%_p% %_s% -x  > srcX%_e%
%_p% %_s% -xx > srcXX%_e%

%_p% %_s%     > src%_e%
%_p% %_s% -w  > srcW%_e%
%_p% %_s% -c  > srcC%_e%
%_p% %_s% -f
copy *.mod      srcF%_e%
del *.org

echo Done !

del %_s%

filecomp *.old *.new

set _e=
set _p=
set _s=

*)






