(* ---------------------------------------------------------------
Title         Q&D Text Generator
Author        PhG
Overview      another useless program
Notes         minimal error messages and checking, etc.
              too many globerks... ;-)
              clipboard works with Win92 and Win98SE but NOT with WinXP :-(

              rules format was inspired by a source found in a Usenet CD,
              SPEW.C, written in 1987 by a Greg Smith
              who himself had rewritten a source written by a "mark@pixar"
              in order to generate "National Enquirer" headlines.
              I liked the "rules" idea but I did not bother
              to try and understand the ugly unreadable C source :
              instead, I created TEXTGEN ex nihilo so it could
              parse SPEW companion rules file, then I added a few features
              and converted to TEXTGEN new rules format many data files
              found with similar (more specialized and often hard-coded)
              novelty programs.
              too bad : at the time I did not consider creating
              a real script language with variables and functions :
              TEXTGEN would have been the equal of the excellent
              "dada engine" without the stupid complication
              *nixians seem to love (FLEX, YACC and the like...)

              maybe I'll rewrite TEXTGEN someday (warning : MaybeWare !)
              when I'm too bothered with DOS memory limits,
              so program can too process a file using programmed rules...

              a new .TX script required strHUGE to grow from 4Kb to 16Kb,
              unexpectedly bringing new compilation and run-time problems,
              thanks to DOS limited memory :
              experimental v1.1i required all strHUGE to become globerks
              and a huge stack in order to avoid weird random crashes

              from v1.1j, a SAFEOUTPUT directive allows
              reverting to older 4Kb strHUGE,
              and a few strHUGEs are local again

              oddly enough, Win32 port using 16Kb strings works
              from Win98SE and WinXP ; using 24Kb strings, it still works
              from WinXP but crashes from Win98SE : go figure...

              catho.tx and rex.tx do require 16Kb version
              pwmix.tx does require 4Kb version

              a PROCTHEM.BAT test batch for *.TX scripts can be created with :

              dirbat *.Tx "echo :: $f$_textgen -mem $c$_pause"

Bugs          getSentence() is not bullet-proof (prevTag and Tag)
              yet another silly TopSpeed M2 bug in heap* (see WORDFREQ.MOD) :
              result is in paragraphs, not in bytes !
              crash if (#) seems too high a value...
              but no logical reason for it !
              (culprit is CRITIQUE.DAT with 15 and 45 count values)
              problem is not solved by large model nor by longcards count !

              well... quirk in fact :
              constant only works for literal strings but not for called class
              because we merely store and freeze an index...
              thus, a \classe entry in a $VAR will always create a new string
              we won't care for now

              DESIGN bug : we did not think of \xxx between curlies :
              categories in variants are NOT supported by findvariant()
              (because escaped sequences are !)

Wish List     stop at 1.1a ! we really need a fully rewritten, more clever
              and not backwards-compatible version 2.0 of the whole thing !
              (operators, functions, better syntax, etc.)

              an operator to put a full word in CAPS ?
              allow change of separators ~ \ / |
              better support for French (ah ah, only serious !)
              read quoted string instead of trimmed verbatim ?
              a real two-passes interpreter with variables and classes ?
              functions such as grab unique token or token other than specified

              handle more French exceptions (/au, ce/cet, ma/mon etc.)
              or add a special flag for French/English processing
              (" de le " --> " du ", "  le " --> " au ", etc.)
              or a macro-like replacement ?
              un flag global avertissant que le texte est  prparer
              en fonction d'une langue (" de le " --> " du ", etc.)
              ou une section rserve avec les remplacements  faire, comme :
              " que  le avenir " --> " qu' l'avenir "

              support for the rather nice "net.charabia.generation"
              written in (yerk !) java by a (smart) Rodrigo Reyes

              support for (excellent) dada and/or scigen engines ?

              a full rewrite with vars and functions
              (so we can easily add markov ?)

              creating password.tx gave us a few ideas for new operators :
              - repeat # times             [#] or (((#)))
              - repeat random[1..#] times  [?#] or (((?#)))
              - grab initial from word     \=
              - choices (a|b|c)

              a better debug should show forward and undefined references

              another syntax clearly needed if we want enhancements

              variants should not be limited to one char ! use comma as delimiter

              allow another escape character such as degree ?
              passim : see //FIXME

              use UpperCaseAlt() instead of UpperCase() for \@ token
              (but we though of this program for English first, eh eh)

              specify ASCII / OEM with an option ?
              add a replacement section (ignoring case or not ?)

              =
              " de le "         " du "
              "  le "          " au "
              " de [aeiouyh]"   " d'[]" ou " d'[aeiouyh]"
              " ce abruti "     " cet abruti "
              " ma/mon "

              partial support for " de le " and "  le "

              math operators ? well, better write a v2.0 !
              make a retrieved string unique ?

              handle categories in variants

--------------------------------------------------------------- *)

MODULE TextGen;

IMPORT Lib;
IMPORT Str;
IMPORT FIO;
IMPORT SYSTEM;
IMPORT MsMouse;
IMPORT BiosIO;
IMPORT IO;

FROM Storage IMPORT Available,ALLOCATE,DEALLOCATE,HeapTotalAvail,MainHeap;

FROM QD_ASCII IMPORT dash, slash, nullchar, tabchar, (* cr, lf, nl, bs, *)
space, dot, deg, doublequote, quote, colon, percent, vbar,
blank, equal, dquote, charnull, singlequote, antislash, dollar,
star, backslash, coma, question, underscore, tabul, hbar,
comma, semicolon, diese, pound, openbracket, closebracket, tilde, exclam,
stardotstar, dotdot, escCh, escSet, letters, digits,
lettersUpp, lettersLow, openbrace, closebrace;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory, qdSplitAllPath,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite, setReadOnly,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs, UpperCaseAlt, LowerCaseAlt,
completedInit, completedShow, completedSHOW, completedEnd, completed,
removeDups, isValidHDunit, removePhantoms, removeFloppies,
getCDROMunits, getCDROMletters, removeCDROMs, getAllHDunits,
getAllLegalUnits, metaproc, getCli, argc, argv;

FROM QD_rand IMPORT InitRnd, GetRnd, GetRndCardRange, GetRndLngCardRange;

FROM QD_File IMPORT pathtype, w9XnothingRequired,
fileOpenRead, fileOpen, fileExists, fileExistsAlt,
fileIsRO, fileSetRW, fileSetRO,
fileErase, fileCreate, fileRename, fileGetFileSize, fileGetFileStamp,
fileIsDirectorySpec, fileClose, fileFlush, fileSupportLFN;

FROM QD_LFN IMPORT path9X, huge9X, findDataRecordType,
unicodeConversionFlagType, w9XchangeDir,
w9XgetDOSversion, w9XgetTrueDOSversion, w9XisWindowsEnh, w9XisMSDOS7,
w9XfindFirst, w9XfindNext, w9XfindClose, w9XgetCurrentDirectory,
w9XlongToShort, w9XshortToLong, w9XtrueName, w9XchangeDir,
w9XmakeDir, w9XrmDir, w9Xrename, w9XopenFile, w9XcloseFile,
w9XsupportLFN;

FROM QD_Text IMPORT
colortype, cursorshapetype, scrolltype,
ff, cr, lf, bs, tab, nl, mincolor, maxcolor,
BW40, CO40, BW80, CO80, CO80x43, CO80x50, MONO,
vesa80x60, vesa132x25, vesa132x43, vesa132x50, vesa132x60,
selectCursorEmulation,
setCursorShape,
handleVesa, setBrightPaper, setBlinkMode,
setFillChar, setFillInk, setFillPaper,
setFillInkPaper, setTxtInk, setTxtPaper, setTxtInkPaper, setWrapMode,
setUseBiosMode, setTabWidth, getScreenData, setWindow,
setMode, restoreMode,
gotoXY, xyToHtabVtab, home, setVisualPage, setActivePage,
scrollWindow, fillTextAttr, cls, writeStr, writeLn, getScreenWidth,
getScreenHeight, getScreenMinX, getScreenMinY, getScreenMaxX, getScreenMaxY,
getMinHtab, getMaxHtab, getMinVtab, getMaxVtab, getUseBiosMode,
getMinHtab, getMaxHtab, getMinVtab, getMaxVtab, getHtab, getVtab,
getWindowWidth, getWindowHeight,
initScreenConsole,
findInkPaperAtStartup, getInkAtStartup, getPaperAtStartup,
setFullScreenWindow, gotoFullScreenXY;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    CULPRIT    = FALSE;
    SAFEOUTPUT = TRUE; (* strHUGE is 4Kb if TRUE, 16Kb if FALSE *)

(*%T SAFEOUTPUT *)
TYPE
    strHUGE  = str4096;
CONST
    maxoutput= "4Kb";
(*%E  *)
(*%F SAFEOUTPUT *)
TYPE
    strHUGE  = ARRAY [0..16384-1] OF CHAR;
CONST
    maxoutput= "16Kb";
(*%E *)

(* ------------------------------------------------------------ *)

TYPE
    str32    = ARRAY [0..32-1] OF CHAR;
CONST
    ProgEXEname   = "TEXTGEN";
    ProgTitle     = "Q&D Text Generator";
    ProgVersion   = "v1.1l";
(*%F CULPRIT *)
    ProgCopyright = "by PhG";
(*%E *)
(*%T CULPRIT  *)
    ProgCopyright = "by Philippe Guiochon";
(*%E  *)
    Banner        = ProgTitle+" "+ProgVersion+" ("+maxoutput+") "+ProgCopyright;
CONST
    extEXE        = ".EXE";
    extDAT        = ".TX"; (* was ".DAT" *)
    exclamation   = exclam;       (* "!" *)
    opencurly     = openbrace;    (* "{" *)
    closecurly    = closebrace;   (* "}" *)
    openparen     = "(";
    closeparen    = ")";
    commercial    = "&";
    arrobas       = "@";
    plus          = "+";
    (* british       = ""; *)
CONST
    IDCLASS       = tilde;      (* "~" *)
    IDVAR         = dollar;     (* "$" *)
    IDINVOKE      = backslash;  (* "\" : must be same as esc char //FIXME at full rewrite *)
    IDVARIANT     = slash;      (* "/" *)
    IDCALLER      = commercial; (* "&" *)
    IDSEPAR       = vbar;
    IDHERIT       = IDVARIANT+IDCALLER;   (* "/&" *)
    IDsuppress    = IDVARIANT+IDVARIANT;  (* "//" is an impossible tag *)
    EMPTYSTRING   = dquote+dquote;
CONST
    lenmarker     = 2; (* "\" plus one character not in [A..Z0..9] *)
    newlinemarker = backslash+exclamation;
    capmarker     = backslash+arrobas;
    lowmarker     = backslash+dollar;
    suffixmarker  = backslash+commercial; (* was +british *)
    elisionmarker = backslash+singlequote; (* in fact, we handle "?\' ?" sequence *)
    articlemarker = backslash+dash; (* in fact, we handle "a\- ?" sequence *)
    packmarker    = backslash+equal;
    concatenatemarker = backslash+plus;
CONST
    escbackslash  = backslash+backslash;
    escopencurly  = backslash+openparen;
    escclosecurly = backslash+closeparen;
CONST
    alphanum        = letters+digits; (* uppercase *)
    legalforcategory= alphanum+underscore; (* // was letters prior to v1.0d, alphanum prior to v1.0e *)
    legalfortag     = alphanum+IDCALLER;
CONST
    vowels          = "AEIOUY";
    elisionRequired = vowels+"H";
    possibleElision = "?"+elisionmarker+space+"?";
    lenpossibleElision = 1+lenmarker+1+1;
CONST
    articleRequired = "AEIOU";
    possibleArticle = "A"+articlemarker+space+"?";
    lenpossibleArticle = 1+lenmarker+1+1;
CONST
    minpause            = 0;
    maxpause            = 30;
    defaultpause        = 1;
    defaultalwayspause  = 2; (* always pause 1 seconds PLUS # s per line *)
CONST
    commentchar1 = semicolon;
    commentchar2 = pound;
    comment1     = "//";
    comment2     = ":::";
    comment3     = "(*";
    comment3a    = "*)";
    IDreserved    = IDCLASS+IDVAR+IDINVOKE+commentchar1+commentchar2+openparen;
CONST
    extBAK          = ".BK!";
    extCOM          = ".COM";
    (* extEXE          = ".EXE"; *)
    extDLL          = ".DLL";
    extOVR          = ".OVR";
    extOVL          = ".OVL";
    extDRV          = ".DRV";
    extZIP          = ".ZIP";
    extARJ          = ".ARJ";
    extLZH          = ".LZH";
    extOBJ          = ".OBJ";
    skippedextensions=extBAK+delim+extCOM+delim+extEXE+delim+
                      extDLL+delim+extOVR+delim+extOVL+delim+extDRV+delim+
                      extZIP+delim+extARJ+delim+extLZH+delim+
                      extOBJ;

CONST
    PBTOOMANY      = MAX(CARDINAL); (* buildfilelist() *)
    ISNOTVAR       = MAX(CARDINAL); (* normal "\class" for .varindex *)
    UNDEFINEDVAR   = 1-1;           (* uninitialized "$variable" for .varindex i.e. 0 *)
    NOWEIGHTHERE   = MAX(CARDINAL); (* isoleweight() *)
    UNDEFINEDCOUNT = MAX(CARDINAL); (* undefined .count *)
    STRNOTFOUND    = MAX(CARDINAL); (* char or string not found in Str. module *)

(* ------------------------------------------------------------ *)

CONST
    (* aliases for our own procedures *)
    WrStr ::= writeStr;
    WrLn  ::= writeLn;
    WrChar::= writeStr;

CONST
    progink   = cyan;
    progpaper = darkblue;

PROCEDURE colorhelp ();
BEGIN
    setTxtInk(getInkAtStartup());      (* was green *)
    setTxtPaper(getPaperAtStartup());  (* was black *)
    setFillInkPaper(getInkAtStartup(),getPaperAtStartup());
END colorhelp;

PROCEDURE colortext (ink,paper:CARDINAL );
BEGIN
    setTxtInk   (VAL(colortype,ink));
    setTxtPaper (VAL(colortype,paper));
    setFillInkPaper(getInkAtStartup(),getPaperAtStartup());
END colortext;

(* ------------------------------------------------------------ *)

CONST
    errNone           = 0;
    errHelp           = 1;
    errOption         = 2;
    errParameter      = 3;
    errBadNumber      = 4;
    errInkRange       = 5;
    errPaperRange     = 6;
    errCountRange     = 7;
    errMALLOC         = 8;
    errFormat         = 9;
    errSentenceTooBig = 10;
    errWidthRange     = 11;
    errJoker          = 12;
    errNotFound       = 13;
    errLoading        = 14;
    errReallyNotFound = 15;
    errVerboseHelp    = 16;
    errPauseRange     = 17;
    errNotInSaverMode = 18;
    errNotInNormalMode= 19;
    errTooManyFiles   = 20;
    errVerboserHelp   = 21;
    errBadJokers      = 22;
    errOnlyForList    = 23;
    errProcSpec       = 24;  (* base *)
    errNetwork        = errProcSpec+0;
    errColon          = errProcSpec+1;
    errUnit           = errProcSpec+2;
    errNoParent       = errProcSpec+3;
    errEmpty          = errProcSpec+4;
    errInnerParent    = errProcSpec+5;
    errDirJoker       = errProcSpec+6;

(* ------------------------------------------------------------ *)

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
    (*
    MODULE message;
    IMPORT Str;
    EXPORT msg3;

    PROCEDURE msg3 (VAR R:ARRAY OF CHAR;S1,S2,S3:ARRAY OF CHAR);
    BEGIN
        Str.Concat(R,S1,S2);Str.Append(R,S3);
    END msg3;

    END message;
    *)
CONST
    placeholder = vbar;
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
     helpmsg=
Banner+nl+
nl+
"Syntax 1 : "+ProgEXEname+" [datafile["+extDAT+"]] [option]..."+nl+
"Syntax 2 : "+ProgEXEname+" <-list> [datafile(s)["+extDAT+"]]"+nl+
nl+
'  -l     show first title line in datafile(s) (default pattern is "'+star+extDAT+'")'+nl+
"  -n:#   count"+nl+
"  -k     remove space from space+{"+semicolon+colon+exclamation+question+"} sequences"+nl+
"  -f:#   frame type (0=none, 1=single, 2=double, 3=raw), default is 0"+nl+
"  -w[w]  wait for keypress or mouseclick (-ww = -w -m)"+nl+
"  -m     ignore mouse if present"+nl+
"  -p[p]  -w[w] with French prompt"+nl+
"  -n     add a newline (CR+LF) in order to beautify display (useful with PEXEC)"+nl+
"  -g     glue output data (no newline added if count > 1 and -f:0)"+nl+
"  -i:#   ink [0..15], default is cyan"+nl+
"  -p:#   paper [0..15], default is dark blue"+nl+
"  -b     monochrome BIOS output (no colors)"+nl+
"  -w:#   set line width, default is screen width"+nl+
"  -s     screensaver mode, end on Escape or Return"+nl+
"  -s:#   in screensaver mode, pause [0..30] in seconds per line, default is 1"+nl+
"  -m:#   in screensaver mode, minimum pause [0..30] in seconds, default is 2"+nl+
"  -z     in screensaver mode, next = left click, quit = right click"+nl+
"  -r     in screensaver mode, randomize position, default is center"+nl+
"  -c     in screensaver mode, do not clear screen at exit"+nl+
"  -y     copy raw text to Vindoze clipboard if available (ignored by -s option)"+nl+
"  -x     disable LFN support even if available"+nl+
"  -??[?] verbose(r) help, including file format and an example"+nl+
nl+
"a) Unless it is specified with a path or with -list option,"+nl+
'   datafile (default is "'+ProgEXEname+extDAT+'") is searched for'+nl+
"   first in current directory, then in executable directory."+nl+
"b) This program does not handle all language exceptions."+nl+
'c) For syntax 2, a legal title line can be "'+commentchar1+" "+comment1+'", "'+
"  "+commentchar1+" "+comment2+'" or "'+commentchar1+" "+comment3+" ... "+comment3a+'".'+nl+
"   Note -list option only displays the first matching title line."+nl+
"d) -y option tries and converts text from DOS ASCII to Win OEM character set."+nl+
"e) Any file with any of the following extensions will be ignored :"+nl+
"   "+skippedextensions+nl+
"f) Dark [0..7] : black, blue, green, cyan, red, magenta, brown and gray."+nl+
"   Bright [8..15] : gray, blue, green, cyan, red, magenta, yellow and white."+nl+
"g) With DR-DOS 6.0 or Novell DOS 7.0, "+ProgEXEname+" can be called after each"+nl+
"   external command by setting SET PEXEC=path\"+ProgEXEname+extEXE+" -n and PROMPT $x$p$g"+nl+
"h) Note this program was compiled for "+maxoutput+" maximum text output."+nl;

    morehelpmsg=
"DATA FILE FORMAT :"+nl+
nl+
"   "+IDCLASS+"class{variant|...}"+nl+
"   {variant|...}entry{variant|...}"+nl+
nl+
'   Use "'+IDINVOKE+'class" to include a class in a class definition.'+nl+
'   Use "'+IDINVOKE+'class/?" to invoke a "\class" with a "/variant id letter".'+nl+
nl+
'a) A category is a unique string (up to 32 chars) beginning with a "'+IDCLASS+'" marker,'+nl+
'   with an optional suffix : a set of variants between "'+opencurly+closecurly+'",'+nl+
"   each variant being identified by a single letter. Case is ignored."+nl+
"   Last category defines the final output. Program can handle 500 categories."+nl+
'   A category beginning with "'+IDVAR+'" instead of "'+IDCLASS+'" defines a global variable'+nl+
"   whose value, once defined at first call, will remain constant. ;-)"+nl+
"b) Each category entry is on its own line, with optional variants specified"+nl+
'   between "'+opencurly+closecurly+'" and separated with inner "'+IDSEPAR+'"'+nl+
'   according to "{[0][|1][|#]...}" pattern (note first letter variant is 1 ;'+nl+
"   note, too, categories are NOT supported in variants)."+nl+
'   "('+pound+')" prefix duplicates the entry # times.'+nl+
"   Please remember each category entry is stored verbatim."+nl+
"   Should an empty string category entry be required, use "+EMPTYSTRING+" form."+nl+
"   Note a verbatim two double quotes entry, if needed, will have to be built."+nl+
'c) A long paragraph can be built from individual lines ending with "'+concatenatemarker+'" marker'+nl+
"   until a line without ending marker."+nl+
'd) "'+IDINVOKE+'" prefix includes a category, an optional variant being specified with "'+IDVARIANT+'"'+nl+
'   followed by its single letter ID ("'+IDHERIT+'" forces use of calling variant).'+nl+
"   Forward references are supported."+nl+
'e) "'+newlinemarker+'" forces a newline, "'+suffixmarker+'" glues together two text units verbatim,'+nl+
'   "'+capmarker+'" forces next word initial to upper case ("'+lowmarker+'" to lower case).'+nl+
'f) If last character of "'+possibleElision+'" sequence belongs to ['+elisionRequired+'] set,'+nl+
"   first character and space will be replaced with a single quote (French)."+nl+
'   Sequence " de'+packmarker+' le " becomes " du " and sequence " '+packmarker+' le " becomes " au ".'+nl+
'g) If last character of "'+possibleArticle+'" sequence belongs to ['+articleRequired+'] set,'+nl+
'   the article "a" will be replaced with the article "an" (English).'+nl+
"h) Should entry first character belong to ["+IDreserved+"] reserved set,"+nl+
'   prefix it with "(1)" ; should an inner character be "'+backslash+'", use "'+escbackslash+'" instead ;'+nl+
'   "'+escopencurly+'" and "'+escclosecurly+'" stand for "'+opencurly+'" and "'+closecurly+'".'+
" Alt-255 is an unbreakable space."+nl+
"i) -dump, -steps and -chkmem options may be of some use for diagnostics."+nl+
"j) Check companion *.TX datafiles to see what can be done using TEXTGEN !"+nl; (* yes, yes, what's the use defining constants AND NOT using them ? ;-) *)

    evenmorehelpmsg =
"EXAMPLE 1 :"+nl+
nl+
"; // this is a mere test for Latin"+nl+
"; nominatif,vocatif,accusatif,gnitif,datif,ablatif SINGULIER = abcdef"+nl+
"; nominatif,vocatif,accusatif,gnitif,datif,ablatif PLURIEL   = ghijkl"+nl+
"~radixRosa"+nl+
"ros"+nl+
"poet"+nl+
"~radixDominus"+nl+
"domin"+nl+
"amic"+nl+
"~declRosa{abcdefghijkl}"+nl+
"{|a|a|am|ae|ae|a|ae|ae|as|arum|is|is}"+nl+
"~declDominus{abcdefghijkl}"+nl+
"{|us|e|um|i|o|o|i|i|os|orum|is|is}"+nl+
"~nom{abcdefghijkl}"+nl+
"\radixRosa\declRosa/&"+nl+
"\radixDominus\declDominus/&"+nl+
"~test"+nl+
"\@\nom/a amat \nom/c"+nl+
"(2)\@\nom/i \nom/g amant"+nl+
"\!\!\@this is a mere test for Latin\!\!"+nl+
nl+
"EXAMPLE 2 :"+nl+
nl+
"~doublequote"+nl+
'"'+nl+
nl+
"~emptystringVerbatim"+nl+
"\doublequote\doublequote"+nl+
nl+
"~emptystringSymbol"+nl+
EMPTYSTRING+nl+
nl+
"~rand"+nl+
"A"+nl+
"B"+nl+
"C"+nl+
"D"+nl+
nl+
"$varname"+nl+
"; will remain constant in script once defined at first call"+nl+
"; note only literal strings are allowed here :"+nl+
"; calling a class will not work"+nl+
"FOO"+nl+
"BAR"+nl+
"FOOBAR"+nl+
"FOOBARBAZ"+nl+
nl+
"$constant"+nl+
"\varname"+nl+
nl+
"# class definition                 : ~* or ~*{?|?|...}"+nl+
"# fixed variable definition        : $*"+nl+
nl+
"; entry count                      : (#)*"+nl+
nl+
"; comment1                         : ;"+nl+
"; comment2                         : #"+nl+
nl+
"; class call                       : \* or \*/? or \*/&"+nl+
nl+
"; escaped sequences"+nl+
"; antislash                        : \\"+nl+
"; newline                          : \!"+nl+
"; initial caps                     : \@"+nl+
"; initial lows                     : \$"+nl+
"; suffix                           : \&"+nl+
"; elision FR                       : \'"+nl+
"; elision US                       : \-"+nl+
"; concatenate                      : \+"+nl+
nl+
"~firstchars"+nl+
"(1)~ tilde"+nl+
"(1)$ dollar"+nl+
"(1)( open parenthesis"+nl+
"(1); comment"+nl+
"(1)# comment"+nl+
"(1)\ backslash"+nl+
nl+
"~anywhere"+nl+
"\\foo\\~$;#(/&\(|\)"+nl+
nl+
"~escaped"+nl+
"\@upper \$LOWER A\&B\!\+"+nl+
"-- ANTISLASH \\\+"+nl+
"-- FRENCH : la\' art la\' science -- ENGLISH : a\- letter a\- alien\+"+nl+
nl+
"~test"+nl+
'Char at first position : \firstchars "\~$;#("\!\+'+nl+
"Char anywhere          : \anywhere\!\+"+nl+
"Escaped chars          : \escaped\!\+"+nl+
"\!\+"+nl+
'If entry first char belongs to "~$(;#" then prefix entry with "(1)"\!\+'+nl+
'If "\" char is needed in an entry then use "\\\\"\!\+'+nl+
"\!\+"+nl+
"\varname = \varname = \varname = \constant\!\rand is not necessarily \rand"+nl+
nl+
'; note supra "\\\\" in source will become "\\" when displayed'+nl;

VAR
    (* S : strHUGE; (* was str256 but we may get a huge string here *) //V11I *)
    abS : strHUGE; (* //V11J *)
BEGIN
    colorhelp();
    CASE e OF
    | errHelp,errVerboseHelp,errVerboserHelp :
        WrLn;
        WrStr(helpmsg);
        CASE e OF
        | errVerboseHelp,errVerboserHelp:
            WrLn;
            WrStr(morehelpmsg);
        END;
        IF e = errVerboserHelp THEN
            WrLn;
            WrStr(evenmorehelpmsg);
        END;
        e:=errHelp;
    | errOption :      abS:='Illegal "'+placeholder+'" option !';
    | errParameter :   abS:='"'+placeholder+'" is just one parameter too many !';
    | errBadNumber:    abS:='Illegal value in "'+placeholder+'" option !';
    | errInkRange:     abS:="Ink range is [0..15] !";
    | errPaperRange:   abS:="Paper range is [0..15] !";
    | errCountRange:   abS:="Count range is [1..1000] !";
    | errMALLOC:       abS:="Storage.ALLOCATE() failed !";
    | errFormat:       abS:='Illegal or undefined tilde command ("'+placeholder+'") !';
    | errSentenceTooBig:abS:="Formatted sentence is too big !";
    | errWidthRange:   abS:="Illegal line width !";
    | errJoker:        abS:='At least one illegal joker in "'+placeholder+'" !';
    | errNotFound:     abS:='No valid file matches "'+placeholder+'" specification !';
    | errLoading:      abS:='Error while loading "'+placeholder+'" !';
    | errReallyNotFound:abS:='No valid file matches "'+placeholder+'" specification !';
    | errPauseRange:   abS:="Pause range is [0..30] !";
    | errNotInSaverMode: Str.Copy(abS,einfo);
    | errNotInNormalMode:Str.Copy(abS,einfo);
    | errTooManyFiles: abS:='Too many files match "'+placeholder+'" specification !';
    | errBadJokers:    abS:='At least one invalid joker in "'+placeholder+'" !';
    | errOnlyForList:  abS:='-list option is required to process "'+placeholder+'" !'; (* containing at least one joker ! *)

    | errNetwork:      abS:='Illegal network reference in "'+placeholder+'" !';
    | errColon:        abS:='":" problem in "'+placeholder+'" !';
    | errUnit:         abS:='Illegal unit in "'+placeholder+'" !';
    | errNoParent:     abS:='"'+placeholder+'" has no parent directory !';
    | errEmpty:        abS:='"'+placeholder+'" contains only unit part !';
    | errInnerParent:  abS:='Illegal inner parent in "'+placeholder+'" !';
    | errDirJoker:     abS:='At least one illegal joker in "'+placeholder+'" path !';
    ELSE
        abS := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone, errHelp: ;
    ELSE
        Str.Subst(abS,placeholder,einfo);
        WrLn;
        WrStr(ProgEXEname+" : "); WrStr(abS); WrLn;
    END;
    Lib.SetReturnCode(SHORTCARD(e));
    HALT;
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* taken almost verbatim from OLDNEW v1.1f and TRIM v1.1 code, out of weariness *)

TYPE
    pFname = POINTER TO fnameType;
    fnameType = RECORD
        next      : pFname;
        slen      : CARDINAL; (* a SHORTCARD could do but who knows ? *)
        str       : CHAR;
    END;

PROCEDURE initList (VAR anchor : pFname );
BEGIN
    anchor := NIL;
END initList;

PROCEDURE freeList (anchor : pFname);
VAR
    needed : CARDINAL;
    p      : pFname;
BEGIN
    (* p:=anchor; *)
    WHILE anchor # NIL DO
        needed := SIZE(fnameType) - SIZE(anchor^.str) + anchor^.slen;
        p := anchor^.next;
        DEALLOCATE(anchor,needed);
        anchor:=p;
    END
END freeList;

PROCEDURE buildNewPtr (VAR anchor,p:pFname; len:CARDINAL):BOOLEAN;
VAR
    needed : CARDINAL;
BEGIN
    needed := SIZE(fnameType) - SIZE(p^.str) + len;
    IF Available(needed)=FALSE THEN RETURN FALSE; END;
    IF anchor = NIL THEN
        ALLOCATE(anchor,needed);
        p:=anchor;
    ELSE
        p:=anchor;
        WHILE p^.next # NIL DO
            p:=p^.next;
        END;
        ALLOCATE(p^.next,needed);
        p:=p^.next;
    END;
    p^.next := NIL;
    RETURN TRUE;
END buildNewPtr;

(* assume p is valid *)

PROCEDURE getStr (VAR S : pathtype; p:pFname);
VAR
    len:CARDINAL;
BEGIN
    len := p^.slen;
    Lib.FastMove( ADR(p^.str),ADR(S),len);
    S[len] := nullchar; (* REQUIRED safety ! *)
END getStr;

(* ------------------------------------------------------------ *)

(* Str.Match is not case sensitive *)

PROCEDURE isReservedPattern (S,skipthem:ARRAY OF CHAR):BOOLEAN;
VAR
    e3 : str16;
    n:CARDINAL;
    rc:BOOLEAN;
BEGIN
    rc:=FALSE;
    n:=0;
    LOOP
        isoleItemS(e3, skipthem,delim,n);
        IF same(e3,"") THEN EXIT; END;
        Str.Prepend(e3,"*");
        IF Str.Match(S,e3) THEN rc:=TRUE;EXIT; END;
        INC(n);
    END;
    RETURN rc;
END isReservedPattern;

PROCEDURE isReservedEntry (S:ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dotdot);
END isReservedEntry;

PROCEDURE buildFileList (VAR anchor:pFname;
                        noskip,useLFN,DEBUG :BOOLEAN;
                        spec:pathtype):CARDINAL;
VAR
    count:CARDINAL; (* should do ! *)
    ok,found:BOOLEAN;
    unicodeconversion:unicodeConversionFlagType;
    w9Xentry : findDataRecordType;
    w9Xhandle,errcode:CARDINAL;
    entry : FIO.DirEntry;
    dosattr:FIO.FileAttr;
    entryname:pathtype;
    len : CARDINAL;
    pp:pFname;
    excludeme1,excludeme2:BOOLEAN;
BEGIN
    count:=0;
    IF useLFN THEN
        found := w9XfindFirst (spec,SHORTCARD(everything),SHORTCARD(w9XnothingRequired),
                              unicodeconversion,w9Xentry,w9Xhandle,errcode);
    ELSE
        found := FIO.ReadFirstEntry(spec,everything,entry);
    END;
    WHILE found DO
        IF useLFN THEN
            Str.Copy(entryname,w9Xentry.fullfilename);
        ELSE
            Str.Copy(entryname,entry.Name);
        END;
        excludeme1 := isReservedEntry   (entryname);  (* skip "." and ".." *)
        IF noskip THEN
            excludeme2 := FALSE;
        ELSE
            excludeme2 := isReservedPattern (entryname,skippedextensions );
        END;
        IF NOT(excludeme1 OR excludeme2) THEN
            IF useLFN THEN
                dosattr:=FIO.FileAttr(w9Xentry.attr AND 0FFH);
            ELSE
                dosattr:=entry.attr;
            END;
            IF NOT (aD IN dosattr) THEN
                (* if file has no extension, add it as a marker *)
                IF Str.RCharPos(entryname,".")=STRNOTFOUND THEN
                    Str.Append(entryname,".");
                END;
                IF DEBUG THEN WrStr("Included : ");WrStr(entryname);WrLn; END;
                len:=Str.Length(entryname);
                IF buildNewPtr(anchor,pp,len)=FALSE THEN
                    IF useLFN THEN ok:=w9XfindClose(w9Xhandle,errcode); END;
                    RETURN PBTOOMANY; (* errStorage *)
                END;
                INC(count);
                pp^.slen      := len;
                Lib.FastMove ( ADR(entryname),ADR(pp^.str),len );
            ELSE
                IF DEBUG THEN WrStr("Ignored  : ");WrStr(entryname);WrLn;END;
            END;
        ELSE
            IF DEBUG THEN WrStr("Excluded : ");WrStr(entryname);WrLn;END;
        END;
        IF useLFN THEN
            found :=w9XfindNext(w9Xhandle, unicodeconversion,w9Xentry,errcode);
        ELSE
            found :=FIO.ReadNextEntry(entry);
        END;
    END;
    IF useLFN THEN ok:=w9XfindClose(w9Xhandle,errcode); END;
    RETURN count;
END buildFileList;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBuffer  = ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
VAR
    bufferIn  : ioBuffer;

CONST
    mincount    = 1;
    maxcount    = 1000;
    frameNone   = 0;
    frameSingle = 1;
    frameDouble = 2;
    frameRaw    = 3;
    minframe    = frameNone;
    maxframe    = frameRaw;
    msgWait     = "Hit any key to continue... ";
    msgWaitMouse  = "Hit any key or click any mouse button to continue... ";
    msgWaitFR     = "Appuyez sur une touche pour continuer... ";
    msgWaitMouseFR= "Appuyez sur une touche ou sur un bouton pour continuer... ";

(* ------------------------------------------------------------ *)

PROCEDURE pack (VAR S : ARRAY OF CHAR;dumb:BOOLEAN; older,newer:ARRAY OF CHAR);
VAR
    p,pold,lenold,lennew:CARDINAL;
BEGIN
    IF dumb THEN (* will pack repeatedly *)
        LOOP
            IF Str.Pos(S,older)=STRNOTFOUND THEN EXIT; END;
            Str.Subst(S,older,newer);
        END;
    ELSE (* won't eat "\\\\\" to "\" *)
        lenold:=Str.Length(older); (* normally 2 *)
        lennew:=Str.Length(newer); (* normally 1 *)
        p:=10;
        LOOP
            pold:=Str.NextPos(S,older,p);
            IF pold = STRNOTFOUND THEN EXIT; END;
            Str.Delete(S,pold,lenold);
            Str.Insert(S,newer,pold);
            INC(pold,lennew);
            p:=pold;
        END;
    END;
END pack;

(*
    almost useless, for data was already verified,
    but as our dmpTTX proc does not check punctuation marks...
*)

PROCEDURE cleanstring (fullclean:BOOLEAN; VAR S : ARRAY OF CHAR);
CONST
    dumb=TRUE;
BEGIN
    pack(S,dumb,space+space      ,space);
    pack(S,dumb,space+dot        ,dot);
    pack(S,dumb,space+comma      ,comma);
    IF fullclean THEN
    pack(S,dumb,space+semicolon  ,semicolon);
    pack(S,dumb,space+colon      ,colon);
    pack(S,dumb,space+exclamation,exclamation);
    pack(S,dumb,space+question   ,question);
    END;
END cleanstring;

CONST
    firstline = 1;
    maxline   = 500; (* was 50, already oversized ! *)
VAR
    sline  : ARRAY [firstline..maxline] OF str128; (* str144 would create too large an object *)
    slen   : ARRAY [firstline..maxline] OF CARDINAL;

CONST
    (*            012345     *)
    sSingle    = "ڳ";
    sDouble    = "ɺͼ";
    sNone      = "      ";
    wiHORIZ    = 4; (* bar, space, ... , space, bar *)
    wiVERTI    = 4; (* line, filler, ... , filler, line *)
    wiHORIZalt = 2; (* space, ... , space *)
    wiVERTIalt = 2; (* filler, ... , filler *)

(* uses global sline[] and slen[] arrays *)

PROCEDURE dmpSentence (screenwidth,linewidth,doFrame:CARDINAL;
                      redirected,doBeautify,glue:BOOLEAN;
                      lastline,longest:CARDINAL);
VAR
    plus,len,i,j,k    : CARDINAL;
    frameChars   : str16;
    S            : str128;
    neednl:BOOLEAN;
BEGIN
    len := longest;

    CASE doFrame OF
    | frameNone   : frameChars := sNone;   plus:=0;
    | frameSingle : frameChars := sSingle; plus:=2;
    | frameDouble : frameChars := sDouble; plus:=2;
    END;

    CASE doFrame OF
    | frameRaw :
        IF NOT(glue) THEN WrLn;END;

        FOR j:=firstline TO lastline DO
            WrStr(sline[j]);
            neednl :=( slen[j] < linewidth );
            neednl :=(neednl OR redirected);
            neednl :=(neednl OR (linewidth # screenwidth) ); (* < *)
            IF neednl THEN WrLn; END;
        END;

    ELSE
        neednl := ((1+len+plus+1) < linewidth );
        neednl := (neednl OR redirected);
        neednl := (neednl OR (linewidth # screenwidth)); (* < *)

        WrLn;
        WrChar(frameChars[0]);
        FOR i:=1 TO (len+plus) DO WrChar(frameChars[4]); END;
        WrChar(frameChars[2]);
        IF neednl THEN WrLn; END;

        IF doFrame # frameNone THEN
            WrChar(frameChars[1]);
            FOR i:=1 TO (len+plus) DO WrChar(space); END;
            WrChar(frameChars[1]);
            IF neednl THEN WrLn; END;
        END;

        FOR j:=firstline TO lastline DO
            WrChar(frameChars[1]);
            IF doFrame # frameNone THEN WrChar(space); END;
            WrStr(sline[j]);
            FOR k:=Str.Length(sline[j])+1 TO len DO
                WrChar(space);
            END;
            IF doFrame # frameNone THEN WrChar(space); END;
            WrChar(frameChars[1]);
            IF neednl THEN WrLn; END;
        END;

        IF doFrame # frameNone THEN
            WrChar(frameChars[1]);
            FOR i:=1 TO (len+plus) DO WrChar(space); END;
            WrChar(frameChars[1]);
            IF neednl THEN WrLn; END;
        END;

        WrChar(frameChars[3]);
        FOR i:=1 TO (len+plus) DO WrChar(frameChars[4]); END;
        WrChar(frameChars[5]);
        IF neednl THEN WrLn; END;
    END;
    IF doBeautify THEN WrLn; END;
END dmpSentence;

(* ------------------------------------------------------------ *)

(* try not to recurse nor overlap *)

PROCEDURE oldnewX (VAR R:ARRAY OF CHAR;oldstr,newstr:str16);
VAR
    p,newp,oldlen,newlen:CARDINAL;
BEGIN
    IF same(oldstr,newstr) THEN RETURN; END; (* avoid nonsense *)

    oldlen:=Str.Length(oldstr);
    newlen:=Str.Length(newstr);
    p:=0;
    LOOP
        newp:=Str.NextPos(R,oldstr,p);
        IF newp = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(R,newp,oldlen);
        Str.Insert(R,newstr,newp);
        p:=newp+newlen;
        IF p >= Str.Length(R) THEN EXIT; END;
    END;
END oldnewX;

PROCEDURE cleanescaped (VAR S:ARRAY OF CHAR); (* //FIXME *)
CONST
    dumb = FALSE;
BEGIN
    pack(S,dumb,escbackslash        ,backslash);
    (* //FIXME handle other reserved chars too ? *)
    pack(S,dumb,escopencurly        ,opencurly);
    pack(S,dumb,escclosecurly       ,closecurly);
END cleanescaped;

PROCEDURE autocapitalize (VAR S : ARRAY OF CHAR);
VAR
    p : CARDINAL;
    c : CHAR;
BEGIN
    LOOP
        p:=Str.Pos(S,capmarker);
        IF p=STRNOTFOUND THEN EXIT; END;
        Str.Subst(S,capmarker,"");
        c:=S[p];
        IF c # nullchar THEN
            UpperCaseAlt(c); (* //V11H *)
            S[p]:=c;
        END;
    END;
END autocapitalize;

PROCEDURE autolow (VAR S : ARRAY OF CHAR);
VAR
    p : CARDINAL;
    c : CHAR;
BEGIN
    LOOP
        p:=Str.Pos(S,lowmarker);
        IF p=STRNOTFOUND THEN EXIT; END;
        Str.Subst(S,lowmarker,"");
        c:=S[p];
        IF c # nullchar THEN
            LowerCaseAlt(c); (* //V11H *)
            S[p]:=c;
        END;
    END;
END autolow;

(* identical to pack("\&","") ! *)

PROCEDURE autosuffix (VAR S : ARRAY OF CHAR);
VAR
    p : CARDINAL;
    c : CHAR;
BEGIN
    LOOP
        p:=Str.Pos(S,suffixmarker);
        IF p=STRNOTFOUND THEN EXIT; END;
        Str.Subst(S,suffixmarker,"");
    END;
END autosuffix;

PROCEDURE autoelision (n:CARDINAL;VAR S : ARRAY OF CHAR);
VAR
    prevp,p : CARDINAL;
    c       : CHAR;
    seq     : str16;
BEGIN
    IF Str.Length(S)=0 THEN RETURN; END; (* don't bother ! *)

    CASE n OF
    | 1 :
         (*
         handle "?\' ?" sequence only, i.e. character, elision marker, space, character
                 01234
         *)
         prevp:=1; (* ignore possible "\'" at the beginning of S *)
         LOOP
             p:=Str.NextPos(S,elisionmarker,prevp); (* "\'" *)
             IF p= STRNOTFOUND THEN EXIT; END;
             Str.Slice(seq, S, p-1, lenpossibleElision);
             IF Str.Match(seq,possibleElision) THEN
                 c:=S[p-1+lenpossibleElision-1];
                 UpperCase(c);
                 IF Belongs(elisionRequired,c) THEN
                     Str.Delete(S,p-1,lenpossibleElision-1);    (* remove "?\' " *)
                     Str.Insert(S,singlequote,p-1); (* insert "'" *)
                     prevp:=p;                      (* restart after the single quote we just inserted *)
                 ELSE
                     Str.Delete(S,p,lenmarker); (* just remove elision marker, leaving first character and space *)
                     prevp:=p; (* yes, we could restart after last character...  *)
                 END;
             ELSE
                 prevp:=p+lenmarker; (* skip "\'" marker *)
             END;
         END;
    | 2:
         (*
         brutal and even kludgy for letter case
         does not handle all possible cases such as "\! le"
         (would require a "previous char not letter" operator)
         DOS and Vindoze accents : zut !
         we know it and we won't care until v2.0
         *)
         oldnewX(S," de"+packmarker+" le "," du ");
         oldnewX(S," De"+packmarker+" le "," Du ");
         oldnewX(S," DE"+packmarker+" LE "," DU ");

         oldnewX(S," "+packmarker+" le "," au ");
         oldnewX(S," A"+packmarker+" le "," Au ");
         oldnewX(S," A"+packmarker+" LE "," AU ");

         oldnewX(S,packmarker,"");

         (* handle " ce\' [aeiouyh]? " => " cet " *)
    END;
END autoelision;

(*
   handle "A\- ?" sequence only, i.e. "a", article marker, space, character
           01234
*)

PROCEDURE autoarticle (VAR S : ARRAY OF CHAR);
VAR
    prevp,p : CARDINAL;
    c,ourA,ourN : CHAR;
    seq     : str16;
BEGIN
    IF Str.Length(S)=0 THEN RETURN; END; (* don't bother ! *)
    prevp:=1; (* ignore possible "\-" at the beginning of S *)
    LOOP
        p:=Str.NextPos(S,articlemarker,prevp);
        IF p= STRNOTFOUND THEN EXIT; END;
        Str.Slice(seq, S, p-1, lenpossibleArticle);
        UpperCase(seq);
        IF Str.Match(seq,possibleArticle) THEN
            c:=S[p-1+lenpossibleArticle-1];
            UpperCase(c);
            IF Belongs(articleRequired,c) THEN
                ourA := S[p-1];
                (* it's "A" or "a" *)
                IF ourA = "A" THEN
                    ourN := "n"; (* too smart ! *)
                ELSE
                    ourN := "n";
                END;
                Str.Delete(S,p,lenmarker);     (* remove "\-" *)
                Str.Insert(S,ourN,p);  (* insert "N" or "n" *)
                prevp:=p+1;            (* restart after the added letter *)
            ELSE
                Str.Delete(S,p,lenmarker); (* just remove article marker *)
                prevp:=p; (* yes, we could restart after last character...  *)
            END;
        ELSE
            prevp:=p+lenmarker; (* skip "\-" marker *)
        END;
    END;
END autoarticle;

(* uses global sline[] and slen[] arrays *)

VAR
    fsZ : strHUGE;

PROCEDURE formatSentence (LineWidth,doFrame:CARDINAL;fullclean:BOOLEAN;
                          VAR lastline,longest:CARDINAL;S:ARRAY OF CHAR):BOOLEAN;
VAR
    tmplen  : CARDINAL;
    tmp               : str256;   (* could be str128 but... *)
    splitagain        : BOOLEAN;
    p                 : CARDINAL;
    (* Z                 : strHUGE;  (* just in CASE *) //V11I *)
BEGIN
    cleanstring(fullclean,S);
    cleanescaped(S);
    autocapitalize(S);
    autolow(S);
    autosuffix(S);
    autoelision(1,S); (* FR 1 *)
    autoelision(2,S); (* FR 2 *)
    autoarticle(S); (* US *)

    CASE doFrame OF
    | frameRaw : ;
    | frameNone:
        DEC(LineWidth,wiHORIZalt); (* string + 2 spaces *)
    ELSE
        DEC(LineWidth,wiHORIZ);    (* string + 2 spaces + 2 bars *)
    END;

    lastline  := firstline-1;
    longest   := 0;

    LOOP
        p:=Str.Pos(S,newlinemarker);
        IF p = STRNOTFOUND THEN EXIT; END;
        Str.Slice(fsZ,S,0,p);
        Str.Delete(S,0,p+lenmarker); (* "\!" CRLF marker takes two characters *)

        splitagain:=dmpTTX(fsZ,LineWidth,tmp,TRUE);
        WHILE splitagain DO
            Str.Copy(sline[firstline+lastline],tmp);
            tmplen:=Str.Length(tmp);
            slen[firstline+lastline]:=tmplen;
            IF tmplen > longest THEN longest := tmplen; END;
            INC(lastline);
            IF lastline >= maxline THEN RETURN FALSE; END;
            splitagain:=dmpTTX(fsZ,LineWidth,tmp,FALSE);
        END;
        IF Str.Pos(S,newlinemarker)=0 THEN
            Str.Copy(sline[firstline+lastline], "");
            slen[firstline+lastline]:=0;
            INC(lastline);
            IF lastline >= maxline THEN RETURN FALSE; END;
        END;
    END;

        splitagain:=dmpTTX(S,LineWidth,tmp,TRUE);
        WHILE splitagain DO
            Str.Copy(sline[firstline+lastline],tmp);
            tmplen:=Str.Length(tmp);
            slen[firstline+lastline]:=tmplen;
            IF tmplen > longest THEN longest := tmplen; END;
            INC(lastline);
            IF lastline >= maxline THEN RETURN FALSE; END;
            splitagain:=dmpTTX(S,LineWidth,tmp,FALSE);
        END;

    RETURN TRUE;
END formatSentence;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* ripped and adapted from old PC2WIN v1.0a last revised 29 Apr 00 *)

TYPE
    chardef   = RECORD
                    Code    : BYTE;
                    Flag    : CHAR;
                    MapChar : BYTE;
                END;
    CharTable = ARRAY [0..255] OF chardef;

CONST
    TpcTOwin  = CharTable (
    chardef(000H, "=", 000H),
    chardef(001H, "=", 001H),
    chardef(002H, "=", 002H),
    chardef(003H, "=", 003H),
    chardef(004H, "=", 004H),
    chardef(005H, "=", 005H),
    chardef(006H, "=", 006H),
    chardef(007H, "=", 007H),
    chardef(008H, "=", 008H),
    chardef(009H, "!", 009H),
    chardef(00AH, "=", 00AH),
    chardef(00BH, "=", 00BH),
    chardef(00CH, "=", 00CH),
    chardef(00DH, "=", 00DH),
    chardef(00EH, "=", 00EH),
    chardef(00FH, "=", 00FH),
    chardef(010H, "=", 010H),
    chardef(011H, "=", 011H),
    chardef(012H, "=", 012H),
    chardef(013H, "=", 013H),
    chardef(014H, "!", 0B6H),
    chardef(015H, "!", 0A7H),
    chardef(016H, "=", 016H),
    chardef(017H, "=", 017H),
    chardef(018H, "=", 018H),
    chardef(019H, "=", 019H),
    chardef(01AH, "=", 01AH),
    chardef(01BH, "=", 01BH),
    chardef(01CH, "=", 01CH),
    chardef(01DH, "=", 01DH),
    chardef(01EH, "=", 01EH),
    chardef(01FH, "=", 01FH),
    chardef(020H, "=",  " "),
    chardef(021H, "=",  "!"),
    chardef(022H, "=",  '"'),
    chardef(023H, "=",  "#"),
    chardef(024H, "=",  "$"),
    chardef(025H, "=",  "%"),
    chardef(026H, "=",  "&"),
    chardef(027H, "=",  "'"),
    chardef(028H, "=",  "("),
    chardef(029H, "=",  ")"),
    chardef(02AH, "=",  "*"),
    chardef(02BH, "=",  "+"),
    chardef(02CH, "=",  ","),
    chardef(02DH, "=",  "-"),
    chardef(02EH, "=",  "."),
    chardef(02FH, "=",  "/"),
    chardef(030H, "=",  "0"),
    chardef(031H, "=",  "1"),
    chardef(032H, "=",  "2"),
    chardef(033H, "=",  "3"),
    chardef(034H, "=",  "4"),
    chardef(035H, "=",  "5"),
    chardef(036H, "=",  "6"),
    chardef(037H, "=",  "7"),
    chardef(038H, "=",  "8"),
    chardef(039H, "=",  "9"),
    chardef(03AH, "=",  ":"),
    chardef(03BH, "=",  ";"),
    chardef(03CH, "=",  "<"),
    chardef(03DH, "=",  "="),
    chardef(03EH, "=",  ">"),
    chardef(03FH, "=",  "?"),
    chardef(040H, "=",  "@"),
    chardef(041H, "=",  "A"),
    chardef(042H, "=",  "B"),
    chardef(043H, "=",  "C"),
    chardef(044H, "=",  "D"),
    chardef(045H, "=",  "E"),
    chardef(046H, "=",  "F"),
    chardef(047H, "=",  "G"),
    chardef(048H, "=",  "H"),
    chardef(049H, "=",  "I"),
    chardef(04AH, "=",  "J"),
    chardef(04BH, "=",  "K"),
    chardef(04CH, "=",  "L"),
    chardef(04DH, "=",  "M"),
    chardef(04EH, "=",  "N"),
    chardef(04FH, "=",  "O"),
    chardef(050H, "=",  "P"),
    chardef(051H, "=",  "Q"),
    chardef(052H, "=",  "R"),
    chardef(053H, "=",  "S"),
    chardef(054H, "=",  "T"),
    chardef(055H, "=",  "U"),
    chardef(056H, "=",  "V"),
    chardef(057H, "=",  "W"),
    chardef(058H, "=",  "X"),
    chardef(059H, "=",  "Y"),
    chardef(05AH, "=",  "Z"),
    chardef(05BH, "=",  "["),
    chardef(05CH, "=",  "\"),
    chardef(05DH, "=",  "]"),
    chardef(05EH, "=",  "^"),
    chardef(05FH, "=",  "_"),
    chardef(060H, "=",  "`"),
    chardef(061H, "=",  "a"),
    chardef(062H, "=",  "b"),
    chardef(063H, "=",  "c"),
    chardef(064H, "=",  "d"),
    chardef(065H, "=",  "e"),
    chardef(066H, "=",  "f"),
    chardef(067H, "=",  "g"),
    chardef(068H, "=",  "h"),
    chardef(069H, "=",  "i"),
    chardef(06AH, "=",  "j"),
    chardef(06BH, "=",  "k"),
    chardef(06CH, "=",  "l"),
    chardef(06DH, "=",  "m"),
    chardef(06EH, "=",  "n"),
    chardef(06FH, "=",  "o"),
    chardef(070H, "=",  "p"),
    chardef(071H, "=",  "q"),
    chardef(072H, "=",  "r"),
    chardef(073H, "=",  "s"),
    chardef(074H, "=",  "t"),
    chardef(075H, "=",  "u"),
    chardef(076H, "=",  "v"),
    chardef(077H, "=",  "w"),
    chardef(078H, "=",  "x"),
    chardef(079H, "=",  "y"),
    chardef(07AH, "=",  "z"),
    chardef(07BH, "=",  "{"),
    chardef(07CH, "=",  "|"),
    chardef(07DH, "=",  "}"),
    chardef(07EH, "=",  "~"),
    chardef(07FH, "?",  " "),
    chardef(080H, "=", 0C7H),
    chardef(081H, "=", 0FCH),
    chardef(082H, "=", 0E9H),
    chardef(083H, "=", 0E2H),
    chardef(084H, "=", 0E4H),
    chardef(085H, "=", 0E0H),
    chardef(086H, "=", 0E5H),
    chardef(087H, "=", 0E7H),
    chardef(088H, "=", 0EAH),
    chardef(089H, "=", 0EBH),
    chardef(08AH, "=", 0E8H),
    chardef(08BH, "=", 0EFH),
    chardef(08CH, "=", 0EEH),
    chardef(08DH, "=", 0ECH),
    chardef(08EH, "=", 0C4H),
    chardef(08FH, "=", 0C5H),
    chardef(090H, "=", 0C9H),
    chardef(091H, "=", 0E6H),
    chardef(092H, "=", 0C6H),
    chardef(093H, "=", 0F4H),
    chardef(094H, "=", 0F6H),
    chardef(095H, "=", 0F2H),
    chardef(096H, "=", 0FBH),
    chardef(097H, "=", 0F9H),
    chardef(098H, "=", 0FFH),
    chardef(099H, "=", 0D6H),
    chardef(09AH, "=", 0DCH),
    chardef(09BH, "=", 0A2H),
    chardef(09CH, "=", 0A3H),
    chardef(09DH, "=", 0A5H),
    chardef(09EH, "?",  " "),
    chardef(09FH, "?",  " "),
    chardef(0A0H, "=", 0E1H),
    chardef(0A1H, "=", 0EDH),
    chardef(0A2H, "=", 0F3H),
    chardef(0A3H, "=", 0FAH),
    chardef(0A4H, "=", 0F1H),
    chardef(0A5H, "=", 0D1H),
    chardef(0A6H, "=", 0AAH),
    chardef(0A7H, "=", 0BAH),
    chardef(0A8H, "=", 0BFH),
    chardef(0A9H, "?",  " "),
    chardef(0AAH, "=", 0ACH),
    chardef(0ABH, "=", 0BDH),
    chardef(0ACH, "=", 0BCH),
    chardef(0ADH, "=", 0A1H),
    chardef(0AEH, "=", 0ABH),
    chardef(0AFH, "=", 0BBH),
    chardef(0B0H, "@",  " "),
    chardef(0B1H, "@",  " "),
    chardef(0B2H, "@",  " "),
    chardef(0B3H, "@",  " "),
    chardef(0B4H, "@",  " "),
    chardef(0B5H, "@",  " "),
    chardef(0B6H, "@",  " "),
    chardef(0B7H, "@",  " "),
    chardef(0B8H, "@",  " "),
    chardef(0B9H, "@",  " "),
    chardef(0BAH, "@",  " "),
    chardef(0BBH, "@",  " "),
    chardef(0BCH, "@",  " "),
    chardef(0BDH, "@",  " "),
    chardef(0BEH, "@",  " "),
    chardef(0BFH, "@",  " "),
    chardef(0C0H, "@",  " "),
    chardef(0C1H, "@",  " "),
    chardef(0C2H, "@",  " "),
    chardef(0C3H, "@",  " "),
    chardef(0C4H, "@",  " "),
    chardef(0C5H, "@",  " "),
    chardef(0C6H, "@",  " "),
    chardef(0C7H, "@",  " "),
    chardef(0C8H, "@",  " "),
    chardef(0C9H, "@",  " "),
    chardef(0CAH, "@",  " "),
    chardef(0CBH, "@",  " "),
    chardef(0CCH, "@",  " "),
    chardef(0CDH, "@",  " "),
    chardef(0CEH, "@",  " "),
    chardef(0CFH, "@",  " "),
    chardef(0D0H, "@",  " "),
    chardef(0D1H, "@",  " "),
    chardef(0D2H, "@",  " "),
    chardef(0D3H, "@",  " "),
    chardef(0D4H, "@",  " "),
    chardef(0D5H, "@",  " "),
    chardef(0D6H, "@",  " "),
    chardef(0D7H, "@",  " "),
    chardef(0D8H, "@",  " "),
    chardef(0D9H, "@",  " "),
    chardef(0DAH, "@",  " "),
    chardef(0DBH, "@",  " "),
    chardef(0DCH, "@",  " "),
    chardef(0DDH, "@",  " "),
    chardef(0DEH, "@",  " "),
    chardef(0DFH, "@",  " "),
    chardef(0E0H, "?",  " "),
    chardef(0E1H, "=", 0DFH),
    chardef(0E2H, "?",  " "),
    chardef(0E3H, "?",  " "),
    chardef(0E4H, "?",  " "),
    chardef(0E5H, "?",  " "),
    chardef(0E6H, "=", 0B5H),
    chardef(0E7H, "?",  " "),
    chardef(0E8H, "?",  " "),
    chardef(0E9H, "?",  " "),
    chardef(0EAH, "?",  " "),
    chardef(0EBH, "?",  " "),
    chardef(0ECH, "?",  " "),
    chardef(0EDH, "=", 0D8H),
    chardef(0EEH, "?",  " "),
    chardef(0EFH, "?",  " "),
    chardef(0F0H, "?",  " "),
    chardef(0F1H, "=", 0B1H),
    chardef(0F2H, "?",  " "),
    chardef(0F3H, "?",  " "),
    chardef(0F4H, "?",  " "),
    chardef(0F5H, "?",  " "),
    chardef(0F6H, "=", 0F7H),
    chardef(0F7H, "?",  " "),
    chardef(0F8H, "=", 0B0H),
    chardef(0F9H, "?",  " "),
    chardef(0FAH, "?",  " "),
    chardef(0FBH, "?",  " "),
    chardef(0FCH, "?",  " "),
    chardef(0FDH, "=", 0B2H),
    chardef(0FEH, "?",  " "),
    chardef(0FFH, "=",  " "));

(* we don't care about flag here *)

PROCEDURE remap2oem (ch:CHAR):CHAR;
BEGIN
    RETURN TpcTOwin[ ORD(ch) ].MapChar;
END remap2oem;

(* uses global sline[] and slen[] arrays *)

PROCEDURE dmpToClipboard (lastline:CARDINAL):BOOLEAN ;
CONST
    multiplex = 2FH;
VAR
    R : SYSTEM.Registers;
VAR
    (* Z : strHUGE; //V11I *)
    dZ : strHUGE; (* //V11J *)
    i,j:CARDINAL;
    ch,newch:CHAR;
BEGIN
    R.AX := 1700H; (* INT 2F - MS Windows "WINOLDAP" - IDENTIFY WinOldAp version *)
    Lib.Intr(R,multiplex);
    IF R.AX = 1700H THEN RETURN FALSE; END; (* clipboard not supported *)

    R.AX := 1701H; (* INT 2F - MS Windows "WINOLDAP" - OPEN CLIPBOARD *)
    Lib.Intr(R,multiplex);
    IF R.AX = 0 THEN RETURN FALSE; END; (* clipboard already open *)

    R.AX := 1702H; (* INT 2F - MS Windows "WINOLDAP" - EMPTY CLIPBOARD *)
    Lib.Intr(R,multiplex);
    IF R.AX = 0 THEN RETURN FALSE; END; (* failure to empty clipboard *)

    dZ := "";
    FOR i:=firstline TO lastline DO
        FOR j:= 1 TO slen[i] DO
            ch:=sline[i][j-1];
            newch:=remap2oem(ch); (* should do *)
            Str.Append(dZ,newch);
        END;
        IF i < lastline THEN Str.Append(dZ,nl); END; (* leave paste cursor at last typed char *)
    END;

    R.AX := 1703H; (* INT 2F - MS Windows "WINOLDAP" - SET CLIPBOARD DATA *)
    R.DX := 1; (* 1=text, 7=OEM text *)
    R.ES := Seg(dZ);
    R.BX := Ofs(dZ);
    R.SI := 0;                (* hugeStr is never more than 4096 *)
    R.CX := Str.Length(dZ); (* idem *)
    Lib.Intr(R,multiplex);
    IF R.AX = 0 THEN (* failure to copy data to clipboard *)
        ; (* we should return FALSE here but we'll force closeclipboard for safety *)
    END;

    R.AX := 1708H; (* INT 2F - MS Windows "WINOLDAP" - CloseClipboard *)
    Lib.Intr(R,multiplex);
    RETURN (R.AX # 0);
END dmpToClipboard;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* ripped from MPAUSE *)

PROCEDURE MouseDriverHere ( ) : BOOLEAN;
CONST
    MouseInt   = 033H;
CONST
    InstallChk = 00000H;
VAR
    R : SYSTEM.Registers;
BEGIN
    (*
    R.AX := InstallChk;
    Lib.Intr(R,MouseInt);
    RETURN (R.AX # 0);
    *)
    RETURN (MsMouse.Reset() # MAX(INTEGER) ); (* InstallChk is Reset ! *)
END MouseDriverHere;

(* ------------------------------------------------------------ *)

CONST
    delai       = 100; (* 0.1 second *)
    delaimickey = 300; (* avoid too fast a change with a mouseclick *)
TYPE
    mousebuttonstype = SET OF (leftbutton,rightbutton,middlebutton);
VAR
    which : mousebuttonstype;

PROCEDURE mouseclick ( ):BOOLEAN;
VAR
    msdata:MsMouse.MsData;
BEGIN
    MsMouse.GetStatus(msdata);
    which:=mousebuttonstype{};
    IF msdata.left_pressed   THEN INCL(which,leftbutton); END;
    IF msdata.right_pressed  THEN INCL(which,rightbutton); END;
    IF msdata.middle_pressed THEN INCL(which,middlebutton);END;
    RETURN (which # mousebuttonstype{} );
END mouseclick;

PROCEDURE getLastPressed (  ):mousebuttonstype;
BEGIN
    Lib.Delay(delaimickey); (* force a small delay *)
    RETURN which;
END getLastPressed;

CONST
    keyEscape  = 01B00H;
    keySpace   = 02000H;
    keyCR      = 00D00H;

PROCEDURE flushKeyboard (  );
VAR
    c : CHAR;
BEGIN
    LOOP
        IF BiosIO.KeyPressed()=FALSE THEN EXIT; END;
        c := BiosIO.RdKey();
        IF c = CHR(0) THEN c := BiosIO.RdKey(); END;
    END;
END flushKeyboard;

PROCEDURE getKeyboardCode (VAR keycode:CARDINAL):BOOLEAN;
VAR
    c1,c2:CHAR;
BEGIN
    IF BiosIO.KeyPressed()=FALSE THEN RETURN FALSE; END;
    c1 := BiosIO.RdKey();
    IF c1 = CHR(0) THEN
        c2 := BiosIO.RdKey();
    ELSE
        c2 := CHR(0);
    END;
    keycode := (ORD(c1) << 8) + ORD(c2);
    RETURN TRUE;
END getKeyboardCode;

PROCEDURE forcepause (stopmouse:BOOLEAN; alwayspause,pause,first,last:CARDINAL );
VAR
    i,j:CARDINAL;
BEGIN
    FOR i := 1 TO alwayspause*10 DO
        IF BiosIO.KeyPressed() THEN RETURN;END;
        IF stopmouse THEN
            IF mouseclick() THEN RETURN;  END;
        END;
        Lib.Delay(delai);
    END;
    FOR j:=first TO last DO
        FOR i := 1 TO pause*10 DO
            IF BiosIO.KeyPressed() THEN RETURN; END;
            IF stopmouse THEN
                IF mouseclick() THEN RETURN; END;
            END;
            Lib.Delay(delai);
        END;
    END;
END forcepause;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE wrlngcard (v:LONGCARD;wi:CARDINAL);
VAR
    S:str16;
    ok:BOOLEAN;
    i:CARDINAL;
BEGIN
    Str.CardToStr( v,S,10,ok);
    IF NOT(ok) THEN S:="ERROR !";END;
    FOR i:=Str.Length(S)+1 TO wi DO Str.Prepend(S,blank);END;
    WrStr(S);
END wrlngcard;

PROCEDURE wrcard (v,wi:CARDINAL);
BEGIN
    wrlngcard( LONGCARD(v),wi);
END wrcard;

(* yes, yes, we know we should have rewritten dmpSentence in a more general way... *)
(* uses global sline[] and slen[] arrays *)

PROCEDURE dmpSentenceAt (doFrame:CARDINAL;
                         lastline,longest:CARDINAL;
                         alwayspause,pause:CARDINAL; atrandompos,stopmouse:BOOLEAN );
VAR
    plus,len,i,j,k    : CARDINAL;
    frameChars   : str16;
    S            : str128;
VAR
    mini,maxi,wi,ws,v,htab,vtab : CARDINAL;
BEGIN
    mini := getMinHtab(); (* 0.. *)
    maxi := getMaxHtab();
    wi := maxi-mini+1;
    ws := longest;
    CASE doFrame OF
    | frameRaw : ;
    | frameNone:
        INC(ws,wiHORIZalt);
    ELSE
        INC(ws,wiHORIZ);
    END;
    IF wi > ws THEN
        IF atrandompos THEN
            v:=GetRndCardRange(1,wi-ws) -1;
        ELSE
            v:=(wi-ws) DIV 2;
        END;
    ELSE
        v := 0;
    END;
    htab := mini+v;
(*
WrLn;wrcard(mini,4);wrcard(maxi,4);
WrLn;wrcard(wi,4);
WrLn;wrcard(longest,4);wrcard(ws,4);
WrLn;wrcard(v,4);
WrLn;wrcard(htab,4);
WrLn;
*)
    mini := getMinVtab(); (* 0.. *)
    maxi := getMaxVtab();
    wi := maxi-mini+1;
    ws := lastline-firstline+1;
    CASE doFrame OF
    | frameRaw : ;
    | frameNone:
        INC(ws,wiVERTIalt);
    ELSE
        INC(ws,wiVERTI);
    END;
    IF wi > ws THEN
        IF atrandompos THEN
            v:=GetRndCardRange(1,wi-ws) -1;
        ELSE
            v:=(wi-ws) DIV 2;
        END;
    ELSE
        v := 0;
    END;
    vtab := mini+v;

    len := longest;
    CASE doFrame OF
    | frameNone   : frameChars := sNone;   plus:=0;
    | frameSingle : frameChars := sSingle; plus:=2;
    | frameDouble : frameChars := sDouble; plus:=2;
    END;

    CASE doFrame OF
    | frameRaw :
        FOR j:=firstline TO lastline DO
            gotoXY(htab,vtab);
            WrStr(sline[j]);
            INC(vtab);
        END;
    ELSE
        gotoXY(htab,vtab);
        WrChar(frameChars[0]);
        FOR i:=1 TO (len+plus) DO WrChar(frameChars[4]); END;
        WrChar(frameChars[2]);
        INC(vtab);

        IF doFrame # frameNone THEN
            gotoXY(htab,vtab);
            WrChar(frameChars[1]);
            FOR i:=1 TO (len+plus) DO WrChar(space); END;
            WrChar(frameChars[1]);
            INC(vtab);
        END;

        FOR j:=firstline TO lastline DO
            gotoXY(htab,vtab);
            WrChar(frameChars[1]);
            IF doFrame # frameNone THEN WrChar(space); END;
            WrStr(sline[j]);
            FOR k:=Str.Length(sline[j])+1 TO len DO
                WrChar(space);
            END;
            IF doFrame # frameNone THEN WrChar(space); END;
            WrChar(frameChars[1]);
            INC(vtab);
        END;

        IF doFrame # frameNone THEN
            gotoXY(htab,vtab);
            WrChar(frameChars[1]);
            FOR i:=1 TO (len+plus) DO WrChar(space); END;
            WrChar(frameChars[1]);
            INC(vtab);
        END;

        gotoXY(htab,vtab);
        WrChar(frameChars[3]);
        FOR i:=1 TO (len+plus) DO WrChar(frameChars[4]); END;
        WrChar(frameChars[5]);
        INC(vtab);
    END;
    forcepause(stopmouse,alwayspause,pause,firstline,lastline);
END dmpSentenceAt;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    MAXHASH  = MAX(CARDINAL); (* 65535 *)
TYPE
    ptrEntry = POINTER TO entryType;
    entryType = RECORD
        next     : ptrEntry;
        len      : CARDINAL; (* was SHORTCARD but now we accept long sentences... *)
        string   : CHAR;       (* here, after other data, because variable length *)
    END;
TYPE
    categoryType = RECORD
        anchor      : ptrEntry;
        count       : CARDINAL; (* // LONGCARD is useless *)
        hash        : CARDINAL;
        varindex    : CARDINAL; (* 0=uninitialized index, max(cardinal)=not a var *)
        id          : str32;
        tags        : str32;
    END;
CONST
    firstcategory = 1;   (* must be 1 *)
    maxcategory   = 500;
VAR
    category     : ARRAY [firstcategory..maxcategory] OF categoryType;
    lastcategory : CARDINAL;

(* ------------------------------------------------------------ *)

(*
   0=first tag i.e. text between open curly and first vbar,
   1=2nd tag i.e. text between first vbar and next terminator (either vbar or close curly)

   //FIXME note findvariant handles escaped sequences thus not allowing calling categories !

*)

VAR
    fvR : strHUGE;

PROCEDURE findvariant (wanted:CARDINAL;VAR S : ARRAY OF CHAR);
VAR
    len,p:CARDINAL;
    (* R:strHUGE; //V11I *)
    state:(waiting,incurly,escaped);
    c:CHAR;
    currtag:CARDINAL;
BEGIN
    len:=Str.Length(S);
    IF len=0 THEN RETURN;END; (* should never happen *)
    Str.Copy(fvR,"");
    state:=waiting;
    p:=0;
    WHILE p < len DO
        c:=S[p];
        CASE state OF
        | waiting:
            CASE c OF
            | opencurly:
                state:=incurly; currtag:=0;
            ELSE
                Str.Append(fvR,c);
            END;
        | incurly:
            CASE c OF
            | backslash : Str.Append(fvR,c);state:=escaped;
            | closecurly: state:=waiting;
            | IDSEPAR   : INC(currtag);
            ELSE
                IF currtag=wanted THEN Str.Append(fvR,c);END;
            END;
        | escaped:
            Str.Append(fvR,c);
            state:=incurly;
        END;
        INC(p);
    END;
    CASE state OF
    | waiting: ; (* nada OR {*} *)
    | incurly: ; (* {* *)
    | escaped: ; (* never ! *)
    END;
    Str.Copy(S, fvR);
END findvariant;

(* ------------------------------------------------------------ *)

PROCEDURE getnextkeywords (len:CARDINAL;S:ARRAY OF CHAR;
                           VAR p,basep,count:CARDINAL;
                           VAR W,T:ARRAY OF CHAR ):BOOLEAN ;
VAR
    state:(waiting,chkescaped,incategory,intag);
    c:CHAR;
    ok:BOOLEAN;
BEGIN
    (* "\xxx", "\xxx/x" *)

    basep:=p;
    count:=0;

    Str.Copy(W,"");
    Str.Copy(T,"");

    state:=waiting;
    LOOP
        IF NOT (p<len) THEN EXIT; END;
        c := S[p];
        UpperCase(c);
        CASE state OF
        | waiting:
            CASE c OF
            | backslash: Str.Copy(W,c);state:=chkescaped; (* IDINVOKE *)
            ELSE
                INC (count);
            END;
        | chkescaped:
            IF Belongs(legalforcategory,c) THEN (* // was alphanum *)
                Str.Append(W,c);
                state:=incategory;
            ELSE
                INC(count,lenmarker);    (* pass "\?" = 1+1 *)
                state:=waiting;
                Str.Copy(W,"");  (* just in case *)
            END;
        | incategory:
            IF Belongs(legalforcategory,c) THEN (* // was alphanum  *)
                Str.Append(W,c);
            ELSE
                CASE c OF
                | IDINVOKE:   RETURN TRUE; (* "\xx\" *)
                | IDVARIANT:  Str.Copy(T,c);state:=intag; (* "\xx/" *)
                ELSE
                    RETURN TRUE; (* "\xx?" *)
                END;
            END;
        | intag:
            IF Belongs(legalfortag,c) THEN (* // was alphanum+commercial *)
                Str.Append(T,c);
                INC(p); (* pass char *)
                RETURN TRUE; (* only one letter or digit or & after "/" i.e. "\xx/?" *)
            ELSE
                (* "\xx/?" assume empty tag *)
                RETURN TRUE;
            END;
        END;
        INC(p);
    END;
    CASE state OF
    | waiting    : ok:=FALSE; (* nothing was found *)
    | chkescaped : ok:=FALSE; (* "*\" *)
    | incategory : ok:=TRUE;  (* "*\x" *)
    | intag      : ok:=TRUE;  (* "\xx/" *)
    END;
    RETURN ok;
END getnextkeywords;

VAR
    dcR,dcTMP:strHUGE;

PROCEDURE docapskeywords (VAR S:ARRAY OF CHAR  );
VAR
    (* R,TMP : strHUGE; //V11I *)
    len,p,basep,count : CARDINAL;
    W,T : str128;
BEGIN
    len:=Str.Length(S);
    IF len=0 THEN RETURN;END; (* should never happen *)

    Str.Copy(dcR,"");
    p:=0;
    WHILE getnextkeywords(len,S, p,basep,count, W,T) DO
        Str.Slice (dcTMP, S, basep,count);
        Str.Append(dcR,dcTMP);
        Str.Append(dcR,W);
        Str.Append(dcR,T);
    END;
    Str.Slice (dcTMP, S,basep,count);
    Str.Append(dcR,dcTMP);

    Str.Copy(S, dcR);
END docapskeywords;

(* ------------------------------------------------------------ *)

PROCEDURE isoleweight (VAR S : ARRAY OF CHAR):CARDINAL ;
VAR
    p,q,n:CARDINAL ;
    S2 : str32;
    v  : LONGCARD;
    ok: BOOLEAN;
BEGIN
    IF S[0]=openparen THEN
        p:=0;
        q:=Str.CharPos(S,closeparen);
        IF q = STRNOTFOUND THEN RETURN NOWEIGHTHERE;END; (* "(..." *)
        Str.Slice(S2,S,p+1,q-p-1);
        IF verifyString(S2,digits)=FALSE THEN RETURN NOWEIGHTHERE;END; (* we could return 1 but use (1)(...) trick instead *)
        Str.Delete(S,p,q-p+1); (* S[p]:=nullchar; *)
        v:=Str.StrToCard(S2,10,ok);
        IF ok = FALSE THEN RETURN NOWEIGHTHERE;END;
        IF v > MAX(SHORTCARD) THEN RETURN NOWEIGHTHERE;END; (* 1..255 *)
        n:=CARDINAL(v);
    ELSE
        n:=1;
    END;
    RETURN n;
END isoleweight;

PROCEDURE addData (VAR newInList:ptrEntry;VAR problems:CARDINAL;
                   doanchor:BOOLEAN; i:CARDINAL;
                   S:ARRAY OF CHAR);
VAR
    len,needed:CARDINAL;
    p : ptrEntry;
BEGIN
    IF same(S,EMPTYSTRING) THEN Str.Copy(S,"");END;
    problems:=0;
    len    := Str.Length(S);
    needed := SIZE(entryType)-SIZE(CHAR)+len;
    IF Available(needed)=FALSE THEN INC(problems);RETURN;END;
    IF doanchor THEN
        ALLOCATE( p,needed);
        newInList := p;
        category[i].anchor := p;
    ELSE
        ALLOCATE(newInList^.next,needed);
        newInList :=newInList^.next;
    END;
    Lib.FastMove( ADR(S),ADR(newInList^.string),len);
    newInList^.len       := len;
    newInList^.next      := NIL;
    INC( category[i].count);
END addData;

(* S is category, S2 is tags between curlies *)

PROCEDURE isoletags (VAR S,S2:ARRAY OF CHAR ):BOOLEAN ;
VAR
    p,q:CARDINAL;
BEGIN
    Str.Copy(S2,""); (* default *)
    Str.Delete(S,0,1); (* remove tilde IDCLASS *)
    p:=Str.CharPos(S,opencurly);
    q:=Str.RCharPos(S,closecurly);
    IF p = STRNOTFOUND THEN
        IF q # STRNOTFOUND THEN RETURN FALSE;END; (* } alone *)
    ELSE
        IF q = STRNOTFOUND THEN RETURN FALSE;END; (* { alone *)
        IF p > q THEN RETURN FALSE; END; (* }*{ *)
        Str.Slice(S2,S,p+1,q-p-1);
        Str.Delete(S,p,q-p+1); (* S[p]:=nullchar; *)
    END;
    IF Str.Length(S)  > SIZE(str32) THEN RETURN FALSE; END;
    UpperCase(S);
    IF verifyString(S ,legalforcategory)=FALSE THEN RETURN FALSE;END; (* // was alphanum *)

    IF Str.Length(S2) > SIZE(str32) THEN RETURN FALSE; END;
    UpperCase(S2);
    IF verifyString(S2,legalfortag)=FALSE THEN RETURN FALSE;END; (* // was alphanum *)
    RETURN TRUE;
END isoletags;

VAR
    rsS,rsSPLUS : strHUGE; (* now globerks in order TO avoid crash *)

PROCEDURE readScript (debug,useLFN:BOOLEAN; datafile:pathtype) : BOOLEAN;
VAR
    hin : FIO.File;
    (* S,SPLUS   : strHUGE;  (* oversized just in CASE *) //V11I *)
    rc,ateof  : BOOLEAN;
    i,problems,j,weight,position,len: CARDINAL;
    p   : ptrEntry;
    S2  : str32;
    currline : CARDINAL;
    id:CHAR;
BEGIN
    FOR i := firstcategory TO maxcategory DO
        category[i].anchor   := NIL;
        category[i].count    := UNDEFINEDCOUNT;
    END;

    i:=firstcategory-1;
    p:=NIL;
    rc:=TRUE;
    currline := 0;

    hin := fileOpenRead(useLFN,datafile);
    FIO.AssignBuffer(hin,bufferIn);

    FIO.EOF:=FALSE;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hin,rsS);
        (* IF FIO.EOF THEN EXIT; END; *)
        LtrimBlanks(rsS);
        RtrimBlanks(rsS);
        (* handle multiline here but we won't bother to check for 4096 chars limit ! *)
        position:=Str.Pos(rsS,concatenatemarker);
        len := Str.Length(rsS);
        IF ( (position # STRNOTFOUND) AND (len >= lenmarker) ) THEN
            (* do not test directly with len-2 ! it would confuse single character entry ! *)
            IF position=(len-lenmarker) THEN
                ateof := FALSE;
                LOOP
                    FIO.RdStr(hin,rsSPLUS);
                    IF FIO.EOF THEN ateof:=TRUE; EXIT; END;
                    LtrimBlanks(rsSPLUS);
                    RtrimBlanks(rsSPLUS);
                    Str.Subst(rsS,concatenatemarker,""); (* was space *)
                    Str.Append(rsS,rsSPLUS);
                    position:=Str.Pos(rsS,concatenatemarker);
                    len := Str.Length(rsS);
                    IF ( (position=STRNOTFOUND) OR (len<lenmarker) ) THEN EXIT; END;
                    IF position # (len-lenmarker) THEN EXIT; END;
                END;
                IF ateof THEN EXIT; END;
            END;
        END;

        (* resume normal operation *)
        INC(currline);
        IF debug THEN wrcard(currline,5);WrStr(" : ");WrStr(rsS);WrLn;END;
        id:=rsS[0];
        CASE id OF
        | nullchar, semicolon, pound: ; (* empty or comment *)
        | IDCLASS, IDVAR :
            INC(i);
            IF i > maxcategory THEN rc:=FALSE;EXIT;END;

            IF isoletags(rsS,S2)=FALSE THEN rc:=FALSE;EXIT;END;
            Str.Copy(category[i].id,rsS);
            Str.Copy(category[i].tags,S2);
            category[i].hash := Lib.HashString(rsS,MAXHASH);
            category[i].count:= 0;
            IF id = IDCLASS THEN
                j:=ISNOTVAR;
            ELSE
                j:=UNDEFINEDVAR;
            END;
            category[i].varindex:=j;

            (* //FIXME should we allow a fixed variable to have variant(s) ? nope *)
            (* //FIXME constant ok for string literals but not for called CLASS *)

        ELSE
            IF i # (firstcategory-1) THEN (* handle illegal entry before any category is defined ! *)
                (* // LONGCARD was useless ! *)
                CASE category[i].count OF
                | UNDEFINEDCOUNT: rc:=FALSE;EXIT;
                | 0 :
                    weight:=isoleweight(rsS);
                    IF weight=NOWEIGHTHERE THEN rc:=FALSE;EXIT; END;
                    docapskeywords(rsS);
                    addData(p,problems,  TRUE,i,  rsS);
                ELSE
                    weight:=isoleweight(rsS);
                    IF weight=NOWEIGHTHERE THEN rc:=FALSE;EXIT; END;
                    docapskeywords(rsS);
                    addData(p,problems,  FALSE,i,  rsS);
                END;
                IF problems # 0 THEN rc:=FALSE;EXIT;END;
                FOR j:=1 TO weight-1 DO
                    IF problems=0 THEN addData(p,problems,  FALSE,i,  rsS); END;
                END;
            END;
        END;
    END;
    fileClose(useLFN,hin);
    IF debug THEN WrLn;END;
    lastcategory := i;
    RETURN rc;
END readScript;

(* ------------------------------------------------------------ *)

PROCEDURE dumpquoted (S:ARRAY OF CHAR   );
BEGIN
    WrStr('"');
    WrStr(S);
    WrStr('"');
END dumpquoted;

(* //FIXME we should improve debug : forward or unexistant references *)

PROCEDURE dumpit (i:CARDINAL;full:BOOLEAN);
CONST
    msgIndex    = "Index    : ";
    msgCount    = "Count    : ";
    msgVar      = "Variable : ";
    msgCategory = "Category : ";
    msgTags     = "Tags     : ";
    msgEntry    = "           ";
    msgTerseB   = "Category[";
    msgTerseE   = "] = ";

    localplaceholder = CHR(255); (* was vbar *)
VAR
    firstInList,newInList : ptrEntry;
    (* S     : strHUGE;  (* huge just in case ! *) //V11I *)
    dmS : strHUGE; (* //V11J *)
    len,p : CARDINAL;
    tags,Z: str128; (* should do *)
BEGIN
    IF NOT(full) THEN
        WrStr(msgTerseB);  wrcard(i,4);
        WrStr(msgTerseE);
        Str.Copy(Z,category[i].id);
        IF category[i].varindex = ISNOTVAR THEN
            Str.Prepend(Z,IDCLASS);
        ELSE
            Str.Prepend(Z,IDVAR);
        END;
        dumpquoted(Z);
        WrLn;
        RETURN;
    END;
    WrStr(msgIndex);wrcard(i,4);WrLn;
    WrStr(msgCount);wrcard(category[i].count,4);WrLn; (* // WrLngCard 8 *)
    WrStr(msgVar);
    p:=category[i].varindex;
    IF p = ISNOTVAR THEN
        Z:="no";
    ELSE
        Z:="yes"; (* index decided at runtime *)
    END;
    WrStr(Z);WrLn;
    WrStr(msgCategory);dumpquoted(category[i].id);WrLn;
    WrStr(msgTags);dumpquoted(category[i].tags);WrLn;
    WrLn;

    firstInList := category[i].anchor;
    newInList := firstInList;
    WHILE newInList # NIL DO
        firstInList := firstInList^.next;
        len         := CARDINAL(newInList^.len);
        Lib.FastMove( ADR(newInList^.string),ADR(dmS),len);
        dmS[len]      := nullchar; (* REQUIRED safety ! *)

        WrStr(msgEntry);dumpquoted(dmS);
        WrLn;

        newInList := firstInList;
    END;
    WrLn;

    Str.Copy(tags,category[i].tags);

    IF same(tags,"") THEN RETURN; END;

    FOR p:=0 TO Str.Length(tags) DO
        Z:="::: Caller : "+IDINVOKE+localplaceholder; (* //FIXME : was antislash ! *)
        CASE p OF
        | 0 :
            Str.Subst(Z,localplaceholder,category[i].id); (* calling without any tag *)
        ELSE
            Str.Append(Z,IDVARIANT+localplaceholder);
            Str.Subst(Z,localplaceholder,category[i].id);
            Str.Subst(Z,localplaceholder,category[i].tags[p-1]); (* \category/tagletter *)
        END;
        WrStr(msgEntry);dumpquoted(Z);WrLn;
        WrLn;

        firstInList := category[i].anchor;
        newInList := firstInList;
        WHILE newInList # NIL DO
            firstInList := firstInList^.next;
            len         := CARDINAL(newInList^.len);
            Lib.FastMove( ADR(newInList^.string),ADR(dmS),len);
            dmS[len]      := nullchar; (* REQUIRED safety ! *)
            (* variant using p index *)
            findvariant (p,dmS);

            WrStr(msgEntry);dumpquoted(dmS);WrLn;

            newInList := firstInList;
        END;
        WrLn;
    END;

END dumpit;

PROCEDURE dumpall (  );
VAR
    i : CARDINAL;
BEGIN
    FOR i := firstcategory TO lastcategory DO
        dumpit(i,FALSE);
    END;
    WrLn;
    FOR i := firstcategory TO lastcategory DO
        dumpit(i,TRUE);
    END;
END dumpall;

PROCEDURE freeit ( i : CARDINAL);
VAR
    len,needed      : CARDINAL;
    firstInList,newInList   : ptrEntry;
BEGIN
    firstInList := category[i].anchor;
    newInList := firstInList;
    WHILE newInList # NIL DO
         len         := CARDINAL(newInList^.len);
         needed      := SIZE(entryType)-SIZE(CHAR)+len;
         firstInList := firstInList^.next;
         DEALLOCATE (newInList,needed);
         newInList := firstInList;
    END
END freeit;

PROCEDURE freeall ();
VAR
    i : CARDINAL;
BEGIN
    FOR i := firstcategory TO lastcategory DO
        freeit(i);
    END;
END freeall;

(* ------------------------------------------------------------ *)

(* assume there's enough room in R ! *)

PROCEDURE loadString (ndx:CARDINAL;VAR R:ARRAY OF CHAR);
VAR
    firstInList,newInList:ptrEntry;
    i,n, len:CARDINAL;
BEGIN
    IF category[ndx].count=0 THEN Str.Copy(R,"");RETURN;END; (* returning "???" was useless *)
    n := GetRndCardRange ( 1 ,category[ndx].count); (* 1=mincategory *)

    CASE category[ndx].varindex OF
    | UNDEFINEDVAR : category[ndx].varindex := n; (* define it now *)
    | ISNOTVAR     :  ;
    ELSE
        n:=category[ndx].varindex;
    END;

    (* n := GetRndLngCardRange (1,category[ndx].count); *)
    firstInList := category[ndx].anchor;
    newInList := firstInList;
    DEC(n); (* trick to force to anchor if 1, and locate correct string if > 1 *)
    FOR i:= 1 TO n DO
        firstInList := firstInList^.next;
        newInList := firstInList;
    END;
    len := CARDINAL(newInList^.len);
    Lib.FastMove( ADR(newInList^.string),ADR(R),len);
    R[len] := nullchar; (* REQUIRED safety ! *)
END loadString;

PROCEDURE findcategoryindex (VAR i : CARDINAL;W:ARRAY OF CHAR):BOOLEAN;
VAR
    hash:CARDINAL;
BEGIN
    Str.Delete(W,0,1); (* remove marker *)
    hash:=Lib.HashString(W,MAXHASH);
    i:=firstcategory;
    LOOP
        IF category[i].hash=hash THEN
            IF same(W,category[i].id) THEN RETURN TRUE; END;
        END;
        INC(i);
        IF i > lastcategory THEN RETURN FALSE;END;
    END;
END findcategoryindex;

PROCEDURE getVariant (i:CARDINAL;T:ARRAY OF CHAR;VAR R:ARRAY OF CHAR);
VAR
    wanted : CARDINAL;
BEGIN
    loadString(i,R);   (* \*, * or {*} *)
    Str.Delete(T,0,1); (* remove marker *)
    IF Str.Length(T)=0 THEN RETURN;END;
    wanted:=Str.CharPos(category[i].tags,T[0]);
    IF wanted = STRNOTFOUND THEN
        wanted:=0; (* keep "{*|" if any *)
    ELSE
        INC(wanted);
    END;
    findvariant(wanted,R);
END getVariant;

VAR
    gsmsg : strHUGE;

PROCEDURE getSentence (debug:BOOLEAN; VAR R : ARRAY OF CHAR):BOOLEAN;
VAR
    len,p,basep,count:CARDINAL;
    i:CARDINAL;
    (* msg : strHUGE; //V11I *)
    W,T,prevT : str128;
    rc : BOOLEAN;
BEGIN
    loadString(lastcategory,R); (* main string *)
    Str.Copy(prevT,"");
    rc:=TRUE;
    LOOP
        len:=Str.Length(R);
        p:=0;
        IF getnextkeywords(len,R, p,basep,count, W,T)=FALSE THEN EXIT;END;
        IF debug THEN
            WrStr("tag0: ");dumpquoted(prevT);WrLn;
            WrStr("str : ");dumpquoted(R);WrLn;
            WrStr("cat : ");dumpquoted(W);WrLn;
            WrStr("tag : ");dumpquoted(T);WrLn;
            WrLn;
        END;
        IF findcategoryindex(i,W)=FALSE THEN rc:=FALSE; EXIT; END;
        IF same(T,"") THEN
            getVariant(i,IDsuppress,gsmsg); (* force an impossible tag to remove text between curlies *)
            Str.Subst(R,W,gsmsg);
            (* Str.Copy(prevT,T); *)
        ELSIF same(T,IDHERIT) THEN (* "/&" *)
            IF same(prevT,"") THEN
                getVariant(i,IDsuppress,gsmsg);
            ELSE
                getVariant(i,prevT,gsmsg);
            END;
            Str.Subst(R,T,"");
            Str.Subst(R,W,gsmsg);
        ELSE                       (* "/?" *)
            getVariant(i,T,gsmsg);
            Str.Subst(R,T,"");
            Str.Subst(R,W,gsmsg);
            Str.Copy(prevT,T);
        END;
    END;
    RETURN rc;
END getSentence;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE showmem();
VAR
    heapsize    : CARDINAL; (* in PARAGRAPHS and not in bytes ! help is wrong ! *)
    n           : LONGCARD;
BEGIN
    heapsize :=HeapTotalAvail(MainHeap);
    WrStr("Available : ");
    n :=16 * LONGCARD(heapsize);
    wrlngcard(n,6);WrLn;
END showmem;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE padstr (VAR S:ARRAY OF CHAR;alt:BOOLEAN;mini,maxi:CARDINAL);
VAR
    i:CARDINAL;
BEGIN
    FOR i := mini TO maxi DO
        IF alt THEN
            Str.Prepend(S,space);
        ELSE
            Str.Append(S,space);
        END;
    END;
END padstr;

CONST
              (* "fff.e       " *)
              (* "      ff.ee " *)
              (* "ffffffff.eee" if DOS f8e3 *)
    sBase      = "; Directory";
    sepabout   =  " : ";

PROCEDURE fmtFileName ( VAR R:pathtype;
                      useLFN,altdisplay:BOOLEAN; maxlenfilename:CARDINAL;
                      S : pathtype );
CONST
    f8len      = 8;
    e3len      = 3;
    rightalign = TRUE; (* prettier *)
VAR
    p:CARDINAL;
BEGIN
    Str.Copy(R,S);
    IF Str.RCharPos(R,dot)=STRNOTFOUND THEN Str.Append(R,dot);END;

    IF useLFN THEN
        padstr(R, rightalign,  Str.Length(R)+1, maxlenfilename);
    ELSE
        p:=Str.RCharPos(R,dot);
        padstr(R, rightalign,  p+1,f8len);
        p:=Str.RCharPos(R,dot);
        padstr(R, FALSE,       Str.Length(R)+1,f8len+1+e3len);
    END;
END fmtFileName;

(* assume file exists *)

PROCEDURE showtitle (maxlenfilename,linewidth:CARDINAL;
                    redirected,useLFN,DEBUG:BOOLEAN;
                    zebase,zefile:pathtype);
CONST
    msgUndefined = "(undefined or not a "+ProgEXEname+" script)";
    msgMore      = "...";
    lenMsgMore   = 3;
    maxtryline   = 10;
VAR
    hin:FIO.File;
    (* S : strHUGE; //V11I *)
    stS : strHUGE; (* //V11J *)
    state:(waiting,gottitle);
    F,F2:pathtype;
    remopen,remclose:str16;
    i,len,slen,currline:CARDINAL;
BEGIN
    fmtFileName(F, useLFN,TRUE,maxlenfilename,zefile);
    Str.Append(F,sepabout);
    Str.Concat(F2,zebase,zefile);
    IF DEBUG THEN
        WrStr("F showtitle : ");WrStr(F);WrLn;
        WrStr("F2 showtitle: ");WrStr(F2);WrLn;
    END;

    hin := fileOpenRead(useLFN,F2);
    FIO.AssignBuffer(hin,bufferIn);

    currline:=0;
    state:=waiting;
    FIO.EOF:=FALSE;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hin,stS);
        (* IF FIO.EOF THEN EXIT; END; *)
        LtrimBlanks(stS);
        RtrimBlanks(stS);
        CASE stS[0] OF
        | commentchar1,commentchar2:
            Str.Delete(stS,0,1);
            LtrimBlanks(stS);
            FOR i:=1 TO 3 DO
                CASE i OF
                | 1 : remopen:=comment1; remclose:="";        (* //  *)
                | 2 : remopen:=comment2; remclose:="";        (* ::: *)
                | 3 : remopen:=comment3; remclose:=comment3a; (*     *)
                END;
                IF Str.Pos(stS,remopen)=0 THEN
                    IF same(remclose,"") THEN
                        INC(state);
                    ELSE
                        slen:=Str.Length(stS);
                        len :=Str.Length(remclose);
                        IF slen >= len THEN
                            Str.Slice(F2,stS,slen-len,len);
                            IF same(F2,remclose) THEN
                                stS[slen-len]:=nullchar;
                                RtrimBlanks(stS);
                                INC(state);
                            END;
                        END;
                    END;
                END;
                IF state # waiting THEN EXIT; END;
            END;
        END;
        INC(currline);
        IF currline > maxtryline THEN EXIT; END;
    END;
    fileClose(useLFN,hin);
    CASE state OF
    | waiting :
        F2:=msgUndefined;
    | gottitle:
        Str.Delete(stS,0,Str.Length(remopen));
        LtrimBlanks(stS);
        Str.Copy(F2,stS);
    END;
    Str.Append(F,F2);
    IF redirected THEN
        WrStr(F);WrLn;
    ELSE
        slen:=Str.Length(F);
        IF slen >= linewidth THEN
            F[linewidth-lenMsgMore-1]:=nullchar; (* brutal *)
            Str.Append(F,msgMore);
        END;
        WrStr(F);WrLn;
    END;
END showtitle;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE initDefaultFilenames(VAR exedir,currdir,defaultdatfile:pathtype; ext:ARRAY OF CHAR);
VAR
    exe,u,d,f8,e3:str128; (* str128 was already oversized for DOS library used here *)
    currunit:SHORTCARD;
BEGIN
    Lib.ParamStr(exe,0);
    UpperCaseAlt(exe); (* useless but... *)
    qdSplitAllPath(exe,u,d,f8,e3);
    Lib.MakeAllPath(exedir,u,d,"","");
    Lib.MakeAllPath(defaultdatfile,"","",f8,ext);
    currunit:=FIO.GetDrive(); (* 1=A etc. *)
    FIO.GetDir(currunit,currdir); (* "\*" *)
    Str.Prepend(currdir,colon);
    Str.Prepend(currdir, CHR( CARDINAL(currunit)+ORD("A")-1) );
    fixDirectory(currdir); (* add trailing "\" *)
END initDefaultFilenames;

PROCEDURE dbg (DEBUG,useLFN:BOOLEAN;varname,varcontent:ARRAY OF CHAR);
CONST
    wi = 25;
VAR
    i:CARDINAL;
BEGIN
    IF DEBUG THEN
        WrStr("// ");WrStr(varname);
        IF same(varcontent,"") = FALSE THEN
            FOR i:=Str.Length(varname)+1 TO wi DO WrStr(" ");END;
            WrStr(" = ");
            IF useLFN THEN WrStr(dquote);END;
            WrStr(varcontent);
            IF useLFN THEN WrStr(dquote);END;
        END;
        WrLn;
    END;
END dbg;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* //BUGJPI : Lib.SplitAllPath eats extension in directory part if path is fixed with a trailing "\" ! *)

PROCEDURE splitFileExt (VAR f,e:pathtype;S:pathtype):BOOLEAN;
VAR
    p:CARDINAL;
BEGIN
    p:=Str.RCharPos(S,dot);
    CASE p OF
    | 0 :
        RETURN FALSE; (* nonsense : extension without file ! *)
    | STRNOTFOUND :
        Str.Copy(f,S);
        Str.Copy(e,"");
    ELSE
        Str.Slice(f,S,0,p);
        Str.Copy(e,S);
        Str.Delete(e,0,p+1);
    END;
    RETURN TRUE;
END splitFileExt;

(* currdir is "\" or "\*\" *)

PROCEDURE fileBuildParent (VAR parentdir:pathtype; currdir:pathtype):BOOLEAN;
VAR
    p:CARDINAL;
BEGIN
    IF Str.Match(currdir,antislash) THEN RETURN FALSE; END;
    unfixDirectory(currdir);
    p:=Str.RCharPos(currdir,antislash);
    Str.Slice(parentdir,currdir,0,p+1); (* keep final "\" *)
    RETURN TRUE;
END fileBuildParent;

(* drive is never 0 i.e. default here  *)

PROCEDURE fileGetCurrdir (VAR sUnit:str2; VAR currdir:pathtype;
                         useLFN:BOOLEAN;drive:SHORTCARD);
VAR
    rc:CARDINAL;
    longform:pathtype;
BEGIN
    Str.Concat(sUnit, CHR( ORD("A")-1+ORD(drive) ),colon);

    FIO.GetDir(drive,currdir); (* "\path" without "u:" nor trailing "\" except at root *)
    IF currdir[1] # colon THEN Str.Prepend(currdir,sUnit); END; (* safety *)
    IF useLFN THEN
        IF w9XshortToLong(currdir,rc,longform) THEN (* if error, keep DOS current *)
            Str.Copy(currdir,longform);
        END;
    END;
    (* LFN function seems to always return "u:\*" form except at root *)
    IF currdir[1] = colon THEN Str.Delete(currdir,0,2);END; (* safety *)
    fixDirectory(currdir);
END fileGetCurrdir;

CONST
    rcNone            = 0;
    rcNetwork         = 1;
    rcColon           = 2;
    rcUnit            = 3;
    rcNoParent        = 4;
    rcEmpty           = 5;
    rcInnerParent     = 6;
    rcDirJoker        = 7;
    rcEntryIsFile     = 100; (* mere warning *)
    rcEntryNotFound   = 101; (* mere warning *)

PROCEDURE getErrcode (rc:CARDINAL  ):CARDINAL ;
VAR
    e:CARDINAL;
BEGIN
    CASE rc OF
    | rcNetwork       : e:=errNetwork;
    | rcColon         : e:=errColon;
    | rcUnit          : e:=errUnit;
    | rcNoParent      : e:=errNoParent;
    | rcEmpty         : e:=errEmpty;
    | rcInnerParent   : e:=errInnerParent;
    | rcDirJoker      : e:=errDirJoker;
    ELSE
                        e:=errNone;
    END;
    RETURN e;
END getErrcode;

(*
    remember dirs can have an extension, and LFNs can have inner dots
    we handle, whether u: or not

    *\\*                    network                     ok
    .                       current                     ok
    ..                      parent                      ok
    \                       root
    ""                      empty or u:                 ok

    .\xxx                   current\xxx   F/D           ok
    ..\xxx                  parent\xxx    F/D           ok

    xxx\                    current\xxx\                ok
    xxx\.                   current\xxx\                ok
    xxx\..                  parent                      ok
    xxx                     current\xxx   F/D           ok

    \xxx\                   \xxx\                       ok
    \xxx                    \xxx          F/D           ok

    *..*                    inner parent

*)

PROCEDURE fileFixSpec (VAR zebase,zespec:pathtype;
                      DEBUG,useLFN:BOOLEAN;
                      raw,defaultspec,defaultext:pathtype):CARDINAL;
CONST
    netslash = antislash+antislash;
VAR
    drive:SHORTCARD;
    rc,len,p:CARDINAL;
    u:CHAR;
    S:pathtype;
    currdir:pathtype; (* "\" or "\*\" *)
    parentdir:pathtype;
    sUnit:str2; (* "u:" *)
    okparent:BOOLEAN;
BEGIN
    Str.Copy(S,raw);

    IF Str.Pos(S,netslash) # STRNOTFOUND THEN RETURN rcNetwork;END;
    rc:=rcNone;
    (* process u: in S *)

    CASE CharCount(S,colon) OF
    | 0 :
        drive := FIO.GetDrive();
    | 1 :
        IF Str.CharPos(S,colon) = 1 THEN
            u:=CAP( S[0] );
            CASE u OF
            | "A".."Z" :
                drive := SHORTCARD( ORD(u) - ORD("A") +1 );
                Str.Delete(S,0,2); (* remove u: *)
            ELSE
                rc:=rcUnit;
            END;
        ELSE
            rc:=rcUnit;
        END;
    ELSE
        rc:=rcColon;
    END;
    IF rc # rcNone THEN RETURN rc; END;
    dbg(DEBUG,useLFN,"S without unit",S);

    IF same(S,"") THEN RETURN rcEmpty;END; (* should NEVER happen *)

    (* find current directory from (un)specified unit -- note S no longer has u: *)

    fileGetCurrdir(sUnit,currdir,  useLFN,drive); (* "u:" and "\" or "\*\" *)
    dbg(DEBUG,useLFN,"sUnit",sUnit);
    dbg(DEBUG,useLFN,"currdir",currdir);
    okparent:=fileBuildParent(parentdir, currdir);
    IF okparent THEN
    dbg(DEBUG,useLFN,"parentdir",parentdir);
    ELSE
    dbg(DEBUG,useLFN,"no parent !","");
    END;

    (* handle classic cases : "."  ".."  ".\*"  "..\*"  "*"  "*\."  "*\.." *)

    IF same(S,dot) THEN Str.Copy(S,currdir);END;
    dbg(DEBUG,useLFN,"S against .",S);

    IF same(S,dotdot) THEN
        IF NOT(okparent) THEN RETURN rcNoParent; END;
        Str.Copy(S,parentdir);
    END;
    dbg(DEBUG,useLFN,"S against ..",S);

    IF Str.Match(S,dot+antislash+star) THEN Str.Subst(S,dot+antislash,currdir); END;
    dbg(DEBUG,useLFN,"S against .\*",S);

    IF Str.Match(S,dotdot+antislash+star) THEN
        IF NOT(okparent) THEN RETURN rcNoParent; END;
        Str.Subst(S,dotdot+antislash,parentdir);
    END;
    dbg(DEBUG,useLFN,"S against ..\*",S);

    IF Str.Match(S,antislash+star)=FALSE THEN Str.Prepend(S,currdir);END;
    dbg(DEBUG,useLFN,"S against * not from root",S);

    IF Str.Match(S,star+antislash+dot) THEN
        (* S[Str.Length(S)-1]:=0C; *)
        len:=Str.Length(S);
        Str.Delete(S,len-1,1);
    END;
    dbg(DEBUG,useLFN,"S against *\.",S);

    IF Str.Match(S,star+antislash+dotdot) THEN
        IF NOT(okparent) THEN RETURN rcNoParent;END;
        Str.Copy(S,parentdir);
    END;
    dbg(DEBUG,useLFN,"S against *\..",S);

    (* we don't want inner or trailing ".." now *)
    IF Str.Pos(S,dotdot) # STRNOTFOUND THEN RETURN rcInnerParent;END;

    (* base = "u:\xxx\" and spec = "xxx" *)

    (* handle "*\" OR "* *)

    IF Str.Match(S,star+antislash) THEN
        Str.Concat(zebase,sUnit,S);
        Str.Copy(zespec,defaultspec);
        dbg(DEBUG,useLFN,"zebase1",zebase);
        dbg(DEBUG,useLFN,"zespec1",zespec);
        IF same(defaultext,"")=FALSE THEN
            IF Str.CharPos(zespec,dot)=STRNOTFOUND THEN Str.Append(zespec,defaultext);END;
        END;
        dbg(DEBUG,useLFN,"zeSPEC1",zespec);
        IF chkJoker(zebase) THEN RETURN rcDirJoker; END;
    ELSE
        Str.Prepend(S,sUnit);
        (* S is u:[\xxx]... without trailing "\" *)
        len:=Str.Length(S);
        p:=Str.RCharPos(S,antislash);
        Str.Slice(zebase,S,0,p+1);
        Str.Slice(zespec,S,p+1,len-p);
        dbg(DEBUG,useLFN,"zebase2",zebase);
        dbg(DEBUG,useLFN,"zespec2",zespec);
        IF same(defaultext,"")=FALSE THEN
            IF Str.CharPos(zespec,dot)=STRNOTFOUND THEN Str.Append(zespec,defaultext);END;
        END;
        dbg(DEBUG,useLFN,"zeSPEC2",zespec);
        IF chkJoker(zebase) THEN RETURN rcDirJoker; END;

        IF chkJoker(zespec)=FALSE THEN (* if spec has joker(s), assume files *)
            (* spec has no joker : dir or file ? *)
            IF fileIsDirectorySpec(useLFN,S) THEN
                Str.Copy(zebase,S);
                fixDirectory(zebase); (* safety *)
                Str.Copy(zespec,defaultspec);
            ELSE
                (* either entry not found, or found a file *)
                IF fileExists(useLFN,S) THEN
                    IF Str.RCharPos(zespec,dot)=STRNOTFOUND THEN
                        Str.Append(zespec,dot); (* file extension *)
                    END;
                    RETURN rcEntryIsFile;
                ELSE
                    RETURN rcEntryNotFound;
                END;
            END;
            dbg(DEBUG,useLFN,"zebase3",zebase);
            dbg(DEBUG,useLFN,"zespec3",zespec);
        END;
    END;
    RETURN rcNone; (* OR rc *)
END fileFixSpec;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    defaultpat = star+extDAT; (* "*"+".TX" or "" ? *)
    mincolumns = 1+1+1+1+1;
    noskip     = FALSE; (* no reason FOR this TO be TRUE here *)
VAR
    parmcount,i,opt   : CARDINAL;
    S,R               : pathtype;
    state             : (waiting,gotparm1);
VAR
    doFrame : CARDINAL;
    doWait,doBeautify,doList : BOOLEAN;
    DODUMP,DOSTEPS,CHKMEM,OUTPUTME : BOOLEAN;
    screenwidth,maxcolumns,LineWidth:CARDINAL;
    exedir,currdir,defaultdatafile,datafile:pathtype;
    rawfilespec,zebase,zespec: pathtype;
    savermode,stopmouse,atrandompos,docls:BOOLEAN;
    DEBUG,useLFN,glue,FRprompt,usemouse,fullclean,toclipboard:BOOLEAN;
    pause,alwayspause:CARDINAL;
    maxlenfilename,thislen,filecount:CARDINAL;
    anchor,ptr      : pFname;
    rc,lastpass:CARDINAL;
    clipok:BOOLEAN;
VAR
    v                 : LONGCARD;
    c1,c2             : CHAR;
    ink,paper,count   : CARDINAL;
    lastline,longest  : CARDINAL;
    hugestring        : strHUGE;  (* really huge sentence, just in case... *)
    redirected,chk               : BOOLEAN;
    keycode           : CARDINAL;
    mousebuttons:mousebuttonstype;
BEGIN
    Lib.DisableBreakCheck();
    FIO.IOcheck:=FALSE;

    (* handleVesa; *) (* useless, because we won't change video mode *)
    setUseBiosMode ( IsRedirected() );
    findInkPaperAtStartup();
    colorhelp;

    redirected := IsRedirected();

    screenwidth:= getWindowWidth(); (* 80 no longer becomes 79 *)

    useLFN      := TRUE;
    DEBUG       := FALSE;
    LineWidth   := screenwidth;
    maxcolumns  := screenwidth;
    doFrame     := frameNone;
    doWait      := FALSE;
    doBeautify  := FALSE;
    ink         := ORD(progink);
    paper       := ORD(progpaper);
    count       := mincount;
    DODUMP      := FALSE;
    DOSTEPS     := FALSE;
    CHKMEM      := FALSE;
    OUTPUTME    := TRUE;
    savermode   := FALSE;
    pause       := defaultpause;
    alwayspause := defaultalwayspause;
    stopmouse   := FALSE;
    atrandompos := FALSE;
    docls       := TRUE ;
    glue        := FALSE;
    doList      := FALSE;
    FRprompt    := FALSE;
    fullclean   := FALSE;
    toclipboard := FALSE;
    usemouse    := TRUE;

    state     := waiting;
    parmcount := Lib.ParamCount();

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i);
        Str.Copy(R,S); cleantabs(R);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   "F:"+delim+"FRAME:"+delim+
                                   "W"+delim+"WAIT"+delim+
                                   "N"+delim+"NEWLINE"+delim+"CR"+delim+"CRLF"+delim+
                                   "I:"+delim+"INK:"+delim+
                                   "P:"+delim+"PAPER:"+delim+
                                   "B"+delim+"BIOS"+delim+
                                   "W:"+delim+"WIDTH:"+delim+
                                   "N:"+delim+"COUNT:"+delim+
                                   "DUMP"+delim+
                                   "STEPS"+delim+
                                   "??"+delim+"HH"+delim+"FORMAT"+delim+
                                   "S"+delim+"SAVER"+delim+"SHOW"+delim+
                                   "S:"+delim+"PAUSE:"+delim+
                                   "Z"+delim+"MOUSECLICK"+delim+
                                   "R"+delim+"RANDOMPOS"+delim+
                                   "C"+delim+
                                   "CHKMEM"+delim+
                                   "M:"+delim+"MINIMUM:"+delim+
                                   "G"+delim+"GLUE"+delim+
                                   "L"+delim+"LIST"+delim+
                                   "M"+delim+"MOUSE"+delim+
                                   "WW"+delim+"WM"+delim+
                                   "P"+delim+
                                   "PP"+delim+
                                   "K"+delim+"CLEAN"+delim+
                                   "X"+delim+"LFN"+delim+
                                   "???"+delim+"HHH"+delim+
                                   "Y"+delim+"CLIPBOARD"+delim+
                                   "MEM"+delim+
                                   "DEBUG"
                               );
            CASE opt OF
            | 1,2,3 :
                abort(errHelp,"");
            | 4,5 :
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < minframe) OR (v > maxframe) ) THEN abort(errBadNumber,S); END;
                doFrame:=CARDINAL(v);
            | 6,7 :
                doWait  := TRUE;
            | 8,9,10,11:
                doBeautify  := TRUE;
            | 12,13:
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < mincolor) OR (v > maxcolor) ) THEN abort(errInkRange,"");END;
                ink:=CARDINAL(v);
            | 14,15:
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < mincolor) OR (v > maxcolor) ) THEN abort(errPaperRange,"");END;
                paper:=CARDINAL(v);
            | 16,17:
                setUseBiosMode ( TRUE );
            | 18,19:
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < mincolumns) OR (v > LONGCARD(maxcolumns)) ) THEN abort(errWidthRange,"");END;
                LineWidth:=CARDINAL(v);
            | 20,21:
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < mincount) OR (v > maxcount) ) THEN abort(errCountRange,"");END;
                count:=CARDINAL(v);
            | 22: DODUMP:=TRUE;
            | 23: DOSTEPS:=TRUE;
            | 24,25,26:
                abort(errVerboseHelp,"");
            | 27,28,29:
                savermode:=TRUE;
            | 30,31:
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < minpause) OR (v > maxpause) ) THEN abort(errPauseRange,"");END;
                pause:=CARDINAL(v);
            | 32,33:
                stopmouse := TRUE;
            | 34,35:
                atrandompos:=TRUE;
            | 36:
                docls := FALSE;
            | 37:
                CHKMEM:=TRUE;
            | 38,39:
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < minpause) OR (v > maxpause) ) THEN abort(errPauseRange,"");END;
                alwayspause:=CARDINAL(v);
            | 40,41:
                glue:=TRUE;
            | 42,43:
                doList:=TRUE;
            | 44,45:
                usemouse:=FALSE;
            | 46,47:
                doWait:=TRUE; usemouse:=FALSE;
            | 48:
                doWait:=TRUE;                  FRprompt:=TRUE;
            | 49:
                doWait:=TRUE; usemouse:=FALSE; FRprompt:=TRUE;
            | 50,51:
                fullclean := TRUE;
            | 52,53:
                useLFN:=FALSE;
            | 54,55:
                abort(errVerboserHelp,"");
            | 56,57:
                toclipboard:=TRUE;
            | 58:
                CHKMEM:=TRUE; OUTPUTME := FALSE;
            | 59:
                DEBUG := TRUE;
            ELSE
                abort(errOption,S);
            END;
        ELSE
            CASE state OF
            | waiting :
                (*
                IF same(R,"?") THEN abort(errHelp,""); END;
                IF same(R,"??") THEN abort(errVerboseHelp,"");END;
                *)
                Str.Copy(rawfilespec,S); (* keep org case *)
            | gotparm1 :
                abort(errParameter,S);
            END;
            INC(state);
        END;
    END;

    useLFN := ( useLFN AND fileSupportLFN() );
    initDefaultFilenames(exedir,currdir,defaultdatafile, extDAT);

    dbg(DEBUG,useLFN,"exedir",exedir);
    dbg(DEBUG,useLFN,"currdir",currdir);
    dbg(DEBUG,useLFN,"defaultdatafile",defaultdatafile);

    IF state = waiting THEN
        IF doList THEN
            rawfilespec:=star;
        ELSE
            rawfilespec:=defaultdatafile;
        END;
    END;
    dbg(DEBUG,useLFN,"rawfilespec 1",rawfilespec);

    rc:=fileFixSpec(zebase,zespec,DEBUG,useLFN,rawfilespec,defaultpat,extDAT);
    dbg(DEBUG,useLFN,"ZEbase",zebase);
    dbg(DEBUG,useLFN,"ZEspec",zespec);
    rc:=getErrcode(rc);
    IF rc # errNone THEN abort(rc,rawfilespec);END;

    IF Str.CharPos(rawfilespec,antislash)=STRNOTFOUND THEN (* filename without path *)
        IF Str.Match(currdir,exedir) THEN (* case-insensitive *)
            lastpass:=1;
        ELSE
            lastpass:=2; (* we'll try exe dir *)
        END;
    ELSE
        lastpass:=1;
    END;

    initList(anchor);
    i:=1;
    LOOP
        CASE i OF
        | 1:
            IF DEBUG THEN WrStr("// step1"+nl);END;
        | 2:
            IF DEBUG THEN WrStr("// step2"+nl);END;
            freeList(anchor);
            initList(anchor);
            Str.Copy(zebase,exedir); (* try exe dir as base now *)
        END;
        Str.Concat(datafile,zebase,zespec);
        dbg(DEBUG,useLFN,"full datafile",datafile);

        filecount := buildFileList(anchor,noskip,useLFN,DEBUG,datafile);
        CASE filecount OF
        | 0 :
            IF i = lastpass THEN abort(errNotFound,datafile); END;
        | 1:
            getStr(zespec,anchor);
            Str.Concat(datafile,zebase,zespec);
            dbg(DEBUG,useLFN,"single file",datafile);
            EXIT;
        | PBTOOMANY :
            abort(errTooManyFiles,datafile);
        ELSE
            IF doList THEN
                EXIT;
            ELSE
                abort(errOnlyForList,datafile);
            END;
        END;
        INC(i);
        IF i > lastpass THEN EXIT; END;
    END;

    (* ------------------------------------------------------------ *)
    (* handle -list command *)
    (* ------------------------------------------------------------ *)

    IF doList THEN
        WrLn;
        WrStr(sBase+sepabout);
        IF useLFN THEN WrStr(dquote);END;
        WrStr(zebase);
        IF useLFN THEN WrStr(dquote);END;
        WrLn;

        WrLn;
        maxlenfilename:=0;
        FOR i:=1 TO 2 DO
            ptr:=anchor;
            WHILE ptr # NIL DO
                getStr(datafile,ptr);
                CASE i OF
                | 1 :
                    thislen:=Str.Length(datafile);
                    IF thislen > maxlenfilename THEN maxlenfilename:=thislen;END;
                | 2 :
                    showtitle (maxlenfilename,LineWidth,
                              redirected,useLFN,DEBUG,zebase,datafile);
                END;
                ptr:=ptr^.next;
            END;
        END;
        freeList(anchor);

        abort(errNone,"");
    END;

    (* ------------------------------------------------------------ *)
    (* -list command has been handled : handle single file *)
    (* ------------------------------------------------------------ *)

    getStr(zespec,anchor);
    Str.Concat(datafile,zebase,zespec);

    IF CHKMEM THEN showmem; END;
    IF readScript(DODUMP,useLFN,datafile)=FALSE THEN abort(errLoading,datafile); END; (* was errMALLOC *)
    IF CHKMEM THEN showmem; END;
    IF DODUMP THEN dumpall(); END;

    InitRnd();

    CASE savermode OF
    | FALSE:
        IF atrandompos THEN
            abort(errNotInNormalMode,"-r option is a nonsense without -s option !");
        END;
        IF stopmouse THEN
            abort(errNotInNormalMode,"-z option is a nonsense without -s option !");
        END;
        IF count = mincount THEN glue:=FALSE;END;
        IF glue THEN WrLn;END;
        FOR i := mincount TO count DO
            colortext( ink,paper );
            IF getSentence(DOSTEPS,hugestring)=FALSE THEN
                abort(errFormat,hugestring);
            END;
            IF formatSentence(LineWidth,doFrame,fullclean,lastline,longest,hugestring)=FALSE THEN
                abort(errSentenceTooBig,"");
            END;
            IF OUTPUTME THEN
                dmpSentence (screenwidth,LineWidth,
                             doFrame,redirected,doBeautify,glue,lastline,longest);
            END;
            colorhelp;

            IF toclipboard THEN
                clipok:=dmpToClipboard(lastline); (* ignore error status *)
            END;

            IF doWait THEN
                IF usemouse THEN usemouse:=MouseDriverHere();END;
                IF usemouse THEN
                    IF FRprompt THEN
                        S:=msgWaitMouseFR;
                    ELSE
                        S:=msgWaitMouse;
                    END;
                ELSE
                    IF FRprompt THEN
                        S:=msgWaitFR;
                    ELSE
                        S:=msgWait;
                    END;
                END;
                video(S,TRUE);
                (* BiosWaitkey(c1,c2); *)
                LOOP
                    IF usemouse THEN
                        IF mouseclick() THEN EXIT; END;
                    END;
                    IF getKeyboardCode(keycode) THEN EXIT; END;
                END;
                video(S,FALSE);
            END;
        END;
    | TRUE:

        (* we ignore toclipboard here, for obvious reasons *)

        IF redirected THEN
             abort(errNotInSaverMode,"Redirection is a nonsense in screensaver mode !");
        END;

        flushKeyboard;
        setCursorShape(invisiblecursor);
        IF stopmouse THEN stopmouse:=MouseDriverHere();END;
        LOOP
            colorhelp;
            cls;
            colortext( ink,paper );
            (* here, ignore all errors *)
            IF getSentence(DOSTEPS,hugestring) THEN
                IF formatSentence(LineWidth,doFrame,fullclean,lastline,longest,hugestring) THEN
                    dmpSentenceAt (doFrame,lastline,longest,
                                  alwayspause,pause,atrandompos,stopmouse);
                END;
            END;
            chk:=getKeyboardCode(keycode);
            IF chk THEN
                CASE keycode OF
                | keyEscape     : EXIT;
                (* | keyCR         : EXIT; *)
                END;
            END;
            IF stopmouse THEN
                (* IF mouseclick() THEN EXIT; END; *)
                mousebuttons:=getLastPressed();
                IF (rightbutton IN mousebuttons) THEN EXIT; END;
            END;
        END;
        colorhelp;
        IF docls THEN cls; ELSE WrLn; END;
        setCursorShape(oldcursor);
    END;

    (* useless but good practice *)

    IF  CHKMEM THEN showmem; END;
    freeall();
    IF CHKMEM THEN showmem; END;

    abort(errNone,"");
END TextGen.


