Option Explicit
DefInt A-Z

' --- from APIDECS.TXT

Declare Function GetVersion& Lib "Kernel" ()

' ------------------------------------------------------------------------

' ------------------------------------------------------------------------

Global Const MATCHANYCASE = 1
Global Const EXACTCASE = 0

'--------------------------------------------------------------------
' paramcount = argC (cli$)

'--------------------------------------------------------------------
' param$ = ArgV$ (cli$, parmnumber) you must take care yourself of case

Function argc (ByVal cli$)
Const empty = 0
Const intoken = 1
Const instring = 2

Dim quote
Dim blank

Dim cliLen
Dim cliPos
Dim argCount
Dim state
Dim char$
Dim code
Dim arg$

quote = 34
blank = &H20

cli$ = Trim$(cli$)
cliLen = Len(cli$)
cliPos = 1
argCount = 0
state = empty
Do Until cliPos > cliLen
    char$ = Mid$(cli$, cliPos, 1)
    code = Asc(char$)
    Select Case state
    Case empty
	Select Case code
	Case quote
	    state = instring' begin new string
	    arg$ = char$
	    argCount = argCount + 1
	Case Is > blank ' quote already trapped
	    state = intoken' begin new token
	    arg$ = char$
	    argCount = argCount + 1
	End Select
    Case intoken
	Select Case code
	Case quote ' quote in token
	    state = instring' if string in parameter
	    arg$ = arg$ + char$
	Case Is > blank
	    arg$ = arg$ + char$
	Case Else
	    state = empty' end of token
	End Select
    Case instring
	Select Case code
	Case quote
	    arg$ = arg$ + char$
	    state = empty' end of string
	Case Is > blank
	    arg$ = arg$ + char$
	Case Else
	    arg$ = arg$ + Chr$(blank)' remove TAB if any
	End Select
    End Select
    cliPos = cliPos + 1
Loop
argc = argCount
End Function

Function ArgV$ (ByVal cli$, ByVal n)
Const empty = 0
Const intoken = 1
Const instring = 2

Dim quote
Dim blank

Dim cliLen
Dim cliPos
Dim argCount
Dim state
Dim char$
Dim code
Dim arg$

quote = 34
blank = &H20

If n < 1 Or n > argc(cli$) Then
    ArgV$ = ""
    Exit Function
End If
cli$ = Trim$(cli$)
cliLen = Len(cli$)
cliPos = 1
argCount = 0
state = empty
Do Until cliPos > cliLen
    char$ = Mid$(cli$, cliPos, 1)
    code = Asc(char$)
    Select Case state
    Case empty
	If n = argCount Then ' argV$ test
	    Exit Do
	End If
	Select Case code
	Case quote
	    state = instring' begin new string
	    arg$ = char$
	    argCount = argCount + 1
	Case Is > blank' quote already trapped
	    state = intoken' begin new token
	    arg$ = char$
	    argCount = argCount + 1
	End Select
    Case intoken
	Select Case code
	Case quote ' quote in token
	    state = instring' if string in parameter
	    arg$ = arg$ + char$
	Case Is > blank
	    arg$ = arg$ + char$
	Case Else
	    state = empty' end of token
	End Select
    Case instring
	Select Case code
	Case quote
	    arg$ = arg$ + char$
	    state = empty' end of string
	Case Is > blank
	    arg$ = arg$ + char$
	Case Else
	    arg$ = arg$ + Chr$(blank)' remove TAB if any
	End Select
    End Select
    cliPos = cliPos + 1
Loop
ArgV$ = arg$
End Function

Function is31% ()
Const vTHREE = 3
Const v10 = 10 * 256
Dim doswindows&
Dim major%, minor%
doswindows& = GetVersion&()
major% = doswindows& And &HFF&
minor% = doswindows& And &HFF00&
If major% = vTHREE And minor% = v10 Then
	is31% = True
Else
	is31% = False
End If
End Function

Function is3x% ()
Const vTHREE = 3
Const v10 = 10 * 256
Const v11 = 11 * 256
Dim doswindows&
Dim major%, minor%
doswindows& = GetVersion&()
major% = doswindows& And &HFF&
minor% = doswindows& And &HFF00&
If major% = vTHREE And (minor% = v10 Or minor% = v11) Then
	is3x% = True
Else
	is3x% = False
End If
End Function

Function isRunning% ()
Dim rc%
If App.PrevInstance = True Then
    rc% = True
Else
    rc% = False
End If
isRunning% = rc%
End Function

Function Occurrences% (ByVal s$, ByVal substring$, ByVal anycase)
Dim Count
Dim p
Count = 0
Do
    p = InStr(1, s$, substring$, anycase)
    If p = 0 Then Exit Do
    Count = Count + 1
    s$ = Mid$(s$, p + Len(substring$))
Loop
Occurrences% = Count
End Function

Function replaceAll$ (ByVal s$, ByVal what$, ByVal become$, ByVal anycase)
Dim i
For i = 1 To Occurrences%(s$, what$, anycase)
    s$ = replaceFirst$(s$, what$, become$, anycase)
Next
replaceAll$ = s$
End Function

Function replaceFirst$ (ByVal s$, ByVal what$, ByVal become$, ByVal anycase)
Dim p
p = InStr(1, s$, what$, anycase)
If p > 0 Then
    s$ = Left$(s$, p - 1) + become$ + Mid$(s$, p + Len(what$))' use FixPath for \\
End If
replaceFirst$ = s$
End Function

Sub waiting (ByVal flag%)
Select Case flag%
Case True
    screen.MousePointer = HOURGLASS
Case False
    screen.MousePointer = DEFAULT
End Select
End Sub

