(* --------------------------------------------------------------
Title         see help
Overview      see help
Usage         see help
Notes         model cannot be small :
              v0.9 was compact, v1.0 requires xlarge

              TXTCAP20.ZIP archive is included in CAP2TGA.ZIP archive,
              for its author has written in his TXTCAP.DOC :
              "In any case, this utility may be used and copied freely."

Bugs
Wish List     where are VT attributes ???
              support for others than 25/50 * 80 ? bah...

--------------------------------------------------------------- *)

MODULE cap2tga;

IMPORT FIO;
IMPORT Str;
IMPORT Lib;
IMPORT Graph;
IMPORT BiosIO;

FROM IO IMPORT WrStr,WrLn;

FROM QD_ASCII IMPORT dash, slash, nullchar, tabchar, cr, lf, nl, bs,
space, dot, deg, doublequote, quote, colon, percent, vbar,
blank, equal, dquote, charnull, singlequote, antislash, dollar,
star, backslash, coma, question, underscore, tabul, hbar,
comma, semicolon, diese, pound, openbracket, closebracket, tilde, exclam,
stardotstar, dotdot, escCh, escSet, letters, digits,
lettersUpp, lettersLow, openbrace, closebrace;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite, setReadOnly,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs, UpperCaseAlt, LowerCaseAlt,
completedInit, completedShow, completedSHOW, completedEnd, completed,
removeDups, isValidHDunit, removePhantoms, removeFloppies,
getCDROMunits, getCDROMletters, removeCDROMs, getAllHDunits,
getAllLegalUnits, metaproc, getCli, argc, argv,
metaproc, UpperCaseFR, LowerCaseFR, ASCIIonly;

FROM NewFontA IMPORT FontDef,
FontCELTIC, FontHEBREW,
FontDEFAULT, FontIBM,
FontVGA, FontELEGANT,
FontROUND, FontMODERN,
FontSANS, FontREADABLE, FontNOVA;

FROM NewFontB IMPORT
FontCOMPUTER, FontDIGITAL,
FontOLDENGLISH, FontGREEK,
FontGREEKSANS, FontREVERSED,
FontHELVETIC, FontHELVBOLD,
FontISO, FontTHIN, FontSCRIPT, FontAWARD;

FROM NewFontC IMPORT
FontSWISS, FontSWISSLARGE,
FontMUCHERY, FontMUCHERYLARGE,
FontMODERNITY, FontMODERNITYLARGE,
FontBLOCKS, FontPLAIN,
FontAPPLE, FontWIN9X, FontARIAL;

FROM NewFontD IMPORT
FontROMAN, FontROMANLARGE,
FontTEKTITE, FontCLOUDS,
FontHAL, FontFAT,
FontBLOOD, FontSERIF,
FontHACKER, FontAMBASSAD,
FontAPPLE2, FontLEGIBLE, FontALTSTD;

FROM NewFontE IMPORT smallFontDef,
smallFontAPPLE,smallFontCOMPAQ,
smallFontSYS,smallFontSYSLINE,smallFontSYSGL,
smallFontWIN9X;

FROM QD_VESA IMPORT vesa640x480x8, vesa800x600x8,
vesa640x480x32, vesa800x600x32, vesa1024x768x8, vesa1280x1024x8,
vesa1024x768x32, vesa1280x1024x32, vesa1600x1200x8,
paltriplettype, minpalndx, maxpalndx,
isMonoMode, waitVGAretrace, setDAC,
resetDAC, getDAC, savesystempal, restoresystempal,
SetVesaMode, initVESAlookup, getVESAmodeInfos,
setVESAbank, VESAgetpixel8, VESAgetpixel32, VESAputpixel8,
VESAputpixel32, initVESAhline, updateVESAhline, VESAputpixel8hline,
VESAputpixel32hline, initVESAmode, getVESAgeometry, chkVESAhere,
isModeHere, set80x25, set80x50, getTextmodeDimensions,
getModeFromList;

(* ------------------------------------------------------------ *)

CONST
    ProgEXEname   = "CAP2TGA";
    ProgTitle     = "Q&D text mode to graphics mode";
    ProgVersion   = "v1.0";
    ProgCopyright = "by PhG";
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;
    extVTF        = ".VTF";
    extTXT        = ".TXT";
    extTGA        = ".TGA";
    extASC        = ".ASC";
CONST
    errNone      = 0;
    errHelp      = 1;
    errOpt       = 2;
    errParm      = 3;
    errVGA       = 4;
    errCannotSet = 5;
    errNotFound  = 6;
    errJoker     = 7;
    errExpecting = 8;
    errcapfile   = 9;
    errExtension = 10;
    errTargetExists =11;
    errFont      = 12;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    helpmsg =
Banner+nl+
nl+
"Syntax : "+ProgEXEname+" <source["+extTXT+"]> [option]..."+nl+
nl+
"   -nocrop     do not automatically crop screen height"+nl+
"   -overwrite  overwrite existing target"+nl+
"   -ascii      create "+extASC+" text file instead of "+extTGA+" graphics file"+nl+
"   -exact      do not right-trim lines (-ascii only)"+nl+
"   -fix        increase character height by one"+nl+
"   -$          font name"+nl+
"   -debug<1|2> debug display"+nl+
nl+
"a) This program converts "+extTXT+" files created with TEXTCAP 2.0"+nl+
"   (a text screen capture DOS program written by a Gisbert W. Selke in 1991)."+nl+
"   Only 25 or 50 lines of 80 characters screens are supported for now."+nl+
(* "   Support for "+extVTF+" files created with VTHIEF is minimal and experimental."+nl+ *)
"b) Default font is 50-lines Apple ][ font. Others choices may be :"+nl+
"   apple, compaq, sys, sysline, sysgl, win9x (50-lines) ;"+nl+
"   vga, readable, plain, ibm, muchery, mucherylarge, arial, legible (25-lines)."+nl+
"c) In order NOT to create target (<source> with "+extTGA+" extension), hit ESC key."+nl+
"d) LFNs are not supported."+nl;

VAR
    S : str256;
BEGIN
    CASE e OF
    | errHelp       : WrStr(helpmsg);
    | errOpt        : S:="Unknown ~ option !";
    | errParm       : S:="~ is one parameter too many !";
    | errVGA        : S:="VGA card required !";
    | errCannotSet  : S:="Cannot set required video mode !";
    | errNotFound   : S:="~ <source> does not exist !";
    | errJoker      : S:="Jokers are NOT allowed !";
    | errExpecting  : S:="~ expected !";
    | errcapfile    : S:="~ may be damaged !";
    | errExtension  : S:="~ cannot have "+extTGA+" extension !";
    | errTargetExists:S:="~ target already exists !";
    | errFont       : S:="Required font does not fit <source> screen height !";
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp :
        ; (* nada *)
    ELSE
        Str.Subst(S,"~",einfo);
        WrStr(ProgEXEname+" : "); WrStr(S); WrLn;
    END;
    Lib.SetReturnCode(SHORTCARD(e));
    HALT;
END abort;

(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBufferType  = ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
VAR
    ioBufferIn,ioBufferOut : ioBufferType;

(* ------------------------------------------------------------ *)

PROCEDURE num2str (v,base,wi:CARDINAL;pad:CHAR  ):str16;
VAR
    R:str16;
    ok:BOOLEAN;
    i:CARDINAL;
BEGIN
    Str.CardToStr( LONGCARD(v),R,base,ok);
    IF ok THEN
        FOR i:=Str.Length(R)+1 TO wi DO
            Str.Prepend(R,pad);
        END;
    ELSE
        R:="???";
    END;

    RETURN R;
END num2str;

(* ------------------------------------------------------------ *)

CONST
    minline = 1;
    maxline = 50;
    minchar = 1;
    maxchar = 80;  (* yes, yes, we should support unlikely 132 columns mode *)
TYPE
    celltype = RECORD
        code  : SHORTCARD;
        attr  : SHORTCARD;
    END;
    linetype = ARRAY [minchar..maxchar] OF celltype;
    dattype  = ARRAY [minline..maxline] OF linetype;
VAR
    datscr,datink,datpaper : dattype;

(* ------------------------------------------------------------ *)

CONST
    capbad = 0;
    capbin = 1;
    capvtf = 2;

PROCEDURE getcapdata (VAR nlines:CARDINAL; F:ARRAY OF CHAR):CARDINAL;
CONST
    txt25fsize   = 4000;
    txt50fsize   = 8000;
    vtfsize      = 132096;
VAR
    hin:FIO.File;
    ok:BOOLEAN;
    whatcap,pb,wanted,got:CARDINAL;
    ID:ARRAY [1..3] OF CHAR;
    fsize:LONGCARD;
BEGIN
    pb:=0;
    hin:=FIO.OpenRead(F);
    FIO.AssignBuffer(hin,ioBufferIn);
    fsize:= FIO.Size(hin);
    IF fsize = txt25fsize THEN
        whatcap := capbin;
        nlines:=25;
        wanted:=txt25fsize;
        got:=FIO.RdBin(hin,datscr,wanted);
        IF got # wanted THEN INC(pb);END;
    ELSIF fsize = txt50fsize THEN
        whatcap := capbin;
        nlines:=50;
        wanted:=txt50fsize;
        got:=FIO.RdBin(hin,datscr,wanted);
        IF got # wanted THEN INC(pb);END;
    ELSIF fsize = vtfsize THEN
        whatcap:=capvtf;
        wanted:=SIZE(ID);
        got:=FIO.RdBin(hin,ID,wanted);
        IF got # wanted THEN INC(pb);END;
        IF same(ID,"VTF")=FALSE THEN INC(pb);END;

        FIO.Seek(hin,0400H);   IF FIO.IOresult() # 0 THEN INC(pb);END;

        wanted:=SIZE(datscr);
        got:=FIO.RdBin(hin,datscr,wanted);
        IF got # wanted THEN INC(pb);END;

        FIO.Seek(hin,8400H);   IF FIO.IOresult() # 0 THEN INC(pb);END;

        wanted:=SIZE(datink);
        got:=FIO.RdBin(hin,datink,wanted);
        IF got # wanted THEN INC(pb);END;

        nlines:=50; (* //FIXME *)
    ELSE
        INC(pb);
    END;
    FIO.Close(hin);
    IF pb # 0 THEN whatcap:=capbad;END;
    RETURN whatcap;
END getcapdata;

CONST
    DUMPSCREENmode = 1;
    DUMPCHARSmode  = 2;
    SAVESCREENmode = 3;

PROCEDURE dmpscr (nlines,listmode:CARDINAL;dotrim:BOOLEAN ;target:ARRAY OF CHAR  );
VAR
    x,y,code:CARDINAL;
    ch:CHAR;
    S:str128;
    filtered:BOOLEAN;
    hout:FIO.File;
BEGIN
    IF listmode = SAVESCREENmode THEN
        hout:=FIO.Create(target);
    END;

        WrLn;
        FOR y:=minline TO nlines DO
            S:="";
            FOR x:=minchar TO maxchar DO
                code:=CARDINAL ( datscr[y,x].code );
                filtered:=FALSE;
                CASE code OF
                | 0..31,255 :
                    ch:="."; filtered:=TRUE;
                ELSE
                    ch:=CHAR( code );
                END;
                CASE listmode OF
                | DUMPSCREENmode :
                    WrStr( ch );
                | DUMPCHARSmode :
                    S:='hex=$~  dec=~  ch="|"~  vtab=~  htab=~';
                    Str.Subst(S,"~",num2str(code,16,2,"0"));
                    Str.Subst(S,"~",num2str(code,10,3," "));
                    Str.Subst(S,"|",ch);
                    IF filtered THEN
                        Str.Subst(S,"~","*");
                    ELSE
                        Str.Subst(S,"~"," ");
                    END;
                    Str.Subst(S,"~",num2str(y,10,2," "));
                    Str.Subst(S,"~",num2str(x,10,2," "));
                    WrStr(S);WrLn;
                | SAVESCREENmode:
                    Str.Append(S,ch);
                END;
            END;
            IF listmode = SAVESCREENmode THEN
                IF dotrim THEN RtrimBlanks(S); END;
                FIO.WrStr(hout,S); FIO.WrLn(hout);
            END;
        END;
    IF listmode = SAVESCREENmode THEN
        FIO.Close(hout);
    END;
END dmpscr;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    cBLACK	       =0;
    cPALEBLUE 	   =1;
    cPALEGREEN     =2;
    cPALECYAN      =3;
    cPALERED       =4;
    cPALEMAGENTA   =5;
    cBROWN         =6;
    cPALEWHITE     =7; (* was WHITE *)
    cGRAY          =8;
    cBLUE          =9;
    cGREEN         =10;
    cCYAN          =11;
    cRED           =12;
    cMAGENTA       =13;
    cYELLOW        =14;
    cWHITE         =15; (* was BRIGHTWHITE *)

    minink         = cBLACK;
    maxink         = cWHITE; (* was BRIGHTWHITE *)

TYPE
    palette16=ARRAY[0..15] OF LONGCARD;
CONST
    pal16=palette16(
    Graph._BLACK       ,
    Graph._BLUE        ,
    Graph._GREEN       ,
    Graph._CYAN        ,
    Graph._RED         ,
    Graph._MAGENTA     ,
    Graph._BROWN       ,
    Graph._WHITE       ,
    Graph._GRAY        ,
    Graph._LIGHTBLUE   ,
    Graph._LIGHTGREEN  ,
    Graph._LIGHTCYAN   ,
    Graph._LIGHTRED    ,
    Graph._LIGHTMAGENTA,
    Graph._LIGHTYELLOW ,
    Graph._BRIGHTWHITE ); (* crire la palette dans l'ordre original de dfinition des couleurs ! *)

TYPE
    textcoords = RECORD     (* must match Graph.TextCoords *)
       row, col: INTEGER;
    END;

CONST
    xmin = 0;
    ymin = 0;
VAR
    screenwidth,screenheight:CARDINAL;
    xmax,ymax:CARDINAL;

CONST                                           (* fastest handling ! *)
    tmode        = Graph._DEFAULTMODE;
    gmode        = Graph._VRES16COLOR;
    Solid        = 0FFFFH;

PROCEDURE pset (x,y,ink:CARDINAL  );
BEGIN
    Graph.Plot(x,y,ink);
END pset;

PROCEDURE HiresOn () : BOOLEAN;
BEGIN
    RETURN Graph.SetVideoMode(gmode);
END HiresOn;

PROCEDURE TextOn (  ) : BOOLEAN;
BEGIN
    RETURN Graph.SetVideoMode(tmode);
END TextOn;

PROCEDURE GrLine (x1,y1,x2,y2:INTEGER;ink,pattern:CARDINAL);
BEGIN
    Graph.SetLinestyle(pattern);
    Graph.Line(x1,y1,x2,y2,ink);
END GrLine;

PROCEDURE GrClearScreen();
BEGIN
    Graph.ClearScreen(Graph._GWINDOW);
END GrClearScreen;

PROCEDURE GrSetBkColor (color : LONGCARD) : LONGCARD;
BEGIN
    RETURN Graph.SetBkColor(color);
END GrSetBkColor;

PROCEDURE GrOutText(S: ARRAY OF CHAR);
BEGIN
    Graph.OutText(S);
END GrOutText ;

PROCEDURE GrSetTextColor(color: CARDINAL): CARDINAL;
BEGIN
    RETURN Graph.SetTextColor(color);
END GrSetTextColor;

PROCEDURE GrSetTextPosition(row, col: CARDINAL) : textcoords ;
BEGIN
    RETURN textcoords(Graph.SetTextPosition(row,col));
END GrSetTextPosition;

PROCEDURE GrPrintAt (vtab,htab,ink:CARDINAL;S:ARRAY OF CHAR );
VAR
    oldcoors : textcoords;
    oldink   : CARDINAL;
BEGIN
    oldink   := GrSetTextColor(ink);
    oldcoors := GrSetTextPosition(vtab,htab);
    GrOutText(S);
END GrPrintAt;

PROCEDURE VGAhere (  ) : BOOLEAN;
VAR
    infovideo : Graph.VideoConfig;
BEGIN
    Graph.GetVideoConfig(infovideo);
    IF infovideo.adapter # Graph._VGA THEN RETURN FALSE; END;
    RETURN TRUE;
END VGAhere;

TYPE
    vidmodetype = (vga640);

PROCEDURE initmode (vidmode:vidmodetype);
BEGIN
    CASE vidmode OF
    | vga640:    screenwidth  := 640;   screenheight := 480;
    END;
    xmax         := screenwidth-1;
    ymax         := screenheight-1;
END initmode;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    (* 50 lines *)
    fntApple         = 1;
    fntCompaq        = 2;
    fntSys           = 3;
    fntSysline       = 4;
    fntSysgl         = 5;
    fntWin9x         = 6;
    (* 25 lines *)
    fntVGA           = 7;
    fntPlain         = 8;
    fntReadable      = 9;
    fntIBM           = 10;
    fntMuchery       = 11;
    fntMucheryLarge  = 12;
    fntArial         = 13;
    fntLegible       = 14;

PROCEDURE getFontLines ( whatfont:CARDINAL  ):CARDINAL;
BEGIN
    CASE whatfont OF
    | fntVGA,fntPlain,fntReadable,fntIBM,fntMuchery,fntMucheryLarge,
      fntArial,fntLegible:
        RETURN 25;
    ELSE
        RETURN 50;
    END;
END getFontLines;

CONST
    wichar   = 8; (* native mode X and or our 8x8 font *)
    hechar8  = 8;
    hechar16 = 16;

PROCEDURE doCharAt (x,y,ink,paper,whatfont,code:CARDINAL;fixhe:BOOLEAN);
TYPE
    bitmasktype = ARRAY[1..8] OF CARDINAL;
CONST
    bitmask = bitmasktype( 80H,40H,20H,10H, 08H,04H,02H,01H);
VAR
    hechar,charsize,p,wi,he,xx,yy,mask,newhechar:CARDINAL;
BEGIN
    IF getFontLines(whatfont) = 25 THEN
        hechar:=hechar16;
    ELSE
        hechar:=hechar8;
    END;

    charsize := (wichar DIV 8 ) * hechar;

    IF fixhe THEN
        newhechar:=hechar+1;
    ELSE
        newhechar:=hechar;
    END;
    x:=x * wichar;
    y:=y * newhechar;

            p  :=code * charsize;
            yy :=y;
            FOR he := 1 TO newhechar DO
                xx := x;
                CASE whatfont OF
                | fntApple :  mask:=CARDINAL ( smallFontAPPLE[p] );
                | fntCompaq:  mask:=CARDINAL ( smallFontCOMPAQ[p] );
                | fntSys   :  mask:=CARDINAL ( smallFontSYS[p] );
                | fntSysline: mask:=CARDINAL ( smallFontSYSLINE[p] );
                | fntSysgl:   mask:=CARDINAL ( smallFontSYSGL[p] );
                | fntWin9x:   mask:=CARDINAL ( smallFontWIN9X[p] );
                | fntVGA:     mask:=CARDINAL ( FontVGA[p] );
                | fntReadable:mask:=CARDINAL ( FontREADABLE[p] );
                | fntPlain:   mask:=CARDINAL ( FontPLAIN[p] );
                | fntIBM:     mask:=CARDINAL ( FontIBM[p] );
                | fntMuchery: mask:=CARDINAL ( FontMUCHERY[p] );
                | fntMucheryLarge:  mask:=CARDINAL ( FontMUCHERYLARGE[p] );
                | fntArial:   mask:=CARDINAL ( FontARIAL[p] );
                | fntLegible: mask:=CARDINAL ( FontLEGIBLE[p] );
                END;
                IF fixhe THEN
                   IF he = newhechar THEN mask:=00H;END;
                END;
                FOR wi:=1 TO wichar DO
                    IF ( mask AND bitmask[wi] ) # 0 THEN
                        pset(xx,yy,ink);
                    ELSE
                        pset(xx,yy,paper);
                    END;
                    INC(xx);
                END;
                INC(p);
                INC(yy);
            END;
END doCharAt;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE showscr (nlines,whatcap,whatfont:CARDINAL;fixhe:BOOLEAN   );
VAR
    x,y,code,ink,paper:CARDINAL;
    ch:CHAR;
BEGIN
        FOR y:=minline TO nlines DO
            FOR x:=minchar TO maxchar DO
                code:=CARDINAL ( datscr[y,x].code );

                CASE whatcap OF
                | capbin:
                    ink   := CARDINAL( datscr[y,x].attr) AND 0FH;
                    paper := CARDINAL( datscr[y,x].attr) >> 4;
                | capvtf:
                    ink   := CARDINAL( datink[y,x].code);
                    paper := cBROWN;
                END;
                doCharAt(x-minchar,y-minline,ink,paper,whatfont,code,fixhe);
            END;
        END;
END showscr;

PROCEDURE screenToFile (bpp,xmin,ymin,wi,he:CARDINAL; targaquirk:BOOLEAN;
                       source,target:ARRAY OF CHAR );
CONST
    egashift = 2;
TYPE
    TGAheaderType = RECORD
	    imgidlen                  : BYTE; (* should be 0 to avoid imgidstring *)
	    colormaptype              : BYTE; (* 0=no map, 1=256 entry palette *)
	    imgtype                   : BYTE; (* 1=uncompressed color mapped, 2=uncompressed rgb *)

	    indexoffirstcolormapentry : CARDINAL; (* ex:1024 entries but only 72 needed, start at position 342 *)
	    countofcolormapentries    : CARDINAL;
	    bitspercolormapentry      : BYTE; (* 15, 16, 24, 32 *)

	    lowerleftcornerX          : CARDINAL; (* x origin *)
	    lowerleftcornerY          : CARDINAL; (* y origin *)
	    imgwidth                  : CARDINAL;
	    imgheight                 : CARDINAL;
	    bitsperpixel              : BYTE; (* number of bits in a stored pixel index 8,16,24,32 *)
	    imgdescriptor             : BYTE;
	                                (*
	                                bits 3..0=number of attribute bits for each pixel
						            0 or 1 for targa16, 0 for targa24, 8 for targa32
					                bit 4=left to right ordering
						            bit 5=top to bottom ordering 0 for origin lower left, 1 for origin upper left
                                    this byte should be $00
                                    *)
    END;
    (*
    then possible color map data
    according to bitspercolor map entry
    4=B G R Attr
    3=B G R
    2=ARRRRRGG GGGGBBBBB (hi lo)
    then image data
    width x height colormap indices
    *)
VAR
    hout:FIO.File;
    h : TGAheaderType;
    ink,r,g,b:SHORTCARD;
    i,x,y:CARDINAL;
    ok:BOOLEAN;
BEGIN
    hout:=FIO.Create(target);
    FIO.AssignBuffer(hout,ioBufferOut);

    CASE bpp OF
    | 8:
        h.imgidlen                  := 0;
        h.colormaptype              := 1; (* map *)
        h.imgtype                   := 1; (* uncompressed color mapped *)
        h.indexoffirstcolormapentry := minpalndx; (* 0 *)
        h.countofcolormapentries    := maxpalndx-minpalndx+1; (* 256 *)
        h.bitspercolormapentry      := 3*8;
        h.lowerleftcornerX          := 0;
        h.lowerleftcornerY          := 0;
        h.imgwidth                  := wi;
        h.imgheight                 := he;
        h.bitsperpixel              := 8;
        h.imgdescriptor             := 0;
    END;

    FIO.WrBin(hout,h,SIZE(h));

    CASE bpp OF
    | 8:
        FOR i:=minpalndx TO maxpalndx DO
            getDAC(i,r,g,b);
            IF targaquirk THEN (* $00..$3f to $00..$ff *)
                r:=r << egashift;
                g:=g << egashift;
                b:=b << egashift;
            END;
            FIO.WrBin(hout,b,1);
            FIO.WrBin(hout,g,1);
            FIO.WrBin(hout,r,1);
        END;
        FOR y :=(he-1) TO ymin BY -1 DO
	        FOR x := xmin TO (wi-1) DO
                ink:=SHORTCARD( Graph.Point(x,y) );
    	        FIO.WrBin(hout,ink,1);
            END;
        END;
    END;

    FIO.Flush(hout);
    FIO.Close(hout);

END screenToFile;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    msgINFO   = "::: ";
    msgCreated= " has been created.";
CONST
    firstparm = 1;
    maxparm   = 1;
VAR
    lastparm : CARDINAL;
    parm     : ARRAY[firstparm..maxparm] OF str128;
VAR
    S,R,source,target:str128;
    i,opt,parmcount:CARDINAL;
    whatfont:CARDINAL;
    DEBUG,chk,ok:BOOLEAN;
    listmode:CARDINAL;
    bgr:LONGCARD;
    dotrim,dumpascii,overwrite,autocrop,fixhe,saveme:BOOLEAN;
    ch:CHAR;
    hechar,screenH,whatcap,nlines:CARDINAL;
BEGIN
    FIO.IOcheck:=FALSE;
    WrLn;                       (* must be here for pretty ulterior display ! *)

    whatfont := fntApple;
    autocrop := TRUE;
    overwrite:= FALSE;
    dumpascii:= FALSE;
    dotrim   := TRUE;
    fixhe    := FALSE;
    DEBUG    := FALSE;

    parmcount := Lib.ParamCount();
    lastparm := firstparm-1;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i);
        Str.Copy(R,S);
        UpperCase(R);
        RtrimBlanks(R);
        IF isOption(R) THEN
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   "APPLE"+delim+
                                   "COMPAQ"+delim+
                                   "SYS"+delim+
                                   "SYSLINE"+delim+
                                   "SYSGL"+delim+
                                   "WIN9X"+delim+"WIN"+delim+
                                   "DEBUG1"+delim+
                                   "DEBUG2"+delim+
                                   "FIX"+delim+       "F"+delim+
                                   "NOCROP"+delim+    "N"+delim+
                                   "OVERWRITE"+delim+ "O"+delim+
                                   "ASCII"+delim+     "A"+delim+
                                   "EXACT"+delim+     "E"+delim+
                                   "AA"+delim+
                                   "VGA"+delim+
                                   "READABLE"+delim+
                                   "PLAIN"+delim+
                                   "IBM"+delim+
                                   "MUCHERY"+delim+
                                   "MUCHERYLARGE"+delim+
                                   "ARIAL"+delim+
                                   "LEGIBLE"
                                   );
            CASE opt OF
            | 1,2,3: abort(errHelp,"");
            | 4:     whatfont:=fntApple;
            | 5:     whatfont:=fntCompaq;
            | 6:     whatfont:=fntSys;
            | 7:     whatfont:=fntSysline;
            | 8:     whatfont:=fntSysgl;
            | 9,10:  whatfont:=fntWin9x;
            |11:     DEBUG:=TRUE; listmode:=DUMPSCREENmode;
            |12:     DEBUG:=TRUE; listmode:=DUMPCHARSmode;
            |13,14:  fixhe:=TRUE;
            |15,16:  autocrop:=FALSE;
            |17,18:  overwrite:=TRUE;
            |19,20:  dumpascii:=TRUE;
            |21,22:  dotrim:=FALSE;
            |23:     dumpascii:=TRUE;
                     dotrim:=FALSE;
            |24:     whatfont:=fntVGA;
            |25:     whatfont:=fntReadable;
            |26:     whatfont:=fntPlain;
            |27:     whatfont:=fntIBM;
            |28:     whatfont:=fntMuchery;
            |29:     whatfont:=fntMucheryLarge;
            |30:     whatfont:=fntArial;
            |31:     whatfont:=fntLegible;
            ELSE
                abort(errOpt,S);
            END;
        ELSE
            INC(lastparm);
            IF lastparm > maxparm THEN abort(errParm,S);END;
            Str.Copy(parm[lastparm],S);
        END;
    END;
    CASE lastparm OF
    | firstparm-1 : abort(errExpecting,"<source>");
    | firstparm   : Str.Copy(source, parm[firstparm]);
    ELSE
        abort(errHelp,"");
    END;
    IF Str.RCharPos(source,dot)=MAX(CARDINAL) THEN Str.Append(source,extTXT);END;
    IF chkJoker(source) THEN abort(errJoker,source);END;
    IF Str.Match(source,"*"+extTGA) THEN abort(errExtension,source);END;
    IF FIO.Exists(source)=FALSE THEN abort(errNotFound,source);END;

    Str.Copy(target,source);
    i:=Str.RCharPos(target,dot);
    IF i # MAX(CARDINAL) THEN target[i]:=CHR(0); END;
    IF dumpascii THEN
        R:=extASC;
    ELSE
        R:=extTGA;
    END;
    Str.Append(target,R);
    IF NOT(DEBUG) THEN
        IF FIO.Exists(target) THEN
            IF NOT(overwrite) THEN abort(errTargetExists,target);END;
            FIO.Erase(target);
        END;
    END;

    whatcap:=getcapdata(nlines,source);
    IF whatcap = capbad THEN abort(errcapfile,source);END;
    IF nlines > getFontLines(whatfont) THEN abort(errFont,"");END;

    IF DEBUG THEN
        dmpscr(nlines,listmode,dotrim,"");
        abort(errNone,"");
    END;

    (* ------------------------------------------------------------ *)

    IF dumpascii THEN
        dmpscr(nlines,SAVESCREENmode,dotrim,target);
        WrStr(msgINFO);WrStr(target);WrStr(msgCreated);WrLn;
        abort(errNone,"");
    END;

    (* ------------------------------------------------------------ *)

    initmode(vga640);

    IF VGAhere()=FALSE THEN abort(errVGA,"");END;
    IF HiresOn()=FALSE THEN
        chk := TextOn();
        abort(errCannotSet,"");
    END;

    showscr(nlines,whatcap,whatfont,fixhe);

    saveme := TRUE;
    ch:=BiosIO.RdKey();
    CASE ch OF
    | CHR(0): ch:=BiosIO.RdKey(); ch:=" "; (* fake *)
    | CHR(27): saveme:=FALSE  ;
    END;
    IF saveme THEN
        IF autocrop THEN
            IF getFontLines(whatfont) = 25 THEN
                hechar:=hechar16;
            ELSE
                hechar:=hechar8;
            END;
            CASE nlines OF
            | 25,50:
                IF fixhe THEN INC(hechar);END;
                screenH := hechar * nlines;
            ELSE
                screenH := screenheight;
            END;
        ELSE
            screenH := screenheight;
        END;

        screenToFile(8,xmin,ymin,screenwidth,screenH,TRUE,source,target);
    END;

    chk:=TextOn();
    IF saveme THEN
        WrStr(msgINFO);WrStr(target);WrStr(msgCreated);WrLn;
    END;
    abort(errNone,"");
END cap2tga.



