(* ---------------------------------------------------------------
Title         Q&D Money Converter
Overview      convertisseur gnraliste,
              mais aussi, hlas, pour la monnaie d'occupation  cours forc
Notes         clipboard works with Win92 and Win98SE but NOT with WinXP :-(
Bugs
Wish List     a real calculator with an eval function ?
              a shortcut for -l -n
              a format string so we can use a prefix ?

              this is a statement against Yet Another Evil Empire a.k.a. E.U.
              (John Walker is *right* about it, here too)
              this is like yet another awful AMGOT currency

--------------------------------------------------------------- *)

MODULE Change;

IMPORT Lib;
IMPORT Str;
IMPORT FIO;
IMPORT SYSTEM;

FROM IO IMPORT WrStr,WrLn,WrCard;

FROM QD_ASCII IMPORT dash, slash, nullchar, tabchar, cr, lf, nl, bs,
space, dot, deg, doublequote, quote, colon, percent, vbar,
blank, equal, dquote, charnull, singlequote, antislash, dollar,
star, backslash, coma, question, underscore, tabul, hbar,
comma, semicolon, diese, pound, openbracket, closebracket, tilde, exclam,
stardotstar, dotdot, escCh, escSet, letters, digits,
lettersUpp, lettersLow, openbrace, closebrace;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs,
completedInit, completedShow, completedSHOW, completedEnd, completed;

(* ------------------------------------------------------------ *)

CONST
    ProgEXEname   = "CHANGE";
    ProgTitle     = "Q&D Money Converter";
    ProgVersion   = "v1.0i";
    ProgCopyright = "by PhG";
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;
    extINI        = ".INI";
    extEXE        = ".EXE";

(* ------------------------------------------------------------ *)

CONST
    errNone            = 0;
    errHelp            = 1;
    errOption          = 2;
    errBadMult         = 3;
    errBadFix          = 4;
    errBadMarker       = 5;
    errBadAmount       = 6;
    errBadAmountMarker = 7;
    errSameMarkers     = 8;
    errTooManyAmounts  = 9;
    errNoAmount        = 10;
    errWinOldApClipboard = 11;
    errNotFound        = 12;
    errDatafile        = 13;
    errBothMarkers     = 14;
    errOverlap         = 15;
    errIllogical       = 16;
    errMutuallyExclusive=17;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
CONST
    helpmsg =
Banner+nl+
nl+
"Syntax : "+ProgEXEname+" <[marker]amount[marker]>... [option]..."+nl+
nl+
"    -l|-p    one line presentation"+nl+
"    -a       US decimal format (default is French decimal format)"+nl+
"    -s|-t    show grand total"+nl+
"    -n       keep CRLFs to a minimum"+nl+
"    -c|-w|-y copy output to Vindoze clipboard if available"+nl+
"             (-cc = -ww = -c -l ; -ccc = -www = -c -l -n)"+nl+
"    -f:$     user-specified external file for conversion parameters"+nl+
"    -!       create default "+ProgEXEname+extINI+" in current directory then terminate"+nl+
nl+
"a) Decimal separator is either a comma or a dot."+nl+(* "Spaces may be used for clarity." *)
"b) Optional "+ProgEXEname+extINI+' may be created using "-!" option.'+nl+
"   It is first searched for in current directory then in executable directory."+nl+
"   Here is expected format :"+nl+
nl+
"       value of occupation currency expressed in local currency (decimal)"+nl+
"       digits after decimal separator (decimal)"+nl+
"       verbatim occupation currency marker (up to 16 character)"+nl+
"       verbatim local currency marker (up to 16 characters)"+nl+
"       plain text for occupation currency (singular)"+nl+
"       plain text for occupation currency (plural)"+nl+
"       plain text for local currency (singular)"+nl+
"       plain text for local currency (plural)"+nl+
nl+
'   Lines beginning with ";" or "#" are ignored. Empty lines are ignored too.'+nl+
"c) John Walker is right about EU (as he is about many other subjects) :"+nl+
"   it *is* Yet Another Evil Empire."+nl;

VAR
    S : str256;
BEGIN
    CASE e OF
    | errHelp :      WrStr(helpmsg);
    | errOption :         S := 'Illegal "|" option !';
    | errBadMult:         S := "Illegal coefficient in data file !";
    | errBadMarker:       S := "Illegal marker in data file !";
    | errBadAmount:       S := 'Illegal "|" amount !';
    | errBadAmountMarker: S := "Illegal <[marker]amount[marker]> !";
    | errSameMarkers:     S := "Markers must be different !";
    | errTooManyAmounts:  S := "Too many amounts !";
    | errNoAmount:        S := "No amount was specified !";
    | errWinOldApClipboard:S:= "Data could not be copied to clipboard !";
    | errNotFound:        S := '"|" does not exist !';
    | errDatafile:        S := '"|" format does not seem correct !';
    | errBothMarkers:     S := '"|" containd both prefix and suffix markers !';
    | errOverlap:         S := '"|" contains overlapping markers !';
    | errIllogical:       S := '"|" contains mutually exclusive markers !';
    | errMutuallyExclusive:S:= '"|" contains mutually exclusive markers !';
    ELSE
                          S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone, errHelp : ;
    ELSE
        Str.Subst(S,"|",einfo);
        WrStr(ProgEXEname+" : ");WrStr(S);WrLn;
    END;
    Lib.SetReturnCode(SHORTCARD(e));
    HALT;
END abort;

PROCEDURE fmtreal (v:LONGREAL;sep,decimal:CHAR;fix:CARDINAL;
                   VAR RR:ARRAY OF CHAR);
VAR
    S,R : str128;
    ok:BOOLEAN;
    i,len:CARDINAL;
BEGIN
    Str.FixRealToStr(v,fix,S,ok);
    IF ok THEN
        ReplaceChar(S,dot,decimal); (* replace dot with comma or... dot ! *)
        (* "*,##" *)
        len:=Str.CharPos(S,decimal); (* trick ! *)
        R := "";
        FOR i := 1 TO len DO
            Str.Prepend(R,S[len-i]);
            IF i < len THEN
                IF (i MOD 3) = 0 THEN Str.Prepend(R,sep); END;
            END;
        END;
        Str.Delete(S,0,len);
        Str.Prepend(S,R);
    ELSE
        S := "?";
    END;
    Str.Copy(RR,S);
END fmtreal;

PROCEDURE fmthowmuch (v:LONGREAL;sing,plur:ARRAY OF CHAR; VAR R:ARRAY OF CHAR);
BEGIN
    IF v > 1.0 THEN
        Str.Copy(R,plur);
    ELSE
        Str.Copy(R,sing);
    END;
END fmthowmuch;

(* ------------------------------------------------------------ *)

VAR
    what : (mult,
            decimals,
            marker,
            localmarker,
            singular,
            plural,
            localsingular,
            localplural);
CONST
    firstndx = ORD(mult);
    lastndx  = ORD(localplural);
VAR
    strdat : ARRAY [firstndx..lastndx] OF str128; (* globerk strikes again *)
CONST
    defaultdata=
"6.55957"+delim+
"2"+delim+
"E"+delim+
"F"+delim+
"unit en monnaie d'occupation"+delim+
"units en monnaie d'occupation"+delim+
"franc"+delim+
"francs";

   defaultdatafile=
"; correspondance entre une unit de la monnaie d'occupation et la monnaie locale"+nl+
"6.55957"+nl+
nl+
"; dcimales"+nl+
"2"+nl+
nl+
"; marqueur verbatim de la monnaie d'occupation faon AMGOT"+nl+
"E"+nl+
nl+
"; marqueur verbatim de la monnaie locale"+nl+
"F"+nl+
nl+
"; monnaie d'occupation (singulier, pluriel)"+nl+
"; technocrates incultes  la Giscard dit d'Estaing,"+nl+
"; qui aimeraient supprimer la marque du pluriel,"+nl+
'; et mme imposer "cent" au lieu du logique "centieuro"'+nl+
"; quand ils n'ont pas os "+'"dollaro" ou mieux : "dolleuro" !'+nl+
"unit en monnaie d'occupation"+nl+
"units en monnaie d'occupation"+nl+
nl+
"; monnaie locale (singulier, pluriel)"+nl+
"franc"+nl+
"francs"+nl+
nl;

PROCEDURE initDat (DEBUG,gen:BOOLEAN; VAR ini:ARRAY OF CHAR):CARDINAL;
VAR
    S:str128;
    hnd:FIO.File;
    internal:BOOLEAN;
    i:CARDINAL;
    ndx:INTEGER; (* 0-1 is NOT a CARDINAL, eh eh *)
BEGIN
    IF gen THEN
        Str.Copy(ini,ProgEXEname+extINI);
        hnd:=FIO.Create(ini);
        FIO.WrStr(hnd,defaultdatafile);
        FIO.Close(hnd);
        WrStr(ini);WrStr(" has been created.");WrLn;
        RETURN errNone;
    END;

    IF same (ini,"") THEN
        Str.Copy(ini,ProgEXEname+extINI);
        internal:= NOT( FIO.Exists(ini) );
        IF internal THEN
            Lib.ParamStr(ini,0);
            UpperCase(ini); (* useless but... *)
            Str.Subst(ini,extEXE,extINI);
            internal:= NOT( FIO.Exists(ini) );
        END;
    ELSE
        IF Str.CharPos(ini,".")=MAX(CARDINAL) THEN Str.Append(ini,extINI);END;
        internal:= NOT( FIO.Exists(ini) );
        IF internal THEN RETURN errNotFound; END; (* could just use internal too *)
    END;
    IF internal THEN
        (* warn ? *)
        FOR i:=firstndx TO lastndx DO
            Str.ItemS ( strdat[i], defaultdata, delim, i);
            IF DEBUG THEN WrStr(strdat[i]);WrLn;END;
        END;
    ELSE
        hnd:=FIO.OpenRead(ini);
        ndx:=firstndx-1;
        LOOP
            IF FIO.EOF THEN EXIT; END;
            FIO.RdStr(hnd,S);
            LtrimBlanks(S);
            RtrimBlanks(S);
            IF DEBUG THEN WrStr(S);WrLn;END;
            CASE S[0] OF
            | semicolon,pound,nullchar : ; (* ignore comment or empty string *)
            ELSE
                IF ndx < lastndx THEN
                    INC(ndx);
                    Str.Copy( strdat[ndx], S);
                ELSE
                    EXIT;
                END;
            END;
        END;
        FIO.Close(hnd);
        IF ndx # lastndx THEN RETURN errDatafile; END;
    END;
    RETURN errNone;
END initDat;

(* ------------------------------------------------------------ *)

(* ripped and adapted from old PC2WIN v1.0a last revised 29 Apr 00 *)

TYPE
    chardef   = RECORD
                    Code    : BYTE;
                    Flag    : CHAR;
                    MapChar : BYTE;
                END;
    CharTable = ARRAY [0..255] OF chardef;

CONST
    TpcTOwin  = CharTable (
    chardef(000H, "=", 000H),
    chardef(001H, "=", 001H),
    chardef(002H, "=", 002H),
    chardef(003H, "=", 003H),
    chardef(004H, "=", 004H),
    chardef(005H, "=", 005H),
    chardef(006H, "=", 006H),
    chardef(007H, "=", 007H),
    chardef(008H, "=", 008H),
    chardef(009H, "!", 009H),
    chardef(00AH, "=", 00AH),
    chardef(00BH, "=", 00BH),
    chardef(00CH, "=", 00CH),
    chardef(00DH, "=", 00DH),
    chardef(00EH, "=", 00EH),
    chardef(00FH, "=", 00FH),
    chardef(010H, "=", 010H),
    chardef(011H, "=", 011H),
    chardef(012H, "=", 012H),
    chardef(013H, "=", 013H),
    chardef(014H, "!", 0B6H),
    chardef(015H, "!", 0A7H),
    chardef(016H, "=", 016H),
    chardef(017H, "=", 017H),
    chardef(018H, "=", 018H),
    chardef(019H, "=", 019H),
    chardef(01AH, "=", 01AH),
    chardef(01BH, "=", 01BH),
    chardef(01CH, "=", 01CH),
    chardef(01DH, "=", 01DH),
    chardef(01EH, "=", 01EH),
    chardef(01FH, "=", 01FH),
    chardef(020H, "=",  " "),
    chardef(021H, "=",  "!"),
    chardef(022H, "=",  '"'),
    chardef(023H, "=",  "#"),
    chardef(024H, "=",  "$"),
    chardef(025H, "=",  "%"),
    chardef(026H, "=",  "&"),
    chardef(027H, "=",  "'"),
    chardef(028H, "=",  "("),
    chardef(029H, "=",  ")"),
    chardef(02AH, "=",  "*"),
    chardef(02BH, "=",  "+"),
    chardef(02CH, "=",  ","),
    chardef(02DH, "=",  "-"),
    chardef(02EH, "=",  "."),
    chardef(02FH, "=",  "/"),
    chardef(030H, "=",  "0"),
    chardef(031H, "=",  "1"),
    chardef(032H, "=",  "2"),
    chardef(033H, "=",  "3"),
    chardef(034H, "=",  "4"),
    chardef(035H, "=",  "5"),
    chardef(036H, "=",  "6"),
    chardef(037H, "=",  "7"),
    chardef(038H, "=",  "8"),
    chardef(039H, "=",  "9"),
    chardef(03AH, "=",  ":"),
    chardef(03BH, "=",  ";"),
    chardef(03CH, "=",  "<"),
    chardef(03DH, "=",  "="),
    chardef(03EH, "=",  ">"),
    chardef(03FH, "=",  "?"),
    chardef(040H, "=",  "@"),
    chardef(041H, "=",  "A"),
    chardef(042H, "=",  "B"),
    chardef(043H, "=",  "C"),
    chardef(044H, "=",  "D"),
    chardef(045H, "=",  "E"),
    chardef(046H, "=",  "F"),
    chardef(047H, "=",  "G"),
    chardef(048H, "=",  "H"),
    chardef(049H, "=",  "I"),
    chardef(04AH, "=",  "J"),
    chardef(04BH, "=",  "K"),
    chardef(04CH, "=",  "L"),
    chardef(04DH, "=",  "M"),
    chardef(04EH, "=",  "N"),
    chardef(04FH, "=",  "O"),
    chardef(050H, "=",  "P"),
    chardef(051H, "=",  "Q"),
    chardef(052H, "=",  "R"),
    chardef(053H, "=",  "S"),
    chardef(054H, "=",  "T"),
    chardef(055H, "=",  "U"),
    chardef(056H, "=",  "V"),
    chardef(057H, "=",  "W"),
    chardef(058H, "=",  "X"),
    chardef(059H, "=",  "Y"),
    chardef(05AH, "=",  "Z"),
    chardef(05BH, "=",  "["),
    chardef(05CH, "=",  "\"),
    chardef(05DH, "=",  "]"),
    chardef(05EH, "=",  "^"),
    chardef(05FH, "=",  "_"),
    chardef(060H, "=",  "`"),
    chardef(061H, "=",  "a"),
    chardef(062H, "=",  "b"),
    chardef(063H, "=",  "c"),
    chardef(064H, "=",  "d"),
    chardef(065H, "=",  "e"),
    chardef(066H, "=",  "f"),
    chardef(067H, "=",  "g"),
    chardef(068H, "=",  "h"),
    chardef(069H, "=",  "i"),
    chardef(06AH, "=",  "j"),
    chardef(06BH, "=",  "k"),
    chardef(06CH, "=",  "l"),
    chardef(06DH, "=",  "m"),
    chardef(06EH, "=",  "n"),
    chardef(06FH, "=",  "o"),
    chardef(070H, "=",  "p"),
    chardef(071H, "=",  "q"),
    chardef(072H, "=",  "r"),
    chardef(073H, "=",  "s"),
    chardef(074H, "=",  "t"),
    chardef(075H, "=",  "u"),
    chardef(076H, "=",  "v"),
    chardef(077H, "=",  "w"),
    chardef(078H, "=",  "x"),
    chardef(079H, "=",  "y"),
    chardef(07AH, "=",  "z"),
    chardef(07BH, "=",  "{"),
    chardef(07CH, "=",  "|"),
    chardef(07DH, "=",  "}"),
    chardef(07EH, "=",  "~"),
    chardef(07FH, "?",  " "),
    chardef(080H, "=", 0C7H),
    chardef(081H, "=", 0FCH),
    chardef(082H, "=", 0E9H),
    chardef(083H, "=", 0E2H),
    chardef(084H, "=", 0E4H),
    chardef(085H, "=", 0E0H),
    chardef(086H, "=", 0E5H),
    chardef(087H, "=", 0E7H),
    chardef(088H, "=", 0EAH),
    chardef(089H, "=", 0EBH),
    chardef(08AH, "=", 0E8H),
    chardef(08BH, "=", 0EFH),
    chardef(08CH, "=", 0EEH),
    chardef(08DH, "=", 0ECH),
    chardef(08EH, "=", 0C4H),
    chardef(08FH, "=", 0C5H),
    chardef(090H, "=", 0C9H),
    chardef(091H, "=", 0E6H),
    chardef(092H, "=", 0C6H),
    chardef(093H, "=", 0F4H),
    chardef(094H, "=", 0F6H),
    chardef(095H, "=", 0F2H),
    chardef(096H, "=", 0FBH),
    chardef(097H, "=", 0F9H),
    chardef(098H, "=", 0FFH),
    chardef(099H, "=", 0D6H),
    chardef(09AH, "=", 0DCH),
    chardef(09BH, "=", 0A2H),
    chardef(09CH, "=", 0A3H),
    chardef(09DH, "=", 0A5H),
    chardef(09EH, "?",  " "),
    chardef(09FH, "?",  " "),
    chardef(0A0H, "=", 0E1H),
    chardef(0A1H, "=", 0EDH),
    chardef(0A2H, "=", 0F3H),
    chardef(0A3H, "=", 0FAH),
    chardef(0A4H, "=", 0F1H),
    chardef(0A5H, "=", 0D1H),
    chardef(0A6H, "=", 0AAH),
    chardef(0A7H, "=", 0BAH),
    chardef(0A8H, "=", 0BFH),
    chardef(0A9H, "?",  " "),
    chardef(0AAH, "=", 0ACH),
    chardef(0ABH, "=", 0BDH),
    chardef(0ACH, "=", 0BCH),
    chardef(0ADH, "=", 0A1H),
    chardef(0AEH, "=", 0ABH),
    chardef(0AFH, "=", 0BBH),
    chardef(0B0H, "@",  " "),
    chardef(0B1H, "@",  " "),
    chardef(0B2H, "@",  " "),
    chardef(0B3H, "@",  " "),
    chardef(0B4H, "@",  " "),
    chardef(0B5H, "@",  " "),
    chardef(0B6H, "@",  " "),
    chardef(0B7H, "@",  " "),
    chardef(0B8H, "@",  " "),
    chardef(0B9H, "@",  " "),
    chardef(0BAH, "@",  " "),
    chardef(0BBH, "@",  " "),
    chardef(0BCH, "@",  " "),
    chardef(0BDH, "@",  " "),
    chardef(0BEH, "@",  " "),
    chardef(0BFH, "@",  " "),
    chardef(0C0H, "@",  " "),
    chardef(0C1H, "@",  " "),
    chardef(0C2H, "@",  " "),
    chardef(0C3H, "@",  " "),
    chardef(0C4H, "@",  " "),
    chardef(0C5H, "@",  " "),
    chardef(0C6H, "@",  " "),
    chardef(0C7H, "@",  " "),
    chardef(0C8H, "@",  " "),
    chardef(0C9H, "@",  " "),
    chardef(0CAH, "@",  " "),
    chardef(0CBH, "@",  " "),
    chardef(0CCH, "@",  " "),
    chardef(0CDH, "@",  " "),
    chardef(0CEH, "@",  " "),
    chardef(0CFH, "@",  " "),
    chardef(0D0H, "@",  " "),
    chardef(0D1H, "@",  " "),
    chardef(0D2H, "@",  " "),
    chardef(0D3H, "@",  " "),
    chardef(0D4H, "@",  " "),
    chardef(0D5H, "@",  " "),
    chardef(0D6H, "@",  " "),
    chardef(0D7H, "@",  " "),
    chardef(0D8H, "@",  " "),
    chardef(0D9H, "@",  " "),
    chardef(0DAH, "@",  " "),
    chardef(0DBH, "@",  " "),
    chardef(0DCH, "@",  " "),
    chardef(0DDH, "@",  " "),
    chardef(0DEH, "@",  " "),
    chardef(0DFH, "@",  " "),
    chardef(0E0H, "?",  " "),
    chardef(0E1H, "=", 0DFH),
    chardef(0E2H, "?",  " "),
    chardef(0E3H, "?",  " "),
    chardef(0E4H, "?",  " "),
    chardef(0E5H, "?",  " "),
    chardef(0E6H, "=", 0B5H),
    chardef(0E7H, "?",  " "),
    chardef(0E8H, "?",  " "),
    chardef(0E9H, "?",  " "),
    chardef(0EAH, "?",  " "),
    chardef(0EBH, "?",  " "),
    chardef(0ECH, "?",  " "),
    chardef(0EDH, "=", 0D8H),
    chardef(0EEH, "?",  " "),
    chardef(0EFH, "?",  " "),
    chardef(0F0H, "?",  " "),
    chardef(0F1H, "=", 0B1H),
    chardef(0F2H, "?",  " "),
    chardef(0F3H, "?",  " "),
    chardef(0F4H, "?",  " "),
    chardef(0F5H, "?",  " "),
    chardef(0F6H, "=", 0F7H),
    chardef(0F7H, "?",  " "),
    chardef(0F8H, "=", 0B0H),
    chardef(0F9H, "?",  " "),
    chardef(0FAH, "?",  " "),
    chardef(0FBH, "?",  " "),
    chardef(0FCH, "?",  " "),
    chardef(0FDH, "=", 0B2H),
    chardef(0FEH, "?",  " "),
    chardef(0FFH, "=",  " "));

(* we don't care about flag here *)

PROCEDURE remap2oem (ch:CHAR):CHAR;
BEGIN
    RETURN TpcTOwin[ ORD(ch) ].MapChar;
END remap2oem;

(* ------------------------------------------------------------ *)

VAR
    hugeStr : str4096; (* globerk should do *)

PROCEDURE initclipbuff (  );
BEGIN
    Str.Copy(hugeStr,"");
END initclipbuff;

PROCEDURE appendclipbuff (addnl:BOOLEAN; S:ARRAY OF CHAR);
VAR
    i  : CARDINAL;
    ch : CHAR;
BEGIN
    FOR i:=1 TO Str.Length(S) DO
         ch:=S[i-1];
         S[i-1]:=remap2oem(ch); (* should do *)
    END;
    Str.Append(hugeStr,S);
    IF addnl THEN Str.Append(hugeStr,nl); END;
END appendclipbuff;

PROCEDURE forcenewclipboard (  ):BOOLEAN;
CONST
    multiplex = 2FH;
VAR
    R : SYSTEM.Registers;
BEGIN
    (* WrStr(hugeStr); *)

    R.AX := 1700H; (* INT 2F - MS Windows "WINOLDAP" - IDENTIFY WinOldAp version *)
    Lib.Intr(R,multiplex);
    IF R.AX = 1700H THEN RETURN FALSE; END; (* clipboard not supported *)

    R.AX := 1701H; (* INT 2F - MS Windows "WINOLDAP" - OPEN CLIPBOARD *)
    Lib.Intr(R,multiplex);
    IF R.AX = 0 THEN RETURN FALSE; END; (* clipboard already open *)

    R.AX := 1702H; (* INT 2F - MS Windows "WINOLDAP" - EMPTY CLIPBOARD *)
    Lib.Intr(R,multiplex);
    IF R.AX = 0 THEN RETURN FALSE; END; (* failure to empty clipboard *)

    R.AX := 1703H; (* INT 2F - MS Windows "WINOLDAP" - SET CLIPBOARD DATA *)
    R.DX := 1; (* 1=text, 7=OEM text *)
    R.ES := Seg(hugeStr);
    R.BX := Ofs(hugeStr);
    R.SI := 0;                (* hugeStr is never more than 4096 *)
    R.CX := Str.Length(hugeStr); (* idem *)
    Lib.Intr(R,multiplex);
    IF R.AX = 0 THEN (* failure to copy data to clipboard *)
        ; (* we should return FALSE here but we'll force closeclipboard for safety *)
    END;

    R.AX := 1708H; (* INT 2F - MS Windows "WINOLDAP" - CloseClipboard *)
    Lib.Intr(R,multiplex);
    RETURN (R.AX # 0);
END forcenewclipboard;

PROCEDURE align (oneline:BOOLEAN;pad:CHAR;VAR S1,S2:ARRAY OF CHAR);
VAR
    l1,l2,wi,i:CARDINAL;
BEGIN
    IF oneline THEN RETURN; END;
    l1:=Str.Length(S1);
    l2:=Str.Length(S2);
    IF l1 < l2 THEN
        wi:=l2;
    ELSE
        wi:=l1;
    END;
    (* ugly but functional ! *)
    FOR i:=1 TO wi DO
        IF Str.Length(S1) < wi THEN Str.Prepend(S1,pad);END;
        IF Str.Length(S2) < wi THEN Str.Prepend(S2,pad);END;
    END;
END align;

PROCEDURE padstring (VAR S:ARRAY OF CHAR;separ: ARRAY OF CHAR; wi:INTEGER);
VAR
    l1,l2,ll,i:CARDINAL;
BEGIN
    ll:= Str.Length(separ);
    l1:= Str.Length(S)+1+ll;
    l2:=CARDINAL( ABS(wi) );
    FOR i:=l1 TO l2 DO
        IF wi < 0 THEN
            Str.Prepend(S," ");
        ELSE
            Str.Append (S," ");
        END;
    END;
    Str.Append(S,separ);
END padstring;

CONST
    wisepar = 80 DIV 2; (* half standard line width *)

PROCEDURE dmpem (S1,S2:ARRAY OF CHAR;oneline,addnl,toclipboard,donl:BOOLEAN);
VAR
    S:str128;
BEGIN
    Str.Copy(S,S1);
    IF oneline THEN padstring(S," = ",wisepar); END;
    WrStr(S);
    IF NOT(oneline) THEN WrLn; END;
    WrStr(S2);WrLn;

    IF donl THEN WrLn;END;

    IF toclipboard THEN
        appendclipbuff( NOT(oneline), S);
        appendclipbuff(TRUE, S2);
        IF donl THEN
            appendclipbuff( addnl, "");
        END;
    END;

END dmpem;

PROCEDURE chkpat (S,pat1,pat2:ARRAY OF CHAR ):BOOLEAN ;
VAR
    pat:str128; (* oversized *)
BEGIN
    Str.Concat(pat,pat1,pat2);
    RETURN Str.Match(S,pat);
END chkpat;

(*
    valid entiers  : ###  ###.###.###  ###,###,###
    valid decimals : ###,##  ###.##  ###[,###].##  ###[.###],##
    faulty         : ###,###.###,##  ###.###,###.##
*)

PROCEDURE unbeautify (VAR S:ARRAY OF CHAR   ):BOOLEAN;
VAR
    pcomma,pdot:CARDINAL;
    ncommas,ndots:CARDINAL;
    ch:CHAR;
BEGIN
    pcomma  := Str.RCharPos(S,comma);
    pdot    := Str.RCharPos(S,dot);
    ncommas := CharCount(S,comma);
    ndots   := CharCount(S,dot);

    (* handle ###  ###.##  ###,## *)
    IF (ncommas+ndots) <= 1 THEN
        ReplaceChar(S,comma,dot);
        RETURN TRUE;
    END;
    (* handle ###.###.### *)
    IF ( (ncommas=0) AND (ndots # 0) ) THEN
        ReplaceChar(S,dot,"");
        RETURN TRUE;
    END;
    (* handle ###,###,### *)
    IF ( (ncommas#0) AND (ndots = 0) ) THEN
        ReplaceChar(S,comma,"");
        RETURN TRUE;
    END;

    (* only ambiguous form : both "," and "." in S *)

    IF ( (pcomma # MAX(CARDINAL)) AND (pdot # MAX(CARDINAL)) ) THEN
        (* find last decimal separator *)
        IF pcomma < pdot THEN  (* "*,*.*" *)
            (* handle ###.###,###.## *)
            IF ndots # 1 THEN RETURN FALSE;END;
            ch:=comma;
        ELSE                   (* "*.*,*" *)
            (* handle ###,###.###,## *)
            IF ncommas # 1 THEN RETURN FALSE;END;
            ch:=dot;
        END;
        (* handle ###,###,###.##  ###.###.###,## *)
        ReplaceChar(S,ch,"");  (* "*.*" or "*,*" now *)
    END;
    ReplaceChar( S, comma, dot);
    RETURN TRUE;
END unbeautify;

(* ------------------------------------------------------------ *)

CONST
    sepsum      = "===================="+nl;
    firstparm   = 1;
    maxparm     = 64; (* silly ! *)
VAR
    parm : ARRAY [firstparm..maxparm] OF str128; (* oversized too *)
    lastparm : CARDINAL;
VAR
    parmcount,i,opt : CARDINAL;
    S,R             : str128;
    altfile,sAmount  : str128;
    DEBUG,altfmt,showsum,toclipboard,oneline,addnl,ok : BOOLEAN;
    coeff,number,result,totallocal,totalecus : LONGREAL;
    sKollabo,sLocal : str16;
    ch,chgroup,chdecimal     : CHAR;
    fix,occ : CARDINAL;
    convmode        : (fromlocal,tolocal);
    lc              : LONGCARD;
    S1,S2           : str128;
    suffixKollabo   : BOOLEAN;
    suffixLocal     : BOOLEAN;
    prefixKollabo   : BOOLEAN;
    prefixLocal     : BOOLEAN;
BEGIN
    FIO.IOcheck:=FALSE;
    WrLn;

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,"");END;

    lastparm    := firstparm-1;
    altfmt      := FALSE;
    showsum     := FALSE;
    toclipboard := FALSE;
    oneline     := FALSE;
    addnl       := TRUE;
    altfile     := "";
    DEBUG       := FALSE;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   "A"+delim+"ALTERNATE"+delim+"US"+delim+
                                   "S"+delim+"SUM"+delim+"T"+delim+"TOTAL"+delim+
                                   "C"+delim+"CLIPBOARD"+delim+"COPY"+delim+
                                             "W"+delim+"WINDOWS"+delim+
                                   "!"+delim+"GEN"+delim+
                                   "F:"+delim+"FILE:"+delim+
                                   "L"+delim+"P"+delim+"ONELINE"+delim+"PACKED"+delim+
                                   "CC"+delim+"WW"+delim+
                                   "N"+delim+
                                   "CCC"+delim+"WWW"+delim+
                                   "Y"+delim+
                                   "DEBUG"
                               );
            CASE opt OF
            | 1,2,3          : abort(errHelp,"");
            | 4,5,6          : altfmt:=TRUE;
            | 7,8,9,10       : showsum:=TRUE;
            | 11,12,13,14,15 : toclipboard:=TRUE;
            | 16,17          : opt:=initDat(DEBUG,TRUE,altfile);
                               abort(errNone,"");
            | 18,19          : GetString(R,altfile);
            | 20,21,22,23    : oneline:=TRUE;
            | 24,25          : toclipboard:=TRUE;
                               oneline:=TRUE;
            | 26             : addnl:=FALSE;
            | 27,28          : toclipboard:=TRUE;
                               oneline:=TRUE;
                               addnl:=FALSE;
            | 29             : toclipboard:=TRUE; (* id 11..15 *)
            | 30             : DEBUG:=TRUE;
            ELSE
                abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            INC(lastparm);
            IF lastparm > maxparm THEN abort(errTooManyAmounts,"");END;
            Str.Copy(parm[lastparm],R); (* keep uppercase *)
        END;
    END;

    DEBUG := FALSE; (* // ignore it *)

    IF lastparm < firstparm THEN abort(errNoAmount,"");END;

    i:=initDat(DEBUG,FALSE,altfile);
    IF i # errNone THEN abort(i,altfile);END;

    (*
    FOR what := mult TO verbplural DO
        WrStr( strdat[ORD(what)] ); WrLn;
    END;
    *)

    Str.Copy(S, strdat[ORD(mult)] );
    ReplaceChar( S, comma, dot);
    coeff:=Str.StrToReal(S,ok);
    IF ok=FALSE THEN abort(errBadMult,"");END;

    Str.Copy(S, strdat[ORD(decimals)] );
    fix:=CARDINAL( Str.StrToCard(S,10,ok) );
    IF ok=FALSE THEN abort(errBadFix,"");END;

    Str.Copy( S, strdat[ORD(marker)] );
    UpperCase(S);
    IF Str.Length( S ) > SIZE(sKollabo) THEN abort(errBadMarker,"");END;
    Str.Copy(sKollabo,S);

    Str.Copy( S, strdat[ORD(localmarker)] );
    UpperCase(S);
    IF Str.Length( S ) > SIZE(sLocal) THEN abort(errBadMarker,"");END;
    Str.Copy(sLocal,S);

    IF same(sKollabo,sLocal) THEN abort(errSameMarkers,"");END;

    totallocal:=0.0;
    totalecus :=0.0;

    IF toclipboard THEN initclipbuff();END;

    FOR i:=firstparm TO lastparm DO

        Str.Copy(sAmount,parm[i]);

        (* IF DEBUG THEN WrStr("// ");WrStr(sAmount);WrLn;END; *)

        ReplaceChar( sAmount, blank, ""); (* quoted and space beautified *)

        IF unbeautify(sAmount) = FALSE THEN abort(errBadAmount,parm[i]);END;

        (* yes, we could be smarter : isolete non-nums and nums *)

        (* check possible markers *)
        suffixKollabo :=chkpat(sAmount, "*",sKollabo);
        suffixLocal   :=chkpat(sAmount, "*",sLocal);
        prefixKollabo :=chkpat(sAmount, sKollabo,"*");
        prefixLocal   :=chkpat(sAmount, sLocal  ,"*");

        (*
           handle expressions     : EUR#  #EUR  FF#  #FF  #
           handle faulty variants : FF#EUR  EUR#FF
        *)

        occ:=0;
        IF prefixKollabo THEN
            IF prefixLocal     THEN abort(errOverlap,sAmount);END;
            IF suffixKollabo   THEN abort(errBothMarkers,sAmount);END;
            IF suffixLocal     THEN abort(errIllogical,sAmount);END;
            INC(occ);
        ELSIF suffixKollabo THEN
            IF suffixLocal     THEN abort(errOverlap,sAmount);END;
            IF prefixLocal     THEN abort(errIllogical,sAmount);END;
            INC(occ);
        END;
        IF prefixLocal THEN
            IF prefixKollabo   THEN abort(errOverlap,sAmount);END;
            IF suffixLocal     THEN abort(errBothMarkers,sAmount);END;
            IF suffixKollabo   THEN abort(errIllogical,sAmount);END;
            INC(occ);
        ELSIF suffixLocal THEN
            IF suffixKollabo   THEN abort(errOverlap,sAmount);END;
            IF prefixKollabo   THEN abort(errIllogical,sAmount);END;
            INC(occ);
        END;

        opt:=0;
        IF Str.Pos(sAmount,sKollabo) # MAX(CARDINAL) THEN INC(opt);END;
        IF Str.Pos(sAmount,sLocal)   # MAX(CARDINAL) THEN INC(opt);END;
        IF opt > 1 THEN abort(errMutuallyExclusive,parm[i]);END;

        IF occ = 0 THEN (* raw value without suffix nor prefix *)
            Str.Append(sAmount,sKollabo); suffixKollabo := TRUE;
        END;

        IF    (prefixKollabo  OR suffixKollabo)  THEN
            convmode := tolocal;   Str.Copy(R,sKollabo);
        ELSIF (prefixLocal OR suffixLocal) THEN
            convmode := fromlocal; Str.Copy(R,sLocal);
        END;
        Str.Subst(sAmount,R,"");
        IF verifyString(sAmount,digits+dot)=FALSE THEN abort(errBadAmount,parm[i]);END;

        number:=Str.StrToReal(sAmount,ok);
        IF ok=FALSE THEN abort(errBadAmount,sAmount);END;

        CASE convmode OF
        | tolocal:   result:=number * coeff;
        | fromlocal: result:=number / coeff;
        END;
        IF altfmt THEN      (* US *)
            chgroup   :=comma;
            chdecimal :=dot;
        ELSE                (* FR *)
            chgroup   :=dot;
            chdecimal :=comma;
        END;
        fmtreal(number,chgroup,chdecimal,fix,S);
        fmtreal(result,chgroup,chdecimal,fix,R);
        align(oneline,blank,S,R);

        CASE convmode OF
        | tolocal:
            fmthowmuch(number,strdat[ORD(singular)]     ,strdat[ORD(plural)]     ,S1);
            fmthowmuch(result,strdat[ORD(localsingular)],strdat[ORD(localplural)],S2);
            IF showsum THEN
                totalecus :=totalecus+number;
                totallocal:=totallocal+result;
            END;
        | fromlocal:
            fmthowmuch(number,strdat[ORD(localsingular)],strdat[ORD(localplural)],S1);
            fmthowmuch(result,strdat[ORD(singular)]     ,strdat[ORD(plural)]     ,S2);
            IF showsum THEN
                totallocal:=totallocal+number;
                totalecus :=totalecus+result;
            END;
        END;
        Str.Append(S," ");Str.Append(S,S1);
        Str.Append(R," ");Str.Append(R,S2);
        ok:=(addnl AND (i < lastparm));
        dmpem(S,R,oneline,addnl,toclipboard,ok);
    END;

    (* ok := (showsum AND (lastamount > firstamount) ); *)
    ok := showsum;
    IF ok THEN
        dmpem("",sepsum,FALSE,addnl,toclipboard,FALSE);

        number:=totalecus;
        result:=totallocal;

        fmtreal(number,chgroup,chdecimal,fix,S);
        fmtreal(result,chgroup,chdecimal,fix,R);
        align(oneline,blank,S,R);

        fmthowmuch(number,strdat[ORD(singular)]     ,strdat[ORD(plural)]     ,S1);
        fmthowmuch(result,strdat[ORD(localsingular)],strdat[ORD(localplural)],S2);

        Str.Append(S," ");Str.Append(S,S1);
        Str.Append(R," ");Str.Append(R,S2);
        dmpem(S,R,oneline,addnl,toclipboard,FALSE);
    END;

    IF toclipboard THEN
        appendclipbuff(TRUE,""); (* "let's have a last nl for the road..." -- frenglish proverb *)
        ok:=forcenewclipboard();
        IF NOT (ok) THEN WrLn; abort(errWinOldApClipboard,"");END; (* beautify *)
    END;

    abort(errNone,"");
END Change.





(*


@echo off

xchoice /c:abc Test A=output  B=format  C=decimal :
if errorlevel 3 goto three
if errorlevel 2 goto two
if errorlevel 1 goto one
goto end

:one
@echo on
change 1.2
                                                xchoice /r:y
change 1.2 -l
                                                xchoice /r:y
change 1.2 -t
                                                xchoice /r:y
change 1.2 -l -t
                                                xchoice /r:y

change 1.2 10 4.8
                                                xchoice /r:y
change 1.2 10 4.8 -l
                                                xchoice /r:y
change 1.2 10 4.8 -t
                                                xchoice /r:y
change 1.2 10 4.8 -l -t
                                                xchoice /r:y

change 1.2                 -n
                                                xchoice /r:y
change 1.2 -l              -n
                                                xchoice /r:y
change 1.2 -t              -n
                                                xchoice /r:y
change 1.2 -l -t           -n
                                                xchoice /r:y

change 1.2 10 4.8          -n
                                                xchoice /r:y
change 1.2 10 4.8 -l       -n
                                                xchoice /r:y
change 1.2 10 4.8 -t       -n
                                                xchoice /r:y
change 1.2 10 4.8 -l -t    -n
                                                xchoice /r:y
@echo off
GOTO end

:two
set e=eur
set f=ff
@echo on
change -debug     1.2
                                                xchoice /r:y
change -debug     1,2%e%
                                                xchoice /r:y
change -debug     1,2%f%
                                                xchoice /r:y
change -debug  %f%1.2
                                                xchoice /r:y
change -debug  %e%1.2
                                                xchoice /r:y
change -debug  %f%1,2%e%
                                                xchoice /r:y
change -debug  %f%1,2%f%
                                                xchoice /r:y
change -debug  %e%1.2%e%
                                                xchoice /r:y
change -debug  %e%1.2%f%
                                                xchoice /r:y
change -debug     1,2f%e%
                                                xchoice /r:y
change -debug     1,2e%f%
                                                xchoice /r:y
change -debug  %f%%e%1.2
                                                xchoice /r:y
change -debug  %e%%f%1.2
                                                xchoice /r:y
change -debug  %e%1,2%e%
                                                xchoice /r:y
change -debug  %f%1,2%f%
                                                xchoice /r:y
@echo off
set e=
set f=
GOTO END

:three
@echo on
change    123456789
                                                xchoice /r:y
change    1234567.89
                                                xchoice /r:y
change    1234567,89
                                                xchoice /r:y
change    123,456,78.9
                                                xchoice /r:y
change    123.456.78,9
                                                xchoice /r:y
change    123,456.78,9
                                                xchoice /r:y
change    123.456,78.9
                                                xchoice /r:y
change    123,456,789
                                                xchoice /r:y
change    123.456.789
                                                xchoice /r:y
@echo off
GOTO END

:END

*)

