(* ---------------------------------------------------------------
Title         Q&D Date & Time
Author        PhG
Overview      see help
Notes         test with
              dt -f:"$d $m $yy $0d $0m $yyyy $dd $mm h m s 0h 0m 0s !d !0d"
Bugs          not really : implementation quirk
              as we do a global find/replace, we cannot handle "\\"...
              and we do not care about it ! ;-)
              even though we're not proud of it either...
Wish List

--------------------------------------------------------------- *)

MODULE DT;

IMPORT SYSTEM;
IMPORT Lib;
IMPORT Str;
IMPORT IO;
IMPORT FIO;
IMPORT MATHLIB;

FROM QD_ASCII IMPORT dash, slash, nullchar, tabchar, (* cr, lf, nl, bs, *)
space, dot, deg, doublequote, quote, colon, percent, vbar,
blank, equal, dquote, charnull, singlequote, antislash, dollar,
star, backslash, coma, question, underscore, tabul, hbar,
comma, semicolon, diese, pound, openbracket, closebracket, tilde, exclam,
stardotstar, dotdot, escCh, escSet, letters, digits,
lettersUpp, lettersLow, openbrace, closebrace;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite, setReadOnly,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs, UpperCaseAlt, LowerCaseAlt,
completedInit, completedShow, completedSHOW, completedEnd, completed,
removeDups, isValidHDunit, removePhantoms, removeFloppies,
getCDROMunits, getCDROMletters, removeCDROMs, getAllHDunits,
getAllLegalUnits, metaproc, getCli, argc, argv;

FROM QD_Text IMPORT
colortype, cursorshapetype, scrolltype,
ff, cr, lf, bs, tab, nl, mincolor, maxcolor,
BW40, CO40, BW80, CO80, CO80x43, CO80x50, MONO,
vesa80x60, vesa132x25, vesa132x43, vesa132x50, vesa132x60,
selectCursorEmulation,
setCursorShape,
handleVesa, setBrightPaper, setBlinkMode,
setFillChar, setFillInk, setFillPaper,
setFillInkPaper, setTxtInk, setTxtPaper, setTxtInkPaper, setWrapMode,
setUseBiosMode, setTabWidth, getScreenData, setWindow,
setMode, restoreMode,
gotoXY, xyToHtabVtab, home, setVisualPage, setActivePage,
scrollWindow, fillTextAttr, cls, writeStr, writeLn, getScreenWidth,
getScreenHeight, getScreenMinX, getScreenMinY, getScreenMaxX, getScreenMaxY,
getMinHtab, getMaxHtab, getMinVtab, getMaxVtab, getUseBiosMode,
getMinHtab, getMaxHtab, getMinVtab, getMaxVtab, getHtab, getVtab,
getWindowWidth, getWindowHeight,
initScreenConsole,
findInkPaperAtStartup, getInkAtStartup, getPaperAtStartup,
setFullScreenWindow, gotoFullScreenXY;

FROM QD_Eris IMPORT discordianType, erisGetDaysInMonth, using, oldnew,
gregorianToDiscordian, discordianToType, buildDiscordianTokens,
buildDiscordianStrings, ErisFmtDefault, ErisFmtTerse, ErisFmtAlt;

FROM QD_rand IMPORT InitRnd, GetRnd,
GetRndCardRange, GetRndLngCardRange,
GetRndLngRealRange, GetRndRealRange,
GetRndIntRange, GetRndLngIntRange;

FROM QD_File IMPORT pathtype, w9XnothingRequired,
fileOpenRead, fileOpen, fileExists, fileExistsAlt,
fileIsRO, fileSetRW, fileSetRO,
fileErase, fileCreate, fileRename, fileGetFileSize, fileGetFileStamp,
fileIsDirectorySpec, fileClose, fileFlush, fileSupportLFN;

(* ------------------------------------------------------------ *)

CONST
    (* aliases for our own procedures *)
    WrStr ::= writeStr;
    WrLn  ::= writeLn;
    WrChar::= writeStr;

CONST
    defaultink  = white;
    defaultpaper= black;

PROCEDURE colorhelp (  );
BEGIN
    setTxtInk(getInkAtStartup());      (* was green *)
    setTxtPaper(getPaperAtStartup());  (* was black *)
    setFillInkPaper(getInkAtStartup(),getPaperAtStartup());
END colorhelp;

PROCEDURE color (ink,paper:CARDINAL );
BEGIN
    setTxtInk   (VAL(colortype,ink));
    setTxtPaper (VAL(colortype,paper));
    setFillInkPaper(getInkAtStartup(),getPaperAtStartup());
END color;

(* ------------------------------------------------------------ *)

TYPE
    languagetype = (nolanguageyet,french,english);
CONST
    escch   = "\";
    chDT    = "h"; (* lower case required for pretty display in help *)
    chCRLF  = "n";
    chTAB   = "t";
    chPERCENT="p";

    ChDT    = "H";
    ChCRLF  = "N";
    ChTAB   = "T";
    ChPERCENT="P";

    fmtDT     = escch+chDT;     (* almost C-like ! berk... *)
    fmtCRLF   = escch+chCRLF;   (* C-like ! berk... *)
    fmtTAB    = escch+chTAB;    (* ditto ! *)
    fmtPERCENT= escch+chPERCENT;
    (*
    nl      = CHR(13) + CHR(10);
    tab     = CHR(9);
    *)
    defaultFmtFR           = "$dd !d $mm $yyyy  0hh 0mmn 0ss";
    defaultFmtUS           = "$dd, $mm $d, $yyyy at 0h:0m:0s";
    defaultFmtFRfilestamp  =     "!d $mm $yyyy  0hh 0mmn 0ss";
    defaultFmtUSfilestamp  =      "$mm $d, $yyyy at 0h:0m:0s";
    undeterminedDay        = "<???>";
    undeterminedDayFR      = "<???>"; (* was "<indfini>" *)
    undeterminedDayUS      = "<???>"; (* was "<undetermined>" *)

    defaultErisFmt         = "#d\n\n#h\n\n#s";
    defaultErisFmtShort    = "#e\n\n#i\n\n#s";
    defaultErisFmtAlt      = "#f\n\n#j";

CONST
    mintabwidth   = 1;
    maxtabwidth   = 16;
CONST
    ProgEXEname   = "DT";
    ProgTitle     = "Q&D Date & Time";
    ProgVersion   = "v1.1d";
    ProgCopyright = "by PhG";
CONST
    errNone         = 0;
    errHelp         = 1;
    errUnknownOpt   = 2;
    errTooManyParms = 3;
    errBadNumber    = 4;
    errInkRange     = 5;
    errPaperRange   = 6;
    errHtabRange    = 7;
    errVtabRange    = 8;
    errCenterHTAB   = 9;
    errLanguage     = 10;
    errNotFound     = 11;
    errJoker        = 12;
    errMoreHelp     = 13;
    errDateSource   = 14;
    errUserDate     = 15;
    errUserYear     = 16;
    errBadRecursiveToken = 17;
    errTooManyLines = 18;
    errEvenMoreHelp = 19;
    errTabWidthRange= 20;
    errEitherOr     = 21;
    errNotFilename  = 22;

(* ------------------------------------------------------------ *)

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
(*
 .........1.........2.........3.........4.........5.........6.........7.........8
 12345678901234567890123456789012345678901234567890123456789012345678901234567890
*)
CONST
    placeholder = "|";
    helpmsg = nl+
    ProgTitle+" "+ProgVersion+" "+ProgCopyright+nl+
nl+
"Syntax : "+ProgEXEname+" [string] [option]..."+nl+
nl+
"This program prints current or filename date and time."+nl+
"Date format can be user-specified. Discordian calendar is supported."+nl+
nl+
'-f:$     format string (tokens listed in -?? help screen)'+nl+  (* "$[0]<d|m>", "$dd", "$mm", "$yy", "$yyyy", "[0]<h|m|s>" *)
'         French default is "'+defaultFmtFR+'"'+nl+
'         English default is "'+defaultFmtUS+'"'+nl+
'         Discordian default is "'+defaultErisFmt+'"'+nl+
'         Discordian short default is "'+defaultErisFmtShort+'"'+nl+
'         Discordian alternate default is "'+defaultErisFmtAlt+'"'+nl+
'         French without day of week is "'+defaultFmtFRfilestamp+'"'+nl+
'         English without day of week is "'+defaultFmtUSfilestamp+'"'+nl+
"-fr      French (default)"+nl+
"-us      English"+nl+
"-i:#     ink [0..15] -- default is white"+nl+
"-p:#     paper [0..15] -- default is black"+nl+
"-t:#     tab width (default is 4)"+nl+
"-b       monochrome BIOS output (no colors)"+nl+
"-n[n]    dump a cr+lf newline (-n = after output, -nn = before & after output)"+nl+
"-![!]    beautified output (-i:# and -p:# options recommended, -!! = -! -c)"+nl+
"-c       centered output (one-liner only or beautified output)"+nl+
"-x:#     horizontal position i.e. htab (one-liner only)"+nl+
"-y:#     vertical position i.e. vtab (one-liner only)"+nl+
"-n:$     use date and time from f8e3 or LFN filename instead of PC clock"+nl+
"-jma:$   use date specified as jj/mm/aaaa or jj-MMM-aaaa (default is sysdate)"+nl+
"-mdy:$   use date specified as mm/dd/yyyy or MMMdd,aaaa (default is sysdate)"+nl+
"-e[e[e]] display Discordian date (-eris = -yold = -kallisti = -ddate = -e)"+nl+
"-hail:#  dump the whole Discordian year (check 1900, 2000, 1960, 1963, etc.)"+nl+
"-??[?]   more help (to be read at least once !)"+nl+
nl+
"Dark [0..7] : black, blue, green, cyan, red, magenta, brown and gray."+nl+
"Bright [8..15] : gray, blue, green, cyan, red, magenta, yellow and white."+nl+
nl+
"a) String, if specified, should be delimited with double quotes."+nl+
"b) Default program behavior is to append date and time to string,"+nl+
"   unless string contains "+doublequote+fmtDT+doublequote+", which stands for date and time."+nl+
'   Other special substrings are "'+fmtPERCENT+'" for "%", "'+fmtCRLF+'" for CRLF, and "'+fmtTAB+'" for TAB.'+nl+
'   Note mixing any of "'+fmtTAB+'", -c, -!, -x:# and -y:# may have unexpected results.'+nl+
"c) Year is [1583..3000] : change from julian to gregorian was on Oct 15, 1582"+nl+
"   in the Western world, although a few countries waited until Sep 14, 1752."+nl+
"d) -jma:$ and -mdy:$ options modify date display but time is still system time."+nl+
"e) -n:$ option expects a filename (directory names are not supported)."+nl+
"f) For obvious reasons, Discordian calendar defaults to English. ;-)"+nl+
"g) By design, Discordian date and holyday formats cannot be modified."+nl+
"   Alternate formats are available with -ee and -eee options."+nl;

CONST
    morehelpmsg =
"h) Note DDATE Unix utility does not compute leap years correctly,"+nl+
"   while "+ProgEXEname+" does : 1900, for example, is common, not leap."+nl+
'   Hail Eris ! Kallisti ! Hail Discordia ! Praise "Bob" ! Fnord ! ;-)'+nl+
nl+
"Examples : "+ProgEXEname+nl+
"           "+ProgEXEname+" "+doublequote+"Date et heure actuelles : "+doublequote+nl+
"           "+ProgEXEname+" -us ***"+fmtCRLF+fmtTAB+fmtDT+fmtCRLF+"***"+nl+
"           "+ProgEXEname+' -f:"'+"!d.$m.$yyyy"+'"'+nl+
"           "+ProgEXEname+' -f:"'+"$0d-$0m-$yyyy"+'"'+nl+
"           "+ProgEXEname+' -f:"'+"Roman date : $!"+'"'+nl+
"           "+ProgEXEname+' -f:"$d $m $yy $0d $0m $yyyy $dd $mm h m s 0h 0m 0s !d !0d"'+nl+
"           "+ProgEXEname+' -n:C:\WINDOWS\USER.DAT -us "Previous USER.DAT access was "'+nl+
"           "+ProgEXEname+" -e!! -i:14 -p:4 -jma:1/2/1963"+nl+
"           "+ProgEXEname+" -mdy:2/1/1963 -us -i:14 -p:4 -! -t:12"+nl+
"           "+"  "+       ' -f:"Gregorian\t$0d-$0m-$yyyy\nDiscordian\t#d\n\t#h\n\n\t#s"'+nl+
nl+
"Tokens allowed in format string are :"+nl+
nl+
"$dd     lundi..dimanche / monday..sunday"+nl+
"$d      1..31 (ordinal)"+nl+
"$0d     01..31"+nl+
"$mm     janvier..dcembre / january..december"+nl+
"$m      1..12"+nl+
"$0m     01..12"+nl+
"$yyyy   ####"+nl+
"$yy     00..99"+nl+
"!d      1er..31 (cardinal)"+nl+
"!0d     1er..31"+nl+
"h      0..23"+nl+
"0h     00..23"+nl+
"m      0..59"+nl+
"0m     00..59"+nl+
"s      0..59"+nl+
"0s     00..59"+nl+
nl+
"$!      Latin date"+nl+
nl+
"$f      reference filename"+nl+
nl+
"n      CRLF"+nl+
"q      double quote"+nl;


CONST
    evenmorehelpmsg = nl+
"#d      default Discordian date"+nl+
"#h      default Discordian holyday"+nl+
"#e      terse Discordian date"+nl+
"#i      terse Discordian holyday"+nl+
"#f      alternate Discordian date"+nl+
"#j      alternate Discordian holyday"+nl+
"#s      Discordian slogan"+nl+
nl+
"#o      1st..73rd or 1er..73e Discordian ordinal (0=St Tib)"+nl+
"#c      1..73 Discordian cardinal (0=St Tib)"+nl+
'#z      Discordian season ("?"=St Tib)'+nl+
"#y      #### Discordian year"+nl+
'#w      Discordian day of week ("?"=St Tib)'+nl+
'#a      terse Discordian season ("?"=St Tib)'+nl+
'#x      terse Discordian day of week ("?"=St Tib)'+nl+
nl+
"Gregorian calendar    Discordian calendar   Holyday"+nl+
"====================  ====================  ===================="+nl+
"January 5             Chaos 5               Mungday"+nl+
"February 19           Chaos 50              Chaoflux"+nl+
"February 29           Saint Tib's Day       Saint Tib's Day"+nl+
"March 19              Discord 5             Mojoday"+nl+
"May 3                 Discord 50            Discoflux"+nl+
"May 31                Confusion 5           Syaday"+nl+
"July 15               Confusion 50          Confuflux"+nl+
"August 12             Bureaucracy 5         Zaraday"+nl+
"September 26          Bureaucracy 50        Bureflux"+nl+
"October 24            The Aftermath 5       Maladay"+nl+
"December 8            The Aftermath 50      Afflux"+nl;

VAR
    S : str256;
BEGIN
    colorhelp;
    CASE e OF
    | errHelp,errMoreHelp,errEvenMoreHelp :
        WrStr(helpmsg);
        IF e # errHelp THEN WrStr(morehelpmsg); END;
        IF e = errEvenMoreHelp THEN WrStr(evenmorehelpmsg);END;
        e:=errHelp;
    | errUnknownOpt :
        S := "Illegal "+placeholder+" option !";
        Str.Subst(S,placeholder,einfo);
    | errTooManyParms :
        (* Str.Concat(S,einfo," is just one parameter too many !"); *)
        S := "Enclose string with double quotes !";
    | errBadNumber:
        S := "Illegal value in "+placeholder+" option !";
        Str.Subst(S,placeholder,einfo);
    | errInkRange:
        S := "Ink range is [0..15] !";
    | errPaperRange:
        S := "Paper range is [0..15] !";
    | errHtabRange:
        S := "Horizontal position (htab) is not in legal range !";
    | errVtabRange:
        S := "Vertical position (vtab) is not in legal range !";
    | errCenterHTAB :
        S := "-c and -x:# options are mutually exclusive !";
    | errLanguage:
        S := "-french and -english options are mutually exclusive !";
    | errNotFound:
        S := 'Specified "'+placeholder+'" file does not exist !';
        Str.Subst(S,placeholder,einfo);
    | errJoker:
        S := "At least one illegal joker in "+placeholder+" option !";
        Str.Subst(S,placeholder,einfo);
    | errDateSource:
        S := "-n:$, -jma:$ and -mdy:$ options are mutually exclusive !";
    | errUserDate:
        S := 'Illegal or out of legal [1583..3000] range "'+placeholder+'" user date !';
        Str.Subst(S,placeholder,einfo);
    | errUserYear:
        S := "Illegal year or year out of legal [1583..3000] range !";
    | errBadRecursiveToken:
        (*
        S :='Illegal "'+fmtDT+'" token in "'+placeholder+'" format string !';
        Str.Subst(S,placeholder,einfo);
        *)
        S := '"'+fmtDT+'" can be used in message only and not in format string !';
    | errTooManyLines:
        S := "Too many lines to output !";
    | errTabWidthRange:
        S := "Tab width is [1..16] range !";
    | errEitherOr:
        S := placeholder+" options are mutually exclusive !";
        Str.Subst(S,placeholder,einfo);
    | errNotFilename:
        S := 'Specified "'+placeholder+'" cannot be a directory !';
        Str.Subst(S,placeholder,einfo);
    ELSE
        S := "This is illogical, Captain !!!";
    END;
    CASE  e OF
    | errNone, errHelp : ;
    ELSE
        WrLn;
        WrStr(ProgEXEname+" : "); WrStr(S); WrLn;
    END;
    Lib.SetReturnCode(SHORTCARD(e));
    HALT;
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* ripped/adapted from frozen QD_SKY *)

(* ---------------------------------------------------------------
   input  : value
   output : int(value) ie int(0.95) gives 0 (no rounding)

   TRUNC(n) gives only a CARDINAL without rounding either
--------------------------------------------------------------- *)

PROCEDURE int (v : LONGREAL) : LONGREAL;
VAR
    tmp : LONGINT; (* this should be enough! *)
BEGIN
    tmp := VAL(LONGINT,v); (* as intended, does NOT perform any rounding *)
    RETURN VAL(LONGREAL,tmp);
END int;

(* ---------------------------------------------------------------
   input  : value
   output : frac(value)

   frac keeps sign
--------------------------------------------------------------- *)

PROCEDURE frac (v : LONGREAL) : LONGREAL;
BEGIN
    RETURN (v - int (v));
END frac;

(* ---------------------------------------------------------------
   input  : value1, value2
   output : value1 mod value2

   mod keeps sign
--------------------------------------------------------------- *)

PROCEDURE mod (v1, v2 : LONGREAL) : LONGREAL;
BEGIN
    RETURN ( MATHLIB.Mod(v1, v2) );
END mod;

(* ---------------------------------------------------------------
   assume day with decimal, and whole date is ok
   valid only for JD >= 0 i.e. NOT before 1.5 Jan -4712 !
   input  : first gregorian date (yyyymmdd), day (with decimals), month, year
   output : JD
   thanks to Meeus !
--------------------------------------------------------------- *)

PROCEDURE dateToJD (Day,Month,Year:LONGREAL) : LONGREAL;
VAR
    YYYYMMDD  : LONGREAL;
    A,gregorian : LONGREAL; (* gregorian correction *)
    JD        : LONGREAL;
BEGIN
    YYYYMMDD := Year * 10000.0 + Month * 100.0 + Day;
    IF Month < 2.5 THEN
        Year  := Year - 1.0;
        Month := Month + 12.0;
    END;
    IF YYYYMMDD < LONGREAL(15821015.0) THEN (* before 15 october 1582, julian calendar *)
        gregorian := 0.0;
    ELSE
        A         := int (Year / 100.0);
        gregorian := 2.0 - A + int (A / 4.0);
    END;
    JD := int (365.25 * (Year + 4716.0)) + int (30.6001 * (Month + 1.0));
    JD := JD + Day + gregorian - 1524.5;
    RETURN JD;
END dateToJD;

(* ---------------------------------------------------------------
   find JD at 0h
   input  : JD
   output : JD for this day at 0H
--------------------------------------------------------------- *)

PROCEDURE JDtoJD0H (JD : LONGREAL) : LONGREAL;
VAR
    JD0H : LONGREAL;
BEGIN
    IF frac(JD) < 0.5 THEN
       JD0H := int(JD) - 0.5; (* was < 23H59 so take previous 0H *)
    ELSE
       JD0H := int(JD) + 0.5; (* was 0H or later so take current 0H *)
    END;
    RETURN JD0H;
END JDtoJD0H;

(* ---------------------------------------------------------------
   0=sunday, 1=monday... 6=saturday
   input  : JD
   output : day of week
--------------------------------------------------------------- *)

CONST
    firstdayofweek = 0; (* dimanche i.e. sunday *)
    lastdayofweek  = 6; (* samedi i.e. saturday *)

PROCEDURE JDtoWeekday (JD : LONGREAL) : CARDINAL;
VAR
    v : LONGREAL;
BEGIN
    v := mod ( (JDtoJD0H (JD) + 1.5), 7.0 );
    RETURN ( VAL(CARDINAL, v ) );
END JDtoWeekday;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    datetype = RECORD
        day   : CARDINAL;
        month : CARDINAL;
        year  : CARDINAL;
        dayOfWeek  : Lib.DayType;
        validDayOfWeek : BOOLEAN; (* cleaner but useless *)
    END;
    timetype = RECORD
        hours   : CARDINAL;
        minutes : CARDINAL;
        seconds : CARDINAL;
    END;

PROCEDURE computeDofW ( VAR dmy:datetype ); (* //FIXME maybeware *)
CONST
    lastweekday = Lib.Saturday;
VAR
    JD,jj,mm,aaaa:LONGREAL;
    n:CARDINAL;
BEGIN
    (*
    dmy.dayOfWeek := lastweekday; (* INC( dmy.dayOfWeek); (* force undetermined day *) *)
    dmy.validDayOfWeek:=FALSE;
    *)
    jj   := LONGREAL(dmy.day);
    mm   := LONGREAL(dmy.month);
    aaaa := LONGREAL(dmy.year);
    JD   := dateToJD (jj,mm,aaaa);
    n    := JDtoWeekday (JD);
    dmy.dayOfWeek := Lib.DayType(n);
    dmy.validDayOfWeek:=TRUE;
END computeDofW;

PROCEDURE getDateNow (VAR d : datetype);
VAR
    dayOfWeek : Lib.DayType;
BEGIN
    Lib.GetDate(d.year,d.month,d.day,d.dayOfWeek);
    d.validDayOfWeek:=TRUE;
END getDateNow;

PROCEDURE getTimeNow (VAR t : timetype);
VAR
    hundredth : CARDINAL;
BEGIN
    Lib.GetTime(t.hours,t.minutes,t.seconds,hundredth);
END getTimeNow;

CONST
    jours   = "dimanche lundi mardi mercredi jeudi vendredi samedi "+
               undeterminedDayFR;
    mois    = "janvier fvrier mars avril mai juin "+
              "juillet aot septembre octobre novembre dcembre";
CONST
    joursUS = "Sunday Monday Tuesday Wednesday Thursday Friday Saturday "+
               undeterminedDayUS;
    moisUS  = "January February March April May June "+
              "July August September October November December";

(* ------------------------------------------------------------ *)

TYPE
    dttype = RECORD
        CASE : BOOLEAN OF
        | TRUE  :
            t : CARDINAL; (* hms is low  *)
            d : CARDINAL; (* ymd is high *)
        | FALSE :
            dt : LONGCARD;
        END;
    END;

(*
Year stored relative to 1980 (ex. 1988 stores as 8)
    year      month    day   

 F E D C B A 9 8 7 6 5 4 3 2 1 0   <-- Bit Number

Seconds are 0 to 29 -- DOS stores nearest even / 2
  hours    minutes   seconds 

 F E D C B A 9 8 7 6 5 4 3 2 1 0   <-- Bit Number
*)

CONST
    DOSbaseyear  = 1980;
CONST
    yyMask=BITSET{9..15};    yyShft=9;
    moMask=BITSET{5..8};     moShft=5;
    ddMask=BITSET{0..4};     ddShft=0;
CONST
    hhMask=BITSET{11..15};   hhShft=11;
    miMask=BITSET{5..10};    miShft=5;
    ssMask=BITSET{0..4};     ssShft=0;

PROCEDURE unpackDate (ymd:CARDINAL;VAR y,m,d:CARDINAL);
BEGIN
    y :=  CARDINAL(BITSET(ymd) * yyMask) >> yyShft ;
    m :=  CARDINAL(BITSET(ymd) * moMask) >> moShft ;
    d :=  CARDINAL(BITSET(ymd) * ddMask) >> ddShft ;
    INC(y,DOSbaseyear);
END unpackDate;

PROCEDURE unpackTime (hms:CARDINAL;VAR h,m,s:CARDINAL);
BEGIN
    h :=  CARDINAL(BITSET(hms) * hhMask) >> hhShft ;
    m :=  CARDINAL(BITSET(hms) * miMask) >> miShft ;
    s :=  CARDINAL(BITSET(hms) * ssMask) >> ssShft ;
    s := s << 1; (* yes, yes, "* 2" works too... *)
END unpackTime;

PROCEDURE getfilestamp (VAR dmy:datetype; VAR hms:timetype;
                       useLFN:BOOLEAN; refpath:pathtype);
VAR
    hnd:FIO.File;
    rc:BOOLEAN;
    stamp:dttype;
BEGIN
    hnd:=fileOpenRead(useLFN,refpath);
    IF hnd = MAX(CARDINAL) THEN (* not trapped by fileGetFileStamp() *)
        rc:=FALSE;
    ELSE
        stamp.dt:=FIO.GetFileDate(hnd);
        rc:=TRUE;
    END;
    FIO.Close(hnd);

    unpackDate(stamp.d , dmy.year  ,dmy.month  ,dmy.day );
    computeDofW(dmy);

    unpackTime(stamp.t , hms.hours ,hms.minutes,hms.seconds );
END getfilestamp;

(* ------------------------------------------------------------ *)

(*
    gregorian calendar rule : leap 366 years if divisible by 4
    but centurial years NOT divisible by 4 are common
    Leap years are divisible by 400, or by 4 and not by 100
    1900 is common, 2000 is leap
*)

PROCEDURE getDaysInFebruary (annee:CARDINAL):CARDINAL;
CONST
    common = 28;
    leap   = 29;
BEGIN
    IF (annee MOD 400) = 0 THEN RETURN leap; END;
    IF (((annee MOD 4) = 0) AND ((annee MOD 100) # 0)) THEN RETURN leap; END;
    RETURN common;
END getDaysInFebruary;

PROCEDURE getDaysInMonth (mois,annee:INTEGER):INTEGER;
TYPE
    daysinmonthtype = ARRAY [1..12] OF INTEGER;
CONST
    (*                    JanFevMarAprMayJunJulAugSepOctNovDec *)
    (*                     1  2  3  4  5  6  7  8  9 10 11 12  *)
    dpm = daysinmonthtype(31, 0,31,30,31,30,31,31,30,31,30,31);
VAR
    m : INTEGER;
BEGIN
    m:= dpm[mois];
    IF m=0 THEN m:=getDaysInFebruary(annee);END;
    RETURN m;
END getDaysInMonth;

PROCEDURE latinDate (jour,mois,annee:CARDINAL):str80;
CONST
    calendes = 1;
    nones    = 5;
    ides     = 13;
    veille   = "PRID.";
    sKAL     = "KAL.";
    sNON     = "NON.";
    sID      = "ID.";
CONST
    (* 31-13=18 so go to 20 for safety *)
    countLAT= veille+" III IV V VI VII VIII IX "+
              "X XI XII XIII XIV XV XVI XVII XVIII XIX XX";
    moisLAT = "IAN. FEB. MART. APR. MAI. IUN. "+
              "IUL. AUG. SEPT. OCT. NOV. DEC.";
VAR
    j,m,R:str80;
    v:CARDINAL;
BEGIN
    v:=mois-1;
    Str.ItemS(m,moisLAT," ",v);

    CASE jour OF
    | calendes :
        j:=sKAL;
    | calendes+1..nones-1:
        Str.Prepend(m,sNON);
        v:=(nones-jour)-1;
        Str.ItemS(j,countLAT," ",v);
        IF same(j,veille)=FALSE THEN Str.Prepend(j,"A.D."); END;
    | nones :
        j:=sNON;
    | nones+1..ides-1 :
        Str.Prepend(m,sID);
        v:=(ides-jour)-1;
        Str.ItemS(j,countLAT," ",v);
        IF same(j,veille)=FALSE THEN Str.Prepend(j,"A.D."); END;
    | ides :
        j:=sID;
    ELSE
        v:=getDaysInMonth(mois,annee);
        IF v < jour THEN
            j:="???";
        ELSE
            v:=((v+1)-jour)-1;
            Str.ItemS(j,countLAT," ",v);
        END;
        IF same(j,veille)=FALSE THEN Str.Prepend(j,"A.D."); END;
        INC(mois);
        IF mois > 12 THEN mois := 1; END;
        v:=mois-1;
        Str.ItemS(m,moisLAT," ",v);
        Str.Prepend(m,sKAL);
    END;
    IF j[Str.Length(j)-1] # "." THEN Str.Append(j," ");END;
    Str.Concat(R,j,m);
    RETURN R;
END latinDate;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE getnum(VAR n:CARDINAL; ndx,mini,maxi:CARDINAL;S:ARRAY OF CHAR):BOOLEAN;
VAR
    v:LONGCARD;
    ok:BOOLEAN;
    R:str16;
BEGIN
    isoleItemS(R,  S,dash,ndx-1);
    v:=Str.StrToCard(R,10,ok);
    IF NOT(ok) THEN RETURN FALSE;END;
    IF v > MAX(CARDINAL) THEN RETURN FALSE;END;
    n:=CARDINAL(v);
    RETURN  NOT ( (n < mini) OR (n > maxi) );
END getnum;

(*
    separator is "-" or "/"
    we handle :
    jma : jj/mm/aaaa   jj/MMM/aaaa   jjMMMaaaa
    dmy : mm/jj/aaaa   MMM/jj/aaaa   MMMjj,aaaa   MMM/jj,aaaa

    yes, we know it's BFL (Brute Force and Lazyness)
    YES, we know we should compute day of week, etc.
*)

CONST
    modeJMA = 0;
    modeMJA = 1;

PROCEDURE parseUserDate (VAR jj,mm,aa:CARDINAL;
                        dateparsemode:CARDINAL;S:ARRAY OF CHAR   ):BOOLEAN;
CONST
    abrevMMfr   = "jan fev mar avr mai jun jui aou sep oct nov dec";
    abrevMMus   = "jan feb mar apr may jun jul aug sep oct nov dec";
    abrevMMnum  = "1 2 3 4 5 6 7 8 9 10 11 12";
    febmonth    = 2;
CONST
    minday      = 1;
    maxday      = 31;
    minmonth    = 1;
    maxmonth    = 12;
    minyear     = 1583; (* Oct 15, 1582 for most Western countries ; september 1752 for a few others *)
    maxyear     = 3000; (* we should ALL be dead *)
VAR
    i,j:CARDINAL;
    plain,number:str16;
BEGIN
    ReplaceChar(S, antislash, dash);
    ReplaceChar(S, slash    , dash);
    ReplaceChar(S, comma    , dash);
    ReplaceChar(S, dot      , dash);
    LowerCase(S); (* ignore accents *)
    FOR i:=1 TO 12 DO
        FOR j:=1 TO 2 DO
            CASE j OF
            | 1: isoleItemS(plain,   abrevMMfr  ,blank,i-1);
            | 2: isoleItemS(plain,   abrevMMus  ,blank,i-1);
            END;
                 isoleItemS(number,  abrevMMnum ,blank,i-1);
            Str.Prepend(number,dash);Str.Append(number,dash);
            Str.Subst(S, plain, number);
        END;
    END;
    oldnew (dash+dash, dash, S);
    IF S[0]=dash THEN Str.Delete(S,0,1);END;
    IF CharCount(S,dash) # 2 THEN RETURN FALSE;END;
    (* WrStr(S);WrLn; *)
    CASE dateparsemode OF
    | modeJMA:
        IF getnum(jj,   1,  minday,maxday,    S)=FALSE THEN RETURN FALSE;END;
        IF getnum(mm,   2,  minmonth,maxmonth,S)=FALSE THEN RETURN FALSE;END;
    | modeMJA:
        IF getnum(jj,   2,  minday,maxday,    S)=FALSE THEN RETURN FALSE;END;
        IF getnum(mm,   1,  minmonth,maxmonth,S)=FALSE THEN RETURN FALSE;END;
    ELSE
        RETURN FALSE; (* should never happen for now ! *)
    END;
        IF getnum(aa,   3,  minyear,maxyear,  S)=FALSE THEN RETURN FALSE;END;

    (* don't limit ourself to febmonth here *)
    IF jj > CARDINAL( erisGetDaysInMonth(mm,aa) ) THEN RETURN FALSE; END;

    RETURN TRUE;
END parseUserDate;

TYPE
    datesourceType = (nodatesourceyet,sysdate,filestampdate,
                     userdatejma,userdatemdy);

PROCEDURE newDateSource (VAR datesource:datesourceType;
                        wanted:datesourceType):BOOLEAN;
VAR
    ok:BOOLEAN;
BEGIN
    IF ( (datesource = nodatesourceyet) OR (datesource = wanted) ) THEN
        datesource:=wanted;
        ok:=TRUE;
    ELSE
        ok:=FALSE;
    END;
    RETURN ok;
END newDateSource;

PROCEDURE getuserdate (VAR dmy:datetype;
                      dateparsemode:CARDINAL;S:ARRAY OF CHAR);
VAR
    ok:BOOLEAN;
BEGIN
    ok:=parseUserDate (dmy.day,dmy.month,dmy.year,
                      dateparsemode,S);

    computeDofW(dmy);
END getuserdate;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)


PROCEDURE getDateAndTime (VAR dmy:datetype; VAR hms:timetype;
                         datesource:datesourceType;
                         useLFN:BOOLEAN;
                         refpath:pathtype;sUser:ARRAY OF CHAR);
VAR
    dmyCHK:datetype;
BEGIN
    CASE datesource OF
    | filestampdate:   getfilestamp (dmy,hms,useLFN,refpath);
    | sysdate:         getDateNow(dmy);
    | userdatejma:     getuserdate(dmy, modeJMA,sUser);
    | userdatemdy:     getuserdate(dmy, modeMJA,sUser);
    END;
    IF datesource # filestampdate THEN
        getTimeNow(hms);
        (* check midnight crossing -- //FIXME maybe add a delay here ? *)
        getDateNow(dmyCHK);
        IF NOT (dmy=dmyCHK) THEN getTimeNow(hms); END;
    END;
END getDateAndTime;

(*

    order DOES matter !!!

    $dd     lundi..dimanche / monday..sunday
    $d      1..31 (ordinal)
    $0d     01..31
    $mm     janvier..dcembre / january..december
    $m      1..12
    $0m     01..12

    $yyyy   ####
    $yy     00..99

    !d      1er..31 (cardinal)
    !0d     1er..31

    h      0..23
    0h     00..23
    m      0..59
    0m     00..59
    s      0..59
    0s     00..59

    $!      Latin date

    $f      reference filename

    n      CRLF
    q      doublequote

    #d      Discordian date
    #h      Discordian holyday
    #s      Discordian slogan
    #e      terse Discordian date
    #i      terse Discordian holyday
    #f      alternate Discordian date
    #j      alternate Discordian holyday

    #o      1st..73rd or 1er..73e Discordian ordinal (0=St Tib)
    #c      1..73 Discordian cardinal (0=St Tib)
    #z      Discordian season ("?"=St Tib)
    #y      #### Discordian year
    #w      Discordian day of week ("?"=St Tib)
    #a      terse Discordian season ("?"=St Tib)
    #x      terse Discordian day of week ("?"=St Tib)
*)

PROCEDURE processDateTimeTokens ( VAR R : ARRAY OF CHAR ;
                                datesource:datesourceType;language:languagetype;
                                useLFN:BOOLEAN;
                                refpath:pathtype;sUser,strFormat:ARRAY OF CHAR);
VAR
    dmy    : datetype;
    hms    : timetype;
    S,T    : str16;
    pad    : CHAR;
    v      : CARDINAL;
    celebrate:BOOLEAN;
    DinS,season,YOLD,DofW,DinYOLD:CARDINAL;
    eng,isExtraDay:BOOLEAN;
    d:discordianType;
    rndnum:CARDINAL;
    strDate,strHolyday,strSlogan:str256; (* better safe than sorry *)
    strDateAlt,strHolydayAlt:str256;     (* better safe than sorry too *)
    strDateTerse,strHolydayTerse:str128; (* should do *)
BEGIN
    getDateAndTime(dmy,hms,  datesource,useLFN,refpath,sUser);

    Str.Copy(R,strFormat);

    IF dmy.validDayOfWeek THEN (* //V11C always from this version *)
        v := ORD(dmy.dayOfWeek);
        CASE language OF
        | french:   Str.ItemS(T,jours," ",v);
        | english:  Str.ItemS(T,joursUS," ",v);
        END;
    ELSE
        T:=undeterminedDay; (* was "", same as getting lastweekday+1 *)
    END;

    oldnew("$dd",T,R);

    v:=dmy.day;
    pad := "";   oldnew("$d",    using(v,2,pad), R);
    pad := "0";  oldnew("$0d",   using(v,2,pad), R);

    IF v=1 THEN
    pad := "";   oldnew("!d",    "1er"         , R);
    pad := "0";  oldnew("!0d",   "1er"         , R);
    ELSE
    pad := "";   oldnew("!d",    using(v,2,pad), R);
    pad := "0";  oldnew("!0d",   using(v,2,pad), R);
    END;

    v := dmy.month-1;
    CASE language OF
    | french:   Str.ItemS(T,mois," ",v);
    | english:  Str.ItemS(T,moisUS," ",v);
    END;
    oldnew("$mm",T,R);

    v := dmy.month;
    pad := "";  oldnew("$m",    using(v,2,pad), R);
    pad := "0"; oldnew("$0m",   using(v,2,pad), R);

    v := dmy.year;
    pad := "";  oldnew("$yyyy", using(v,4,pad), R);
    pad := "0";
    v:=(v MOD 100);
                oldnew("$yy",   using(v,2,pad), R);

    (* getTimeNow() was here *)

    v := hms.hours;
    pad := "";   oldnew("h",    using(v,2,pad), R);
    pad := "0";  oldnew("0h",   using(v,2,pad), R);

    v := hms.minutes;
    pad := "";   oldnew("m",    using(v,2,pad), R);
    pad := "0";  oldnew("0m",   using(v,2,pad), R);

    v := hms.seconds;
    pad := "";   oldnew("s",    using(v,2,pad), R);
    pad := "0";  oldnew("0s",   using(v,2,pad), R);

    (* we could handle some escaped chars here, such as "\n", "\t", "\p" *)

    oldnew ("$!", latinDate(dmy.day,dmy.month,dmy.year), R);

    oldnew ("$f", refpath, R);
    oldnew ("n", nl, R);
    oldnew ("q", doublequote, R);

    (* discordian stuff now *)

    eng:=(language=english);

    rndnum:=GetRndCardRange (0,99); (* will be reduced by modulo *)

    gregorianToDiscordian (DinS,season,YOLD,DofW,DinYOLD, isExtraDay,
                           dmy.day, dmy.month, dmy.year);
    discordianToType (d,   DinS,season,YOLD,DofW,isExtraDay);
    buildDiscordianTokens (d,  rndnum, eng );

    buildDiscordianStrings (strDate,strHolyday,strSlogan,
                           d,ErisFmtDefault,eng);
    buildDiscordianStrings (strDateTerse,strHolydayTerse,strSlogan,
                           d,ErisFmtTerse,  eng);
    buildDiscordianStrings (strDateAlt,strHolydayAlt,strSlogan,
                           d,ErisFmtAlt,    eng);

    oldnew( "#e",  strDateTerse,      R);
    oldnew( "#i",  strHolydayTerse,   R);
    oldnew( "#f",  strDateAlt,        R);
    oldnew( "#j",  strHolydayAlt,     R);
    oldnew( "#d",  strDate,           R);
    oldnew( "#h",  strHolyday,        R);
    oldnew( "#s",  strSlogan,         R);

    (* irrelevant values for Saint Tib's day are shown as "0" or "?" *)

    oldnew( "#o",  d.strDinSordinal,  R);
    oldnew( "#c",  d.strDinS,         R);
    oldnew( "#z",  d.strSeason,       R);
    oldnew( "#y",  d.strYOLD,         R);
    oldnew( "#w",  d.strDofW,         R);

    oldnew( "#a",  d.strshortSeason,       R);
    oldnew( "#x",  d.strshortDofW,         R);

END processDateTimeTokens;

PROCEDURE processFormattingTokens (VAR R:ARRAY OF CHAR;
                                   msg,sDate:ARRAY OF CHAR):BOOLEAN;
VAR
    dtwashere:BOOLEAN;
    i,len:CARDINAL;
    ch:CHAR;
    getting:(grab,gotesc);
BEGIN
    dtwashere:=FALSE;
    getting:=grab;
    Str.Copy(R,"");

    len := Str.Length(msg);
    i:=0;
    WHILE i < len DO
        ch := msg[i];
        CASE getting OF
        | grab :
            IF ch = escch THEN
                getting:=gotesc;
            ELSE
                Str.Append(R,ch);
            END;
        | gotesc:
            CASE ch OF
            | chDT,ChDT     : Str.Append(R,sDate); dtwashere:=TRUE;
            | chCRLF,ChCRLF : Str.Append(R,nl);
            | chTAB,ChTAB   :
                IF getUseBiosMode() THEN
                    Str.Append(R,tab);
                ELSE
                    Str.Append(R,tab); (* we did not handle tab, but v1.0e should be ok *)
                END;
            | escch         : Str.Append(R,escch); (* \\ becomes \ *)
            | chPERCENT,ChPERCENT:
                Str.Append(R,percent);
            ELSE
                Str.Append(R,escch); Str.Append(R,ch);
            END;
            getting := grab;
        END;
        INC(i);
    END;
    RETURN dtwashere;
END processFormattingTokens;

(* ------------------------------------------------------------ *)

PROCEDURE expandTabs (VAR S:ARRAY OF CHAR;tabwidth:CARDINAL );
VAR
    R:str256; (* same as dumpline[] *)
    i,j,add:CARDINAL;
    c:CHAR;
BEGIN
    Str.Copy(R,"");
    j:=0; (* yes, 0 and not 1 ! *)
    FOR i:=1 TO Str.Length(S) DO
        c:= S[i-1];
        IF c = tabul THEN
            add := tabwidth - (j MOD tabwidth);
            WHILE add > 0 DO
                Str.Append(R,space); INC(j);
                DEC(add);
            END;
        ELSE
            Str.Append(R,c); INC(j);
        END;
    END;
    Str.Copy(S,R);
END expandTabs;

PROCEDURE computeHtab (len:CARDINAL ):CARDINAL ;
VAR
    mini,maxi,wi,value : CARDINAL;
BEGIN
    mini := getMinHtab(); (* 0.. *)
    maxi := getMaxHtab();
    wi := maxi-mini+1;
    IF wi > len THEN
        value:=(wi-len) DIV 2;
    ELSE
        value := 0;
    END;
    RETURN (mini+value);
END computeHtab;

CONST
    minline = 1;
    maxline = 25; (* a normal 25x80 screen : should be overkill *)
VAR
    dmpline : ARRAY [minline..maxline] OF str256; (* should do *)

(* we'll use global error codes *)

PROCEDURE prepareDmp (VAR lastline:CARDINAL;
                     tabwidth,htab,vtab:CARDINAL;
                     cooked:BOOLEAN; Z:str1024 ):CARDINAL;
VAR
    i,p,rc,len,maxlen,maxvtab,currvtab:CARDINAL;
    S:str256; (* same as dmpline[] *)
BEGIN
    maxvtab  := getMaxVtab();
    currvtab := vtab;
    rc       := errNone;
    maxlen   := 0;
    lastline := minline-1;

    IF cooked THEN Str.Prepend(Z,nl);Str.Append(Z,nl+nl);END; (* 2 nl before the last will be seen as empty line *)

    LOOP
        IF same(Z,"") THEN EXIT; END;

        p:=Str.Pos(Z,nl);
        IF p = MAX(CARDINAL) THEN
            Str.Copy(S,Z);
            Str.Copy(Z,"");
        ELSE
            Str.Slice(S, Z,0,p);
            Str.Delete(Z,0,p+2);   (* +2 because it's crlf length *)
        END;
        INC(lastline);
        IF lastline > maxline THEN rc:=errTooManyLines; EXIT; END;
        IF cooked THEN Str.Prepend(S,blank);Str.Append(S,blank); END;
        expandTabs(S,tabwidth);
        len:=Str.Length(S);
        IF len > maxlen THEN maxlen := len; END;
        Str.Copy( dmpline[lastline], S);
        INC(currvtab);
        (* IF currvtab > maxvtab THEN rc:=errMaxVtab; EXIT; END; *)
    END;
    IF rc # errNone THEN RETURN rc; END;
    IF cooked THEN
        FOR i:=minline TO lastline DO
            FOR len:=Str.Length(dmpline[i])+1 TO maxlen DO
                Str.Append(dmpline[i],blank);
            END;
        END;
    END;
    RETURN rc;
END prepareDmp;

CONST
    nlnone   = 0;
    nlbefore = 1;
    nlafter  = 2;
    nlboth   = 3;

PROCEDURE dmpAll (lastline,htab,vtab,nlmode:CARDINAL;centered,cooked:BOOLEAN);
VAR
    S:str256; (* same as dmpline[] *)
    i,len:CARDINAL;
BEGIN
    CASE nlmode OF
    | nlbefore,nlboth :
        WrLn;
        IF vtab < getMaxVtab() THEN INC(vtab);END;
    END;
    FOR i:=minline TO lastline DO
        S:=dmpline[i];
        len:=Str.Length(S);
        IF centered THEN htab:=computeHtab(len);END;
        gotoXY(htab,vtab);
        WrStr(S);
        IF i < lastline THEN WrLn; END;
        IF vtab < getMaxVtab() THEN INC(vtab); END;
    END;

    colorhelp; (* safety *)

    CASE nlmode OF
    | nlafter,nlboth:
        WrLn;
    END;
END dmpAll;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE dbg (S1,S2:ARRAY OF CHAR);
CONST
    wi = 20;
VAR
    i:CARDINAL;
BEGIN
    WrStr("// ");WrStr(S1);
    FOR i:=Str.Length(S1)+1 TO wi DO WrStr(space);END;
    WrStr(" = ");WrStr(S2);WrLn;
END dbg;

PROCEDURE dbgC (S1:ARRAY OF CHAR;v:CARDINAL );
BEGIN
    dbg(S1,using(v,1,""));
END dbgC;

PROCEDURE dbgB (S1:ARRAY OF CHAR;tf:BOOLEAN);
BEGIN
    IF tf THEN
        dbg(S1,"TRUE");
    ELSE
        dbg(S1,"FALSE");
    END;
END dbgB;

PROCEDURE showDiscordianYear (year,erispat:CARDINAL;eng,DEBUG:BOOLEAN);
CONST
    blanks5 = "     ";
    blanks20= blanks5+blanks5+blanks5+blanks5;
VAR
    day,month,rndnum,p:CARDINAL;
    DinS,season,YOLD,DofW,DinYOLD:CARDINAL;
    isExtraDay:BOOLEAN;
    d:discordianType;
    strDate,strHolyday,strSlogan:str256;
    strDateAlt,strHolydayAlt    :str256;
    strDateTerse,strHolydayTerse:str128;
    S:str256;
    indent:str16;
BEGIN
    WrLn;
    rndnum:=0; (* we won't need it *)
    FOR month:=1 TO 12 DO
        FOR day :=1 TO erisGetDaysInMonth(month,year) DO
            gregorianToDiscordian (DinS,season,YOLD,DofW,DinYOLD, isExtraDay,
                                   day,month,year);
            discordianToType (d,   DinS,season,YOLD,DofW,isExtraDay);
            buildDiscordianTokens (d,  rndnum, eng );

            buildDiscordianStrings (strDate,strHolyday,strSlogan,
                                    d,ErisFmtDefault,eng);
            buildDiscordianStrings (strDateTerse,strHolydayTerse,strSlogan,
                                    d,ErisFmtTerse,eng);
            buildDiscordianStrings (strDateAlt,strHolydayAlt,strSlogan,
                                    d,ErisFmtAlt,eng);

            IF DEBUG THEN
                dbgC ("DinS",d.DinS);
                dbgC ("season",d.season);
                dbgC ("YOLD",d.YOLD);
                dbgC ("DofW",d.DofW);
                dbgB ("isExtraDay",d.isExtraDay);
                dbg  ("strDinS",d.strDinS);
                dbg  ("strDinSordinal",d.strDinSordinal);
                dbg  ("strSeason",d.strSeason);
                dbg  ("strshortSeason",d.strshortSeason);
                dbg  ("strYOLD",d.strYOLD);
                dbg  ("strDofW",d.strDofW);
                dbg  ("strshortDofW",d.strshortDofW);
                dbg  ("strExtraDay",d.strExtraDay);
                dbg  ("strshortExtraDay",d.strshortExtraDay);
                dbgB ("isHolyday",d.isHolyday);
                dbg  ("strHolyDay",d.strHolyDay);
                dbg  ("strshortHolyDay",d.strshortHolyDay);
            END;

            CASE erispat OF
            | ErisFmtTerse:
                Str.Copy(strDate,   strDateTerse);
                Str.Copy(strHolyday,strHolydayTerse);
            | ErisFmtAlt:
                Str.Copy(strDate,   strDateAlt);
                Str.Copy(strHolyday,strHolydayAlt);
            END;

            S:="~-~-~ : ~";
            Str.Subst(S,"~",using(day,2,"0"));
            Str.Subst(S,"~",using(month,2,"0"));
            Str.Subst(S,"~",using(year,4,"0"));
            Str.Subst(S,"~",strDate);
            WrStr(S);WrLn;
            IF d.isHolyday THEN
                p:=Str.CharPos(S,":");
                Str.Slice(indent,blanks20,0,p+2);
                WrStr(indent);WrStr(strHolyday);WrLn;
            END;

        END;
        WrLn;
    END;
    WrLn;
END showDiscordianYear;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

VAR
    parmcount,i,opt : CARDINAL;
    S,R       : str128;
    state     : (waiting,gotstring);
    language  : languagetype;

    ink,paper : CARDINAL;
    centered,cooked  : BOOLEAN;
    nlmode,tabwidth,htab,vtab : CARDINAL;

    refpath             : pathtype;
    strMsg,strFormat    : str128;
    lookfor,replacewith : str128;

    len,lastline,rc  : CARDINAL;
    v         : LONGCARD;
    useLFN,DEBUG     : BOOLEAN;
    datesource: datesourceType;
    sYear,sUser     : str80; (* oversized for "jj/MMM/aaaa" *)
    jj,mm,aa : CARDINAL;
    dmy:datetype;
    hms:timetype;
    erisshortform,dtwashere,hailEris,marvin:BOOLEAN;
    SSS,RRR,Z : str1024; (* (comanche maximum) overkill in the unlikely case output would be very long *)
    ErisFormat : CARDINAL;
BEGIN
    Lib.DisableBreakCheck();
    FIO.IOcheck := FALSE;
    (* WrLn; *)

    (* handleVesa; *) (* useless, because we won't change video mode *)
    setUseBiosMode ( IsRedirected() );
    findInkPaperAtStartup();
    ink          := ORD(defaultink);
    paper        := ORD(defaultpaper);
    centered     := FALSE;
    nlmode       := nlnone;
    cooked       := FALSE;
    erisshortform:= FALSE;
    htab         := MAX(CARDINAL); (* remember it starts at 0 ! *)
    vtab         := MAX(CARDINAL);
    tabwidth     := 4;

    Str.Copy(strMsg,"");
    Str.Copy(refpath,"");
    Str.Copy(strFormat,"");
    language     := nolanguageyet;
    state        := waiting;
    datesource   := nodatesourceyet;

    Str.Copy(sYear,""); (* useless *)
    hailEris     := FALSE;
    ErisFormat   := ErisFmtDefault;
    marvin       := FALSE; (* the paranoid android *)

    useLFN       := TRUE;
    useLFN       := ( useLFN AND fileSupportLFN() ); (* defined earlier than usual *)

    DEBUG        := FALSE;

    parmcount := Lib.ParamCount();
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i);
        Str.Copy(R,S);
        cleantabs(R);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   "US"+delim+"UK"+delim+"ENGLISH"+delim+
                                   "I:"+delim+"INK:"+delim+
                                   "P:"+delim+"PAPER:"+delim+
                                   "B"+delim+"BIOS"+delim+
                                   "F:"+delim+"FORMAT:"+delim+
                                   "C"+delim+"CENTER"+delim+
                                   "X:"+delim+"HTAB:"+delim+
                                   "Y:"+delim+"VTAB"+delim+
                                   "FR"+delim+"FRENCH"+delim+
                                   "N:"+delim+"NAME:"+delim+"FILE:"+delim+
                                   "JMA:"+delim+"DMY:"+delim+
                                   "MJA:"+delim+"MDY:"+delim+
                                   "??"+delim+"HH"+delim+"MOREHELP"+delim+
                                   "N"+delim+"NL"+delim+"CRLF"+delim+
                                   "!"+delim+"COOKED"+delim+"BEAUTIFIED"+delim+
                                   "???"+delim+"HHH"+delim+"EVENMOREHELP"+delim+
                                   "E"+delim+"ERIS"+delim+"YOLD"+delim+"KALLISTI"+delim+
                                   "E!"+delim+"ERIS!"+delim+"YOLD!"+delim+"KALLISTI!"+delim+
                                   "HAIL:"+delim+
                                   "DDATE"+delim+
                                   "T:"+delim+"TAB:"+delim+"TABWIDTH:"+delim+
                                   "EE"+delim+
                                   "EE!"+delim+
                                   "!!"+delim+
                                   "E!!"+delim+
                                   "EE!!"+delim+
                                   "NN"+delim+
                                   "EEE"+delim+
                                   "EEE!"+delim+
                                   "EEE!!"+delim+
                                   "DEBUG"
                               );
            CASE opt OF
            | 1,2,3 :
                abort(errHelp,"");
            | 4,5,6:
                CASE language OF
                | nolanguageyet,english : language := english;
                ELSE
                    abort(errLanguage,"");
                END;
            | 7,8:
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < mincolor) OR (v > maxcolor) ) THEN abort(errInkRange,"");END;
                ink:=CARDINAL(v);
            | 9,10:
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < mincolor) OR (v > maxcolor) ) THEN abort(errPaperRange,"");END;
                paper:=CARDINAL(v);
            | 11,12:
                setUseBiosMode ( TRUE );
            | 13,14:
                GetString(S,strFormat); (* keep case *)
            | 15,16:
                centered:=TRUE;
            | 17,18:
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF v >= MAX(CARDINAL) THEN abort(errHtabRange,"");END;
                len := CARDINAL(v);
                IF ( (len < getMinHtab()) OR (len > getMaxHtab()) ) THEN abort(errHtabRange,"");END;
                htab:=len;
            | 19,20:
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF v >= MAX(CARDINAL) THEN abort(errVtabRange,"");END;
                len := CARDINAL(v);
                IF ( (len < getMinVtab()) OR (len > getMaxVtab()) ) THEN abort(errVtabRange,"");END;
                vtab:=len;
            | 21,22:
                CASE language OF
                | nolanguageyet,french : language := french;
                ELSE
                    abort(errLanguage,"");
                END;
            | 23,24,25:
                GetString(S,refpath);
                IF chkJoker(refpath) THEN abort(errJoker,S);END;
                IF fileIsDirectorySpec(useLFN,refpath) THEN abort(errNotFilename,S);END;
                IF fileExists(useLFN,refpath)=FALSE THEN abort(errNotFound,S);END;
                IF newDateSource(datesource,filestampdate)=FALSE THEN abort(errDateSource,S);END;
            | 26,27:
                GetString(S,sUser);
                IF newDateSource(datesource,userdatejma)=FALSE THEN abort(errDateSource,S);END;
            | 28,29:
                GetString(S,sUser);
                IF newDateSource(datesource,userdatemdy)=FALSE THEN abort(errDateSource,S);END;
            | 30,31,32:
                abort(errMoreHelp,"");
            | 33,34,35:
                nlmode:=nlafter;
            | 36,37,38:
                cooked:= TRUE;
            | 39,40,41:
                abort(errEvenMoreHelp,"");
            | 42,43,44,45:
                hailEris := TRUE;
            | 46,47,48,49:
                hailEris := TRUE; cooked := TRUE;
            | 50:
                GetString(S,sYear);
                Str.Prepend(sYear,"1/1/"); (* ok with jma and mja *)
                IF parseUserDate(jj,mm,aa,modeJMA,sYear)=FALSE THEN abort(errUserYear,"");END;
                marvin := TRUE;
            | 51:
                hailEris := TRUE;
            | 52,53,54:
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF v >= MAX(CARDINAL) THEN abort(errTabWidthRange,"");END;
                len := CARDINAL(v);
                IF ( (len < mintabwidth) OR (len > maxtabwidth) ) THEN abort(errTabWidthRange,"");END;
                tabwidth := len;
            | 55:
                hailEris    := TRUE;
                ErisFormat  := ErisFmtTerse;              (* -ee *)
            | 56:
                hailEris    := TRUE;
                ErisFormat  := ErisFmtTerse;cooked:=TRUE; (* -ee! *)
            | 57:
                cooked:=TRUE; centered:=TRUE;             (* -!! *)
            | 58:
                hailEris    := TRUE;                      (* -e!! *)
                cooked:=TRUE; centered:=TRUE;
            | 59:
                hailEris    := TRUE;
                ErisFormat  := ErisFmtTerse;              (* -ee!! *)
                cooked:=TRUE; centered:=TRUE;
            | 60:
                nlmode:=nlboth;
            | 61:
                hailEris    := TRUE;
                ErisFormat  := ErisFmtAlt;                (* -eee *)
            | 62:
                hailEris    := TRUE;
                ErisFormat  := ErisFmtAlt;  cooked:=TRUE; (* -eee! *)
            | 63:
                hailEris    := TRUE;
                ErisFormat  := ErisFmtAlt;                (* -eee!! *)
                cooked:=TRUE; centered:=TRUE;
            | 64:
                DEBUG := TRUE;
            ELSE
                abort(errUnknownOpt,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            CASE state OF
            | waiting :
                Str.Copy(strMsg,S);
            ELSE
                abort(errTooManyParms,S);
            END;
            INC(state);
        END;
    END;
    IF (centered AND (htab # MAX(CARDINAL)) ) THEN abort(errCenterHTAB,"");END;

    IF (hailEris AND marvin) THEN abort(errEitherOr,"-hail:# and -e[e[e]]");END;

    IF language=nolanguageyet THEN
        IF (hailEris OR marvin) THEN
            language:=english;
        ELSE
            language:=french;
        END;
    END;

    (* now we can parse *)
    CASE datesource OF
    | nodatesourceyet :
        datesource:=sysdate;
    | userdatejma :
        IF parseUserDate(jj,mm,aa,modeJMA,sUser)=FALSE THEN abort(errUserDate,S);END;
    | userdatemdy :
        IF parseUserDate(jj,mm,aa,modeMJA,sUser)=FALSE THEN abort(errUserDate,S);END;
    END;


    InitRnd();

    color(ink,paper);

    IF same(strFormat,"") THEN
        (* //V11C code obsolete now
        CASE datesource OF
        | filestampdate,userdatejma,userdatemdy: (* no day of week here *)
            CASE language OF
            | french  : Str.Copy(strFormat,defaultFmtFRfilestamp);
            | english : Str.Copy(strFormat,defaultFmtUSfilestamp);
            END;
        | sysdate:
            CASE language OF
            | french  : Str.Copy(strFormat,defaultFmtFR);
            | english : Str.Copy(strFormat,defaultFmtUS);
            END;
        END;
        *)
        CASE language OF
        | french  : Str.Copy(strFormat,defaultFmtFR);
        | english : Str.Copy(strFormat,defaultFmtUS);
        END;
    END;

    (* //FIXME handle hailEris and marvin *)

    (* ------------------------------------------------------------ *)

    IF marvin THEN
        (*
        1900 is common contrarily to what DDATE says
        2000 is leap
        1960 is leap
        1963 is common
        *)
        (* recompute jj,mm,aa *)
        IF parseUserDate(jj,mm,aa,modeJMA,sYear)=FALSE THEN abort(errUserYear,"");END;
        showDiscordianYear(aa,ErisFmtDefault,(language=english),DEBUG );
        showDiscordianYear(aa,ErisFmtTerse,  (language=english),DEBUG );
        showDiscordianYear(aa,ErisFmtAlt,    (language=english),DEBUG );
        abort(errNone,"");
    END;

    (* ------------------------------------------------------------ *)

    IF hailEris THEN
        CASE ErisFormat OF
        | ErisFmtDefault:
            Str.Copy(strFormat,defaultErisFmt);
        | ErisFmtTerse:
            Str.Copy(strFormat,defaultErisFmtShort);
        | ErisFmtAlt:
            Str.Copy(strFormat,defaultErisFmtAlt);
        END;
        Str.Copy(strMsg,""); (* we don't want any user message here ! *)
    END;

    IF DEBUG THEN
        WrStr("user message : ");WrStr(doublequote);WrStr(strMsg);WrStr(doublequote);WrLn;
        WrStr("date format  : ");WrStr(strFormat);WrLn;
        WrStr("file source  : ");WrStr(doublequote);WrStr(refpath);WrStr(doublequote);WrLn;
        WrStr("user date    : ");WrStr(doublequote);WrStr(sUser);WrStr(doublequote);WrLn;
    END;

    processDateTimeTokens(SSS,  datesource,language,useLFN,refpath,sUser,strFormat);

    dtwashere:=processFormattingTokens(RRR, SSS,"");
    IF dtwashere THEN abort(errBadRecursiveToken,strFormat);END;

    dtwashere:=processFormattingTokens(Z, strMsg,RRR);
    IF NOT(dtwashere) THEN Str.Append(Z,RRR);END;

    IF htab=MAX(CARDINAL) THEN htab := getHtab();END;
    IF vtab=MAX(CARDINAL) THEN vtab := getVtab();END;

    rc:=prepareDmp (lastline,tabwidth,htab,vtab,
                   cooked,Z);
    IF rc # errNone THEN abort(rc,"");END;

    dmpAll(lastline,htab,vtab,nlmode,centered,cooked);

    abort(errNone,"");
END DT.




(*

@echo off

if not "%1" == "" goto newtests

cls
set _p_=dt0
mpause 10J

%_p_% -n   -x:10 -y:5

%_p_% -n

%_p_% -n   "Date et heure actuelles : "

%_p_% -n   -us ***\n\t\h\n***

%_p_% -n   -f:"!d.$m.$yyyy"

%_p_% -n   -f:"$0d-$0m-$yyyy"

%_p_% -n   -f:"Roman date : $!"

%_p_% -n   -f:"$d $m $yy $0d $0m $yyyy $dd $mm h m s 0h 0m 0s !d !0d"

%_p_% -n   -n:C:\WINDOWS\user.dat -us "Last USER.DAT access was "

%_p_% -n   -c


set _p_=dt
mpause 11
%_p_%  -n  -x:10 -y:20

%_p_%  -n

%_p_%  -n  "Date et heure actuelles : "

%_p_%  -n  -us ***\n\t\h\n***

%_p_%  -n  -f:"!d.$m.$yyyy"

%_p_%  -n  -f:"$0d-$0m-$yyyy"

%_p_%  -n  -f:"Roman date : $!"

%_p_%  -n  -f:"$d $m $yy $0d $0m $yyyy $dd $mm h m s 0h 0m 0s !d !0d"

%_p_%  -n  -n:C:\WINDOWS\user.dat -us "Last USER.DAT access was "

%_p_%  -n  -c

%_p_%  -n  -jma:1/3/1900 -i:14 -p:4 -c

%_p_%  -n  -mdy:2/1/1963 "Unfortunate birthday : "

mpause Hail Eris !
cls tests

%_p_%  -n  -! -c -i:14 -p:4

%_p_%  -n  -! -i:12 -p:2

%_p_%  -n  -e!! -i:13 -p:3 -jma:1/2/1963

%_p_%  -n  -mdy:2/1/1963 -us -i:15 -p:5 -! -t:12 -f:"Gregorian\t$0d-$0m-$yyyy\nDiscordian\t#d\n\t#h\n\n\t#s"

%_p_%  -n  -ee!!

mpause Hail Eris !

:newtests
set _p_=dt

cls

SET _jma_=5/1/1960
rem SET _jma_=19/2/1960
rem SET _jma_=28/2/1960
rem SET _jma_=29/2/1960


%_p_%  -n -us -e       -jma:%_jma_%
%_p_%  -n -us -e!      -jma:%_jma_%
%_p_%  -n -us -e!!     -jma:%_jma_%

mpause
cls

%_p_%  -n -us -ee      -jma:%_jma_%
%_p_%  -n -us -ee!     -jma:%_jma_%
%_p_%  -n -us -ee!!    -jma:%_jma_%

mpause
cls

%_p_%  -n -us -eee     -jma:%_jma_%
%_p_%  -n -us -eee!    -jma:%_jma_%
%_p_%  -n -us -eee!!   -jma:%_jma_%

mpause Hail Eris !
cls

%_p_%  -n -fr -e       -jma:%_jma_%
%_p_%  -n -fr -e!      -jma:%_jma_%
%_p_%  -n -fr -e!!     -jma:%_jma_%

mpause
cls

%_p_%  -n -fr -ee      -jma:%_jma_%
%_p_%  -n -fr -ee!     -jma:%_jma_%
%_p_%  -n -fr -ee!!    -jma:%_jma_%

mpause
cls

%_p_%  -n -fr -eee     -jma:%_jma_%
%_p_%  -n -fr -eee!    -jma:%_jma_%
%_p_%  -n -fr -eee!!   -jma:%_jma_%


SET _jma_=
SET _p_=

*)



