(* ---------------------------------------------------------------
Title         Q&D Every N
Overview      more general an EVENODD
Usage         see help
Notes         very, very, very quick & dirty... :-(
              minimal error messages and checking, etc.
              original header size was variable,
              but a fixed-length header might sometimes be better an idea
Bugs
Wish List     are you kidding ?
              -i should show org date/time
              encrypted header ?
              headerless data ? (just use XTRACT)

--------------------------------------------------------------- *)

MODULE EveryN;

IMPORT Str;
IMPORT Lib;
IMPORT FIO;
IMPORT IO;
IMPORT SYSTEM;

FROM QD_ASCII IMPORT dash, slash, nullchar, tabchar, cr, lf, nl, bs,
space, dot, deg, doublequote, quote, colon, percent, vbar,
blank, equal, dquote, charnull, singlequote, antislash, dollar,
star, backslash, coma, question, underscore, tabul, hbar,
comma, semicolon, diese, pound, openbracket, closebracket, tilde, exclam,
stardotstar, dotdot, escCh, escSet, letters, digits,
lettersUpp, lettersLow, openbrace, closebrace;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory, qdSplitAllPath,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite, setReadOnly,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs, UpperCaseAlt, LowerCaseAlt,
completedInit, completedShow, completedSHOW, completedEnd, completed,
removeDups, isValidHDunit, removePhantoms, removeFloppies,
getCDROMunits, getCDROMletters, removeCDROMs, getAllHDunits,
getAllLegalUnits, metaproc, getCli, argc, argv;

FROM QD_File IMPORT pathtype, w9XnothingRequired,
fileOpenRead, fileOpen, fileExists, fileExistsAlt,
fileIsRO, fileSetRW, fileSetRO,
fileErase, fileCreate, fileRename, fileGetFileSize, fileGetFileStamp,
fileIsDirectorySpec, fileClose, fileFlush, fileSupportLFN;

FROM IO IMPORT WrStr, WrLn;

(* ------------------------------------------------------------ *)

CONST
    progEXEname     = "EVERYN";
    progTitle       = "Q&D Every N";
    progVersion     = "v1.0";
    progCopyright   = "by PhG";
    banner          = progTitle+" "+progVersion+" "+progCopyright;
CONST
    extBang         = ".!"; (* .!02  ..  .!99 *)
    firstcount      = 1;
    mincount        = 2;
    maxcount        = 99;
    sRange          = "[2..99]";
    smincount       = "01";
    vMajor          = 1;
    vMinor          = 0;
    sDataAddress    = "$0116 (278)"; (* see splitheaderType // different size for Win32 ! *)
CONST
    placeholder = dquote+vbar+dquote;
CONST
    errNone             = 0;
    errHelp             = 1;
    errOption           = 2;
    errParmOverflow     = 3;
    errSyntax           = 4;
    errExclusive        = 5;
    errJoker            = 6;
    errBadNum           = 7;
    errRange            = 8;
    errUselessExt       = 9;
    errNotFound         = 10;
    errOverwrite        = 11;
    errAlready          = 12;
    errReadOnly         = 13;
    errSplits           = 14;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
CONST
errmsg =
banner+nl+
nl+
"Syntax 1 : "+progEXEname+" [-s] <count> <source> [option]..."+nl+
"Syntax 2 : "+progEXEname+" [-c] <basename> [option]..."+nl+
"Syntax 3 : "+progEXEname+" <-f> <basename> <target> [option]..."+nl+
"Syntax 4 : "+progEXEname+" <-i> <file>"+nl+
nl+
"    -s[s[s]] split (-ss = -s -o, -sss = -s -o -r)"+nl+
"    -c[c[c]] create (-cc = -c -o, -ccc = -c -o -r)"+nl+
"    -f[f[f]] create (-ff = -f -o, -fff = -f -o -r)"+nl+
"    -i       show split file header infos"+nl+
nl+
"    -o[o]    overwrite (-oo = -o -r)"+nl+
"    -r       ignore read-only attribute"+nl+
"    -n       do not restore original date/time stamp (-c and -f only)"+nl+
"    -x       disable LFN support even if available"+nl+
nl+
"This program saves <source> content to <count> split files (syntax 1),"+nl+
"rebuilds source from split files (syntax 2 and syntax 3),"+nl+
"or shows split file header infos if any (syntax 4)."+nl+
nl+
"a) Split files extension is "+extBang+"## where ## goes from "+smincount+" to <count>."+nl+
"b) <basename> is filename of split files without extension."+nl+
"   target name comes from either header (syntax 2) or command line (syntax 3)."+nl+
"c) By design, split files and target are created in current directory."+nl+
"d) This program is best used to process compressed and/or encrypted files."+nl+
"e) Should raw data be necessary, it starts at this address : "+sDataAddress+"."+nl+
"f) Please note rebuilding source from split files is slow a process."+nl+
"g) The same executable run to split files must be used in order to rebuilt it !"+nl+
nl+
"Examples : "+progEXEname+" 16 c:\z\foo.bin"+nl+
"           "+progEXEname+" foo"+nl+
"           "+progEXEname+" -i foo"+extBang+"00"+nl;
VAR
    S : str1024; (* in case we get a LFN *)
BEGIN
    CASE e OF
    | errHelp :        WrStr(errmsg);
    | errOption:       S := "Unknown "+placeholder+" option !";
    | errParmOverflow: S := placeholder+" is one parameter too many !";
    | errSyntax :      S := "Illegal syntax, please check help screen !";
    | errExclusive:    S := "-s[s[s]], -c[c[c]], -f[f[f]] and -i options are mutually exclusive !";
    | errJoker:        S := placeholder+" should not contain any joker !";
    | errBadNum:       S := "Illegal "+placeholder+" value !";
    | errRange:        S := placeholder+" is out of "+sRange+" valid range !";
    | errUselessExt:   S := placeholder+" should not have an extension !";
    | errNotFound:     S := placeholder+" does not exist !";
    | errOverwrite:    S := "-o[o] option seems required in order to create "+dquote+vbar+extBang+"##"+dquote+" !";
    | errAlready:      S := placeholder+" already exists !";
    | errReadOnly:     S := placeholder+" is read-only !";
    | errSplits:       S := 'Invalid "'+vbar+extBang+'##" set of files !';
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp:
        ;
    ELSE
        Str.Subst(S,vbar,einfo);
        WrStr(progEXEname+" : ");WrStr(S);WrLn;
    END;
    Lib.SetReturnCode(SHORTCARD(e));
    HALT;
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (96 * 512) + FIO.BufferOverhead; (* was 8 *)
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
VAR
    ioBufferIn  : ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
    ioBufferOut : ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
CONST
    dataBufferSize      = MAX(CARDINAL)-256-32; (* avoid pos+255 overflow beyond 65535 ! *)
    firstDataBufferByte = 0;
    maxDataBufferByte   = dataBufferSize-1;
VAR
    databuffer  : ARRAY [firstDataBufferByte..maxDataBufferByte] OF BYTE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE strToCardnum (VAR n:CARDINAL; S:ARRAY OF CHAR):BOOLEAN;
VAR
    ok:BOOLEAN;
    v:LONGCARD;
BEGIN
    v:=Str.StrToCard(S,10,ok);
    IF ok THEN
        ok := (v <= MAX(CARDINAL) );
        IF ok THEN n:=CARDINAL(v);END;
    END;
    RETURN ok;
END strToCardnum;

PROCEDURE numToStr (n,base:CARDINAL;wi:INTEGER;padchar:CHAR):str16;
VAR
    R:str16;
    ok:BOOLEAN;
    i:CARDINAL;
BEGIN
    Str.CardToStr( LONGCARD(n),R,base,ok);
    IF ok THEN
        FOR i := (Str.Length(R)+1) TO ABS(wi) DO
            IF wi < 0 THEN
                Str.Append(R,padchar);
            ELSE
                Str.Prepend(R,padchar);
            END;
        END;
    ELSE
        R:="*** ERROR ! ***"; (* should never happen ! *)
    END;
    RETURN R;
END numToStr;

PROCEDURE wrq (S:ARRAY OF CHAR);
BEGIN
    WrStr(dquote);WrStr(S);WrStr(dquote);
END wrq;

CONST
    sepcolon = " : ";

PROCEDURE dmpstr (enquote:BOOLEAN;S1,S2:ARRAY OF CHAR   );
BEGIN
    WrStr(S1); WrStr(sepcolon);
    IF enquote THEN
        wrq(S2);
    ELSE
        WrStr(S2);
    END;
    WrLn;
END dmpstr;

PROCEDURE dmplc(v:LONGCARD;S:ARRAY OF CHAR);
BEGIN
    WrStr(S);WrStr(sepcolon);
    IO.WrLngCard(v,0);WrLn;
END dmplc;

PROCEDURE zesame (S1,S2:ARRAY OF CHAR ):BOOLEAN;
BEGIN
    LowerCaseAlt(S1);
    LowerCaseAlt(S2);
    RETURN same(S1,S2);
END zesame;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    ctrlz         = CHR(26);
    zemark        = ".##"+ctrlz;
    chDOS         = "D";
    chWin32       = "w";
    chExpectedOS  = chDOS; (* //WARNING ! chWin32 for unlikely XDS version ! *)
TYPE
    splitheaderType = RECORD
        magicmark : ARRAY[0..3] OF CHAR; (* end with ctrl-Z *)
        os        : CHAR;      (* "D" = DOS, "w" = Win32 *)
        version   : SHORTCARD;
        orgdt     : LONGCARD;
        orgfsize  : LONGCARD;
        totalcount: SHORTCARD; (* plain view ! *)
        thiscount : SHORTCARD; (* plain view ! *)
        orgfname  : pathtype;
    END;
    (* original source filename follows this structure *)

PROCEDURE buildHeader (VAR H:splitheaderType;
                       total,current:CARDINAL;hnd:FIO.File;fname:pathtype);
BEGIN
    H.magicmark:= zemark;
    H.os       := chExpectedOS;
    H.version  := SHORTCARD(vMajor << 4 + vMinor);
    H.orgdt    := FIO.GetFileDate(hnd);
    H.orgfsize := FIO.Size(hnd);
    H.totalcount:=SHORTCARD(total);
    H.thiscount:= SHORTCARD(current);
    Lib.Fill( ADR(H.orgfname),SIZE(H.orgfname)," ");
    Str.Copy(H.orgfname,fname);
END buildHeader;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* don't bother with exact error code here : let's assume user has a brain ! *)

PROCEDURE ChkTargets (DEBUG,useLFN,OVERWRITE,IGNORERO:BOOLEAN;
                     count:CARDINAL;base:pathtype  ):BOOLEAN;
VAR
    pb,i:CARDINAL;
    F:pathtype;
    hin:FIO.File;
BEGIN
    pb:=0;
    FOR i:=firstcount TO count DO
        Str.Concat(F,base,extBang);
        Str.Append(F,numToStr(i,10,2,"0"));
        IF DEBUG THEN dmpstr(TRUE,"/// ChkTargets()",F);END;
        IF fileExists(useLFN,F) THEN
            IF OVERWRITE THEN
                IF fileIsRO(useLFN,F) THEN
                    IF IGNORERO THEN
                        fileSetRW(useLFN,F);
                    ELSE
                        INC(pb);
                    END;
                END;
            ELSE
                INC(pb);
            END;
        END;
    END;
    RETURN (pb=0);
END ChkTargets;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE procSplit (DEBUG,useLFN,OVERWRITE,IGNORERO:BOOLEAN;
                    count:CARDINAL;source,base,ext:pathtype  );
VAR
    H:splitheaderType;
    hin,hout:FIO.File;
    p,j,i,got,wanted:CARDINAL;
    SRC,F:pathtype;
    S:str256;
    ok:BOOLEAN;
BEGIN
    IF DEBUG THEN
        dmpstr(TRUE, "Source",source);
        dmpstr(TRUE, "Base  ",base);
        dmpstr(FALSE,"Count ",numToStr(count,10,2,""));
    END;

    IF same(ext,"") THEN ext:=dot;END; (* cosmetic *)
    Str.Concat(SRC,base,ext);
    wanted:=(dataBufferSize DIV count) * count; (* multiple of count *)

    hin:=fileOpenRead(useLFN,source);
    FIO.AssignBuffer(hin,ioBufferIn);

    FOR i:=firstcount TO count DO
        Str.Concat(F,base,extBang);
        Str.Append(F,numToStr(i,10,2,"0"));

        hout:=fileCreate(useLFN,F);
        FIO.AssignBuffer(hout,ioBufferOut);
        buildHeader(H, count,i,hin,SRC); (* hin ! *)
        FIO.WrBin(hout,H,SIZE(H));
        S:="+++ Creating "+placeholder;
        Str.Subst(S,vbar,F);
        video(S,TRUE);

        FIO.Seek(hin,0); (* source from beginning *)
        LOOP
            got:=FIO.RdBin(hin,databuffer,wanted);
            IF got = 0 THEN EXIT; END;
            p:=i-1; (* every Nth *)
            LOOP
                FIO.WrBin(hout,databuffer[p],1);
                INC(p,count); (* p+count should never overflow buffer size ! *)
                IF p >= got THEN EXIT; END;
            END;
            IF got < wanted THEN EXIT;END;
        END;
        fileClose(useLFN,hout);
        video(S,FALSE);
    END;

    fileClose(useLFN,hin);

    S:="::: Processed "+placeholder;
    Str.Subst(S,vbar,source);
    WrStr(S);WrLn;
END procSplit;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE grabHeader (VAR H:splitheaderType;
                     useLFN:BOOLEAN;source:pathtype):CARDINAL;
VAR
    got,pb:CARDINAL;
    hin:FIO.File;
BEGIN
    H.magicmark := "";
    H.os        := "?";
    H.totalcount:= 0;
    H.thiscount := 0;
    Str.Copy(H.orgfname,"");

    pb:=0;
    hin:=fileOpenRead(useLFN,source);
    got:=FIO.RdBin(hin,H,SIZE(H));
    IF got # SIZE(H) THEN INC(pb);RETURN pb; END;

    IF same(H.magicmark,zemark)=FALSE THEN INC(pb);END;
    IF H.os # chExpectedOS THEN INC(pb);END; (* //WARNING *)

    fileClose(useLFN,hin);
    RETURN pb;
END grabHeader;

PROCEDURE procAbout (DEBUG,useLFN:BOOLEAN;source:pathtype  );
VAR
    H : splitheaderType;
    S : str256;
    pb:CARDINAL;
BEGIN
    pb:=grabHeader(H, useLFN,source);

    IF pb # 0 THEN
        dmpstr(TRUE,"--- No valid header in ",source); (* DOS # Win32, among other problems *)
    ELSE
        CASE H.os OF
        | chDOS:   S:="DOS";
        | chWin32: S:="Win32";
        END;
        dmpstr            (TRUE, "::: O.S.           ",S);
        WrLn;
        dmpstr            (TRUE, "::: File name      ",source);
        S:="~ out of ~";
        Str.Subst(S,"~",numToStr( CARDINAL(H.thiscount), 10,1,""));
        Str.Subst(S,"~",numToStr( CARDINAL(H.totalcount),10,1,""));
        dmpstr            (FALSE,"::: File content   ",S);
        WrLn;
        dmpstr            (TRUE, "::: Target name    ",H.orgfname);
        dmplc  (H.orgfsize,      "::: Target filesize");
        (* //FIXME dump decoded H.orgdt LONGCARD *)
    END;
END procAbout;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* don't bother with exact error code here : let's assume user has a brain ! *)

PROCEDURE ChkSplits (VAR H:splitheaderType;
                    DEBUG,useLFN,OVERWRITE,IGNORERO:BOOLEAN;base:pathtype):BOOLEAN;
VAR
    pb,i:CARDINAL;
    F:pathtype;
    hin:FIO.File;
    HH:splitheaderType;
    pbhere:BOOLEAN;
BEGIN
    Str.Concat(F,base,extBang);
    Str.Append(F,numToStr(firstcount,10,2,"0"));
    IF DEBUG THEN dmpstr(TRUE,"/// ChkSplits()",F);END;
    IF fileExists(useLFN,F)=FALSE THEN RETURN FALSE;END; (* *.!01 does not exist *)
    IF grabHeader (H, useLFN,F) # 0 THEN RETURN FALSE;END; (* no valid *.!01 *)

    pb:=0;
    FOR i:=firstcount+1 TO CARDINAL(H.totalcount) DO (* 1 already checked *)
        pbhere:=TRUE;
        Str.Concat(F,base,extBang);
        Str.Append(F,numToStr(i,10,2,"0"));
        IF DEBUG THEN dmpstr(TRUE,"/// ChkSplits()",F);END;
        IF fileExists(useLFN,F) THEN
            IF grabHeader(HH, useLFN,F) = 0 THEN
                IF H.orgfsize = HH.orgfsize THEN
                    IF H.orgdt = HH.orgdt THEN
                        IF zesame(H.orgfname,HH.orgfname) THEN pbhere:=FALSE;END;
                    END;
                END;
            END;
        END;
        IF pbhere THEN INC(pb);END;
    END;
    RETURN (pb=0);
END ChkSplits;

PROCEDURE procRebuild (DEBUG,useLFN,OVERWRITE,IGNORERO,ORGDT:BOOLEAN;
                      H:splitheaderType;target,base:pathtype);
VAR
    hout,hin:FIO.File;
    i,j,got,wanted,count:CARDINAL;
    fpos:LONGCARD;
    Htmp:splitheaderType;
    F:pathtype;
    S:str256;
BEGIN
    count:=CARDINAL(H.totalcount);

    hout:=fileCreate(useLFN,target);
    FIO.AssignBuffer(hout,ioBufferOut);

    FOR i:=firstcount TO count DO
        Str.Concat(F,base,extBang);
        Str.Append(F,numToStr(i,10,2,"0"));

        S:="+++ Processing "+placeholder;
        Str.Subst(S,vbar,F);
        video(S,TRUE);

        hin:=fileOpenRead(useLFN,F);
        FIO.AssignBuffer(hin,ioBufferIn);

        got:=FIO.RdBin(hin,Htmp,SIZE(Htmp));

        fpos:=LONGCARD(i-1);
        wanted:=dataBufferSize;
        LOOP
            got:=FIO.RdBin(hin,databuffer,wanted);
            FOR j:=1 TO got DO
                FIO.Seek(hout,fpos); (* ugly but rebuilding a buffer is NOT faster *)
                FIO.WrBin(hout,databuffer[j-1],1);
                INC(fpos, LONGCARD(count));
            END;
            IF got # wanted THEN EXIT; END;
        END;
        fileClose(useLFN,hin);
        video(S,FALSE);
    END;
    fileClose(useLFN,hout);

    IF ORGDT THEN
        hout := fileOpen(useLFN,target);
        FIO.SetFileDate(hout,H.orgdt);
        fileClose(useLFN,hout);
    END;

    S:="::: Rebuilt "+placeholder;
    Str.Subst(S,vbar,target);
    WrStr(S);WrLn;

END procRebuild;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    cmdtype = (cmdnone, cmdsplit, cmdrebuild, cmdrebuilduser,cmdabout);

PROCEDURE newcmd (VAR cmd:cmdtype;wanted:cmdtype):BOOLEAN;
BEGIN
    IF cmd = wanted  THEN RETURN TRUE; END;
    IF cmd # cmdnone THEN RETURN FALSE;END;
    cmd:=wanted;
    RETURN TRUE;
END newcmd;

(* ------------------------------------------------------------ *)

CONST
    minparm = 1;
    maxparm = 2;
VAR
    lastparm,parmcount,i,opt : CARDINAL;
    S,R                : pathtype;
    target,source,base,uu,dd,nn,ee:pathtype; (* uu is so overdimensionned it's a shame *)
    count:CARDINAL;
    parm : ARRAY [minparm..maxparm] OF pathtype;
    cmd                : cmdtype;
    DEBUG,useLFN,OVERWRITE,IGNORERO,ORGDT:BOOLEAN;
    baseheader : splitheaderType;
BEGIN
    Lib.DisableBreakCheck();
    FIO.IOcheck := FALSE;

    WrLn;

    DEBUG     := FALSE;
    useLFN    := TRUE;
    OVERWRITE := FALSE;
    IGNORERO  := FALSE;
    ORGDT     := TRUE;

    cmd       := cmdnone;

    lastparm := minparm-1;
    parmcount := Lib.ParamCount();
    IF parmcount=0 THEN abort(errHelp,"");END;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i);
        Str.Copy(R,S); cleantabs(R);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   "O"+delim+"OVERWRITE"+delim+
                                   "R"+delim+"READONLY"+delim+
                                   "OO"+delim+
                                   "X"+delim+"LFN"+delim+
                                   "DEBUG"+delim+

                                   "I"+delim+"INFO"+delim+"ABOUT"+delim+
                                   "S"+delim+"SPLIT"+delim+
                                   "SS"+delim+
                                   "SSS"+delim+
                                   "C"+delim+"CREATE"+delim+"REBUILD"+delim+
                                   "CC"+delim+
                                   "CCC"+delim+
                                   "F"+delim+"TARGET"+delim+
                                   "FF"+delim+
                                   "FFF"+delim+
                                   "N"+delim+"NOUPDATE"
                               );
            CASE opt OF
            | 1,2,3 :    abort(errHelp,"");
            | 4,5:       OVERWRITE := TRUE;
            | 6,7:       IGNORERO  := TRUE;
            | 8:         OVERWRITE := TRUE;
                         IGNORERO  := TRUE;
            | 9,10:      useLFN    := FALSE;
            | 11:        DEBUG     := TRUE;

            | 12,13,14:  IF newcmd(cmd,cmdabout)=FALSE THEN abort(errExclusive,"");END;
            | 15,16   :  IF newcmd(cmd,cmdsplit)=FALSE THEN abort(errExclusive,"");END;
            | 17      :  IF newcmd(cmd,cmdsplit)=FALSE THEN abort(errExclusive,"");END;
                         OVERWRITE := TRUE;
            | 18      :  IF newcmd(cmd,cmdsplit)=FALSE THEN abort(errExclusive,"");END;
                         OVERWRITE := TRUE;
                         IGNORERO  := TRUE;
            | 19,20,21:  IF newcmd(cmd,cmdrebuild)=FALSE THEN abort(errExclusive,"");END;
            | 22      :  IF newcmd(cmd,cmdrebuild)=FALSE THEN abort(errExclusive,"");END;
                         OVERWRITE := TRUE;
            | 23      :  IF newcmd(cmd,cmdrebuild)=FALSE THEN abort(errExclusive,"");END;
                         OVERWRITE := TRUE;
                         IGNORERO  := TRUE;
            | 24,25   :  IF newcmd(cmd,cmdrebuilduser)=FALSE THEN abort(errExclusive,"");END;
            | 26      :  IF newcmd(cmd,cmdrebuilduser)=FALSE THEN abort(errExclusive,"");END;
                         OVERWRITE := TRUE;
            | 27      :  IF newcmd(cmd,cmdrebuilduser)=FALSE THEN abort(errExclusive,"");END;
                         OVERWRITE := TRUE;
                         IGNORERO  := TRUE;
            | 28,29   :  ORGDT     := FALSE;
            ELSE
                abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            INC(lastparm);
            IF lastparm > maxparm THEN abort(errParmOverflow,S);END;
            parm[lastparm]:=S;
        END;
    END;
    useLFN := (useLFN AND fileSupportLFN() );

    CASE lastparm OF
    | minparm-1:
        abort(errSyntax,"");
    | minparm:
        CASE cmd OF
        | cmdabout : ;
        ELSE
            IF newcmd(cmd,cmdrebuild)=FALSE THEN abort(errExclusive,"");END;
        END;
    | minparm+1:
        CASE cmd OF
        | cmdrebuilduser: ;
        ELSE
            IF newcmd(cmd,cmdsplit)=FALSE THEN abort(errExclusive,"");END;
        END;
    END;

    CASE cmd OF
    | cmdnone :
        abort(errSyntax,""); (* should never happen *)
    | cmdsplit:
        S:=parm[minparm];
        source:=parm[minparm+1];
        IF strToCardnum(count,S)=FALSE THEN abort(errBadNum,S);END;
        IF ( (count < mincount) OR (count > maxcount) ) THEN abort(errRange,S);END;
        IF chkJoker(source) THEN abort(errJoker,source);END;
        IF fileExists(useLFN,source)=FALSE THEN abort(errNotFound,source);END;
        qdSplitAllPath(source, uu,dd,nn,ee);
        IF ChkTargets(DEBUG,useLFN,OVERWRITE,IGNORERO,count,nn)=FALSE THEN
            abort(errOverwrite,nn);
        END;
        procSplit(DEBUG,useLFN,OVERWRITE,IGNORERO,count,source,nn,ee);
    | cmdrebuild,cmdrebuilduser:
        source:=parm[minparm];
        IF chkJoker(source) THEN abort(errJoker,source);END;
        qdSplitAllPath(source, uu,dd,nn,ee);
        IF same(ee,"")=FALSE THEN abort(errUselessExt,source);END;
        Lib.MakeAllPath(base,uu,dd,nn,"");
        IF ChkSplits(baseheader, DEBUG,useLFN,OVERWRITE,IGNORERO,base)=FALSE THEN
            abort(errSplits,base);
        END;
        IF cmd=cmdrebuilduser THEN
            target:=parm[minparm+1];
            IF chkJoker(target) THEN abort(errJoker,target);END;
        ELSE
            target:=baseheader.orgfname;
        END;
        IF fileExists(useLFN,target) THEN
            IF OVERWRITE THEN
                IF fileIsRO(useLFN,target) THEN
                    IF IGNORERO THEN
                        fileSetRW(useLFN,target);
                    ELSE
                        abort(errReadOnly,target);
                    END;
                END;
            ELSE
                abort(errAlready,target);
            END;
        END;
        procRebuild(DEBUG,useLFN,OVERWRITE,IGNORERO,ORGDT,baseheader,target,base);
    | cmdabout:
        source:=parm[minparm];
        IF chkJoker(source) THEN abort(errJoker,source);END;
        IF fileExists(useLFN,source)=FALSE THEN abort(errNotFound,source);END;
        procAbout(DEBUG,useLFN,source);
    END;

    abort(errNone,"");
END EveryN.

