(* ---------------------------------------------------------------
Title         Q&D Glyphes
Author        PhG
Overview      see help
Usage
Notes         very, very, very quick & dirty... :-(

              make sure USEBGI is FALSE in QD_MAKE.DEF
              so QD_HIRES uses TS VGA library !

Bugs          not really a bug but a quirk :
              when dumped, smaller shapes are 16x16, bigger shapes are 32x32
              display is centered using -16 0 +16 range (width 33)
              but shape ascii definitions are -15 0 +16 (width 32)
              thus making topmost and leftmost rows disappear
              when dumping to ASCII
              remedy is just NOT to reposition shapes to borders ;-)
              see //FIX
Wish List     read glyphs definitions from an external text file
              bound cursor to really available rane ?
              update TOOLSKY v1.5c with revised code ?
              bah, glyphs are definitive, so...

--------------------------------------------------------------- *)

MODULE Glyphes;

IMPORT FIO;
IMPORT Str;
IMPORT Lib;
IMPORT IO;

FROM IO IMPORT WrStr,WrLn;

FROM QD_ASCII IMPORT dash, slash, nullchar, tabchar, cr, lf, nl, bs,
space, dot, deg, degree, doublequote, quote, colon, percent, vbar,
blank, equal, dquote, charnull, singlequote, antislash, dollar,
star, backslash, coma, question, underscore, underbar, tabul, hbar,
comma, semicolon, diese, pound, openbracket, closebracket, tilde, exclam,
stardotstar, dotdot, escCh, escSet, letters, digits,
lettersUpp, lettersLow, openbrace, closebrace, ampersand;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite, setReadOnly,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs, UpperCaseAlt, LowerCaseAlt,
completedInit, completedShow, completedSHOW, completedEnd, completed,
removeDups, isValidHDunit, removePhantoms, removeFloppies,
getCDROMunits, getCDROMletters, removeCDROMs, getAllHDunits,
getAllLegalUnits, metaproc, getCli, argc, argv, qdSplitAllPath,
metaproc, UpperCaseFR, LowerCaseFR, ASCIIonly;

FROM QD_Hires IMPORT WaitVGAretrace, palval,
pset, HiresOn, TextOn, GrLine, GrCircle,
GrClearScreen, GrSetLinestyle, GrWrapon, GrPoint,
GrSetBkColor, GrOutText, GrSetTextColor, GrSetTextPosition, textcoords,
VGAhere, getmaxhtab, getmaxvtab,
xmax,ymax,xmin,ymin,cx,cy,
cPALEWHITE, cPALEBLUE, cPALEGREEN, cPALECYAN, cPALERED, cPALEMAGENTA,
cBROWN, cGRAY, cBLACK, cBLUE, cGREEN, cCYAN, cRED, cMAGENTA,
cYELLOW, cWHITE, cMYBLACK,
firstInk, lastInk, inkToRGB, FixPalette, palette16, pal16,
restype, initHGR, charheight;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    exe        = "GLYPHES";
    title      = "Q&D Glyphes";
    version    = "v1.0";
    culprit    = "PhG ( partir de TOOLSKY v1.5c)";
    banner     = title+" "+version+" par "+culprit;

    basefile   = "GLYPHES";
    extTXT     = ".TXT";
    extASC     = ".ASC";
    extLST     = ".LST";

    infofile  = basefile+extTXT;
    ascfile   = basefile+extASC;
    lstfile   = basefile+extLST;
CONST
    errNone = 0;
    errHelp = 255;

PROCEDURE abort (errcode:CARDINAL;msg:ARRAY OF CHAR);
CONST
    helpmsg = banner+nl+
nl+
"Syntaxe : "+exe+" <taille du point>"+nl+
nl+
"Ce programme permet de visualiser les glyphes Q&D AstroTools."+nl;

BEGIN
    CASE errcode OF
    | errHelp :
        WrStr(helpmsg);
    | errNone :
        ;
    ELSE
        WrStr(msg);WrLn;
    END;

    Lib.SetReturnCode(SHORTCARD(errcode));
    HALT;
END abort;

(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead; (* was 32, i.e. 16 Kb *)
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
    maxCharCount    = 16*512;
VAR
    ioBufferOut     : ARRAY [firstBufferByte..lastBufferByte] OF BYTE;

    (*
       seems string buffer used by FIO.RdStr must NOT be greater
       than iobuffersize ! else, crash ! does seem to be a limit
       at about 8Kb for string !
       warning : hugestring could be str4096 as paragraph should not be greater,
       but who knows what evil lurks in the hearts of code ? ;-)
    *)

(* ------------------------------------------------------------ *)

PROCEDURE wr (hout:FIO.File; S:ARRAY OF CHAR);
BEGIN
    FIO.WrStr(hout, S);
END wr;

PROCEDURE wrln (hout:FIO.File );
BEGIN
    FIO.WrLn(hout);
END wrln;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    patSolid         = 0FFFFH; (* 1111111111111111 *)
    patLight         = 0AAAAH; (* 1010101010101010 *)
    patVeryLight     = 08888H; (* 1000100010001000 *)
    patVeryVeryLight = 08080H; (* 1000000010000000 *)

CONST
    firstshape =1; (* must be 1 *)
    countshape =75;
    lastshape  =2*countshape;
    mindotsize =1;
    maxdotsize =12;
    strdotsizerange = "[1..12]";
    inkpaper   = cMYBLACK;
    inktext    = cYELLOW;
    inkline    = cRED;
    inkshape   = cWHITE;
    inklimit   = cGREEN;

    bwinkpaper = cWHITE;
    bwinktext  = cMYBLACK;
    bwinkline  = cMYBLACK;
    bwinkshape = cMYBLACK;

VAR
    ofsx : ARRAY [firstshape..lastshape] OF INTEGER;
    ofsy : ARRAY [firstshape..lastshape] OF INTEGER;

TYPE
    objettype    = (soleil,lune,mercure,venus,mars,
                jupiter,saturne,uranus,neptune,pluton,
                as,mc,ds,fc,lilith,dragonhead,dragontail,blacksun);
                (* we could probably add earth here, right after blacksun *)
    signtype = (belier,taureau,gemeaux,
                cancer,lion,vierge,
                balance,scorpion,sagittaire,
                capricorne,verseau,poissons);
    aspecttype = (conjonction,opposition,carre,trigone,sextile,
                  semicarre,semisextile,quinconce,sesquicarre);
    cuspidetype  = (mAS,m2,m3,mFC,m5,m6,mDS,m8,m9,mMC,m11,m12);

CONST
    Retro  ="R";
    sDeg   = "";
    sMin   = "'";
    cN     = "N";
    cS     = "S";
    cE     = "E";
    cO     = "O";
    cW     = "W";
    cPlus  = "+";
    cMinus = "-";

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* warning : lots of hard coded values here ! *)
(* check qd_names, qd_glyph, qd_calc *)

PROCEDURE sound (freq,duration:CARDINAL);
BEGIN
    Lib.Sound(freq);
    Lib.Delay(duration);
    Lib.NoSound();
END sound;

PROCEDURE wrS (VAR vtab:CARDINAL;htab:CARDINAL;S:ARRAY OF CHAR);
VAR
    rowcol:textcoords;
BEGIN
    rowcol:=GrSetTextPosition(vtab,htab);
    GrOutText(S);
    INC(vtab);
END wrS;

PROCEDURE prS (VAR vtab:CARDINAL;htab:CARDINAL;S:ARRAY OF CHAR);
VAR
    rowcol:textcoords;
BEGIN
    rowcol:=GrSetTextPosition(vtab,htab);
    GrOutText(S);
END prS;

PROCEDURE int2str (v:INTEGER   ):str16;
VAR
    S:str16;
    ok:BOOLEAN;
BEGIN
    Str.IntToStr(LONGINT(v),S,10,ok);
    IF ok=FALSE THEN S:="???";END;
    RETURN S;
END int2str;

PROCEDURE card2str (v:CARDINAL ):str16;
VAR
    S:str16;
    ok:BOOLEAN;
BEGIN
    Str.CardToStr(LONGCARD(v),S,10,ok);
    IF ok=FALSE THEN S:="???";END;
    RETURN S;
END card2str;

PROCEDURE lc2hex (v:LONGCARD ;bytes:CARDINAL ):str16;
VAR
    S:str16;
    ok:BOOLEAN;
    i:CARDINAL;
BEGIN
    Str.CardToStr(v,S,16,ok);
    IF ok=FALSE THEN S:="???";RETURN S; END;
    FOR i:=Str.Length(S) TO (bytes*2) DO
        Str.Prepend(S,"0");
    END;
    Str.Prepend(S,"0"); (* just in case *)
    Str.Append(S,"H");
    RETURN S;
END lc2hex;

PROCEDURE clearscreen (inkPaper:CARDINAL);
VAR
    oldpaper,newpaper:LONGCARD;
BEGIN
    newpaper:=inkToRGB(inkPaper);
    oldpaper:=GrSetBkColor(newpaper);
    WaitVGAretrace(); (* now here for all calls *)
    (* this piece of crap does NOT like _GCLEARSCREEN which is buggy ! *)
    (* use _GWINDOW instead !!! *)
    GrClearScreen();
END clearscreen;

PROCEDURE GrBox (x1,y1,x2,y2:INTEGER;ink,pattern:CARDINAL   );
BEGIN
    GrLine (x1,y1,x2,y1,ink,pattern);
    GrLine (x2,y1,x2,y2,ink,pattern);
    GrLine (x2,y2,x1,y2,ink,pattern);
    GrLine (x1,y2,x1,y1,ink,pattern);
END GrBox;

PROCEDURE xpad (VAR S : ARRAY OF CHAR;wi:CARDINAL );
VAR
    n : CARDINAL;
BEGIN
    FOR n:=Str.Length(S)+1 TO wi DO
        Str.Append(S," ");
    END;
END xpad;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE getShapeDefObject (id:objettype;big:BOOLEAN;
                             VAR dx,dy:INTEGER; VAR S : str1024);
BEGIN
    CASE big OF
    | FALSE :
        CASE id OF
        | soleil:
            S:="LLmUUmLUmLUUUURmUmRmLUmRUmRRRRRDmRDmRDmRDDDDDmLLmDLmDLLU"+
               "mUmRmLmUmRmLmUmRmLmUmRmLU";
            dx:=-1;dy:=5;
        | lune:
            S:="LLmUUmLUmLUUUURmUmRmLUmRUmRRRRRDmLDmLDmLDDDDDmRDmRDmRLLL";
            dx:=1;dy:=5;
        | mercure:
            S:="LUmLUmLUURmUmRmLRmURRDmRRmDDDLmDLmDDmLDDLmUmRmLRmRUmUmR"+
               "mLmUmRmLmUmRmLmUmRmLmUmRmLmUmRmLmUmRmLmUmRUmRULmLmLmLmLmLDDmRR";
            dx:=0;dy:=3;
        | venus:
            S:="LUmLUmLUURmUmRmLRmURRDmRRmDDDLmDLmDDmLDDLmUmRmLRmRUmUmR"+
               "mLmUmRmLmUmRmLmUmRmLmUmRmLmUmRmLmUmRmL";
            dx:=0;dy:=2;
        | mars:
            S:="LUmLUmLUURmUmRmLRmURRDmRRmDDDLmDLmDUmUmRmLmUmRmLmUmR"+
               "mLmUmRmLmUmRmLmUmLUmRUmRUmRDDDmUmRmLmUmRmLmUmLLL";
            dx:=0;dy:=5;
        | jupiter:
            S:="rrmdrmdddlmdlmlmdrrrrrmrumumlddddd";
            dx:=-2;dy:=-4;
        | saturne:
            S:="rumrumruuumlumlluuuulmlmdmdrrmrrr";
            dx:=0;dy:=5;
        | uranus:
            S:="LUmLUmLUURmUmRmLRmURRDmRRmDDDLmDLmDUmUmRmLmUmRmLmU"+
               "mRmLmUmRmLmUmRmLmUmLULLLDUmURmRmRRmRmRDDLmULL";
            dx:=0;dy:=4;
        | neptune:
            S:="LUmLUmLUURmUmRmLRmURRDmRRmDDDLmDLmDUmUmRmLmUmRmLmU"+
               "mRmLmUmRmLmUmRmLmUmRUmRULmLmLmLmLmLDDmRRmRUUU";
            dx:=0;dy:=4;
        | pluton:
            S:="LUmLUmLUURmUmRmLRmURRDmRRmDDDLmDLmDUmUmRmLmUmRmLmU"+
               "mRmLmUmRmLmUmRmLmUmLUmLUmLLRmRmRmDmRUmRRR";
            dx:=0;dy:=4;
        | as:
            S:="UUUUUUmRRmDDDDDDLmUmUmRmLmUmRmLRmRmRmRRmDDDmLLmUmRmLU"+
               "mDmUmUmRmLmUmRmLUUmRRmDD";
            dx:=-3;dy:=3;
        | mc:
            S:="UUUUUURmDRmUmRmLDDDDDDRmRmRUmRLmLUUUUUmRRmDD";
            dx:=-3;dy:=3;
        | ds:
            S:="UUUUUURRmDDDDDDmLRmRmUmRDmRUmRUUmLUmLUUmRRmDD";
            dx:=-3;dy:=3;
        | fc:
            S:="UUUUUURRDmDmDmLRmRmRUUUmRRmDDmDmDmDDmLUmLUU";
            dx:=-3;dy:=3;
        | lilith:
            S:="ldllmdrrdlldrrdldmrrddmddlmlmumurrrrd";
            dx:=0;dy:=-5;
        | dragonhead:
            S:="LLmDDDmRLmLRmDUmRmRmRRmDUmRLmUmRmLUUmLU";
            dx:=0;dy:=-2;
        | dragontail:
            S:="LUmLUUmRUmLLmDRmDmDmDmRmRmRUmRUUmLUmRRmDR";
            dx:=0;dy:=2;
        | blacksun:
            S:="dddmruuuuumrddddddruuuuuurmdddddrmuuuu";
            dx:=-2;dy:=-1;
        (* we could probably insert earth here *)
	END;
    | TRUE :
        CASE id OF
        |  soleil:
            S:="UUUUmRUUmRUmRUmRRRmURRRRRRDmRRRmDRmDRmDDDmRDDDDDDDmLDDmLD"+
               "mLDmLLDmLLLLLLLUmLLLmULmULmUUUmLUUUmRmRmRmRmRmRmRmRmRR";
            dx:=-9;dy:=0;
        | lune:
            S:="UUUUmRUUmRUmRUmRRRmURRRRRRDmLDmLDDmLDDDmLDDDDRmDDDDmRDDmRD"+
               "mRLLLLLLUmLLLmUUmLUmLUUmLUUR";
            dx:=-6;dy:=0;
        | mercure:
            S:="UUUmRUmRUmRRRRRDmRDmRDmRDDDDDmLLmDLmDLLLLUmLUmLUmLURmRmRmR"+
               "mRmDmDmDmDmDDDDDLmLmUmUmRmLRRmRRUmUmUmRmLmUmRmLmUmRmLmUmRmL"+
               "mUmRmLmUmRmLmUmRmLmUmRmLmUmRmLmUmRmLmUmRmUUmRUmRUULmLmLmLmL"+
               "mLmLmLmLmLDDDmRDmRD";
            dx:=-5;dy:=0;
        | venus:
            S:="UUUmRUmRUmRRRRRDmRDmRDmRDDDDDmLLmDLmDLLLLUmLUmLUmLURmRmRmR"+
               "mRmDmDmDmDmDDDDDLmLmUmUmRmLRRmRRU";
            dx:=-5;dy:=-2;
        | mars:
            S:="UUUmRUmRUmRRRRRDmRDmRDmRDDDDDmLLmDLmDLLLLUmLUmLUmLUUmUmUmR"+
               "mLmUmRmLmUmRmLmUmRmLmUmRmRmRmRmRUmRUmRUmRUmRUmRLLLLDmRmRmRmRDDDL";
            dx:=-5;dy:=3;
        | jupiter:
            S:="ddddddddrmrmumumumullmlllllllumrmrmrumrumruuuuumlumlumllll";
            dx:=2;dy:=-1;
        | saturne:
            S:="rrrmurmurmuuuuuumlumlumllluuuuuulmlmlmdmdmdrrrrrrr";
            dx:=0;dy:=8;
        | uranus:
            S:="UUUmRUmRUmRRRRRDmRDmRDmRDDDDDmLLmDLmDLLLLUmLUmLUmLUUmRmRmRmR"+
               "mRmUmRmLmUmRmLmUmRmLmUmRmLmUmRmLmUmRmLUUUULmLmLmLmLDDDDRmRmR"+
               "mRmRmRmRmRmRmRUUUULmDmDLLLLmLLLLU";
            dx:=-5;dy:=2;
        | neptune:
            S:="UUUmRUmRUmRRRRRDmRDmRDmRDDDDDmLLmDLmDLLLLUmLUmLUmLUUmUmUmRmL"+
               "mUmRmLmUmRmLmUmRmLmUmRmLmUmRmLmUmRmLUURmRmRmRmRmRmRmRmRmRDDD"+
               "mLDmLLmLmLUUUULmLmLmLmDmDmDDmRR";
            dx:=-5;dy:=2;
        | pluton:
            S:="UUUmRUmRUmRRRRRDmRDmRDmRDDDDDmLLmDLmDLLLLUmLUmLUmLUUmRmRmRmR"+
               "mRmUmRmLmUmRmLmUmRmLmUmRmLmUmRmLmUmRmLUUmLUmLUmLLLDmDmDmDmRmR"+
               "mRmRmRmUmUmRUmRUmRRRD";
            dx:=-5;dy:=2;
        | as:
            S:="UUUUUUUmRUmRDmRDmRDDDDDDLmLmLmUmUmRmLmUmRmLRRRmRmRmRmDDDmRRRRmU"+
               "mRmLUUUmLLLUmLUUUmRRRRmDDD";
            dx:=-5;dy:=4;
        | mc:
            S:="UUUUUUUURmDRmDUmRUmRDDDDDDDDRmRmRmRRRUmRUUmUmUmRmLmUmRmLUUmLLLL"+
               "mDDDDDDDR";
            dx:=-5;dy:=4;
        | ds:
            S:="UUUUUUUURRRRmDDDDDDDLmLmLmDRRRmRmRmRmRRRRmUmRmLUUUmLLLUmLUUU"+
               "mRRRRmDDDmLmLmLmLmDmDmDDD";
            dx:=-5;dy:=4;
        | fc:
            S:="UUUUUUUURRRRDmDmDmDmLLLDmRmRmRmRmRmRUUUURmURRRmDDDmDmDmDDDmLLLUmLUR";
            dx:=-5;dy:=4;
        | lilith:
            S:="rrrrrrdmdmdmlmlmluuumuuulllmurrumllllmurrrumlllurrullurrrullumrrrrmulll";
            dx:=-3;dy:=5;
        | dragonhead:
            S:="UmRRmDDmLUmUmRmLmUmRmLUmRUmRRRRmDRmDDDmRDmLUmLU";
            dx:=-4;dy:=1;
        | dragontail:
            S:="UmRRmDDmLDDmRDmRRRRmUmRmLUmRUUmLUmRRmDD";
            dx:=-4;dy:=-1;
        | blacksun:
            S:="rrrrrmdlllllllmdrrrrrrrrrmdlllllllllldrrrrrrrrrr"+
               "dlllllllllldrrrrrrrrrrdlllllllllldmrrrrrrrrrdmllllllldmrrrrrr";
            dx:=-2;dy:=-5;
        (* we could probably insert earth here *)
        END;
    END;
END getShapeDefObject;

(*
    tweaking with object definition would be possible
    (setting earth after blacksun) but after all... let's not take chance !
    this is for heliocentric display only in CARTE.MOD
    both glyphs based upon soleil glyphs
*)

PROCEDURE getShapeDefEarth (big:BOOLEAN;
                            VAR dx,dy:INTEGER; VAR S : str1024);
BEGIN
    CASE big OF
    | FALSE :
        S:="LLmUUmLUmLUUUURmUmRmLUmRUmRRRRRDmRDmRDmRDDDDDmLLmDLmDLLU"+
           "mUmRmLmUmRmLmUmRmLmUmRmLU"+
           "UUUDmDmDmDmDDDDRmRmRmRmUmUmUmULLLLmLLLLU";
        dx:=-1;dy:=5;
    | TRUE :
        S:="UUUUmRUUmRUmRUmRRRmURRRRRRDmRRRmDRmDRmDDDmRDDDDDDDmLDDmLD"+
           "mLDmLLDmLLLLLLLUmLLLmULmULmUUUmLUUUmRmRmRmRmRmRmRmRmRR"+
           "RRRRRRRRLmLmLmLmLmLmLmLmLmLLLLLLLLU"+
           "mUmUmUmUmUmUmUmRmRmRmRmRmRmRmRDDDDDDDDmDDDDDDDDD";
        dx:=-9;dy:=0;
    END;
END getShapeDefEarth;

PROCEDURE getShapeDefSign (id:signtype;big:BOOLEAN;
                           VAR dx,dy:INTEGER; VAR S : str1024);
BEGIN
    CASE big OF
    | FALSE :
        CASE id OF
        | belier:
             S:="UUUUmLUUUmLUmLLLmDRmRmRmRmRmRmDmDmDUUUmRUmRRRmDU";
             dx:=0;dy:=4;
        | taureau:
             S:="LmUmRmLUmLUmLUUmRUmRRRRmDDmRDDmLDmLUmUmRmLmUmRmLmUmR"+
                "mLmUmRmLmUmRUmRLmLmLmLmLmLRmDU";
             dx:=0;dy:=4;
        | gemeaux :
             S:="LLUUUUUUUULLDmDmDmDmDmDmDmDRRmRmRmRRUUUUUUUULLLRmRmR"+
                "mRRDmDmDmDmDmDmDmDLL";
             dx:=0;dy:=4;
        | cancer   :
             S:="LLUmLLUmLLmUmRmLUmRRmDDmRmRmRmRmRmDRRmUmRmLUmRmDmUmR"+
                "mLmUmRmLUmRUmLmLmDUmRUmLLLmULLLmDLLmDL";
             dx:=1;dy:=4;
        | lion      :
             S:="UUmLUUmLUUmRUmRRRRmDDmRDDmLDDmLDDmRUmRLmLmLmLmLmLDmRD";
             dx:=-1;dy:=3;
        | vierge     :
             S:="UUUUUUUmLLmDRmRmRmURmDDDDDDDRmRUUUUUULmUmRmLDmRmRmUmR"+
                "mLRmDDDDmLDmDmLmLR";
             dx:=-2;dy:=4;
        | balance     :
             S:="LLLLRmRmRmRmRRRRUmULLUUmLLmUmRmLLmDLmDDLLUUmRmRmRmRmRmRmRmRmDD";
             dx:=0;dy:=3;
        | scorpion     :
             S:="UUUUUUUmLLmDRmRmRmURmDDDDDDDRmRUUUUUULmUmRmLDmDmDmDmDmD"+
                "mDmDmRmRRRmUUmRULRmRDDDmLmLmLmLmLmLmLmLmLmLmLmUmUmRmLmU"+
                "mRmLmUmRmLmUmRmLUmLLLmDUmRmRmDmDmRD";
             dx:=-2;dy:=3;
        | sagittaire    :
             S:="UmRUmRUmRUmRUmRUmRUmRLLLLmRmRmRmRmDDDDmLmLmLmDUmLmLmUU";
             dx:=-3;dy:=3;
        | capricorne     :
             S:="UUmRUmRRRmDRmDDDmLLmDLLmUUmLmUmUmLUUmRUmRUmRUmRUmLmLmLmD"+
                "mDLmUmRmLLmDLmRmDmDmDmDmDmDmDmRDD";
             dx:=-1;dy:=2;
        | verseau         :
             S:="UmRUmRRmDRmDRmUmRmLRmURmDDmRUmRUmRUmUmRmLmUmRmLDmLDmLUmLU"+
                "mLLmDLmDUmLUmLDmLDmLD";
             dx:=-5;dy:=3;
        | poissons         :
             S:="UmRRRmURRRmDRRmDUmUmRmLmUmRmLmUmLmLmLmLmDULUmLLLmURmRmRmR"+
                "mRmRmRmRDmLLLmDD";
             dx:=-4;dy:=3;
        END;
    | TRUE :
        CASE id OF
        | belier:
             S:="mRmRmRmRmRmRmRmRmRmRmDmDUUUUUmLUUUmLUmLUmLLLmULLLmDDmLDDDmRD"+
                "mRmRmRmRmRmRmRmRmRmRUUUmRUmRUmRRRmURRRmDDmRDDDmLL";
             dx:=-10;dy:=3;
        | taureau:
             S:="mRmRmRmRmRmRmRmRmRmRmDmDLmUmRmLUmLUmLUUmLUUUmRUmRRRRRRmDRmDDDD"+
                "mLDDmLDmLUmUmRmLmUmRmLmUmRmLmUmRmLmUmRmLmUmRmLmUmRmLmUmRmRRRmU"+
                "mRmLRRmUmRmLRmULmLmLmLmLmLmLmLmLmLmLmLmLmLmLmLRmDRmDRRmDRR";
             dx:=-10;dy:=5 ;
        | gemeaux :
             S:="RRRRRRRRRRRRRRRRRRUmUmRmLmUmRmLmUmRmLmUmRmLmUmRmLmUmRmLmUmRmL"+
                "mUmRmLmUmRmLmUmRmLLLLLLLLLLLLLLLLLLLDmRmRmRmRmRDDDDDDDDDRmRmR"+
                "mRmRmRmRmRUUUUUUUUUL";
             dx:=-9;dy:=6   ;
        | cancer   :
             S:="mRmRmRmRmRmRmRmRmRmRmDmDLLLmUmRmLLLLmULLmUmRmLLmUUmRmRmRmRmR"+
                "mRmRmRmRmRmDmDmDmDmDRUmRRRUmRRUmRUmRUUmLLLmDDDmRUmLmLmLmLmLmL"+
                "mLmLmLmLmLmLmLmLmLmLmUmUmRmLmUmRmLUUmRRRmDDDmLLUmUmUmRmLmUmRRR"+
                "mURRRmURRRRDmRRRDmRRRmDRmDR";
             dx:=-10;dy:=4   ;
        | lion      :
             S:="mRmRmRmRmRmRmRmRmRmUmUmRmLmUmRmLmUmRmLmUmRmLmUmRmLmUmRmLmUmRmL"+
                "mUmRmLmUmRmLLLLmDDmLDmLDDDDDmRDmRDDmLDmLLUmLUmLUUmRRmUmRmLUmRmR"+
                "mRmRmRmRmRmUmUmRmLmUmRmLmUmRmLmUmRmLmUmRmLRDmRDmRDmRDDDDDmLDmLDD"+
                "mRDmRRRmUUmRU";
             dx:=-9;dy:=4     ;
        | vierge     :
             S:="mRmRmRmRmRmRmRmRUUUUUUUUmLUmLLLmDDmLDDDDDDDLmLmLmUmRmLmUmRmLmU"+
                "mRmLmUmRmLmUmRmLmUmRmLmUmRmLmUmRmLmUmRmLRRmDRmRmRmRmRmRmRUmRRR"+
                "mDDmRDDDDDDDUmDmUmUmRmLmUmRmLmUmRmLmUmRmLmUmRmLmUmRmLmUmRUmRR"+
                "mDDmRDDDmLDDmLDmLDmLmLmUmDmDDmLDD";
             dx:=-8;dy:=4      ;
        | balance     :
             S:="RRRRUUUmRUmRUmRRRRRDmRDmRDmRDDRRRRDmUmDmDmDLLLLLLLLLLLLLLLLLLU";
             dx:=-9;dy:=1       ;
        | scorpion     :
             S:="mRmRmRmRmRmRmRmRUUUUUUUUUmLLLmDDDDDDDDDRmRmRmRmRmRUUUUUUUUU"+
                "mLLLmLmLmLmLLLmDDmLDLRmRmDDDmRmRmRmRmRmRmRmRmRmDmDmDmDmRDmRRR"+
                "mLmRmUmRmLUmRUmLRRDDDmLmLmLmLmLmLmLmLmLmLmLmLmLmLmLmLmLmLmUmR"+
                "mLmUmRmLmUmRmLmUmRmLmUmRmLmUmRmLmUmRmLU";
             dx:=-7;dy:=4        ;
        | sagittaire    :
             S:="UmRUmRUmRUmRUmRUmRUmRUmRUmRUmRUmRUmRUmRUmRUmRUmRLLLLLLDmRmRmR"+
                "mRmRmRDDDDDDmDmDmDmDmDmDmLmLmLmLmLmLmUmRmLUmLUmLUmLmLmUUmLUmLU";
             dx:=-8;dy:=8         ;
        | capricorne     :
             S:="mUmUmRmLmUmRmLmUmRmLmUmRmLmUmRmLmUmRmLmUmRmRmRUmRUmRRmDDmRRR"+
                "mDRRUmRRRmURmDmDmDmLmLmUmLDmLDmLLLmDDmLDmLDDDDmRRmDDmRRRRUmRU"+
                "mRUmRUUUmLUmLUmLLLLLmDmLmLLmDLmDLmDDD";
             dx:=-9;dy:=3          ;
        | verseau         :
             S:="UmRUmRUmRUmRDmRDmRDmRDmRUmRUmRUmRUmRDmRDmRDmRDmRUmRUmRUmRUmRU"+
                "mUmRmLmUmRmLmUmRmLmUmRmLDmLDmLDmLDmLUmLUmLUmLUmLDmLDmLDmLDmLU"+
                "mLUmLUmLUmLDmLDmLDmLDmLR";
             dx:=-10;dy:=4          ;
        | poissons         :
             S:="mRmRmRmRmRmRmRmRmRmUmUmRmLmUmRmLmUmRmLUUULLLLmULLLmULLmUmRmLR"+
                "mRmRmRmRmRmRmRmRmRmRmRmRmRmRmRmRmRDmLLLmDLLLmDLLDmDmDmDmRmRmR"+
                "mLLLLLLLDmLLLLmDLLmDRmRmRmRmRmRmRmRmRmRmRmRmRmRmRmRmRmRUmLLLmULLU";
             dx:=-9;dy:=5            ;
        END;
    END;
END getShapeDefSign;

PROCEDURE getShapeDefAspect (id:aspecttype;big:BOOLEAN;
                             VAR dx,dy:INTEGER; VAR S : str1024);
BEGIN
    CASE big OF
    | FALSE :
        CASE id OF
        | conjonction:
            S:="dmldmldmlumllllmdlmddddmrdmrrrrmurmuuuu";
            dx:=4;dy:=-4;
        | opposition:
            S:="llmdddmrrrmuuuumrumrumruuumrrrmdddmllll";
            dx:=-2;dy:=1;
        | carre:
            S:="uuuuuuurrrrrrrdddddddlllllll";
            dx:=-3;dy:=3;
        | trigone:
            S:="rrrrrrrruumluumluumluumldmlddmlddmlddmld";
            dx:=-4;dy:=4;
        | sextile:
            S:="umrumrrddrmrmrumlumluuumrumrdmdmdllllllumumurmdrmdrrrmurmulmlmldd";
            dx:=-3;dy:=3;
        | quinconce : (* ^ *)
            S:="rrrrrrrrdmdmdmdlmulmulmulmllmdlmdlmdr";
            dx:=-4;dy:=-2;
        | semisextile : (* V *)
            S:="rrrrrrrrumumumulmdlmdlmdlmllmulmulmur";
            dx:=-4;dy:=2;
        | semicarre : (* < *)
            S:="umlumlumllmuumrumrumrumrd";
            dx:=2;dy:=4;
        | sesquicarre : (* Q *)
            S:="llluuuuuurrrrrrddddddllumulmdlmdddmmlrrrrr";
            dx:=0;dy:=2;
        END;
    | TRUE :
        CASE id OF
        | conjonction:
            S:="umllllllmdlmdlmddddddmrdmrdmrrrrrrmurmurmuuuuuumluumrumrumrumrd";
            dx:=2;dy:=-3;
        | opposition:
            S:="rmdrrmurmuuumlumlllmdlmddd"+
               "mrmrmrmrmrmumumumuumrumrumrumrumrumr"+
               "rmdrrmurmuuumlumlllmdlmddd";
            dx:=-6;dy:=7;
        | carre:
            S:="dddddddddddddddrrrrrrrrrrrrrrruuuuuuuuuuuuuuulllllllllllllll";
            dx:=-7;dy:=-8;
        | trigone:
            S:="rrrrrrrrrrrrrrrru"+
               "mlumluumluumluumluumluumluumludmlmdddmlddmlddmlddmlddmlddmld";
            dx:=-8;dy:=7;
        | sextile:
            S:="rrrrrrrrrrrrdmlmlmlmlmllllmdlmdlmdlmdlmdrmrmrmrmrmr"+
               "uuuurmrdmrdmrdmrdmrumumumumumumumumumumumu"+
               "lmdlmdlmdlmdlmdlllmulmulmulmulmurmrmrmrmrmrdddddd";
            dx:=-6;dy:=0;
        | quinconce : (* ^ *)
            S:="rrrrrrrrrrrrrrdmdmdmdmdmdmdlmulmulmulmulmulmulmllmdlmdlmdlmdlmdlmdr";
            dx:=-7;dy:=-4;
        | semisextile : (* V *)
            S:="rrrrrrrrrrrrrrumumumumumumulmdlmdlmdlmdlmdlmdlmlumlumlumlumlumlumlr";
            dx:=-7;dy:=4;
        | semicarre : (* < *)
            S:="dmldmldmldmldmldmldmldmldmrdmrdmrdmrdmrdmrdmrdmru";
            dx:=3;dy:=-8;
        | sesquicarre : (* Q *)
            S:="llluuuuuuuuuurrrrrrrrrrddddddddddllllllumumumrmrmrdml"+
               "lmddmdmlmllmdlmdrrrrrrr";
            dx:=-2;dy:=4;
        END;
    END;
END getShapeDefAspect;

PROCEDURE getShapeDefCuspide (id:cuspidetype;big:BOOLEAN;
                              VAR dx,dy:INTEGER; VAR S : str1024);
BEGIN
    CASE big OF
    | FALSE :
        CASE id OF
        | mAS:
            S:="UUU";
            dx:=0;dy:=1;
        | m2:
            S:="UURmRDDD";
            dx:=-1;dy:=1;
        | m3:
            S:="UURmRDDRmRUUU";
            dx:=-2;dy:=1;
        | mFC:
            S:="UURmRDDmRRmUmRmLUU";
            dx:=-2;dy:=1;
        | m5:
            S:="mUURmRDDmLL";
            dx:=-1;dy:=1;
        | m6:
            S:="mUURmRDDmLRmRmRUUR";
            dx:=-2;dy:=1;
        | mDS:
            S:="mUURmRDDmLRmRmRUURmRDDR";
            dx:=-3;dy:=1;
        | m8:
            S:="mUURmRDDmLRmRmRUURmRDDRmRUUL";
            dx:=-4;dy:=1;
        | m9:
            S:="UURmRRmRLmDRmDLmLU";
            dx:=-2;dy:=1;
        | mMC:
            S:="UmUmRmLRmDRmDUmUmRmLL";
            dx:=-1;dy:=1;
        | m11:
            S:="UmUmRmLRmDRmDUmUmRmLLmRmRmRDDR";
            dx:=-2;dy:=1;
        | m12:
            S:="UmUmRmLRmDRmDUmUmRmLLmRmRmRDDRmRUUL";
            dx:=-3;dy:=1;
        END;
    | TRUE :
        CASE id OF
        | mAS:
            S:="UUUUUUR";
            dx:=0;dy:=3;
	    | m2:
            S:="UUUUUURmRmRDDDDDDR";
            dx:=-1;dy:=3;
    	| m3:
            S:="UUUUUURmRmRDDDDDDRmRmRUUUUUUL";
            dx:=-3;dy:=3;
	    | mFC:
            S:="UUUUUURmRmRDDDDDmRDmRUmRUmRUUUUL";
            dx:=-3;dy:=3;
    	| m5:
            S:="mRmRUmLUmLUUUURmRmRmRDDDDDmLL";
            dx:=-2;dy:=3;
        | m6:
            S:="mRmRUmLUmLUUUURmRmRmRDDDDDmLLmDmRmRmRmRmRUUUUUUR";
            dx:=-3;dy:=3;
     	| mDS:
            S:="mRmRUmLUmLUUUURmRmRmRDDDDDmLLmDmRmRmRmRmRUUUUUURmRmRDDDDDDR";
            dx:=-5;dy:=3;
    	| m8:
            S:="mRmRUmLUmLUUUURmRmRmRDDDDDmLLmDmRmRmRmRmRUUUUUURmRmRDDDDDDRmRmRUUUUUUL";
            dx:=-6;dy:=3;
     	| m9:
            S:="UUUUUURmRmRDDmRDmRDmRDmRDLmLmLmLUUmRUmRmUmRRmUmRmLUL";
            dx:=-3;dy:=3;
    	| mMC:
            S:="UUmRUmRUmRUmRULmLmLmLDDmRDmRmDmRDmRDR";
            dx:=-2;dy:=3;
    	| m11:
            S:="UUmRUmRUmRUmRULmLmLmLDDmRDmRmDmRDmRDRmRmRUUUUUUR";
            dx:=-3;dy:=3;
    	| m12:
            S:="UUmRUmRUmRUmRULmLmLmLDDmRDmRmDmRDmRDRmRmRUUUUUURmRmRDDDDDDL";
            dx:=-5;dy:=3;
        END;
    END;
END getShapeDefCuspide;

PROCEDURE getShapeDefChar (id:CHAR;big:BOOLEAN;
                             VAR dx,dy:INTEGER; VAR S : str1024);
BEGIN
    (* 0 1 ... 9 coma dot R (delta is 0 for these -- origin=lower left) *)

    CASE big OF
    | FALSE :
        CASE id OF (* 0..9 origin is from lower left (0-0) but now we take center of 5*2 *)
        | "0" :
            S:="UUUURRDDDDLU";
            dx:=-1;dy:=2;
        | "1" :
            S:="mRUUUUU";
            dx:=-1;dy:=2;
    	| "2" :
            S:="UURRUULLDmDmDmDmRRR";
            dx:=-1;dy:=2;
    	| "3":
            S:="RRUULLUmUmRmLRRDD";
            dx:=-1;dy:=2;
    	| "4":
            S:="mRmRUULLUURmRDD";
            dx:=-1;dy:=2;
    	| "5":
            S:="RRUULLUURRR";
            dx:=-1;dy:=2;
	    | "6":
            S:="UUUURRLmDmDRDDLU";
            dx:=-1;dy:=2;
    	| "7":
            S:="mRmRUUUULLU";
            dx:=-1;dy:=2;
    	| "8":
            S:="UUUURRDDDDLUmUU";
            dx:=-1;dy:=2;
    	| "9":
            S:="mRmRUUUULLDDRDmDLU";
            dx:=-1;dy:=2;
        | coma :
            S:="mRDDmLU";
            dx:=-1;dy:=2;
        | dot:
            S:="mRD";
            dx:=-1;dy:=2;
        | Retro:
            S:="uuurrmddmldmru";
            dx:=-1;dy:=2;
        | sDeg :
            S:="mRmUmURUULLDDR";
            dx:=-1;dy:=2;
        | sMin :
            S:="mRmUmUmUUU";
            dx:=-1;dy:=2;
        | space :
            S:="mR";     (* just move right*)
            dx:=-1;dy:=2;
        | cN :
            S:="UUUURRmDDDDD";
            dx:=-1;dy:=2;
        | cS :                  (* id 5 in 3x5 after all... *)
            S:="RRUULLUURRR";
            dx:=-1;dy:=2;
        | cE :
            S:="UUUURRDmDLDmDRR";
            dx:=-1;dy:=2;
        | cO :                  (* id 0 *)
            S:="UUUURRDDDDLU";
            dx:=-1;dy:=2;
        | cW :
            S:="UUUURmRDDDLRDD";
            dx:=-1;dy:=2;
        | cPlus :
            S:="mUmURRUmLDDD";
            dx:=-1;dy:=2;
        | cMinus:
            S:="mUmURRR";
            dx:=-1;dy:=2;
        END;
    | TRUE :
        CASE id OF   (* 0..9 (was 0-0 but now take center of 7*5) *)
        | "0" :
            S:="mRRRUmRUUUUUmLLLLmDDDDDR";
            dx:=-2;dy:=3;
	    | "1":
            S:="mRRRUmLUUUUULmDD";
            dx:=-2;dy:=3;
     	| "2":
            S:="RRRRUmLmLmLmLUmRUmRRUmRUUmLLLLmDD";
            dx:=-2;dy:=3;
    	| "3":
            S:="mURmDRRUmRUUmLLUmRUmRULLLLD";
            dx:=-2;dy:=3;
    	| "4":
            S:="mRmRmRUURLmLLLUUmRUmRUmRDDDD";
            dx:=-2;dy:=3;
    	| "5":
            S:="mURmDRRUmRUUUmLLLLUURRRRR";
            dx:=-2;dy:=3;
    	| "6":
            S:="mURmDRRUmRUUmLLLLmDUUUmRUmRRRU";
            dx:=-2;dy:=3;
     	| "7":
            S:="mRUUUmRUmRUmRULLLLD";
            dx:=-2;dy:=3;
     	| "8":
            S:="mRRRUmRUUmLLLUmLUUmRRRRmDDDmLmLmLmLmDDD";
            dx:=-2;dy:=3;
    	| "9":
            S:="RRRmUmRmLUmRUUUUmLLLLmDDDmRRRU";
            dx:=-2;dy:=3;
    	| coma:
            S:="mRmRmUDDmLD";
            dx:=-2;dy:=3;
    	| dot:
            S:="mRmRD";
            dx:=-2;dy:=3;
        | Retro:
            S:="uuuurrrmddmlldmrmrdd";
            dx:=-2;dy:=3;
        | sDeg :
            (* S:="mRmRmUmUmUmURUULLDDR"; too square *)
            S:="mRmRmUmUmUmURmUUmLLmDD";
            dx:=-2;dy:=3;
        | sMin :
            S:="mRmRmUmUmUmUUUU";
            dx:=-2;dy:=3;
        | space :
            S:="mR";     (* just move right*)
            dx:=-2;dy:=3;
        | cN :
            S:="UUUUUURmDmDRmDRmDDmDmRUUUUUUL";
            dx:=-2;dy:=3;
        | cS :
            S:="RRRRUUULLLLUUURRRRD";
            dx:=-2;dy:=3;
        | cE :
            S:="RRRRUmUmULLLLUUURRRRDmDmDmDmLmLmLmLDD";
            dx:=-2;dy:=3;
        | cO :
            S:="RRRRUUUUUULLLLDDDDDD";
            dx:=-2;dy:=3;
        | cW :
            S:="mUUUUUURmRmRmRDDDDDDmLUmUmLDDmLL";
            dx:=-2;dy:=3;
        | cPlus :
            S:="mUmUmURRRRUmUmLmLDDDDD";
            dx:=-2;dy:=3;
        | cMinus:
            S:="mUmUmURRRRU";
            dx:=-2;dy:=3;
        END;
    END;
END getShapeDefChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE getShapeData ( n:CARDINAL;VAR dx,dy:INTEGER;
                         VAR IDFR,ID,IDENG : str16; VAR S : str1024  );
(* 0 1 ... 9 , . R : delta is 0 for these, origin=lower left *)
(* keep order of structure enumerations in qd_calc and qd_names *)
CONST
    T="Soleil,Lune,Mercure,Vnus,Mars,Jupiter,Saturne,Uranus,Neptune,Pluton,"+
          "Ascendant,Milieu du Ciel,Descendant,Fond du Ciel,"+
          "Lilith,Tte du Dragon,Queue du Dragon,Soleil Noir,"+
      "Terre,"+
      "Blier,Taureau,Gmeaux,Cancer,Lion,Vierge,"+
          "Balance,Scorpion,Sagittaire,Capricorne,Verseau,Poissons,"+
      "Conjonction,Opposition,Carr,Trigone,Sextile,"+
          "Semi-Carr,Semi-Sextile,Quinconce,Sesqui-Carr,"+
      "i,ii,iii,iv,v,vi,vii,viii,ix,x,xi,xii,"+
      "0,1,2,3,4,5,6,7,8,9,"+
      "virgule,point,rtrograde,degr,minute,espace,"+
          "nord,sud,est,ouest,west,plus,moins";

    Z="soleil,lune,mercure,venus,mars,jupiter,saturne,uranus,neptune,pluton,"+
          "as,mc,ds,fc,lilith,"+
          "dragonhead,dragontail,blacksun,"+
      "earth,"+
      "belier,taureau,gemeaux,cancer,lion,vierge,"+
          "balance,scorpion,sagittaire,capricorne,verseau,poissons,"+
      "conjonction,opposition,carre,trigone,sextile,"+
          "semicarre,semisextile,quinconce,sesquicarre,"+
      "mAS,m2,m3,mFC,m5,m6,mDS,m8,m9,mMC,m11,m12,"+
      "0,1,2,3,4,5,6,7,8,9,"+
      "coma,dot,Retro,sDeg,sMin,space,"+
          "cN,cS,cE,cO,cW,cPlus,cMinus";

    E="Sun,Moon,Mercury,Venus,Mars,Jupiter,Saturn,Uranus,Neptune,Pluto,"+
          "Ascendant,Midheaven,Descendant,Nadir,"+
          "Lilith,North Node,South Node,Black Sun,"+
      "Earth,"+
      "Aries,Taurus,Gemini,Cancer,Leo,Virgo,"+
          "Libra,Scorpio,Sagittarius,Capricorn,Aquarius,Pisces,"+
      "Conjunction,Opposition,Square,Trine,Sextile,"+
          "Semisquare,Semisextile,Quincunx,Sesquiquadrate,"+
      "i,ii,iii,iv,v,vi,vii,viii,ix,x,xi,xii,"+
      "0,1,2,3,4,5,6,7,8,9,"+
      "virgule,point,rtrograde,degr,minute,espace,"+
          "North,South,East,West,West,plus,minus";
VAR
    big : BOOLEAN;
BEGIN
    IF n > countshape THEN
        big:=TRUE;
        DEC(n,countshape);
    ELSE
        big:=FALSE;
    END;
    isoleItemS( IDFR , T , "," , n-1 ); (* we do need a 0-based value *)
    isoleItemS( ID   , Z , "," , n-1 ); (* we do need a 0-based value *)
    isoleItemS( IDENG, E , "," , n-1 ); (* we do need a 0-based value *)
    CASE n OF
    |  1 : getShapeDefObject (soleil        ,big,dx,dy,S);
    |  2 : getShapeDefObject (lune          ,big,dx,dy,S);
    |  3 : getShapeDefObject (mercure       ,big,dx,dy,S);
    |  4 : getShapeDefObject (venus         ,big,dx,dy,S);
    |  5 : getShapeDefObject (mars          ,big,dx,dy,S);
    |  6 : getShapeDefObject (jupiter       ,big,dx,dy,S);
    |  7 : getShapeDefObject (saturne       ,big,dx,dy,S);
    |  8 : getShapeDefObject (uranus        ,big,dx,dy,S);
    |  9 : getShapeDefObject (neptune       ,big,dx,dy,S);
    | 10 : getShapeDefObject (pluton        ,big,dx,dy,S);
    | 11 : getShapeDefObject (as            ,big,dx,dy,S);
    | 12 : getShapeDefObject (mc            ,big,dx,dy,S);
    | 13 : getShapeDefObject (ds            ,big,dx,dy,S);
    | 14 : getShapeDefObject (fc            ,big,dx,dy,S);
    | 15 : getShapeDefObject (lilith        ,big,dx,dy,S);
    | 16 : getShapeDefObject (dragonhead    ,big,dx,dy,S);
    | 17 : getShapeDefObject (dragontail    ,big,dx,dy,S);
    | 18 : getShapeDefObject (blacksun      ,big,dx,dy,S);
    | 19 : getShapeDefEarth  (               big,dx,dy,S);
    | 20 : getShapeDefSign   (belier       ,big,dx,dy,S);
    | 21 : getShapeDefSign   (taureau      ,big,dx,dy,S);
    | 22 : getShapeDefSign   (gemeaux      ,big,dx,dy,S);
    | 23 : getShapeDefSign   (cancer       ,big,dx,dy,S);
    | 24 : getShapeDefSign   (lion         ,big,dx,dy,S);
    | 25 : getShapeDefSign   (vierge       ,big,dx,dy,S);
    | 26 : getShapeDefSign   (balance      ,big,dx,dy,S);
    | 27 : getShapeDefSign   (scorpion     ,big,dx,dy,S);
    | 28 : getShapeDefSign   (sagittaire   ,big,dx,dy,S);
    | 29 : getShapeDefSign   (capricorne   ,big,dx,dy,S);
    | 30 : getShapeDefSign   (verseau      ,big,dx,dy,S);
    | 31 : getShapeDefSign   (poissons     ,big,dx,dy,S);
    | 32 : getShapeDefAspect (conjonction   ,big,dx,dy,S);
    | 33 : getShapeDefAspect (opposition    ,big,dx,dy,S);
    | 34 : getShapeDefAspect (carre         ,big,dx,dy,S);
    | 35 : getShapeDefAspect (trigone       ,big,dx,dy,S);
    | 36 : getShapeDefAspect (sextile       ,big,dx,dy,S);
    | 37 : getShapeDefAspect (semicarre     ,big,dx,dy,S);
    | 38 : getShapeDefAspect (semisextile   ,big,dx,dy,S);
    | 39 : getShapeDefAspect (quinconce     ,big,dx,dy,S);
    | 40 : getShapeDefAspect (sesquicarre   ,big,dx,dy,S);
    | 41 : getShapeDefCuspide (mAS          ,big,dx,dy,S);
    | 42 : getShapeDefCuspide (m2           ,big,dx,dy,S);
    | 43 : getShapeDefCuspide (m3           ,big,dx,dy,S);
    | 44 : getShapeDefCuspide (mFC          ,big,dx,dy,S);
    | 45 : getShapeDefCuspide (m5           ,big,dx,dy,S);
    | 46 : getShapeDefCuspide (m6           ,big,dx,dy,S);
    | 47 : getShapeDefCuspide (mDS          ,big,dx,dy,S);
    | 48 : getShapeDefCuspide (m8           ,big,dx,dy,S);
    | 49 : getShapeDefCuspide (m9           ,big,dx,dy,S);
    | 50 : getShapeDefCuspide (mMC          ,big,dx,dy,S);
    | 51 : getShapeDefCuspide (m11          ,big,dx,dy,S);
    | 52 : getShapeDefCuspide (m12          ,big,dx,dy,S);
    | 53 : getShapeDefChar   ("0"           ,big,dx,dy,S);
    | 54 : getShapeDefChar   ("1"           ,big,dx,dy,S);
    | 55 : getShapeDefChar   ("2"           ,big,dx,dy,S);
    | 56 : getShapeDefChar   ("3"           ,big,dx,dy,S);
    | 57 : getShapeDefChar   ("4"           ,big,dx,dy,S);
    | 58 : getShapeDefChar   ("5"           ,big,dx,dy,S);
    | 59 : getShapeDefChar   ("6"           ,big,dx,dy,S);
    | 60 : getShapeDefChar   ("7"           ,big,dx,dy,S);
    | 61 : getShapeDefChar   ("8"           ,big,dx,dy,S);
    | 62 : getShapeDefChar   ("9"           ,big,dx,dy,S);
    | 63 : getShapeDefChar   (","           ,big,dx,dy,S);
    | 64 : getShapeDefChar   ("."           ,big,dx,dy,S);
    | 65 : getShapeDefChar   ("R"           ,big,dx,dy,S);
    | 66 : getShapeDefChar   (""           ,big,dx,dy,S);
    | 67 : getShapeDefChar   ("'"           ,big,dx,dy,S);
    | 68 : getShapeDefChar   (" "           ,big,dx,dy,S);
    | 69 : getShapeDefChar   ("N"           ,big,dx,dy,S);
    | 70 : getShapeDefChar   ("S"           ,big,dx,dy,S);
    | 71 : getShapeDefChar   ("E"           ,big,dx,dy,S);
    | 72 : getShapeDefChar   ("O"           ,big,dx,dy,S);
    | 73 : getShapeDefChar   ("W"           ,big,dx,dy,S);
    | 74 : getShapeDefChar   ("+"           ,big,dx,dy,S);
    | 75 : getShapeDefChar   ("-"           ,big,dx,dy,S);
    END;
END getShapeData;

CONST
    ofsBody  = 1; countBody  =10;
    ofsFict  =11; countFict  = 9;
    ofsEarth =19; countEarth = 1;
    ofsSign  =20; countSign  =12;
    ofsAspect=32; countAspect= 9;
    ofsCusp  =41; countCusp  =12;
    ofsDigit =53; countDigit =10;
    ofsChar  =63; countChar  =13;

(* adapted from plotshape() in qd_glyph *)

PROCEDURE showshape (slow:BOOLEAN; x,y:INTEGER;ink:CARDINAL;
                     dotsize,deltax,deltay:INTEGER;S:str1024);
VAR
    plotmode:BOOLEAN;
    cmd:CARDINAL;
    t:CHAR;
    ix,iy:INTEGER;
BEGIN
    x:=x+deltax*dotsize;
    y:=y+deltay*dotsize;
    plotmode:=TRUE;
    FOR cmd:=1 TO Str.Length(S) DO
	    t:=S[cmd-1];
	    t:=CAP(t);
	    IF t="M" THEN plotmode:=FALSE; END; (* move *)
	    IF plotmode THEN
            FOR ix:=1 TO dotsize DO
		        FOR iy:=1 TO dotsize DO
		            pset (x+ix-1,y+iy-1,ink);
               	END;
	        END;
    	    IF slow THEN Lib.Delay(100);END;
    	END;
	    CASE t OF
	    | "D" : (* down *)
	        INC(y,dotsize);
	    | "U" : (* up *)
	        DEC(y,dotsize);
	    | "R" : (* right *)
            INC(x,dotsize);
	    | "L" : (* left *)
	        DEC(x,dotsize);
    	END;
	    IF t # "M" THEN plotmode:=TRUE; END;
    END;
END showshape;

PROCEDURE showrange (offs:CARDINAL;slow:BOOLEAN;VAR x,y:INTEGER;
                     shape,inkshape,dotsize,count,wi,he,inkframe,pattern:CARDINAL  );
VAR
    i:CARDINAL;
    shapeDef:str1024;
    half,dx,dy:INTEGER;
    shapeName,shapeCodeName,shapeNameEng:str16;
BEGIN
    IF offs=0 THEN
	    half:=16 DIV 2;
    ELSE
	    half:=32 DIV 2;
    END;
    FOR i := 1 TO count DO
        getShapeData(shape+offs,dx,dy,shapeName,shapeCodeName,shapeNameEng,shapeDef);
        (* showshape (slow, x,y,inkshape,dotsize,dx,dy,shapeDef); *)
        showshape    (slow, x,y,inkshape,dotsize,dx+ofsx[shape+offs],dy+ofsy[shape+offs],shapeDef);
	    GrBox (x-half,y-half,x+half,y+half,inkframe,pattern);
        INC(shape);
    	INC(x, INTEGER(wi) );
    	INC(y, INTEGER(he) );
    END;
END showrange;

CONST
    minhtab = 1;
    minvtab = 1;
    filled  = "X";
    empty   = " ";
    blocked = CHR(249);

PROCEDURE saverange (hout:FIO.File;inkshape,dotsize:CARDINAL;slowmode:BOOLEAN;
                     org,count:CARDINAL );
VAR
    n,i,ndx,htab,vtab,xx,yy,ink,matrix:CARDINAL;
    dx,dy,zcx,zcy,px,py:INTEGER;
    shapeName,shapeCodeName,shapeNameEng,strucid,strucopen,strucclose:str16;
    shapeDef:str1024;
    S:str128;
BEGIN
    htab:=minhtab;
    vtab:=minvtab;

    zcx:=INTEGER(cx);
    zcy:=INTEGER(cy);
    FOR n:=1 TO 2 DO
        FOR i:=1 TO count DO
            clearscreen(inkpaper);
            Str.Concat(S,lstfile," en cours de sauvegarde");Str.Append(S,", veuillez patienter...");
            prS(vtab,htab,S);
            CASE n OF
            | 1 : ndx:=(org+i-1);
            | 2 : ndx:=(org+i-1) + countshape;
            END;
            getShapeData(ndx,dx,dy,shapeName,shapeCodeName,shapeNameEng,shapeDef);
            showshape (slowmode, zcx,zcy,inkshape,dotsize,dx+ofsx[ndx],dy+ofsy[ndx],shapeDef);
     		IF ndx > countshape THEN
        	    matrix:=32; strucid:="shape32x32";strucopen:="(";
            ELSE
             	matrix:=16; strucid:="shape16x16";strucopen:="(";
            END;
            strucclose:=")";

            Str.Concat(S,"; glyphe : ",card2str(i));
            wr(hout, S);wrln(hout);
            Str.Concat(S,"; nom    : ",shapeName);
            wr(hout, S);wrln(hout);
            Str.Concat(S,"; id     : ",shapeCodeName);
            wr(hout, S);wrln(hout);
            wrln(hout);
            wr(hout, strucid);wrln(hout);
            wr(hout, strucopen);wrln(hout);
            FOR yy:=1 TO matrix DO
                py:=cy-(matrix DIV 2) +yy;
                S :=dquote;
        	    FOR xx:=1 TO matrix DO
                    px:=cx-(matrix DIV 2)+xx;
                    ink:=GrPoint(px,py);
                    IF ink=inkshape THEN
                	    Str.Append(S,filled);
                    ELSE
                        Str.Append(S,empty);
                    END;
                END;
                Str.Append(S,dquote); (* IF yy< matrix THEN Str.Append(S,"+");END; *)
                wr(hout, S);wrln(hout);
            END;
            wr(hout, strucclose);wrln(hout);
            wrln(hout);
        END;
    END;
END saverange;

PROCEDURE getShapeDim (S:str1024;VAR shw,shh:CARDINAL) ;
VAR
    plotmode:BOOLEAN;
    cmd:CARDINAL;
    t:CHAR;
    x,y,minx,maxx,miny,maxy,currx,curry:INTEGER;
BEGIN
    minx:=0;
    maxx:=0;
    miny:=0;
    maxy:=0;
    currx:=0;
    curry:=0;
    x:= INTEGER(cx);
    y:= INTEGER(cy);
    plotmode:=TRUE;
    FOR cmd:=1 TO Str.Length(S) DO
	    t:=S[cmd-1];
	    t:=CAP(t);
	    IF t="M" THEN plotmode:=FALSE; END; (* move *)
	    IF plotmode THEN
            IF currx<minx  THEN minx:=currx;END;
            IF currx>maxx  THEN maxx:=currx;END;
            IF curry<miny  THEN miny:=curry;END;
            IF curry>maxy  THEN maxy:=curry;END;
    	END;
	    CASE t OF
	    | "D" : (* down *)
	        INC(y);
            INC(curry);
	    | "U" : (* up *)
	        DEC(y);
            DEC(curry);
	    | "R" : (* right *)
            INC(x);
            INC(currx);
	    | "L" : (* left *)
	        DEC(x);
            DEC(currx);
    	END;
	    IF t # "M" THEN plotmode:=TRUE; END;
    END;
    shw:=CARDINAL(maxx-minx+1);
    shh:=CARDINAL(maxy-miny+1);
END getShapeDim;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE doGlyphs (dotsize:INTEGER ):BOOLEAN ;
CONST
    k       = 16;
    w       = 2;
VAR
    i,j,n,htab,vtab,shw,shh: CARDINAL;
    c1,c2     : CHAR;
    loopstate : (continue,waitcmd,quit);
    zcx,zcy,dx,dy,x,y,r,rm,rp : INTEGER;
    shapeName,shapeCodeName,shapeNameEng : str16;
    shapeDef  : str1024;
    ok,slowmode,shifted  : BOOLEAN;
    S,R : str128;
    wx,wy, orgx,  yplus:INTEGER;
    ofs,matrix,xx,yy,px,py,ink:CARDINAL;
    strucid,strucopen,strucclose,hex:str16;
    bits : LONGCARD;
    wiframe:INTEGER;
    hout:FIO.File;
BEGIN
    yplus:=0;

    (* required ! *)
    FOR i:= firstshape TO lastshape DO
        ofsx[i] := 0;
        ofsy[i] := 0;
    END;

    zcx := INTEGER(cx);
    zcy := INTEGER(cy);
    ok:=GrWrapon(FALSE);
    i:=GrSetTextColor(inktext);

    slowmode := FALSE;

    i := firstshape;
    BiosFlushkey();
    LOOP
        getShapeData(i,dx,dy,shapeName,shapeCodeName,shapeNameEng,shapeDef);
        getShapeDim(shapeDef,shw,shh);
        LOOP
            clearscreen(inkpaper);
            htab:=minhtab;
            vtab:=minvtab;
            wrS(vtab,htab,shapeName);
            INC(vtab);
            wrS(vtab,htab,shapeCodeName);
            INC(vtab);
            Str.Concat(S,"# ",card2str(i));
            Str.Append(S," / ");
            Str.Append(S,card2str(lastshape));
            wrS(vtab,htab,S);
            INC(vtab);
            wrS(vtab,htab,"ijkl    : position");
            wrS(vtab,htab,"+n$     : suivant");
            wrS(vtab,htab,"-p*     : prcdent");
            wrS(vtab,htab,"q       : quitter");
            wrS(vtab,htab,"c       : continuer");
            Str.Copy(S,   "espace  : vitesse ");
            IF slowmode THEN
                Str.Append(S,"rapide");
            ELSE
                Str.Append(S,"lente");
            END;
            wrS(vtab,htab,S);
            INC(vtab);

            Str.Concat(S, "largeur = ",card2str(shw));
            wrS(vtab,htab,S);
            Str.Concat(S, "hauteur = ",card2str(shh));
            wrS(vtab,htab,S);
            INC(vtab);

            Str.Concat(S, "orgdx   = ",int2str(dx));
            wrS(vtab,htab,S);
            Str.Concat(S, "orgdy   = ",int2str(dy));
            wrS(vtab,htab,S);
            INC(vtab);
            Str.Concat(S, "currdx  = ",int2str(dx+ofsx[i]));
            wrS(vtab,htab,S);
            Str.Concat(S, "currdy  = ",int2str(dy+ofsy[i]));
            wrS(vtab,htab,S);

            (* very light grid at 1 intervals *)
            r := dotsize;
            LOOP
          	    GrBox (zcx-r , zcy-r , zcx+r+dotsize , zcy+r+dotsize ,inkline,patVeryLight);
          	    INC (r, dotsize);
          	    IF r > k*dotsize THEN EXIT; END;
            END;

            (* heavy grid at dotsize intervals *)

            r := w * dotsize;
            LOOP
          	    GrBox (zcx-r , zcy-r , zcx+r+dotsize , zcy+r+dotsize ,inkline,patSolid);
          	    INC (r, w * dotsize);
          	    IF r > k*dotsize THEN EXIT; END;
            END;
            rm:= k * dotsize;
            rp:=rm + dotsize;

       	    GrLine (zcx-rm      , zcy         , zcx+rp      , zcy         ,inkline,patSolid);
            GrLine (zcx-rm      , zcy+dotsize , zcx+rp      , zcy+dotsize ,inkline,patSolid);
       	    GrLine (zcx         , zcy-rm      , zcx         , zcy+rp      ,inkline,patSolid);
            GrLine (zcx+dotsize , zcy-rm      , zcx+dotsize , zcy+rp      ,inkline,patSolid);


            (* //FIX show limits 16x16 and 32x32 *)

            IF i > countshape THEN
                wiframe:=16;
            ELSE
                wiframe:=8;
            END;
            wiframe:=wiframe * dotsize;
            GrLine(zcx-wiframe+dotsize,zcy-wiframe+dotsize,zcx-wiframe+dotsize,zcy+wiframe+dotsize,inklimit,patLight);
            GrLine(zcx-wiframe+dotsize,zcy-wiframe+dotsize,zcx+wiframe+dotsize,zcy-wiframe+dotsize,inklimit,patLight);

            x:=zcx+dotsize*(dx+ofsx[i]);
            y:=zcy+dotsize*(dy+ofsy[i]);
            (* showshape (slowmode, x,y,inkshape,dotsize,0,0,shapeDef); *)
            showshape (slowmode, zcx,zcy,inkshape,dotsize,dx+ofsx[i],dy+ofsy[i],shapeDef);
            loopstate:=continue;
            BiosWaitkeyShifted(c1,c2,shifted);
            c1:=CAP(c1);
            CASE c1 OF
            | "+","N","$","",CHR(13) :
                    n:=1;IF shifted THEN n:=10;END;
                    FOR j:=1 TO n DO
                        INC(i);IF i > lastshape THEN i:=firstshape;END;
                    END;
            | "-","P","*","" :
                    n:=1;IF shifted THEN n:=10;END;
                    FOR j:=1 TO n DO
                        DEC(i);IF i < firstshape THEN i:=lastshape;END;
                    END;
            | "L" :     INC(ofsx[i]);
            | "J" :     DEC(ofsx[i]);
            | "I" :     DEC(ofsy[i]);
            | "K" :     INC(ofsy[i]);
            | " " :     slowmode := NOT(slowmode);
            | "Q",CHR(27) :     RETURN FALSE ;
            | "C" :
                        loopstate:=quit;
            | CHR(0) :
                CASE c2 OF
                | CHR(77) : INC(ofsx[i]); (* right *)
                | CHR(75) : DEC(ofsx[i]); (* left *)
                | CHR(72) : DEC(ofsy[i]); (* up *)
                | CHR(80) : INC(ofsy[i]); (* down *)
                ELSE
                    sound(55,50);
                    BiosFlushkey();
                    loopstate:=waitcmd;
                END;
            ELSE
                sound(55,50);
                BiosFlushkey();
                loopstate:=waitcmd;
            END;
            IF loopstate # waitcmd THEN EXIT; END;
        END;
        IF loopstate = quit THEN EXIT; END;
    END;

    (* show all shapes *)
    dotsize:=1;
    slowmode:=FALSE;
    clearscreen(inkpaper);
    htab:=minhtab;
    vtab:=minvtab;
    wrS(vtab,htab,"q : quitter");
    wrS(vtab,htab,"s : sauvegarder les fichiers "+basefile+".*");

    wy:=32;
    FOR i:=1 TO 2 DO
	    CASE i OF
        | 1 : wx:=16 ; orgx:=wx DIV 2;         ofs:=0;
        | 2 : wx:=32 ; orgx:=16*13+wx DIV 2+8; ofs:=countshape;
        END;
	    x:=orgx;
	    y:=64+wy DIV 2; (* take two lines of text into account, was 100+ *)

	    showrange (ofs,slowmode,x,y,ofsBody,inkshape,dotsize,countBody,wx,yplus,inkline,patSolid);
 	    INC( y,wy);
	    x:=orgx;

	    showrange (ofs,slowmode,x,y,ofsFict,inkshape,dotsize,countFict,wx,yplus,inkline,patSolid);
 	    INC( y,wy);
	    x:=orgx;
	
	    showrange (ofs,slowmode,x,y,ofsSign,inkshape,dotsize,countSign,wx,yplus,inkline,patSolid);
 	    INC( y,wy);
	    x:=orgx;

	    showrange (ofs,slowmode,x,y,ofsAspect,inkshape,dotsize,countAspect,wx,yplus,inkline,patSolid);
 	    INC( y,wy);
	    x:=orgx;

	    showrange (ofs,slowmode,x,y,ofsCusp,inkshape,dotsize,countCusp,wx,yplus,inkline,patSolid);
 	    INC( y,wy);
	    x:=orgx;

	    showrange (ofs,slowmode,x,y,ofsDigit,inkshape,dotsize,countDigit,wx,yplus,inkline,patSolid);
 	    INC( y,wy);
	    x:=orgx;

	    showrange (ofs,slowmode,x,y,ofsChar,inkshape,dotsize,countChar,wx,yplus,inkline,patSolid);
 	    INC( y,wy);
	    x:=orgx;

    END;

    BiosFlushkey();
    LOOP
        BiosWaitkey(c1,c2);
        c1:=CAP(c1);
        CASE c1 OF
        | "Q",CHR(27) : RETURN FALSE;
        | "S" : EXIT;
        ELSE
            sound(55,50);
            BiosFlushkey();
            loopstate:=waitcmd;
        END;
    END;

    (* dump infos *)

    hout:=FIO.Create(infofile);
    FIO.AssignBuffer(hout,ioBufferOut);
    Str.Copy(R,"index");xpad(R,8);   Str.Copy(S,R);
    Str.Copy(R,"id");xpad(R,16);      Str.Append(S,R);
    Str.Copy(R,"idcode");xpad(R,16);  Str.Append(S,R);
    Str.Copy(R,"width");xpad(R,8);   Str.Append(S,R);
    Str.Copy(R,"height");xpad(R,8);  Str.Append(S,R);
    Str.Copy(R,"deltax");xpad(R,8);  Str.Append(S,R);
    Str.Copy(R,"deltay");xpad(R,8);  Str.Append(S,R);
    wr(hout, S);wrln(hout);
    FOR i:=firstshape TO lastshape DO
        getShapeData(i,dx,dy,shapeName,shapeCodeName,shapeNameEng,shapeDef);
        getShapeDim(shapeDef,shw,shh);
        Str.Copy(R,card2str(i));xpad(R,8);        Str.Copy(S,R);
        Str.Copy(R,shapeName);xpad(R,16);          Str.Append(S,R);
        Str.Copy(R,shapeCodeName);xpad(R,16);      Str.Append(S,R);
        Str.Copy(R,card2str(shw));xpad(R,8);      Str.Append(S,R);
        Str.Copy(R,card2str(shh));xpad(R,8);      Str.Append(S,R);
	    Str.Copy(R,int2str(dx+ofsx[i]));xpad(R,8);Str.Append(S,R);
        Str.Copy(R,int2str(dy+ofsy[i]));xpad(R,8);Str.Append(S,R);
        wr(hout, S);wrln(hout);
    END;
    FIO.Flush(hout);
    FIO.Close(hout);

    (* dump bitmaps in asc raw format *)

    dotsize:=1;
    slowmode:=FALSE;
    htab:=minhtab;
    vtab:=minvtab;

    hout:=FIO.Create(ascfile);
    FIO.AssignBuffer(hout,ioBufferOut);
    FOR i:=firstshape TO lastshape DO
        clearscreen(inkpaper);
        Str.Concat(S,ascfile," en cour de sauvegarde");Str.Append(S,", veuillez patienter...");
        prS(vtab,htab,S);

        getShapeData(i,dx,dy,shapeName,shapeCodeName,shapeNameEng,shapeDef);
        showshape (slowmode, zcx,zcy,inkshape,dotsize,dx+ofsx[i],dy+ofsy[i],shapeDef);
		IF i > countshape THEN
        	matrix:=32; strucid:="shape32x32";strucopen:="(";
        ELSE
         	matrix:=16; strucid:="shape16x16";strucopen:="(";
        END;
        strucclose:=")";

        Str.Concat(S,"; glyphe : ",card2str(i));
        wr(hout, S);wrln(hout);
        Str.Concat(S,"; nom    : ",shapeName);
        wr(hout, S);wrln(hout);
        Str.Concat(S,"; id     : ",shapeCodeName);
        wr(hout, S);wrln(hout);
        wrln(hout);
        wr(hout, strucid);wrln(hout);
        wr(hout, strucopen);wrln(hout);
        FOR yy:=1 TO matrix DO
            py:=cy-(matrix DIV 2) +yy;
            S :=dquote;
        	FOR xx:=1 TO matrix DO
                px:=cx-(matrix DIV 2)+xx;
                ink:=GrPoint(px,py);
                IF ink=inkshape THEN
                	Str.Append(S,filled);
                ELSE
                    Str.Append(S,empty);
                END;
            END;
            Str.Append(S,dquote); (* IF yy< matrix THEN Str.Append(S,"+");END; *)
            wr(hout, S);wrln(hout);
        END;
        wr(hout, strucclose);wrln(hout);
        wrln(hout);
    END;

    FIO.Flush(hout);
    FIO.Close(hout);

    (* dump bitmaps in lst format ready to generate a .M2 file later *)

    dotsize:=1;
    slowmode:=FALSE;
    htab:=minhtab;
    vtab:=minvtab;

    hout:=FIO.Create(lstfile);
    FIO.AssignBuffer(hout,ioBufferOut);

    saverange(hout,inkshape,dotsize,slowmode,ofsSign,countSign);
    saverange(hout,inkshape,dotsize,slowmode,ofsBody,countBody+countFict-countEarth);
    saverange(hout,inkshape,dotsize,slowmode,ofsAspect,countAspect);
    saverange(hout,inkshape,dotsize,slowmode,ofsDigit,countDigit+countChar);
    saverange(hout,inkshape,dotsize,slowmode,ofsCusp,countCusp);
    saverange(hout,inkshape,dotsize,slowmode,ofsEarth,countEarth);

    FIO.Flush(hout);
    FIO.Close(hout);

    RETURN TRUE;
END doGlyphs;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

VAR
    S,R:str128;
    i,opt,parmcount:CARDINAL;
    state:(waiting,gotparm);
    lc:LONGCARD;
    ok:BOOLEAN;
    resolution : restype;
BEGIN
    Lib.DisableBreakCheck();
    FIO.IOcheck:=FALSE;
    WrLn;

    state:=waiting;

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,""); END;
    FOR i:=1 TO parmcount DO
        Lib.ParamStr(R, i ); cleantabs(R); (* fix "Yet Another Topspeed Bug" ! *)
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R, "?"+delim+"H"+delim+"HELP"
                              );
            CASE opt OF
            | 1,2,3 : abort(errHelp,"");
            ELSE
                abort(1,exe+" : Option imprvue !");
            END;
        ELSE
            CASE state OF
            | waiting: Str.Copy(S,R);
            | gotparm: abort(2,exe+" : Trop de paramtres !");
            END;
            INC(state);
        END;
    END;
    IF state = waiting THEN abort(0,"");END;

    lc:=Str.StrToCard(S,10,ok);
    IF ok=FALSE THEN abort(3,exe+" : La <taille du point> est illgale !");END;
    IF (lc < mindotsize) OR (lc > maxdotsize) THEN
        abort(4,exe+" : La <taille du point> doit appartenir  'intervalle "+strdotsizerange+" !");
    END;

    resolution := res640x480;
    initHGR(resolution);
    IF VGAhere()=FALSE THEN abort(5,exe+" : Une carte VGA est indispensable !");END;
    IF HiresOn()=FALSE THEN abort(6,exe+" : Impossible d'initialiser le mode graphique !");END;
    FixPalette(); (* very important if reverse video is to work !!! *)
    ok:=doGlyphs( INTEGER(lc) );
    IF TextOn()=FALSE THEN abort(7,exe+" : Impossible de rtablir le mode texte !"); END;
    IF ok THEN
        WrStr("::: Cration des fichiers "+infofile+", "+ascfile+" et "+lstfile+".");WrLn;
    END;
    abort(errNone,"");
END Glyphes.

