(* ---------------------------------------------------------------
Title         see help
Overview      see help
Usage         see help
Notes         as usual
              remember ModeX library requires LARGE model
              remember modex.obj must be specified in project !
Bugs
Wish List     gamma and brightness using code from AOEPAL ?
              speed improvement ? ah ah...
              force border to black without using PICLAB ?

--------------------------------------------------------------- *)

MODULE Movie;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT IO;
IMPORT MsMouse;
IMPORT SYSTEM;

FROM IO IMPORT WrStr,WrLn;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory, qdSplitAllPath,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs,
completedInit, completedShow, completedSHOW, completedEnd, completed;

FROM ModeX IMPORT
Mode_320x200,Mode_320x400,Mode_360x200,Mode_360x400,
Mode_320x240,Mode_320x480,Mode_360x240,Mode_360x480,
SET_VGA_MODEX, SET_MODEX, CLEAR_VGA_SCREEN, SET_POINT, READ_POINT,
FILL_BLOCK, DRAW_LINE, SET_DAC_REGISTER, GET_DAC_REGISTER,
LOAD_DAC_REGISTERS, READ_DAC_REGISTERS,
SET_ACTIVE_PAGE, GET_ACTIVE_PAGE, SET_DISPLAY_PAGE, GET_DISPLAY_PAGE,
SET_WINDOW, GET_X_OFFSET, GET_Y_OFFSET, SYNC_DISPLAY,
GPRINTC, TGPRINTC, PRINT_STR, TPRINT_STR,
SET_DISPLAY_FONT, DRAW_BITMAP, TDRAW_BITMAP, COPY_PAGE, COPY_BITMAP,
mxTrue, mxFalse, mxnil,
c_BLACK, c_BLUE, c_GREEN, c_CYAN, c_RED, c_PURPLE, c_BROWN, c_WHITE,
c_GREY, c_bBLUE, c_bGREEN, c_bCYAN, c_bRED, c_bPURPLE, c_YELLOW, c_bWHITE,
c_BRIGHT,
Ky_F1, Ky_F2, Ky_F3, Ky_F4, Ky_F5, Ky_F6, Ky_F7, Ky_F8, Ky_F9, Ky_F10,
Ky_Up, Ky_Left, Ky_Right, Ky_Down,
Ky_SUp, Ky_SLeft, Ky_SRight, Ky_SDown,
Ky_Home, Ky_End, Ky_PgUp, Ky_PgDn,
Ky_SHome, Ky_SEnd, Ky_SPgUp, Ky_SPgDn,
Ky_Ins, Ky_Del, Ky_SIns, Ky_SDel, Ky_Tab, Ky_RvsTab, Ky_STab,
Ky_BS, Ky_CR, Ky_ESC, Ky_Clr, Ky_Plus, Ky_Minus,
Ky_AltA, Ky_AltB, Ky_AltC, Ky_AltD, Ky_AltE, Ky_AltF, Ky_AltG,
Ky_AltH, Ky_AltI, Ky_AltJ, Ky_AltK, Ky_AltL, Ky_AltM, Ky_AltN,
Ky_AltO, Ky_AltP, Ky_AltQ, Ky_AltR, Ky_AltS, Ky_AltT, Ky_AltU,
Ky_AltV, Ky_AltW, Ky_AltX, Ky_AltY, Ky_AltZ,
DOS_PRINT, DOS_PRINTS, SET_VIDEO_MODE,
SCAN_KEYBOARD, RANDOM_INT, INIT_RANDOM, INT_SQR, TIMER_COUNT;

FROM QD_IniT IMPORT FreeIni, readIniFile,
findSection, getFirstSection, getNextSection,
findEntry, getItemStr, getItemStrUp, getItemCard, getItemInt,
getItemBool, getItemChar, getItemCharUp;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    minDataBufferByte = 0;
    maxDataBufferByte = (8 * 512)-1; (* 8 seems best, 4 is ok *)
    dataBufferSize    = maxDataBufferByte-minDataBufferByte+1;
TYPE
    databuffertype = ARRAY [minDataBufferByte..maxDataBufferByte] OF BYTE;
VAR
    databuffer : databuffertype;

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBufferType = ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
VAR
    ioBuffer,ioBufferOut : ioBufferType;

(* ------------------------------------------------------------ *)

PROCEDURE getrndrange ( lower,upper:CARDINAL ):CARDINAL;
VAR
    range : CARDINAL;
BEGIN
    range := upper-lower+1 ;
    RETURN lower+ RANDOM_INT(range);
END getrndrange;

PROCEDURE swap (VAR v1,v2:CARDINAL);
VAR
    tmp:CARDINAL;
BEGIN
    tmp := v2;
    v2  := v1;
    v1  := tmp;
END swap;

PROCEDURE getCard (S:ARRAY OF CHAR;VAR v:CARDINAL):BOOLEAN;
VAR
    n:LONGCARD;
BEGIN
    IF GetLongCard(S,n)=FALSE THEN RETURN FALSE; END;
    IF n > MAX(CARDINAL) THEN RETURN FALSE; END;
    v:= CARDINAL(n);
    RETURN TRUE;
END getCard;

PROCEDURE mouseclick (  ):BOOLEAN;
VAR
    msdata:MsMouse.MsData;
BEGIN
    MsMouse.GetStatus(msdata);
    IF msdata.left_pressed THEN RETURN TRUE; END;
    IF msdata.right_pressed THEN RETURN TRUE; END;
    RETURN msdata.middle_pressed;
END mouseclick;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    Ky_SPACE = 0020H;
CONST
    v640x480x8 = 0101H;
    v800x600x8 = 0103H;

(*# save *)
(*# data(near_ptr => off)  *)
TYPE
    vpointer = POINTER TO WORD; (* well, glad M2 is case-sensitive ! *)
    pchar   = POINTER TO CHAR;
(*# restore *)

TYPE
    vesamainbuffertype = RECORD
        id             : ARRAY [0..3] OF CHAR;
        majmin         : WORD;
        pOEMname       : LONGWORD;  (* asciiz *)
        capabilities   : LONGWORD;
        pList          : LONGWORD;
        VRAM64KBblocks :WORD;
        OEMmajmin      : WORD;
        pOEM           : LONGWORD;
        pProduct       : LONGWORD;
        pRevision      : LONGWORD;
        VBEAFversion   : WORD;
        pAcceleratedModes:LONGWORD;
        dummy          : ARRAY [1..216] OF BYTE;
        OEMdummy       : ARRAY [1..256] OF BYTE;
    END;

VAR
    Buffer : vesamainbuffertype;

PROCEDURE CheckVesaHere (forceVBE2:BOOLEAN;VAR listPtr : vpointer) : BOOLEAN;
VAR
    R : SYSTEM.Registers;
BEGIN
    IF forceVBE2 THEN
        Buffer.id[0]:="V";
        Buffer.id[1]:="B";
        Buffer.id[2]:="E";
        Buffer.id[3]:="2";
    END;
    R.AX := 4F00H;
    R.ES := Seg(Buffer); (* buffer segment *)
    R.DI := Ofs(Buffer); (* buffer offset *)
    Lib.Intr(R,10H);
    IF R.AL # 4FH THEN RETURN FALSE; END;
    IF R.AH # 00H THEN RETURN FALSE; END;
    IF Buffer.id[0] # "V" THEN RETURN FALSE; END;
    IF Buffer.id[1] # "E" THEN RETURN FALSE; END;
    IF Buffer.id[2] # "S" THEN RETURN FALSE; END;
    IF Buffer.id[3] # "A" THEN RETURN FALSE; END;
    (* Lib.Move (ADR(Buffer[0EH]),ADR(listPtr),4); (* set pointer to list ADDRESS *) *)
    Lib.Move (ADR(Buffer.pList),ADR(listPtr),SIZE(Buffer.pList));
    RETURN TRUE;
END CheckVesaHere;

(* warning ! a mode may be supposed "available" while not being implemented ! matrox idiosyncrasy ! *)

PROCEDURE ModeAvailable (listPtr : vpointer; mode : CARDINAL) : BOOLEAN;
BEGIN
    LOOP
        IF listPtr^ = WORD(0FFFFH) THEN EXIT; END;
        IF listPtr^ = WORD(mode) THEN RETURN TRUE; END;
        Lib.IncFarAddr(listPtr,SIZE(WORD));
    END;
    RETURN FALSE;
END ModeAvailable;

PROCEDURE SetVesaMode (mode : CARDINAL) : BOOLEAN;
VAR
    R : SYSTEM.Registers;
BEGIN
    R.AX := 4F02H;
    R.BX := mode;
    Lib.Intr(R,10H);
    IF R.AL # 4FH THEN RETURN FALSE; END;
    IF R.AH # 00H THEN RETURN FALSE; END;
    RETURN TRUE;
END SetVesaMode;

(* ------------------------------------------------------------ *)

(* vesamodeinfobuffertype MUST be 256 bytes *)

TYPE
    vesamodeinfobuffertype = RECORD
        modeattributes      : WORD; (* 79 *)
        wA                  : BYTE; (* 81 *)
        wB                  : BYTE; (* id *)
        wgranularityKB      : WORD;
        wsizeKB             : WORD;
        segmentwA           : WORD; (* 0 if unsupported *)
        segmentwB           : WORD; (* id *)
        wpositioningfunction: LONGWORD;
        bytesperscanline    : WORD;
    (* ---remainder is optional for VESA modes in v1.0/1.1, needed for OEM modes--- *)
        width               : WORD; (* pixels or chars *)
        height              : WORD; (* id *)
        wcell               : BYTE;
        hcell               : BYTE;
        memplanes           : BYTE;
        bpp                 : BYTE;
        banks               : BYTE;
        memorymodeltype     : BYTE; (* 82 *)
        banksizeKB          : BYTE;
        imagepages          : BYTE; (* -1 *)
        reservedflag        : BYTE; (* 1 for VBE 3.0, ELSE 0 *)
    (* ---VBE v1.2+ --- *)
        rmasksize           : BYTE;
        rfield              : BYTE;
        gmasksize           : BYTE;
        gfield              : BYTE;
        bmasksize           : BYTE;
        bfield              : BYTE;
        reservedmasksize    : BYTE;
        reservedmaskposition: BYTE;
        directcolormode     : BYTE; (* bits 0 and 1 *)
    (* ---VBE v2.0+ --- *)
        linearvideobufferaddr: LONGWORD;
        offscreenmemoryaddr : LONGWORD;
        offscreenmemoryKB   : WORD;
    (* ---VBE v3.0 --- *)
        bytesperscanlinelinear:WORD;
        imagesforbankedmodes: BYTE; (* -1 *)
        imagesforlinearmodes: BYTE; (* -1 *)
        rmasklinear         : BYTE;
        rmaskLSBlinear      : BYTE;
        gmasklinear         : BYTE;
        gmaskLSBlinear      : BYTE;
        bmasklinear         : BYTE;
        bmaskLSBlinear      : BYTE;
        reservedmasklinear  : BYTE;
        reservedmaskLSBlinear:BYTE;
        maxclockHz          : LONGWORD;
        unused              : ARRAY [1..190] OF BYTE;
    END;

CONST
    vesaminy = 0;
    vesamaxy = 1024-1; (* 1280x1024 at most *)
VAR
    currbank:CARDINAL; (* a word in fact *)
    binfos : vesamodeinfobuffertype;

VAR
    vesabaseaddr : ARRAY [vesaminy..vesamaxy] OF LONGCARD;

PROCEDURE initVESAlookup (  );
VAR
    y : CARDINAL;
    addr,wi : LONGCARD;
BEGIN
    addr:=0;
    wi:=LONGCARD(binfos.width);
    FOR y:=vesaminy TO vesamaxy DO
        vesabaseaddr[y]  := addr;
        INC (addr, wi);
    END;
END initVESAlookup;

PROCEDURE getVESAmodeInfos (mode:CARDINAL):BOOLEAN;
VAR
    R : SYSTEM.Registers;
BEGIN
    Lib.Fill(ADR(binfos),SIZE(binfos),00H);

    R.AX := 4F01H;      (* GET SuperVGA MODE INFORMATION *)
    R.CX := WORD(mode);
    R.ES := Seg(binfos); (* buffer segment *)
    R.DI := Ofs(binfos); (* buffer offset *)
    Lib.Intr(R,10H);

    IF R.AL # 4FH THEN RETURN FALSE; END; (* unsupported function *)
    IF R.AH = 00H THEN initVESAlookup; END; (* ok, init if needed *)
    RETURN (R.AH=00H); (* FALSE if function failure *)
END getVESAmodeInfos;

PROCEDURE initVESAbank (  ):BOOLEAN;
VAR
    R:SYSTEM.Registers;
BEGIN
    currbank := 0000H;
    R.AX := 04F05H;
    R.BH := 00H;     (* select video memory window -- dx = window address in granularity units *)
    R.BL := 00H;     (* window A should always work *)
    R.DX := currbank;
    Lib.Intr(R,10H);
    IF R.AL # 4FH THEN RETURN FALSE; END;
    RETURN (R.AH=00H);
END initVESAbank;

PROCEDURE VESAputpixel (x,y,n:CARDINAL);
VAR
    addr:LONGCARD;
    bank,offset:CARDINAL;
    R:SYSTEM.Registers;
BEGIN
    addr  := LONGCARD(x)+vesabaseaddr[y];
    bank  := CARDINAL (addr >> 16);
    offset:= CARDINAL (addr MOD 65536);
    IF currbank # bank THEN
        currbank := bank;
        R.AX := 04F05H;
        R.BH := 00H;
        R.BL := 00H;
        R.DX := currbank;
        Lib.Intr(R,10H); (* assume ok *)
    END;
    (* ugly hack *)
    Lib.FarFill([binfos.segmentwA:offset],1,BYTE(n));
END VESAputpixel;

PROCEDURE VESAgetpixel (x,y:CARDINAL):BYTE;
VAR
    addr:LONGCARD;
    bank,offset:CARDINAL;
    R:SYSTEM.Registers;
    n:BYTE;
BEGIN
    addr  := LONGCARD(x)+vesabaseaddr[y];
    bank  := CARDINAL (addr >> 16);
    offset:= CARDINAL (addr MOD 65536);
    IF currbank # bank THEN
        currbank := bank;
        R.AX := 04F05H;
        R.BH := 00H;
        R.BL := 00H;
        R.DX := currbank;
        Lib.Intr(R,10H); (* assume ok *)
    END;
    (* ugly hack *)
    Lib.FarMove([binfos.segmentwA:offset],FarADR(n),1);
    RETURN n;
END VESAgetpixel;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    xmin = 0;
    ymin = 0;
VAR
    xmax,ymax,xcount,ycount:CARDINAL;

PROCEDURE VESAcls (paper:CARDINAL);
VAR
    x,y:CARDINAL;
BEGIN
    FOR y:=ymin TO ymax DO
        FOR x:=xmin TO xmax DO
            VESAputpixel(x,y,paper);
        END;
    END;
END VESAcls;

PROCEDURE setvesamoderange (vmode:CARDINAL;VAR R:ARRAY OF CHAR);
BEGIN
    CASE vmode OF
    | v640x480x8:xcount:=640;ycount:=480;Str.Copy(R,"640x480x8");
    | v800x600x8:xcount:=800;ycount:=600;Str.Copy(R,"800x600x8");
    END;
    xmax:=xcount-1;
    ymax:=ycount-1;
END setvesamoderange;

CONST
    PagesVirtual=2; (* view, work *)
    page1=0;
    page2=1;
VAR
    xMaxVirtual,yMaxVirtual:CARDINAL;
    viewpage,workpage:CARDINAL;
    (* to avoid casts *)
    iscreenwidth  : INTEGER;
    iscreenheight : INTEGER;
    ixmax         : INTEGER;
    iymax         : INTEGER;
    cx,cy		  : INTEGER;

PROCEDURE HiresON (vmode:CARDINAL;VAR R:ARRAY OF CHAR):BOOLEAN;
VAR
    m:CARDINAL;
BEGIN
    CASE vmode OF
    | Mode_320x240: xcount:=320;ycount:=240; Str.Copy(R,"320x240x8");
    | Mode_320x200: xcount:=320;ycount:=200; Str.Copy(R,"320x200x8");
    END;
    xmax:=xcount-1;
    ymax:=ycount-1;

    xMaxVirtual := xcount;
    yMaxVirtual := ycount;
    cx          := INTEGER(xmax DIV 2);
    cy          := INTEGER(ymax DIV 2);
    (* to avoid casts *)
    iscreenwidth  := INTEGER(xcount);
    iscreenheight := INTEGER(ycount);
    ixmax         := INTEGER(xmax);
    iymax         := INTEGER(ymax);
    RETURN (SET_VGA_MODEX(vmode,xMaxVirtual,yMaxVirtual,PagesVirtual) # 0);
END HiresON;

PROCEDURE HiresOFF ();
CONST
    biostxtmode = 3;
BEGIN
    SET_VIDEO_MODE(biostxtmode);
END HiresOFF;

PROCEDURE setviewwork (view,work:CARDINAL );
BEGIN
    SET_DISPLAY_PAGE(view);
    SET_ACTIVE_PAGE(work);
END setviewwork;

PROCEDURE modexcls (paper:CARDINAL);
BEGIN
    CLEAR_VGA_SCREEN (paper);
END modexcls;

PROCEDURE setDAC(index:CARDINAL;red,green,blue:BYTE);
CONST
    DACWriteIndex  = 03C8H;
    DACDataRegister= 03C9H;
BEGIN
    SYSTEM.Out (DACWriteIndex,SHORTCARD(index));
    SYSTEM.Out (DACDataRegister, red);
    SYSTEM.Out (DACDataRegister, green);
    SYSTEM.Out (DACDataRegister, blue);
END setDAC;

PROCEDURE getDAC (index:CARDINAL;VAR r,g,b:SHORTCARD);
CONST
    DACReadIndex   = 03C7H;
    DACDataRegister= 03C9H;
BEGIN
    SYSTEM.Out (DACReadIndex,SHORTCARD(index));
    r:=SYSTEM.In (DACDataRegister);
    g:=SYSTEM.In (DACDataRegister);
    b:=SYSTEM.In (DACDataRegister);
END getDAC;

PROCEDURE cls (usevesa:BOOLEAN;paper:CARDINAL);
BEGIN
    SYNC_DISPLAY();
    IF usevesa THEN
        VESAcls(paper);
    ELSE
        modexcls(paper);
    END;
END cls;

PROCEDURE genpos (centered:BOOLEAN; wiclip,heclip:CARDINAL;
                 VAR xpos,ypos:CARDINAL  );
BEGIN
        IF centered THEN
            IF wiclip < xcount THEN
                xpos:=(xcount-wiclip) DIV 2;
            ELSE
                xpos:=xmin;
            END;
            IF heclip < ycount THEN
                ypos:=(ycount-heclip) DIV 2;
            ELSE
                ypos:=ymin;
            END;
        ELSE
            IF wiclip < xcount THEN
                xpos:=getrndrange(xmin,xmax-wiclip);
            ELSE
                xpos:=xmin;
            END;
            IF heclip < ycount THEN
                ypos:=getrndrange(ymin,ymax-heclip);
            ELSE
                ypos:=ymin;
            END;
        END;
END genpos;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    PCXrgbType = RECORD
        red,green,blue:BYTE;
    END;

    (* (almost) useless fields are indented again *)

    PCXheaderType = RECORD
     manufacturer    : BYTE; (* constant 10=$0A=ZSoft *)
     version         : BYTE; (* constant 5=PC Paintbrush v3.0+ *)
     encoding        : BYTE; (* constant 1=RLE *)
    bitsPerPixel     : BYTE; (* 1, 2, 4 or 8, i.e. mono, 4, 16 OR 256 colors  *)
	                  (* window, i.e. image dimensions : xmin, ymin, xmax, ymax *)
    leftmargin       : WORD;
    uppermargin      : WORD;
    rightmargin      : WORD; (* do not use xmax-xmin ! *)
    lowermargin      : WORD;
     hDPIresolution  : WORD; (* put 300 for instance *)
     vDPIresolution  : WORD; (* idem *)
    colormap         : ARRAY[0..15] OF PCXrgbType;
     reserved1       : BYTE; (* must be 0 *)
    NCP              : BYTE; (* number of color planes, 1 or 4 *)
    NBS              : WORD; (* number of bytes per scanline, always even *)
                            (* from here, fields may contain rubbish *)
     paletteInfo     : WORD; (* 1=color or BW, 2=grayscale *)
     hscreensize     : WORD;
     vscreensize     : WORD;
     reserved2       : ARRAY[0..53] OF BYTE; (* must be 0 *)
    END;

CONST
    palID = BYTE(0CH); (* 12=$0C *)
    palidsize=1;
    palsize = 3 * 256;

PROCEDURE chkPCX256 (S:ARRAY OF CHAR):BOOLEAN;
CONST
    kTen = BYTE(0AH);
    kOne = BYTE(1);
    kZero= BYTE(0);
CONST
    kFour= BYTE(4);
    kOneW= WORD(1); (* all tests being in the same proc now... *)
    kEight=BYTE(8);
VAR
    n : CARDINAL;
    h : PCXheaderType;
    hnd:FIO.File;
BEGIN
    hnd:=FIO.OpenRead(S);
    FIO.AssignBuffer(hnd,ioBuffer);
    n:=FIO.RdBin(hnd,h,SIZE(PCXheaderType));
    FIO.Close(hnd);
    IF n < SIZE(PCXheaderType) THEN RETURN FALSE; END;
    IF h.manufacturer # kTen THEN RETURN FALSE; END;
    IF h.encoding # kOne THEN RETURN FALSE;END;
    IF h.reserved1 # kZero THEN RETURN FALSE; END;
    (*
    FOR n:=0 TO 53 DO
        IF h.reserved2[n] # kZero THEN RETURN FALSE; END;
    END;
    *)
    IF h.bitsPerPixel > kEight THEN RETURN FALSE; END;
    IF h.NCP > kFour THEN RETURN FALSE; END;
    IF h.paletteInfo # kOneW THEN RETURN FALSE; END;
    CASE CARDINAL(h.NCP) OF
    | 1:
        CASE CARDINAL(h.bitsPerPixel) OF
        | 8 :
            (*
            picwidth  := CARDINAL(h.rightmargin-h.leftmargin)+1;
            picheight := CARDINAL(h.lowermargin-h.uppermargin)+1;
            *)
            RETURN TRUE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END chkPCX256;

PROCEDURE newpalette (hnd:FIO.File):CARDINAL ;
VAR
    i,n,darkest,avg,avgref:CARDINAL;
    r,g,b:SHORTCARD;
    rr,gg,bb:SHORTCARD;
BEGIN
    SYNC_DISPLAY;
    rr:=255;gg:=255;bb:=255;darkest:=255;avgref:=255;
    FOR i := 0 TO 255 DO
        n:=FIO.RdBin(hnd,r,SIZE(r));
        n:=FIO.RdBin(hnd,g,SIZE(g));
        n:=FIO.RdBin(hnd,b,SIZE(b));


        (* we must reduce to EGA range : [$00..$3F] *)
        r:=r >> 2;
        g:=g >> 2;
        b:=b >> 2;
        SET_DAC_REGISTER(i,CARDINAL(r),CARDINAL(g),CARDINAL(b) );
        avg:=( CARDINAL(r)+CARDINAL(g)+CARDINAL(b) ) DIV 3;
        IF (avg < avgref) OR ( (r<rr) AND (g<gg) AND (b<bb)) THEN
            rr:=r;
            gg:=g;
            bb:=b;
            avgref:=avg;
            darkest:=i;
        END;
    END;

    (*
    SET_DAC_REGISTER(0,00H,00H,00H); (* force index 0 to black because of border *)
    *)

    (* argh : border still sucks ! *)

    RETURN darkest;
END newpalette;

PROCEDURE openPCX (hnd:FIO.File;fsize:LONGCARD;
                   VAR darkest,  wi,he,lastcode:CARDINAL ):LONGCARD;
VAR
    here:LONGCARD;
    n:CARDINAL;
    h:PCXheaderType;
BEGIN
    here:=FIO.GetPos(hnd);
    FIO.Seek(hnd,here+fsize-palsize);
    darkest:=newpalette(hnd);
    FIO.Seek(hnd,here);
    n:=FIO.RdBin(hnd,h,SIZE(PCXheaderType));
    here:=FIO.GetPos(hnd);
    wi       := CARDINAL (h.rightmargin-h.leftmargin)+1;
    he       := CARDINAL (h.lowermargin-h.uppermargin)+1;
    lastcode := CARDINAL(h.NCP) * CARDINAL(h.NBS) -1;
    RETURN here;
END openPCX;

(* ------------------------------------------------------------ *)

CONST
    maxPlanes = 4;
    maxpixels = 1280;
    firstcode = 0;
    (* maxcode   = (1280 DIV 8) * maxPlanes -1; (* in bytes *) *)
    maxcode   = maxpixels * maxPlanes-1;
TYPE
    imgtype = RECORD
        picwidth : CARDINAL ;
        picheight: CARDINAL ;
        decodebuffer : ARRAY [firstcode..maxcode] OF BYTE;
    END;
VAR
    img : imgtype;
CONST
    PCXCOUNTFLAG = BYTE(0C0H); (* 11000000 *)
    PCXCOUNTMASK = BYTE(03FH); (* 00111111 *)
    PCXMAXCOUNT  = 03FH;

PROCEDURE decodeScanline (hnd:FIO.File;lastcode:CARDINAL);
VAR
    databyte:BYTE;
    p,count,n : CARDINAL;
BEGIN
    p := firstcode;
    WHILE p <= lastcode DO
        n:=FIO.RdBin(hnd,databyte,1);
        IF (databyte AND PCXCOUNTFLAG) = PCXCOUNTFLAG THEN
            count := CARDINAL(databyte AND PCXCOUNTMASK);
            n := FIO.RdBin(hnd,databyte,1);
            FOR n := 1 TO count DO
                img.decodebuffer[p]:=databyte;
                INC(p);
            END;
        ELSE
            img.decodebuffer[p]:=databyte;
            INC(p);
        END;
    END;
END decodeScanline;

(* valid for 256 colors -- 8 bpp ONLY ! *)

PROCEDURE decodePCX (hnd:FIO.File;here:LONGCARD;
                    lastcode,  left,top, wi,he:CARDINAL;
                    usevesa:BOOLEAN);
VAR
    lastx,lasty,x,y,n,xx,yy:CARDINAL;
BEGIN
    FIO.Seek(hnd,here);

    lastx    := wi-1;
    lasty    := he-1;

    y:=top;
    FOR yy := 1 TO he DO (* ymin TO lasty *)
        decodeScanline(hnd,lastcode);
        x:=left;
        FOR xx := 0 TO lastx DO
            n := CARDINAL(img.decodebuffer[xx]);
            IF ((x <= xmax) AND (y <= ymax)) THEN
                IF usevesa THEN
                    VESAputpixel(x,y,n);
                ELSE
                    SET_POINT(x,y,n);
                END;
            END;
            INC(x);
        END;
        INC(y);
    END;
END decodePCX;

(*
defint a-z

columns=4
rows=2

?
?"columns",columns
?"rows",rows
?
?"frame","xorg","yorg"

for currframe=0 to 7

    xorg=(currframe MOD columns)
    yorg=(currframe-xorg) \ columns
    'xorg=(xorg-1)*wi
    'yorg=(yorg-1)*he

	?currframe,xorg,yorg

next
*)

PROCEDURE decodePCXclip (hnd:FIO.File;here:LONGCARD;
                        lastcode,  left,top, wi,he:CARDINAL;
                        columns,rows,currframe:CARDINAL;
                        usevesa:BOOLEAN);
VAR
    lastx,lasty,x,y,n,xx,yy:CARDINAL;
    xorg,yorg:CARDINAL;
BEGIN
    (* frame# = (y-1) * columns + x *)
    DEC (currframe); (* we need 0-based here *)
    xorg:=(currframe MOD columns);
    yorg:=(currframe-xorg) DIV columns;
    xorg:=xorg*wi;
    yorg:=yorg*he;

    FIO.Seek(hnd,here);

    lastx    := wi-1;
    lasty    := he-1;

    FOR yy := (0+1) TO yorg DO
        decodeScanline(hnd,lastcode);
    END;

    y:=top;
    FOR yy := 1 TO he DO (* ymin TO lasty *)
        decodeScanline(hnd,lastcode);
        x:=left;
        FOR xx := 0 TO lastx DO
            n := CARDINAL(img.decodebuffer[xorg+xx]);
            IF ((x <= xmax) AND (y <= ymax)) THEN
                IF usevesa THEN
                    VESAputpixel(x,y,n);
                ELSE
                    SET_POINT(x,y,n);
                END;
            END;
            INC(x);
        END;
        INC(y);
    END;
END decodePCXclip;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    progEXEname   = "MOVIE";
    progTitle     = "Q&D Movie";
    progVersion   = "v1.0c";
    progCopyright = "by PhG";
    Banner        = progTitle+" "+progVersion+" "+progCopyright;
    credit        = "(public domain Mode X v1.04 library by Matt Pritchard)";
CONST
    extBIN        = ".BIN";
    extPCX        = ".PCX";
    extINI        = ".INI";
    extEXE        = ".EXE";
    cr            = CHR(13);
    lf            = CHR(10);
    nl            = cr+lf;
    dot           = ".";
    baseFileBank  = progEXEname+extBIN;
CONST (* same as my VB Movie *)
    sFile         = "File";
    sRows         = "Rows";
    sColumns      = "Columns";
    sRewind       = "Rewind";
CONST
    errNone       = 0;
    errHelp       = 1;
    errOption     = 2;
    errParameter  = 3;
    errCmd        = 4;
    errExpected   = 5;
    errCmdSyntax  = 6;
    errJoker      = 7;
    errNotFound   = 8;
    errFound      = 9;
    errUnsupported= 10;
    errReadIni    = 11;
    errUndefined  = 12;
    errReadError  = 13;
    errBankFormat = 14;
    errCorrupted  = 15;
    errValue      = 16;
    errRange      = 17;
    errMode       = 18;
    errIndex      = 19;
    errNoVesa     = 20;
    errNotAvailable=21;
    errVesaProblem= 22;
    err104F01     = 23;
    err104F05     = 24;
    errModeXproblem=25;
    errSpeed      = 26;
    errEmptyBank  = 27;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);

    MODULE message;
    IMPORT Str;
    EXPORT msg3,msg2;

    PROCEDURE msg3 (VAR R:ARRAY OF CHAR;S1,S2,S3:ARRAY OF CHAR);
    BEGIN
        Str.Concat(R,S1,S2);Str.Append(R,S3);
    END msg3;

    PROCEDURE msg2 (VAR R:ARRAY OF CHAR;S1,S2:ARRAY OF CHAR);
    BEGIN
        Str.Concat(R,S1,S2);
    END msg2;

    END message;

CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
msgHelp =
Banner+nl+
nl+
credit+nl+
nl+
"Syntax 1 : "+progEXEname+" -create <ini["+extINI+"]> <picture["+extPCX+"]> [-overwrite]"+nl+
nl+
"  Create "+baseFileBank+" from *"+extPCX+" files using data found in initialization file."+nl+
"  Each entry in initialization file must conform to this format :"+nl+
nl+
"      [$]"+nl+
"      "+sFile+"=$["+extPCX+"]"+nl+
"      "+sRows+"=#"+nl+
"      "+sColumns+"=#"+nl+
"      "+sRewind+"=#"+nl+
nl+
"  Section is required as a separator. File extension is optional"+nl+
"  (if specified, it will be replaced with "+extPCX+")."+nl+
"  Picture without matching entry will abort program if -v was specified."+nl+
"  Only 256 colors PCX files are supported."+nl+
"  Processing pictures with the great PICLAB will help fix the border color."+nl+
nl+
"Syntax 2 : "+progEXEname+" -list [-overwrite]"+nl+
nl+
"  List files from "+baseFileBank+". Redirected output will be in XTRACT format."+nl+
nl+
"Syntax 3 : "+progEXEname+" [#] [-m:#] [-speed:#] [-random] [-buffered] [-mouse] [-saver]"+nl+
nl+
"  Show selected or random animation from "+baseFileBank+" in required video mode :"+nl+
"  0=320x240 (default), 1=320x200, 2=640x480 (VESA), 3=800x600 (VESA)."+nl+
nl+
"  [Tab]-random animation  [+|-]-speed  [C]-center position  [R]-random position"+nl+
"  [F1|F2]-previous/next  [PageUp|PageDn]-previous/next  [Escape|Return]-quit"+nl+
nl+
"a) Options irrelevant to specified command will be ignored."+nl+
"b) Note that "+extBIN+" data filename must match "+extEXE+" executable filename."+nl+
"c) Data file is searched for in current directory then in executable directory."+nl+
"d) LFNs are not supported."+nl;

VAR
    S : str256;
BEGIN
    CASE e OF
    | errHelp :
        WrStr(msgHelp);
    | errOption :     msg3(S,"Unknown ",einfo," option !");
    | errParameter:   msg3(S,"Useless ",einfo," parameter !");
    | errCmd:         S:="-create and -list options are mutually exclusive !";
    | errExpected:    msg2(S,einfo," option requires two parameters !");
    | errCmdSyntax:   S:="No parameter required with specified option !";
    | errJoker  :     msg3(S,"No joker allowed in ",einfo," specification !");
    | errNotFound:    msg3(S,"No file matches ",einfo," specification !");
    | errFound    :   msg2(S,einfo," already exists !");
    | errUnsupported: msg2(S,einfo," is not a 256 colors PCX picture !");
    | errReadIni:     msg2(S,einfo," would not load !");
    | errUndefined:   msg2(S,einfo," is not referenced in "+extINI+" file !");
    | errReadError:   msg2(S,einfo," may be corrupted !");
    | errBankFormat:  msg2(S,einfo," may be corrupted !");
    | errCorrupted:   msg2(S,einfo," is corrupted !");
    | errValue:       msg3(S,"Illegal ",einfo," value !");
    | errRange:       msg2(S,einfo," index out of range !");
    | errMode:        msg3(S,"Illegal ",einfo," mode !");
    | errIndex:       S:="Illegal index value !";
    | errNoVesa:      S:="VESA functions are not available !";
    | errNotAvailable:msg2(S,einfo," video mode is not available !");
    | errVesaProblem: msg2(S,einfo," video mode would not initialize !");
    | err104F01:      S := "$104f01 VESA function failure !";
    | err104F05:      S := "$104f05 VESA function failure !";
    | errModeXproblem:msg2(S,einfo," video mode would not initialize !");
    | errSpeed:       msg3(S,"Illegal ",einfo," speed !");
    | errEmptyBank:   msg3(S,"Empty ",einfo," bank !");
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone, errHelp :
        ;
    ELSE
        WrStr(progEXEname+" : "); WrStr(S); WrLn;
    END;
    Lib.SetReturnCode(SHORTCARD(e));
    HALT;
END abort;

PROCEDURE dbg (DEBUG:BOOLEAN;S1,S2,S3:ARRAY OF CHAR   );
VAR
    S:str1024;
BEGIN
    IF DEBUG THEN
        S:='/// ~ : ~ = "~"';
        Str.Subst(S,"~",S1);
        Str.Subst(S,"~",S2);
        Str.Subst(S,"~",S3);
        WrStr(S);WrLn;
    END;
END dbg;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    msgProcessing = "Processing ";
    bankMAGIC = "Q&D Movie"+CHR(01AH);
TYPE
    bankheadertype = RECORD
        ID    : ARRAY [0..SIZE(bankMAGIC)-1] OF CHAR;
        count : CARDINAL;
    END;
    picinfotype = RECORD
        fsize        : LONGCARD;
        rows,columns : CARDINAL;
        rewind       : BOOLEAN;
        stamp        : LONGCARD;
        orgname      : FIO.PathTail; (* in FIO.DEF : ARRAY [0..12] OF CHAR *)
    END;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* assume upper CASE *)

PROCEDURE forceExt (VAR S:ARRAY OF CHAR; ext:ARRAY OF CHAR   );
VAR
    p:CARDINAL;
    R:str128;
BEGIN
    Str.Copy(R,S);
    p:=Str.RCharPos(R,dot);
    IF p # MAX(CARDINAL) THEN R[p]:=CHR(0); END; (* brutal ! *)
    Str.Concat(S,R,ext);
END forceExt;

PROCEDURE getAbout (VAR rows,columns:CARDINAL;VAR rewind:BOOLEAN;
                   DEBUG:BOOLEAN;orgwanted:ARRAY OF CHAR):BOOLEAN;
VAR
    found:BOOLEAN;
    wanted,section,R:str128;
    v:INTEGER;
BEGIN
    Str.Copy(wanted,orgwanted);
    UpperCase(wanted);
    dbg(DEBUG,"getAbout()","wanted",wanted);
    forceExt(wanted,extPCX);

    found:=getFirstSection(section);
    WHILE found DO
        getItemStrUp(section,sFile,"", R);
        dbg(DEBUG,"getAbout()","section",section);
        dbg(DEBUG,"getAbout()","sFile",R);
        forceExt(R,extPCX);
        IF same(R,wanted) THEN
            getItemCard(section,sRows,"0", rows);
            getItemCard(section,sColumns,"0",columns);
            getItemInt(section,sRewind,"0",v);
            rewind := (v#0);
            RETURN TRUE;
        END;
        found:=getNextSection(section);
    END;
    RETURN FALSE;
END getAbout;

PROCEDURE bankappend (hout:FIO.File;DEBUG:BOOLEAN;S:ARRAY OF CHAR):BOOLEAN;
VAR
    rows,columns:CARDINAL;
    rewind:BOOLEAN;
    hnd:FIO.File;
    wanted,got:CARDINAL;
    picinfo:picinfotype;
BEGIN
    IF getAbout(rows,columns,rewind,DEBUG,S)=FALSE THEN RETURN FALSE; END;

    hnd:=FIO.OpenRead(S);
    FIO.AssignBuffer(hnd,ioBuffer);

    picinfo.fsize   := FIO.Size(hnd);
    picinfo.rows    := rows;
    picinfo.columns := columns;
    picinfo.rewind  := rewind;
    picinfo.stamp   := FIO.GetFileDate(hnd);
    Str.Copy(picinfo.orgname,S);

    FIO.WrBin(hout,picinfo,SIZE(picinfo));

    FIO.EOF:=FALSE;
    LOOP
        got:=FIO.RdBin(hnd,databuffer,dataBufferSize);
        IF got = 0 THEN EXIT; END;
        FIO.WrBin(hout,databuffer,got);
        IF got # dataBufferSize THEN EXIT; END;
    END;
    FIO.Close(hnd);
    RETURN TRUE;
END bankappend;

(* ------------------------------------------------------------ *)

PROCEDURE pad (wi:CARDINAL;padchar:CHAR; VAR R:ARRAY OF CHAR   );
VAR
    i:CARDINAL;
BEGIN
    FOR i:=Str.Length(R)+1 TO wi DO
        Str.Prepend(R,padchar);
    END;
END pad;

PROCEDURE fmtVal (n:LONGCARD;base,digits:CARDINAL;padchar:CHAR;
                 VAR R:ARRAY OF CHAR);
VAR
    ok: BOOLEAN;
    i:CARDINAL;
BEGIN
    Str.CardToStr( n, R, base, ok);
    pad(digits,padchar,R);
END fmtVal;

PROCEDURE fmtpicinfo (ndx:CARDINAL;batchmode:BOOLEAN;picinfo:picinfotype;
                     here:LONGCARD;bnk:ARRAY OF CHAR;
                     VAR R:ARRAY OF CHAR);
VAR
    S : str16;
BEGIN
    Str.Copy(S,picinfo.orgname);
    pad(8+1+3," ",S);
  IF batchmode THEN
    Str.Concat(R,"xtract %1 %2 %3 %4 ",bnk);
    Str.Append(R," ");
    Str.Append(R,S);

    fmtVal( here                     ,16,8,"0",S);
    Str.Append(R," $");
    Str.Append(R,S);

    fmtVal( picinfo.fsize            ,10,1,"0",S);
    Str.Append(R," L");
    Str.Append(R,S);

  ELSE
    Str.Copy(R,S);

    fmtVal( LONGCARD(ndx)            ,10,3," ",S);
    Str.Append(R,"    ndx = ");
    Str.Append(R,S);

    fmtVal( LONGCARD(picinfo.columns),10,3," ",S);
    Str.Append(R,"    columns = ");
    Str.Append(R,S);

    fmtVal( LONGCARD(picinfo.rows)   ,10,3," ",S);
    Str.Append(R,"    rows = ");
    Str.Append(R,S);

    Str.Append(R,"    rewind = ");
    IF picinfo.rewind THEN
        S:="ON";
    ELSE
        S:="off";
    END;
    Str.Append(R,S);
  END;
END fmtpicinfo;

PROCEDURE createbankname (forcelocal:BOOLEAN;  VAR R:ARRAY OF CHAR   );
VAR
    u,d,n,e:str128;
BEGIN
    Lib.ParamStr(R,0);
    qdSplitAllPath(R, u,d,n,e);
    Lib.MakeAllPath(R, "","",n,extBIN);
    IF forcelocal THEN RETURN; END;
    IF FIO.Exists(R)=FALSE THEN
        Lib.MakeAllPath(R, u,d,n,extBIN);
    END;
END createbankname;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    Ky_lowerC= ORD("c");
    Ky_upperC= ORD("C");
    Ky_lowerR= ORD("r");
    Ky_upperR= ORD("R");
CONST
    mode320x240 = 0;
    mode320x200 = 1;
    mode640x480 = 2; (* vesa *)
    mode800x600 = 3; (* vesa *)
    firstvmode  = mode320x240;
    maxvmode    = mode800x600;
    firstframe  = 1;
    minspeed    = 0;
    maxspeed    = 20;
    mincycle    = 200;
    maxcycle    = 1000;
VAR
    state               : (waiting,gotini,gotspec);
    parmcount,i,opt,got : CARDINAL;
    S,R                 : str128;
    S1,S2,S3,S4         : str16;
    hout,hin            : FIO.File;
    found,batchmode     : BOOLEAN;
    entry               : FIO.DirEntry;
    bankheader          : bankheadertype;
    picinfo             : picinfotype;
    here                : LONGCARD;
    count,animindex     : CARDINAL;
    listPtr             : vpointer;
VAR
    hirestype           : (modex,vesa);
    cmd                 : (unspecified,build,list,show);
    ini,spec,fileBank   : str128;
    skipmissing,saver,buffered,centered,overwrite  : BOOLEAN;
    speed,paper,vmode,orgvmode,keycode : CARDINAL;
    wi,he,lastcode      : CARDINAL;
    wiclip,heclip,xpos,ypos : CARDINAL;
    stopmouse,usevesa,rewind,chk,singlestep      : BOOLEAN;
    currframe,lastframe : CARDINAL;
    xclip,yclip         : CARDINAL;
    motion              : (avance,recule);
    p,cycle,rows,columns        : CARDINAL;
    eyecandy,DEBUG:BOOLEAN;
BEGIN
    Lib.DisableBreakCheck();
    FIO.IOcheck := FALSE;

    WrLn; (* here for pretty output *)

    parmcount := Lib.ParamCount();
    (* IF parmcount = 0 THEN abort(errHelp,"");END; *)

    cmd       := unspecified;
    overwrite := FALSE;
    vmode     := mode320x240;
    animindex := MAX(CARDINAL);
    paper     := 0; (* c_BLACK *)
    speed     := 1;
    centered  := TRUE;
    buffered  := FALSE;
    stopmouse := FALSE;
    saver     := FALSE;
    skipmissing:=TRUE;
    DEBUG     := FALSE;
    eyecandy  := TRUE;

    state     := waiting;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R, "?"+delim+"H"+delim+"HELP"+delim+
                                  "C"+delim+"CREATE"+delim+
                                  "L"+delim+"LIST"+delim+
                                  "O"+delim+"OVERWRITE"+delim+
                                  "M:"+delim+"MODE:"+delim+
                                  "S:"+delim+"SPEED:"+delim+
                                  "R"+delim+"RANDOM"+delim+
                                  "B"+delim+"BUFFERED"+delim+
                                  "M"+delim+"MOUSE"+delim+
                                  "S"+delim+"SAVER"+delim+"SS"+delim+
                                  "V"+delim+"VERIFY"+delim+
                                  "DEBUG"
                              );
            CASE opt OF
            | 1,2,3 : abort(errHelp,"");
            | 4,5   : CASE cmd OF
                      | unspecified,build:cmd:=build;
                      ELSE abort(errCmd,"");
                      END;
            | 6,7   : CASE cmd OF
                      | unspecified,list:cmd:=list;
                      ELSE abort(errCmd,"");
                      END;
            | 8,9   : overwrite:=TRUE;
            | 10,11 : IF getCard(R,vmode)=FALSE THEN abort(errValue,S);END;
                      CASE vmode OF
                      | firstvmode..maxvmode : ;
                      ELSE
                          abort(errMode,S);
                      END;
            | 12,13 : IF getCard(R,speed)=FALSE THEN abort(errValue,S);END;
                      CASE speed OF
                      | minspeed..maxspeed : ;
                      ELSE
                          abort(errSpeed,S);
                      END;
            | 14,15:  centered:=FALSE;
            | 16,17:  buffered:=TRUE;
            | 18,19:  stopmouse:=TRUE;
            | 20,21,22:saver:=TRUE;
            | 23,24:  skipmissing:=FALSE;
            | 25:     DEBUG:=TRUE; eyecandy:=FALSE;
            ELSE
                abort(errOption,S);
            END;
        ELSE
            CASE state OF
            | waiting : Str.Copy(ini,R);
            | gotini  : Str.Copy(spec,R);
            | gotspec : abort(errParameter,S);
            END;
            INC(state);
        END;
    END;
    IF cmd=unspecified THEN cmd:=show; END;
    CASE state OF
    | waiting:
        CASE cmd OF
        | build: abort(errExpected,"-create");
        | list,show: ;
        END;
    | gotini:
        CASE cmd OF
        | build: abort(errExpected,"-create");
        | list: abort(errCmdSyntax,"");
        | show: Str.Concat(S,"-n:",ini);
                IF GetLongCard(ini,here)=FALSE THEN
                   abort(errValue,ini);
                END;
                IF (here < 1) OR (here >= MAX(CARDINAL)) THEN
                   abort(errRange,ini);
                END;
                animindex:=CARDINAL(here);
        END;
    | gotspec:
        CASE cmd OF
        | build : ;
        | list,show: abort(errCmdSyntax,"");
        END;
    END;


    CASE cmd OF
    | build:
        IF chkJoker(ini) THEN abort(errJoker,ini);END;
        IF Str.CharPos(ini,dot)=MAX(CARDINAL) THEN Str.Append(ini,extINI);END;
        IF FIO.Exists(ini)=FALSE THEN abort(errNotFound,ini);END;

        IF same(spec,dot) THEN spec:="*";END;
        forceExt(spec,extPCX);

        createbankname(TRUE,fileBank);

        IF FIO.Exists(fileBank) THEN
            IF overwrite=FALSE THEN abort(errFound,fileBank);END;
        END;

        IF readIniFile(ini)=FALSE THEN abort(errReadIni,ini);END;

        WrStr(Banner);WrLn;
        WrLn;

        hout:=FIO.Create(fileBank);
        FIO.AssignBuffer(hout,ioBufferOut);

        bankheader.ID    := bankMAGIC;
        bankheader.count := 0;
        FIO.WrBin(hout,bankheader,SIZE(bankheader));

        IF eyecandy THEN video(msgProcessing,TRUE); END;

        i:=errNone;
        count:=0;
        found:=FIO.ReadFirstEntry(spec,allfiles,entry);
        IF NOT(found) THEN abort(errNotFound,spec);END;
        LOOP
            IF NOT(found)THEN EXIT; END;
            Str.Copy(S,entry.Name);
            UpperCase(S);
            dbg(DEBUG,"main()","S",S);
            IF eyecandy THEN video(S,TRUE); END;
            IF chkPCX256(S)=FALSE THEN
                i:=errUnsupported;
                EXIT;
            END;
            IF bankappend(hout,DEBUG,S) THEN
                INC(count);
            ELSE
                IF skipmissing=FALSE THEN
                    i:=errUndefined;
                    EXIT;
                END;
            END;
            IF eyecandy THEN video(S,FALSE); END;
            found:=FIO.ReadNextEntry(entry);
        END;

        FIO.Seek(hout,0);
        bankheader.ID    := bankMAGIC;
        bankheader.count := count;
        FIO.WrBin(hout,bankheader,SIZE(bankheader));

        FIO.Flush(hout);
        FIO.Close(hout);

        FreeIni();

        CASE i OF
        | errNone :
            IF eyecandy THEN video(msgProcessing,FALSE); END;
        ELSE
            IF eyecandy THEN
                video(S,FALSE);
                video(msgProcessing,FALSE);
            END;
            abort(i,S);
        END;

        fmtVal( LONGCARD(count),10,1,"",R);
        S:="| has been created from | file(s).";
        Str.Subst(S,"|",fileBank);
        Str.Subst(S,"|",R);
        WrStr(S);WrLn;

    | list:

        createbankname(FALSE,fileBank);

        IF FIO.Exists(fileBank)=FALSE THEN abort(errNotFound,fileBank);END;
        batchmode:=IsRedirected();

        hin:=FIO.OpenRead(fileBank);
        FIO.AssignBuffer(hin,ioBuffer);
        got:=FIO.RdBin(hin,bankheader,SIZE(bankheader));
        IF got # SIZE(bankheader) THEN
            FIO.Close(hin);
            abort(errReadError,fileBank);
        END;
        IF same(bankheader.ID,bankMAGIC)=FALSE THEN
            FIO.Close(hin);
            abort(errBankFormat,fileBank);
        END;

        IF batchmode THEN
            WrLn;
            WrStr("@ECHO OFF");WrLn;
            WrLn;
        END;

        i:=0;
        LOOP
            got:=FIO.RdBin(hin,picinfo,SIZE(picinfotype));
            CASE got OF
            | 0 : EXIT;
            | SIZE(picinfotype) :
                INC(i);
                here:=FIO.GetPos(hin);
                IF batchmode THEN
                    fmtpicinfo(i,FALSE,picinfo, here,fileBank,  R);
                    WrStr("rem ");WrStr(R);WrLn;
                END;
                fmtpicinfo(i,batchmode,picinfo, here,fileBank,  R);
                WrStr(R);WrLn;

                FIO.Seek( hin, here+picinfo.fsize);
            ELSE
                abort(errCorrupted,fileBank);
            END;
        END;

        IF batchmode THEN
            WrLn;
            WrStr("ECHO Done !");WrLn;
        END;

    | show:

        createbankname(FALSE,fileBank);

        IF FIO.Exists(fileBank)=FALSE THEN abort(errNotFound,fileBank);END;

        hin:=FIO.OpenRead(fileBank);
        FIO.AssignBuffer(hin,ioBuffer);
        got:=FIO.RdBin(hin,bankheader,SIZE(bankheader));
        IF got # SIZE(bankheader) THEN
            FIO.Close(hin);
            abort(errReadError,fileBank);
        END;
        IF same(bankheader.ID,bankMAGIC)=FALSE THEN
            FIO.Close(hin);
            abort(errBankFormat,fileBank);
        END;

        IF stopmouse THEN
            IF MsMouse.Reset()=MAX(INTEGER) THEN stopmouse := FALSE; END;
        END;

        INIT_RANDOM();
        FOR i:=1 TO RANDOM_INT(256) DO opt:=RANDOM_INT(256); END;

        count:=bankheader.count;
        IF count = 0 THEN abort(errEmptyBank,fileBank);END;

        IF animindex = MAX(CARDINAL) THEN
            animindex:=getrndrange(1,count);
        ELSE
            IF animindex > count THEN abort(errIndex,"");END;
        END;

        FOR i:=1+1 TO animindex DO
            got:=FIO.RdBin(hin,picinfo,SIZE(picinfotype));
            here:=FIO.GetPos(hin);
            FIO.Seek( hin, here+picinfo.fsize);
        END;
        got:=FIO.RdBin(hin,picinfo,SIZE(picinfotype));

        orgvmode:=vmode;
        CASE vmode OF
        | mode320x240: hirestype:=modex; vmode:=Mode_320x240;
        | mode320x200: hirestype:=modex; vmode:=Mode_320x200;
        | mode640x480: hirestype:=vesa;  vmode:=v640x480x8;
        | mode800x600: hirestype:=vesa;  vmode:=v800x600x8;
        END;

        CASE hirestype OF
        | vesa:
            setvesamoderange(vmode,S);
            IF CheckVesaHere(FALSE,listPtr)=FALSE THEN abort(errNoVesa,""); END;
            IF ModeAvailable(listPtr,vmode)=FALSE THEN abort(errNotAvailable,S); END;
            IF SetVesaMode(vmode) = FALSE THEN HiresOFF; abort(errVesaProblem,S); END;
            IF getVESAmodeInfos (vmode)=FALSE THEN abort(err104F01,"");END;
            IF initVESAbank()=FALSE THEN abort(err104F05,"");END;
            here:=openPCX(hin,picinfo.fsize, paper,wi,he,lastcode);
            usevesa:=TRUE;
        | modex:
            IF HiresON(vmode,S)=FALSE THEN HiresOFF;abort(errModeXproblem,S);END;
            here:=openPCX(hin,picinfo.fsize, paper,wi,he,lastcode);
            usevesa:=FALSE;

            IF buffered THEN
                viewpage:=page1;
                workpage:=page2;
                setviewwork(viewpage,workpage);
                cls(usevesa,paper);
            ELSE
                viewpage:=page1;
                workpage:=page1;
            END;
            setviewwork(viewpage,viewpage);

        END;

        cls(usevesa,paper);

        rows   :=picinfo.rows;
        columns:=picinfo.columns;
        rewind :=picinfo.rewind;
        wiclip :=wi DIV columns;
        heclip :=he DIV rows;

        motion    := avance;
        currframe := firstframe-1; (* trick *)
        lastframe := rows * columns;
        IF lastframe=firstframe THEN rewind:=FALSE; END; (* avoid nonsense *)

        genpos(centered,wiclip,heclip, xpos,ypos);

        singlestep:=FALSE;
        cycle:=getrndrange(mincycle,maxcycle);

        LOOP
            FOR i:=1 TO speed DO SYNC_DISPLAY(); END;
            IF ( NOT(usevesa) AND buffered) THEN
                swap(viewpage,workpage);
                setviewwork(viewpage,workpage);
                modexcls(paper);
            END;

            CASE motion OF
            | avance:
                INC(currframe);
                IF currframe > lastframe THEN
                    IF rewind THEN
                        currframe:=lastframe-1;
                        motion:=recule;
                    ELSE
                        currframe:=firstframe;
                    END;
                END;
            | recule:
                DEC(currframe);
                IF currframe < firstframe THEN
                    currframe:=firstframe;
                    motion:=avance;
                END;
            END;

            decodePCXclip (hin,here,lastcode, xpos,ypos, wiclip,heclip,
                          columns,rows,currframe,usevesa);

            IF singlestep THEN
                LOOP
                    keycode:=SCAN_KEYBOARD();
                    IF keycode # 0 THEN EXIT; END;
                END;
                chk:=(keycode # Ky_SPACE);
                singlestep:=NOT(chk);
            ELSE
                keycode:=SCAN_KEYBOARD();
                chk:=keycode # 0;

                DEC(cycle);
                IF cycle = 0 THEN
                    cycle:=getrndrange(mincycle,maxcycle);
                    chk:=TRUE;keycode:=Ky_Tab;
                END;
            END;
            IF chk THEN
                CASE keycode OF
                | Ky_SPACE : singlestep:=NOT (singlestep);
                | Ky_ESC   : EXIT;
                | Ky_CR    : EXIT;
                | Ky_Minus : IF speed < maxspeed THEN INC(speed);END;
                | Ky_Plus  : IF speed > minspeed THEN DEC(speed);END;
                | Ky_Tab,Ky_F1,Ky_F2,Ky_PgUp,Ky_PgDn :
                    FIO.Seek(hin,0); (* remember ! *)

                    got:=FIO.RdBin(hin,bankheader,SIZE(bankheader));

                    CASE keycode OF
                    | Ky_Tab: animindex:=getrndrange(1,count);
                    | Ky_F1,Ky_PgUp:  DEC(animindex);IF animindex<1 THEN animindex:=count;END;
                    | Ky_F2,Ky_PgDn:  INC(animindex);IF animindex>count THEN animindex:=1;END;
                    END;

                    FOR i:=1+1 TO animindex DO
                        got:=FIO.RdBin(hin,picinfo,SIZE(picinfotype));
                        here:=FIO.GetPos(hin);
                        FIO.Seek( hin, here+picinfo.fsize);
                    END;
                    got:=FIO.RdBin(hin,picinfo,SIZE(picinfotype));

                    here:=openPCX(hin,picinfo.fsize, paper,wi,he,lastcode);

                    rows   :=picinfo.rows;
                    columns:=picinfo.columns;
                    rewind :=picinfo.rewind;
                    wiclip :=wi DIV columns;
                    heclip :=he DIV rows;

                    motion    := avance;
                    currframe := firstframe-1; (* trick *)
                    lastframe := rows * columns;
                    IF lastframe=firstframe THEN rewind:=FALSE; END; (* avoid nonsense *)

                    genpos(centered,wiclip,heclip, xpos,ypos);

                    cls(usevesa,paper);
                | Ky_lowerC,Ky_upperC :
                    centered:=TRUE;
                    genpos(centered,wiclip,heclip, xpos,ypos);
                    cls(usevesa,paper);
                | Ky_lowerR,Ky_upperR :
                    centered:=FALSE;
                    genpos(centered,wiclip,heclip, xpos,ypos);
                    cls(usevesa,paper);
                END;
            END;
            IF stopmouse THEN
                IF mouseclick() THEN EXIT; END;
            END;
        END;

        HiresOFF;
        WrLn;
        fmtVal ( LONGCARD(animindex), 10,1,"", S1);
        fmtVal ( LONGCARD(speed),     10,1,"", S2);

        Str.Concat(S,progEXEname+" ",S1);
        Str.Append(S," -s:"); Str.Append(S,S2);
        IF NOT(centered) THEN Str.Append(S," -r");END;
        IF buffered THEN Str.Append(S," -b");END;
        WrStr(S);WrLn;
    END;

    abort(errNone,"");
END Movie.

