Option Explicit
DefInt A-Z

Const MINQBCOLOR = 0 ' was 0 but was hardly legible on my monitor
Const MAXQBCOLOR = 15

Const MINCOLOR& = 0&
Const MAXCOLOR& = &HFFFFFF

Const KNOTRADIUS = 4

Global Const FIRSTKNOT = 1
Global Const MAXKNOT = 100
Global Const FIRSTKNOTINDEX = FIRSTKNOT - 1
Global Const MAXKNOTINDEX = MAXKNOT + 2

Global Const MINPOINTS = 2
Global Const MAXPOINTS = 100
Global Const SMALLCHANGEPOINTS = 1
Global Const LARGECHANGEPOINTS = 10

Global Const MINSEGMENTS = 2
Global Const MAXSEGMENTS = 50
Global Const SMALLCHANGESEGMENTS = 1
Global Const LARGECHANGESEGMENTS = 5

Global Const MINMINSPEED = 1
Global Const MAXMINSPEED = 50
Global Const SMALLCHANGEMINSPEED = 1
Global Const LARGECHANGEMINSPEED = 5

Global Const MINMAXSPEED = 1
Global Const MAXMAXSPEED = 50
Global Const SMALLCHANGEMAXSPEED = 1
Global Const LARGECHANGEMAXSPEED = 5

Global Const MINTRAILS = 1
Global Const MAXTRAILS = 50
Global Const SMALLCHANGETRAILS = 1
Global Const LARGECHANGETRAILS = 5

Global Const FIRSTTRAILINDEX = 1
Global Const MAXTRAILINDEX = 50 + 1

Global xmin%
Global ymin%
Global xmax%
Global ymax%

Type knotType ' modula code uses real
    xcoor As Integer
    ycoor As Integer
    dx As Integer
    dy As Integer
End Type

Dim knot(FIRSTKNOTINDEX To MAXKNOTINDEX, FIRSTTRAILINDEX To MAXTRAILINDEX)  As knotType
Dim couleur&(FIRSTTRAILINDEX To MAXTRAILINDEX)

Sub blend (ByVal count%, ByVal startink&, ByVal endink&)
Dim r1%, g1%, b1%
Dim r2%, g2%, b2%
Dim r%, g%, b%
Dim ndx%
unpackRGBstring Str$(startink&), r1%, g1%, b1%
unpackRGBstring Str$(endink&), r2%, g2%, b2%

For ndx% = FIRSTTRAILINDEX To count%
    r% = r1% + ((r2% - r1%) * ndx%) \ count%
    g% = g1% + ((g2% - g1%) * ndx%) \ count%
    b% = b1% + ((b2% - b1%) * ndx%) \ count%
    couleur&(ndx%) = RGB(r%, g%, b%)
Next
End Sub

Sub doline (ByVal x1%, ByVal y1%, ByVal x2%, ByVal y2%, ByVal ink&)
    If x1% < xmin% Then Exit Sub
    If x1% >= xmax% Then Exit Sub
    If y1% < ymin% Then Exit Sub
    If y1% >= ymax% Then Exit Sub
    If x2% < xmin% Then Exit Sub
    If x2% >= xmax% Then Exit Sub
    If y2% < ymin% Then Exit Sub
    If y2% >= ymax% Then Exit Sub
    f!picPage(workpage%).Line (x1%, y1%)-(x2%, y2%), ink&
End Sub

Function getrndlongrange& (ByVal lower&, ByVal upper&)
getrndlongrange& = Int((upper& - lower& + 1) * Rnd + lower&)
End Function

Function getrndrange% (ByVal lower%, ByVal upper%)
getrndrange% = Int((upper% - lower% + 1) * Rnd + lower%)
End Function

Sub initknots (ByVal numPts%, ByVal numTrails%)
Dim i%
Dim ndx%

xmin% = 0
ymin% = 0
xmax% = screen.Width \ screen.TwipsPerPixelX + 1' obtain 640 or so now !
ymax% = screen.Height \ screen.TwipsPerPixelY + 1' obtain 480 or so now !

ndx% = FIRSTTRAILINDEX

Randomize
For i% = FIRSTKNOT To numPts%
    knot(i%, ndx%).xcoor = getrndrange%(xmin%, xmax%)
    knot(i%, ndx%).ycoor = getrndrange%(ymin%, ymax%)
    knot(i%, ndx%).dx = newdelta%(gMinSpeed%, gMaxSpeed%)
    knot(i%, ndx%).dy = newdelta%(gMinSpeed%, gMaxSpeed%)
Next

For i% = FIRSTKNOT To numPts%
    For ndx% = numTrails% To FIRSTTRAILINDEX Step -1
        knot(i%, ndx% + 1) = knot(i%, ndx%)
    Next
Next

Select Case gMode%
Case kFIXED, kRANDOM
    For ndx% = numTrails% To FIRSTTRAILINDEX Step -1
        couleur&(ndx%) = gInk&
    Next
Case kFADE
    blend numTrails%, gInk&, gInkFadeTo&
End Select

End Sub

Sub moveknots (ByVal numPts%, ByVal numTrails%)
Dim i%
Dim p%
Dim ndx%

For i% = FIRSTKNOT To numPts%
    For ndx% = numTrails To FIRSTTRAILINDEX Step -1
        knot(i%, ndx% + 1) = knot(i%, ndx%)
    Next
Next

ndx% = FIRSTTRAILINDEX

For i% = FIRSTKNOT To numPts%
    Do
        p% = knot(i%, ndx%).xcoor + knot(i%, ndx%).dx
        If (p% >= xmin%) And (p% < xmax%) Then Exit Do
        knot(i%, ndx%).dx = newdelta(gMinSpeed%, gMaxSpeed%)
    Loop
    knot(i%, ndx%).xcoor = p%
    
    Do
        p% = knot(i%, ndx%).ycoor + knot(i%, ndx%).dy
        If (p% >= ymin%) And (p% < ymax%) Then Exit Do
        knot(i%, ndx%).dy = newdelta(gMinSpeed%, gMaxSpeed%)
    Loop
    knot(i%, ndx%).ycoor = p%
Next
End Sub

Function newdelta% (ByVal lower%, ByVal upper%)
Dim delta%
Do
    delta% = getrndrange%(-upper%, upper%)
    If Abs(delta%) >= lower% Then Exit Do
Loop
newdelta% = delta%
End Function

Sub Parab_Calc (ByVal T!, ByVal D!, ByVal Apx%, ByVal Bpx%, ByVal Cpx%, ByVal Apy%, ByVal Bpy%, ByVal Cpy%, X%, Y%)
Dim T2!
T2! = T! * T!
X% = ((Apx% * T2!) + (Bpx% * T!) + Cpx%) / D!
Y% = ((Apy% * T2!) + (Bpy% * T!) + Cpy%) / D!
End Sub

Sub Parab_ComputeCoeffs (ByVal n%, ByVal ndx%, Apx%, Bpx%, Cpx%, Apy%, Bpy%, Cpy%)
Apx% = knot(n% - 1, ndx%).xcoor - 2 * knot(n%, ndx%).xcoor + knot(n% + 1, ndx%).xcoor
Bpx% = -2 * knot(n% - 1, ndx%).xcoor + 2 * knot(n%, ndx%).xcoor
Cpx% = knot(n% - 1, ndx%).xcoor + knot(n%, ndx%).xcoor
Apy% = knot(n% - 1, ndx%).ycoor - 2 * knot(n%, ndx%).ycoor + knot(n% + 1, ndx%).ycoor
Bpy% = -2 * knot(n% - 1, ndx%).ycoor + 2 * knot(n%, ndx%).ycoor
Cpy% = knot(n% - 1, ndx%).ycoor + knot(n%, ndx%).ycoor
End Sub

Sub ParabolicSpline (ByVal numPts%, ByVal Resolution%, ByVal numTrails%)
Dim ndx%
Dim ink&
Dim i%

f!picPage(workpage%).Cls

    Select Case gMode%
    Case kFIXED
    Case kRANDOM
        'For ndx% = numTrails% To FIRSTTRAILINDEX Step -1
        '    couleur&(ndx% + 1) = couleur&(ndx%)
        'Next
        'Do
        '    'i% = getrndrange%(MINQBCOLOR, MAXQBCOLOR)
        '    'ink& = QBColor(i%)
        '    ink& = getrndlongrange&(MINCOLOR&, MAXCOLOR&)
        '    If ink& <> gPaper& Then Exit Do
        'Loop
        'couleur&(FIRSTTRAILINDEX) = ink&

        ndx% = getrndrange(FIRSTTRAILINDEX, numTrails%)
        Do
            ink& = getrndlongrange&(MINCOLOR&, MAXCOLOR&)
            If ink& <> gPaper& Then Exit Do
        Loop
        couleur&(ndx%) = ink&

    Case kFADE
    End Select

For ndx% = numTrails% To FIRSTTRAILINDEX Step -1
    ParabolicSplineIndividual numPts%, Resolution%, ndx%, couleur&(ndx%)
Next

'updateDateTime

End Sub

Sub ParabolicSplineIndividual (ByVal numPts%, ByVal Resolution%, ByVal ndx%, ByVal ink&)
Dim n%
Dim i%, j%
Dim Apx%, Bpx%, Cpx%, Apy%, Bpy%, Cpy%
Dim lastX%, lastY%, X%, Y%
Dim V1!, res!
Dim half%

n% = numPts%
knot(FIRSTKNOT - 1, ndx%).xcoor = knot(n%, ndx%).xcoor
knot(FIRSTKNOT - 1, ndx%).ycoor = knot(n%, ndx%).ycoor
knot(n% + 1, ndx%).xcoor = knot(FIRSTKNOT, ndx%).xcoor
knot(n% + 1, ndx%).ycoor = knot(FIRSTKNOT, ndx%).ycoor
knot(n% + 2, ndx%).xcoor = knot(FIRSTKNOT + 1, ndx%).xcoor
knot(n% + 2, ndx%).ycoor = knot(FIRSTKNOT + 1, ndx%).ycoor

lastX% = knot(FIRSTKNOT, ndx%).xcoor
lastY% = knot(FIRSTKNOT, ndx%).ycoor

    res! = Resolution%
    half% = Resolution% \ 2

    i% = FIRSTKNOT
    Parab_ComputeCoeffs i%, ndx%, Apx%, Bpx%, Cpx%, Apy%, Bpy%, Cpy%
    For j% = 0 To Resolution%
        V1! = j%
        Parab_Calc V1! / res!, 2#, Apx%, Bpx%, Cpx%, Apy%, Bpy%, Cpy%, X%, Y%
        If j% >= half% Then
            doline lastX%, lastY%, X%, Y%, ink&
        End If
        lastX% = X%
        lastY% = Y%
    Next

For i% = FIRSTKNOT + 1 To n%
    Parab_ComputeCoeffs i%, ndx%, Apx%, Bpx%, Cpx%, Apy%, Bpy%, Cpy%
    For j% = 0 To Resolution%
        V1! = j%
        Parab_Calc V1! / res!, 2#, Apx%, Bpx%, Cpx%, Apy%, Bpy%, Cpy%, X%, Y%
        doline lastX%, lastY%, X%, Y%, ink&
        lastX = X%
        lastY% = Y%
    Next
Next

    i% = n% + 1
    Parab_ComputeCoeffs i%, ndx%, Apx%, Bpx%, Cpx%, Apy%, Bpy%, Cpy%
    For j% = 0 To Resolution%
        V1! = j%
        Parab_Calc V1! / res!, 2#, Apx%, Bpx%, Cpx%, Apy%, Bpy%, Cpy%, X%, Y%
        If j% < half% Then
            doline lastX%, lastY%, X%, Y%, ink&
        End If
        lastX% = X%
        lastY% = Y%
    Next

End Sub

Sub showknots (ByVal numPts%)
Dim i%
Dim X%, Y%
Dim ndx%

ndx% = FIRSTTRAILINDEX

For i% = FIRSTKNOT To numPts%
    X% = knot(i%, ndx%).xcoor
    Y% = knot(i%, ndx%).ycoor
    f!picPage(workpage%).Circle (X%, Y%), KNOTRADIUS, gInk&
Next
End Sub

