Option Explicit
DefInt A-Z

Function BoolToChk% (ByVal flag%)
Select Case flag%
Case True
    flag% = CHECKED
Case False
    flag% = UNCHECKED
End Select
BoolToChk% = flag%
End Function

Sub doChangePassword ()
Set ff = frmSetPassword
ff.Hide
doChangePasswordMain
Unload ff
End Sub

Sub doSetupCancel ()
Unload f
End Sub

Sub doSetupMain ()
Set f = frmSetup

retrieveParameters

f.Visible = False
f.AutoRedraw = True
' f.ControlBox = False
' f.MaxButton = False
' f.MinButton = False
' f.BorderStyle = DOUBLEFIXED
f.Caption = title$ + " " + culprit$ + " : Setup"
f.WindowState = NORMAL

centerform f

showSetupParms

f.Show
f.Visible = True
End Sub

Sub doSetupOK ()
saveSetupParms
Unload f
End Sub

Sub doSetupRestoreDefaults ()
Dim flag%
' security

gPasswordProtected% = dPasswordProtected%
gMaxPasswordWait% = dMaxPasswordWait%

gShowNow% = dShowNow%
gNowLanguage% = dNowLanguage%
gNowFont$ = dNowFont$
gNowSize% = dNowSizeNDX%

gNowBold% = dNowBold%
gNowInk& = dNowInk&
gNowMoveInterval% = dNowMoveInterval%
gNowMove% = dNowMove%
gNowMaxMove% = dNowMaxMove%

gPaper& = dPaper&
gInk& = dInk&
gControlPoints% = dControlPoints%
gSegments% = dSegments%
gMinSpeed% = dMinSpeed%
gMaxSpeed% = dMaxSpeed%
gTrails% = dTrails%
gMode% = dMode%

showSetupParms
End Sub

Sub saveSetupParms ()
Dim rc%
Dim s$
Dim i%

' update all flags according to form

' security (password itself already updated)
s$ = chkToStr$(f!chkPasswordProtected.Value)
rc% = writeIni%(ini$, sSection$, ePasswordProtected$, s$)

s$ = fmtInt$(gMaxPasswordWait%)
rc% = writeIni%(ini$, sSection$, eMaxPasswordWait$, s$)

' date and time

s$ = chkToStr$(f!chkShowNow.Value)
rc% = writeIni%(ini$, sSection$, eShowNow$, s$)

Select Case f!lstNowLanguage.ListIndex
Case kFR: s$ = lFR$
Case kUS: s$ = lUS$
End Select
rc% = writeIni%(ini$, sSection$, eNowLanguage$, s$)

i% = f!lstNowFont.ListIndex
s$ = f!lstNowFont.List(i%)
rc% = writeIni%(ini$, sSection$, eNowFont$, s$)

i% = f!lstNowSize.ListIndex
Select Case i%
Case kFONT8: s$ = "8.25"
Case kFONT10: s$ = "9.75"
Case kFONT12: s$ = "12"
Case kFONT14: s$ = "13.5"
Case Else: s$ = dNowSize$
End Select
rc% = writeIni%(ini$, sSection$, eNowSize$, s$)

s$ = chkToStr$(f!chkNowBold.Value)
rc% = writeIni%(ini$, sSection$, eNowBold$, s$)

s$ = "&h" + Hex$(f!lblNowInk.BackColor) + "&"
rc% = writeIni%(ini$, sSection$, eNowInk$, s$)

s$ = fmtInt$(gNowMoveInterval%)
rc% = writeIni%(ini$, sSection$, eNowMoveInterval$, s$)

s$ = fmtInt$(gNowMove%)
rc% = writeIni%(ini$, sSection$, eNowMove$, s$)

s$ = fmtInt$(gNowMaxMove%)
rc% = writeIni%(ini$, sSection$, eNowMaxMove$, s$)

s$ = fmtInt$(gRefreshNow%)
rc% = writeIni%(ini$, sSection$, eRefreshNow$, s$)

' screen

s$ = "&h" + Hex$(f!lblPaper.BackColor) + "&"
rc% = writeIni%(ini$, sSection$, ePaper$, s$)

s$ = "&h" + Hex$(f!lblInk.BackColor) + "&"
rc% = writeIni%(ini$, sSection$, eInk$, s$)

s$ = "&h" + Hex$(f!lblInkFadeTo.BackColor) + "&"
rc% = writeIni%(ini$, sSection$, eInkFadeTo$, s$)

s$ = fmtInt$(f!hbarControlPoints.Value)
rc% = writeIni%(ini$, sSection$, eControlPoints$, s$)

s$ = fmtInt$(f!hbarSegments.Value)
rc% = writeIni%(ini$, sSection$, eSegments$, s$)

s$ = fmtInt$(f!hbarMinSpeed.Value)
rc% = writeIni%(ini$, sSection$, eMinSpeed$, s$)

s$ = fmtInt$(f!hbarMaxSpeed.Value)
rc% = writeIni%(ini$, sSection$, eMaxSpeed$, s$)

s$ = fmtInt$(f!hbarTrails.Value)
rc% = writeIni%(ini$, sSection$, eTrails$, s$)

i% = f!lstMode.ListIndex
Select Case i%
Case kFIXED: s$ = lFIXED$
Case kRANDOM: s$ = lRANDOM$
Case kFADE: s$ = lFADE$
End Select
rc% = writeIni%(ini$, sSection$, eMode$, s$)

s$ = chkToStr$(f!chkBoldLines.Value)
rc% = writeIni%(ini$, sSection$, eBoldLines$, s$)

End Sub

Sub showSetupParms ()
Dim c As Control
Dim i%
Dim s$
Dim ok%

' init lists

Set c = f!lstNowLanguage
'c.Sorted = False
'c.Style = dropdown list
c.Clear
c.AddItem "French", kFR
c.AddItem "English", kUS

Set c = f!lstNowFont
'c.Sorted = true
'c.Style = dropdown list
c.Clear
For i% = 0 To screen.FontCount - 1
    c.AddItem screen.Fonts(i%)
Next

Set c = f!lstNowSize
'c.Sorted = False
'c.Style = dropdown list
c.Clear
c.AddItem "8.25", kFONT8
c.AddItem "9.75", kFONT10
c.AddItem "12", kFONT12
c.AddItem "13.5", kFONT14

Set c = f!lstMode
'c.Sorted = False
'c.Style = dropdown list
c.Clear
c.AddItem "Fixed color", kFIXED
c.AddItem "Random colors", kRANDOM
c.AddItem "Fade", kFADE

' security

f!chkPasswordProtected.Value = BoolToChk%(gPasswordProtected%)

' date and time

f!chkShowNow.Value = BoolToChk%(gShowNow%)

f!lstNowLanguage.ListIndex = gNowLanguage%

ok% = False
s$ = UCase$(gNowFont$)
For i% = 0 To screen.FontCount - 1
    If s$ = UCase$(f!lstNowFont.List(i%)) Then
        f!lstNowFont.ListIndex = i%
        ok% = True
        Exit For
    End If
Next
If ok% = False Then
    f!lstNowFont.ListIndex = 1
End If

f!lstNowSize.ListIndex = gNowSize%

f!chkNowBold.Value = BoolToChk%(gNowBold%)

f!lblNowInk.Caption = ""
f!lblNowInk.BackColor = gNowInk&

' animation

Set c = f!hbarControlPoints
c.Min = MINPOINTS
c.Max = MAXPOINTS
c.SmallChange = SMALLCHANGEPOINTS
c.LargeChange = LARGECHANGEPOINTS
c.Value = gControlPoints%
f!lblControlPoints.Alignment = CENTER
updateValue c, f!lblControlPoints

Set c = f!hbarSegments
c.Min = MINSEGMENTS
c.Max = MAXSEGMENTS
c.SmallChange = SMALLCHANGESEGMENTS
c.LargeChange = LARGECHANGESEGMENTS
c.Value = gSegments%
f!lblSegments.Alignment = CENTER
updateValue c, f!lblSegments

Set c = f!hbarMinSpeed
c.Min = MINMINSPEED
c.Max = MAXMINSPEED
c.SmallChange = SMALLCHANGEMINSPEED
c.LargeChange = LARGECHANGEMINSPEED
c.Value = gMinSpeed%
f!lblMinSpeed.Alignment = CENTER
updateValue c, f!lblMinSpeed

Set c = f!hbarMaxSpeed
c.Min = MINMAXSPEED
c.Max = MAXMAXSPEED
c.SmallChange = SMALLCHANGEMAXSPEED
c.LargeChange = LARGECHANGEMAXSPEED
c.Value = gMaxSpeed%
f!lblMaxSpeed.Alignment = CENTER
updateValue c, f!lblMaxSpeed

Set c = f!hbarTrails
c.Min = MINTRAILS
c.Max = MAXTRAILS
c.SmallChange = SMALLCHANGETRAILS
c.LargeChange = LARGECHANGETRAILS
c.Value = gTrails%
f!lblTrails.Alignment = CENTER
updateValue c, f!lblTrails

f!lstMode.ListIndex = gMode%

f!lblPaper.Caption = ""
f!lblPaper.BackColor = gPaper&

f!lblInk.Caption = ""
f!lblInk.BackColor = gInk&

f!lblInkFadeTo.Caption = ""
f!lblInkFadeTo.BackColor = gInkFadeTo&

f!chkBoldLines.Value = BoolToChk%(gBoldLines%)

' update if required
updateSecurityParms
updateSample
End Sub

Sub updateSample ()
Dim s$
Dim flag%
Dim i%

f!lblNowSamplePaper.Caption = ""
f!lblNowSamplePaper.BackColor = f!lblPaper.BackColor

If f!chkShowNow.Value = CHECKED Then
    Select Case f!lstNowLanguage.ListIndex
    Case kFR: s$ = "Bonjour !"
    Case kUS: s$ = "Hello !"
    End Select
Else
    s$ = ""
End If
f!lblNowSampleInk.Caption = s$
f!lblNowSampleInk.BackColor = f!lblPaper.BackColor
f!lblNowSampleInk.ForeColor = f!lblNowInk.BackColor
i% = f!lstNowFont.ListIndex
If i% >= 0 Then
    s$ = f!lstNowFont.List(i%)
    f!lblNowSampleInk.FontName = s$
End If
Select Case f!lstNowSize.ListIndex
Case kFONT8: s$ = "8.25"
Case kFONT10: s$ = "9.75"
Case kFONT12: s$ = "12"
Case kFONT14: s$ = "13.5"
Case Else: s$ = "13.5"
End Select
f!lblNowSampleInk.FontSize = Val(s$)
flag% = f!chkNowBold.Value
flag% = chkToBool%(flag%)
f!lblNowSampleInk.FontBold = flag%
f!lblNowSampleInk.Alignment = CENTER
End Sub

Sub updateSecurityParms ()
Dim flag%
flag% = f!chkPasswordProtected.Value
flag% = chkToBool%(flag%)
f!cmdSetPassword.Enabled = flag%
End Sub

Sub updateValue (bar As Control, lbl As Control)
Dim s$
s$ = fmtInt$(bar.Value)
lbl.Caption = s$
End Sub

