Option Explicit
DefInt A-Z

Function BoolToChk% (ByVal flag%)
Select Case flag%
Case True
    flag% = CHECKED
Case False
    flag% = UNCHECKED
End Select
BoolToChk% = flag%
End Function

Sub doChangePassword ()
Set ff = frmSetPassword
ff.Hide
doChangePasswordMain
Unload ff
End Sub

Sub doSample ()
Dim s$
Dim rc%
Dim i%
Dim c As control

'background
f!lblSamplePaper.BackColor = f!lblPaper.BackColor

'date and time
i% = f!clstFontDateAndTime.ListIndex
If i% >= 0 Then
    s$ = f!clstFontDateAndTime.List(i%)
    f!lblSampleDateAndTime.FontName = s$
End If

Set c = f!clstSizeDateAndTime
Select Case c.ListIndex
Case kFONT8: s$ = "8.25"
Case kFONT10: s$ = "9.75"
Case kFONT12: s$ = "12"
Case kFONT14: s$ = "13.5"
Case kFONT18: s$ = "18"
End Select
If s$ <> "" Then f!lblSampleDateAndTime.FontSize = Val(s$)

f!lblSampleDateAndTime.ForeColor = f!lblInkDateAndTime.BackColor

rc% = f!chkBoldDateAndTime.Value
rc% = chkToBool%(rc%)
f!lblSampleDateAndTime.FontBold = rc%

'countdown
i% = f!clstFontCountdown.ListIndex
If i% >= 0 Then
    s$ = f!clstFontCountdown.List(i%)
    f!lblSampleCountdown.FontName = s$
End If

Set c = f!clstSizeCountdown
Select Case c.ListIndex
Case kFONT8: s$ = "8.25"
Case kFONT10: s$ = "9.75"
Case kFONT12: s$ = "12"
Case kFONT14: s$ = "13.5"
Case kFONT18: s$ = "18"
End Select
If s$ <> "" Then f!lblSampleCountdown.FontSize = Val(s$)

f!lblSampleCountdown.ForeColor = f!lblInkCountdown.BackColor

rc% = f!chkBoldCountdown.Value
rc% = chkToBool%(rc%)
f!lblSampleCountdown.FontBold = rc%

End Sub

Sub doSetupCancel ()
Unload f
End Sub

Sub doSetupMain ()
Set f = frmSetup

retrieveParameters

f.Visible = False
f.AutoRedraw = True
' f.ControlBox = False
' f.MaxButton = False
' f.MinButton = False
' f.BorderStyle = DOUBLEFIXED
f.Caption = title$ + " " + culprit$ + " : Setup"
f.WindowState = NORMAL

OngletsInitialisation f

centerform f
showSetupParms

f.Show
f.Visible = True
End Sub

Sub doSetupOK ()
saveSetupParms
Unload f
End Sub

Sub doSetupRestoreDefaults ()
Dim flag%
' security

savPasswordProtected% = defaultPasswordProtected%
savPasswordProtected% = False ' force it alas...

savPassword$ = defaultPassword$

' sound
savChimeOnStart% = defaultChimeOnStart
savChimeAtHour% = defaultChimeAtHour
savChimeAtHalfHour% = defaultChimeAtHalfHour
savChimeOnExit% = defaultChimeOnExit%

savHourSound$ = LCase$(fixname$(exedir$, defaultHourSound$))
savHalfHourSound$ = LCase$(fixname$(exedir$, defaultHalfHourSound$))

' deadline

flag% = parseDate%(defaultDeadlineDate$, savDay%, savMonth%, savYear%)
flag% = parseTime%(defaultDeadlineTime$, False, savHH%, savMM%, savSS%)

' universal time correction

flag% = parseTime%(defaultDeltaUT$, True, savHHUT%, savMMUT%, savSSUT%)

' display

savIncludeTodayInDaysRemaining% = defaultIncludeTodayInDaysRemaining%
savShowLanguage$ = defaultShowLanguage$
savShowDateAndTime% = defaultShowDateAndTime%
savShowUT% = defaultShowUT%
savDateFormat$ = defaultDateFormat$
savRemainingFormat$ = defaultRemainingFormat$

' undocumented for main screen (not in setup)
' fontsize should be [6..18], other numerical values should be checked
' paper is useless now for we force transparency...

savPaperRGB$ = rgbToHex$(defaultPaperRGB$)
savFontDateAndTime$ = defaultFont$
savBoldDateAndTime% = defaultBold%
savSizeDateAndTime% = defaultSize%
savInkRGBDateAndTime$ = rgbToHex$(defaultInkRGB$)
savFontCountdown$ = defaultFont$
savBoldCountdown% = defaultBold%
savSizeCountdown% = defaultSize%
savInkRGBCountdown$ = rgbToHex$(defaultInkRGB$)

' messages

BeforeFR1$ = defaultBeforeFR1$
BeforeFR3$ = defaultBeforeFR3$
AfterFR1$ = defaultAfterFR1$
AfterFR3$ = defaultAfterFR3$
VerityFR$ = defaultVerityFR$

BeforeUS1$ = defaultBeforeUS1$
BeforeUS3$ = defaultBeforeUS3$
AfterUS1$ = defaultAfterUS1$
AfterUS3$ = defaultAfterUS3$
VerityUS$ = defaultVerityUS$

' undocumented

savRefreshInterval$ = defaultRefreshInterval$
savMoveInterval$ = defaultMoveInterval$
savMotion$ = defaultMotion$
savMaxMotion$ = defaultMaxMotion$
savMaxPasswordWait$ = defaultMaxPasswordWait$
savPictureFile$ = LCase$(fixname$(exedir$, defaultPictureFile$))

' preset events cannot be changed, useless to reset them !

showSetupParms
End Sub

Function fmtMonth$ (ByVal M%)
Dim s$
Select Case M%
Case 1: s$ = "Jan"
Case 2: s$ = "Feb"
Case 3: s$ = "Mar"
Case 4: s$ = "Apr"
Case 5: s$ = "May"
Case 6: s$ = "Jun"
Case 7: s$ = "Jul"
Case 8: s$ = "Aug"
Case 9: s$ = "Sep"
Case 10: s$ = "Oct"
Case 11: s$ = "Nov"
Case 12: s$ = "Dec"
Case Else
    s$ = "???"
End Select
fmtMonth$ = s$
End Function

Function fmtVal$ (ByVal v%, digits%)
Dim s$
Dim i%
s$ = Str$(Abs(v%)) ' if < 0 !
s$ = Trim$(s$) ' remove leading space
For i = 1 To digits%
    If Len(s$) < digits% Then s$ = "0" + s$
Next
fmtVal$ = s$
End Function

Sub saveSetupParms ()
Dim rc%
Dim s$

' update all flags according to form

' security (password itself already updated)
s$ = chkToStr$(f!chkPasswordProtected.Value)
rc% = writeIni%(ini$, sSection$, ePasswordProtected$, s$)

' sound
s$ = chkToStr$(f!chkChimeOnStart.Value)
rc% = writeIni%(ini$, sSection$, eChimeOnStart$, s$)
s$ = chkToStr$(f!chkChimeAtHour.Value)
rc% = writeIni%(ini$, sSection$, eChimeAtHour$, s$)
s$ = chkToStr$(f!chkChimeAtHalfHour.Value)
rc% = writeIni%(ini$, sSection$, eChimeAtHalfHour$, s$)
s$ = chkToStr$(f!chkChimeOnExit.Value)
rc% = writeIni%(ini$, sSection$, eChimeOnExit$, s$)
s$ = savHourSound$
rc% = writeIni%(ini$, sSection$, eHourSound$, s$)
s$ = savHalfHourSound$
rc% = writeIni%(ini$, sSection$, eHalfHourSound$, s$)

' deadline
s$ = f!txtDay.Text + "-" + f!txtMonth.Text + "-" + f!txtYear.Text
rc% = writeIni%(ini$, sSection$, eDeadlineDate$, s$)
s$ = f!txtHours.Text + ":" + f!txtMinutes.Text + ":" + f!txtSeconds.Text
rc% = writeIni%(ini$, sSection$, eDeadlineTime$, s$)

' universal time correction
s$ = f!txtHoursUT.Text + ":" + f!txtMinutesUT.Text + ":" + f!txtSecondsUT.Text
Select Case f!clstSign.ListIndex
Case kMINUS: s$ = "-" + s$
Case kPLUS: s$ = "+" + s$
End Select
rc% = writeIni%(ini$, sSection$, eDeltaUT$, s$)

' display

s$ = chkToStr$(f!chkIncludeTodayInDaysRemaining.Value)
rc% = writeIni%(ini$, sSection$, eIncludeTodayInDaysRemaining$, s$)

Select Case f!clstLanguage.ListIndex
Case kFRENCH: s$ = "FR"
Case kENGLISH: s$ = "US"
End Select
rc% = writeIni%(ini$, sSection$, eShowLanguage$, s$)

s$ = chkToStr$(f!chkShowDateAndTime.Value)
rc% = writeIni%(ini$, sSection$, eShowDateAndTime$, s$)

s$ = chkToStr$(f!chkShowUT.Value)
rc% = writeIni%(ini$, sSection$, eShowUT$, s$)

Select Case f!clstDateFormat.ListIndex
Case kDMY: s$ = "DMY"
Case kMDY: s$ = "MDY"
End Select
rc% = writeIni%(ini$, sSection$, eDateFormat$, s$)

Select Case f!clstRemainingFormat.ListIndex
Case kD: s$ = "D"
Case kH: s$ = "H"
Case kM: s$ = "M"
Case kDH: s$ = "DH"
Case kDHM: s$ = "DHM"
End Select
rc% = writeIni%(ini$, sSection$, eRemainingFormat$, s$)

' messages

s$ = f!txtBeforeFR1.Text
rc% = writeIni%(ini$, sSection$, eBeforeFR1$, s$)
s$ = f!txtBeforeFR3.Text
rc% = writeIni%(ini$, sSection$, eBeforeFR3$, s$)
s$ = f!txtAfterFR1.Text
rc% = writeIni%(ini$, sSection$, eAfterFR1$, s$)
s$ = f!txtAfterFR3.Text
rc% = writeIni%(ini$, sSection$, eAfterFR3$, s$)
s$ = f!txtVerityFR.Text
rc% = writeIni%(ini$, sSection$, eVerityFR$, s$)

s$ = f!txtBeforeUS1.Text
rc% = writeIni%(ini$, sSection$, eBeforeUS1$, s$)
s$ = f!txtBeforeUS3.Text
rc% = writeIni%(ini$, sSection$, eBeforeUS3$, s$)
s$ = f!txtAfterUS1.Text
rc% = writeIni%(ini$, sSection$, eAfterUS1$, s$)
s$ = f!txtAfterUS3.Text
rc% = writeIni%(ini$, sSection$, eAfterUS3$, s$)
s$ = f!txtVerityUS.Text
rc% = writeIni%(ini$, sSection$, eVerityUS$, s$)

' undocumented for main screen (not in setup)
' paper is useless now for we force transparency

s$ = "&h" + Hex$(f!lblPaper.BackColor) + "&"
rc% = writeIni%(ini$, sSection$, ePaperRGB$, s$)

s$ = f!clstFontDateAndTime.List(f!clstFontDateAndTime.ListIndex)
rc% = writeIni%(ini$, sSection$, eFontDateAndTime$, s$)
Select Case f!clstSizeDateAndTime.ListIndex
Case kFONT8: s$ = "8.25"
Case kFONT10: s$ = "9.75"
Case kFONT12: s$ = "12"
Case kFONT14: s$ = "13.5"
End Select
rc% = writeIni%(ini$, sSection$, eSizeDateAndTime$, s$)
s$ = "&h" + Hex$(f!lblInkDateAndTime.BackColor) + "&"
rc% = writeIni%(ini$, sSection$, eInkRGBDateAndTime$, s$)
s$ = chkToStr$(f!chkBoldDateAndTime.Value)
rc% = writeIni%(ini$, sSection$, eBoldDateAndTime$, s$)

s$ = f!clstFontCountdown.List(f!clstFontCountdown.ListIndex)
rc% = writeIni%(ini$, sSection$, eFontCountdown$, s$)
Select Case f!clstSizeCountdown.ListIndex
Case kFONT8: s$ = "8.25"
Case kFONT10: s$ = "9.75"
Case kFONT12: s$ = "12"
Case kFONT14: s$ = "13.5"
Case kFONT18: s$ = "18"
End Select
rc% = writeIni%(ini$, sSection$, eSizeCountdown$, s$)
s$ = "&h" + Hex$(f!lblInkCountdown.BackColor) + "&"
rc% = writeIni%(ini$, sSection$, eInkRGBCountdown$, s$)
s$ = chkToStr$(f!chkBoldCountdown.Value)
rc% = writeIni%(ini$, sSection$, eBoldCountdown$, s$)

s$ = savPictureFile$
rc% = writeIni%(ini$, sSection$, ePictureFile$, s$)

' undocumented

s$ = savRefreshInterval$
rc% = writeIni%(ini$, sSection$, eRefreshInterval$, s$)
s$ = savMoveInterval$
rc% = writeIni%(ini$, sSection$, eMoveInterval$, s$)

s$ = savMotion$
rc% = writeIni%(ini$, sSection$, eMotion$, s$)
s$ = savMaxMotion$
rc% = writeIni%(ini$, sSection$, eMaxMotion$, s$)

s$ = savMaxPasswordWait$
rc% = writeIni%(ini$, sSection$, eMaxPasswordWait$, s$)

' save at least first three default events

s$ = defaultPreset1$
rc% = writeIni%(ini$, sSection$, ePreset$ + "1", s$)
s$ = defaultPreset2$
rc% = writeIni%(ini$, sSection$, ePreset$ + "2", s$)
s$ = defaultPreset3$
rc% = writeIni%(ini$, sSection$, ePreset$ + "3", s$)

End Sub

Sub showSetupParms ()
Dim c As control
Dim i%
Dim s$
Dim ok%

' reinit lists

Set c = f!clstSign
'c.Sorted = False
'c.Style = dropdown list
c.Clear
c.AddItem "Minus", kMINUS
c.AddItem "Plus", kPLUS

Set c = f!clstLanguage
'c.Sorted = False
'c.Style = dropdown list
c.Clear
c.AddItem "French", kFRENCH
c.AddItem "English", kENGLISH

Set c = f!clstDateFormat
'c.Sorted = False
'c.Style = dropdown list
c.Clear
c.AddItem "Day Month Year", kDMY
c.AddItem "Month Day Year", kMDY

Set c = f!clstRemainingFormat
'c.Sorted = False
'c.Style = dropdown list
c.Clear
c.AddItem "Days (24 hours)", kD
c.AddItem "Hours", kH
c.AddItem "Minutes", kM
c.AddItem "Days Hours", kDH
c.AddItem "Days Hours Minutes", kDHM

Set c = f!clstSizeDateAndTime
'c.Sorted = False
'c.Style = dropdown list
c.Clear
c.AddItem "8.25", kFONT8
c.AddItem "9.75", kFONT10
c.AddItem "12", kFONT12
c.AddItem "13.5", kFONT14

Set c = f!clstSizeCountdown
'c.Sorted = False
'c.Style = dropdown list
c.Clear
c.AddItem "8.25", kFONT8
c.AddItem "9.75", kFONT10
c.AddItem "12", kFONT12
c.AddItem "13.5", kFONT14
c.AddItem "18", kFONT18

Set c = f!clstFontDateAndTime
'c.Sorted = true
'c.Style = dropdown list
c.Clear
For i% = 0 To screen.FontCount - 1
    c.AddItem screen.Fonts(i%)
Next

Set c = f!clstFontCountdown
'c.Sorted = true
'c.Style = dropdown list
c.Clear
For i% = 0 To screen.FontCount - 1
    c.AddItem screen.Fonts(i%)
Next

Set c = f!clstPreset
'c.Sorted=false
'c.style = dropdown list
c.Clear
For i% = MINPRESET To presetNdx%
    c.AddItem presetData(i%).presetTitle$
Next
If presetNdx% < MINPRESET Then
    c.Enabled = False
Else
    c.Enabled = True
    c.ListIndex = 0
End If
f!lblPreset.Enabled = c.Enabled

' security
f!chkPasswordProtected.Value = BoolToChk%(savPasswordProtected%)
updateSecurityParms
' sound
f!chkChimeOnStart.Value = BoolToChk%(savChimeOnStart%)
f!chkChimeAtHour.Value = BoolToChk%(savChimeAtHour%)
f!chkChimeAtHalfHour.Value = BoolToChk%(savChimeAtHalfHour%)
f!chkChimeOnExit.Value = BoolToChk%(savChimeOnExit%)
' deadline
f!txtDay.Text = fmtVal$(savDay%, 2)
f!txtMonth.Text = fmtMonth$(savMonth%)
f!txtYear.Text = fmtVal$(savYear%, 4)

f!txtHours.Text = fmtVal$(savHH%, 2)
f!txtMinutes.Text = fmtVal$(savMM%, 2)
f!txtSeconds.Text = fmtVal$(savSS%, 2)
' universal time correction
f!txtHoursUT.Text = fmtVal$(Abs(savHHUT%), 2)
f!txtMinutesUT.Text = fmtVal$(savMMUT%, 2)
f!txtSecondsUT.Text = fmtVal$(savSSUT%, 2)
Select Case savHHUT%
Case Is < 0: i% = kMINUS
Case Else: i% = kPLUS
End Select
f!clstSign.ListIndex = i%
' display
f!chkShowDateAndTime.Value = BoolToChk%(savShowDateAndTime%)
f!chkShowUT.Value = BoolToChk%(savShowUT%)
f!chkIncludeTodayInDaysRemaining.Value = BoolToChk%(savIncludeTodayInDaysRemaining%)

Select Case savShowLanguage$
Case "FR": i% = kFRENCH
Case "US": i% = kENGLISH
End Select
f!clstLanguage.ListIndex = i%

Select Case savDateFormat$
Case "DMY": i% = kDMY
Case "MDY": i% = kMDY
End Select
f!clstDateFormat.ListIndex = i%

Select Case savRemainingFormat$
Case "D": i% = kD
Case "H": i% = kH
Case "M": i% = kM
Case "DH": i% = kDH
Case "DHM": i% = kDHM
End Select
f!clstRemainingFormat.ListIndex = i%

' messages
f!txtBeforeFR1.Text = BeforeFR1$
f!txtBeforeFR3.Text = BeforeFR3$
f!txtAfterFR1.Text = AfterFR1$
f!txtAfterFR3.Text = AfterFR3$
f!txtVerityFR.Text = VerityFR$

f!txtBeforeUS1.Text = BeforeUS1$
f!txtBeforeUS3.Text = BeforeUS3$
f!txtAfterUS1.Text = AfterUS1$
f!txtAfterUS3.Text = AfterUS3$
f!txtVerityUS.Text = VerityUS$

' files
f!lblHourSound.Caption = savHourSound$
f!lblHalfHourSound.Caption = savHalfHourSound$

f!lblPictureFile.Caption = savPictureFile$

' fonts and colors
f!lblPaper.Caption = ""
f!lblPaper.BackColor = Val(savPaperRGB$)

f!lblInkDateAndTime.Caption = ""
f!lblInkDateAndTime.BackColor = Val(savInkRGBDateAndTime$)
f!chkBoldDateAndTime.Value = BoolToChk(savBoldDateAndTime%)

f!lblInkCountdown.Caption = ""
f!lblInkCountdown.BackColor = Val(savInkRGBCountdown$)
f!chkBoldCountdown.Value = BoolToChk(savBoldCountdown%)

f!lblSamplePaper.Caption = ""

f!lblSampleDateAndTime.Caption = "PhG"
f!lblSampleDateAndTime.Alignment = CENTER
f!lblSampleDateAndTime.BackStyle = BACK_TRANSPARENT

f!lblSampleCountdown.Caption = "PhG"
f!lblSampleCountdown.Alignment = CENTER
f!lblSampleCountdown.BackStyle = BACK_TRANSPARENT

Select Case savSizeDateAndTime%
Case Is < 9: i% = kFONT8
Case Is < 11: i% = kFONT10
Case Is < 13: i% = kFONT12
Case Else: i% = kFONT14
End Select
f!clstSizeDateAndTime.ListIndex = i%

Select Case savSizeCountdown%
Case Is < 9: i% = kFONT8
Case Is < 11: i% = kFONT10
Case Is < 13: i% = kFONT12
Case Is < 15: i% = kFONT14
Case Else: i% = kFONT18
End Select
f!clstSizeCountdown.ListIndex = i%

ok% = False
s$ = UCase$(savFontDateAndTime$)
For i% = 0 To screen.FontCount - 1
    If s$ = UCase$(f!clstFontDateAndTime.List(i%)) Then
        f!clstFontDateAndTime.ListIndex = i%
        ok% = True
        Exit For
    End If
Next
If ok% = False Then
    f!clstFontDateAndTime.ListIndex = 1
End If

ok% = False
s$ = UCase$(savFontCountdown$)
For i% = 0 To screen.FontCount - 1
    If s$ = UCase$(f!clstFontCountdown.List(i%)) Then
        f!clstFontCountdown.ListIndex = i%
        ok% = True
        Exit For
    End If
Next
If ok% = False Then
    f!clstFontCountdown.ListIndex = 1
End If

doSample

updateDisplayParms
End Sub

Sub updateDeadlineDateTime ()
Dim i%
i% = f!clstPreset.ListIndex + 1
' deadline
f!txtDay.Text = fmtVal$(presetData(i%).theDay%, 2)
f!txtMonth.Text = fmtMonth$(presetData(i%).theMonth%)
f!txtYear.Text = fmtVal$(presetData(i%).theYear%, 4)

f!txtHours.Text = fmtVal$(presetData(i%).theHH%, 2)
f!txtMinutes.Text = fmtVal$(presetData(i%).theMM%, 2)
f!txtSeconds.Text = fmtVal$(presetData(i%).theSS%, 2)
End Sub

Sub updateDisplayParms ()
Dim flag%
Dim rc%

flag% = f!chkShowDateAndTime.Value
flag% = chkToBool%(flag%)

f!clstLanguage.Enabled = flag%
f!lblLanguage.Enabled = flag%
f!clstDateFormat.Enabled = flag%
f!lblDateFormat.Enabled = flag%
f!clstRemainingFormat.Enabled = flag%
f!lblRemainingFormat.Enabled = flag%
f!chkShowUT.Enabled = flag%
Select Case flag%
Case True
    ' include checkbox is valid only for display in days
    If f!clstRemainingFormat.ListIndex = kD Then
        rc% = True
    Else
        rc% = False
    End If
    ' with French enabled, MDY would be a nonsense
    If f!clstLanguage.ListIndex = kFRENCH Then
        f!clstDateFormat.Enabled = False
        f!lblDateFormat.Enabled = False
    End If
Case False
    rc% = False
End Select
f!chkIncludeTodayInDaysRemaining.Enabled = rc%
End Sub

Sub updateSecurityParms ()
Dim flag%
flag% = f!chkPasswordProtected.Value
flag% = chkToBool%(flag%)
f!cmdSetPassword.Enabled = flag%
End Sub

