Option Explicit
DefInt A-Z

Function BoolToChk% (ByVal flag%)
Select Case flag%
Case True
    flag% = CHECKED
Case False
    flag% = UNCHECKED
End Select
BoolToChk% = flag%
End Function

Sub doChangePassword ()
Set ff = frmSetPassword
ff.Hide
doChangePasswordMain
Unload ff
End Sub

Sub doSetupCancel ()
Unload f
End Sub

Sub doSetupMain ()
Set f = frmSetup

retrieveParameters

f.Visible = False
f.AutoRedraw = True
' f.ControlBox = False
' f.MaxButton = False
' f.MinButton = False
' f.BorderStyle = DOUBLEFIXED
f.Caption = title$ + " " + culprit$ + " : Setup"
f.WindowState = NORMAL

centerform f

showSetupParms

f.Show
f.Visible = True
End Sub

Sub doSetupOK ()
saveSetupParms
Unload f
End Sub

Sub doSetupRestoreDefaults ()
Dim flag%
' security

gPasswordProtected% = dPasswordProtected%
gMaxPasswordWait% = dMaxPasswordWait%

gShowNow% = dShowNow%
gNowLanguage% = dNowLanguage%
gNowFont$ = dNowFont$
gNowSize% = dNowSizeNDX%

gNowBold% = dNowBold%
gNowInk& = dNowInk&
gNowMoveInterval% = dNowMoveInterval%
gNowMove% = dNowMove%
gNowMaxMove% = dNowMaxMove%

showSetupParms
End Sub

Sub saveSetupParms ()
Dim rc%
Dim s$
Dim i%

' update all flags according to form

' security (password itself already updated)
s$ = chkToStr$(f!chkPasswordProtected.Value)
rc% = writeIni%(ini$, sSection$, ePasswordProtected$, s$)

s$ = fmtInt$(gMaxPasswordWait%)
rc% = writeIni%(ini$, sSection$, eMaxPasswordWait$, s$)

' date and time

s$ = chkToStr$(f!chkShowNow.Value)
rc% = writeIni%(ini$, sSection$, eShowNow$, s$)

Select Case f!lstNowLanguage.ListIndex
Case kFR: s$ = lFR$
Case kUS: s$ = lUS$
End Select
rc% = writeIni%(ini$, sSection$, eNowLanguage$, s$)

i% = f!lstNowFont.ListIndex
s$ = f!lstNowFont.List(i%)
rc% = writeIni%(ini$, sSection$, eNowFont$, s$)

i% = f!lstNowSize.ListIndex
Select Case i%
Case kFONT8: s$ = "8.25"
Case kFONT10: s$ = "9.75"
Case kFONT12: s$ = "12"
Case kFONT14: s$ = "13.5"
Case Else: s$ = dNowSize$
End Select
rc% = writeIni%(ini$, sSection$, eNowSize$, s$)

s$ = chkToStr$(f!chkNowBold.Value)
rc% = writeIni%(ini$, sSection$, eNowBold$, s$)

s$ = "&h" + Hex$(f!lblNowInk.BackColor) + "&"
rc% = writeIni%(ini$, sSection$, eNowInk$, s$)

s$ = fmtInt$(gNowMoveInterval%)
rc% = writeIni%(ini$, sSection$, eNowMoveInterval$, s$)

s$ = fmtInt$(gNowMove%)
rc% = writeIni%(ini$, sSection$, eNowMove$, s$)

s$ = fmtInt$(gNowMaxMove%)
rc% = writeIni%(ini$, sSection$, eNowMaxMove$, s$)

s$ = fmtInt$(gRefreshNow%)
rc% = writeIni%(ini$, sSection$, eRefreshNow$, s$)

End Sub

Sub showSetupParms ()
Dim c As Control
Dim i%
Dim s$
Dim ok%

' init lists

Set c = f!lstNowLanguage
'c.Sorted = False
'c.Style = dropdown list
c.Clear
c.AddItem "French", kFR
c.AddItem "English", kUS

Set c = f!lstNowFont
'c.Sorted = true
'c.Style = dropdown list
c.Clear
For i% = 0 To screen.FontCount - 1
    c.AddItem screen.Fonts(i%)
Next

Set c = f!lstNowSize
'c.Sorted = False
'c.Style = dropdown list
c.Clear
c.AddItem "8.25", kFONT8
c.AddItem "9.75", kFONT10
c.AddItem "12", kFONT12
c.AddItem "13.5", kFONT14

' security

f!chkPasswordProtected.Value = BoolToChk%(gPasswordProtected%)

' date and time

f!chkShowNow.Value = BoolToChk%(gShowNow%)

f!lstNowLanguage.ListIndex = gNowLanguage%

ok% = False
s$ = UCase$(gNowFont$)
For i% = 0 To screen.FontCount - 1
    If s$ = UCase$(f!lstNowFont.List(i%)) Then
        f!lstNowFont.ListIndex = i%
        ok% = True
        Exit For
    End If
Next
If ok% = False Then
    f!lstNowFont.ListIndex = 1
End If

f!lstNowSize.ListIndex = gNowSize%

f!chkNowBold.Value = BoolToChk%(gNowBold%)

f!lblNowInk.Caption = ""
f!lblNowInk.BackColor = gNowInk&

' update if required
updateSecurityParms
updateSample
End Sub

Sub updateSample ()
Dim s$
Dim flag%
Dim i%

f!lblNowSamplePaper.Caption = ""
f!lblNowSamplePaper.BackColor = dPaper&

If f!chkShowNow.Value = CHECKED Then
    Select Case f!lstNowLanguage.ListIndex
    Case kFR: s$ = "Bonjour !"
    Case kUS: s$ = "Hello !"
    End Select
Else
    s$ = ""
End If
f!lblNowSampleInk.Caption = s$
f!lblNowSampleInk.BackColor = dPaper&
f!lblNowSampleInk.ForeColor = f!lblNowInk.BackColor
i% = f!lstNowFont.ListIndex
If i% >= 0 Then
    s$ = f!lstNowFont.List(i%)
    f!lblNowSampleInk.FontName = s$
End If
Select Case f!lstNowSize.ListIndex
Case kFONT8: s$ = "8.25"
Case kFONT10: s$ = "9.75"
Case kFONT12: s$ = "12"
Case kFONT14: s$ = "13.5"
Case Else: s$ = "13.5"
End Select
f!lblNowSampleInk.FontSize = Val(s$)
flag% = f!chkNowBold.Value
flag% = chkToBool%(flag%)
f!lblNowSampleInk.FontBold = flag%
f!lblNowSampleInk.Alignment = CENTER
End Sub

Sub updateSecurityParms ()
Dim flag%
flag% = f!chkPasswordProtected.Value
flag% = chkToBool%(flag%)
f!cmdSetPassword.Enabled = flag%
End Sub

