Option Explicit
DefInt A-Z

' --- from APITYPES.TXT

Type RECT   '8 Bytes
        Left As Integer
        Top As Integer
        right As Integer
        bottom As Integer
End Type

Type POINTAPI  '4 Bytes - Synonymous with LONG
        x As Integer
        y As Integer
End Type

Type WINDOWPLACEMENT    '20 Bytes
   length As Integer
   flags As Integer ' another Desaware reference forgotten item !
   showCmd As Integer
   ptMinPosition As POINTAPI
   ptMaxPosition As POINTAPI
   rcNormalPosition As RECT
End Type

' --- from APIDECS.TXT

' warning ! getwindowplacement requires length field to be initialized by caller !
' documented in msdn, not in sdk help !
Declare Function GetWindowPlacement% Lib "User" (ByVal hWnd%, lpwndpl As WINDOWPLACEMENT)
Declare Function SetWindowPlacement% Lib "User" (ByVal hWnd%, lpwndpl As WINDOWPLACEMENT)

' ------------------------------------------------------------------------

Sub centerform (f As Form)
Dim screenXmax%, screenYmax%
Dim windowXmax%, windowYmax%
screenXmax% = screen.Width
screenYmax% = screen.Height
windowXmax% = f.Width
windowYmax% = f.Height
f.Left = (screenXmax% - windowXmax%) \ 2
f.Top = (screenYmax% - windowYmax%) \ 2
End Sub

Sub resetPosition (f As Form, ByVal ini$, ByVal section$, ByVal entryTop$, ByVal entryLeft$)
Dim s$
Dim wTop%, wLeft%
s$ = readini$(ini$, section$, entryTop$)
wTop% = Val(s$)
s$ = readini$(ini$, section$, entryLeft$)
wLeft% = Val(s$)
If wTop% < 0 Then wTop% = 0 ' just in case
If wLeft% < 0 Then wLeft% = 0 ' idem
f.Top = wTop%
f.Left = wLeft%
End Sub

Sub restoreWindowPosition (fo As Form, ByVal ini$, ByVal section$, ByVal entryLeftIcon$, ByVal entryTopIcon$, ByVal entryLeft$, ByVal entryTop$, ByVal wState%)
Const dXtsr% = 0
Const dYtsr% = 0
Const dXtsrIcon% = 0
Const dYtsrIcon% = 0
Dim wininfo As WINDOWPLACEMENT
Dim rc%
Dim wLeft%, wTop%
Dim wRight%, wBottom%
Dim wLeftIcon%, wTopIcon%
Dim s$

s$ = readini$(ini$, section$, entryLeft$)
wLeft% = getInt%(s$, dXtsr%)
s$ = readini$(ini$, section$, entryTop$)
wTop% = getInt%(s$, dYtsr%)

's$ = readini$(ini$, section$, entryRight$)
'wRight% = getInt%(s$, dX2tsr%)
's$ = readini$(ini$, section$, entryBottom$)
'wBottom% = getInt%(s$, dY2tsr%)
' we must use default form dimensions !
wRight% = wLeft% + (fo.Width \ screen.TwipsPerPixelX)
wBottom% = wTop% + (fo.Height \ screen.TwipsPerPixelY)

s$ = readini$(ini$, section$, entryLeftIcon$)
wLeftIcon% = getInt%(s$, dXtsrIcon%)
s$ = readini$(ini$, section$, entryTopIcon$)
wTopIcon% = getInt%(s$, dYtsrIcon%)

wininfo.length = Len(wininfo) ' another nice Vindoze API bug ! documented in MSDN only !
wininfo.flags = WPF_SETMINPOSITION

wininfo.rcNormalPosition.Left = wLeft%
wininfo.rcNormalPosition.Top = wTop%
wininfo.rcNormalPosition.right = wRight%
wininfo.rcNormalPosition.bottom = wBottom%
wininfo.ptMinPosition.x = wLeftIcon%
wininfo.ptMinPosition.y = wTopIcon%
wininfo.showCmd = wState%

rc% = SetWindowPlacement%(ByVal fo.hWnd, wininfo)
End Sub

Sub savePosition (f As Form, ByVal ini$, ByVal section$, ByVal entryTop$, ByVal entryLeft$)
Dim rc%
Dim wTop%, wLeft%
wTop% = f.Top
wLeft% = f.Left
rc% = writeIni(ini$, section$, entryTop$, Str$(wTop%))
rc% = writeIni(ini$, section$, entryLeft$, Str$(wLeft%))
End Sub

Sub saveWindowPosition (fo As Form, ByVal ini$, ByVal section$, ByVal entryLeftIcon$, ByVal entryTopIcon$, ByVal entryLeft$, ByVal entryTop$)
Dim wininfo As WINDOWPLACEMENT
Dim rc%
Dim wLeft%, wTop%
'Dim wRight%, wBottom%
Dim wLeftIcon%, wTopIcon%
Dim s$

wininfo.length = Len(wininfo) ' another nice Vindoze API bug ! documented in MSDN only !
rc% = GetWindowPlacement%(ByVal fo.hWnd, wininfo)

wLeft% = wininfo.rcNormalPosition.Left
wTop% = wininfo.rcNormalPosition.Top
'wRight% = wininfo.rcNormalPosition.right
'wBottom% = wininfo.rcNormalPosition.bottom
wLeftIcon% = wininfo.ptMinPosition.x
wTopIcon% = wininfo.ptMinPosition.y

s$ = fmtInt$(wLeft%)
rc% = writeIni(ini$, section$, entryLeft$, s$)
s$ = fmtInt$(wTop%)
rc% = writeIni(ini$, section$, entryTop$, s$)
's$ = fmtInt$(wRight%)
'rc% = writeIni(ini$, section$, entryRight$, s$)
's$ = fmtInt$(wBottom%)
'rc% = writeIni(ini$, section$, entryBottom$, s$)
s$ = fmtInt$(wLeftIcon%)
rc% = writeIni(ini$, section$, entryLeftIcon$, s$)
s$ = fmtInt$(wTopIcon%)
rc% = writeIni(ini$, section$, entryTopIcon$, s$)
End Sub

