Option Explicit
DefInt A-Z

'
' --- from APIDECS.TXT slightly modified

Declare Function GetWindowsDirectory% Lib "Kernel" (ByVal lpBuffer$, ByVal nSize%)
Declare Function GetSystemDirectory% Lib "Kernel" (ByVal lpBuffer$, ByVal nSize%)


' returns # of bytes copied to EntryValue$ (result buffer)
' EntryValueSize% (size of result buffer) must be filled before call

' entry$ is lpKeyName normally defined as Any as to pass a string or NULL (i.e. 0&)

Declare Function GetPrivateProfileString% Lib "Kernel" (ByVal section$, ByVal entry$, ByVal Default$, ByVal entryValue$, ByVal EntryValueSize%, ByVal inipath$)

' returns 0 if function failed
' one can pass NULL to EntryValue$

Declare Function WritePrivateProfileString% Lib "Kernel" (ByVal section$, ByVal entry$, ByVal entryValue$, ByVal inipath$)

' read win.ini

Declare Function GetProfileString% Lib "Kernel" (ByVal section$, ByVal entry$, ByVal Default$, ByVal entryValue$, ByVal EntryValueSize%)

' write win.ini

Declare Function WriteProfileString% Lib "Kernel" (ByVal section$, ByVal entry$, ByVal entryValue$)


' ------------------------------------------------------------------------

Const CHARNULL = 0                   ' for CHR$(0)
Const BUFFERSIZE = 255          ' for ReadIni$

Const strYes$ = "Y"
Const strNo$ = "N"

' ------------------------------------------------------------------------

Function boolToStr$ (ByVal flag%)
Dim s$
Select Case flag%
Case True
    s$ = strYes$
Case False
    s$ = strNo$
End Select
boolToStr$ = s$
End Function

Function chkToBool% (flag%)
Dim rc%
Select Case flag%
Case CHECKED
    rc% = True
Case UNCHECKED
    rc% = False
Case GRAYED
    rc% = False' should never happen
End Select
chkToBool% = rc%
End Function

Function chkToStr$ (ByVal flag%)
Dim s$
Select Case flag%
Case CHECKED
    s$ = strYes$
Case UNCHECKED
    s$ = strNo$
Case GRAYED
    s$ = strNo$' should never happen
End Select
chkToStr$ = s$
End Function

Function Clean$ (ByVal s$)
Clean$ = LTrim$(RTrim$(s$))
End Function

Function formatPath$ (ByVal Path$)
Dim s$
s$ = UCase$(Path$)
s$ = Trim$(s$)' almost certainly useless !
If Right$(s$, 1) <> "\" Then s$ = s$ + "\"
formatPath$ = s$
End Function

Function getBool% (ByVal s$, ByVal defaultBool%)
Dim flag%
Select Case UCase$(s$)
Case UCase$(strYes$), "1"
    flag% = True
Case UCase$(strNo$), "0"
    flag% = False
Case Else ' empty, digits, or anything else = illegal
    flag% = defaultBool%
End Select
getBool% = flag%
End Function

Sub getDirectories (Windows$, WindowsSystem$)
Dim buffer$, bufferLength%
Dim p%
buffer$ = String$(BUFFERSIZE, Chr$(CHARNULL))
bufferLength% = BUFFERSIZE
p% = GetWindowsDirectory(buffer$, bufferLength%) ' we'll use returned length assuming it's not 0 !
buffer$ = Left$(buffer$, p%)
buffer$ = Trim$(buffer$)
Windows$ = formatPath$(buffer$)
buffer$ = String$(BUFFERSIZE, Chr$(CHARNULL))
bufferLength% = BUFFERSIZE
p% = GetSystemDirectory(buffer$, bufferLength%) ' we'll use returned length assuming it's not 0 !
buffer$ = Left$(buffer$, p%)
buffer$ = Trim$(buffer$)
WindowsSystem$ = formatPath$(buffer$)
End Sub

Function getInt% (ByVal s$, ByVal defaultInt%)
Dim v%
s$ = UCase$(s$)
If s$ = "" Then
    v% = defaultInt%
Else
    v% = Val(s$)
End If
getInt% = v%
End Function

Function getSingleReal! (ByVal s$, ByVal defaultReal!)
Dim v!
s$ = UCase$(s$)
If s$ = "" Then
    v! = defaultReal!
Else
    v! = Val(s$)
End If
getSingleReal! = v!
End Function

Function intToStr$ (ByVal v%)
Dim s$
Select Case v%
Case Is < 0
    s$ = Str$(v%)
Case Else
    s$ = Str$(v%)
    s$ = Trim$(s$)
End Select
intToStr$ = s$
End Function

Sub NormalizeString (s$) ' no byval here! ;-)
Dim p%
p% = InStr(s$, Chr$(CHARNULL))
If p% > 0 Then
    s$ = Left$(s$, p% - 1)
End If
End Sub

Function readIni$ (ByVal ini$, ByVal section$, ByVal entry$)
Dim buffer$, bufferLength%
Dim p%
buffer$ = String$(BUFFERSIZE, Chr$(CHARNULL))
bufferLength% = BUFFERSIZE
p% = GetPrivateProfileString(section$, entry$, "", buffer$, bufferLength%, ini$)
' we do not check returned length : what for, eh ! ;-)
NormalizeString buffer$
If Len(buffer$) = 0 Then
    readIni$ = ""
Else
    readIni$ = Clean$(buffer$)
End If
End Function

Function readWinini$ (ByVal section$, ByVal entry$)
Dim buffer$, bufferLength%
Dim p%
buffer$ = String$(BUFFERSIZE, Chr$(CHARNULL))
bufferLength% = BUFFERSIZE
p% = GetProfileString(section$, entry$, "", buffer$, bufferLength%)
' we do not check returned length : what for, eh ! ;-)
NormalizeString buffer$
If Len(buffer$) = 0 Then
    readWinini$ = ""
Else
    readWinini$ = Clean$(buffer$)
End If
End Function

Function writeIni% (ByVal ini$, ByVal section$, ByVal entry$, ByVal entryNewValue$)
Dim rc%
On Error Resume Next
entryNewValue$ = Clean$(entryNewValue$)
rc% = WritePrivateProfileString%(section$, entry$, entryNewValue$, ini$)
If (Err <> 0) Or rc% = False Then
    writeIni% = False
Else
    writeIni% = True
End If
End Function

Function WriteWinIni% (ByVal section$, ByVal entry$, ByVal entryNewValue$)
Dim rc%
On Error Resume Next
entryNewValue$ = Clean$(entryNewValue$)
rc% = WriteProfileString%(section$, entry$, entryNewValue$)
If (Err <> 0) Or rc% = False Then
    WriteWinIni% = False
Else
    WriteWinIni% = True
End If
End Function

