Option Explicit
DefInt A-Z

'
' --- from APIDECS.TXT slightly modified

' returns # of bytes copied to EntryValue$ (result buffer)
' EntryValueSize% (size of result buffer) must be filled before call

' entry$ is lpKeyName normally defined as Any as to pass a string or NULL (i.e. 0&)

Declare Function GetPrivateProfileString% Lib "Kernel" (ByVal section$, ByVal entry$, ByVal Default$, ByVal EntryValue$, ByVal EntryValueSize%, ByVal inipath$)

' returns 0 if function failed
' one can pass NULL to EntryValue$

Declare Function WritePrivateProfileString% Lib "Kernel" (ByVal section$, ByVal entry$, ByVal EntryValue$, ByVal inipath$)

' read win.ini

Declare Function GetProfileString% Lib "Kernel" (ByVal section$, ByVal entry$, ByVal Default$, ByVal EntryValue$, ByVal EntryValueSize%)

' write win.ini

Declare Function WriteProfileString% Lib "Kernel" (ByVal section$, ByVal entry$, ByVal entryValue$)


' ------------------------------------------------------------------------

Const CHARNULL = 0                   ' for CHR$(0)
Const BUFFERSIZE = 255          ' for ReadIni$

' ------------------------------------------------------------------------

Function Clean$ (ByVal s$)
Clean$ = LTrim$(RTrim$(s$))
End Function

Sub NormalizeString (s$) ' no byval here! ;-)
Dim p%
p% = InStr(s$, Chr$(CHARNULL))
If p% > 0 Then
    s$ = Left$(s$, p% - 1)
End If
End Sub

Function readini$ (ByVal ini$, ByVal section$, ByVal entry$)
Dim buffer$, bufferLength%
Dim p%
buffer$ = String$(BUFFERSIZE, Chr$(CHARNULL))
bufferLength% = BUFFERSIZE
p% = GetPrivateProfileString(section$, entry$, "", buffer$, bufferLength%, ini$)
' we do not check returned length : what for, eh ! ;-)
NormalizeString buffer$
If Len(buffer$) = 0 Then
    readini$ = ""
Else
    readini$ = Clean$(buffer$)
End If
End Function

Function readWinini$ (ByVal section$, ByVal entry$)
Dim buffer$, bufferLength%
Dim p%
buffer$ = String$(BUFFERSIZE, Chr$(CHARNULL))
bufferLength% = BUFFERSIZE
p% = GetProfileString(section$, entry$, "", buffer$, bufferLength%)
' we do not check returned length : what for, eh ! ;-)
NormalizeString buffer$
If Len(buffer$) = 0 Then
    readWinini$ = ""
Else
    readWinini$ = Clean$(buffer$)
End If
End Function

Sub resetPosition (f As Form, ByVal ini$, ByVal section$, ByVal entryTop$, ByVal entryLeft$)
Dim s$
Dim wTop%, wLeft%
s$ = readini$(ini$, section$, entryTop$)
wTop% = Val(s$)
s$ = readini$(ini$, section$, entryLeft$)
wLeft% = Val(s$)
If wTop% < 0 Then wTop% = 0 ' just in case
If wLeft% < 0 Then wLeft% = 0 ' idem
f.Top = wTop%
f.Left = wLeft%
End Sub

Sub savePosition (f As Form, ByVal ini$, ByVal section$, ByVal entryTop$, ByVal entryLeft$)
Dim rc%
Dim wTop%, wLeft%
wTop% = f.Top
wLeft% = f.Left
rc% = WriteIni(ini$, section$, entryTop$, Str$(wTop%))
rc% = WriteIni(ini$, section$, entryLeft$, Str$(wLeft%))
End Sub

Function WriteIni% (ByVal ini$, ByVal section$, ByVal entry$, ByVal entryNewValue$)
Dim rc%
On Error Resume Next
entryNewValue$ = Clean$(entryNewValue$)
rc% = WritePrivateProfileString%(section$, entry$, entryNewValue$, ini$)
If (Err <> 0) Or rc% = False Then
    WriteIni% = False
Else
    WriteIni% = True
End If
End Function

Function WriteWinIni% (ByVal section$, ByVal entry$, ByVal entryNewValue$)
Dim rc%
On Error Resume Next
entryNewValue$ = Clean$(entryNewValue$)
rc% = WriteProfileString%(section$, entry$, entryNewValue$)
If (Err <> 0) Or rc% = False Then
    WriteWinIni% = False
Else
    WriteWinIni% = True
End If
End Function

