Option Explicit
DefInt A-Z

Const dos% = &H21
Const multiplex% = &H2F

Const returnTruePath% = &H0    ' return a path containing true path for a SUBSTed drive letter
Const returnSubstPath% = &H80 ' return a path containing the SUBSTed drive letter

Type path9Xtype
    path9X As String * 262 ' [0..260+1] max filename=255, max path=260, must be 0-terminated hence +1 safety
End Type

Type huge9Xtype
    huge9X As String * 517 ' [0..255+260+1] hold full path and filename +1 safety
End Type





Rem using code from HDFREE.MOD v1.0f dated 10 Oct 08


Rem TYPE
Rem     extendedFreeSpaceType = RECORD
Rem         strucsize                : CARDINAL;
Rem         version                  : CARDINAL; (* called with 0 *)
Rem         sectorsPerCluster        : LONGCARD; (* adjusted for compression *)
Rem         bytesPerSector           : LONGCARD;
Rem         freeClusters             : LONGCARD; (* availableClusters *)
Rem         totalClusters            : LONGCARD;
Rem         physicalSectorsAvailable : LONGCARD; (* not adjusted for compression *)
Rem         physicalTotalSectors     : LONGCARD; (* not adjusted for compression *)
Rem         realAvailableUnits       : LONGCARD; (* not adjusted for compression *)
Rem         totalUnits               : LONGCARD; (* not adjusted for compression *)
Rem         reserved                 : ARRAY [1..8] OF BYTE;
Rem     END;


Rem PROCEDURE getUnitFreeTotal (assumeFAT32,verbose:BOOLEAN; u:CHAR;
Rem                            VAR freebytes,totalbytes:HUGECARD):BOOLEAN;
Rem VAR
Rem     r : SYSTEM.Registers;
Rem     sectorsPerCluster, freeClusters, bytesPerSector, totalClusters,v : LONGCARD;
Rem     S           : str128;
Rem     i           : CARDINAL;
Rem     strucFAT32  : extendedFreeSpaceType;
Rem     unitFAT32   : str16; (* oversized *)
Rem BEGIN
Rem     u:=CAP(u);
Rem     freebytes  :=HUGEZERO;
Rem     totalbytes :=HUGEZERO;

Rem     IF assumeFAT32 THEN
Rem         Str.Concat(unitFAT32,u,colon+backslash);
Rem         unitFAT32[Str.Length(unitFAT32)]:=charnull; (* safety for ASCIZ *)
Rem         strucFAT32.version:=0;

Rem         r.AX := 07303H;  (* FAT32 - GET EXTENDED FREE SPACE ON DRIVE *)
Rem         r.DS := Seg( unitFAT32 );
Rem         r.DX := Ofs( unitFAT32 );
Rem         r.ES := Seg( strucFAT32 );
Rem         r.DI := Ofs( strucFAT32 );
Rem         r.CX := SIZE(strucFAT32);
Rem         Lib.Dos(r);
Rem         IF (SYSTEM.CarryFlag IN r.Flags) THEN RETURN FALSE; END;
Rem         sectorsPerCluster := strucFAT32.sectorsPerCluster;
Rem         freeClusters      := strucFAT32.freeClusters;
Rem         bytesPerSector    := strucFAT32.bytesPerSector;
Rem         totalClusters     := strucFAT32.totalClusters;

Rem         freebytes := HUGECARD(bytesPerSector);
Rem         totalbytes:= HUGECARD(bytesPerSector);
Rem         freebytes := freebytes  * HUGECARD(strucFAT32.physicalSectorsAvailable);
Rem         totalbytes:= totalbytes * HUGECARD(strucFAT32.physicalTotalSectors);
Rem     ELSE
Rem         r.AH := 036H;  (* DOS 2+ - GET FREE DISK SPACE *)
Rem         r.DL := BYTE( ORD(u)-ORD("A")+1 ); (* $00=default, $01=A:, etc. *)
Rem         Lib.Dos(r);
Rem         IF r.AX = 0FFFFH THEN RETURN FALSE; END;
Rem         sectorsPerCluster := LONGCARD(r.AX); (* IF $FFFF, invalid drive *)
Rem         freeClusters      := LONGCARD(r.BX);
Rem         bytesPerSector    := LONGCARD(r.CX);
Rem         totalClusters     := LONGCARD(r.DX);

Rem         freebytes  := HUGECARD(sectorsPerCluster) * HUGECARD(bytesPerSector);
Rem         totalbytes := HUGECARD(sectorsPerCluster) * HUGECARD(bytesPerSector);
Rem         freebytes  := freebytes  * HUGECARD(freeClusters);
Rem         totalbytes := totalbytes * HUGECARD(totalClusters);
Rem     END;

Rem     IF verbose THEN (* unit was a valid one *)
Rem         newline;
Rem         newline;
Rem         FOR i:=1 TO 4 DO
Rem             CASE i OF
Rem             | 1: v:=bytesPerSector;    S:="bytes per sectors  ";
Rem             | 2: v:=sectorsPerCluster; S:="sectors per cluster";
Rem             | 3: v:=totalClusters;     S:="total clusters     ";
Rem             | 4: v:=freeClusters;      S:="free clusters      ";
Rem             END;
Rem             Str.Prepend(S,"    ");Str.Append(S," : ");
Rem             Str.Append(S,str(v,wiinfo));
Rem             print (S);newline;
Rem         END;
Rem     END;
Rem     RETURN TRUE;
Rem END getUnitFreeTotal;

Rem (* ------------------------------------------------------------ *)

Rem TYPE
Rem     DOS_DriveParameterBlockType = RECORD
Rem         driveNum          : BYTE;     (* drive number (00h = A:, 01h = B:, etc) *)
Rem         unitNumber        : BYTE;     (* unit number within device driver *)
Rem         bytesPerSector    : CARDINAL; (* bytes per sector *)
Rem         highestSectNum    : BYTE;     (* highest sector number within a cluster *)
Rem         shiftCount        : BYTE;     (* shift count to convert clusters into sectors *)
Rem         reservedSectors   : CARDINAL; (* number of reserved sectors at beginning of drive *)
Rem         numberOfFATs      : BYTE;     (* number of FATs *)
Rem         rootentries       : CARDINAL; (* number of root directory entries *)
Rem         userdatafirstsector:CARDINAL; (* number of first sector containing user data *)
Rem         highestclusterNum : CARDINAL; (* highest cluster number (number of data clusters + 1)
Rem                                       16-bit FAT if greater than 0FF6h, else 12-bit FAT *)
Rem         (* DOS 4.0-6.0 specific *)
Rem         sectorsPerFAT     : CARDINAL; (* number of sectors per FAT *)
Rem         firstdirsector    : CARDINAL; (* sector number of first directory sector *)
Rem         devdrvaddr        : LONGCARD; (* address of device driver header *)
Rem         mediaID           : BYTE;     (* media ID BYTE *)

Rem         busydisk          : BYTE;     (* 00h if disk accessed, FFh if NOT *)
Rem         nextDPBptr        : LONGCARD; (* pointer to next DPB *)
Rem         searchfromcluster : CARDINAL; (* cluster at which to start search for free space when writing,
Rem                                       usually the last cluster allocated *)
Rem         freeClusters      : CARDINAL; (* number of free clusters on drive, FFFFh = unknown *)
Rem     END;

Rem     FSItype = RECORD
Rem         sig : LONGCARD;          (* signature 61417272h *)
Rem         freeclusters : LONGCARD; (* number of free clusters (FFFFFFFFh if unknown) *)
Rem         lastallocated: LONGCARD; (* most recently allocated cluster *)
Rem         rsv : ARRAY [0..11] OF BYTE;
Rem     END;

Rem     extDPBbufferType = RECORD
Rem         datalen           : CARDINAL; (* must be $3D *)

Rem         (* now is extended DPB structure beginning with 24 bytes OF DOS DPB *)
Rem         driveNum          : BYTE;     (* drive number (00h = A:, 01h = B:, etc) *)
Rem         unitNumber        : BYTE;     (* unit number within device driver *)
Rem         bytesPerSector    : CARDINAL; (* bytes per sector *)
Rem         highestSectNum    : BYTE;     (* highest sector number within a cluster *)
Rem         shiftCount        : BYTE;     (* shift count to convert clusters into sectors *)
Rem         reservedSectors   : CARDINAL; (* number of reserved sectors at beginning of drive *)
Rem         numberOfFATs      : BYTE;     (* number of FATs *)
Rem         rootentries       : CARDINAL; (* number of root directory entries *)
Rem         userdatafirstsector:CARDINAL; (* number of first sector containing user data *)
Rem         highestclusterNum : CARDINAL; (* highest cluster number (number of data clusters + 1)
Rem                                       16-bit FAT if greater than 0FF6h, else 12-bit FAT *)
Rem         sectorsPerFAT     : CARDINAL; (* number of sectors per FAT *)
Rem         firstdirsector    : CARDINAL; (* sector number of first directory sector *)
Rem         devdrvaddr        : LONGCARD; (* address of device driver header *)
Rem         mediaID           : BYTE;     (* media ID BYTE *)

Rem         (* extension begins here at offset $18  *)
Rem         dpb_flags         : BYTE;     (* undocumented : FFh force media check *)
Rem         fsiPtr            : LONGCARD; (* pointer to next DPB *)
Rem         searchfromcluster : CARDINAL; (* cluster at which to start search for free space when writing,
Rem                                       usually the last cluster allocated *)

Rem         freeClustersLo    : CARDINAL; (* number of free clusters on drive, FFFFh = unknown *)
Rem         freeClustersHi    : CARDINAL; (* high word of free cluster count *)
Rem         (* freeClustersLoHi  : LONGCARD; *)

Rem         FATflag           : CARDINAL; (* active FAT/mirroring
Rem                                       bit 7: do not mirror active FAT to inactive FATs
Rem                                       bits 6-4: reserved (0)
Rem                                       bits 3-0: the 0-based FAT number of the active FAT
Rem                                       (only meaningful if mirroring disabled) *)
Rem         FSinfosector      : CARDINAL; (* sector number of file system information sector, or
Rem                                       FFFFh for none *)
Rem         backupbootsector  : CARDINAL; (* sector number of backup boot sector, or FFFFh for none *)
Rem         firstclustersector: LONGCARD; (* first sector number of the first cluster *)
Rem         maxCluster        : LONGCARD; (* maximum cluster number *)
Rem         FATinSectors      : LONGCARD; (* number of sectors occupied by FAT *)
Rem         rootdircluster    : LONGCARD; (* cluster number of start of root directory *)
Rem         freespacecluster  : LONGCARD; (* cluster number at which to start searching for free space *)
Rem     END;

Rem (* u should be UPPERCASE but we handle it anyway -- DOS 4.0+ assumed *)

Rem PROCEDURE getUnitDPB (assumeFAT32,verbose:BOOLEAN; u:CHAR;
Rem                      VAR freebytes,totalbytes:HUGECARD):BOOLEAN;
Rem CONST
Rem     wiinfo = 9; (* was 5 for P233 2Gb drive, but with P4 15Gb... *)
Rem VAR
Rem     r : SYSTEM.Registers;
Rem     S       : str128;
Rem     i       : CARDINAL;
Rem     a       : FarADDRESS;
Rem     DOS_DPB : DOS_DriveParameterBlockType;
Rem     extDPBbuffer: extDPBbufferType;
Rem     sectorsPerCluster, freeClusters, bytesPerSector, totalClusters,v : LONGCARD;
Rem BEGIN
Rem     u:=CAP(u);
Rem     freebytes  :=HUGEZERO;
Rem     totalbytes :=HUGEZERO;

Rem     IF assumeFAT32 THEN
Rem         i:= SIZE(extDPBbufferType) - SIZE (extDPBbuffer.datalen);
Rem         extDPBbuffer.datalen := i;
Rem         r.AX := 07302H; (* FAT32 - "Get_ExtDPB" - GET EXTENDED DPB *)
Rem         r.DL := BYTE( ORD(u)-ORD("A")+1 ); (* $00=default, $01=A:, etc. *)
Rem         r.ES := Seg(extDPBbuffer);
Rem         r.DI := Ofs(extDPBbuffer);
Rem         r.CX := SIZE(extDPBbuffer); (* 3Fh *)
Rem         r.SI := 0F1A6H;             (* undocumented *)
Rem         Lib.Dos(r);
Rem         IF (SYSTEM.CarryFlag IN r.Flags) THEN RETURN FALSE; END; (* AX = error code, 0018h bad buffer length *)

Rem         bytesPerSector    := LONGCARD( extDPBbuffer.bytesPerSector);
Rem         sectorsPerCluster := LONGCARD( 1 << CARDINAL( extDPBbuffer.shiftCount) );
Rem         totalClusters     := extDPBbuffer.maxCluster;
Rem         DEC(totalClusters);

Rem         (* nonsense ! *)

Rem         freeClusters      := LONGCARD(extDPBbuffer.freeClustersHi) << 16;
Rem                              INC(freeClusters,LONGCARD(extDPBbuffer.freeClustersLo));
Rem     ELSE
Rem         r.AH := 032H; (* DOS 2+ - GET DOS DRIVE PARAMETER BLOCK FOR SPECIFIC DRIVE *)
Rem         r.DL := BYTE( ORD(u)-ORD("A")+1 ); (* $00=default, $01=A:, etc. *)
Rem         Lib.Dos(r);
Rem         IF r.AL # 00H THEN RETURN FALSE; END; (* FF = invalid or network drive *)
Rem         a:=[ r.DS:r.BX ];
Rem         Lib.FarMove( a, FarADR(DOS_DPB),SIZE (DOS_DPB) );

Rem         totalClusters     := LONGCARD(DOS_DPB.highestclusterNum);
Rem         DEC(totalClusters);
Rem         freeClusters      := LONGCARD(DOS_DPB.freeClusters);

Rem     END;

Rem     RETURN TRUE;
Rem END getUnitDPB;


Rem     IF showgeometry THEN
Rem         FOR i := firstUnit TO lastUnit DO
Rem             colorheader;
Rem             Str.Concat(S,unit[i],colon);Str.Append(S," unit geometry");
Rem             print(S);
Rem             colortext;
Rem             IF getUnitFreeTotal(assumeFAT32,TRUE,unit[i],freespace,totalspace)=FALSE THEN
Rem                colorheader;
Rem                print(" is not available !"); newline;
Rem             END;
Rem             IF i < lastUnit THEN newline; END;
Rem         END;
Rem     END;

Rem             IF getUnitFreeTotal(assumeFAT32,FALSE,unit[i],freespace,totalspace) THEN

Function hibyte% (ByVal hilo As Integer)
hibyte% = (hilo% And &HFF00) \ &H100
End Function

Function lobyte% (ByVal hilo As Integer)
lobyte% = hilo% And &HFF
End Function

Function makehilo% (ByVal hi As Integer, ByVal lo As Integer)
Dim v%
v% = ((hi% And &HFF) * &H100) + (lo% And &HFF)
makehilo% = v%
End Function

Sub w9XgetDOSversion (major As Integer, minor As Integer)

Rem                          msdos7 before win9x    DOS box from win9x   DOS box from WinXP
Rem getDOSversion            7.10                   7.10                 5.0
Rem getTrueDOSversion        7.10                   7.10                 5.50
Rem isWindowsEnh             FALSE (0.22)           TRUE (4.10)          FALSE (0.22)
Rem MS DOS 7 / Windows 9X    TRUE                   TRUE                 FALSE

Rem INT 21 - DOS 2+ - GET DOS VERSION
Rem win95 returns 7.0, osr2 7.1, NT DOS box 5.0, various OS/2 modes 10 or 20 !

Dim r As VBREGS

r.AX = &H3000 ' al=$00 DOS 5+ : what to return in BH : here, useless OEM number
Call vbInterrupt(dos%, r, r)
major% = lobyte%(r.AX)
minor% = hibyte%(r.AX)
End Sub

Sub w9XgetTrueDOSversion (major As Integer, minor As Integer)

Rem INT 21 - DOS 5+ - GET TRUE VERSION NUMBER
Rem win95 returns 7.0, osr2 7.1, NT DOS box 5.50 (which will do as a check for WinXP console)

Dim r As VBREGS

r.AX = &H3306
Call vbInterrupt(dos%, r, r)
major% = lobyte%(r.BX)
minor% = hibyte%(r.BX)
End Sub

Function w9XisMSDOS7% ()

Rem INT 2F - Windows95 - CHECK MS-DOS VERSION 7

Dim rc%

Dim r As VBREGS

r.AX = &H4A33
Call vbInterrupt(multiplex%, r, r)
If r.AX = 0 Then
    rc% = True
Else
    rc% = False
End If
w9XisMSDOS7% = rc% ' MS DOS 7.00+
End Function

Function w9XisWindowsEnh% (major As Integer, minor As Integer)

Rem INT 2F - MS Windows - WINDOWS ENHANCED MODE INSTALLATION CHECK

Dim rc%
Dim r As VBREGS

r.AX = &H1600
Call vbInterrupt(multiplex%, r, r)
major% = lobyte%(r.AX) ' if >= 3
minor% = hibyte%(r.AX)

Select Case major%
Case &H0, &H1, &H80, &HFF ' not 3.1 or more
    rc% = False
Case Else
    rc% = True
End Select
w9XisWindowsEnh% = rc%
End Function

Function w9XshortToLong% (shortname As path9Xtype, errcode As Integer, longname As path9Xtype)

' shortname should be a byval

Rem INT 21 - Windows95 - LONG FILENAME - GET CANONICAL LONG FILENAME OR PATH *)

Dim r As VBREGS
Dim rc%

r.AX = &H7160
r.CX = makehilo(returnSubstPath%, &H2)
'r.DS = Seg(shortname.path9X)
'r.SI = Ofs(shortname.path9X)
'r.ES = Seg(longname.path9X) ' will contain TRUENAME qualified long name
'r.DI = Ofs(longname.path9X)
Call vbInterrupt(dos%, r, r)
If (r.flags And VBFLAGS_CARRY) <> 0 Then
    errcode% = r.AX ' 02h = invalid component, 03h = malformed
    rc% = False
Else
    rc% = True
End If
w9XshortToLong% = rc%
End Function

Function w9XsupportLFN% ()
Const WinXPconsoleMajor% = 5
Const WinXPconsoleMinor% = 50

Dim rc%

Dim major%
Dim minor%

rc% = False
Call w9XgetTrueDOSversion(major%, minor%)
If major% = WinXPconsoleMajor% Then
    If minor% = WinXPconsoleMinor% Then rc% = True' risky business !
End If
If rc% = False Then
    rc% = ((w9XisMSDOS7%()) And (w9XisWindowsEnh%(major%, minor%)))
End If
w9XsupportLFN% = rc%
End Function

