Option Explicit
DefInt A-Z

' --- from APIDECS.TXT

Declare Function GetVersion& Lib "Kernel" ()
Declare Function showCursor% Lib "User" (ByVal bShow%)

' for topmost option : SUB according to VB and Appleman, but FUNCTION according to SDK and Knowledge base !

Declare Function SetWindowPos% Lib "User" (ByVal hWnd%, ByVal hWndInsertAfter%, ByVal X%, ByVal Y%, ByVal cx%, ByVal cy%, ByVal wFlags%)

Declare Function SetSysModalWindow% Lib "User" (ByVal hWnd%)

Declare Function SystemParametersInfo% Lib "User" (ByVal uAction%, ByVal uParam%, lpvParam As Any, ByVal fuWinIni%)
Declare Function SystemParametersInfoByval% Lib "User" Alias "SystemParametersInfo" (ByVal uAction%, ByVal uParam%, ByVal lpvParam As Any, ByVal fuWinIni%)

' ---- from MMDECS.TXT

Declare Function sndPlaySound% Lib "MMSYSTEM.DLL" (ByVal lpszSoundName$, ByVal uFlags%)
Declare Function sndPlaySoundPointer% Lib "MMSystem" Alias "sndPlaySound" (ByVal ptr&, ByVal uFlags%)

'--------------------------------------------------------------------
' paramcount = argC (cli$)

'--------------------------------------------------------------------
' param$ = ArgV$ (cli$, parmnumber) you must take care yourself of case

Function argc (ByVal cli$)
Const empty = 0
Const intoken = 1
Const instring = 2

Dim quote
Dim blank

Dim cliLen
Dim cliPos
Dim argCount
Dim state
Dim char$
Dim code
Dim arg$

quote = 34
blank = &H20

cli$ = Trim$(cli$)
cliLen = Len(cli$)
cliPos = 1
argCount = 0
state = empty
Do Until cliPos > cliLen
    char$ = Mid$(cli$, cliPos, 1)
    code = Asc(char$)
    Select Case state
    Case empty
	Select Case code
	Case quote
	    state = instring' begin new string
	    arg$ = char$
	    argCount = argCount + 1
	Case Is > blank ' quote already trapped
	    state = intoken' begin new token
	    arg$ = char$
	    argCount = argCount + 1
	End Select
    Case intoken
	Select Case code
	Case quote ' quote in token
	    state = instring' if string in parameter
	    arg$ = arg$ + char$
	Case Is > blank
	    arg$ = arg$ + char$
	Case Else
	    state = empty' end of token
	End Select
    Case instring
	Select Case code
	Case quote
	    arg$ = arg$ + char$
	    state = empty' end of string
	Case Is > blank
	    arg$ = arg$ + char$
	Case Else
	    arg$ = arg$ + Chr$(blank)' remove TAB if any
	End Select
    End Select
    cliPos = cliPos + 1
Loop
argc = argCount
End Function

Function argv$ (ByVal cli$, ByVal n)
Const empty = 0
Const intoken = 1
Const instring = 2

Dim quote
Dim blank

Dim cliLen
Dim cliPos
Dim argCount
Dim state
Dim char$
Dim code
Dim arg$

quote = 34
blank = &H20

If n < 1 Or n > argc(cli$) Then
    argv$ = ""
    Exit Function
End If
cli$ = Trim$(cli$)
cliLen = Len(cli$)
cliPos = 1
argCount = 0
state = empty
Do Until cliPos > cliLen
    char$ = Mid$(cli$, cliPos, 1)
    code = Asc(char$)
    Select Case state
    Case empty
	If n = argCount Then ' argV$ test
	    Exit Do
	End If
	Select Case code
	Case quote
	    state = instring' begin new string
	    arg$ = char$
	    argCount = argCount + 1
	Case Is > blank' quote already trapped
	    state = intoken' begin new token
	    arg$ = char$
	    argCount = argCount + 1
	End Select
    Case intoken
	Select Case code
	Case quote ' quote in token
	    state = instring' if string in parameter
	    arg$ = arg$ + char$
	Case Is > blank
	    arg$ = arg$ + char$
	Case Else
	    state = empty' end of token
	End Select
    Case instring
	Select Case code
	Case quote
	    arg$ = arg$ + char$
	    state = empty' end of string
	Case Is > blank
	    arg$ = arg$ + char$
	Case Else
	    arg$ = arg$ + Chr$(blank)' remove TAB if any
	End Select
    End Select
    cliPos = cliPos + 1
Loop
argv$ = arg$
End Function

Sub cursorOFF ()
Dim rc%
rc% = showCursor%(False)

End Sub

Sub cursorON ()
Dim rc%
rc% = showCursor%(True)

End Sub

Function FilterKey% (ByVal keycode%)

Const KEY_RETURN = 13
' replacing with TAB forces a sound alarm !

' passTo as control is now useless thanks to TAB but assume tab order is correct

If keycode% = KEY_RETURN Then ' avoid invisible editbox
    SendKeys "{TAB}" ' was passTo.SetFocus
    keycode% = 0 ' disable silly default beep
End If
FilterKey% = keycode%
End Function

Sub fullselect (c As Control)
Const MAXPATHLENGTH% = 128
c.SelStart = 0
c.SelLength = MAXPATHLENGTH%
End Sub

Function is31% ()
Const vTHREE = 3
Const v10 = 10 * 256
Dim doswindows&
Dim major%, minor%
doswindows& = GetVersion&()
major% = doswindows& And &HFF&
minor% = doswindows& And &HFF00&
If major% = vTHREE And minor% = v10 Then
	is31% = True
Else
	is31% = False
End If
End Function

Function is3X% ()
Const vTHREE = 3
Const v10 = 10 * 256
Const v11 = 11 * 256
Dim doswindows&
Dim major%, minor%
doswindows& = GetVersion&()
major% = doswindows& And &HFF&
minor% = doswindows& And &HFF00&
If major% = vTHREE And (minor% = v10 Or minor% = v11) Then
	is3X% = True
Else
	is3X% = False
End If
End Function

Function IsRunning% ()
Dim rc%
If app.PrevInstance = True Then
    rc% = True
Else
    rc% = False
End If
IsRunning% = rc%
End Function

Function Occurrences% (ByVal s$, ByVal substring$)
Dim Count
Dim p
Count = 0
Do
    p = InStr(1, s$, substring$)
    If p = 0 Then Exit Do
    Count = Count + 1
    s$ = Mid$(s$, p + Len(substring$))
Loop
Occurrences% = Count
End Function

Function replaceall$ (ByVal s$, ByVal what$, ByVal become$)
Dim i
For i = 1 To Occurrences%(s$, what$)
    s$ = replaceFirst$(s$, what$, become$)
Next
replaceall$ = s$
End Function

Function replaceFirst$ (ByVal s$, ByVal what$, ByVal become$)
Dim p
p = InStr(1, s$, what$)
If p > 0 Then
    s$ = Left$(s$, p - 1) + become$ + Mid$(s$, p + Len(what$))' use FixPath for \\
End If
replaceFirst$ = s$
End Function

