Option Explicit
DefInt A-Z

' ripped from misc vb_* files

' --- from APIDECS.TXT slightly modified

Declare Function WinExec% Lib "Kernel" (ByVal lpCmdLine$, ByVal nCmdShow%)

Declare Function GetVersion& Lib "Kernel" ()

Declare Function GetWindowsDirectory% Lib "Kernel" (ByVal lpBuffer$, ByVal nSize%)
Declare Function GetSystemDirectory% Lib "Kernel" (ByVal lpBuffer$, ByVal nSize%)

' returns # of bytes copied to EntryValue$ (result buffer)
' EntryValueSize% (size of result buffer) must be filled before call

' entry$ is lpKeyName normally defined as Any as to pass a string or NULL (i.e. 0&)

Declare Function GetPrivateProfileString% Lib "Kernel" (ByVal section$, ByVal entry$, ByVal Default$, ByVal entryValue$, ByVal EntryValueSize%, ByVal inipath$)

' returns 0 if function failed
' one can pass NULL to EntryValue$

Declare Function WritePrivateProfileString% Lib "Kernel" (ByVal section$, ByVal entry$, ByVal entryValue$, ByVal inipath$)

' read win.ini

Declare Function GetProfileString% Lib "Kernel" (ByVal section$, ByVal entry$, ByVal Default$, ByVal entryValue$, ByVal EntryValueSize%)

' write win.ini

Declare Function WriteProfileString% Lib "Kernel" (ByVal section$, ByVal entry$, ByVal entryValue$)

' ------------------------------------------------------------------------

Const CHARNULL = 0              ' for CHR$(0)
Const BUFFERSIZE = 255          ' for ReadIni$

' ------------------------------------------------------------------------

' Alignment
Global Const LEFT_JUSTIFY = 0  ' 0 - Left Justify
Global Const RIGHT_JUSTIFY = 1 ' 1 - Right Justify
Global Const CENTER = 2        ' 2 - Center

' BorderStyle (form)
'Global Const NONE = 0          ' 0 - None
Global Const FIXED_SINGLE = 1   ' 1 - Fixed Single
Global Const SIZABLE = 2        ' 2 - Sizable (Forms only)
Global Const FIXED_DOUBLE = 3   ' 3 - Fixed Double (Forms only)

' BorderStyle (Shape and Line)
'Global Const TRANSPARENT = 0    '0 - Transparent
'Global Const SOLID = 1          '1 - Solid
'Global Const DASH = 2         ' 2 - Dash
'Global Const DOT = 3          ' 3 - Dot
'Global Const DASH_DOT = 4     ' 4 - Dash-Dot
'Global Const DASH_DOT_DOT = 5 ' 5 - Dash-Dot-Dot
'Global Const INSIDE_SOLID = 6 ' 6 - Inside Solid

' ScaleMode
Global Const USER = 0        ' 0 - User
Global Const TWIPS = 1       ' 1 - Twip
Global Const POINTS = 2      ' 2 - Point
Global Const PIXELS = 3      ' 3 - Pixel
Global Const CHARACTERS = 4  ' 4 - Character
Global Const INCHES = 5      ' 5 - Inch
Global Const MILLIMETERS = 6 ' 6 - Millimeter
Global Const CENTIMETERS = 7 ' 7 - Centimeter


' WindowState
Global Const NORMAL = 0    ' 0 - Normal
Global Const MINIMIZED = 1 ' 1 - Minimized
Global Const MAXIMIZED = 2 ' 2 - Maximized

''  ShowWindow() Commands
Global Const SW_HIDE = 0
Global Const SW_SHOWNORMAL = 1
Global Const SW_NORMAL = 1
Global Const SW_SHOWMINIMIZED = 2
Global Const SW_SHOWMAXIMIZED = 3
Global Const SW_MAXIMIZE = 3
Global Const SW_SHOWNOACTIVATE = 4
Global Const SW_SHOW = 5
Global Const SW_MINIMIZE = 6
Global Const SW_SHOWMINNOACTIVE = 7
Global Const SW_SHOWNA = 8
Global Const SW_RESTORE = 9

' Function Parameters
' MsgBox parameters
Global Const MB_OK = 0                 ' OK button only
Global Const MB_OKCANCEL = 1           ' OK and Cancel buttons
Global Const MB_ABORTRETRYIGNORE = 2   ' Abort, Retry, and Ignore buttons
Global Const MB_YESNOCANCEL = 3        ' Yes, No, and Cancel buttons
Global Const MB_YESNO = 4              ' Yes and No buttons
Global Const MB_RETRYCANCEL = 5        ' Retry and Cancel buttons

Global Const MB_ICONSTOP = 16          ' Critical message
Global Const MB_ICONQUESTION = 32      ' Warning query
Global Const MB_ICONEXCLAMATION = 48   ' Warning message
Global Const MB_ICONINFORMATION = 64   ' Information message

Global Const MB_APPLMODAL = 0          ' Application Modal Message Box
Global Const MB_DEFBUTTON1 = 0         ' First button is default
Global Const MB_DEFBUTTON2 = 256       ' Second button is default
Global Const MB_DEFBUTTON3 = 512       ' Third button is default
Global Const MB_SYSTEMMODAL = 4096      'System Modal

' MsgBox return values
Global Const IDOK = 1                  ' OK button pressed
Global Const IDCANCEL = 2              ' Cancel button pressed
Global Const IDABORT = 3               ' Abort button pressed
Global Const IDRETRY = 4               ' Retry button pressed
Global Const IDIGNORE = 5              ' Ignore button pressed
Global Const IDYES = 6                 ' Yes button pressed
Global Const IDNO = 7                  ' No button pressed

' SetAttr, Dir, GetAttr functions
Global Const ATTR_NORMAL = 0
Global Const ATTR_READONLY = 1
Global Const ATTR_HIDDEN = 2
Global Const ATTR_SYSTEM = 4
Global Const ATTR_VOLUME = 8
Global Const ATTR_DIRECTORY = 16
Global Const ATTR_ARCHIVE = 32

' ------------------------------------------------------------------------

Sub centerform (f As Form)
Dim screenXmax%, screenYmax%
Dim windowXmax%, windowYmax%
screenXmax% = screen.Width
screenYmax% = screen.Height
windowXmax% = f.Width
windowYmax% = f.Height
f.Left = (screenXmax% - windowXmax%) \ 2
f.Top = (screenYmax% - windowYmax%) \ 2
End Sub

Function Clean$ (ByVal s$)
Clean$ = LTrim$(RTrim$(s$))
End Function

Function formatPath$ (ByVal Path$)
Dim s$
s$ = UCase$(Path$)
s$ = Trim$(s$)' almost certainly useless !
If Right$(s$, 1) <> "\" Then s$ = s$ + "\"
formatPath$ = s$
End Function

Sub getDirectories (Windows$, WindowsSystem$)
Dim buffer$, bufferLength%
Dim p%
buffer$ = String$(BUFFERSIZE, Chr$(CHARNULL))
bufferLength% = BUFFERSIZE
p% = GetWindowsDirectory(buffer$, bufferLength%) ' we'll use returned length assuming it's not 0 !
buffer$ = Left$(buffer$, p%)
buffer$ = Trim$(buffer$)
Windows$ = formatPath$(buffer$)
buffer$ = String$(BUFFERSIZE, Chr$(CHARNULL))
bufferLength% = BUFFERSIZE
p% = GetSystemDirectory(buffer$, bufferLength%) ' we'll use returned length assuming it's not 0 !
buffer$ = Left$(buffer$, p%)
buffer$ = Trim$(buffer$)
WindowsSystem$ = formatPath$(buffer$)
End Sub

Sub NormalizeString (s$) ' no byval here! ;-)
Dim p%
p% = InStr(s$, Chr$(CHARNULL))
If p% > 0 Then
    s$ = Left$(s$, p% - 1)
End If
End Sub

Function readIni$ (ByVal ini$, ByVal section$, ByVal entry$)
Dim buffer$, bufferLength%
Dim p%
buffer$ = String$(BUFFERSIZE, Chr$(CHARNULL))
bufferLength% = BUFFERSIZE
p% = GetPrivateProfileString(section$, entry$, "", buffer$, bufferLength%, ini$)
' we do not check returned length : what for, eh ! ;-)
NormalizeString buffer$
If Len(buffer$) = 0 Then
    readIni$ = ""
Else
    readIni$ = Clean$(buffer$)
End If
End Function

Function readWinini$ (ByVal section$, ByVal entry$)
Dim buffer$, bufferLength%
Dim p%
buffer$ = String$(BUFFERSIZE, Chr$(CHARNULL))
bufferLength% = BUFFERSIZE
p% = GetProfileString(section$, entry$, "", buffer$, bufferLength%)
' we do not check returned length : what for, eh ! ;-)
NormalizeString buffer$
If Len(buffer$) = 0 Then
    readWinini$ = ""
Else
    readWinini$ = Clean$(buffer$)
End If
End Function

Function is3X% ()
Const vTHREE = 3
Const v10 = 10 * 256
Const v11 = 11 * 256
Dim doswindows&
Dim major%, minor%
doswindows& = GetVersion&()
major% = doswindows& And &HFF&
minor% = doswindows& And &HFF00&
If major% = vTHREE And (minor% = v10 Or minor% = v11) Then
	is3X% = True
Else
	is3X% = False
End If
End Function

Function isRunning% ()
Dim rc%
If app.PrevInstance = True Then
    rc% = True
Else
    rc% = False
End If
isRunning% = rc%
End Function

Function fileexists% (ByVal fi$)
Dim p%
On Error Resume Next
p% = Len(Dir$(fi$)) ' only normal file here
If (Err <> 0) Or (p% = 0) Then ' prevent vb box for disk error
    fileexists% = False
Else
    fileexists% = True
End If
End Function

Function getEXEname$ ()
Dim p$
p$ = App.EXEName
getEXEname$ = p$
End Function

' retrieve program path
Function getEXEpath$ ()
Dim p$
p$ = App.Path
If Right$(p$, 1) <> "\" Then p$ = p$ + "\"
getEXEpath$ = p$
End Function

Sub parseCanonical (ByVal canonical$, unit$, subdir$, FileName$)
Dim lastslash, firstslash, p
lastslash = 0
p = Len(canonical$)
Do While p > 0
    If Mid$(canonical$, p, 1) = "\" Then
    lastslash = p
    Exit Do
    End If
    p = p - 1
Loop

firstslash = 0
p = 1
Do While p < Len(canonical$)
    If Mid$(canonical$, p, 1) = "\" Then
    firstslash = p
    Exit Do
    End If
    p = p + 1
Loop

If firstslash = 0 And lastslash = 0 Then
    unit$ = ""
    subdir$ = ""
    FileName$ = canonical$
Else
    unit$ = Left$(canonical$, 1)
    subdir$ = Mid$(canonical$, firstslash, lastslash - firstslash + 1)
    FileName$ = Mid$(canonical$, lastslash + 1)
End If
End Sub

