Option Explicit
DefInt A-Z

'
' Composants requis pour la simulation des onglets
'
' THREED.VBX (car les boutons et panneaux 3D ont des bordures personnalisables)
'
' Chaque onglet a deux composants :
'     1) un bouton de slection (SSCommand -- Command3D1) : OngletBouton
'     2) un panneau principal (SSPanel -- Panel3D1) : OngletPanneau
'
' Pour cacher la sparation entre le bouton de slection
' et le panneau principal, le programme utilise un panneau 3D supplmentaire :
' (SSpanel -- Panel3D1) : OngletBoutonCache
'
' Les deux composants de chaque onglet appartiennent  un tableau de contrles.
'
' Les position et dimensions de OngletPanneau(0) ainsi que BevelWidth
' servent de rfrence pour construire les autres onglets
' La hauteur de OngletBouton(0) sert de rfrence aux autres boutons
' Le code de gestion est dans les vnements GotFocus et LostFocus des boutons de slection
'
' Le nom des procdures et variables commence par Onglet pour
' faciliter leur reprage dans le code
'
Const BEVELNONE = SS_BEVELOUTER_NONE

Const ONGLETREFERENCE = 0 ' first index of control array

Dim ongletPrecedent% ' unfortunately, must be global


Sub OngletSauverPosition (ByVal index%)
ongletPrecedent% = index%
End Sub

Sub OngletSelection (fo As Form, ByVal index%)
Dim wBevel As Single
Dim x As Single
Dim y As Single

wBevel = fo!OngletPanneau(ONGLETREFERENCE).BevelWidth ' in pixels

If index% <> ongletPrecedent% Then
    fo!OngletBouton(ongletPrecedent%).FontBold = False
    fo!OngletBouton(index%).FontBold = True
End If
fo!OngletPanneau(index%).ZOrder
x = fo!OngletBouton(index%).Left
y = fo!OngletPanneau(ONGLETREFERENCE).Top - fo!OngletBoutonCache.Height \ 2 ' because -wBevel won't work : there's a minimum heigth !
x = x + (wBevel * screen.TwipsPerPixelX) * 2   ' the last *2 is a security
fo!OngletBoutonCache.Move x, y
fo!OngletBoutonCache.ZOrder
' prevent focus outline effect
' later, try to set focus on first element on panel
fo.cmdOK.SetFocus
End Sub

Sub OngletsInitialisation (fo As Form)

Dim i%
Dim wPanel As Single
Dim wPanelPixels As Single
Dim wTab As Single
Dim hPanel As Single
Dim hTab As Single
Dim x As Single
Dim y As Single
Dim wBevel As Single
Dim s$

fo.ScaleMode = TWIPS ' TWIPS *required* here for ease of use !

wBevel = fo!OngletPanneau(ONGLETREFERENCE).BevelWidth ' in pixels

wPanel = fo!OngletPanneau(ONGLETREFERENCE).Width
wPanelPixels = wPanel \ screen.TwipsPerPixelX
If (wPanelPixels Mod ONGLETNOMBRE) <> 0 Then ' beautify display if required
    wPanelPixels = ((wPanelPixels \ ONGLETNOMBRE) + 1) * ONGLETNOMBRE
    fo!OngletPanneau(ONGLETREFERENCE).Width = wPanelPixels * screen.TwipsPerPixelX
    wPanel = wPanelPixels * screen.TwipsPerPixelX
End If
hPanel = fo!OngletPanneau(ONGLETREFERENCE).Height

x = fo!OngletPanneau(ONGLETREFERENCE).Left
y = fo!OngletPanneau(ONGLETREFERENCE).Top
For i% = (2 - 1) To (ONGLETNOMBRE - 1)
    fo!OngletPanneau(i%).Move x, y, wPanel, hPanel
    fo!OngletPanneau(i%).BevelWidth = wBevel
    fo!OngletPanneau(i%).Caption = ""
Next
fo!OngletPanneau(ONGLETREFERENCE).Caption = ""

wTab = wPanel \ ONGLETNOMBRE
hTab = fo!OngletBouton(ONGLETREFERENCE).Height

y = fo!OngletPanneau(ONGLETREFERENCE).Top - hTab
y = y + wBevel * screen.TwipsPerPixelY
For i% = (1 - 1) To (ONGLETNOMBRE - 1)
    x = fo!OngletPanneau(ONGLETREFERENCE).Left + i% * wTab
    fo!OngletBouton(i%).Move x, y, wTab, hTab
    fo!OngletBouton(i%).BevelWidth = wBevel
    fo!OngletBouton(i%).FontBold = False
    Select Case i%
    Case 0: s$ = OngletTitle0$
    Case 1: s$ = OngletTitle1$
    Case 2: s$ = OngletTitle2$
    Case 3: s$ = OngletTitle3$
    Case 4: s$ = OngletTitle4$
    Case 5: s$ = OngletTitle5$
    End Select
    fo!OngletBouton(i%).Caption = s$
Next

fo!OngletPanneau(ONGLETREFERENCE).ZOrder
fo!OngletBouton(ONGLETREFERENCE).FontBold = True

fo!OngletBoutonCache.BevelInner = BEVELNONE
fo!OngletBoutonCache.BevelOuter = BEVELNONE
fo!OngletBoutonCache.Caption = ""

fo!OngletBoutonCache.Width = wTab - (2 * wBevel * screen.TwipsPerPixelX) * 2 ' the last *2 is a security
fo!OngletBoutonCache.Height = 2 * wBevel * screen.TwipsPerPixelY ' try to set it to minimum

x = fo!OngletPanneau(ONGLETREFERENCE).Left + (wBevel * screen.TwipsPerPixelX) * 2 ' the last *2 is a security
y = fo!OngletPanneau(ONGLETREFERENCE).Top - fo!OngletBoutonCache.Height \ 2 ' because -wBevel won't work : there's a minimum heigth !

fo!OngletBoutonCache.Move x, y
fo!OngletBoutonCache.ZOrder
End Sub

